function [XBEG,YBEG]=ellip(nel,N,A,B,ANGN,XC,YC)
ANGLE=ANGN*atan(1.0)/4.5e1;
CSM=cos(ANGLE);
SNM=sin(ANGLE);
TWOPI=8.0*atan(1.0);

if ((A/B-1)<0.5) 
    for J=1:N,
        X(J)=A*cos((J-1)*TWOPI/N);
        Y(J)=B*sin((J-1)*TWOPI/N);
    end
else
    X(1)=A;
    Y(1)=0.;
    X(N/4+1)=0;
    Y(N/4+1)=B;
    X(N/4*2+1)=-A;
    Y(N/4*2+1)=0.0;
    X(N/4*3+1)=0.0;
    Y(N/4*3+1)=-B;
    for I=2:N/4,
        SLOPE=B/(N/4)*(I-1)/(A/(N/4)*(N/4+1-I));
        X(I)=A*B/(B*B+A*A*SLOPE*SLOPE)^0.50;
        Y(I)=SLOPE*X(I);
    end
    for I=2:N/4,
        X(N/4+I)=-X(N/4-I+2);
        Y(N/4+I)=Y(N/4-I+2);
    end
    for I=2:N/4,
        X(N/4*2+I)=-X(I);
        Y(N/4*2+I)=-Y(I);
    end
    for I=2:N/4,
        X(N/4*3+I)=X(N/4-I+2);
        Y(N/4*3+I)=-Y(N/4-I+2);
    end
end
for I=1:N,
    XBEG(I)=X(I)*CSM-Y(I)*SNM+XC;
    YBEG(I)=Y(I)*CSM+X(I)*SNM+YC;
end
XBEG(N+1)=XBEG(1);
YBEG(N+1)=YBEG(1);
h=plot(XBEG,YBEG,'k');
%fill(XBEG,YBEG,[0,0,0]);
set(h,'LineWidth',2);
text(XC,YC,num2str(nel));

