      subroutine polygons()
      implicit real*8 (a-h,o-z)
       parameter(maxm=800,maxn=800,maxg=4000,nbp=66000,
     &     mbpg=2000,maxinst=18,maxbpg=2000,maxnew=maxinst*maxg,
     &     maxface=20,maxtrip=1000,maxpts=10000)

      dimension eulg(3,maxm,maxn),conf(maxm,maxn),
     &     xg(maxm,maxn),yg(maxm,maxn),euls(3,maxg),ngc(maxg),
     &     ngrain(maxm,maxn),xbound(nbp),ybound(nbp),
     &     ngp(maxg),ibound(maxg,mbpg),ichk(maxm,maxn),
     &     itag(maxg,maxbpg),itag_node(maxg,maxinst,maxbpg),
     &     nct(maxg,maxinst),ntags(maxg),nzero_chk(maxm,maxn),
     &     npg(maxg),eul_ang1(maxg),eul_ang2(maxg),eul_ang3(maxg),
     &     xcg(maxg),ycg(maxg),ng_new(maxg),ibp(nbp,2),nneighb(maxg),
     &     ineighb(maxg,maxg),irem(nbp),inno(maxg,maxg-1),
     &     iparent(maxnew),ig_list(maxg),ig_no(maxg),itrip(nbp),
     &     ifilt(2,maxg),ibad(nbp),iord(maxg,mbpg),ntripg(maxg),
     &     itripg(maxg,mbpg),itrippos(maxg,mbpg),ijk(maxg,mbpg),
     &     nnodes(maxg),xnode(nbp),ynode(nbp),znode(nbp),imap(nbp),
     &     ijk_3d(maxg,2*mbpg),ijk_p(maxg,2*mbpg),x3d(nbp),y3d(nbp),
     &     z3d(nbp),iface(maxg,maxface,mbpg),nnf(maxg,mbpg+2),
     &     nface_no(mbpg*maxg),nface_info(10000,20),
     &     nstface(maxg),nendface(maxg),itrip_no(maxg,mbpg),
     &     ichk_side(maxtrip,maxtrip),ngar(maxg)
   
c      dimension xor(maxpts),yor(maxpts),or1(maxpts),or2(maxpts),or3(maxpts)

      Character*3 number
      character*20 unitname
c      write(*,*)'Number of points to consider, N:'
c      read(*,*)N1

      do i=1,maxg
         ngar(i)=0
      enddo

      dx=1.d0
      dy=1.d0
      mmax=0
      nmax=0
c      xtol=4.d0*3.142/180.d0
      xtol=0.25d0
      open(unit=10,file='poly.in')
      read(10,*) N1
      xmin=10000.d0
      ymin=10000.d0
      ormax=0.d0      
      do i=1,N1 
         read(10,*)xori,yori,or1i
         if(xori.lt.xmin)xmin=xori
         if(yori.lt.ymin)ymin=yori
         if(or1i.gt.ormax)ormax=or1i
      enddo
      ormax=ormax+1
      rewind(10)
       print *,'came into polygons'
      read(10,*) N1
      ng=0
      do i=1,N1
         read(10,*)xori,yori,or1i
         x=xori-xmin
         y=yori-ymin
         m=1+x/dx
         n=1+y/dy
         if(m.gt.maxm.or.n.gt.maxn)then
            write(*,*)'Warning Array Bounds exceeded:'
            write(*,*)'m maxm',m,maxm
            write(*,*)'n maxn',n,maxn
            stop
         endif
         xg(m,n)=x
         yg(m,n)=y
         or=or1i
         if(or1i.eq.0)or=ormax
         eulg(1,m,n)=or
         eulg(2,m,n)=or
         eulg(3,m,n)=or
         if(or.gt.ng)ng=or
         ngrain(m,n)=or
         ngar(or)=ngar(or)+1
         if(m.gt.mmax)mmax=m
         if(n.gt.nmax)nmax=n
      enddo


      nb=0
      do i=1,ng
         ngp(i)=0
      enddo


      do i=1,nbp
         itrip(i)=0
      enddo
      ntrip=0
      do j=1,nmax
         do i=1,mmax
            ngij=ngrain(i,j)
            if(ngij.ne.ormax)then
            ip=minf(i+1,mmax)
            im=maxf(i-1,1)
            jp=minf(j+1,nmax)
            jm=maxf(j-1,1)
           if((ngrain(i,j).ne.ngrain(ip,j)).or.(i.eq.ip))then
              xb=0.5d0*(xg(ip,j)+xg(i,j))
              yb=yg(i,j)
              iflag=0
              k=1
              do while(iflag.eq.0.and.k.le.nb)
                 if(dabs(xb-xbound(k)).lt.1d-10.and.
     &                dabs(yb-ybound(k)).lt.1d-10)then
                    iflag=k
                 else
                    k=k+1
                 endif
              enddo
              if(iflag.eq.0)then
                 nb=nb+1
                 if(nb.gt.nbp)then
                    write(*,*)'Warning: array bounds Exceeded:bound'
                    write(*,*)'nb nbp',nb,nbp
                    stop
                 endif
                 k=nb
                 ibp(k,1)=ngrain(i,j)
                 ibp(k,2)=ngrain(ip,j)
                 xbound(k)=xb
                 ybound(k)=yb
                 if(j.eq.1.or.j.eq.nmax)then
                    ntrip=ntrip+1
                    itrip(k)=ntrip
                 endif
              endif
                 
              ngp(ngij)=ngp(ngij)+1

              if(ngp(ngij).gt.mbpg)then
                 write(*,*)'Warning: Array bounds exceeded:npg'
                 write(*,*)ngp(ngij),mbpg
                 stop
              endif
              ibound(ngij,ngp(ngij))=k
             
           endif
           if((ngrain(i,j).ne.ngrain(im,j)).or.(i.eq.im))then
              xb=0.5d0*(xg(im,j)+xg(i,j))
              yb=yg(i,j)
              iflag=0
              k=1
              do while(iflag.eq.0.and.k.le.nb)
                 if(dabs(xb-xbound(k)).lt.1d-10.and.
     &                dabs(yb-ybound(k)).lt.1d-10)then
                    iflag=k
                 else
                    k=k+1
                 endif
              enddo
              if(iflag.eq.0)then
                 nb=nb+1
                 if(nb.gt.nbp)then
                    write(*,*)'Warning: array bounds Exceeded'
                    write(*,*)'nb nbp',nb,nbp
                    stop
                 endif
                 k=nb
                 ibp(k,1)=ngrain(i,j)
                 ibp(k,2)=ngrain(im,j)
                 xbound(k)=xb
                 ybound(k)=yb
                 if(j.eq.1.or.j.eq.nmax)then
                    ntrip=ntrip+1
                    itrip(k)=ntrip
                 endif
              endif
                 
              ngp(ngij)=ngp(ngij)+1

              if(ngp(ngij).gt.mbpg)then
                 write(*,*)'Warning: Array bounds exceeded'
                 write(*,*)ngp(ngij),mbpg
                 stop
              endif
              ibound(ngij,ngp(ngij))=k
           endif
           if((ngrain(i,j).ne.ngrain(i,jp)).or.(jp.eq.j))then
              yb=0.5d0*(yg(i,jp)+yg(i,j))
              xb=xg(i,j)
              iflag=0
              k=1
              do while(iflag.eq.0.and.k.le.nb)
                 if(dabs(xb-xbound(k)).lt.1d-10.and.
     &                dabs(yb-ybound(k)).lt.1d-10)then
                    iflag=k
                 else
                    k=k+1
                 endif
              enddo
              if(iflag.eq.0)then
                 nb=nb+1
                 if(nb.gt.nbp)then
                    write(*,*)'Warning: array bounds Exceeded'
                    write(*,*)'nb nbp',nb,nbp
                    stop
                 endif
                 k=nb
                 ibp(k,1)=ngrain(i,j)
                 ibp(k,2)=ngrain(i,jp)
                 xbound(k)=xb
                 ybound(k)=yb
                 if(i.eq.1.or.i.eq.mmax)then
                    ntrip=ntrip+1
                    itrip(k)=ntrip
                 endif
              endif
                 
              ngp(ngij)=ngp(ngij)+1
              if(ngp(ngij).gt.mbpg)then
                 write(*,*)'Warning: Array bounds exceeded'
                 write(*,*)ngp(ngij),mbpg
                 stop
              endif
              ibound(ngij,ngp(ngij))=k
             
           endif
           if((ngrain(i,j).ne.ngrain(i,jm)).or.(j.eq.jm))then
              yb=0.5d0*(yg(i,jm)+yg(i,j))
              xb=xg(i,j)
              iflag=0
              k=1
              do while(iflag.eq.0.and.k.le.nb)
                 if(dabs(xb-xbound(k)).lt.1d-10.and.
     &                dabs(yb-ybound(k)).lt.1d-10)then
                    iflag=k
                 else
                    k=k+1
                 endif
              enddo
              if(iflag.eq.0)then
                 nb=nb+1
                 if(nb.gt.nbp)then
                    write(*,*)'Warning: array bounds Exceeded'
                    write(*,*)'nb nbp',nb,nbp
                    stop
                 endif
                 k=nb
                 ibp(k,1)=ngrain(i,j)
                 ibp(k,2)=ngrain(i,jm)
                 xbound(k)=xb
                 ybound(k)=yb
                 if(i.eq.1.or.i.eq.mmax)then
                    ntrip=ntrip+1
                    itrip(k)=ntrip
                 endif
              endif
                 
              ngp(ngij)=ngp(ngij)+1
              if(ngp(ngij).gt.mbpg)then
                 write(*,*)'Warning: Array bounds exceeded'
                 write(*,*)ngp(ngij),mbpg
                 stop
              endif
              ibound(ngij,ngp(ngij))=k
           endif
           endif
         enddo
      enddo

      ng=ng-1
      call ord_points(nb,ng,ibad,ibound,xbound,ybound,itrip,iord
     &    ,ngp) 


      do ig=1,ng
         ntrip=0
         k=iord(ig,1)
         ntrip=ntrip+1
         itrip(k)=ntrip
         k=iord(ig,ngp(ig)/4)
         ntrip=ntrip+1
         itrip(k)=ntrip
         k=iord(ig,ngp(ig)/2)
         ntrip=ntrip+1
         itrip(k)=ntrip
         k=iord(ig,(ngp(ig)/4)*3)
         ntrip=ntrip+1
         itrip(k)=ntrip
         iflag_refine=1
         irefine=0
         do while(iflag_refine.eq.1)
            irefine=irefine+1
c$$$            write(*,*)'ig iref=',ig,irefine
            iflag_refine=0
            do il1=1,maxtrip
               do il2=1,maxtrip
                  ichk_side(il1,il2)=0
               enddo
            enddo
            ntripg(ig)=0
            do i=1,ngp(ig)
               if(itrip(iord(ig,i)).ne.0)then
                  ntripg(ig)=ntripg(ig)+1
                  itripg(ig,ntripg(ig))=iord(ig,i)
                  itrippos(ig,ntripg(ig))=i
                  itrip_no(ig,ntripg(ig))=itrip(iord(ig,i))
               endif
            enddo
            
            nnodes(ig)=0
            do it=1,ntripg(ig)
               nnodes(ig)=nnodes(ig)+1
               ijk(ig,nnodes(ig))=itripg(ig,it)
               it_next=mod(it,ntripg(ig))+1
               in_start=itrippos(ig,it)+1
               in_end=itrippos(ig,it_next)-1
               if(it.eq.ntripg(ig))in_end=ngp(ig)
               maxarea=0.d0
               itrip1=itrip_no(ig,it)
               itrip2=itrip_no(ig,it_next)
               
               
               x1=xbound(itripg(ig,it))
               y1=ybound(itripg(ig,it))
               x2=xbound(itripg(ig,it_next))
               y2=ybound(itripg(ig,it_next))
               if(ichk_side(itrip1,itrip2).eq.0)then
                  do i=in_start,in_end
                     x3=xbound(iord(ig,i))
                     y3=ybound(iord(ig,i))
                     xarea=(x2*y3-x3*y2)+(x3*y1-x1*y3)+(x1*y2-x2*y1)
                     xarea=0.5d0*dabs(xarea)
                     if(xarea.gt.maxarea)then
                        maxarea=xarea
                        iref=i
                     endif
                  enddo
                  if(it.eq.ntripg(ig))then
                     iend=itrippos(ig,1)-1
                     do i=1,iend
                        x3=xbound(iord(ig,i))
                        y3=ybound(iord(ig,i))
                        xarea=(x2*y3-x3*y2)+(x3*y1-x1*y3)+(x1*y2-x2*y1)
                        xarea=0.5d0*dabs(xarea)
                        if(xarea.gt.maxarea)then
                           maxarea=xarea
                           iref=i
                        endif
                     enddo
                  endif
                  area_ref=0.01*ngar(ig)
                  if(maxarea.gt.area_ref)then
                     ichk_side(itrip1,itrip2)=iord(ig,iref)
                     ichk_side(itrip2,itrip1)=iord(ig,iref)
                     iflag_refine=1
                  else
                     ichk_side(itrip1,itrip2)=-1
                     ichk_side(itrip2,itrip1)=-1
                  endif
                  if(ichk_side(itrip1,itrip2).gt.0)then
                     nnodes(ig)=nnodes(ig)+1
                     ijk(ig,nnodes(ig))=ichk_side(itrip1,itrip2)
                  endif
               endif
               ntrip=nnodes(ig)
               do i=1,maxtrip
                  itrip(i)=0
               enddo
               do i=1,ntrip
                  itrip(ijk(ig,i))=i
               enddo          
            enddo
         enddo
      enddo
         
      pi=4.d0*datan(1.d0)
      do ig=1,ng
         iflag_elim=1
         do while(iflag_elim.ne.0)
            nn=nnodes(ig)
            iflag_elim=0
            i=1
            do while(i.le.nn.and.iflag_elim.eq.0)
               if(i.ne.1)then
                  ibef=i-1
               else
                  ibef=nn
               endif
               if(i.ne.nn)then
                  inext=i+1
               else
                  inext=1
               endif
               ip1=ijk(ig,ibef)
               ip2=ijk(ig,i)
               ip3=ijk(ig,inext)
               v1x=xbound(ip2)-xbound(ip1)
               v1y=ybound(ip2)-ybound(ip1)
               v2x=xbound(ip3)-xbound(ip2)
               v2y=ybound(ip3)-ybound(ip2)

               dot=v1x*v2x+v1y*v2y
               v1m=dsqrt(v1x**2+v1y**2)
               v2m=dsqrt(v2x**2+v2y**2)
               dot=dot/(v1m*v2m)
               ang=dacos(dot)*180.d0/pi
               iflag_elim=0
               if(ang.lt.20.d0)iflag_elim=i
               i=i+1
            enddo
            if(iflag_elim.ne.0)then
               do ii=iflag_elim,nn-1
                  ijk(ig,ii)=ijk(ig,ii+1)
               enddo
               nnodes(ig)=nnodes(ig)-1
            endif
         enddo
      enddo

      nsmax=0
         close(122)
     
      icount=0
      do i=1,nb
         imap(i)=0
      enddo
      do ig=1,ng
         do k=1,nnodes(ig)
            nno=ijk(ig,k)
            if(imap(nno).eq.0)then
              icount=icount+1
              imap(nno)=icount
              xnode(icount)=xbound(nno)
              ynode(icount)=ybound(nno)
              znode(icount)=0.d0
              ijk(ig,k)=icount
          else
             ijk(ig,k)=imap(nno)
          endif
         enddo
      enddo
      nx=icount
      call post_el(xbound,ybound,ibound,ngp,nnodes,ijk,ng,iord,
     &     xnode,ynode)
 
      open(unit=109,file='poly.out')
      
      write(109,*)nx,ng
      do i=1,nx
         xnode(i)=xnode(i)+xmin
         ynode(i)=ynode(i)+ymin
      enddo
      

      do i=1,nx
         write(109,*)i,xnode(i),ynode(i)
      enddo

      do ig=1,ng
         write(109,*)ig,nnodes(ig),(ijk(ig,j),j=1,nnodes(ig))
      enddo
      close(109)
      return
      end
      

      function minf(i,j)
      implicit real*8(a-h,o-z)
      minf=i
      if(j.lt.i)minf=j
      return
      end


      function maxf(i,j)
      implicit real*8(a-h,o-z)
      maxf=i
      if(j.gt.i)maxf=j
      return
      end

      subroutine rem_repeat(ngb,ibound,ngp)
      implicit real*8 (a-h,o-z)
      parameter(maxm=800,maxn=800,maxg=4000,nbp=66000,
     &     mbpg=2000,maxinst=18,maxbpg=2000,maxnew=maxinst*maxg,
     &     maxface=20,maxtrip=1000,maxpts=10000)
      dimension ibound(maxg,mbpg),ibound2(maxg,mbpg),ngp(maxg)
      do ig=1,ngb
         nnp=0
         do i=1,ngp(ig)
            ip=ibound(ig,i)
            iflag=0
            j=1
            do while(iflag.eq.0.and.j.le.nnp)
               if(i.ne.j.and.ibound2(ig,j).eq.ip)then
                  iflag=j
               else
                  j=j+1
               endif
            enddo
            if(iflag.eq.0)then
               nnp=nnp+1
               ibound2(ig,nnp)=ibound(ig,i)
            endif
         enddo
         ngp(ig)=nnp
         do i=1,nnp
            ibound(ig,i)=ibound2(ig,i)
         enddo
      enddo

      return
      end




      subroutine ord_points(nb,ngb,ibad,ibound,xbound,ybound,itrip,
     &     iord,ngp)
      implicit real*8 (a-h,o-z)
      parameter(maxm=800,maxn=800,maxg=4000,nbp=66000,
     &     mbpg=2000,maxinst=18,maxbpg=2000,maxnew=maxinst*maxg,
     &     maxface=20,maxtrip=1000,maxpts=10000)
      dimension iord_chk(maxg,maxbpg),ibad(nbp),ibound(maxg,mbpg),
     &     xbound(nbp),ybound(nbp),iord(maxg,mbpg),iln(maxg,mbpg),
     &     ngp(maxg),itrip(nbp)


      call rem_repeat(ngb,ibound,ngp)
      do i=1,nb
         ibad(i)=0
      enddo

      do ig=1,ngb
         do i=1,ngp(ig)
            iord_chk(ig,i)=0
         enddo
         ngord=0
         irefloc=1
         i=1
         
         do while(i.le.ngp(ig).and.irefloc.ne.0)
            iref=ibound(ig,irefloc)
            xref=xbound(iref)
            yref=ybound(iref)
            if(iord_chk(ig,irefloc).eq.0)then
               iord_chk(ig,irefloc)=1
               ngord=ngord+1
               iord(ig,ngord)=iref
            endif
            
            sm=3.d0
            iflag=0
            ism=0
            do j=1,ngp(ig)
               if(iord_chk(ig,j).eq.0)then
                  ip=ibound(ig,j)
                  xp=xbound(ip)
                  yp=ybound(ip)
                  dist=dsqrt((xp-xref)**2+(yp-yref)**2)
                  if(dist.lt.sm)then
                     sm=dist
                     ism=j
                     iflag=1
                  endif
                  
               endif
            enddo
            irefloc=ism
            i=i+1
         enddo

         if(ngord.ne.ngp(ig))then
            do i=1,ngp(ig)
               if(iord_chk(ig,i).eq.0)then
                  iref=ibound(ig,i)
                  ibad(iref)=1
                  if(itrip(iref).ne.0)then
                     xref=xbound(iref)
                     yref=ybound(iref)
                     sm=0.d0
                     do k=1,ngord
                        ip=iord(ig,k)
                        xp=xbound(ip)
                        yp=ybound(ip)
                        dist=dsqrt((xref-xp)**2+(yref-yp)**2)
                        if(dist.lt.sm.or.k.eq.1)then
                           if(k.eq.1.or.itrip(k).eq.0)then
                              ism=k
                              sm=dist
                           endif
                        endif
                     enddo
                     if(itrip(ism).eq.0)then
                        iord(ig,ism)=iref
                        iord_chk(ig,i)=1
                     endif
                     if(itrip(ism).ne.0)then
                        write(*,*)'Error in Filtering'
                     endif
                  endif
               endif
            enddo
         endif
         ngp(ig)=ngord
      enddo      
      return
      end

      subroutine post_el(xbound,ybound,ibound,ngp,ntripg,itripg,ngb,
     &     iord,xnode,ynode) 

      implicit real*8(a-h,o-z)
      parameter(maxm=800,maxn=800,maxg=4000,nbp=66000,
     &     mbpg=2000,maxinst=18,maxbpg=2000,maxnew=maxinst*maxg,
     &     maxface=20,maxtrip=1000,maxpts=10000)
C      parameter(maxm=3000,maxn=3000,maxg=2000,nbp=66000,
C     &     mbpg=2000,maxinst=8,maxbpg=2000)
      dimension xbound(nbp),ybound(nbp),ibound(maxg,mbpg),ngp(maxg),
     &     ntripg(maxg),itripg(maxg,mbpg),iord(maxg,mbpg),xnode(nbp),
     &     ynode(nbp)

      open(888,file='poly.ps')
      write (888,*) '%!'
      write (888,*) '20 100 translate'          ! move the origin

C
C***  Drawing the grains
C     



      write (888,*) '1 1 scale'
      write (888,*) '1.25 setlinewidth' 

      
      do i=1,ngb
        
         k1=iord(i,1)
         write (888,*) 'newpath'
         write (888,'(2X,F8.3,2X,F8.3,2X,A)') xbound(k1),ybound(k1),
     &          'moveto'

         do j=2,ngp(i)
            k=iord(i,j)
            write (888,'(2X,F8.3,2X,F8.3,2X,A)') xbound(k),ybound(k),
     &            'lineto'
         enddo

         write (888,'(2X,F8.3,2X,F8.3,2X,A)') xbound(k1),ybound(k1),
     &         'lineto'
         write (888,*) 'closepath'

         write (888,*) '0 1 0 setrgbcolor stroke'

      enddo


C***  Drawing the VCFEMs
C

      idraw=1
      if(idraw.eq.1)then
      do i=1,ngb
         k1=itripg(i,1)
         write (888,*) 'newpath'
         write (888,'(2X,F8.3,2X,F8.3,2X,A)') xnode(k1),ynode(k1),
     &          'moveto'

         do j=2,ntripg(i)
            k=itripg(i,j)
            write (888,'(2X,F8.3,2X,F8.3,2X,A)') xnode(k),ynode(k),
     &            'lineto'
         enddo

         write (888,'(2X,F8.3,2X,F8.3,2X,A)') xnode(k1),ynode(k1),
     &         'lineto'
         write (888,*) 'closepath'

         write (888,*) '1 0 0 setrgbcolor stroke'
      enddo
      endif

      write (888,*) 'showpage'
      close(888)   
      end
