      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NLM=1000,IDIMTWO=NLM,MAXCOORD=15000,MAXNODPERPAR=32)
      DIMENSION XSCALEM(NLM),YSCALEM(NLM),ANM(NLM)
      DIMENSION XCENTP(NLM),YCENTP(NLM)
      COMMON /BORDER/ BX(4),BY(4)
      COMMON /ELDATA/ CEX(maxcoord),CEY(maxcoord),A(NLM),B(NLM),TH(NLM),
     &     NNODES(IDIMTWO),PX(MAXCOORD),PY(MAXCOORD),GBVX(1,4),GBVY(1,4),
     &     NGBV(1),NTOT
      COMMON /INCLU/ NODPERPAR
      DIMENSION CORNER(4,2)
      CHARACTER *20 FILENM
      

      FILENM = 'random1.dat'
      NODPERPAR = 12

      OPEN(88,FILE=FILENM)
      ZERO=0.D0
      IZERO=0
      IFOUR=4
      
      READ(88,*)
      READ(88,*) IZERO 
      READ(88,*)
      READ(88,*) IFOUR
      READ(88,*)
      DO I=1,IFOUR
         READ(88,*) CORNER(I,1),CORNER(I,2)               
      ENDDO
      READ(88,*)
      READ(88,*) XSCALE
      READ(88,*)
      READ(88,*) YSCALE
      READ(88,*)
      READ(88,*) CORNER(1,1)
      READ(88,*)
      READ(88,*) CORNER(1,2)
      READ(88,*)
      READ(88,*) NELX
      READ(88,*)
      READ(88,*)

      IF(NELX.GT.NLM) THEN
         WRITE(*,*) 'INCREASE NLM TO',NELX
         STOP
      ENDIF
      
      DO NEL=1,NELX
         READ(88,*) II,XSCALEM(NEL),YSCALEM(NEL),XCENTP(NEL),YCENTP(NEL),
     &        ANM(NEL),ZERO,ZERO         
      ENDDO
      CLOSE(88)
      
      NELXTMP=NELX
      CALL elpsN(iflag,xscalem,yscalem,nelx,xcentp,ycentp,anm,corner)
      CALL vcm1(iflag,izero,ifour,nelx,nelxtmp)
      CALL vcm2(iflag,izero,ifour,nelx)

      CALL DRAW(CORNER)         
      NELX=NELXTMP
      
      STOP
      END

c=========================================================================================
c  Purpose:  Creates arrays ex, ey and nnodes
c  Routines: minarc, thstep, epts8
c-----------------------------------------------------------------------------------------
      subroutine elpsN(iflag,aa,bb,ne,cx,cy,theta,corner)

      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NLM=1000,IDIMTWO=NLM,MAXCOORD=15000,MAXNODPERPAR=32)
      COMMON /BORDER/ BX(4),BY(4)
      COMMON /ELDATA/ CEX(maxcoord),CEY(maxcoord),A(NLM),B(NLM),TH(NLM),
     &     NNODES(IDIMTWO),PX(MAXCOORD),PY(MAXCOORD),GBVX(1,4),GBVY(1,4),
     &     NGBV(1),NTOT
      COMMON /INCLU/ NODPERPAR
      COMMON /SMINARC/ SMINNA
      DIMENSION EY(NLM,MAXNODPERPAR*4),EX(NLM,MAXNODPERPAR*4),CORNER(4,2)
      DIMENSION AA(NLM),BB(NLM),THETA(NLM),CX(NLM),CY(NLM)
      
      iflag=0
      ioption1=0
      ioption2=1
      ipsf=103
      do i=1,nlm
         a(i)=aa(i)
         b(i)=bb(i)
         cex(i)=cx(i)
         cey(i)=cy(i)
         th(i)=theta(i)
      enddo

      do i=1,4
         bx(i)=corner(i,1)
         by(i)=corner(i,2)
      enddo

c Find min.char.arc length:
      smina = 1.d10              ! init. min. arc-step

c Read ellipse data
      do i=1,ne                 ! for each el.
         call minarc (a(i),b(i),eqarc)
         if (eqarc .lt. smina) then
            smina = eqarc       ! new value
            ie   = i            ! corr.el.no.
         endif 
      enddo
      if (ioption2.eq.1) then   ! virtual particle def'n
         ninsrt=1
         sminna = smina/(ninsrt+1) ! new min arc lenght...
      endif

c     Generate nod.pts on el.contour
      do i = 1,ne               ! loop over each el.
         if (ioption2.eq.1) then ! virtual particul.
            call thstep (i,cex(i),cey(i),a(i),b(i),th(i),sminna,ex,
     *                   ey,nnodes(i))
         elseif (ioption2.eq.0) then ! default case - no virt.part.
            if (i.eq.ie) then   ! for 'min' el.create 8 nodes
               nnodes(i) = NODPERPAR
               call epts8 (i,cex(i),cey(i),a(i),b(i),th(i),ex,ey)
            else
               call thstep (i,cex(i),cey(i),a(i),b(i),th(i),smina,ex,
     *                      ey,nnodes(i))
            endif
         endif
      enddo

c Finish writing data to random.dat
      ntot = 0                
      do i = 1,ne
         ntot = ntot+nnodes(i)  ! tot.no.of nodes for all el.
      enddo
      jjj=0
      do i = 1,ne
         do k = 1,nnodes(i)
            jjj=jjj+1
            if (jjj.gt.maxcoord) then
               print *,'dimension of px,py not enough',jjj
               print *,'increase maxcoord '
               print *,'stopped in elpsN'
               stop
            endif
            px(jjj)=ex(i,k)
            py(jjj)=ey(i,k)
         enddo
      enddo
      iflag=1

      return
      end

c=========================================================================================
c  Purpose:  Determines coords. of 8 pts. distributed on input ellipse 'i' contour so
c            that the ellipse is approximated with 8 node polygon with 8 equal area
c            triangles.  Output is nodal coords.: 'ex(i,*),ey(i,*)' and equivalent arc: 
c            eqarc.  NOTE:  pts. are distributed in counterclockwise dir.
c-----------------------------------------------------------------------------------------
      subroutine minarc (a,b,eqarc)
      implicit real*8 (a-h,o-z)
      COMMON /INCLU/ NODPERPAR

      eps   = 1.d-12
      pi    = 4.*atan(1.)
      conv  = pi/180.     ! conversion to [rad]
      exc   = b/a
      a8    = a*b*pi/(NODPERPAR*1.)   ! 1/8 (triangle area) ellipse area
      aaprx = 0.          ! initiate aprox.of 'a8'
      th    = 0.          ! initiate polar angle
      dth   = 1*conv      ! initiate angle incr. (~1 deg)

c Nodal (#2) polar coords.in local (el.) c.s.
c Polar radius
 1    rad = b/sqrt(sin(th)**2+(exc*cos(th))**2)
c Approx.area increm.
      darea1 = 0.5*dth*rad*rad
      aaprx = aaprx+darea1
      if ((aaprx-a8) .gt. eps) goto 2
c     if (dabs(aaprx-a8) .le. eps) goto 2
      th = th+dth               ! new polar angle 
      goto 1
c Equivalent arc
 2    rad2 = rad*rad
      cs = cos(th)
      sn = sin(th)
      sl1 = sqrt(a**2+rad2-2.d0*a*rad*cs)
      sl2 = sqrt(b**2+rad2-2.d0*b*rad*sn)
      eqarc = 0.5*(sl1+sl2)

      return
      end

c=========================================================================================
c  Purpose:  Determines coords. of finite no.(N) of evenly distributed pts. on input 
c            ellipse 'i' contour so that the ellipse is approximated with N node polygon
c            with N approx. equal side lenghts.  Outputs nodal coords.: 'ex(i,*),ey(i,*)'
c            and total node # 'n'.  NOTE: pts. are distributed in counterclockwise dir.
c  Routines: epts8
c-----------------------------------------------------------
      subroutine thstep (ii,xc,yc,a,b,theta,sminarc,ex,ey,n)

      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /INCLU/ NODPERPAR
      PARAMETER (NLM=1000,IDIMTWO=NLM,MAXNODPERPAR=32)
      DIMENSION EX(NLM,MAXNODPERPAR*4),EY(NLM,MAXNODPERPAR*4),RLOC(MAXNODPERPAR),THLOC(MAXNODPERPAR)

      pi    = 4.*atan(1.)
      pihlf = pi/2.d0
      conv  = pi/180.d0         ! conversion to [rad]
      sn1   = sin(theta*conv)
      cs1   = cos(theta*conv)
      exc   = b/a
      th    = 0.d0              ! initiate polar angle
      n     = 0                 ! init. total node no.
c process 1st quadrant
      n = n+1
      r  = a                    ! th=0 node 
      rloc(n)  = r
      thloc(n) = th
      x = r*cos(th)
      y = r*sin(th)
      y = dsign(1.d0,y)*b*dsqrt(1.-(x/a)**2)
      ex(ii,n) = xc+x*cs1-y*sn1
      ey(ii,n) = yc+x*sn1+y*cs1
      f = r*dsqrt(1.d0+(sn1*cs1*(1.d0-exc**2))**2)
      dth = sminarc/f

c other 1st quadr. nodes...
 1    th = th+dth               ! new node polar angle  
      sn = sin(th)
      cs = cos(th) 
c Current polar radius
      r = b/dsqrt(sn**2+(exc*cs)**2)
c Curr.'transfer' fn.            
      f = r*dsqrt(1.d0+(sn*cs*(1.d0-exc**2))**2)
c Corr.polar angle point position
      dth = sminarc/f
c Last pt.in 1st quadr.reached ?
      slastarc = (pihlf-th)*b    ! approx.value
      if (slastarc .le. sminarc) goto 2 ! last reached... 
c if last is still not reached...
      n = n+1                   ! new 1st quadr. node+1
      rloc(n)  = r
      thloc(n) = th     
c convert node coords. from local el.c.sys.to global one :
c Node coords. in local (el.) c.s.
      x = r*cos(th)
      y = r*sin(th)
c correction...
      y = dsign(1.d0,y)*b*sqrt(1.-(x/a)**2)

c Node coords. in global c.s.
      ex(ii,n) = xc+x*cs1-y*sn1
      ey(ii,n) = yc+x*sn1+y*cs1      
c Goto new 1st quadr. node
      goto 1

c 1st quadr.is finished so obtain symmetrically other nodes:
 2    nquadr = n                ! no.of nodes per quadrant
c process 2nd quadrant
      n  = n+1
      th = pihlf
      r  = b
      x = r*cos(th)
      y = r*sin(th)
      y = dsign(1.d0,y)*b*dsqrt(1.-(x/a)**2)
      ex(ii,n) = xc+x*cs1-y*sn1
      ey(ii,n) = yc+x*sn1+y*cs1

      do j = 1,nquadr
         n  = n+1
         th = pi-thloc(nquadr+1-j)
         r  = rloc(nquadr+1-j) 
         x  = r*cos(th)
         y  = r*sin(th)
         y  = dsign(1.d0,y)*b*sqrt(1.-(x/a)**2)
         ex(ii,n) = xc+x*cs1-y*sn1
         ey(ii,n) = yc+x*sn1+y*cs1
      enddo

c now process 3rd quadrant
      do j = 2,nquadr
         n  = n+1
         th = -pi+thloc(j)
         r  = rloc(j)
         x  = r*cos(th)
         y  = r*sin(th)
         y  = dsign(1.d0,y)*b*sqrt(1.-(x/a)**2)
         ex(ii,n) = xc+x*cs1-y*sn1
         ey(ii,n) = yc+x*sn1+y*cs1       
      enddo

      n  = n+1
      th = -pihlf        
      r  = b
      x = r*cos(th)
      y = r*sin(th)
      y = dsign(1.d0,y)*b*sqrt(1.-(x/a)**2)
      ex(ii,n) = xc+x*cs1-y*sn1
      ey(ii,n) = yc+x*sn1+y*cs1

c finally process 4th quadrant
      do j = nquadr,2,-1
         n = n+1
         th = -thloc(j)
         r  = rloc(j)
         x = r*cos(th)
         y = r*sin(th)
         y = dsign(1.d0,y)*b*sqrt(1.-(x/a)**2)
         ex(ii,n) = xc+x*cs1-y*sn1
         ey(ii,n) = yc+x*sn1+y*cs1
      enddo

c all nodes are located, final no.of them is 'n'
      if (n .lt. NODPERPAR/2) then        ! in case with only 4 nodes
         n = NODPERPAR
         call epts8 (ii,xc,yc,a,b,theta,ex,ey)
      endif

      return
      end

c=========================================================================================
c  Purpose:  Determines coords. of 8 pts. distributed on input ellipse 'i' contour so
c            that the ellipse is approximated with 8 node polygon with 8 equal area
c            triangles.  Output is nodal coords.: 'ex(i,*),ey(i,*)' and equivalent arc: 
c            eqarc.  NOTE:  pts. are distributed in counterclockwise dir.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine epts8 (i,xc,yc,a,b,theta,ex,ey)

      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NLM=1000,IDIMTWO=NLM,MAXNODPERPAR=32)
      COMMON /INCLU/ NODPERPAR
      DIMENSION EX(NLM,MAXNODPERPAR*4),EY(NLM,MAXNODPERPAR*4),R(MAXNODPERPAR),THLOC(MAXNODPERPAR)

      eps   = 1.d-12
      pi    = 4.*atan(1.)
      conv  = pi/180.           ! conversion to [rad]
      exc   = b/a
      a8    = a*b*pi/(NODPERPAR*1.)         ! 1/8 (triangle area) ellipse area
      aaprx = 0.                ! initiate aprox.of 'a8'
      th    = 0.                ! initiate polar angle
      dth   = 1*conv            ! initiate angle incr. (~1 deg)

c Nodal polar coords.in local (el.) c.s.
      r(1)     = a
      thloc(1) = 0.
c Determine position of pt#2:
c Polar radius
 1    rad = b/sqrt(sin(th)**2+(exc*cos(th))**2)
c Approx.area increm.
      darea1 = 0.5*dth*rad*rad
      aaprx = aaprx+darea1
      if ((aaprx-a8) .gt. eps) goto 2
c     if (dabs(aaprx-a8) .le. eps) goto 2
      th = th+dth               ! new polar angle 
      goto 1

 2    r(2)     = rad
      thloc(2) = th 
      r(3)     = b
      thloc(3) = 0.5*pi
      r(4)     = rad
      thloc(4) = pi-th
      r(5)     = a
      thloc(5) = pi
      r(6)     = rad
      thloc(6) = -thloc(4)
      r(7)     = b
      thloc(7) = -thloc(3)
      r(8)     = rad
      thloc(8) = -th
c Node coords. in local (el.) c.s.
C convert node coords. from local el.c.sys.to global one

      sn = sin(theta*conv)
      cs = cos(theta*conv)

      do j = 1,NODPERPAR                ! for each node on el.cont.
c Node coords. in local (el.) c.s.
         x = r(j)*cos(thloc(j))
         y = r(j)*sin(thloc(j))
c correction...
         y = dsign(1.d0,y)*b*sqrt(1.-(x/a)**2)
c Node coords. in global c.s.
         ex(i,j) = xc+x*cs-y*sn
         ey(i,j) = yc+x*sn+y*cs      
      enddo

      return
      end

c=========================================================================================
C VARIABLE DEFINITION:
C --------------------
C
C NP ............... tot. no. of particulate points
C NTP..............  tot. no. of particul. center pts.= NP + no. of 
C                    image (virtual) pts.
C PX(I),PY(I) ...... coords of particul. center pts. : I=1,NTP
C BVX(I),BVY(I) .... coords of boundary verticies: I=1,NBV
C BPNO(I) .......... index of the closest particul. center pt. to the
C                    bound. vertex pt. I :
C                      If BPNO(I)=J, then (PX(J),PY(J)) is closest to
C                      the vertex(BVX(I),BVY(I))
C IJCONT(I,J) ........ contiguity list for particul. pt I (I=1,NP)
C                      Program allows max. of (k4) contiquous elems.
C                    THE ARRAY IS INITIALIZED WITH ENTRIES -1.
C                    IF IJCONT(I,MAXCT)=-2, THE LIST FOR ELEMENT I IS
C                    COMPLETE.
C BVCAVE(I):         INDICATES WHETHER VERTEX I IS A CONCAVE CORNER
C BVINT(I):          INDICATES WHETHER IMAGE POINT I IS INSIDE THE BODY
C MAXBV,MAXNP:       MAX DIMENSION FOR ARRAY (CONST)
C MAXCT              MAX NUMBER OF CONTIGUITY POINTS AROUND A PARTICULATE
C NIOP               NO. OF INTERNAL OPENINGS          
C NGBV               NO. OF GROUPED BOUNDARY VERTEX
C GVBX,GVBY          COORDINARES OF GROUPED BOUNDARY VERTICES
C NCONVT(I,J) ...... Jth node.no.. of the  Ith elem.
C XNODE(I),YNODE(I)  coord. of the Ith node
C NV(I) ............ no. of vertices of the Ith Voronoi polygon
C--------------------------------------------------------------------------
      subroutine vcm1(iflag,niop,ifour,ne,nelxtmp)

      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (K4=100,NLM=1000,IDIMTWO=NLM,MAXCOORD=15000)
      PARAMETER (k2=MAXCOORD,k1=MAXCOORD)

      DIMENSION CNPX(k2,k4),CNPY(k2,k4),YNODE(k2*3),NGHBR(k2)
      DIMENSION XNODE(k2*3),NCON(k2),ijcont(k2,k4)

      COMMON /BORDER/ BX(4),BY(4)
      COMMON /ELDATA/ CEX(maxcoord),CEY(maxcoord),A(NLM),B(NLM),TH(NLM),
     &     NNODES(IDIMTWO),PX(MAXCOORD),PY(MAXCOORD),GBVX(1,4),GBVY(1,4),
     &     NGBV(1),NTOT
      COMMON /VCM2DAT/ NCONVT(K1,K4),XC(K1,K4),YC(K1,K4),NV(K1)
      COMMON /PTOL/ DMAX,DMAXTOL
      DATA MAXCT/k4/

      IFLAG=0
      NP=NTOT
      DMAXTOL=1.0D-12
      DMAX=dabs(bx(4)-bx(1))
      DO I=1,3
         DMAX=MAX(DMAX,DABS(bx(I)-bx(I+1)))
      ENDDO
      DMAX=MAX(DMAX,DABS(by(4)-by(1)))
      DO I=1,3
         DMAX=MAX(DMAX,DABS(by(I)-by(I+1)))
      ENDDO
      
      PRINT *,'DMAX*DMAXTOL =',DMAX*DMAXTOL

      ngbv(1)=ifour

      do i=1,4
         gbvx(1,i)=bx(i)
         gbvy(1,i)=by(i)
      enddo

c Create contiguity list for particle/ellipse contour nodes:
      call conlist (niop,ngbv,gbvx,gbvy,np,px,py,ijcont,nghbr)

c Locate VC polygon vertices around each particulate centroid
      NUMV = 0                  ! init.no.of vertices
      JOLD = 0

      DO N = 1,NP               ! for each (real) particulate 
         IOLD = 0               ! counter of curr.part.nghbrs
         DO I = 1,MAXCT         ! for all neighbrs.
            IF ((IJCONT(N,I).EQ.-1) .OR. (IJCONT(N,I).EQ.-2)) THEN
            ELSE
               IJ        = IJCONT(N,I) ! part.rel.neighbr.no. I 
               CNPX(N,I) = PX(IJ) ! copy neigbr.coords.to
               CNPY(N,I) = PY(IJ) ! work coords.arrays
               IOLD      = IOLD+1 ! one more nghbr.
            ENDIF
         ENDDO
         NCON(N) = IOLD         ! tot.no.of nghbrs of curr.part 
         DO L = 1,NCON(N)       ! for all ngbrs.of part.N
            IF (L .LT. NCON(N)) THEN ! still there are neigbrs.
               K = L+1          ! count it...    
            ELSE                ! last neighbr.
               K = 1            ! next is one
            ENDIF
c now L,K(next to L) are rel.no of neighbrs. of N
            NUMV = NUMV+1       ! one more VC vertex of part.N 
c Create circle (C(N,L)) thru centroids N,CPN(N,L) & CPN(N,K):
            CALL CENTER (PX(N),PY(N),CNPX(N,L),CNPY(N,L),CNPX(N,K),CNPY(N,K),
     *                   XC(N,L),YC(N,L))       
         enddo
         NV(N) = NUMV-JOLD      ! tot.no.of VC vert.for part.N
         JOLD  = NUMV
      enddo
      
C  THIS PART CALCULATES TOTAL NO. OF NODES & THEIR CONNECTIVITY
      NODTL = NV(1)
      DO I = 1,NV(1)
         NCONVT(1,I) = I 
         XNODE(I) = XC(1,I)
         YNODE(I) = YC(1,I)   
      enddo
      
      N = NODTL 
      
      EPS = DMAX*DMAXTOL*1.0D06
      DO I = 2,NP 
         DO 321 K = 1,NV(I)  
            DO L = 1,NODTL
               IF (DABS(XC(I,K)-XNODE(L)).LE.EPS.AND.DABS(YC(I,K)-YNODE(L)).
     *             LE.EPS) THEN 
                  NCONVT(I,K) = L
                  GO TO 321
               ENDIF  
            enddo
            N = N+1
            NCONVT(I,K) = N
            XNODE(N) = XC(I,K)
            YNODE(N) = YC(I,K)

 321     CONTINUE 
         NODTL = N
      enddo
      iflag=1
      ne=nelxtmp

      return
      END

c=========================================================================================
c  Purpose:  Creates contiguity list for a given set of points (or particulate centroids)
c            Output is IJCONT(*,*), NGHBR(*).
c  Routines: ckcave, ckifin, concave, distsq, reflec, getcon 
c-----------------------------------------------------------------------------------------
      subroutine conlist (niop,ngbv,gbvx,gbvy,np,px,py,ijcont,nghbr)
      
      IMPLICIT REAL *8(A-H,O-Z)
      PARAMETER (k4=100,MAXCOORD=15000)
      PARAMETER (k2=MAXCOORD,k1=MAXCOORD)
      DIMENSION IJCONT(k2,k4),IMAGOF(k2),NGBV(1),NGHBR(k2),IBPNO(k1),CVX(k1)
      DIMENSION PX(maxcoord),PY(maxcoord),BVX(4),BVY(4),GBVX(1,4),GBVY(1,4),IPTR(k2)
      DIMENSION NCV(k1),CVY(k1)
      LOGICAL CORNER,EDGE,BVINT(k2),BVCAVE(k1),B2REV(k1),CKREV
      COMMON /PTOL/ DMAX,DMAXTOL
      DATA MAXBV/4/,MAXNP/MAXCOORD/,MAXCT/k4/,MAXIM/2000/
 
c Identify concave boundary contour :
      DO N=1,NIOP+1             ! do it for each contour...
         NBV = NGBV(N)          ! no. of curr. contour nodes
         DO I=1,NGBV(N)
            BVX(I) = GBVX(N,I)  ! create work coordinate arrays:
            BVY(I) = GBVY(N,I)  ! (contour nodes)
         ENDDO
         NCVR=0                 ! init.no.of concave nds.counter
         M=NBV-1
         DO I=1,NBV             ! for each contour node  
            IF (I-M) 121,122,123 
 121        K=I+1               ! case: I < M
            L=K+1
            GO TO 124
 122        K=I+1               ! case: I = M
            L=1
            GO TO 124  
 123        K=1                 ! case: I > M 
            L=K+1
 124        CALL CONCAVE (BVX(I),BVY(I),BVX(K),BVY(K),BVX(L),BVY(L),ICON,
     *                    XVR1,YVR1,XVR2,YVR2)
            IF (ICON .EQ. 1)THEN ! node K is concave        
               NCVR = NCVR+1    ! incr.concave nodes counter
               CVX(NCVR) = BVX(K) ! work arrays - coords.of 
               CVY(NCVR) = BVY(K) ! concave nodes
               NCV(NCVR) = K    ! index of curr.concave node
c Create 2 virtual particulate pts. (centroids only) around curr. concave corner:
               IF (NP+1.GT.MAXCOORD) THEN
                  PRINT *,'DIMENSION OF PX,PY NOT ENOUGH'
                  PRINT *,'INCREASE MAXCOORD VALUE'
                  PRINT *,'STOPPED IN CONLIST'
                  STOP
               ENDIF
               PX(NP+1) = XVR1  ! 1st. virt. pt.
               PY(NP+1) = YVR1
               PX(NP+2) = XVR2  ! 2nd. virt. pt.
               PY(NP+2) = YVR2
               NP = NP+2        ! incr.no.of partic.for added 2
            ENDIF
         ENDDO
      ENDDO

C initialize interior/exterior flag for each partic.
      DO IC = 1,MAXNP        ! max.no.of particulates in domain
c all image pts. assumed initially outside of the domain
         BVINT(IC) = .FALSE.
      ENDDO

C init. contiguity list: -1 for no entry in the list
      DO IC = 1,MAXCT        ! max.no.of neighbouring particulates
         DO IP = 1,MAXNP    ! max.no.of particulates in domain
            IJCONT(IP,IC) = -1  ! IP-curr.part.no. ,
         ENDDO                  ! IC-rel.indx.of neighb. partic.
      ENDDO

C INITIALIZE B2REV LIST: FALSE INDICATES CORNER IBV HAS FORWARD IMAGE
C POINT REFLECTED INSIDE THE BODY, FIRST SEARCH WILL HAVE ROLE OF IMAGE
C POINT AND REFLECTION POINT REVERSED 

      DO IT=1,NIOP+1         ! for each contour in the domain
         NBV = NGBV(IT)         ! no.of curr.contour nodes
         DO I=1,NGBV(IT)
            BVX(I) = GBVX(IT,I) ! curr.contour nodal coords.-
            BVY(I) = GBVY(IT,I) ! (work arrays)
         ENDDO
         DO IBV = 1,MAXBV       ! for all nodes on curr.contour
            B2REV(IBV) = .FALSE. ! assume all ?
         ENDDO

C locate particulate centroid (PP) closest to boundary vertices
         DO IBV = 1,NBV         ! for each node on curr.contour
            SMINDIFF = 1.D10     ! initial big no. for minimum distance
C for each node on curr.bound.contour find closest particulates:
            DO IP = 1,NP        ! check for each particulate:
c     find distance between pts. IBV and IP: 
               DIFF = DISTSQ (BVX(IBV),BVY(IBV),PX(IP),PY(IP))
               IF ((DIFF-SMINDIFF) .LT. -DMAX*DMAXTOL) THEN
                  SMINDIFF = DIFF ! new value for min.distance
                  INEAR = IP    ! closest particulate index
               ENDIF
            ENDDO
            IBPNO(IBV) = INEAR  ! closest part.index for cont.node IBV
         ENDDO

C create reflection points for each PP particulates:
         IF (IT .EQ. 1) THEN    ! 1 - main (exterior) contour
            NTP = NP+1          ! incr.tot.no. of part. for one virtual
         ELSE
            NTP = NTP+1         ! same thing if interior openings exist 
         ENDIF
         DO IBV = 1,NBV         ! for each curr.contour node
            IF (IBV .EQ. NBV) THEN ! reached end node for curr.contour
               NEXT = 1
               LAST = IBV-1
            ELSE                ! it's still not the end
               IF (IBV .EQ. 1) THEN ! if curr.part. is the first one
                  NEXT = 2
                  LAST = NBV
               ELSE             ! for any other point .ne. 1 or NBV
                  NEXT=IBV+1
                  LAST=IBV-1
               ENDIF
            ENDIF

C determine if the corner is concave  (IBV,LAST,NEXT are working particulate numbers)                            
            CALL CKCAVE (MAXBV,BVCAVE,IBV,LAST,NEXT,BVX,BVY)
C get backline (previous boundary line segment) image point (glob.index is NTP) and label its generator point 
            CALL REFLEC (BVX(LAST),BVY(LAST),BVX(IBV),BVY(IBV),PX(IBPNO(IBV)),
     *                   PY(IBPNO(IBV)),PX(NTP),PY(NTP))
c NTP-NP is realtive index of virtual particulate. IBPNO(IBV) contains index of part. closest to IBV
            IMAGOF(NTP-NP) = IBPNO(IBV)

C check wheather backline image pt. is in contour interior
            IF ( BVCAVE(IBV) ) THEN ! if IBV is concave corner
               CKREV = .FALSE.  ! IBV is concave
               CALL CKIFIN (BVINT,IBV,NEXT,LAST,PX,PY,BVX,BVY,
     *                      B2REV,NTP,CKREV)
            ENDIF

            IF (IJCONT(IBPNO(IBV),1) .EQ. -1) THEN ! no entry in cont.list
               IJCONT(IBPNO(IBV),1) = NTP ! asdsign reflect.part in cont.lst.
            ENDIF

            NTP = NTP+1         ! incr. total no.of particulates

            IF (IBPNO(NEXT).NE.IBPNO(IBV).OR.(IBPNO(NEXT).EQ.IBPNO(IBV).AND.
     *          IJCONT(IBPNO(IBV),2).EQ.-1)) THEN
               CALL REFLEC (BVX(IBV),BVY(IBV),BVX(NEXT),BVY(NEXT),
     *                      PX(IBPNO(IBV)),PY(IBPNO(IBV)),PX(NTP),PY(NTP))
               IMAGOF(NTP-NP) = IBPNO(IBV)
               IF (BVCAVE(IBV)) THEN
                  CKREV = .TRUE.
                  CALL CKIFIN (BVINT,IBV,NEXT,LAST,PX,PY,BVX,BVY,
     *                         B2REV,NTP,CKREV)
               ENDIF
               IF (IJCONT(IBPNO(IBV),2) .EQ. -1) THEN ! no entry in cont.list
                  IJCONT(IBPNO(IBV),2) = NTP ! asdsign reflect.part in cont.lst.
               ENDIF
               NTP = NTP+1      ! incr. total no.of particulates
            ENDIF
         ENDDO
         
C develop contiguity list for each corner particulate:
         CORNER = .TRUE.
         EDGE   = .FALSE.
         DO IBV = 1,NBV         ! for all curr.contour nodes
C if CONT(IBPNO(IBV),MAXCT) = -2 then this indicates that corner pt. IBV is completed. Go to next IBV 
            IF ( IJCONT(IBPNO(IBV),MAXCT) .NE. -2 ) THEN
               IC = IBPNO(IBV)
               I2 = IJCONT(IC,2)
               IFIRST = 3
               CALL GETCON (IC,I2,IFIRST,PX,PY,NP,NTP-1,IJCONT,MAXCT,
     *                      CORNER,BVINT,B2REV,MAXBV,IBV,EDGE,IMAGOF)
            ENDIF
         ENDDO

C reflect the remaining close to boundary pts. and create contiguity list for them:
         CORNER = .FALSE.
         EDGE   = .TRUE.
         DO 46  IBV = 1,NBV
            IF (IBV .EQ. NBV) THEN
               NEXT = 1
            ELSE
               NEXT = IBV+1
            ENDIF
            LAST = IBPNO(IBV)
            IF (IBPNO(NEXT).EQ.IBPNO(IBV))  GOTO 46
 460        IC = IJCONT(LAST,3)
            
C FOLLOWING IF STATEMENT IS NEEDED IF A PARTICULATE SHARES MORE THAN
C ONE BOUNDARY CORNER. IN THAT CASE 3RD PT. ON ITS CONTIGUITY LIST IS
C A REFLECTION PT. AND 4TH PT. IS A MID-BOUNDARY PT.
            IF (IC .GT. NP) THEN
               IC = IJCONT(LAST,4)
            ENDIF
            IF (IC .GT. NP) THEN
               IC = IJCONT(LAST,5)
            ENDIF
            DO 461  I = 1,NBV
               IF(IC .EQ. IBPNO(I) .OR. IC .GT. NP)  GOTO 46
 461        CONTINUE

C THIS NEXT IS NECESSARY IF SOME OTHER POINT HAS CLAIMED THE NEXT
C BOUNDARY POINT IC IN ITS CONTIGUITY LIST
            IJCONT(IC,1) = LAST
            CALL REFLEC (BVX(IBV),BVY(IBV),BVX(NEXT),BVY(NEXT),PX(IC),PY(IC),
     *                   PX(NTP),PY(NTP))
            IMAGOF(NTP-NP) = IC
            IJCONT(IC,2)   = NTP
            I2             = NTP
            IFIRST         = 3
            CORNER         = .FALSE.
            CALL GETCON (IC,I2,IFIRST,PX,PY,NP,NTP,IJCONT,MAXCT,CORNER,
     *                   BVINT,B2REV,MAXBV,IBV,EDGE,IMAGOF)
            NTP = NTP+1
            IF (IJCONT(IC,2).EQ.IBPNO(NEXT).OR.IJCONT(IC,3).EQ.IBPNO(NEXT)) 
     *          GOTO 46
            LAST = IC
            GOTO 460
 46      CONTINUE

C initialize IPTR array
         DO IP = 1,NP
            IPTR(IP) = IP
         ENDDO
      ENDDO

C develop contiguity list for remaining pts.:
      CORNER = .FALSE.
      EDGE   = .FALSE.
      DO 5  IP = 1,NP
         IF (IJCONT(IPTR(IP),MAXCT) .EQ. -2)  GOTO 5
         IF (IJCONT(IPTR(IP),1).EQ.-1) THEN
            DO 51 IPP = IP+1,NP
               IF (IJCONT(IPTR(IPP),1).NE.-1.AND.IJCONT(IPTR(IPP),MAXCT).NE.-2)
     *             THEN
                  ISAVE    = IPTR(IPP)
                  IPTR(IPP) = IPTR(IP)
                  IPTR(IP)  = ISAVE
                  GOTO 501
               ENDIF
 51         CONTINUE
         ENDIF
 501     CONTINUE

         IC     = IPTR(IP)
         I2     = IJCONT(IC,2)
         IFIRST = 3
         CORNER =.FALSE.

         CALL GETCON (IC,I2,IFIRST,PX,PY,NP,NTP,IJCONT,MAXCT,CORNER,BVINT,B2REV,
     *                MAXBV,IBV,EDGE,IMAGOF)
 5    CONTINUE
      NTP = NTP-1
c count no.of neighbouring particles for each (real) particle:
      DO 6  IC = 1,NP           ! for each particulate 
         nghbr(ic) = 0          ! initial no.of neighbrs.for curr.part.
         DO 6  I = 1,MAXCT
            IF (IJCONT(IC,I) .EQ. -1 .OR. IJCONT(IC,I) .EQ. -2) GOTO 6
            nghbr(ic) = nghbr(ic)+1 ! one more neighbr.part. 
 6    CONTINUE     

      return
      end

c=========================================================================================
c  Purpose:  Identifies whether (X2,Y2) is a concave corner in the polygon.  Returns CON = 
c            1.0 if pt.(X2,Y2) falls on the LHS of the line (vector) {(X1,Y1),(X3,Y3)}, 
c            i.e. (X2,Y2) is a concave corner.  If so, the routine returns 2 virtual 
c            particulate pts.:  (XVR1,YVR1) & (XVR1,YVR2) located on either side of pt. 
c            (X2,Y2) at a distance 'DS'.  The above 3 lines are colinear and parallel to
c            the line {(X1,Y1),(X3,Y3)}.  Otherwise CON = 0.
c  Routines: None
c-----------------------------------------------------------------------------------------
      SUBROUTINE CONCAVE (X1,Y1,X2,Y2,X3,Y3,ICON,XVR1,YVR1,XVR2,YVR2)

      IMPLICIT REAL *8(A-H,O-Z)
      COMMON /PTOL/ DMAX,DMAXTOL  
      
      ICON  = 0
C      eps1 = 1.0D-20
C      eps2 = 1.0D-20 
      EPS1=DMAX*DMAXTOL
      EPS2=DMAX*DMAXTOL
      pi   = 4.*atan(1.)
      
      IF (DABS(X3-X1).LE.eps2) THEN
         IF ((Y3-Y1).GE.eps2) THEN
            IF((X2-X1).LE.eps1) THEN
               ICON = 1
            ENDIF
         ELSE
            IF ((X2-X1) .GE. eps1) THEN              
               ICON = 1
            ENDIF
         ENDIF
      ELSE
         Y = Y1+(X2-X1)*(Y3-Y1)/(X3-X1)       
         IF ((X3-X1) .GT. eps2) GOTO 10
         IF ((X1-X3) .GT. eps2) GOTO 20                     
 10      IF ((Y2-Y) .GE. eps1) THEN 
            ICON = 1
         ENDIF
         GO TO 30
 20      IF ((Y2-Y) .LE. eps1) THEN
            ICON = 1
         ENDIF      
 30   ENDIF
      DS = 0.05*DMAX
      IF (ICON .EQ. 1) THEN 
         IF (DABS(X3-X1) .LT. eps2) THEN
            TH = pi/2.
         ELSE
            TH = DABS(ATAN((Y3-Y1)/(X3-X1)))                
         ENDIF

c find in which quadrant falls (X3,Y3) w.r.t. pt. (X1,Y1):

         IF ((DABS(X3-X1) .LE. eps2 .AND. Y3 .GT. Y1) .OR.
     *        (X3 .GT. X1 .AND. Y3 .GT. Y1)) GOTO 40          
         IF ((DABS(Y3-Y1) .LE. eps2 .AND. X3 .LT. X1) .OR.
     *        (X3 .LT. X1 .AND. Y3 .GT. Y1)) GOTO 50        
         IF ((DABS(X3-X1) .LE. eps2 .AND. Y3 .LT. Y1) .OR.
     *        (X3 .LT. X1 .AND. Y3 .LT. Y1)) GOTO 60 
         IF ((DABS(Y3-Y1) .LE. eps2 .AND. X3 .GT. X1) .OR.
     *        (X3 .GT. X1 .AND. Y3 .LT. Y1)) GOTO 70 

 40      XVR1 = X2-DS*COS(TH)
         YVR1 = Y2-DS*SIN(TH)
         XVR2 = X2+DS*COS(TH)
         YVR2 = Y2+DS*SIN(TH)
         GOTO 80

 50      XVR1 = X2+DS*COS(TH)
         YVR1 = Y2-DS*SIN(TH)             
         XVR2 = X2-DS*COS(TH)
         YVR2 = Y2+DS*SIN(TH)
         GOTO 80

 60      XVR1 = X2+DS*COS(TH)
         YVR1 = Y2+DS*SIN(TH)
         XVR2 = X2-DS*COS(TH)
         YVR2 = Y2-DS*SIN(TH)
         GOTO 80

 70      XVR1 = X2-DS*COS(TH)
         YVR1 = Y2+DS*SIN(TH)
         XVR2 = X2+DS*COS(TH)
         YVR2 = Y2-DS*SIN(TH)
         GOTO 80

 80   ENDIF                

      RETURN 
      END

c=========================================================================================
c  Purpose:  Form vector U on the back bound.segment and vector V on the forward boundary 
c            segment.  Then determine whether the boundary vertex is concave.  Output: 
c            BVCAVE(IBV) = .true.  -corner IBV is concave, = .false. -corner IBV is convex
c  Routines: None
c-----------------------------------------------------------------------------------------
      SUBROUTINE CKCAVE (MAXBV,BVCAVE,IBV,LAST,NEXT,BVX,BVY)
      
      IMPLICIT REAL *8(A-H,O-Z)
      PARAMETER (MAXCOORD=15000)
      PARAMETER (k1=MAXCOORD)
      DIMENSION BVX(4),BVY(4)    
      LOGICAL BVCAVE(k1)
      COMMON /PTOL/ DMAX,DMAXTOL        

C      eps1 = 1.D-20
      EPS1=DMAX*DMAXTOL

c NOTE: material is on RHS cof vectors U,V !
      UX = BVX(IBV)-BVX(LAST)
      UY = BVY(IBV)-BVY(LAST)
      VX = BVX(NEXT)-BVX(IBV)
      VY = BVY(NEXT)-BVY(IBV)
      X  = UX+VX
      Y  = UY+VY

C first check for vertical U vector:
      IF (DABS(UX) .LE. eps1) THEN ! line {LAST,IBV}-vertical
         IF (UY .GE. 0.) THEN   ! IBV .ne. LAST
            IF (X .LE. UX) THEN      
               BVCAVE(IBV) = .FALSE. ! IBV is concave
            ELSE
               BVCAVE(IBV) = .TRUE. ! IBV is convex
            ENDIF
         ELSE
            IF (X. GE .UX) THEN
               BVCAVE(IBV) = .FALSE.
            ELSE
               BVCAVE(IBV) = .TRUE.
            ENDIF
         ENDIF
      ELSE
         
C since U is not vertical, find slope of U:
         SLOPE = UY/UX

C check 1st and 4th quadrant:
         IF (UX .GT. 0.) THEN   ! U is in 1st or 4th quadrant
            IF (Y .GE. SLOPE*X) THEN
               BVCAVE(IBV) = .FALSE.
            ELSE
               BVCAVE(IBV) = .TRUE.
            ENDIF
         ELSE
C check 2nd and 3rd quadrant:
            IF (Y .LE. SLOPE*X) THEN
               BVCAVE(IBV) = .FALSE.
            ELSE
               BVCAVE(IBV) = .TRUE.
            ENDIF
         ENDIF
      ENDIF
      
      RETURN
      END

c=========================================================================================
c  Purpose:  Finds coords. of the reflection pt. (RX,RY) of the original point (PX,PY) 
c            w.r.t. line {(SLX1,SLY1),(SLX2,SLY2)}.  Output is (RX,RY).
c-----------------------------------------------------------------------------------------
      SUBROUTINE REFLEC (SLX1,SLY1,SLX2,SLY2,PX,PY,RX,RY)

      IMPLICIT REAL *8(A-H,O-Z)      

c find intersection between L1-L2 and PR as C:
      IF (SLY1 .EQ. SLY2) THEN    ! line SL1-SL2 is horiz.
         XC = PX
         YC = SLY1
         GOTO 10
      ENDIF
      IF (SLX1 .EQ. SLX2) THEN    ! line SL1-SL2 is vert.
         XC = SLX1
         YC = PY
         GOTO 10
      ENDIF
      IF (SLY1 .NE. SLY2 .AND. SLX1 .NE. SLX2) THEN ! line SL1-SL2 inclined
C B12 and BPR are slopes of the lines intersecting at (XC,YC)
         B12 = (SLY2-SLY1)/(SLX2-SLX1)
         BPR = -1.D0/B12
         XC = (SLY1-B12*SLX1-PY+BPR*PX)/(BPR-B12)
         YC = PY+BPR*XC-BPR*PX
      ENDIF
c find reflected particulate centroid
 10   RX = 2.D0*XC-PX
      RY = 2.D0*YC-PY

       RETURN
       END                          

c=========================================================================================
c  Purpose:  Output:  BVINT(NTP) = .true.  , refl. part. P(NTP) is outside domain
c                                = .false. , refl. part. P(NTP) is inside domain
c                     B2REV = .true. , = .false.
c  Routines: None
c-----------------------------------------------------------------------------------------
      SUBROUTINE CKIFIN (BVINT,IBV,NEXT,LAST,PX,PY,BVX,BVY,
     *                   B2REV,NTP,CKREV) 

      IMPLICIT REAL *8(A-H,O-Z)
      PARAMETER (MAXCOORD=15000)
      PARAMETER (k1=MAXCOORD,k2=MAXCOORD)
      DIMENSION BVX(4),BVY(4),PY(MAXCOORD),PX(MAXCOORD)
      LOGICAL BVINT(K2),B2REV(K1),CKREV
      COMMON /PTOL/ DMAX,DMAXTOL

C      eps1 = 1.D-20
C      eps2 = 1.D-20
      EPS1=DMAX*DMAXTOL
      EPS2=DMAX*DMAXTOL

      UX = BVX(IBV)-BVX(LAST)
      UY = BVY(IBV)-BVY(LAST)
      VX = BVX(NEXT)-BVX(IBV)
      VY = BVY(NEXT)-BVY(IBV)
      X  = PX(NTP)
      Y  = PY(NTP)

C CHECK BACKLINE (line LAST-IBV):
C first check if the backline is vertical:
      IF (DABS(UX) .LE. eps1) THEN ! line LAST-IBV is vert.
         IF (UY .LE. 0.) THEN   ! IBV is bellow LAST
            IF (X.GT.BVX(IBV))   BVINT(NTP) = .TRUE.
         ELSE                   ! IBV is above LAST
            IF (X.LT.BVX(IBV))   BVINT(NTP) = .TRUE.
         ENDIF
C if the backline is not vertical...
      ELSE
         SLOPEB = UY/UX         ! backline slope
         SINTB = BVY(IBV)-SLOPEB*BVX(IBV)
         IF (UX .GE. 0.) THEN   ! backline is in 1st quadr.
            IF (Y .GT. SLOPEB*X+SINTB)   BVINT(NTP) = .TRUE.
         ELSE                   ! backline is in 2nd quadr.
            IF (Y .LT. SLOPEB*X+SINTB)   BVINT(NTP) = .TRUE.
         ENDIF
      ENDIF

C CHECK FRONTLINE:
C first check if the frontline is vertical:
      IF (DABS(VX) .LE. eps2) THEN
         IF (VY .LE. 0.) THEN
            IF (X .GT. BVX(IBV))   BVINT(NTP) = .TRUE.
            IF (CKREV .AND. X .GT. BVX(IBV))   B2REV(IBV) = .TRUE.
         ELSE
            IF (X .LT. BVX(IBV))   BVINT(NTP) = .TRUE.
            IF (CKREV .AND. X .LT. BVX(IBV))   B2REV(IBV) = .TRUE.
         ENDIF
C if the frontline is not vertical...
      ELSE
         SLOPEF = VY/VX
         SINTF = BVY(IBV)-SLOPEF*BVX(IBV)
         IF (VX .GE. 0.) THEN
            IF (Y .GT. SLOPEF*X+SINTF)   BVINT(NTP)=.TRUE.
            IF (CKREV .AND. Y .GT. SLOPEF*X+SINTF)   B2REV(IBV)=.TRUE.
         ELSE
            IF (Y .LT. SLOPEF*X+SINTF)   BVINT(NTP) = .TRUE.
            IF (CKREV .AND. Y .LT. SLOPEF*X+SINTF)   B2REV(IBV) = .TRUE.
         ENDIF
      ENDIF
      
      RETURN
      END

c=========================================================================================
c  Purpose:  Develop contiguity list for particulate point IC.
c  Routines: center
c-----------------------------------------------------------------------------------------
      SUBROUTINE GETCON (IC,I2,IFIRST,PX,PY,NP,NTP,IJCONT,MAXCT,CORNER,
     *                   BVINT,B2REV,MAXBV,IBV,EDGE,IMAGOF)

      IMPLICIT REAL *8(A-H,O-Z) 
      PARAMETER (k4=100,MAXCOORD=15000)     
      PARAMETER (k2=MAXCOORD,k1=MAXCOORD)
      DIMENSION IJCONT(K2,K4),IMAGOF(K2),PX(MAXCOORD),PY(MAXCOORD)
      LOGICAL   NEEDCK,DONE,CORNER,EDGE,BVINT(K2),B2REV(K1),REV
      COMMON /PTOL/ DMAX,DMAXTOL
      DATA      BIGNUM/1.0D10/
     
      eps = 1.D-30

      EPS=DMAX*DMAXTOL

      ICONT  = IFIRST
      IDONE  = IJCONT(IC,1)
      IDONE1 = IJCONT(IC,2)
      ILAST  = IDONE
      DONE   = .FALSE.
      J      = I2

c find circle center (OLD) thru centroids IC,J & IDONE :
      CALL CENTER (PX(IC),PY(IC),PX(J),PY(J),PX(IDONE),PY(IDONE),OLDXC,OLDYC)

C START MAIN LOOP COUNTER-CLOCKWISE AROUND POINT IC UNTIL NEXT CONTIGUOUS POINT HAS INDEX IDONE OR IDONE1 (DONE = .TRUE.)
C IF CORNER POINT, CORNER IS CONCAVE, AND B2REV(IBV) = .TRUE. MUST REVERSE THE ROLE OF THE PARTICULATE POINT AND ITS IMAGE
C WHEN SEARCHING FOR THE THIRD CONTIGUOUS POINT. IN THIS CIRCUMSTANCE REV = .TRUE. ON CORNER POINTS IT IS NECESSARY TO 
C CONSIDER THE IMAGE POINT WHICH IS FIRST ON THE CONTIGUITY LIST FOR THE CORNER.

      REV = .FALSE.
      ITP = NP
      IF (CORNER) THEN
         ITP = NTP
         IF (B2REV(IBV)) THEN
            REV = .TRUE.
         ENDIF
      ENDIF

      IF (EDGE) ITP = NTP
 230  IF (DONE) GOTO 300
      SMINDIFF = BIGNUM

      DO 250  IP = 1,ITP
         IF (IP .EQ. IC .OR. IP .EQ. J .OR. IP .EQ. ILAST) GOTO 250
C this is for corner pts. only
         IF (IP .GT. NP) THEN
C this is only case where edge might be used although not done
            IF ( IMAGOF(IP-NP) .NE. IC) GOTO 250
            IF (CORNER) THEN
               IF (BVINT(IP)) GOTO 250
               IF (IP .EQ. IJCONT(IC,2)) GOTO 250
            ENDIF
         ENDIF

         IF ( NEEDCK(PX(IP),PY(IP),PX(IC),PY(IC),PX(J),PY(J),REV) ) THEN
            CALL CENTER (PX(IC),PY(IC),PX(J),PY(J),PX(IP),PY(IP),XC,YC)
            DIFF = DISTSQ(OLDXC,OLDYC,XC,YC)
c      IF (DIFF .LE. SMINDIFF) THEN
            IF ((DIFF-SMINDIFF) .LT. -dmax*dmaxtol) THEN
c            IF (DIFF.LT.SMINDIFF) THEN
c check to see if it is a degenerate case
c take the pt. that turns the right angle
               IF (DABS(DIFF) .LE. eps .AND. J .LE. NP) THEN
                  IJCONT(IC,ICONT) = -1
                  ICONT = ICONT-1
               ENDIF
               SMINDIFF = DIFF
               NEXT    = IP
               SAVEXC  = XC
               SAVEYC  = YC
            ENDIF
         ENDIF
 250  CONTINUE
     
 251  IF (NEXT.EQ.IDONE.OR.NEXT.EQ.IDONE1.OR.NEXT.EQ.IJCONT(IC,3)) THEN
c     inext=0
c     do i=1,7
c     if(next.eq.Cont(IC,i)) inext=1
c     enddo
c     
c     if(inext.eq.1) then
         IJCONT(IC,ICONT) = -1
         DONE = .TRUE.
      ELSE
         if(IC.gt.MAXCOORD.or.icont.gt.100) then
            write(*,*) ic,icont
            PRINT *,'EPS USED IN GETCON = ',eps
            PRINT *,'INCREASE/DECREASE IF YOU GET THIS ERROR'
            stop
         endif
         IJCONT(IC,ICONT) = NEXT
         ILAST = J
         J     = NEXT
         ICONT = ICONT+1
      ENDIF
      IF (IJCONT(NEXT,1) .EQ. -1) THEN
         IJCONT(NEXT,1) = IC
         IJCONT(NEXT,2) = IJCONT(IC,ICONT-2)
      ENDIF
      OLDXC = SAVEXC
      OLDYC = SAVEYC
      REV = .FALSE.
      GOTO 230

C indicate : element IC is done , by entering -2 in last position
 300  IJCONT(IC,MAXCT) = -2
      DO 400 I = 1,MAXCT
         IF (IJCONT(IC,I) .EQ. -1 .OR. IJCONT(IC,I) .EQ. -2) GOTO 400
         J = IJCONT(IC,I)
 400  CONTINUE

      RETURN
      END
c=========================================================================================
c  Purpose:  Return center point (XC,YC) of the circle determined by the points (X1,Y1), 
c            (X2,Y2), (X3,Y3) 
c  Routines: None
c-----------------------------------------------------------------------------------------
       SUBROUTINE CENTER (X1,Y1,X2,Y2,X3,Y3,XC,YC)

       IMPLICIT REAL *8(A-H,O-Z)      

       DATA BIGNUM/1.0D20/,SMMNUM/1.0D-20/

       C1 = Y2**2 - Y1**2 + X2**2 - X1**2
       C2 = Y3**2 - Y1**2 + X3**2 - X1**2
       C3 = Y3**2 - Y2**2 + X3**2 - X2**2

       DENOM = 2.*(X1*Y2 - X2*Y1 + X2*Y3 - X3*Y2 + X3*Y1 - X1*Y3)

       IF (DABS(DENOM) .LE. SMMNUM) THEN
          XC = BIGNUM
          YC = BIGNUM
       ELSE
          XC = (Y3*C1 - Y2*C2 + Y1*C3)/DENOM
          YC = (-X3*C1 + X2*C2 - X1*C3)/DENOM
       ENDIF

       RETURN
       END

c=========================================================================================
c  Purpose:  GENERATION OF FINITE ELEMENT MESH AROUND PARTICULATE POINTS CONTAINED WITHIN 
c            AN ARBITRARY DOMAIN.                             
c  Routines: epts8,setvcnd1, inellip, detelps permuts, cornod ,bordv, conlist, fndnghel, 
c            cpwars, makeseg, lnelint          
c-----------------------------------------------------------------------------------------
C VARIABLE DEFINITION:
C --------------------
C NP ............... tot. no. of particulate points
C NTP .............  tot. no. of particul. center pts.= NP + no. of 
C BVX(I),BVY(I) .... coords of boundary verticies: I=1,NBV
C IJCONT(I,J) ...... contiguity list for particul. pt I (I=1,NP)
C                    Program allows max. of (k4) contiquous elems.
C                    THE ARRAY IS INITIALIZED WITH ENTRIES -1.
C                    IF CONT(I,MAXCT)=-2, THE LIST FOR ELEMENT I IS
C                    COMPLETE.
C NIOP ............. NO. OF INTERNAL OPENINGS          
C GVBX,GVBY ........ COORDINARES OF GROUPED BOUNDARY VERTICES
C NCONVT(I,J) ...... Jth node.no.. of the  Ith elem.
C XNODE(I),YNODE(I)  coord. of the Ith node
C NV(I) ............ no. of vertices of the Ith Voronoi polygon
C POLYAREA(I) ...... area of the Ith Voronoi polygon
C RATIO(I) ......... RATIO OF AREA OF PARTICULATE TO ITS POLYGON
C DNEAR(I) ......... DISTANCE OF NEAREST NEIGHBOUR OF Ith PARTICULATE
C DMEAN(I) ......... MEAN NEAR NEIGHBOUR DISTANCE OF Ith PARTICULATE
C-----------------------------------------------------------------------------------------
      subroutine vcm2(iflag,niop,ifour,nee)

      IMPLICIT REAL *8(A-H,O-Z)
      PARAMETER (NLM=1000,MAXCOORD=15000,IDIMTWO=NLM,MAXNODPERPAR=32)
      PARAMETER (k4=100,k5=300,kel=NLM,k6=50)
      PARAMETER (k1=MAXCOORD,k2=MAXCOORD)
      COMMON /BORDER/ BX(4),BY(4)
      COMMON /ELDATA/ CEX(maxcoord),CEY(maxcoord),A(NLM),B(NLM),TH(NLM),
     &     NNODES(IDIMTWO),PX(MAXCOORD),PY(MAXCOORD),GBVX(1,4),GBVY(1,4),
     &     NGBV(1),NTOT
      COMMON /WCOPY/ NCONT(kel,k5),XNODE(k2*3),YNODE(k2*3)
      COMMON /WCOPY2/ NE,NODTL,NCONT1(KEL,K5),NVEL1(KEL)
      COMMON /ELCNT/ IJCONT(k2,k4),NGHBR(k2),ISEGNOD(kel,k6),NSEG(kel)
      COMMON /VCM2DAT/ NCONVT(k1,K4),XC(k1,K4),YC(k1,K4),NV(k1)
      COMMON /PTOL/ DMAX,DMAXTOL
      DIMENSION EX(nlm,MAXNODPERPAR*4),EY(nlm,MAXNODPERPAR*4)
      DIMENSION POLYAREA(kel),RATIO(kel),NTEMP(k5)
      DIMENSION DNEAR(kel),DMEAN(kel),XW(k1),YW(k1),NVEL(kel),NGLVC(k2)
      LOGICAL flag,vcseg(kel,kel),vcseg1(kel,kel),flag1,flag2
     
      iflag=0
      eps=dmax*dmaxtol
      PI  = 4.*ATAN(1.)
      np=ntot
      ne=nee

c Prepare data for inclusion nodes connectivity:
      do i = 1,ne
         call epts8 (i,cex(i),cey(i),a(i),b(i),th(i),ex,ey)
      enddo

c Calculate final tot.no.of VC nodes and their connectivity
c initialze total no.of VC nodes
      NODTL = 0
c initialize total no.of VC nodes for each ellipse
      do i = 1,ne               ! for each el.
         nvel(i) = 0
      ENDDO
c process first contour node (first el.):
c first initialize first VC node as starting one for global conn. list:
      call setvcnd1 (nconvt,xc,yc,1,1,nv(1))
      do 42  k = 1,nv(1) 
c check if curr.node is within corresp. el. ...
         call inellip (xc(1,k),yc(1,k),cex(1),cey(1),a(1),b(1),th(1),flag)
         if (flag .eqv. .true.) then
            goto 42             ! skip curr. VC node
         endif
c if not, create new 'global' node ...
         nodtl = nodtl+1        ! global node counter
         nvel(1) = nvel(1)+1    ! tot.no.of VC nodes for el.1

         if (nvel(1).gt.k5)  then
            print *,'array violation for ncont'
            print *,'increase k5'
            print *,'stopped in vcm2'
            stop
         endif

         NCONT(1,nvel(1)) = nodtl ! local-global nodal connect.

         if (nodtl.gt.k2*3)  then
            print *,'array violation for xnode,ynode'
            print *,'increase k2'
            print *,'stopped in vcm2'
            stop
         endif

         XNODE(nodtl)      = xc(1,k) ! copy to final 'global' node    
         YNODE(nodtl)      = yc(1,k) ! coords. list
c and memorize last 'out-ellipse' VC node number. Such node belongs to VC ellipse contour...
         lstnod = nconvt(1,k)
 42   CONTINUE                  ! goto new node

c process all other contour nodes :
      eps = 1.D-10            !(-10 this value might create intercell voids)

      EPS = DMAX*DMAXTOL*1.0D06
      PRINT *,'COORDINATE CUTOFF = ',EPS
      PRINT *
      PRINT *,'COMMENT - DECREASE EPS IF YOU SEE LINES CUTTING ACROSS PARTICLES'

      n   = nodtl               ! init.curr.no.of processed global nodes                          
      DO 5  I = 2,NP            ! for each contour node  

         if (i.gt.k1) then
            print *,'dimension of nv not enough'
            print *,'increase size of k1'
            print *,'stopped in vcm2'
            stop
         endif

c first determine which ellipse curr.contr.node belongs to...
         call detelps (i,nnodes,iel,ncnrel)
c cnt.nd 'i' belongs to el. 'iel' (rel.no is 'ncnrel')
         if (ncnrel .eq. 1) then ! first cont.node on curr.el.
c make sure that 'in-ellipse' VC nodes are at the end of CONT list of cont.node 'i':
            call setvcnd1 (nconvt,xc,yc,i,iel,nv(i))
            goto 503            ! start creating ncont(iel,*)
         endif
c 'ncnrel' > 1 so we're already in 'iel': permute CONT list of cnt.nd. 'i'so that it begins with VC node 
c 'lstnod' from previous contour elipse node
         do 501  j = 1,nv(i)
            if (nconvt(i,j) .eq. lstnod) then
               istart = j
               call permuts (nconvt,xc,yc,i,nv(i),istart)
               goto 503         ! cont.with creating ncont(iel,*)
            endif
 501     continue
c 'lstnod' is not found, since there is an in-ellipse VC node which is supposed to be 'lstnod':
         do 502  jp = 1,nv(i-1)
            if (nconvt(i-1,jp) .eq. lstnod) then
c such missing 'last' VC nd.of prev.cnt.nd cell is...
               lstndpr = nconvt(i-1,jp+1) 
c now permute CONT list of cnt.nd. 'i' so that it begins with VC node 'lstndpr' from previous contour elipse node
               do 5021  jj = 1,nv(i)
                  if (nconvt(i,jj) .eq. lstndpr) then
                     istart = jj
                     call permuts (nconvt,xc,yc,i,nv(i),istart)
                     goto 503   ! cont.with creating ncont(iel,*)
                  endif      
 5021          continue
            endif
 502     continue
 503     DO 51  K = 1,NV(I)     ! for each VC node of cnt.node'i'
c check if curr.node is within corresp. el. ...
            call inellip (xc(i,k),yc(i,k),cex(iel),cey(iel),a(iel),b(iel),
     *                    th(iel),flag)
            if (flag .eqv. .true.) then
               goto 51          ! skip internal VC node
            endif
c if not, create/asdsign new/old 'global' nodes ...
c first check is the node-candidate already in created global list:                    
            DO 511  L = 1,NODTL ! for each so far processed node       
               IF ((DABS(xc(i,K)-XNODE(L)) .LE. eps) .AND.(DABS(yc(i,K)-
     *              YNODE(L)) .LE. eps)) THEN
c since it belongs to global con.list, now check whether that node already belongs to con.list of el.'iel':
                  do 5111  j = 1,nvel(iel)
                     if (L .eq. ncont(iel,j)) then
                        goto 51 ! skip that VC node
                     endif 
 5111             continue   
                  nvel(iel) = nvel(iel)+1 ! located VC node for el.'iel'
                  NCONT(iel,nvel(iel)) = L ! which is already located
c update last out-ellipse VC node  
                  lstnod = nconvt(i,k)                    
                  GOTO 51
               ENDIF
 511        CONTINUE
c create one more global node on accnt. of curr. el. 'i'    
            N           = N+1   ! note: N -not to be cofused with NODTL 
            nvel(iel)   = nvel(iel)+1 ! one more VC node for el.'iel'
            NCONT(iel,nvel(iel)) = N ! local-global nodal connect.    
            XNODE(N)    = xc(i,K) ! copy to final 'global' node
            YNODE(N)    = yc(i,K) ! coords. list

c and memorize last 'out-ellipse' VC node number. Such node belongs to VC ellipse contour...
            lstnod = NCONVT(i,k)
 51      CONTINUE
         NODTL = N              ! update total no. of glob.nodes
 5    CONTINUE

c Find 3-ellipse common nodes (3 final VC cells merge there): first count no.of occurances for each gl.node
      do iglvc=1,nodtl
         nglvc(iglvc)=0
      enddo
      do 6 iel = 1,ne           ! loop over each ellipse
         do 6 irelvc = 1,nvel(iel) ! loop over each rel.VC node
            do 6 iglvc = 1,nodtl ! loop over global nodes
c If there is no match, check next global node
               if (iglvc .ne. ncont(iel,irelvc)) go to 6
c else determine no.of occurances of such gl.node           
               nglvc(iglvc) = nglvc(iglvc)+1
 6    continue 

c then create list (counterclockwise) of final VC segment end-nodes for each ellipse  
      do 7  iel = 1,ne          ! loop over each ellipse
         krel = 0               ! initialize nodal counter
         do 71 irelvc = 1,nvel(iel) ! loop over each rel.VC node
            do 71 iglvc = 1,nodtl ! loop over global nodes   
               if (iglvc .eq. ncont(iel,irelvc)) then
                  if (nglvc(iglvc) .ge. 3) then
                     krel = krel+1 ! one more segment end-node
                     isegnod(iel,krel) = iglvc
                  endif
c boundary corner node case:
                  if (nglvc(iglvc) .eq. 1) then
c check if it is corner node...
                     call cornod (xnode(iglvc),ynode(iglvc),flag)
                     if (flag .eqv. .true.) then  
                        krel = krel+1 ! one more segment end-node
                        isegnod(iel,krel) = iglvc
                     else       ! it is on the bound. 
                        ncont(iel,irelvc) = 0 ! rm.such nd. from cont.list
                     endif
                  endif
c boundary '2-node' case:
                  if (nglvc(iglvc) .eq. 2) then
c first check if it is on the region border...
                     call bordr (xnode(iglvc),ynode(iglvc),flag)
                     if (flag .eqv. .true.) then ! it is border pt.
                        krel = krel+1 ! one more segment end-node
                        isegnod(iel,krel) = iglvc
                     else
                        goto 71
                     endif
                  endif
               endif              
 71     continue                   ! el. 'iel' is done...
        nseg(iel) = krel        ! tot.no.of seg.end-nds.for'iel'

c Now update arrays for curr.VC/ellipse contour:
        k = 0                   ! init.counter of proper nodes
        do 72  irelvc = 1,nvel(iel)
           if (ncont(iel,irelvc) .ne. 0) then 
c first copy to work arrray
              k = k+1           ! one more proper node 
              ntemp(k) = ncont(iel,irelvc)
           else
C             print*,'MAIN: removing node from el.',iel
           endif 
 72     continue
        nvel(iel) = k           ! final no.of VC nodes per el.
c then update curr.VC/ellipse contiguity list
        do 73  k = 1,nvel(iel)
           ncont(iel,k) = ntemp(k) 
 73     continue
 7    continue   

c Statistics on no.of VC polyg.sides 
      minvcsd = 1000
      maxvcsd = 0
      nsdtot  = 0
      do 74  iel = 1,ne
         nsdtot = nsdtot + nseg(iel)
         if (nseg(iel) .lt. minvcsd) then
            minvcsd = nseg(iel)
         endif
         if (nseg(iel) .gt. maxvcsd) then
            maxvcsd = nseg(iel) 
         endif
 74   continue

c 'Smooth out' polygonal VC sides with many 'zig-zag' distributed nodes with an approx.curves (using Fourrier transformation).
c Segment nodal end-pts. for each el. are stored in ISEGNOD array (counter-clockwise arrangement) 
c first obtain contiguity list for ellipses:
      ngbv(1) = 4
      call conlist (niop,ngbv,gbvx,gbvy,ne,cex,cey,ijcont,nghbr)

      do iel=1,ne
         do jel=1,ne
            vcseg(iel,jel)=.FALSE.
            vcseg1(iel,jel)=.FALSE.
         enddo
      enddo

      do 8  iel = 1,ne          ! for each el.
c 'close' ISEGNOD array
         isegnod(iel,nseg(iel)+1) = isegnod(iel,1)
         do 81 is = 1,nseg(iel) ! for all VC segments
c find node #s for curr.seg.end-pts.
            nsn1 = isegnod(iel,is)
            nsn2 = isegnod(iel,is+1)
c now find a corr.neigh.el. (jel) 
            call fndnghel (iel,nsn1,nsn2,jel,ne)
            if (jel .eq. 0) then
c 'jel'  is virtual el. or not in CONT list for 'iel'
               goto 811         ! create segment directly
            endif
c check if curr.segment is already created:
            if (vcseg(iel,jel) .eqv. .true.) then
               goto 81          ! it is, goto next seg. 
            else                ! create segment
               vcseg(iel,jel) = .true. ! 'created' status
               vcseg(jel,iel) = .true. ! symmetry
            endif
c copy from NCONT(iel,*) list curr.seg.nodes to work arr's:
 811        call cpwars (nsn1rel,iel,nvel(iel),nsn1,nsn2,xw,yw,lw)

c now create segment (there are 'lw' pts.on curve):
            if (lw .eq. 2) goto 81 ! seg.is line, goto next
c seg.is curved, so find a smooth curve (using 20 harm.): 
            call makeseg (xw,yw,lw,10)
c now update XNODE,YNODE arrays...loop until 'nsn1' is matched:
            do 812  nsn1relwl = 1,nvel(iel)
               if (ncont(iel,nsn1rel) .eq. nsn1) goto 813 
 812        continue

c 'nsn1' (first seg.end-node) is matched so start copying back from work arrays 
 813        lw = 1
            xnode(nsn1) = xw(lw)  
            ynode(nsn1) = yw(lw)
c copy next node...
 814        lw = lw+1
            j  = nsn1rel+lw-1
            if (j .gt. nvel(iel)) then
               j = j-nvel(iel)
               next = ncont(iel,j)
            else
               next = ncont(iel,j)
            endif
            xnode(next) = xw(lw)
            ynode(next) = yw(lw)
c check if 'nsn2' is reached :
            if (next .ne. nsn2) goto 814

c the segment is finally done now!   
 81      continue
 8    continue

      do 9  iel = 1,ne          ! for each el.
c 'close' ISEGNOD array
         isegnod(iel,nseg(iel)+1) = isegnod(iel,1)
c initialize new VC nodal cont.list counter
         nvel1(iel) = 0
         do 90  is = 1,nseg(iel) ! loop over all VC seg's
c find node #s for curr.seg.end-pts.
            nsn1 = isegnod(iel,is)
            nsn2 = isegnod(iel,is+1)
c find corr.neigh.el. ('jel')
            call fndnghel (iel,nsn1,nsn2,jel,ne)
            if (jel .eq. 0) then
c 'jel'  is virtual el. or not in CONT list for 'iel' NOTE: 'vcseg' status is unnecessary in this case:
               goto 905         ! create segment directly
            endif
c check if curr.segment is already created:
            if ((vcseg1(iel,jel).eqv..true.).or.(vcseg1(jel,iel).eqv..true.))
     *           then

c it is, so copy 'linearized' VC nodes from NCONT1(jel,*) list: first loop until 'nsn1' is matched 
               do 902 irjel = 1,nvel1(jel)
                  if (ncont1(jel,irjel) .eq. nsn1) goto 903
 902           continue

c now copy nodes from NCONT1(jel,*) backwards until 'nsn2' is reached:
 903           nvel1(iel) = nvel1(iel)+1

               if (nvel1(iel).gt.k5)  then
                  print *,'array violation for ncont1 for iel = ',iel
                  print *,'increase k5'
                  print *,'stopped in vcm2'
                  stop
               endif

               ncont1(iel,nvel1(iel)) = nsn1
 904           irjel = irjel-1
               if (irjel .le. 0) then
                  irjel = nvel1(jel)+irjel
               endif

c is node 'nsn2' reached ?
               if (ncont1(jel,irjel) .eq. nsn2) goto 90 ! next seg.
c since not, copy one more node
               nvel1(iel) = nvel1(iel)+1

               if (nvel1(iel).gt.k5)  then
                  print *,'array violation for ncont1 for iel = ',iel
                  print *,'increase k5'
                  print *,'stopped in vcm2'
                  stop
               endif

               ncont1(iel,nvel1(iel)) = ncont1(jel,irjel) 
               goto 904         ! go for next node
            endif    
c otherwise linearize this seg.:
            vcseg1(iel,jel) = .true. ! 'linearized' status
            vcseg1(jel,iel) = .true. ! symmetry
c copy from NCONT(iel,*) list curr.seg.nodes to work arr's:
 905        call cpwars (nsn1rel,iel,nvel(iel),nsn1,nsn2,xw,yw,lw)

c Now check if the segment is already line or neigh.el is virtual/doesn't exist in CONT list for 'iel'
c (there are 'lw' pts.on curve):
            if ((lw .eq. 2).or.(jel .eq. 0)) then
c seg.is line, so add starting VC node to NCONT1(iel,*) list NOTE: last seg.end-node is not added to NCONT(iel,*) list
c since it will be during next seg.linearization or it already exists (curr.seg is the last one)
               nvel1(iel) = nvel1(iel)+1

               if (nvel1(iel).gt.k5)  then
                  print *,'array violation for ncont1 for iel = ',iel
                  print *,'increase k5'
                  print *,'stopped in vcm2'
                  stop
               endif

               ncont1(iel,nvel1(iel)) = nsn1
               goto 90          ! next seg.
            endif

c otherwise linearize (curved) seg: add 1st VC node to NCONT(iel,*) list
            nvel1(iel) = nvel1(iel)+1

            if (nvel1(iel).gt.k5)  then
               print *,'array violation for ncont1 for iel = ',iel
               print *,'increase k5'
               print *,'stopped in vcm2'
               stop
            endif
            
            ncont1(iel,nvel1(iel)) = nsn1
            ln1 = 1             ! mark first node

c now try to conn.end (1 & lw) nodes if possible...check int.with el.'iel'
 94         call lnelint (xw(ln1),yw(ln1),xw(lw),yw(lw),cex(iel),cey(iel),
     *                    a(iel),b(iel),th(iel),flag1)
c ...check int.with el.'jel'
          call lnelint (xw(ln1),yw(ln1),xw(lw),yw(lw),cex(jel),cey(jel),
     *                  a(jel),b(jel),th(jel),flag2)
          if ((flag1.eqv..false.).and.(flag2.eqv..false.)) then
c first check if el.'s 'iel' & 'jel' are on the opposite side of
c line 1-lw:
             call chkside (xw(ln1),yw(ln1),xw(lw),yw(lw),cex(iel),cey(iel),
     *                     cex(jel),cey(jel),flag)
             if (flag .eqv. .false.) then
c linearization OK, ell's are on the opp.sides, goto next seg.
                goto 90
             else
c     curved seg.lineariz.must be done
                goto 941
             endif   
          endif
c else linearize segment:
 941      ln2 = ln1+1           ! init. last end-node
 95       call lnelint (xw(ln1),yw(ln1),xw(ln2),yw(ln2),cex(iel),cey(iel),
     *                  a(iel),b(iel),th(iel),flag1)
          call lnelint (xw(ln1),yw(ln1),xw(ln2),yw(ln2),cex(jel),cey(jel),
     *                  a(jel),b(jel),th(jel),flag2)  
          if ((flag1.eqv..true.).or.(flag2.eqv..true.)) then
c one of the ellipses is cut, so fix previous seg.end-node and start new seg.from it 
             ln1 = ln2-1        ! new starting node
c add such node to NCONT1(iel,*) list
             j = nsn1rel+ln1-1
             if (j .gt. nvel(iel)) then
                j = j-nvel(iel)
                nod = ncont(iel,j)
             else
                nod = ncont(iel,j)
             endif
             nvel1(iel) = nvel1(iel)+1

             if (nvel1(iel).gt.k5)  then
                print *,'array violation for ncont1 for iel = ',iel
                print *,'increase k5'
                print *,'stopped in vcm2'
                stop
             endif

             ncont1(iel,nvel1(iel)) = nod
             goto 94            ! try to finish lin.
          endif
c else asdsign next VC node to curr.line-seg.end-node
          ln2 = ln2+1
          goto 95
 90    continue
 9    continue

C Calculate VC polygon area, area ratio of particulate to its VC polygon, nearest neighbour and mean neighbour distances &
C point density.
      tarea = 0.                ! init.tot.area (region) 
      DO 100  ip = 1,ne         ! for each particulate(el.)    
         POLYAREA(ip) = 0.      ! init. VC polyg. area 
         x1 = cex(ip)
         y1 = cey(ip)
         DO 101 j = 1,nvel1(ip)-1 ! loop over VC nodes of el.'ip'
            x2 = xnode(ncont1(ip,j))
            y2 = ynode(ncont1(ip,j))
            x3 = xnode(ncont1(ip,j+1))
            y3 = ynode(ncont1(ip,j+1))
c Triangle area:
            darea = 0.5*(x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2))
            POLYAREA(ip) = POLYAREA(ip)+DAREA 
 101     CONTINUE 
         x2 = xnode(ncont1(ip,nvel1(ip)))
         y2 = ynode(ncont1(ip,nvel1(ip)))
         x3 = xnode(ncont1(ip,1))
         y3 = ynode(ncont1(ip,1))
         DAREA = 0.5*(x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2))
         POLYAREA(ip) = POLYAREA(ip)+DAREA       
c add to total region area...
         tarea = tarea+POLYAREA(ip)
 100  CONTINUE
c check region area...(rect.region only !)
      regarea = (bx(2)-bx(1))*(by(4)-by(1))
      rrae = (tarea-regarea)/regarea
      if (rrae*100. .gt. 1.) then ! report if err > 1%
         PRINT*
         WRITE(*,900) rrae*100.
 900     format(' MAIN: rel.region area error [%] ',f7.2)
      endif
C Calculate area ratio of particulate to its polygon
      DO 110  ip = 1,ne
         RATIO(ip) = (a(ip)*b(ip)*pi)/POLYAREA(ip)
 110  CONTINUE              
C calculate nearest neighbour, and mean near neighbour distances:
      DO 120  ip = 1,ne         ! loop over all particulates
         DNEAR(ip) = 1.E10      ! init.mean.nghb.dist.
         dmsum     = 0.         ! init.mean dist.sum
         DO 121  j = 1,nghbr(ip)
            DIS = DSQRT((cex(ip)-cex(IJCONT(ip,j)))**2+(cey(ip)-cey(
     *            IJCONT(ip,j)))**2)
            IF (DIS .LT. DNEAR(ip)) DNEAR(ip)=DIS
            dmsum = dmsum+DIS  
 121     CONTINUE
         DMEAN(ip) = dmsum/nghbr(ip) ! mean.nghb.dist.
 120  CONTINUE
      
      return
      END

c=========================================================================================
c  Purpose:  For a given VC contour point provides that its contiguity VC nodal list is 
c            permuted as long as its 'in-ellipse' nodes are at the end of CONT array.
c            Output is permuted 'xc','yc' and created contiguity list 'wcnt'. 
c  Routines: inellip, permut
c-----------------------------------------------------------------------------------------
      subroutine setvcnd1 (ncon,xc,yc,icnd,iel,n)

      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (K4=100,MAXCOORD=15000,NLM=1000,IDIMTWO=NLM)
      PARAMETER (k1=MAXCOORD)
      dimension ncon(k1,k4),xc(k1,k4),yc(k1,k4)
      logical flag
      COMMON /ELDATA/ CEX(maxcoord),CEY(maxcoord),A(NLM),B(NLM),TH(NLM),
     &     NNODES(IDIMTWO),PX(MAXCOORD),PY(MAXCOORD),GBVX(1,4),GBVY(1,4),
     &     NGBV(1),NTOT

c check first VC node if it is in-ellipse
 10   k = 1
 20   call inellip (xc(icnd,k),yc(icnd,k),cex(iel),cey(iel),a(iel),
     *                b(iel),th(iel),flag)
      if (flag .eqv. .true.) then ! VC node is internal
c permute arrays for one place to the left
         call prmtcon (ncon,icnd,n)
         call permut (xc,icnd,n)
         call permut (yc,icnd,n)
         goto 10
      endif
c since 1st VC node is out-ellipse, check last one
      k = n
      call inellip (xc(icnd,k),yc(icnd,k),cex(iel),cey(iel),a(iel),
     *                b(iel),th(iel),flag)
      if (flag .eqv. .true.) goto 30 ! VC nod.is inter., go out
c since VC node is exterior to the ellipse, permute arrays
      call prmtcon (ncon,icnd,n)
      call permut (xc,icnd,n)
      call permut (yc,icnd,n)
      goto 10

 30   return
      end

c=========================================================================================
c  Purpose:  Checks whether given point (x,y) is within the given ellipse. If so:  FLAG = 
c            .true. , else output is FLAG = .false.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine inellip (x,y,xc,yc,a,b,theta,flag)
 
      implicit real*8 (a-h,o-z)
      logical   flag

      pi   = 4.*atan(1.)
      conv = pi/180.            ! conversion to [rad]
      flag = .false.            ! assume pt.is outside ellipse

c Convert node coords. from global c.s. to local (el.) c.sys.
      sn = sin(theta*conv)
      cs = cos(theta*conv) 
      x1 = x-xc
      y1 = y-yc
c local pt.coords.
      xl = x1*cs+y1*sn
      yl = -x1*sn+y1*cs
      f = (xl/a)**2+(yl/b)**2
c Check if the point is within ellipse
      if (f .lt. 1.d0) flag = .true. ! pt.is within el. 

      return
      end

c=========================================================================================
c  Purpose:  Permutes given int. array 'a' one place to the left, ie first element becomes 
c            last one (forward shift). Output is permuted 'a'.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine prmtcon (ia,icnd,n)
    
      implicit real*8 (a-h,o-z)
      PARAMETER (MAXCOORD=15000)
      parameter (k1=MAXCOORD,k4=100)  
      dimension ia(k1,k4)

      ia(icnd,n+1) = ia(icnd,1) ! move 1st at the end of an array
      do j = 1,n
         ia(icnd,j) = ia(icnd,j+1) ! shift one place to the left
      enddo

      return
      end

c=========================================================================================
c  Purpose:  Permutes given array 'a' one place to the left, ie first element becomes last 
c            one (forward shift).  Output is permuted 'a'.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine permut (a,icnd,n)

      implicit real*8 (a-h,o-z)
      PARAMETER (MAXCOORD=15000)
      parameter (k1=MAXCOORD,k4=100)  
      dimension a(k1,k4)
      
      a(icnd,n+1) = a(icnd,1)   ! move 1st at the end of an array
      do j = 1,n
         a(icnd,j) = a(icnd,j+1) ! shift one place to the left
      enddo
      
      return
      end

c=========================================================================================
c  Purpose:  Determines ellipse no. which given contour node 'i' belongs to.  Output is:
c            IEL    - corr.el.no, NCNREL - rel.no.of cont.node within IEL.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine detelps (i,nnodes,iel,ncnrel)
      
      implicit real*8 (a-h,o-z)
      PARAMETER (NLM=1000,IDIMTWO=NLM)
      dimension nnodes(idimtwo)

      iel = 1                   ! init. search process
      ncompare = nnodes(iel)
 1    if (i .le. ncompare) then
c el. located...back to main
         ncnrel = i-(ncompare-nnodes(iel))
         goto 2   
      else
         iel = iel+1
         ncompare = ncompare+nnodes(iel)
         goto 1
      endif 

 2    return
      end

c=========================================================================================
c  Purpose:  Permutes given array 'a' to the left, until first element becomes 'nstart'. 
c            Output is permuted 'a' & 'ncon'.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine permuts (ncon,x,y,icnd,n,nstart)

      implicit real*8 (a-h,o-z)
      PARAMETER (MAXCOORD=15000)
      parameter (k1=MAXCOORD,k4=100)  
      dimension ncon(k1,k4),x(k1,k4),y(k1,k4)

      i = 1                     ! check first element
 20   if (nstart .ne. i) then   ! begin shifting
         ncon(icnd,n+1) = ncon(icnd,1) ! move 1st at the end of an array
         x(icnd,n+1) = x(icnd,1)
         y(icnd,n+1) = y(icnd,1)
         do j = 1,n
            ncon(icnd,j) = ncon(icnd,j+1) ! shift one place to the left
            x(icnd,j) = x(icnd,j+1)
            y(icnd,j) = y(icnd,j+1)
         enddo
         i = i+1
         goto 20
      endif

      return
      end

c=========================================================================================
c  Purpose:  Identifies whether given node (x,y) is domain border corner point.  If so: 
c            FLAG = .true. , else output is FLAG = .false.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine cornod (x,y,flag)
      
      implicit real*8 (a-h,o-z)
      common /border/ bx(4),by(4)
      COMMON /PTOL/ DMAX,DMAXTOL
      logical flag

      eps  = dmax*dmaxtol  
      flag = .false.     ! assume pt.is not on the border cont.
c Check if the point is on rectangular border
      do 1  i = 1,4
         if ((dabs(x-bx(i)).le.eps).and.(dabs(y-by(i)).le.eps)) then ! pt.is on the corner
            flag = .true.
            goto 10
         else                   ! pt.is not on the corner
            flag = .false. 
            goto 1
         endif
 1    continue  

 10   return
      end

c=========================================================================================
c  Purpose:  Checks whether given point is on domain border. If so: FLAG = .true. , else 
c            output is FLAG = .false.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine bordr (x,y,flag)
 
      implicit real*8 (a-h,o-z)
      common /border/ bx(4),by(4)
      COMMON /PTOL/ DMAX,DMAXTOL
      logical flag

      eps  = dmax*dmaxtol
      flag = .false.     ! assume pt.is not on the border cont.
       
c Check if the point is on rectangular border
      do i = 1,4
         if(i.lt.4) then
            x1=bx(i)
            y1=by(i)
            x2=bx(i+1)
            y2=by(i+1)
         else
            x1=bx(i)
            y1=by(i)
            x2=bx(1)
            y2=by(1)
         endif
         f=(y-y1)*(x2-x1)-(y2-y1)*(x-x1)
         if (dabs(f).lt.eps) then
            flag = .true.
            return
         endif     
      enddo

      return
      end

c=========================================================================================
c  Purpose:  For the given ellipse (iel) finds a no. of the neighboring one (jel) which
c            has the same global segment end-node numbers of the common segment. Output 
c            is neighboring ellipse number: jel
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine fndnghel (iel,nsn1,nsn2,jel,ne)
 
      implicit real*8 (a-h,o-z)
      PARAMETER (NLM=1000,k4=100,kel=NLM,k6=50,MAXCOORD=15000)
      PARAMETER (k2=MAXCOORD)
      COMMON /ELCNT/ IJCONT(k2,k4),NGHBR(k2),ISEGNOD(kel,k6),NSEG(kel)

c Search thru all neighboring ellipses...
      do 1  irelngh = 1,nghbr(iel)  
         jel = ijcont(iel,irelngh) ! curr.neigh.el.no.
c if 'jel' is virtual el. skip it...
         if (jel .gt. ne) then
            jel = 0             ! mark status
            goto 1              ! goto next neighbr.
         endif        
c find 'nsn1' in list for 'jel'
         do 2  is1 = 1,nseg(jel)
            if (isegnod(jel,is1) .ne. nsn1) goto 2 ! not found
c 'nsn1' is found, so find 'nsn2':
            do 3  is2 = 1,nseg(jel)
               if (isegnod(jel,is2) .ne. nsn2) goto 3 ! not found
c 'nsn2' is also found so search is over...('jel' is found) 
               goto 10
 3          continue
 2       continue
 1    continue
      jel = 0                   ! mark status

 10   return
      end

c=========================================================================================
c  Purpose:  Forms two 1D VC nodal coords. arrays corresp.to the given segment nodes. Also
c            determines their length (nr). Output is : nsn1rel - relative index of global 
c            'nsn1' node within 'ncont(iel,*)' list.  xw(*),yw(*) - nodal corrd. work
c            arr's.  lw - upper arr's length.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine cpwars (nsn1rel,iel,nvciel,nsn1,nsn2,xw,yw,lw)
      
      implicit real*8 (a-h,o-z)
      parameter (NLM=1000,kel=NLM,k5=300,MAXCOORD=15000)
      PARAMETER (K2=MAXCOORD,K1=MAXCOORD)
      COMMON /WCOPY/ ncont(kel,k5),XNODE(k2*3),YNODE(k2*3)
      dimension xw(k1),yw(k1)

c loop until 'nsn1' is matched
      do 1 nsn1rel = 1,nvciel
         if (ncont(iel,nsn1rel) .eq. nsn1) goto 2
 1    continue

c 'nsn1' (first seg.end-node) is matched so start copying to work arrays 
 2    lw = 1
      xw(lw) = xnode(nsn1)
      yw(lw) = ynode(nsn1)

c copy next node...
 3    lw = lw+1
      j = nsn1rel+lw-1
      if (j .gt. nvciel) then
         j = j-nvciel
         next = ncont(iel,j)
         goto 31
      else
         next = ncont(iel,j)
      endif
 31   xw(lw) = xnode(next) 
      yw(lw) = ynode(next)
c check if 'nsn2' is reached :
      if (next .ne. nsn2) goto 3 
c 'nsn2' is reached - back to main prg.
      return
      end

c=========================================================================================
c  Purpose:  Fits a smooth curve through an array of scattered points and 'push them back'
c            to a new position on the curve. Input: coord.arrays of scattered pts. x,y
c            ('n' of them). Output: new ('on curve') position of points (x,y).
c  Routines: newcs, smooth, oldcs
c-----------------------------------------------------------------------------------------
      subroutine makeseg (x,y,n,nhar)

      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MAXCOORD=15000)
      parameter (k1=MAXCOORD,k4=100)  
      DIMENSION x(k1),y(k1),xn(k1),yn(k1),f(k1)

      pi = 4.d0*atan(1.d0)
c Transform coords. into new c.s. 'angle (rad)' - from glob.abscisa to new local abscisa (cntclws)
      call newcs (x,y,n,angle,xn,yn,x0,y0)
c smooth out array of points
      call smooth (xn,yn,n+1,f,nhar)
c locate points (in new c.s.) on the curve 
      xlen = xn(n+1)-xn(1)
      x(1) = 0.
      y(1) = 0.
      do i = 2,n-1
         x(i) = 0.5*(xn(i)+xn(i+1)-2*xn(1))/xlen
         y(i) = 0.              ! cancel old ordinates
      enddo
      x(n) = 1.
      y(n) = 0.
      do i = 1,n
         do ih = 1,nhar
            y(i) = y(i)+2*f(ih)*sin(ih*pi*x(i))
         enddo
      enddo
c strech 'x' array back to 'xn' scale
      x(1) = xn(1)
      do i = 2,n-1
         x(i) = (x(i)+xn(1))*xlen 
      enddo
      x(n) = xn(n+1)
c transform node coords. back to old c.s:
      call oldcs (x,y,n,-angle,x0,y0)

      return
      end

c=========================================================================================
c  Purpose:  Transforms given array of points into a new coord.sys. such that first point
c            is a c.s. origin and the last one determines absica direction. Then modify
c            such arrays so that end points are kept but for other two neighboring points
c            their midpoint is adopted. Output are modified arrays of point coordinates
c            xn,yn (n+1 of them !), direction angle (rad) of new c.s. abscise and
c            translation vector (x0,y0).
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine newcs (x,y,n,angle,xn,yn,x0,y0)
 
      implicit real*8 (a-h,o-z)
      PARAMETER (MAXCOORD=15000)
      parameter (k1=MAXCOORD,k4=100)  
      DIMENSION x(k1),y(k1),xn(k1),yn(k1),xnew(k1),ynew(k1)
      
      pi   = 4.*atan(1.)
c Determine absise direction (w.r.t.) glbal c.s. abscise
      tol=1.0E-05
      if (abs(x(n)-x(1)).gt.tol) then
         angle = atan((y(n)-y(1))/(x(n)-x(1))) 
         sn = sin(angle)
         cs = cos(angle)
      else
         if (y(n)-y(1).gt.0.) then
            angle=pi/2.
            sn = sin(angle)
            cs = cos(angle)
         else
            angle=-pi/2.
            sn = sin(angle)
            cs = cos(angle)
         endif
      endif

c Convert point coords. from global c.s. to local (el.) c.sys.
      x0 = x(1)              ! memorize global new c.s. origin
      y0 = y(1)
      do i = 1,n      ! for each point
         xl = x(i)-x0
         yl = y(i)-y0
c New coordinates
         xnew(i) = xl*cs+yl*sn
         ynew(i) = -xl*sn+yl*cs
      enddo
c Modify arrays adopting midpoints  
      xn(1) = 0.
      yn(1) = 0.
      do i = 2,n
         xn(i) = 0.5*(xnew(i)+xnew(i-1))
         yn(i) = 0.5*(ynew(i)+ynew(i-1))
      enddo
      xn(n+1) = xnew(n) 
      yn(n+1) = 0.

      return
      end

c=========================================================================================
c  Purpose:  Construct an approx.curve for a given array of points. New curve (smooths out
c            array of scattered points) consists of prescribed number of harmonics 'nhar'.
c            Output is harmonic amplitudes (array 'f').
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine smooth (x,y,n,f,nhar)
 
      implicit real*8 (a-h,o-z)
      PARAMETER (MAXCOORD=15000)
      parameter (k1=MAXCOORD,k4=100)  
      dimension x(k1),y(k1),f(k1),phi(k1,k1),s(k1)

      pi   = 4.*atan(1.)

c normalize array of x-coords to fit them in [0,1] (s-array)(normalized array of abscisa is 's')
      xstart = x(1)
      xlen = x(n)-x(1)
      do i = 1,n
         s(i) = (x(i)-xstart)/xlen
      enddo

c determine shape fn. integrals in each point:
      do ih = 1,nhar         ! for each harmonic
         const = 1./(ih*pi)
         f(ih) = 0.             ! initialize harmonic ampl.
c First endpoint (i=1)
         i       = 1
         sip1int = s(i+1)-s(i)
         snsi    = sin(ih*pi*s(i))
         snsip1  = sin(ih*pi*s(i+1))
         cssi    = cos(ih*pi*s(i))
         phi(ih,1) = const/sip1int*(sip1int*cssi-const*
     *              (snsip1-snsi))
         f(ih) = f(ih)+phi(ih,i)*y(i) ! Harmonic ampl.        
         do i = 2,n-1        ! loop over each interior pt.
            sim1int = s(i)-s(i-1)
            sip1int = s(i+1)-s(i)
            snsi    = sin(ih*pi*s(i))
            snsim1  = sin(ih*pi*s(i-1))
            snsip1  = sin(ih*pi*s(i+1))
            cssi    = cos(ih*pi*s(i))
            phi(ih,i) = const/sim1int*(const*(snsi-snsim1)-
     *                sim1int*cssi)+
     *                const/sip1int*(sip1int*cssi-const*
     *                (snsip1-snsi))
            f(ih) = f(ih)+phi(ih,i)*y(i) ! Harmonic ampl.
         enddo
c Second endpoint (i=n) 
         i = n 
         sim1int = s(i)-s(i-1)
         snsi    = sin(ih*pi*s(i))
         snsim1  = sin(ih*pi*s(i-1))
         cssi    = cos(ih*pi*s(i))
         phi(ih,i) = const/sim1int*(const*(snsi-snsim1)-
     *              sim1int*cssi)
         f(ih) = f(ih)+phi(ih,i)*y(i) ! Harmonic ampl.
      enddo

      return
      end

c=========================================================================================
c  Purpose:  Transforms given array of points into the old (global) coord.sys. (angle of
c            rotation (new->global) is 'angle'.  Output are transformed arrays of point
c            coordinates x,y.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine oldcs (x,y,n,angle,x0,y0)
     
      implicit real*8 (a-h,o-z)
      PARAMETER (MAXCOORD=15000)
      parameter (k1=MAXCOORD,k4=100)  
      DIMENSION x(k1),y(k1)

c Determine absise direction (w.r.t.) glbal c.s. abscise
      sn = sin(angle)
      cs = cos(angle)
c Convert point coords. from new c.s. to global one:
      do i = 1,n      ! for each point
         xl = x(i)
         yl = y(i)                   
         x(i) = x0+xl*cs+yl*sn
         y(i) = y0-xl*sn+yl*cs
      enddo

      return
      end

c=========================================================================================
c  Purpose:  Checks if an intersection between given line segment (P1,P2) and an ellipse
c            (xc,yc,a,b,th) exists. Output is FLAG: =.true. if so, otherwise for no int. 
c            exist, FLAG = .false.
c  Routines: findint
c-----------------------------------------------------------------------------------------
      subroutine lnelint (x1,y1,x2,y2,xc,yc,a,b,th,flag)
 
      implicit real*8 (a-h,o-z)
      logical   flag
      COMMON /PTOL/ DMAX,DMAXTOL

      pi   = 4.*atan(1.)
      conv = pi/180.            ! conversion to [rad]
      eps  = dmax*dmaxtol 
      flag = .false.            ! assume no intersection

c First transform coords.of line seg.end-pts into the ellipse local coord.sys.:
      sn = sin(th*conv)
      cs = cos(th*conv) 
      xn1 = x1-xc
      xn2 = x2-xc
      yn1 = y1-yc
      yn2 = y2-yc
c local pt.coords.
      xl1 = xn1*cs+yn1*sn
      xl2 = xn2*cs+yn2*sn
      yl1 = -xn1*sn+yn1*cs
      yl2 = -xn2*sn+yn2*cs
c then determine direction coeff.for line seg.
      xr = xl2-xl1
      if (dabs(xr) .lt. eps) then
         sk = 1.d4*dsign(1.d0,xr)   ! vertical line  
      else
         sk = (yl2-yl1)/xr
      endif
c now check if intersection between el. & lin.seg exist.
      temp = xl1*sk-yl1 
      p = b*b+(sk*a)**2
      q = -2.d0*sk*a*a*temp
      r = a*a*(temp+b)*(temp-b)
      discr = q*q-4.d0*p*r
c check intersection:
c      if (discr .lt. 0.d0) then
      if (discr .le. 0.d0) then
         flag = .false.         ! no intersect.
         goto 20           
      endif
      v12x = xl2-xl1            ! vector P1->P2
      v12y = yl2-yl1
      rootd = dsqrt(discr)
c check tangency ... 
      if (dabs(discr-0.d0) .le. eps) then
         xlint = -0.5*q/p       ! common pt.
         ylint = yl1+sk*(xlint-xl1)
c now check if common pt. belongs to lin.seg.:
         v1ix = xlint-xl1       ! vector P1->Pint
         v1iy = ylint-yl1
         call findint (v12x,v12y,v1ix,v1iy,slambda)
         if ((slambda .ge. 0.d0) .and.(slambda .le. 1.d0)) then
            flag = .true.       ! int.exists
            goto 20        
         endif
      endif
c check an intersect. ...
      if (discr .gt. eps) then
         xlint = 0.5/p*(-q-rootd) ! 1st common pt.
         ylint = yl1+sk*(xlint-xl1)
c now check if common pt#1. belongs to lin.seg.:
         v1ix = xlint-xl1       ! vector P1->Pint
         v1iy = ylint-yl1
         call findint (v12x,v12y,v1ix,v1iy,slmbd1)
c now check if common pt#2. belongs to lin.seg.:
         xlint = 0.5/p*(-q+rootd) ! 2nd common pt.
         ylint = yl1+sk*(xlint-xl1)
         v1ix = xlint-xl1       ! vector P1->Pint
         v1iy = ylint-yl1
         call findint (v12x,v12y,v1ix,v1iy,slmbd2)
         if (((slmbd1.ge.0.d0).and.(slmbd1.le.1.d0)).or.((slmbd2.ge.0.d0).and.
     *         (slmbd2.le.1.d0))) flag = .true.
      endif        

 20   return
      end

c=========================================================================================
c  Purpose:  Find int.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine findint (v12x,v12y,v1ix,v1iy,slambda)

      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /PTOL/ DMAX,DMAXTOL

      eps = dmax*dmaxtol        ! tolerance

      if (v12x .lt. eps) then
         slambda = v1iy/v12y    ! vertical line
      else
         slambda = v1ix/v12x    ! regular incl.line
      endif

      return
      end

c=========================================================================================
c  Purpose:  Checks whether two ellipse centers are on the opposite side of line seg.
c            given with its end pts.  If so: FLAG = .true. , else output is FLAG = .false.
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine chkside (x1,y1,x2,y2,xc1,yc1,xc2,yc2,flag)

      implicit real*8 (a-h,o-z)
      logical   flag

      flag = .true.      ! suppose points are on the same side
c determine line seg.dir.coeff:
      xr = x2-x1
      if (dabs(xr) .lt. 1.d-4 ) then ! line is vertical
         f1 = xc1-x1
         f2 = xc2-x1
         if ((dsign(1.d0,f1)*dsign(1.d0,f2)) .eq. 1) then
            return              ! flag is .true.
         else
            flag = .false.
            return
         endif
      endif
c for oblique line:
      sk = (y2-y1)/xr
      f1 = yc1-(sk*(xc1-x1)+y1)
      f2 = yc2-(sk*(xc2-x1)+y1)
      if ((dsign(1.d0,f1)*dsign(1.d0,f2)) .eq. 1) then
         return                 ! flag is .true.
      else
         flag = .false.
         return
      endif

      end

c=========================================================================================
c  Purpose:  Writes file vchomo.inp and creates postscript file vchomo.ps
c  Routines: None
c-----------------------------------------------------------------------------------------
      subroutine draw(corold)

      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (NLM=1000,MAXCOORD=15000,IDIMTWO=NLM,KEL=NLM,K5=300)
      PARAMETER (K1=MAXCOORD,K2=MAXCOORD,MAXNODPERPAR=32)
      COMMON /ELDATA/ CEX(maxcoord),CEY(maxcoord),A(NLM),B(NLM),TH(NLM),
     &     NNODES(IDIMTWO),PX(MAXCOORD),PY(MAXCOORD),GBVX(1,4),GBVY(1,4),
     &     NGBV(1),NTOT
      COMMON /WCOPY/ NCONT(kel,k5),XNODE(k2*3),YNODE(k2*3)
      COMMON /WCOPY2/ NE,NODTL,NCONT1(KEL,K5),NVEL1(KEL)
      COMMON /INCLU/ NODPERPAR
      COMMON /SMINARC/ SMINNA
      
      DIMENSION IJK1(nlm,NODPERPAR),NINT(nlm,2),ijp(3,2),corold(4,2),ijk(2*nlm,idimtwo)
      DIMENSION RY(NLM),IJK2(nlm,2),xn(k1),yn(k1),CEX1(2*nlm),CEY1(2*nlm)
      DIMENSION NUMCON(2*nlm),YNODE1(maxcoord,2),XNODE1(maxcoord,2),MPE(2*nlm)
      DIMENSION EXX(MAXNODPERPAR),EYY(MAXNODPERPAR)      
      
      nelx=ne
      nx=nodtl
      
      DO I=1,NELX
         ry(i)=b(i)/a(i)
      ENDDO 
      
      new=0
      do 700 i=1,nx
         do j=1,nelx
            do k=1,nvel1(j)
               if(i.eq.ncont1(j,k)) then
                  new=new+1
                  xn(new)=xnode(i)
                  yn(new)=ynode(i)
                  goto 700
               endif
            enddo
         enddo
 700  continue
      nx=new        
      do i=1,nx
         do j=1,nelx
            do k=1,nvel1(j)
               if(xn(i).eq.xnode(ncont1(j,k)).and.yn(i).eq.ynode(ncont1(j,k))) then
                  ncont1(j,k)=i
               endif
            enddo
         enddo
      enddo
      do i=1,nx
         xnode(i)=xn(i)
         ynode(i)=yn(i)
      enddo
      tol=1.E-5
      i=1
 100  if(i.gt.nx) goto 3000
      j=1
      isame=0
      do while(isame.eq.0.and.j.lt.i)         
         if((xnode(i)-xnode(j))**2+(ynode(i)-ynode(j))**2.lt.tol) then            
            do k=i,nx-1
               xnode(k)=xnode(k+1)
               ynode(k)=ynode(k+1)
            enddo
            do l=1,nelx
               do m=1,nvel1(l)
                  if(ncont1(l,m).gt.i) then
                     ncont1(l,m)=ncont1(l,m)-1
                  elseif(ncont1(l,m).eq.i) then
                     ncont1(l,m)=0
                  endif
               enddo
            enddo
            do l=1,nelx
               do m=1,nvel1(l)
                  if(ncont1(l,m).eq.0) ncont1(l,m)=j
               enddo
            enddo
            isame=1
            nx=nx-1
         endif
         j=j+1
      enddo
      i=i+1
      goto 100
 3000 do i=1,nelx
         j=1
         do while(j.lt.nvel1(i))
            if(ncont1(i,j).eq.ncont1(i,j+1)) then
               do k=j+1,nvel1(i)
                  ncont1(i,k-1)=ncont1(i,k)
               enddo
               nvel1(i)=nvel1(i)-1
            else
               j=j+1
            endif
         enddo
      enddo
 600  FORMAT(5F15.9)
      
      OPEN(11,FILE ='vchomo.inp',STATUS='unknown')
      pi=4.*atan(1.)
      WRITE(11,*) 
      WRITE(11,*)   
      WRITE(11,*) NX+nelx*NODPERPAR,NELX
      NUMNODS=NX+NELX*NODPERPAR
      WRITE(11,*) 
      DIV=NODPERPAR/2.
      DO I=1,NELX
         do j=1,NODPERPAR
            XNODE(NX+j)=A(I)*dcos((j-1)*pi/DIV)
            YNODE(NX+j)=A(I)*RY(I)*dsin((j-1)*pi/DIV)
         enddo
         do j=1,NODPERPAR
            xxx=cos(th(i)*pi/180.)*xnode(nx+j)
     $           -sin(th(i)*pi/180.)*ynode(nx+j)
            yyy=sin(th(i)*pi/180.)*xnode(nx+j)
     $           +cos(th(i)*pi/180.)*ynode(nx+j)
            xnode(nx+j)=CEX(I)+xxx
            ynode(nx+j)=CEY(I)+yyy            
            IJK1(I,J)=NX+J
         enddo
         
c         CENX=CEX(I)
c         CENY=CEY(I)
c         AMAJ=A(I)
c         BMAJ=B(I)
c         ANGLE=TH(I)
c         CALL EPTS16(CENX,CENY,AMAJ,BMAJ,ANGLE,EXX,EYY)
c         DO J=1,NODPERPAR
c            XNODE(NX+J)=EXX(J)
c            YNODE(NX+J)=EYY(J)
c         ENDDO

         NX=NX+NODPERPAR
         nint(i,1)=NODPERPAR
      ENDDO

      X_MIN=10.
      Y_MIN=10.

      DO I=1,NX
         IF(XNODE(I).LT.X_MIN) X_MIN=XNODE(I)
         IF(YNODE(I).LT.Y_MIN) Y_MIN=YNODE(I)
      ENDDO

c$$$      DO I=1,NX
c$$$         XNODE(I)=XNODE(I)-X_MIN
c$$$         YNODE(I)=YNODE(I)-Y_MIN
c$$$      ENDDO

      DO I=1,NX
         WRITE(11,333) i,XNODE(I),YNODE(I)
      ENDDO
 333  FORMAT(I5,1X,2(F12.8,2X))

      x_max=0.0
      y_max=0.0

      do i=1,nx
         if(xnode(i).gt.x_max) then
            x_max=xnode(i)
         endif
         if(ynode(i).gt.y_max) then
            y_max=ynode(i)
         endif
      enddo
      write(*,*) 'x_max =',x_max,' y_max =',y_max

      WRITE(11,*)  
      mat1=1
      mat2=2
      DO I=1,NELX
         WRITE(11,603) I,mat1,NVEL1(I),(NCONT1(I,J),J=1,NVEL1(I))
         mpe(i)=mat1
         numcon(i)=nvel1(i)
         do j=1,nvel1(i)
            ijk(i,j)=ncont1(i,j)
         enddo
      ENDDO
      WRITE(11,*)  
      DO I=1,NELX
         WRITE(11,603) I,mat2,NINT(I,1),(IJK1(I,J),J=1,NINT(I,1))
         mpe(nelx+i)=mat2
         numcon(nelx+i)=nint(i,1)
         do j=1,nint(i,1)
            ijk(nelx+i,j)=ijk1(i,j)
         enddo
      ENDDO
      WRITE(11,*) 
      MAT3=0
      DO I=1,NELX 
         NINT(I,2)=0
         WRITE(11,603) I,MAT3 !,NINT(I,2),(IJK2(I,J),J=1,NINT(I,2))
      ENDDO
      WRITE(11,*) 
      ICONFOR=1.0
      IONE=1

C-----calculate the particle volume fraction
      AREI=0.0
      PI=DATAN(1.D0)*4.
      DO I=1,NELX
         AA=A(I)
         BB=A(I)*RY(I)
         AREI=AREI+PI*AA*BB
      ENDDO
      ARET=0.0
      DO I=1,NELX
         XCTMP=0.0
         YCTMP=0.0
         DO J=1,NVEL1(I) 
            XCTMP=XCTMP+XNODE(NCONT1(I,J))
            YCTMP=YCTMP+YNODE(NCONT1(I,J))
         ENDDO
         XCTMP=XCTMP/NVEL1(I)    
         YCTMP=YCTMP/NVEL1(I)    
         DO J=1,NVEL1(I) 
            X1=XNODE(NCONT1(I,J))
            Y1=YNODE(NCONT1(I,J))
            IF (J.EQ.NVEL1(I)) THEN
               X2=XNODE(NCONT1(I,1))
               Y2=YNODE(NCONT1(I,1))
            ELSE
               X2=XNODE(NCONT1(I,J+1))
               Y2=YNODE(NCONT1(I,J+1))
            ENDIF
            ARET=ARET+0.5*(XCTMP*(Y1-Y2)+X1*(Y2-YCTMP)+X2*(YCTMP-Y1))
         ENDDO
      ENDDO

      PRINT *,'AREA FRACTION = ',AREI/ARET
C-------end------



C      do i=1,nelx
C         cex(i)=cex(i)-x_min
C         cey(i)=cey(i)-y_min
C      enddo

      DO I=1,NELX
         WRITE(11,976) 1,a(I),a(I)*RY(I),TH(I),CEX(I),
     &        CEY(I),IONE
      ENDDO
 976  FORMAT(I4,1X,5(F12.8,1X),I3)
      WRITE(11,*)  
      ICONFOR=1.0
      IZERO=0
      ZERO=0.0
      DO I=1,NELX
         WRITE(11,987) IZERO,ZERO,ZERO,ZERO,ZERO,ZERO
      ENDDO
 987  FORMAT(I4,1X,5(F12.8,1X))
      WRITE(11,*) 'Material properties (including debonding) '
      WRITE(11,*) '2, 1, 2'
      WRITE(11,*) '0.5000E06  0.340000E+00  0.000000E+00, 0.0, 0.1, 0.1, 0.001 '
      WRITE(11,*) '0.5000E06  0.200000E+00  0.300000E+90,-1.0, 4.098D2, 2.131, 2.377 '
      WRITE(11,*) '0.550000E10 '
      WRITE(11,*) '0.140000E+00  0.333300E+00  0.000000E+00 '
      WRITE(11,*) '  2 '
      WRITE(11,*) ' 0.55000E10,  0.0 '
      WRITE(11,*) ' 0.21350E11,  1.00000E-00 '
      WRITE(11,*) '0.430000E10 '
      WRITE(11,*) '0.140000E+00  0.333300E+00  0.000000E+00 '
      WRITE(11,*) '   2 '
      WRITE(11,*) '0.430000E10  0.0 '
      WRITE(11,*) '0.500000E10  0.492000E+01 '
      WRITE(11,*) '0.7 1.0E05 1.5 1.5 '
      WRITE(11,*) ' 10 '
      DO I=1,NELX
         WRITE(11,*) '1,3,4' 
         WRITE(11,*) '0,3,4' 
         WRITE(11,*) '0,3,2' 
      ENDDO  
      WRITE(11,*) ' 1'
      DO I=1,NELX
         WRITE(11,*) ' 25'
      ENDDO
      write(11,*)'1st boundary'
      N1=4
      write(11,*) N1
      write(11,105) IJP(1,1)
      write(11,105) IJP(2,1)
      write(11,105) IJP(3,1)
      write(11,105) IJP(1,2)
 105  format(i5,',1,1,0.0,0.0')
      WRITE(11,*) '2ND BOUNDARY'
      WRITE(11,*) ' 0'
      WRITE(11,*) '4 TH BOUNDARY'
      WRITE(11,*) ' 0   1000000.00000000 '
      WRITE(11,*)
      WRITE(11,*) 'REPEATABILITY BOUNDARY'
      WRITE(11,*) '0'
      CLOSE(11)
 603  FORMAT (25I5)

      NCIRCLE=1
      NPIC=1
      LSHADE=0
      FAC=1
      NUMPART=0

      DO J = 1, NPIC
         DO I = 1, NUMNODS
            IF ((I.EQ.1).AND.(J.EQ.1)) THEN
               IF (NUMPART.NE.0) GOTO 31
               XMIN=XNODE(I)
               XMAX=XNODE(I)
               YMIN=YNODE(I)
               YMAX=YNODE(I)
            END IF
 31         IF (XNODE(I).LT.XMIN) THEN
               XMIN=XNODE(I)
            ELSEIF (XNODE(I).GT.XMAX) THEN
               XMAX=XNODE(I)
            ENDIF
            IF (YNODE(I).LT.YMIN) THEN
               YMIN=YNODE(I)
            ELSEIF (YNODE(I).GT.YMAX) THEN
               YMAX=YNODE(I)
            ENDIF
         ENDDO
      ENDDO

      DELX = XMAX - XMIN
      DELY = YMAX - YMIN
      IF (DELX.GT.DELY) THEN
         BIGDEL = DELX
      ELSE
         BIGDEL = DELY
      ENDIF
      SCALEX = 1/(BIGDEL/(FAC*432.))
      SCALEY = 1/(BIGDEL/(FAC*432.))
      DO J = 1, NPIC
         DO IR = 1, NUMNODS
            IF (XNODE(IR).LT.0) THEN
               XNODE1(IR,j) = ABS(XMIN*SCALEX) - ABS(XNODE(IR)*SCALEX)
            ENDIF
            IF (YNODE(IR).LT.0) THEN
               YNODE1(IR,J) = ABS(YMIN*SCALEY) - ABS(YNODE(IR)*SCALEY)
            ENDIF
            IF ((XMIN.GE.0).AND.(XNODE(IR).GE.0)) THEN
               XNODE1(IR,J) = -ABS(XMIN*SCALEX) + ABS(XNODE(IR)*SCALEX)
            ENDIF
            IF ((XMIN.LT.0).AND.(XNODE(IR).GE.0)) THEN
               XNODE1(IR,J) = ABS(XMIN*SCALEX) + ABS(XNODE(IR)*SCALEX)
            ENDIF
            IF ((YMIN.GE.0).AND.(YNODE(IR).GE.0)) THEN
               YNODE1(IR,J) = -ABS(YMIN*SCALEY) + ABS(YNODE(IR)*SCALEY)
            ENDIF 
            IF ((YMIN.LT.0).AND.(YNODE(IR).GE.0)) THEN
               YNODE1(IR,J) = ABS(YMIN*SCALEY) + ABS(YNODE(IR)*SCALEY)
            ENDIF
         ENDDO
         DO IR=1,NELX
            IF (A(IR).LT.0) THEN
               A(IR)=-ABS(A(IR)*SCALEX)
            ENDIF
            IF ((XMIN.GE.0).AND.(A(IR).GE.0)) THEN
               A(IR)=ABS(A(IR)*SCALEX)
            ENDIF
            IF ((XMIN.LT.0).AND.(A(IR).GE.0)) THEN
               A(IR)=ABS(A(IR)*SCALEX)
            ENDIF
            IF (B(IR).LT.0) THEN
               B(IR)=-ABS(B(IR)*SCALEY)
            ENDIF
            IF ((YMIN.GE.0).AND.(B(IR).GE.0)) THEN
               B(IR)=ABS(B(IR)*SCALEY)
            ENDIF
            IF ((YMIN.LT.0).AND.(A(IR).GE.0)) THEN
               B(IR)=ABS(B(IR)*SCALEY)
            ENDIF
         ENDDO
      ENDDO
      DO I=1,4
         IF (COROLD(I,1).LT.0) THEN
            COROLD(I,1)=ABS(XMIN*SCALEX)-ABS(COROLD(I,1)*SCALEX)
         ENDIF
         IF (XMIN.GE.0.AND.COROLD(I,1).GE.0) THEN
            COROLD(I,1)=-ABS(XMIN*SCALEX)+ABS(COROLD(I,1)*SCALEX)
         ENDIF
         IF ((XMIN.LT.0).AND.(COROLD(I,1).GE.0)) THEN
            COROLD(I,1) = ABS(XMIN*SCALEX) + ABS(COROLD(I,1)*SCALEX)
         ENDIF
         IF (COROLD(I,2).LT.0) THEN
            COROLD(I,2)=ABS(YMIN*SCALEY)-ABS(COROLD(I,2)*SCALEY)
         ENDIF
         IF (YMIN.GE.0.AND.COROLD(I,2).GE.0) THEN
            COROLD(I,2)=-ABS(YMIN*SCALEY)+ABS(COROLD(I,2)*SCALEY)
         ENDIF
         IF ((YMIN.LT.0).AND.(COROLD(I,2).GE.0)) THEN
            COROLD(I,2) = ABS(YMIN*SCALEY) + ABS(COROLD(I,2)*SCALEY)
         ENDIF
      ENDDO 
      DO IR=1,2*NELX  
         IJK(IR,NUMCON(IR) + 1) = IJK(IR,1)
      ENDDO

C Write postscript file vchomo.ps
      OPEN(8,FILE='vchomo.ps')
      WRITE(8,141) 
 141  FORMAT('%!')
      write(8,140) '/ellipsedict 8 dict def'
      write(8,140) 'ellipsedict /mtrx matrix put'
      write(8,140) 
      write(8,140) '/ellipse'
      write(8,140) '{ellipsedict begin '
      write(8,140) '	/endangle exch def'
      write(8,140) '	/startangle exch def'
      write(8,140) '	/xrad exch def'
      write(8,140) '	/yrad exch def'
      write(8,140) '	/x exch def'
      write(8,140) '	/y exch def'
      write(8,140) '/savematrix mtrx currentmatrix def'
      write(8,140) 'x y translate'
      write(8,140) 'xrad yrad scale' 
      write(8,140) '0 0 1 startangle endangle arc'
      write(8,140) 'savematrix setmatrix'
      write(8,140) 'end'
      write(8,140) '}def'
 140  FORMAT(A50)	
      write(8,210) ' 45 45 translate'
 210  format(a16)
 170  format(a10)
 180  format(a11)
 190  format(a13)       
 200  format(a15)
 240  format(' 0 setgray stroke')
 250  format(a14)
      graym=0.5
      write(8,*) '2.0 setlinewidth'
      write(8,170) ' newpath'
      write(8,310) COROLD(1,1),COROLD(1,2), ' moveto'
      DO I=2,4
         write(8,310) COROLD(I,1),COROLD(I,2),' lineto'
      ENDDO
      write(8,310) COROLD(1,1),COROLD(1,2), ' lineto'
      write(8,240)
      write(8,*) '1.0 setlinewidth'
      if (lshade.eq.0) then
         do 410 j = 1, npic
            if(j.eq.2) then
               write(8,200) '[4 4] 0 setdash'
            endif
            do 410 ir=1,2*nelx
               if(mpe(ir).eq.2.and.ncircle.eq.1) goto 1
               write(8,170) ' newpath'
               write(8,310) xnode1(ijk(ir,1),j),
     $              ynode1(ijk(ir,1),j), ' moveto'
               do iv = 2, numcon(ir) + 1
                  write(8,310) xnode1(ijk(ir,iv),j),
     $                 ynode1(ijk(ir,iv),j), ' lineto'
               enddo
               write(8,240)
               goto 410
 310           format(2F24.15,a7)
 320           format(6F24.15,a8)
 1             IBEG=1
               IEND=(NODPERPAR/2)+1
               centerx=(xnode1(ijk(ir,IBEG),j)+xnode1(ijk(ir,IEND),j))/2.0
               cex1(ir-nelx)=centerx
               centery=(ynode1(ijk(ir,IBEG),j)+ynode1(ijk(ir,IEND),j))/2.0
               cey1(ir-nelx)=centery
               dis15=sqrt((xnode1(ijk(ir,1),j)-xnode1(ijk(ir,5),j))**2+
     $              (ynode1(ijk(ir,1),j)-ynode1(ijk(ir,5),j))**2)/2.0
               dis37=sqrt((xnode1(ijk(ir,3),j)-xnode1(ijk(ir,7),j))**2+
     $              (ynode1(ijk(ir,3),j)-ynode1(ijk(ir,7),j))**2)/2.0
               dis28=sqrt((xnode1(ijk(ir,2),j)-xnode1(ijk(ir,8),j))**2+
     $              (ynode1(ijk(ir,2),j)-ynode1(ijk(ir,8),j))**2)/2.0
               dis24=sqrt((xnode1(ijk(ir,2),j)-xnode1(ijk(ir,4),j))**2+
     $              (ynode1(ijk(ir,2),j)-ynode1(ijk(ir,4),j))**2)/2.0
               octagon_area=2.*(dis28*dis15+dis24*dis37)
               ellipse_area=3.141592*dis37*dis15
               ratio=octagon_area/ellipse_area
               xrad=ratio*dis15
               yrad=ratio*dis37
               xrad=b(ir-nelx)
               Yrad=a(ir-nelx)
               cx=0.0
               cy=0.0
               startang=0.0
               endang=360.0
               x1=xnode1(ijk(ir,3),j)-centerx
               y1=ynode1(ijk(ir,3),j)-centery
               angle=atan(y1/x1)*180./3.141592
               angle=th(ir-nelx)
               write(8,170) ' newpath'
               write(8,172) centerx,centery,' translate'
               write(8,171) angle,' rotate'
 171           format(F24.15,a7)
 172           format(2(1x,F24.15),a10)
               write(8,320) cx,cy,xrad,yrad,
     &              startang,endang,' ellipse'
               write(8,5080) graym, ' setgray fill'
               write(8,170) ' newpath'
               write(8,320) cx,cy,xrad,yrad,
     &              startang,endang,' ellipse'
               gstroke=0.0
               write(8,5080) gstroke, ' setgray stroke'
               write(8,171) -angle,' rotate'
               write(8,172) -centerx,-centery,' translate'
 5080          format(f2.1,a15)
 410     continue
      endif
      write(8,180) '  0 setgray'
      write(8,510) '/Times-Bold findfont 8 scalefont setfont'
 510  format(a41)       
      write(8,520) ' -45 30 moveto'
 520  format(a14)
      write(8,530) '(y) show'
 530  format(a13)
      write(8,520) ' 29 -47 moveto'
      write(8,530) '(x) show'
      write(8,510) '/Times findfont 8 scalefont setfont'
 550  format(a1,i4,a6)
      do j = 1, npic
         do i = 1, numnods
            write(8,310) xnode1(i,j)+4, ynode1(i,j), ' moveto'
            write(8,550) '(', i, ') show'
         enddo
      enddo       
      WRITE(8,710)' /Times-bold findfont 12 scalefont setfont'
 710  FORMAT(A42)
      WRITE(8,*) '0 setgray'
      DO IR=1,NELX
         WRITE(8,310) CEX1(IR), CEY1(IR), ' moveto' 
         WRITE(8,550) '(', IR, ') show'
      ENDDO
      write(8,1000)
 1000 format(' showpage')
      close(8)
      
      RETURN
      END

c=========================================================================================
c  Purpose:  Determnine if a point (X,Y) lies in the half-plane separated by the line {(XP,
c            YP),(X2,Y2)} - counter-clockwise w.r.t. the particul. pt. (XP,YP). If so, then 
c            NEEDCK = .TRUE. If REV = .TRUE. then reverse the role of the particulate pt. 
c            P and pt. 2 by changing the value NEEDCK.
c  Routines: None
c-----------------------------------------------------------------------------------------
      LOGICAL FUNCTION NEEDCK (X,Y,XP,YP,X2,Y2,REV)
      
      IMPLICIT REAL*8(A-H,O-Z)
      LOGICAL REV

      NEEDCK = .TRUE.
      IF (X2 .EQ. XP) THEN
         IF (YP .GT. Y2) THEN
            IF (X .LE. XP)   NEEDCK = .FALSE.
         ELSE
            IF (X .GE. XP)   NEEDCK = .FALSE.
         ENDIF
      ELSE
         B=(Y2-YP)/(X2-XP)
         REFY=B*(X-XP)+YP
         IF (XP .LT. X2) THEN
            IF (Y .LE. REFY)   NEEDCK = .FALSE.
         ELSE
            IF (Y .GE. REFY)   NEEDCK = .FALSE.
         ENDIF
      ENDIF
      IF (REV) THEN
         IF (NEEDCK) THEN
            NEEDCK = .FALSE.
         ELSE
            NEEDCK = .TRUE.
         ENDIF
      ENDIF

      RETURN
      END

c=========================================================================================
c  Purpose:  Calculate U dot V
c  Routines: None
c-----------------------------------------------------------------------------------------
      FUNCTION UDOTV (UX,UY,VX,VY)      
      IMPLICIT REAL *8(A-H,O-Z)

      UDOTV = UX*VX + UY*VY
      
      RETURN
      END

c=========================================================================================
c  Purpose:  Calculate distq
c  Routines: None
c-----------------------------------------------------------------------------------------
       FUNCTION DISTSQ (X1,Y1,X2,Y2) 

       IMPLICIT REAL*8(A-H,O-Z)

       DISTSQ = (X2-X1)**2+(Y2-Y1)**2

       RETURN
       END

c=========================================================================================
c  Purpose:  Determines coords. of 8 pts. distributed on input ellipse 'i' contour so
c            that the ellipse is approximated with 8 node polygon with 8 eaqual area
c            triangles. Output is nodal coords.: 'ex(i,*),ey(i,*)' and equivalent arc: 
c            eqarc. NOTE: pts. are distributed in counter-clockwise dir.
c  Routines: None
c-----------------------------------------------------------------------------------------

      subroutine epts16 (xc,yc,a,b,theta,ex,ey)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NLM=1000,IDIMTWO=NLM,MAXNODPERPAR=32)
      COMMON /INCLU/ NODPERPAR
      DIMENSION EX(MAXNODPERPAR*4),EY(MAXNODPERPAR*4),R(MAXNODPERPAR),THLOC(MAXNODPERPAR)

      eps   = 1.d-05
      pi    = 4.*atan(1.)
      conv  = pi/180.           ! conversion to [rad]
      exc   = b/a
      a8    = a*b*pi/(NODPERPAR*1.)         ! 1/8 (triangle area) ellipse area
      aaprx = 0.                ! initiate aprox.of 'a8'
      th    = 0.                ! initiate polar angle
      dth   = 1*conv            ! initiate angle incr. (~1 deg)

c Nodal polar coords.in local (el.) c.s.
      r(1)     = a
      thloc(1) = 0.
c Determine position of pt#2:
c Polar radius

      do i=1,nodperpar
         apprx=0.0
 1       rad = b/sqrt(sin(th)**2+(exc*cos(th))**2)
c     Approx.area increm.
         darea1 = 0.5*dth*rad*rad
         aaprx = aaprx+darea1
c         if ((aaprx-a8) .gt. eps) goto 2
         if (dabs(aaprx-a8) .le. eps) goto 2
         th = th+dth            ! new polar angle 
         goto 1
         
 2       thloc(i)=th
         r(i)= b/sqrt(sin(thloc(i))**2+(exc*cos(thloc(i)))**2)
      enddo

c Node coords. in local (el.) c.s.
C convert node coords. from local el.c.sys.to global one

      sn = sin(theta*conv)
      cs = cos(theta*conv)

      do j = 1,NODPERPAR                ! for each node on el.cont.
c Node coords. in local (el.) c.s.
         x = r(j)*cos(thloc(j))
         y = r(j)*sin(thloc(j))
c correction...
         y = dsign(1.d0,y)*b*sqrt(1.-(x/a)**2)
c Node coords. in global c.s.
         ex(j) = xc+x*cs-y*sn
         ey(j) = yc+x*sn+y*cs      
      enddo

      return
      end
