#!/usr/bin/python

# IMPORT PYTHON MODULES

## from tkMessageBox import *
import Tkinter
from Tkinter   import *
from myBoolean import *
from myDialog  import *

import os
import string
from dataprep import *

# IMPORT USER DEFINED MODULES

from dialogs   import *
from files     import *
from find      import *
from configure import *
from plot      import *


# SET THE GLOBAL VARIABLES

fileName = ''
fileDirty = FALSE
appPath = os.getcwd()
currentFind = None
instructions = "Data files for inclusion and matrix data hava a common root name. Suffixes for the files are \".incl\" and \".mat\", respectively. [Suffixes are not included in the rootname entry.]\n\nAnimation is initiated when the first frame number is strictly less than the last frame number. \n\nThe line widget is enbled by :\n(1) Press the 'PPlot' button.\n(2) Recalculate.\n(3) Press the 'i' key. [Disable by pressing the 'i' key again.]\n(4) Selecting the end-point handles draws the graph.\n\nThe base number is added to the frame number when saving images. Suffixes for image files are added to the rootname, automatically."


# THE EDITOR CLASS

class cmrl:
  
# CREATE THE EDITOR WINDOW

  def __init__(self, master):
    self.varKey = 'var1'
    self.startFrame = 1
    self.endFrame = -1
    self.incrementFrame = 1
    self.baseFrame = 0
    self.imageType = 'JPEG'
    self.saveIt = NO
    self.didPlot = NO
    self.didSetCamera = NO

    self.matfilename=appPath+'/matrix.dat'
    self.inclfilename=appPath+'/inclusion.dat'

    self.checkcolor=IntVar()
    self.checkcolor.set(1)
    self.color=self.checkcolor

    self.valueMinText=StringVar()
    self.valueMinText.set('0.00')
    self.valueMaxText=StringVar()
    self.valueMaxText.set('0.60')

    self.vlabel=StringVar()
    self.vlabel.set(self.varKey)

    self.Vmax=float(self.valueMaxText.get())
    self.Vmin=float(self.valueMinText.get())
    
    self.crd1Actor = vtk.vtkTextActor3D()
    self.crd2Actor = vtk.vtkTextActor3D()


    self.master = master
    self.master.title('Metal Stress')
    self.master.geometry('644x542+20+10')
    self.master.bind_class(self.master, '<Control-Key-m>', self.getmatrix)
    self.master.bind_class(self.master, '<Control-Key-i>', self.getincl)
    self.master.bind_class(self.master, '<Control-Key-a>', self.saveAs)
    self.master.bind_class(self.master, '<Control-Key-q>', self.exitMethod)
    self.master.bind_class(self.master, '<Control-Key-r>', self.recalcMethod)
    self.myBar = Frame(self.master, config['frame'])
    self.fileMenu()
    self.windowsMenu()
    self.settingsMenu()
    self.helpMenu()
    self.myBar.pack(side = TOP, fill = X)
    self.myTools = Frame(self.master, config['frame'],
                         borderwidth=1,relief="groove")
    self.myTools.pack(side = TOP, fill = X)

    self.separator0 = Frame(self.myTools, 
                            config['frame'], 
                            width = 15, 
                            height = 30)
    self.separator1 = Frame(self.myTools, 
                            config['frame'], 
                            width = 15, 
                            height = 30)
    self.separator2 = Frame(self.myTools,
                            config['frame'],
                            width = 15,
                            height = 30)
    self.separator0.pack(side = LEFT)
    self.openMatImage = PhotoImage(file = \
                                   os.path.join(appPath, './Icons/openmat.gif'))
    self.openMatButton = Button(self.myTools, config['button'], 
                                image = self.openMatImage, 
                                command = self.getmatrix)
    self.openMatButton.pack(side = LEFT)
    self.separator0 = Frame(self.myTools, 
                            config['frame'], 
                            width = 15, 
                            height = 30)
    self.separator0.pack(side = LEFT)
    self.openInclImage = PhotoImage(file= os.path.join(appPath, './Icons/openincl.gif'))
    self.openInclButton = Button(self.myTools, config['button'], 
                                 image = self.openInclImage, 
                                 command = self.getincl)
    self.openInclButton.pack(side = LEFT)
    self.separator1.pack(side = LEFT)
    self.saveAsImage = PhotoImage(file= os.path.join(appPath, './Icons/saveas.gif'))
    self.saveAsButton = Button(self.myTools, config['button'], 
                               image = self.saveAsImage, 
                               command = self.saveAs)
    self.saveAsButton.pack(side = LEFT)
    self.separator2.pack(side = LEFT)
    self.plotImage = PhotoImage(file= os.path.join(appPath, './Icons/plot.gif'))
    self.plotButton = Button(self.myTools, config['button'],
                              image = self.plotImage,
                              command = self.plotMethod)
    self.plotButton.pack(side = LEFT)
    self.plotWin = NO

    self.separator2 = Frame(self.myTools,
                            config['frame'],
                            width = 15,
                            height = 30)
    self.separator2.pack(side = RIGHT)
    self.recalcImage = PhotoImage(file= os.path.join(appPath, './Icons/recalc.gif'))
    self.recalcButton = Button(self.myTools, config['button'], 
                               image = self.recalcImage, 
                               command = self.recalcMethod)
    self.recalcButton.pack(side = RIGHT)


    self.myStatus = Frame(self.master,config['frame'])
    self.myStatus.pack(side = BOTTOM, fill = X)

    
    self.separator2 = Frame(self.myStatus,
                            config['frame'],
                            width = 15,
                            height = 30)
    self.separator2.pack(side = LEFT)
    self.ColorButton = Checkbutton(self.myStatus, text='Color?',variable=self.checkcolor,
                               command = self.colorMethod)
    self.ColorButton.pack(side = LEFT)
    self.separator2 =  Frame(self.myStatus,
                            config['frame'],
                            width = 50,
                            height = 30)
    self.separator2.pack(side = LEFT)
    self.ValueMaxLabel = Label(self.myStatus, text='Max.:')
    self.ValueMaxLabel.pack(side = LEFT)
    self.ValueMaxEntry = Entry(self.myStatus,width=8,
                            textvariable=self.valueMaxText)
    self.ValueMaxEntry.pack(side = LEFT)
    self.separator2 =  Frame(self.myStatus,
                            config['frame'],
                            width = 10,
                            height = 30)
    self.separator2.pack(side = LEFT)
    self.ValueMinLabel = Label(self.myStatus, text='Min.:')
    self.ValueMinLabel.pack(side = LEFT)
    self.ValueMinEntry = Entry(self.myStatus,width=8,
                            textvariable=self.valueMinText)
    self.ValueMinEntry.pack(side = LEFT)
    self.separator2.pack(side = RIGHT)
    self.ValueMinLabel = Label(self.myStatus, textvariable=self.vlabel)
    self.ValueMinLabel.pack(side = RIGHT)

    
    self.matrixActor = vtk.vtkActor()
    self.scalarBar = vtk.vtkActor2D()
    self.lineActor = vtk.vtkActor()
    self.dictIncl = {}
    self.dictIncDlny= {}

    self.myRender = Frame(self.master, config["frame"], \
                          borderwidth = 2, relief="sunken")
    self.myRender.pack(side = "bottom", anchor = "s", expand = 1, fill = BOTH)
##    self.myRender.pack(side = TOP, fill = X)
    self.renWin = vtk.vtkRenderWindow()
    self.ren = vtk.vtkRenderer()
    self.renWin.AddRenderer(self.ren)
    self.rw = vtkTkRenderWindowInteractor(self.myRender, \
                                          width=640, height=480, \
                                          rw=self.renWin)
    self.rw.pack(expand="t", fill="both")
##    self.rw.pack(side = TOP, fill = X)
    
    self.ren.SetBackground(1.0, 1.0, 1.0)
    self.iren = self.renWin.GetInteractor()
    self.istyle = vtk.vtkInteractorStyleSwitch()

    self.appendF = vtk.vtkAppendPolyData()

# Line Widget stuff


    self.lineWidget = vtk.vtkLineWidget()
    self.lineWidget.SetInteractor(self.iren)
    self.lineWidget.AddObserver("StartInteractionEvent", self.begin_plot)
    self.lineWidget.AddObserver("InteractionEvent", self.generate_plot)
    self.lineWidget.AddObserver("EndInteractionEvent", self.generate_plot)

    self.lineRes = 1000
    self.matrxdlny = vtk.vtkDelaunay2D()
    self.seeds = vtk.vtkPolyData()
    self.pprobe = vtk.vtkProbeFilter()

    self.lineWidget.SetInput(self.matrxdlny.GetOutput())
    self.lineWidget.SetResolution(self.lineRes)

    self.camera = vtk.vtkCamera()
    self.camera.Zoom(1.5)
    self.ren.SetActiveCamera(self.camera)
    
    self.iren.SetInteractorStyle(self.istyle)
    self.istyle.SetCurrentStyleToTrackballCamera()
    self.iren.Initialize()
    self.renWin.Render()
    self.iren.Start()

    self.master.protocol('WM_DELETE_WINDOW', self.exitMethod)
    self.master.mainloop()

# MENU METHODS

# file menu selections, data input(), image save as(), quit()
  def fileMenu(self):
    self.fileButton = Menubutton(self.myBar,
                                 config['menubutton'], 
                                 text = 'file  ',
                                 underline = 0)
    self.fileButton.pack(side = LEFT)
    self.fileMenu = Menu(self.fileButton, config['menu'], tearoff = 1)
    self.fileMenu.add_command(label = 'matrix file open...', 
                              underline = 0, 
                              accelerator = 'ctrl+m', 
                              command = self.getmatrix)
    self.fileMenu.add_command(label = 'inclusion file open...', 
                              underline = 0, 
                              accelerator = 'ctrl+i', 
                              command = self.getincl)
    self.fileMenu.add_separator({})
    self.fileMenu.add_command(label = 'save images as...', 
                              underline = 5, 
                              accelerator = 'ctrl+a', 
                              command = self.saveAs)
    self.fileMenu.add_separator({})
    self.fileMenu.add_command(label = 'quit',
                              underline = 0, 
                              accelerator = 'ctrl+q', 
                              command = self.exitMethod)
    self.fileButton.configure(menu = self.fileMenu)
    return self.fileButton

# bring up the plot graph window
  def windowsMenu(self):
    self.windowsButton = Menubutton(self.myBar, 
                                    config['menubutton'], 
                                    text = 'windows  ', 
                                    underline = 0)
    self.windowsButton.pack(side = LEFT)
    self.windowsMenu = Menu(self.windowsButton,
                            config['menu'],
                            tearoff = 0)
    self.windowsMenu.add_command(label = 'plot graph', 
                                 underline = 0, 
                                 accelerator = 'ctrl+p',
                                 command = self.plotMethod)
    self.windowsButton.configure(menu = self.windowsMenu)
    return self.windowsButton

# bring up the plot graph window
  def settingsMenu(self):
    self.settingsButton = Menubutton(self.myBar, 
                                     config['menubutton'], 
                                     text = 'settings  ', 
                                     underline = 0)
    self.settingsButton.pack(side = LEFT)
    self.settingsMenu = Menu(self.settingsButton,
                             config['menu'],
                             tearoff = 1)
    self.settingsMenu.add_command(label = 'variable', 
                                  underline = 0, 
                                  accelerator = 'ctrl+v',
                                  command = self.varMethod)
    self.settingsMenu.add_separator({})
    self.settingsMenu.add_command(label = 'frame values', 
                                  underline = 0, 
                                  accelerator = 'ctrl+f',
                                  command = self.framesMethod)
    self.settingsMenu.add_separator({})
    self.settingsMenu.add_command(label = 'save image?', 
                                  underline = 0, 
                                  accelerator = 'ctrl+s',
                                  command = self.setsaveMethod)
    self.settingsMenu.add_separator({})
    self.settingsMenu.add_command(label = 'image type', 
                                  underline = 0, 
                                  accelerator = 'ctrl+t',
                                  command = self.imagetypeMethod)
    self.settingsButton.configure(menu = self.settingsMenu)
    return self.settingsButton

  def helpMenu(self):
    self.helpButton = Menubutton(self.myBar, 
                                 config['menubutton'], 
                                 text = 'help  ', 
                                 underline = 0)
    self.helpButton.pack(side = RIGHT)
    self.helpMenu = Menu(self.helpButton,
                         config['menu'],
                         tearoff = 0)
    self.helpMenu.add_command(label = 'about',
                              underline = 0,
                              command = self.aboutMethod)
    self.helpMenu.add_command(label = 'help',
                              underline = 0,
                              command = self.helpMethod)
    self.helpButton.configure(menu = self.helpMenu)
    return self.helpButton


# methods for setting arguments
  def setsaveMethod(self, event = None):
    self.saving = question(self.master)
    self.saveIt = self.saving.go(title = 'image saving',
                                 message = 'Do you want to save images?')

  def imagetypeMethod(self, event = None):
    self.imagecat = input(self.master)
    self.imageType = \
                   self.imagecat.go(title = 'image format',
                                    message = 'Type the desired image format, \'JPEG\', \'TIFF\', \'PS\'',
                                    value = self.imageType,
                                    geometry = '400x120+325+265')

    if self.imageType != 'JPEG' and self.imageType != 'jpeg' and \
       self.imageType != 'TIFF' and self.imageType != 'tiff' and \
       self.imageType != 'PS' and self.imageType != 'ps':
      self.imageType = 'JPEG'
    
    
  def framesMethod(self, event = None):
    self.framesel = input(self.master)
    framesList = str(self.startFrame) + '  ' + str(self.endFrame) + '  ' + \
                 str(self.incrementFrame) + '  ' + str(self.baseFrame)

    self.framesValues = \
                      self.framesel.go(title = 'frame selections',
                                       message = \
                                       'Type frames in list format:\nfirst  last  increment  base',
                                       geometry = '250x180+275+250',
                                       value = framesList)

    if self.framesValues != '' and self.framesValues != None:
      
      data = string.split(self.framesValues)

      if len(data) < 4:
        self.startFrame = 1
        self.endFrame = -1
        self.incrementFrame = 1
        self.baseFrame = 0
      else:
        self.startFrame = int(data[0])
        self.endFrame = int(data[1])
        self.incrementFrame = int(data[2])
        self.baseFrame = int(data[3])
        if self.startFrame < 1:
          self.startFrame = 1
          self.endFrame = -1
          self.incrementFrame = 1
          self.baseFrame = 0         
    else:
      self.startFrame = 1
      self.endFrame = -1
      self.incrementFrame = 1
      self.baseFrame = 0
  
  def varMethod(self, event = None):
    dictVals = {}
    self.varsel = input(self.master)
    self.varKey = self.varsel.go(title = 'variable input',
                                 message = 'Type variable name, i.e. var1',
                                 value = self.varKey)
    matFile = open(self.matfilename)
    matline = matFile.readline()
    matdata = string.split(matline)
    while (matdata[1][:3] == "var"):
        dictVals[matdata[1]] = [matdata[2], matdata[3]]

        matline = matFile.readline()
        matdata = string.split(matline)
    matFile.close()
    if self.varKey == None:
        self.varKey = 'var1'
    elif len(self.varKey) != 4:
        self.varKey = 'var1'

    self.valueMaxText.set(dictVals[self.varKey][1])
    self.valueMinText.set(dictVals[self.varKey][0])
    self.vlabel.set(self.varKey)

    
# help methods.
  def helpMethod(self, event = None):
    information(title = 'Hey! Little help!',
            message = instructions,
            geometry = '500x300+275+265')

  def aboutMethod(self, event = None):
    aboutCMRL(title = 'About CMRL ...',
              message = 'Under construction ....',
              geometry = '300x300+275+265')

# recalculate the matrix
  def recalcMethod(self, event = None):
    self.Vmax=float(self.ValueMaxEntry.get())
    self.Vmin=float(self.ValueMinEntry.get())
    if self.checkcolor.get()==1:
      self.color=1
    else:
      self.color=0
##    print maxval
##    print self.color
    if self.varKey > "var5":
      self.renTubes = 1
      self.renPolys = 0
    else:
      self.renTubes = 0
      self.renPolys = 1


##################################################################################
##  The function 'prepareData' takes the following arguments
##  prepareData(self.matfilename, self.inclfilename, initnum,
##              doMatrix, doInclusion, incRenTubes, incRenPolys,
##              matvarkey, incvarkey, Icolor, Vmax, Vmin)
##
##  The values of doMatrix, doInclusion and Icolor are hard coded as they
##  are always included in the calcualtion.
##################################################################################

    if self.startFrame < self.endFrame:
      
      for f in range(self.startFrame, self.endFrame, self.incrementFrame):
        print "Animation of frame " + str(f)
        
        ## Remove all actors in renderer
        if self.ren.VisibleActorCount() > 0:
          self.ren.RemoveActor
          self.ren.RemoveActor2D(self.scalarBar)
          self.ren.RemoveActor(self.matrixActor)
          self.ren.RemoveActor(self.bigGrey)
          
          for x in self.dictIncl.values():
            self.ren.RemoveActor(x)
            
          for x in self.dictHole.values():
            self.ren.RemoveActor(x)

        self.matrixActor, self.dictIncl, self.matrxdlny, self.dictIncDlny, \
                          self.dictHole, self.xmax, self.xmin, self.ymax, self.ymin = \
                          prepareData(self.matfilename, self.inclfilename, f, 1, 1, 
                                      self.renTubes, self.renPolys, self.varKey,
                                      self.varKey, self.color, self.Vmax, self.Vmin)

        if self.didSetCamera == NO:
          self.didSetCamera = YES
          self.camera.SetPosition(((self.xmin+self.xmax)/2.0) - 0.25, \
                                  (self.ymin+self.ymax)/2.0, 6.0)
          self.camera.SetFocalPoint(((self.xmin+self.xmax)/2.0) - 0.25, \
                                    (self.ymin+self.ymax)/2.0, 0.0)


        # now add the grey backdrop
        self.bigGrey = bigGrey(self.xmax, self.xmin, self.ymax, self.ymin)
        self.ren.AddActor(self.bigGrey)

        self.lineWidget.SetInput(self.matrxdlny.GetOutput())
        self.lineWidget.SetResolution(self.lineRes)
        self.lineWidget.GetPolyData(self.seeds)
        self.lineWidget.PlaceWidget(self.xmin, self.xmax, self.ymin, self.ymax, 0.0, 0.0)
        self.lineWidget.ClampToBoundsOn()

        # The next two commands keep from accumulating data
        del self.appendF
        self.appendF = vtk.vtkAppendPolyData()

        self.appendF.AddInput(self.matrxdlny.GetOutput())
        if len(self.dictIncDlny.values()) > 0:
          for x in self.dictIncDlny.values():
            self.appendF.AddInput(x.GetOutput())

        self.pprobe.SetInput(self.seeds)
        self.pprobe.SetSource(self.appendF.GetOutput())
        self.xyplot = prepPlot(self.pprobe)
        
        if self.didPlot:
          self.plotter.update(self.master, self.xyplot)
          self.plotter.refresh(self.master)
 
        self.scalarBar = makeLegends(self.matrixActor, self.varKey, self.dictIncl)
        self.ren.AddActor2D(self.scalarBar)

        self.ren.AddActor(self.matrixActor)
        
        for x in self.dictIncl.values():
          self.ren.AddActor(x)

        for x in self.dictHole.values():
          self.ren.AddActor(x)

        self.ren.Render()
        self.renWin.Render()

        ## save the image?
        if self.saveIt == YES:
          if self.imageType == 'JPEG' or self.imageType == 'jpeg':
            SaveJPEG(f, self.baseFrame, self.imageFilename+'_'+self.varKey, self.renWin)
          elif self.imageType == 'TIFF' or self.imageType == 'tiff':
            SaveTIFF(f, self.baseFrame, self.imageFilename+'_'+self.varKey, self.renWin)
          else:
            SavePS(f, self.baseFrame, self.imageFilename+'_'+self.varKey, self.renWin)

    else: # Single frame calculation
      ## Remove all actors in renderer
      if self.ren.VisibleActorCount() > 0:
        self.ren.RemoveActor2D(self.scalarBar)
        self.ren.RemoveActor(self.crd1Actor)
        self.ren.RemoveActor(self.crd2Actor)
        self.ren.RemoveActor(self.matrixActor)
        self.ren.RemoveActor(self.bigGrey)

        for x in self.dictIncl.values():
          self.ren.RemoveActor(x)

        for x in self.dictHole.values():
          self.ren.RemoveActor(x)


      self.matrixActor, self.dictIncl, self.matrxdlny, self.dictIncDlny, \
                        self.dictHole, self.xmax, self.xmin, self.ymax, self.ymin = \
                        prepareData(self.matfilename, self.inclfilename, self.startFrame, 1, 1, \
                                    self.renTubes, self.renPolys, self.varKey,
                                    self.varKey, self.color, self.Vmax, self.Vmin)


      if self.didSetCamera == NO:
        self.didSetCamera = YES
        self.camera.SetPosition(((self.xmin+self.xmax)/2.0) + 0.25, \
                                (self.ymin+self.ymax)/2.0, 6.0)
        self.camera.SetFocalPoint(((self.xmin+self.xmax)/2.0) + 0.25, \
                                  (self.ymin+self.ymax)/2.0, 0.0)

      # now add the grey backdrop
      self.bigGrey = bigGrey(self.xmax, self.xmin, self.ymax, self.ymin)
      self.ren.AddActor(self.bigGrey)

      self.lineWidget.SetInput(self.matrxdlny.GetOutput())
      self.lineWidget.SetResolution(self.lineRes)
      self.lineWidget.GetPolyData(self.seeds)
      self.lineWidget.PlaceWidget(self.xmin, self.xmax, self.ymin, self.ymax, 0.0, 0.0)
      self.lineWidget.ClampToBoundsOn()

      # The next two commands keep from accumulating data
      del self.appendF
      self.appendF = vtk.vtkAppendPolyData()

      self.appendF.AddInput(self.matrxdlny.GetOutput())
      if len(self.dictIncDlny.values()) > 0:
        for x in self.dictIncDlny.values():
          self.appendF.AddInput(x.GetOutput())

      self.pprobe.SetInput(self.seeds)
      self.pprobe.SetSource(self.appendF.GetOutput())
      self.xyplot = prepPlot(self.pprobe)

      if self.didPlot:
        self.plotter.update(self.master, self.xyplot)
        self.plotter.refresh(self.master)

      self.scalarBar = makeLegends(self.matrixActor, self.varKey, self.dictIncl)
      self.ren.AddActor2D(self.scalarBar)
      self.ren.AddActor(self.crd1Actor)
      self.ren.AddActor(self.crd2Actor)

      self.ren.AddActor(self.matrixActor)
      
      for x in self.dictIncl.values():
          self.ren.AddActor(x)

      for x in self.dictHole.values():
          self.ren.AddActor(x)

      self.ren.Render()
      self.renWin.Render()

      ## save the image?
      if self.saveIt == YES:
        if self.imageType == 'JPEG' or self.imageType == 'jpeg':
          SaveJPEG(self.startFrame, self.baseFrame, self.imageFilename+'_'+self.varKey, self.renWin)
        elif self.imageType == 'TIFF' or self.imageType == 'tiff':
          SaveTIFF(self.startFrame, self.baseFrame, self.imageFilename+'_'+self.varKey, self.renWin)
        else:
          SavePS(self.startFrame, self.baseFrame, self.imageFilename+'_'+self.varKey, self.renWin)


# plot the graph
  def plotMethod(self, event = None):

    if self.plotWin == NO:
      self.plotWin = YES
      # Call on the plot class
      self.plotter = plot(self.master)
      
# Check color
  def colorMethod(self, event=None):
    if self.checkcolor.get()==1:
      self.color=1
    else:
      self.color=0

# exit the editor
  def exitMethod(self, event = None):
    self.dialog = yesno(self.master)
    self.myMssg = 'Do you want to exit?'
    self.returnValue = self.dialog.go(title = 'exit?',
                                      message = self.myMssg)
    if self.returnValue:
      self.master.destroy()

# save the file as
  def saveAs(self, event = None):
    fileName = appPath
    
    if fileName:
      if os.path.isfile(fileName):
        self.imageFilename = fileName
      else:
        path, file = os.path.split(fileName)
        if os.path.isdir(path):
          self.imageFilename = path
        else:
          self.imageFilename = appPath
    else:
      self.imageFilename = appPath
    
    self.dialog = saveDialog(self.master)
    self.imageFilename = self.dialog.go(title = 'Save Image File Dialog',
                                        startPath = self.imageFilename)
    if self.imageFilename:
      print self.imageFilename
    else:
      self.imageFilename = './default'

# file save primitive
  def fileSave(self, myFile):
    global fileName, fileDirty
    self.fileOutput = open(self.myFile, 'w')
    self.fileOutput.write(self.myText.get('0.0', END))
    self.fileOutput.close()
    fileName = self.myFile
    fileDirty = FALSE
    self.master.title(fileName)
    self.update_menu()

# open a matrix file
  def getmatrix(self, event = None):
    global fileName, fileDirty

    self.didSetCamera = NO

    if fileName:
      self.path, self.file = os.path.split(fileName)
      if os.path.isdir(self.path):
        self.myFile = self.path
      else:
        self.myFile = appPath
    else:
      self.myFile = appPath

    self.dialog = openDialog(self.master)
    self.matfilename = self.dialog.go(title = 'Open Matrix File Dialog',
                                      startPath = self.myFile)

    print self.matfilename
##     if self.myFile:
##       self.fileOpen(self.myFile)

# open an inclusion file
  def getincl(self, event = None):
    global fileName, fileDirty

    if fileName:
      self.path, self.file = os.path.split(fileName)
      if os.path.isdir(self.path):
        self.myFile = self.path
      else:
        self.myFile = appPath
    else:
      self.myFile = appPath

    self.dialog = openDialog(self.master)
    self.inclfilename = self.dialog.go(title = 'Open Inclusion File Dialog',
                                       startPath = self.myFile)

    print self.inclfilename


# file open primitive
  def fileOpen(self, myFile):
    global fileName, fileDirty
    self.myText.delete('0.0', END)
    self.fileInput = open(self.myFile, 'r')
    self.myText.insert('0.0', self.fileInput.read())

    self.fileInput.close()
    fileName = self.myFile
    fileDirty = FALSE
    self.master.title(fileName)
    self.update_menu()


# Line Widget Methods

  def begin_plot(self, obj, event = None):
    if self.plotWin == YES:
      self.lineWidget.GetPolyData(self.seeds)
      self.pprobe.SetInput(self.seeds)
      self.pprobe.SetSource(self.appendF.GetOutput())
      self.xyplot = prepPlot(self.pprobe)

      pt1pos = self.lineWidget.GetPoint1()
      pt2pos = self.lineWidget.GetPoint2()

      coord1 = "(%5.3f" % pt1pos[0] + ", %5.3f" % pt1pos[1] + ")"
      coord2 = "(%5.3f" % pt2pos[0] + ", %5.3f" % pt2pos[1] + ")"

      self.crd1Actor.SetScale(0.005)
      self.crd1Actor.SetInput(coord1)
      self.crd1Actor.SetPosition(pt1pos[0], pt1pos[1], 0.1)
      t1prop = self.crd1Actor.GetTextProperty()
      t1prop.SetFontSize(10)
      t1prop.SetColor(0, 0, 0)
      self.crd1Actor.SetTextProperty(t1prop)
      
      self.crd2Actor.SetScale(0.005)
      self.crd2Actor.SetInput(coord2)
      self.crd2Actor.SetPosition(pt2pos[0], pt2pos[1], 0.1)
      t2prop = self.crd2Actor.GetTextProperty()
      t2prop.SetFontSize(10)
      t2prop.SetColor(0, 0, 0)
      self.crd2Actor.SetTextProperty(t2prop)
      
      self.plotter.update(self.master, self.xyplot)
      self.plotter.refresh(self.master)
 
  def generate_plot(self, obj, event = None):
    if self.plotWin == YES:
      self.lineWidget.GetPolyData(self.seeds)
      self.pprobe.SetInput(self.seeds)
      self.pprobe.SetSource(self.appendF.GetOutput())
      self.xyplot = prepPlot(self.pprobe)

      pt1pos = self.lineWidget.GetPoint1()
      pt2pos = self.lineWidget.GetPoint2()

      coord1 = "(%5.3f" % pt1pos[0] + ", %5.3f" % pt1pos[1] + ")"
      coord2 = "(%5.3f" % pt2pos[0] + ", %5.3f" % pt2pos[1] + ")"

      self.crd1Actor.SetScale(0.005)
      self.crd1Actor.SetInput(coord1)
      self.crd1Actor.SetPosition(pt1pos[0], pt1pos[1], 0.1)
      t1prop = self.crd1Actor.GetTextProperty()
      t1prop.SetFontSize(10)
      t1prop.SetColor(0, 0, 0)
      self.crd1Actor.SetTextProperty(t1prop)
      
      self.crd2Actor.SetScale(0.005)
      self.crd2Actor.SetInput(coord2)
      self.crd2Actor.SetPosition(pt2pos[0], pt2pos[1], 0.1)
      t2prop = self.crd2Actor.GetTextProperty()
      t2prop.SetFontSize(10)
      t2prop.SetColor(0, 0, 0)
      self.crd2Actor.SetTextProperty(t2prop)
      
      self.plotter.update(self.master, self.xyplot)
      self.plotter.refresh(self.master)

  
# UPDATING METHODS

# update the menus
  def update_menu(self, obj, event = None):
    self.update_status()
    if self.getSelection():
      self.myText.bind_class('Text', '<Control-Key-x>', self.cut)
      self.editMenu.entryconfigure(0, state = NORMAL)
      self.cutButton.configure(state = NORMAL)
      self.myText.bind_class('Text', '<Control-Key-c>', self.copy)
      self.editMenu.entryconfigure(1, state = NORMAL)
      self.copyButton.configure(state = NORMAL)
    else:
      self.myText.unbind_class('Text', '<Control-Key-x>')
      self.editMenu.entryconfigure(0, state = DISABLED)
      self.cutButton.configure(state = DISABLED)
      self.myText.unbind_class('Text', '<Control-Key-c>')      
      self.editMenu.entryconfigure(1, state = DISABLED)
      self.copyButton.configure(state = DISABLED)
    if currentFind or self.getSelection():
      self.editMenu.entryconfigure(5, state = NORMAL)
      self.myText.bind_class('Text', '<Control-Key-g>', self.again)
      self.nextButton.configure(state = NORMAL)
    else:
      self.editMenu.entryconfigure(5, state = DISABLED)
      self.myText.unbind_class('Text', '<Control-Key-g>')
      self.nextButton.configure(state = DISABLED)
    if fileName:
      self.master.bind_class(self.master, '<Control-Key-s>', self.save)
      self.fileMenu.entryconfigure(3, state = NORMAL)
      self.saveButton.configure(state = NORMAL)
    else:
      self.master.unbind_class(self.master, '<Control-Key-s>')
      self.fileMenu.entryconfigure(3, state = DISABLED)
      self.saveButton.configure(state = DISABLED)

# update isDirty on KeyRelease
  def update_dirty(self, event):
    global fileDirty
    self.update_status()
    fileDirty = TRUE

# update status bar
  def update_status(self):
    myIndex = self.myText.index('insert')
    myLine, myColumn = string.split(myIndex, ".")
    self.statusLabel.configure(text = 'line: %s column: %s' % (myLine, myColumn))


# RUN THE PROGRAM

# create a window
root = Tk()

# execute the windows
cmrl(root)
