#!/usr/bin/python

# IMPORT PYTHON MODULES

## from tkMessageBox import *
import Tkinter
from Tkinter   import *
from myBoolean import *
from myDialog  import *

import os
import string

# IMPORT USER DEFINED MODULES

from dialogs   import *
from files     import *
from find      import *
from configure import *
from plot      import *


# SET THE GLOBAL VARIABLES

fileName = ''
fileDirty = FALSE
appPath = os.getcwd()
currentFind = None

# THE EDITOR CLASS

class cmrl:

# CREATE THE EDITOR WINDOW

  def __init__(self, master):
    self.master = master
    self.master.title('Metal Stress')
    self.master.geometry('640x480+10+10')
    self.master.bind_class(self.master, '<Control-Key-o>', self.open)
    self.master.bind_class(self.master, '<Control-Key-a>', self.saveAs)
    self.master.bind_class(self.master, '<Control-Key-q>', self.exitMethod)
    self.master.bind_class(self.master, '<Control-Key-r>', self.saveAs)
    self.myBar = Frame(self.master, config['frame'])
    self.fileMenu()
    self.windowsMenu()
    self.helpMenu()
    self.myBar.pack(side = TOP, fill = X)
    self.myTools = Frame(self.master, config['frame'])
    self.myTools.pack(side = TOP, fill = X)

    self.openImage = PhotoImage(file= os.path.join(appPath, 'open.gif'))
    self.openButton = Button(self.myTools, config['button'], 
                             image = self.openImage, 
                             command = self.open)
    self.openButton.pack(side = LEFT)
    self.separator0 = Frame(self.myTools, 
                            config['frame'], 
                            width = 15, 
                            height = 30)
    self.separator0.pack(side = LEFT)
    self.saveAsImage = PhotoImage(file= os.path.join(appPath, 'saveas.gif'))
    self.saveAsButton = Button(self.myTools, config['button'], 
                               image = self.saveAsImage, 
                               command = self.saveAs)
    self.saveAsButton.pack(side = LEFT)
    self.separator1 = Frame(self.myTools, 
                            config['frame'], 
                            width = 15, 
                            height = 30)
    self.separator1.pack(side = LEFT)
    self.recalcImage = PhotoImage(file= os.path.join(appPath, 'recalc.gif'))
    self.recalcButton = Button(self.myTools, config['button'], 
                               image = self.recalcImage, 
                               command = self.saveAs)
    self.recalcButton.pack(side = LEFT)
    self.separator2 = Frame(self.myTools,
                            config['frame'],
                            width = 15,
                            height = 30)
    self.separator2.pack(side = LEFT)
    self.plotImage = PhotoImage(file= os.path.join(appPath, 'plot.gif'))
    self.plotButton = Button(self.myTools, config['button'],
                              image = self.plotImage,
                              command = self.plotMethod)
    self.plotButton.pack(side = LEFT)
    self.myStatus = Frame(self.master, config['frame'])
    self.myStatus.pack(side = BOTTOM, fill = X)
    self.statusLabel = Label(self.myStatus,
                             config['label'])
    self.statusLabel.pack(side=LEFT)
    self.myScroll = Scrollbar(self.master, config['scroll'])
    self.myScroll.pack(side=RIGHT, fill=Y)
    self.myText = Text(self.master, config['text'],
                       yscrollcommand=(self.myScroll, 'set'))
    self.myText.pack(side=LEFT, fill=BOTH, expand=YES)
    self.myScroll.configure(command = self.myText.yview)
    self.master.protocol('WM_DELETE_WINDOW', self.exitMethod)
    self.master.mainloop()

# MENU METHODS

# add the file menu to the menu bar
  def fileMenu(self):
    self.fileButton = Menubutton(self.myBar, config['menubutton'], 
                                 text = 'file  ',
                                 underline = 0)
    self.fileButton.pack(side = LEFT)
    self.fileMenu = Menu(self.fileButton, config['menu'], tearoff = 1)
    self.fileMenu.add_command(label = 'open...', 
                     underline = 0, 
                     accelerator = 'ctrl+o', 
                     command = self.open)
    self.fileMenu.add_separator({})
    self.fileMenu.add_command(label = 'save as...', 
                     underline = 5, 
                     accelerator = 'ctrl+a', 
                     command = self.saveAs)
    self.fileMenu.add_separator({})
    self.fileMenu.add_command(label = 'quit',
                     underline = 0, 
                     accelerator = 'ctrl+q', 
                     command = self.exitMethod)
    self.fileButton.configure(menu = self.fileMenu)
    return self.fileButton

# add the edit menu to editor's menu bar
  def windowsMenu(self):
    self.pplotButton = Menubutton(self.myBar, 
                                 config['menubutton'], 
                                 text = 'windows  ', 
                                 underline = 0)
    self.pplotButton.pack(side = LEFT)
    self.pplotMenu = Menu(self.pplotButton,
                          config['menu'],
                          tearoff = 0)
    self.pplotMenu.add_command(label = 'plot graph', 
                               underline = 2, 
                               state = DISABLED, 
                               accelerator = 'ctrl+p',
                               command = self.plotMethod)
    self.pplotButton.configure(menu = self.windowsMenu)
    return self.pplotButton

  def helpMenu(self):
    self.helpButton = Menubutton(self.myBar, 
                                 config['menubutton'], 
                                 text = 'windows  ', 
                                 underline = 0)
    self.helpButton.pack(side = RIGHT)
    self.helpMenu = Menu(self.helpButton,
                         config['menu']
                         tearoff = 0)
    self.helpMenu.add_command(label = 'about',
                              underline = 0,
                              command = self.aboutMethod)
    self.helpMenu.add_command(label = 'help',
                              underline = 0,
                              command = self.helpMethod)
    self.helpButton.configure(menu = self.helpMenu)
    return self.helpButton

# TEXT EDITING METHODS

# the cut method
  def plotMethod(self, event = None):

    # Create the toplevel window
    top = Tkinter.Toplevel(root)
    top.title("Plotting")
##     top.protocol("WM_DELETE_WINDOW", top_quit)
    top.plot()


# FILE MANAGEMENT METHODS

# exit the editor
  def exitMethod(self):
    self.dialog = yesno(self.master)
    self.myMssg = 'Do you want to exit?'
    self.returnValue = self.dialog.go(message = self.myMssg)
    if self.returnValue:
      self.master.destroy()

##   def exitMethod(self):
##     if askokcancel('Verify exit' , "Really quit?"):
##       self.isDirty()
##       self.master.destroy()

# save the file if edited
  def isDirty(self):
    global fileName, fileDirty
    if fileDirty:
      self.dialog = question(self.master)
      self.answer = self.dialog.go(
                    title = 'editor dialog',
                    message = 'This file has been edited.\nSave the changes?')
      if self.answer:
        self.save()

# save the file as
  def saveAs(self, event = None):
    global fileName
    if fileName:
      if os.path.isfile(fileName):
        self.myFile = fileName
      else:
        self.path, self.file = os.path.split(fileName)
        if os.path.isdir(self.path):
          self.myFile = self.path
        else:
          self.myFile = appPath
    else:
      self.myFile = appPath
    self.dialog = saveDialog(self.master)
    self.myFile = self.dialog.go(title = 'Save File Dialog',
                                 startPath = self.myFile)
    if self.myFile:
      self.fileSave(self.myFile)

# file save primitive
  def fileSave(self, myFile):
    global fileName, fileDirty
    self.fileOutput = open(self.myFile, 'w')
    self.fileOutput.write(self.myText.get('0.0', END))
    self.fileOutput.close()
    fileName = self.myFile
    fileDirty = FALSE
    self.master.title(fileName)
    self.update_menu()

# open a file
  def open(self, event = None):
    global fileName, fileDirty
    self.isDirty()
    if fileName:
      self.path, self.file = os.path.split(fileName)
      if os.path.isdir(self.path):
        self.myFile = self.path
      else:
        self.myFile = appPath
    else:
      self.myFile = appPath
    self.dialog = openDialog(self.master)
    self.myFile = self.dialog.go(title = 'Open File Dialog',
                                 startPath = self.myFile)
    if self.myFile:
      self.fileOpen(self.myFile)

# file open primitive
  def fileOpen(self, myFile):
    global fileName, fileDirty
    self.myText.delete('0.0', END)
    self.fileInput = open(self.myFile, 'r')
    self.myText.insert('0.0', self.fileInput.read())
    self.fileInput.close()
    fileName = self.myFile
    fileDirty = FALSE
    self.master.title(fileName)
    self.update_menu()


# UPDATING METHODS

# update the menus
  def update_menu(self, event = None):
    self.update_status()
    if self.getSelection():
      self.myText.bind_class('Text', '<Control-Key-x>', self.cut)
      self.editMenu.entryconfigure(0, state = NORMAL)
      self.cutButton.configure(state = NORMAL)
      self.myText.bind_class('Text', '<Control-Key-c>', self.copy)
      self.editMenu.entryconfigure(1, state = NORMAL)
      self.copyButton.configure(state = NORMAL)
    else:
      self.myText.unbind_class('Text', '<Control-Key-x>')
      self.editMenu.entryconfigure(0, state = DISABLED)
      self.cutButton.configure(state = DISABLED)
      self.myText.unbind_class('Text', '<Control-Key-c>')      
      self.editMenu.entryconfigure(1, state = DISABLED)
      self.copyButton.configure(state = DISABLED)
    if currentFind or self.getSelection():
      self.editMenu.entryconfigure(5, state = NORMAL)
      self.myText.bind_class('Text', '<Control-Key-g>', self.again)
      self.nextButton.configure(state = NORMAL)
    else:
      self.editMenu.entryconfigure(5, state = DISABLED)
      self.myText.unbind_class('Text', '<Control-Key-g>')
      self.nextButton.configure(state = DISABLED)
    if fileName:
      self.master.bind_class(self.master, '<Control-Key-s>', self.save)
      self.fileMenu.entryconfigure(3, state = NORMAL)
      self.saveButton.configure(state = NORMAL)
    else:
      self.master.unbind_class(self.master, '<Control-Key-s>')
      self.fileMenu.entryconfigure(3, state = DISABLED)
      self.saveButton.configure(state = DISABLED)

# update isDirty on KeyRelease
  def update_dirty(self, event):
    global fileDirty
    self.update_status()
    fileDirty = TRUE

# update status bar
  def update_status(self):
    myIndex = self.myText.index('insert')
    myLine, myColumn = string.split(myIndex, ".")
    self.statusLabel.configure(text = 'line: %s column: %s' % (myLine, myColumn))

# RUN THE PROGRAM

# create a window
root = Tk()

# execute the windows
cmrl(root)

























