#!/usr/bin/python

# import python modules
from Tkinter   import *
from dialogs   import *
from configure import *

# the find/replace window class
class search:
  def __init__(self, master = None, replace = TRUE):
    self.toplevel = Toplevel(master)
    self.replace = replace
    self.replaced = FALSE
    self.caseVar = IntVar()
    self.toplevel.geometry('+300+250')
    self.main_frame = Frame(self.toplevel, 
                            config['frame'])
    self.main_frame.pack(side = TOP, fill = BOTH, expand = YES)
    self.bottom_frame = Frame(self.main_frame, 
                              config['frame'])
    self.bottom_frame.pack(side = BOTTOM, padx = 10, pady = 5)
    self.find_button = Button(self.bottom_frame, 
                              config['button'], 
                              text = 'find next', 
                              width = 8, 
                              command = self.findText)
    self.find_button.pack(side = LEFT)
    if self.replace:
      self.toplevel.title('replace dialog')
      self.replaceAll_button = Button(self.bottom_frame, 
                                      config['button'], 
                                      text = 'replace all', 
                                      width = 8,
                                      command = self.replaceAll)
      self.replaceAll_button.pack(side = LEFT)
    else:
      self.toplevel.title('find dialog')
    self.close_button = Button(self.bottom_frame, 
                               config['button'], 
                               text = 'close', 
                               width = 8, 
                               command = self.exitFind)
    self.close_button.pack(side = RIGHT)
    self.top_frame = Frame(self.main_frame, 
                           config['frame'])
    self.top_frame.pack(side = LEFT, 
                        fill = BOTH, 
                        expand = YES, 
                        padx = 10, 
                        pady = 5)
    self.findString_frame = Frame(self.top_frame, 
                                  config['frame'])
    self.findString_frame.pack(side = TOP, fill = X)
    self.findString_label = Label(self.findString_frame, 
                                  config['label'], 
                                  text = '   find string: ', 
                                  width = 12)
    self.findString_label.pack(side = LEFT)
    self.findString_entry = Entry(self.findString_frame, 
                                  config['text'])
    self.findString_entry.pack(side = RIGHT, fill = X, expand = YES)
    if self.replace:
        self.replaceString_frame = Frame(self.top_frame, 
                                         config['frame'])
        self.replaceString_frame.pack(side = TOP, fill = X)
        self.replaceString_label = Label(self.replaceString_frame, 
                                         config['label'], 
                                         text = 'replace with: ', 
                                         width = 12)
        self.replaceString_label.pack(side = LEFT)
        self.replaceString_entry = Entry(self.replaceString_frame, 
                                         config['text'])
        self.replaceString_entry.pack(side = RIGHT, fill = X, expand = YES)
    self.options_frame = Frame(self.top_frame, 
                               config['frame'])
    self.options_frame.pack(side = TOP, fill = X)
    self.case_check = Checkbutton(self.options_frame, 
                                  config['check'], 
                                  text = ' match case? ',
                                  onvalue = 0,
                                  offvalue = 1,
                                  variable = self.caseVar)
    self.case_check.pack(side = RIGHT)

# start the dialog
  def go(self, object, string = None):
    if string:
        self.findString_entry.insert('0', string)
    else:
        self.findString_entry.delete('0', END)
    self.findString = string
    self.myObject = object
    self.findString_entry.focus_set()
    self.toplevel.grab_set()
    self.toplevel.focus_set()
    self.toplevel.wait_window()
    self.myObject.tag_delete('myString')
    return self.findString, self.replaced

# find or find/replace a string
  def findText(self, event = None):
    self.myObject.tag_delete('myString')
    try:
      myEntry = self.findString_entry.get()
    except:
      myEntry = None
    if myEntry:
      try:
        self.findString = myEntry
        myIndex = self.myObject.search(myEntry, 
                                      'insert + 1 chars', 
                                       nocase = self.caseVar.get())
        self.myObject.mark_set('insert', myIndex)
        myEndex = '%s + %d %s' % ('insert', len(myEntry), 'chars')
        self.myObject.tag_add('myString',myIndex, myEndex)
        self.myObject.tag_configure('myString', 
                                     background = '#800000', 
                                     foreground = '#FFFFFF')
        self.myObject.see(myIndex)
        if self.replace:
          try:
            mySubstitute = self.replaceString_entry.get()
          except:
            mySubstitute = None
          replaceDialog = question(self.toplevel)
          if mySubstitute:
            answer = replaceDialog.go(title = 'replace',
                     geometry = '269x117+352+334',
                     message = 'Replace ' + myEntry + ' with ' + mySubstitute + '?')
          else:
            answer = replaceDialog.go(title = 'replace',
                     geometry = '269x117+352+334',
                     message = 'Delete this instance of ' + myEntry + '?')
          if answer:
            if not mySubstitute:
              mySubstitute = ''
            self.myObject.tag_delete('myString')
            self.myObject.delete(myIndex, myEndex)
            self.myObject.insert(myIndex, mySubstitute)
            self.replaced = TRUE
      except:
        self.findString = None
        message(self.toplevel,
                geometry = '269x117+352+334',
                message = '"' + myEntry + '" not found')

# replace all instances of a string
  def replaceAll(self):
    self.myObject.tag_delete('myString')
    myInsert = self.myObject.index(INSERT)
    try:
      myEntry = self.findString_entry.get()
    except:
      myEntry = None
    if myEntry:
      try:
        mySubstitute = self.replaceString_entry.get()
      except:
        mySubstitute = ''
      again = TRUE
      while again:
        try:
          myIndex = self.myObject.search(myEntry, 
                                        'insert + 1 chars', 
                                         nocase = self.caseVar.get())
          self.myObject.mark_set('insert', myIndex)
          myEndex = '%s + %d %s' % ('insert', len(myEntry), 'chars')
          self.myObject.delete(myIndex, myEndex)
          self.myObject.insert(myIndex, mySubstitute)
          self.replaced = TRUE
        except:
          again = FALSE
    self.findString = None
    self.myObject.mark_set('insert', myInsert)

# exit the dialog
  def exitFind(self, event = None):
    self.myObject.tag_delete('myString')
    self.toplevel.destroy()

# the test command
if __name__ == '__main__':
  root = Tk()
  root.withdraw()
  myTest1 = search(root, replace=FALSE)
  myTest1.go('')
  myTest2 = search(root, replace=TRUE)
  myTest2.go('')

