#!/usr/bin/python

# import python modules
import Tkinter
from Tkinter import *
from myBoolean import *

from dialogs import *
import os, string
from configure import *
import vtk
from vtk.tk.vtkTkRenderWindowInteractor import vtkTkRenderWindowInteractor

# the file dialog class
class plot:
  def __init__(self, master = None):
    self.toplevel = Toplevel(master, config['frame'])
    self.toplevel.geometry('540x540+700+150')

    self.renFrame = Tkinter.Frame(self.toplevel, config['frame'], \
                                  relief = "sunken", \
                                  borderwidth = 2)
    self.pprenWin = vtk.vtkRenderWindow()
    self.ppren = vtk.vtkRenderer()
    self.ppren.SetBackground(1, 1, 1)
    self.pprenWin.AddRenderer(self.ppren)
    self.pprw = vtkTkRenderWindowInteractor(self.renFrame, \
                                            width=540, height=500, \
                                            rw=self.pprenWin)
    self.pprw.pack(expand="t", fill="both")
    self.pprw.Initialize()
    self.pprw.pack(side="top", expand="yes", fill="both")
    self.renFrame.pack(side="top", expand="yes", fill="both")
    self.pprenWin.Render()
    self.pprw.Start()

    
    self.bottomFrame = Tkinter.Frame(self.toplevel, config['frame'], \
                                     borderwidth = 2)
    self.bottomFrame.pack(side=BOTTOM, pady=5, expand=1, fill="both")

    self.cancel_button = Button(self.bottomFrame, config['button'], 
                                width=7, 
                                text="exit", 
                                command = self.exit)
    self.cancel_button.pack(side=RIGHT, expand=YES, padx=8, anchor="e")

    self.refresh_button = Button(self.bottomFrame, config['button'], 
                                width=7, 
                                text="redraw", 
                                command = self.refresh)
    self.refresh_button.pack(side=LEFT, expand=YES, padx=8, anchor="w")
    
    self.toplevel.protocol('WM_DELETE_WINDOW', self.exit)


  # on clicking the cancel button
  def exit(self, event = None):
    self.toplevel.didPlot = NO
    self.pprenWin.RemoveRenderer(self.ppren)
    self.pprw.Disable()
    self.toplevel.destroy()

  def update(self, event = None, xyplot = vtk.vtkActor2D()):
    self.xyplot = xyplot
    self.xyplot.GetPositionCoordinate().SetCoordinateSystemToNormalizedViewport()
    self.xyplot.GetPositionCoordinate().SetValue(0.05, 0.05, 0)
    self.xyplot.GetPosition2Coordinate().SetCoordinateSystemToNormalizedViewport()
    #relative to Position
    self.xyplot.GetPosition2Coordinate().SetValue(0.95, 0.95, 0)

  def refresh(self, event = None):
    if self.ppren.VisibleActorCount() > 0:
      self.ppren.RemoveActor2D(self.xyplot)

    self.ppren.AddActor(self.xyplot)
    self.ppren.ResetCamera()
    self.ppren.Render()
    self.pprenWin.Render()
    

# the test command
if __name__ == '__main__':
  root = Tk()
  plot(root)
