
!********************************************************
SUBROUTINE UPDAT2(NEL,NINPT,NITT,NIT,MP,SC)
!********************************************************

  CALL D_INTG(NEL,NINPT,NITT,NIT,MP,SC)

  RETURN
END SUBROUTINE UPDAT2

!********************************************************
!Update Stress variables
SUBROUTINE UPDAT21(NEL,NINPT,NITT,NIT,MP,SC)
!********************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  DIMENSION SC(1)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /INTLOPBG1/ HYP1(INTC),HYP2(INTC),VMLC(INTC),STRP(INTC,4),&
       SN1(INTC*4)
  COMMON /PROP/ YM,PR
  COMMON /YIELD/ HRD(16,3),YLDIN(16)
  COMMON /CONSTMT1/ NPTS(10),STSN(10,100,2)
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /EPSCOM/ STNCOM(NLM*INTC*4),STNCOMST(NLM*INTC*4)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /PLPCOM/ VMCOM(NLM*INTC),EPLSCOM(NLM*INTC)&
       ,DEPLSCOM(NLM*INTC),NPLCOM(NLM*INTC)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /PLLC/ NPLCM(NLM*INTM),NPLCC(NLM*INTC)
  COMMON /INSTT/ NPLINM(NLM*INTM),NPLINC(NLM*INTC)
  COMMON /PLNST/ KPLS
  COMMON /STEPNUM/ IST
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /MACSTN/ NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)
  COMMON /PROPTRANSLCMAT/ PRMAT_X(INTM),PRMAT_Y(INTM),PRMAT_XY&
       (INTM)
  COMMON /PROPTRANSLCCOM/ PRCOM_X(INTC),PRCOM_Y(INTC),PRCOM_XY&
       (INTC)
  G0=(1.D0+PR)/YM
  G1=-PR/YM
  G=1.D0/YM+KPLS*PR*G1
  G1=G1+KPLS*PR*G1
  ITR1=0
  ITR2=0
  NPT1=NPBM(NEL)
  NPT2=0
  loop_1: DO I=1,NINPT
     IPT=(NPT1+I-1)*4
     HY=STCOMST(IPT+1)+STCOMST(IPT+2)
     STCOMST(IPT+4)=KPLS*PR*HY+KPLS*YM*EZZ_APP
     HY=HY+STCOMST(IPT+4)
     STNCOMST(IPT+1)=G0*STCOMST(IPT+1)-PR*HY/YM
     STNCOMST(IPT+2)=G0*STCOMST(IPT+2)-PR*HY/YM
     STNCOMST(IPT+3)=G0*STCOMST(IPT+3)
     STNCOMST(IPT+4)=EZZ_APP
     SN1(I*4-3)=STNCOMST(IPT+1)
     SN1(I*4-2)=STNCOMST(IPT+2)
     SN1(I*4-1)=STNCOMST(IPT+3)*2.D0
     SN1(I*4)=STNCOMST(IPT+4)
     S11=STCOM(IPT+1)+STCOMST(IPT+1)*0.5D0
     S22=STCOM(IPT+2)+STCOMST(IPT+2)*0.5D0
     S12=STCOM(IPT+3)+STCOMST(IPT+3)*0.5D0
     S33=STCOM(IPT+4)+STCOMST(IPT+4)*0.5D0
     IF (NITT.NE.2) THEN
        I1=(I-1)*9
        SC(I1+1)=G
        SC(I1+2)=G1
        SC(I1+3)=0.D0
        SC(I1+4)=G1
        SC(I1+5)=G
        SC(I1+6)=0.D0
        SC(I1+7)=0.D0
        SC(I1+8)=0.D0
        SC(I1+9)=G0*2.D0
        PRCOM_X(I)=PR*KPLS
        PRCOM_Y(I)=PR*KPLS
        PRCOM_XY(I)=0.D0
     ENDIF
  enddo loop_1
  RETURN
END SUBROUTINE UPDAT21

!******************************************************
SUBROUTINE D_INTG(NEL,NINPT,NITT,NIT,MP,SC)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)

  DIMENSION SC(1),AN(4)
  COMMON /INSTT/ NPLINM(NLM*INTM),NPLINC(NLM*INTC)
  COMMON /SOFTTANG/ STRST1(INTM*4),STRST2(INTM*4),STNST1(INTM*4),&
       STNST2(INTM*4),STNST3(INTM*4)
  COMMON /INTLOPBG/ HYP1(INTM),HYP2(INTM),VMLC(INTM),STRP(INTM,4),&
       SN1(INTM*4)
  COMMON /STEPLC/ ALPHA1(INTM),ALPHA2(INTM),ALPHA(INTM)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /VOIDPARAM/ Q1,Q2,Q3,FCOL,FMAX,FMAX_MODEL
  COMMON /ELEPROP/ PROMAT(16,10),MPE(NLM),MPG(NLM)
  COMMON /PROP/ YM,PR
  COMMON /PLNST/ KPLS
  COMMON /NLOCPRM/ XLCHAR,XP,XQ,XK_NLOC(NLM*INTM)
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /GEOM1/ XMTRL(NDFM)
  COMMON /LOCALIZE/ ILOCAL_LC(INTM),ILOCAL(INTM)
  COMMON /LOCALTILL/ STRST(INTM*4),STNST(INTM*4),DEPLS(INTM*4)&
       ,DFV(INTM*4),VM_L(INTM),EHYD(NLM*INTM),&
       DEHY(NLM*INTM),STMAT_LC(NLM*INTM),STNMAT_LC(NLM*INTM),&
       EPLSMAT_LC(NLM*INTM),FVOID_LC(NLM*INTM),ILCTYP(NLM*INTM)
  COMMON /BOUND/ NBOUND,NBC1(3),VBC1(3),SN11,SN22,SN12
  COMMON /FTOL/ FNORM
  COMMON /YIELD/ HRD(16,3),YLDIN(16)
  COMMON /CONSTMT1/ NPTS(10),STSN(10,100,2)
  COMMON/STRLOC/VOQ1,VOQ2,VOQ3
  COMMON /MATLOC/ VM_LOC(NLM*INTM),EPLS_LOC(NLM*INTM),&
       FVOID_LOC(NLM*INTM),IMATLC(NLM*INTM),IFAIL(NLM*INTM)
  COMMON /VOIDDATA/ FVOID(INTM*NLM),DFVOID(INTM*NLM)
  COMMON /REGENVAR/ IREGEN
  COMMON /VISCOUS/ GAMMA,EXPP,IVISCOUS

  COMMON /ANISOTROPIC/ XF_AN,XG_AN,XH_AN,XC_AN,IANIS

  loop_10000: DO I=1,NINPT
     IPT=NPBG(NEL)+I
     VMLC(I)=VMMAT(IPT)
  enddo loop_10000

  CALL UPDAT_T(NEL,NINPT,NITT,NIT,MP,SC)

  KFL=1
  loop_10001: DO I=1,NINPT
     IPT=NPBG(NEL)+I
     JPT=(IPT-1)*4
     ILOCAL(I)=0
  enddo loop_10001
  ITR=0
  loop_10004: DO I=1,NINPT
     IF (ILOCAL_LC(I).EQ.1) THEN
        ILOCAL(I)=1
     ELSE
        ILOCAL(I)=0
     ENDIF
  enddo loop_10004
  IF (NITT.LT.2) THEN
     loop_10005: DO I=1,NINPT
        IF (ILOCAL(I).EQ.1) THEN
           YM_EFF=EFF_YM(FVOID(NPBG(NEL)+I))
           G1=1.D0/YM_EFF
           G2=-PR*G1
           G1=G1+PR*KPLS*G2
           G2=G2+PR*KPLS*G2
           G0=2.D0*(1.D0+PR)/YM_EFF
           SC(I*9-8)=SC(I*9-8)-G1
           SC(I*9-7)=SC(I*9-7)-G2
           SC(I*9-5)=SC(I*9-5)-G2
           SC(I*9-4)=SC(I*9-4)-G1
           SC(I*9-0)=SC(I*9-0)-G0
        ENDIF
     enddo loop_10005
  ENDIF
  RETURN
END SUBROUTINE D_INTG

!******************************************************
SUBROUTINE UPDAT_T(NEL,NINPT,NITT,NIT,MP,SC)
!******************************************************

  ! Declaration of implicit types

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)

  ! Declaration of parameters
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)

  ! Declaration of dimensions

  DIMENSION SC(1),AN(4)

  INTEGER, ALLOCATABLE :: ICONT1(:),ICONT2(:),ILAMCON(:),ICONV(:)&
       ,ISPECIAL(:),ISTOP(:),ITYPE(:)
  DOUBLE PRECISION, ALLOCATABLE :: SLP(:),DFAC(:),PRESS(:),DSZZ1(:)&
       ,DSZZ2(:),DSZF(:),DF1(:),DF2(:),DF(:),DEP1(:),DEP2(:),DEP(:)&
       ,XLAM1(:),XLAM2(:),XLAM(:),RES1(:),RES2(:),RES(:),VM1(:)&
       ,VM2(:),VM(:)

  ! Declaration of common variables

  COMMON /ELEPROP/ PROMAT(16,10),MPE(NLM),MPG(NLM)
  COMMON /NORMALINT/ XNORM_INT(60)
  COMMON /LOCALTILL/ STRST(INTM*4),STNST(INTM*4),DEPLS(INTM*4)&
       ,DFV(INTM*4),VM_L(INTM),EHYD(NLM*INTM),&
       DEHY(NLM*INTM),STMAT_LC(NLM*INTM),STNMAT_LC(NLM*INTM),&
       EPLSMAT_LC(NLM*INTM),FVOID_LC(NLM*INTM),ILCTYP(NLM*INTM)
  COMMON/STRLOC/VOQ1,VOQ2,VOQ3
  COMMON /MATRIXHARD/ VM_MAT(INTM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /INTLOPBG/ HYP1(INTM),HYP2(INTM),VMLC(INTM),STRP(INTM,4),&
       SN1(INTM*4)
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /PROP/ YM,PR
  COMMON /INSTT/ NPLINM(NLM*INTM),NPLINC(NLM*INTC)
  COMMON /YIELD/ HRD(16,3),YLDIN(16)
  COMMON /CONSTMT1/ NPTS(10),STSN(10,100,2)
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /EPSCOM/ STNCOM(NLM*INTC*4),STNCOMST(NLM*INTC*4)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /PLPCOM/ VMCOM(NLM*INTC),EPLSCOM(NLM*INTC)&
       ,DEPLSCOM(NLM*INTC),NPLCOM(NLM*INTC)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /PLLC/ NPLCM(NLM*INTM),NPLCC(NLM*INTC)
  COMMON /PLNST/ KPLS
  COMMON /STEPNUM/ IST
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /VOIDDATA/ FVOID(INTM*NLM),DFVOID(INTM*NLM)
  COMMON /LOCALIZE/ ILOCAL_LC(INTM),ILOCAL(INTM)
  COMMON /MATLOC/ VM_LOC(NLM*INTM),EPLS_LOC(NLM*INTM),&
       FVOID_LOC(NLM*INTM),IMATLC(NLM*INTM),IFAIL(NLM*INTM)
  COMMON /SOFTTANG/ STRST1(INTM*4),STRST2(INTM*4),STNST1(INTM*4),&
       STNST2(INTM*4),STNST3(INTM*4)
  COMMON /MACSTN/NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)
  COMMON /PROPTRANSLCMAT/ PRMAT_X(INTM),PRMAT_Y(INTM),PRMAT_XY&
       (INTM)
  COMMON /PROPTRANSLCCOM/ PRCOM_X(INTC),PRCOM_Y(INTC),PRCOM_XY&
       (INTC)
  COMMON /NLOCPRM/ XLCHAR,XP,XQ,XK_NLOC(NLM*INTM)
  COMMON /VOIDPARAM/ Q1,Q2,Q3,FCOL,FMAX,FMAX_MODEL
  COMMON /VOIDFAILURE/  VFRT
  COMMON /ANISOTROPIC/ IANIS,XF_AN,XG_AN,XH_AN,XC_AN

  ! Declaration of data

  DATA TOL /1.E-5/
  DATA ITR1MAX /1000/
  DATA ITR2MAX /1000/

  ! Declaration of formats

401 FORMAT (5(I6,2X))
402 FORMAT (5(E12.6,2X))

  ALLOCATE(ICONT1(INTM),ICONT2(INTM),ILAMCON(INTM),ICONV(INTM)&
       ,ISPECIAL(INTM),ISTOP(INTM),ITYPE(INTM))
  ICONT1=0
  ICONT2=0
  ILAMCON=0
  ICONV=0
  ISPECIAL=0
  ISTOP=0
  ITYPE=0
  ALLOCATE(SLP(INTM),DFAC(INTM),PRESS(INTM),DSZZ1(INTM),DSZZ2(INTM)&
       ,DSZF(INTM),DF1(INTM),DF2(INTM),DF(INTM),DEP1(INTM),DEP2(INTM)&
       ,DEP(INTM),XLAM1(INTM),XLAM2(INTM),XLAM(INTM),RES1(INTM)&
       ,RES2(INTM),RES(INTM),VM1(INTM),VM2(INTM),VM(INTM))

  ! Initialization of values

  SLP=0.0D0
  DFAC=0.0D0
  PRESS=0.0D0
  DSZZ1=0.0D0
  DSZZ2=0.0D0
  DSZF=0.0D0
  DF1=0.0D0
  DF2=0.0D0
  DF=0.0D0
  DEP1=0.0D0
  DEP2=0.0D0
  DEP=0.0D0
  XLAM1=0.0D0
  XLAM2=0.0D0
  XLAM=0.0D0
  RES1=0.0D0
  RES2=0.0D0
  RES=0.0D0
  VM1=0.0D0
  VM2=0.0D0
  VM=0.0D0

  !Loop over all integration points of the element
  loop_10007: DO I=1,NINPT

     ! Calculation of elastic properties

     YM_EFF=EFF_YM(FVOID(NPBG(NEL)+I))
     G=(1.0D0+PR)/YM_EFF
     G1=PR/YM_EFF
     G2=1.0D0/YM_EFF

     ICONV(I)=0
     ILAMCON(I)=0
     ILOCAL_LC(I)=0
     ICONT1(I)=1
     ISPECIAL(I)=0
     IPT=NPBG(NEL)+I
     JPT=(IPT-1)*4

     YM_EFF=EFF_YM(FVOID(NPBG(NEL)+I))
     YM0=1.D0/YM_EFF
     G0=(1.D0+PR)*YM0

     ! Calculation of the first guess for t33

     STMATST(JPT+4)=PR*(STMATST(JPT+1)+STMATST(JPT+2))*KPLS+KPLS*YM_EFF&
          *EZZ_APP
     S33=STMAT(JPT+4)+STMATST(JPT+4)
     S11=STMAT(JPT+1)+STMATST(JPT+1)
     S22=STMAT(JPT+2)+STMATST(JPT+2)
     S12=STMAT(JPT+3)+STMATST(JPT+3)
     PRESS(I)=S11+S22+S33
     IF(IANIS.EQ.0) THEN
        VM(I)=S11*S11+S22*S22+S12*S12*2.0D0+S33*S33-PRESS(I)*PRESS(I)/3.0d0
        VM(I)=DSQRT(1.5D0*VM(I))
     ELSE
        VM(I)=XH_AN*((S11-S22)**2)+XF_AN*((S22-S33)**2)+XG_AN*((S33-S11)**2)+XC_AN*(S12**2)
        VM(I)=DSQRT(VM(I))
     ENDIF
     DEV_YLD=VM(I)*VM(I)
     P=PRESS(I)*Q2/VM0

     DS=STMAT(JPT+1)+STMAT(JPT+2)+STMAT(JPT+4)+STMATST(JPT+1)&
          +STMATST(JPT+2)+STMATST(JPT+4)
     S33DB=STMAT(JPT+4)+STMATST(JPT+4)-DS/3.0D0

     ITYPE(I)=0 ! Identify the type of loading (s33 and p)

     IF ((S33DB*3.0D0-2.0D0*PRESS(I)*KPLS)*PRESS(I).GT.1.0D-07*&
          YLDIN(MP)) THEN
        IF (PRESS(I).LT.-1.0D-03*YLDIN(MP)) THEN !Pressure is negative and s33 is negative
           ICONV(I)=5
           ILAMCON(I)=1
           ITYPE(I)=1
        ELSEIF (PRESS(I).GT.1.0D-03*YLDIN(MP)) THEN !Pressure is positive and s33 is positive
           ITYPE(I)=-1
           ICONV(I)=5
           ILAMCON(I)=1
        ENDIF
     ELSEIF ((S33DB*3.0D0-2.0D0*PRESS(I)*KPLS)*PRESS(I).LT.-1.0D-07*&
          YLDIN(MP)) THEN
        IF (PRESS(I).LT.-1.0D-03*YLDIN(MP)) THEN !Pressure is negative and s33 is positive
           ITYPE(I)=-1
        ELSEIF (PRESS(I).GT.1.0D-03*YLDIN(MP)) THEN !Pressure is positive and s33 is negative
           ITYPE(I)=1
        ENDIF
     ENDIF

     ! If ITYPE(I)=0 -> P and S33 are very closed

     HYDIN=STMAT(JPT+1)+STMAT(JPT+2)+STMAT(JPT+4)
     IF(IANIS.EQ.0) THEN
        VMM=1.5D0*(STMAT(JPT+1)*STMAT(JPT+1)+STMAT(JPT+2)*STMAT(JPT+2)&
             +STMAT(JPT+3)*STMAT(JPT+3)*2.0d0+STMAT(JPT+4)*STMAT(JPT+4)-&
             HYDIN*HYDIN/3.0D0)
     ELSE
        VMM=XH_AN*((STMAT(JPT+1)-STMAT(JPT+2))**2)&
             +XF_AN*((STMAT(JPT+2)-STMAT(JPT+4))**2)&
             +XG_AN*((STMAT(JPT+4)-STMAT(JPT+1))**2)&
             +XC_AN*(STMAT(JPT+3)**2)
     ENDIF

     ! Magnitude of the stress increment tensor

     STINC=DSQRT(STMATST(JPT+1)*STMATST(JPT+1)+STMATST(JPT+2)*&
          STMATST(JPT+2)+STMATST(JPT+3)*STMATST(JPT+3)*2.0D0+&
          STMATST(JPT+4)*STMATST(JPT+4))

     ! If the change of stress is zero
     IF (STINC.LT.1.0D-10) THEN

        ILAMCON(I)=1
        ICONV(I)=1
        ILOCAL_LC(I)=0
        DEPLSMAT(IPT)=0.0D0
        DFVOID(IPT)=0.0D0
        XLAM(I)=0.0D0
        VM_MAT(I)=VM0
        STNMATST(JPT+1)=0.0D0
        STNMATST(JPT+2)=0.0D0
        STNMATST(JPT+3)=0.0D0
        STNMATST(JPT+4)=0.0D0
        SN1(I*4-3)=0.0D0
        SN1(I*4-2)=0.0D0
        SN1(I*4-1)=0.0D0
        SN1(I*4-0)=0.0D0
        NPLINM(IPT)=NPLMAT(IPT)
     ELSE
        ILAMCON(I)=1
        ICONV(I)=1
        ILOCAL_LC(I)=0
        IF (IMATLC(IPT).LE.1) THEN
           NPLINM(IPT)=0
           DEPLSMAT(IPT)=0.0D0
           DFVOID(IPT)=0.0D0
           VM_MAT(I)=VMLC(I)
           F=FVOID(IPT)
           YM0=1.0D0/YM_EFF
           G0=(1.0D0+PR)*YM0
           PRS=STMATST(JPT+1)+STMATST(JPT+2)+STMATST(JPT+4)
           STNMATST(JPT+1)=STMATST(JPT+1)*G0-PR*YM0*PRS
           STNMATST(JPT+2)=STMATST(JPT+2)*G0-PR*YM0*PRS
           STNMATST(JPT+3)=STMATST(JPT+3)*G0
           STNMATST(JPT+4)=STMATST(JPT+4)*G0-PR*YM0*PRS
           SN1(I*4-3)=STNMATST(JPT+1)
           SN1(I*4-2)=STNMATST(JPT+2)
           SN1(I*4-1)=STNMATST(JPT+3)*2.0D0
           SN1(I*4)=STNMATST(JPT+4)
           S11=STMAT(JPT+1)+STMATST(JPT+1)*0.50D0
           S22=STMAT(JPT+2)+STMATST(JPT+2)*0.50D0
           S12=STMAT(JPT+3)+STMATST(JPT+3)*0.50D0
           S33=STMAT(JPT+4)+STMATST(JPT+4)*0.50D0
        ENDIF
     ENDIF
  enddo loop_10007
  ! End of the loop over integration points

  DEALLOCATE(ICONT1,ICONT2,ILAMCON,ICONV,ISPECIAL,ISTOP,ITYPE)

  DEALLOCATE(SLP,DFAC,PRESS,DSZZ1,DSZZ2,DSZF,DF1,DF2,DF,DEP1,DEP2&
       ,DEP,XLAM1,XLAM2,XLAM,RES1,RES2,RES,VM1,VM2,VM)
  RETURN
END SUBROUTINE UPDAT_T

!******************************************************
SUBROUTINE NORMAL_GEN(ENUCL)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  COMMON /NORMALINT/ XNORM_INT(60)
  xnorm_int(1) = 0.E0
  xnorm_int(2) = 0.4997917E-1
  xnorm_int(3) = 0.9983358E-1
  xnorm_int(4) = 0.1494394E0
  xnorm_int(5) = 0.1986746E0
  xnorm_int(6) = 0.2474201E0
  xnorm_int(7) = 0.2955601E0
  xnorm_int(8) = 0.3429836E0
  xnorm_int(9) = 0.3895845E0
  xnorm_int(10) = 0.4352629E0
  xnorm_int(11) = 0.4799252E0
  xnorm_int(12) = 0.523485E0
  xnorm_int(13) = 0.5658635E0
  xnorm_int(14) = 0.6069898E0
  xnorm_int(15) = 0.6468012E0
  xnorm_int(16) = 0.6852436E0
  xnorm_int(17) = 0.7222714E0
  xnorm_int(18) = 0.7578476E0
  xnorm_int(19) = 0.7919438E0
  xnorm_int(20) = 0.82454E0
  xnorm_int(21) = 0.8556244E0
  xnorm_int(22) = 0.8851931E0
  xnorm_int(23) = 0.9132498E0
  xnorm_int(24) = 0.9398053E0
  xnorm_int(25) = 0.9648772E0
  xnorm_int(26) = 0.9884894E0
  xnorm_int(27) = 0.1010671E1
  xnorm_int(28) = 0.1031458E1
  xnorm_int(29) = 0.1050887E1
  xnorm_int(30) = 0.1069004E1
  xnorm_int(31) = 0.1085853E1
  xnorm_int(32) = 0.1101486E1
  xnorm_int(33) = 0.1115953E1
  xnorm_int(34) = 0.1129308E1
  xnorm_int(35) = 0.1141605E1
  xnorm_int(36) = 0.1152901E1
  xnorm_int(37) = 0.116325E1
  xnorm_int(38) = 0.1172709E1
  xnorm_int(39) = 0.1181332E1
  xnorm_int(40) = 0.1189174E1
  xnorm_int(41) = 0.1196288E1
  xnorm_int(42) = 0.1202725E1
  xnorm_int(43) = 0.1208535E1
  xnorm_int(44) = 0.1213766E1
  xnorm_int(45) = 0.1218463E1
  xnorm_int(46) = 0.1222672E1
  xnorm_int(47) = 0.1226433E1
  xnorm_int(48) = 0.1229785E1
  xnorm_int(49) = 0.1232766E1
  xnorm_int(50) = 0.123541E1
  xnorm_int(51) = 0.1237749E1
  xnorm_int(52) = 0.1239813E1
  xnorm_int(53) = 0.124163E1
  xnorm_int(54) = 0.1243226E1
  xnorm_int(55) = 0.1244624E1
  xnorm_int(56) = 0.1245845E1
  xnorm_int(57) = 0.1246909E1
  xnorm_int(58) = 0.1247835E1
  xnorm_int(59) = 0.1248637E1
  xnorm_int(60) = 0.1249331E1
  loop_10295: DO I=1,60
     XNORM_INT(I)=XNORM_INT(I)*ENUCL
  enddo loop_10295
  RETURN
END SUBROUTINE NORMAL_GEN

!******************************************************
FUNCTION EFF_YM(F)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  COMMON /PROP/ YM,PR
  EFF_YM=YM
  RETURN
END FUNCTION EFF_YM

