
!********************************************************
! Subroutine for assembling the global stiffness matrix
! and residual forces. 
!********************************************************
SUBROUTINE ASMBLYMPI(NITK,SK,F,DU,NBETA,NODE,NBC1,NLOAD,&
     IJK,IJK1,IJK2,NINT,VBC1,VLOAD,X,Y,NDF,JDIAG)
!********************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (ALPHA=0.E0)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NLM_SOFT=40000)
  PARAMETER (NUMSKIO=NLM*200000)
  PARAMETER (NUMHG=NLM*10000)
  DIMENSION SK(1),F(1),VBC1(1),VLOAD(2,1),NODE(NLM),NBETA(NLM)&
       ,JDIAG(1),DU(1),NBC1(3000),IJK(NLM,1),X(1)&
       ,Y(1),IJK2(NLM,1),NLOAD(1),NINT(NLM,2),IJK1(NLM,1)

  DIMENSION NELIROW(NSDMAX),NELJROW(NSDMAX),LDONE(NDFM)
  DIMENSION DUTOT(NDFELM),FRES(NDFELM*2),X1(NDFELM)&
       ,Y1(NDFELM),DULC(NDFELM),F1(NDFM),FIN1(NDFM)&
       ,FRES_tmp(NDFELM*2),DIST(NDFM),TMPI1(NLM)
  INTEGER, ALLOCATABLE :: ipt_failn_tmp(:),IPT_FAIL_tmp(:),IMATLC_tmp(:),&
       IFAIL_tmp(:)

  DOUBLE PRECISION, ALLOCATABLE :: S_STMATST_tmp(:)&
       ,S_STNMATST_tmp(:),VM_FAILIPT_tmp(:),EPL_FAILIPT_tmp(:)&
       ,DFVOID_S_tmp(:),DEPLSMAT_S_tmp(:),SKE(:,:),SK1(:),&
       VM_LOC_tmp(:),EPLS_LOC_tmp(:),FVOID_LOC_tmp(:)

  COMMON /TVGSTIFF/ SKTVG(NDFM,20),SKTVGT(NDFM,20),FTVG(NDFM),ITVG
  COMMON /UNROTATEDDISP/ DUTEMP(NDFM)
  COMMON /DISPSHIFT/ ISOFTEL(NLM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /MATPR/ YM1,YM2,PR1,PR2
  COMMON /TOTDIS/ DISTOT(NDFM)
  COMMON /ELEPROP/ PROMAT(16,10),MPE(NLM),MPG(NLM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON/BOUNDA/NBOUD1,NBOUD2,NBOUD3,NUPNCH
  COMMON /COMELE/ NTOT,NFIX(1500)
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON /STEPNUM/ IST
  COMMON /LOCALDOF/ IPOINT(NDFELM),NDF_CELL,NDF_INC,&
       NDF_CRCK,NADAPT_CELL,NADAPT_INC,NADAPT_CRCK
  COMMON /SYMNODE/ ICMN(NDFELM)
  COMMON /ADAPTATIONS/ ANGLE_ADAPT_X(NLM,200,2),ANGLE_ADAPT_Y&
       (NLM,200,2),NX_ADAPT_NX(NODM),NX_NX_ADAPT(NODM),NUM_ADAPT_X&
       (NLM,200),NUM_ADAPT_Y(NLM,200),IJK_ADAPT_X(NLM,200,2),&
       IJK_ADAPT_Y(NLM,200,2),nx_adapt
  COMMON /ADAPTOPTML/ IDIR_OPTIMIZE(NLM,200),ANGLE_OPTIMIZE(NLM,200),&
       TRAC_NORM(NLM,200,2),TRAC_FRAC_CELL_ADPX(NLM,200,2),&
       TRAC_FRAC_CELL_ADPY(NLM,200,2)
  COMMON /MACSTN/ NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)  
  COMMON /OUTPLANE/ EZZ_APP1
  COMMON /BOUNDCURVE/ ABD_CRV,BBD_CRV,ANBD_CRV,&
       XBD_CRV,YBD_CRV,IBD_CRV
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /HPADAPTINC/ COORD_HP_INC(NLM*NSDMAX*3),INT_HP_INC&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_INC(NSMAX)
  COMMON /RIGBOD/ JPOINT_RIG(NDFELM)
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /POLLSTF/ NIT_POL
  COMMON /FRHSN/ FIN(NDFM)
  COMMON /INOUT/ SKIO(NUMSKIO),NP_SKIO(NLM,4)
  COMMON /GEOM/ XMTRL(NDFM)
  COMMON/NUCLEA/VONUFN,VONUS,VONUEN,VONUTN,SPECA,SPECB,INUCL
  common/coalesc/fsubc,fsubf,fsubu,facvoid
  common/hoonmt/stsn1(100,2),npts1
  COMMON /CONSTMT1/ NPTS(10),STSN(10,100,2)
  COMMON/STRLOC/VOQ1,VOQ2,VOQ3
  COMMON /VOIDPARAM/ Q1,Q2,Q3,FCOL,FMAX,FMAX_MODEL
  COMMON /PLNST/ KPLS
  COMMON /PROP/ YM,PR
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),&
       INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /NELSID/ NELS_IN_NEL(NLM_SOFT)
  COMMON /BOUNDARYDISP/ IDOSOFT(NDFELM),DD(NDFELM)
  COMMON /FSTBND/ IFST(NLM,NODPER+1,2),VFST(NLM,NODPER+1,2)
  COMMON /HOURGLASS/ IHGLASS(NLM,NDELM),PHI_HGLASS(NUMHG),&
       NP_HGLASS(NLM,4),IHGNEL(NLM)
  COMMON/TVGPARAM/ RHOF_TVG(NDFM),IDOF_TVG(20),IFORCE_TVG(NDFM,2)
  common /plsintsubst/ ksubst
  COMMON /CRACKSOFTBOUND/ NDCRK_ADD(NLM),NDFCRK_ADD(NLM,NDELM)
  COMMON /ARCLPARAM/ ALPH,DALPH,DUTEMPARC(NDFM),DUARC(NDFM),DUIN(NDFM),DUIN1(NDFM),DLTOT,IARCL
  COMMON /BETAGL/ BETTOT(MAXH*NLM),BETST(MAXH*NLM),&
       BETLC(MAXH*NLM)
  COMMON /INSTT/ NPLINM(NLM*INTM),NPLINC(NLM*INTC)
  COMMON /PLLC/ NPLCM(NLM*INTM),NPLCC(NLM*INTC)
  COMMON /PLC/ PMATLC(2*INTM*3*NBM)
  COMMON /PLM/ PCOMLC(INTC*3*NBM)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /EPSCOM/ STNCOM(NLM*INTC*4),STNCOMST(NLM*INTC*4)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /PROPTRANS/ EZ_MAT(NBM,NLM),EZ_COM(NBM,NLM)
  COMMON /CONMPDATAM/ FGM(NLM*INTM),DFDXGM(NLM*INTM),DFDYGM&
       (NLM*INTM),DFDXXGM(NLM*INTM),DFDXYGM(NLM*INTM),DFDYYGM&
       (NLM*INTM)
  COMMON /CONMPDATAMC/ FGMC(NLM*INTM),DFDXGMC(NLM*INTM),DFDYGMC&
       (NLM*INTM),DFDXXGMC(NLM*INTM),DFDXYGMC(NLM*INTM),DFDYYGMC&
       (NLM*INTM)
  COMMON /VOIDDATA/ FVOID(INTM*NLM),DFVOID(INTM*NLM)

  COMMON /MATLOC/ VM_LOC(NLM*INTM),EPLS_LOC(NLM*INTM),&
       FVOID_LOC(NLM*INTM),IMATLC(NLM*INTM),IFAIL(NLM*INTM)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /SOFTPOINTER/ INEW_SOFT,ISOFT_TOT,IEL_SOFT(NLM)
  COMMON /BETACONST/ IBET_TOT(NLM),IBET_CON(NBM,NLM)

  COMMON /INTBEGNSOFT/ NPBG_SOFT(NLM_SOFT),NINTM_SOFT(NLM_SOFT)
  COMMON /SOFTSTR/ S_STMAT(NLM_SOFT*9*4),S_STMATST(NLM_SOFT*9*4)
  COMMON /SOFTSTN/ S_STNMAT(NLM_SOFT*9*4),S_STNMATST(NLM_SOFT*9*4)

  COMMON /DISPNEL/ NELDISP_IN_NEL(NLM), NO_NELDISP(NLM_SOFT,NLM)
  common /IPTFAILDAT/ IPT_FAIL(NLM_SOFT*9),VM_FAILIPT(NLM_SOFT*9),EPL_FAILIPT(NLM_SOFT*9)
  common /iptfaillc/ ipt_failn(nlm_soft*9)

  COMMON /VOIDDATAS/ FVOID_S(NLM_SOFT*9),DFVOID_S(NLM_SOFT*9)
  COMMON /PLPMATS/ VMMAT_S(NLM_SOFT*9),EPLSMAT_S(NLM_SOFT*9)&
       ,DEPLSMAT_S(NLM_SOFT*9),NPLMAT_S(NLM_SOFT*9)
  COMMON /DECOMP/ IPARALLEL
  COMMON /DISPDUFLAG/ IDISP_DU
  COMMON /TIMESTEP/ Time_step,NTot_step
  COMMON /ADPTMESH/ NELS_ADP,IADPT_MESH_NEL(NLM_SOFT), NELS_SUB(NLM_SOFT,4)
  COMMON /WLTBASEC/ DPOSW(NLM*NBM,2),NPBG_WLT(NLM),SSIGXG(NLM*NBM),SSIGYG(NLM*NBM),IWORP(NLM),IBET_WLTC(NBM,NLM)
  COMMON /WLTBASEM/ DPOSWM(NLM*NBM,2),NPBG_WLTM(NLM),SSIGXGM(NLM*NBM),SSIGYGM(NLM*NBM),IBET_WLTM(NBM,NLM)
  COMMON /DAMELEM/ XDAMG(NLM),YDAMG(NLM),ORDAMG(NLM),IDAMG(NLM)
  COMMON /MPITIME/ TMPI(NLM),NELALLOC(100,2)
  COMMON /FINDOT/ DOTIN,DOTIN1
  COMMON /TITLENAME/ title,title1
  COMMON /FRESMAX/ FRES_MAX
  COMMON /TIME/ DT_TOTAL,DT_STEP,DTIME,DTIME1

  CHARACTER*60 title,title1
  dimension BETLC_tmp(MAXH*NLM)
  CHARACTER*60 outfile_name
  DIMENSION TEST(80)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NUMMPI,IERR)
9999 NUM_ACOUNT=NPBG(NELX)+NINTM(NELX)

!**************************Initialise Variables**************************

  ALLOCATE(ipt_failn_tmp(nlm_soft1*9),IPT_FAIL_tmp(NLM_SOFT1*9),&
       IMATLC_tmp(NUM_ACOUNT),IFAIL_tmp(NUM_ACOUNT))
  NELIROW=0
  NELJROW=0
  ipt_failn_tmp=0
  IPT_FAIL_tmp=0
  IMATLC_tmp=0
  IFAIL_tmp=0
  LDONE=0
  DOTIN1=0.D0
  NLM_SOFT1=1
  ALLOCATE(S_STMATST_tmp(NLM_SOFT1*9*4),S_STNMATST_tmp(NLM_SOFT1*9*4),&
       VM_FAILIPT_tmp(NLM_SOFT1*9),EPL_FAILIPT_tmp(NLM_SOFT1*9),&
       DFVOID_S_tmp(NLM_SOFT1*9),DEPLSMAT_S_tmp(NLM_SOFT1*9),&
       SK1(JDIAG(NEQ1)),VM_LOC_tmp(NUM_ACOUNT),EPLS_LOC_tmp(NUM_ACOUNT),&
       FVOID_LOC_tmp(NUM_ACOUNT))
  FRES_tmp=0.D0
  S_STMATST_tmp=0.D0
  S_STNMATST_tmp=0.D0
  VM_FAILIPT_tmp=0.D0
  EPL_FAILIPT_tmp=0.D0
  DFVOID_S_tmp=0.D0
  DEPLSMAT_S_tmp=0.D0
  VM_LOC_tmp=0.D0
  EPLS_LOC_tmp=0.D0
  FVOID_LOC_tmp=0.D0
  DIST=0.D0
  TMPI1=0.D0
  IF(JDIAG(NEQ1).GT.ISKM) THEN
     WRITE(*,*) "ISKM (=",ISKM,") is too small, increase it to", JDIAG(NEQ1)
  ENDIF
  IF (NITK.EQ.-2) THEN
     NIT=-1
     NIT_POL=1
  ELSE
     NIT=NITK
     NIT_POL=0
  ENDIF
  ksubst=1
  IWRITE=0
  FRES=0.
  IF(NIT.NE.2) THEN
     SKIO=0.D0
  ENDIF

  IF (NITK.NE.-1) THEN
     CALL EXCHN (DU,DUTEMP,NEQ2)
     loop_10000: DO NEL=1,NELX
        NEL_BEG=(NEL-1)*(3*NSDMAX+2)
        loop_10001: DO J=1,INT_HP_INC(NEL_BEG+1)
           DULC(J)=DU(INT_HP_INC(NEL_BEG+J*3))
        enddo loop_10001
        loop_10002: DO J=1,INT_HP_INC(NEL_BEG+1)
           NDD=INT_HP_INC(NEL_BEG+J*3)
           DUTEMP(NDD)=0.D0
           IF(IHGNEL(NEL).EQ.1) THEN
              loop_10003: DO K=1,INT_HP_INC(NEL_BEG+1)
                 DUTEMP(NDD)=DUTEMP(NDD)+PHI_HGLASS(NP_HGLASS(NEL,1)+(J-1)*NP_HGLASS(NEL,4)+K)*DULC(K)
              enddo loop_10003
           ELSE
              DUTEMP(NDD)=DUTEMP(NDD)+DULC(J)
           ENDIF
        enddo loop_10002
     enddo loop_10000
  ELSE
  ENDIF

  EZZ_APP=MIN(ALPH*EZZ_APP1,EZZ_APP1)
  DTIME=MIN(ALPH*DTIME1,DTIME1)
  VOQ1=Q1*0.5D0
  VOQ2=Q2*2.D0
  VOQ3=VOQ1*VOQ1
  INUCL=1
  SPECA=0.D0
  SPECB=0.D0

  IT1=1
  IT2=1
  loop_61: DO I=1,JDIAG(NEQ1)
     IF (I.LE.NEQ2) THEN
        F(I)=0.E0
        F1(I)=0.D0
        DUARC(I)=0.E0
        FIN(I)=0.E0
        FIN1(I)=0.D0
     ENDIF
     IF (NIT.NE.2) THEN
        SK(I)=0.E0
        SK1(I)=0.E0
     ENDIF
  enddo loop_61
  loop_62: DO I=NEQ1,NEQ2
     F(I)=0.E0
     F1(I)=0.E0
     DUARC(I)=0.D0
     FIN(I)=0.E0
     FIN1(I)=0.E0
  enddo loop_62

  IF(MYMPI.EQ.0) THEN
     loop_10004: DO NEL=1,NELX
        NEL_BEG=(NEL-1)*(3*NSDMAX+2)
        loop_10005: DO J=1,INT_HP_INC(NEL_BEG+1)
           DIST(INT_HP_INC(NEL_BEG+J*3))=DUTEMP(INT_HP_INC(NEL_BEG+J*3))
           LDONE(INT_HP_INC(NEL_BEG+J*3))=1
        enddo loop_10005
        loop_10006: DO J=1,NINT(NEL,2)
           ND=IJK2(NEL,J)
           ND1=NDGLB(ND*2-1)
           ND2=NDGLB(ND*2)
           DIST(ND1)=DUTEMP(ND1)
           DIST(ND2)=DUTEMP(ND2)
           LDONE(ND1)=1
           LDONE(ND2)=1
        enddo loop_10006
     enddo loop_10004
     loop_10007: DO ND=1,NX
        ND1=(ND-1)*2+1
        ND2=ND*2
        NDF1=NDGLB(ND1)
        NDF2=NDGLB(ND2)
        IF (LDONE(NDF1).EQ.0) THEN
           LDONE(NDF1)=1
           DIST(NDF1)=DU(NDF1)
        endif
        IF (LDONE(NDF2).EQ.0) THEN
           LDONE(NDF2)=1
           DIST(NDF2)=DU(NDF2)
        ENDIF
     enddo loop_10007
     open(986,file='vcfem_du.dat')
     open(987,file='disp_du.dat')
     IDISP_DU=1       
     loop_10008: DO NEL=1,NELX
        NEL_BEG=(NEL-1)*(NSDMAX*3+2)
        NDF_CELL1=INT_HP_CELL(NEL_BEG+2)
        loop_10009: DO ND=1,NDF_CELL1/2
           ND1=(ND-1)*2+1
           ND2=ND*2
           ND11=INT_HP_CELL(NEL_BEG+ND1*3)
           ND21=INT_HP_CELL(NEL_BEG+(ND1+1)*3)
           IF((INT_HP_CELL(NEL_BEG+2+ND1*3).EQ.1.OR.&
                INT_HP_CELL(NEL_BEG+2+ND1*3).EQ.2).OR.&
                (INT_HP_CELL(NEL_BEG+2+ND1*3-1).EQ.-1.OR.&
                INT_HP_CELL(NEL_BEG+2+ND1*3-1).EQ.-1)) THEN 
              DU_1=DIST(ND11)
              DU_2=DIST(ND21)
              write(986,*) DU_1,DU_2
           ENDIF
        enddo loop_10009
        NDF_INC=INT_HP_INC(NEL_BEG+1)
        loop_10010: DO ND=1,NDF_INC/2
           ND1=(ND-1)*2+1
           ND2=ND*2
           IF((INT_HP_INC(NEL_BEG+2+ND1*3).EQ.1.OR.&
                INT_HP_INC(NEL_BEG+2+ND1*3).EQ.2).OR.&
                (INT_HP_INC(NEL_BEG+2+ND1*3-1).EQ.-1.OR.&
                INT_HP_INC(NEL_BEG+2+ND1*3-1).EQ.-1)) THEN 
              ND11=INT_HP_INC(NEL_BEG+ND1*3)
              ND21=INT_HP_INC(NEL_BEG+(ND1+1)*3)
              DU_1=DIST(ND11)
              DU_2=DIST(ND21)
              write(986,*) DU_1,DU_2
           ENDIF
        enddo loop_10010
        loop_10011: DO J=1,NINT(NEL,2)
           ND=IJK2(NEL,J)
           ND1=NDGLB(ND*2-1)
           ND2=NDGLB(ND*2)
           DU_1=DIST(ND1)
           DU_2=DIST(ND2)
           write(986,*) DU_1,DU_2
        enddo loop_10011
        loop_10012: DO ND=1,NODE(NEL)
           ND1=IJK(NEL,ND)*2-1
           ND2=IJK(NEL,ND)*2
           write(986,*) DISTOT(ND1),DISTOT(ND2)
        enddo loop_10012
        loop_10013: DO ND=1,NINT(NEL,1)
           ND1=IJK1(NEL,ND)*2-1
           ND2=IJK1(NEL,ND)*2
           write(986,*) DISTOT(ND1),DISTOT(ND2)
        enddo loop_10013
        loop_10014: DO ND=1,NINT(NEL,2)
           ND1=IJK2(NEL,ND)*2-1
           ND2=IJK2(NEL,ND)*2
           write(986,*) DISTOT(ND1),DISTOT(ND2)
        enddo loop_10014
     enddo loop_10008
     rewind(986)
     close(986)
     rewind(987)
     close(987)
     IDISP_DU=0
  ENDIF
  IDISP_DU=1       

  CALL ALLOCATE_NEL(NUMMPI,NELX)

  IF(MYMPI.EQ.1.AND.NUMMPI.GT.1) THEN
     OPEN(165,file="Allocate_NELS.dat")
     write(165,*) "ID,  StartNEL, EndNEL"
     DO I=1,NUMMPI
        write(165,*) I, NELALLOC(I,1),NELALLOC(I,2)
     ENDDO
     close(165)
  ENDIF

  NELSTART=NELALLOC(MYMPI+1,1)
  NELEND=NELALLOC(MYMPI+1,2)

!**************For Each Element************************************

  loop_50: DO NEL=NELSTART,NELEND
     IF(NIT.NE.2.AND.NUMMPI.GT.1) THEN
        call walltime(STSEC,STMSEC)
     ENDIF
     PROMAT(6,1)=0.D0

!*************Initialize co-ordinates and displacements************

     NUMNOD=NODE(NEL)
     NUMNOD1=NINT(NEL,1)
     NUMNOD2=NINT(NEL,2)
     NEL_BEG=(NEL-1)*(NSDMAX*3+2)
     KEL_BEG=(NEL-1)*NSDMAX*3
     NDF_CELL=INT_HP_CELL(NEL_BEG+1)
     NDF_INC=INT_HP_INC(NEL_BEG+1)
     NDF_CRCK=NUMNOD2*2+ndcrk_add(nel)

     NDF_TOT=NDF_CELL+NDF_INC+NDF_CRCK+6
     ALLOCATE(SKE(NDF_TOT,NDF_TOT))
     SKE=0.D0
     CALL PGLB(NEL,IT1,IT2,NBETA)
     YM1=PROMAT(1,MPE(NEL))
     YM2=PROMAT(1,MPG(NEL))
     PR1=PROMAT(2,MPE(NEL))
     PR2=PROMAT(2,MPG(NEL))         

     NADAPT_INC=0
     NADAPT_CRCK=0
     NEL_BEG=(NEL-1)*(NSDMAX*3+2)
     KEL_BEG=(NEL-1)*NSDMAX*3
     NDF_CELL=INT_HP_CELL(NEL_BEG+1)
     NDF_CELL1=INT_HP_CELL(NEL_BEG+2)
     NADAPT_CELL=NDF_CELL-NUMNOD*2
     IND=0

     loop_10015: DO I=1,NDF_CELL
        IPOINT(I)=INT_HP_CELL(NEL_BEG+2+I*3-2)
        IDOSOFT(I)=0
        IF (IFST(NEL,NDF_CELL+1,1).NE.0.AND.IFST(NEL,I,1).EQ.1) THEN
           IDOSOFT(I)=1
           DD(I)=VFST(NEL,I,1)-DU(IPOINT(I))
        ENDIF
        IF (INT_HP_CELL(NEL_BEG+2+I*3).EQ.1) THEN
           IND=IND+1
           JPOINT_RIG(IND)=I
        ENDIF
        ICMN(I)=I
        DUTOT(I)=DU(IPOINT(I))
        DULC(I)=DUTOT(I)
     enddo loop_10015
     loop_12: DO I=1,NUMNOD
        ND=IJK(NEL,I)
        ND1=NDGLB(ND*2-1)
        ND2=NDGLB(ND*2)
        X1(I)=X(ND)+DU(ND1)*ALPHA
        Y1(I)=Y(ND)+DU(ND2)*ALPHA
     enddo loop_12
     NDF_INC=INT_HP_INC(NEL_BEG+1)
     NDF_INC1=INT_HP_INC(NEL_BEG+2)
     NDF_CRCK=NUMNOD2*2+ndcrk_add(nel)
     NX2=NDF_CELL     
     IND=0
     loop_10016: DO I=1,NDF_INC
        IPOINT(I+NX2)=INT_HP_INC(NEL_BEG+I*3)
        IDOSOFT(I+NDF_CELL)=0
        IF (IHGLASS(NEL,NDF_INC+1).EQ.1.AND.(IHGLASS(NEL,I).EQ.1.OR.&
             I.GT.NDF_INC-3)) THEN
           IDOSOFT(I+NDF_CELL)=0
           DD(I+NDF_CELL)=0.D0
        ENDIF
        IF (INT_HP_INC(NEL_BEG+2+I*3).EQ.1) THEN
           IND=IND+1
           JPOINT_RIG(IND+NUMNOD)=I+NDF_CELL
        ENDIF
        ICMN(NX2+I)=I+NX2
        DUTOT(I+NX2)=DUTEMP(IPOINT(I+NX2))
     enddo loop_10016
     loop_13: DO I=1,NUMNOD1
        ND=IJK1(NEL,I)
        ND1=NDGLB(ND*2-1)
        ND2=NDGLB(ND*2)
        X1(I+NUMNOD+NADAPT_CELL)=X(ND)+DU(ND1)*ALPHA
        Y1(I+NUMNOD+NADAPT_CELL)=Y(ND)+DU(ND2)*ALPHA
     enddo loop_13
     NX2=NX2+NDF_INC
     loop_31: DO I=1,6
        NPT=NEQ+(NEL-1)*6+I
        DUTOT(NX2+NDF_CRCK+I)=DUTEMP(NPT)
        IK=NX2+NDF_CRCK+I
        ICMN(IK)=IK
     enddo loop_31
     NX3=NX2
     loop_32: DO I=1,NUMNOD2
        ND=IJK2(NEL,I)
        ND1=NDGLB(ND*2-1)
        ND2=NDGLB(ND*2)
        IK=I+NUMNOD+NADAPT_CELL+NUMNOD1+NADAPT_INC
        X1(IK)=X(ND)+DU(ND1)*ALPHA
        Y1(IK)=Y(ND)+DU(ND2)*ALPHA
        DUTOT(NX3+I*2-1)=DUTEMP(ND1)
        DUTOT(NX3+I*2)=DUTEMP(ND2)
        ICMN(NX3+I*2-1)=NX3+I*2-1
        ICMN(NX3+I*2)=NX3+I*2
        IPOINT(NX3+I*2-1)=ND1
        IPOINT(NX3+I*2)=ND2
        loop_10017: DO J=1,NDF_INC
           ND=INT_HP_INC(NEL_BEG+J*3)
           IF (ND1.EQ.ND) THEN
              JK=NDF_CELL
              ICMN(NX3+I*2-1)=ICMN(JK+J)
              ICMN(NX3+I*2)=ICMN(JK+J+1)
           ENDIF
        enddo loop_10017
     enddo loop_32
     NB=NBETA(NEL)+NB_ADP_MAT(NEL)
     YM=YM1
     PR=PR1
     mp=mpe(nel)
     ENUCL=PROMAT(6,MP)/DSQRT(DATAN(1.D0)*8.D0)
     CALL NORMAL_GEN(ENUCL)
     IF (KSUBST.EQ.1) THEN
        IPARALLEL=1

!***************Assemble element Stiffness and residual forces for given displacements*************

        CALL ESTIFO(NIT,NEL,NB,NUMNOD,NUMNOD1,NUMNOD2,IJK,X1,Y1,SKE,&
             FRES,DUTOT,MPE(NEL),MPG(NEL),NDF_TOT)
        IPARALLEL=0
        IF(NIT.NE.2) THEN
           DO INDF=1,NDF_TOT
              IF(SUM(SKE(:,INDF)).NE.SUM(SKE(:,INDF))) THEN
                 write(*,*) "SKE=",SUM(SKE(:,INDF))
                 IDEBUG=1
                 DO WHILE(IDEBUG.EQ.1)
                    IDEBUG=1
                 ENDDO
              ENDIF
           ENDDO
        ENDIF
        IF(SUM(FRES).NE.SUM(FRES)) THEN
           write(*,*) "FRES=",SUM(FRES)
           IDEBUG=1
           DO WHILE(IDEBUG.EQ.1)
              IDEBUG=1
           ENDDO
        ENDIF
     ENDIF
     IF (NIT.NE.2) THEN
        IF(NEL.EQ.NELSTART) THEN
           NP_SKIO(NEL,1)=0
           NP_SKIO(NEL,3)=NDF_INC+NDF_CRCK+6+6
           NP_SKIO(NEL,4)=NDF_CELL+NDF_INC+NDF_CRCK+6+6
           NP_SKIO(NEL,2)=NP_SKIO(NEL,3)*NP_SKIO(NEL,4)
        ELSE
           NP_SKIO(NEL,1)=NP_SKIO(NEL-1,1)+NP_SKIO(NEL-1,2)
           NP_SKIO(NEL,3)=NDF_INC+NDF_CRCK+6+6
           NP_SKIO(NEL,4)=NDF_CELL+NDF_INC+NDF_CRCK+6+6
           NP_SKIO(NEL,2)=NP_SKIO(NEL,3)*NP_SKIO(NEL,4)
        ENDIF
        NUM_ACOUNT=NP_SKIO(NEL,1)+NP_SKIO(NEL,2)
        IF(NUM_ACOUNT.GT.NUMSKIO) THEN
           WRITE(*,*) "The dimension of SKIO is not enough."
           WRITE(*,*) "Increase it to",NUM_ACOUNT, NEL
        ENDIF

        loop_112: DO I=1,NDF_INC+NDF_CRCK+6
           I1=I+6
           IF (I.GT.NDF_INC+NDF_CRCK) I1=I-NDF_INC-NDF_CRCK
           loop_111: DO J=1,NDF_INC+NDF_CRCK+6
              J1=J+6
              IF (J.GT.NDF_INC+NDF_CRCK) J1=J-NDF_INC-NDF_CRCK
              SKIO(NP_SKIO(NEL,1)+(I1-1)*NP_SKIO(NEL,4)+J1)=SKE(I+NDF_CELL,J+NDF_CELL)
           enddo loop_111
           loop_110: DO J=1,NDF_CELL
              SKIO(NP_SKIO(NEL,1)+(I1-1)*NP_SKIO(NEL,4)+J+NDF_INC+NDF_CRCK+6)=SKE(I+NDF_CELL,J)
           enddo loop_110
        enddo loop_112
     ENDIF


623  FORMAT ('ske(',I3,',',I3,')=',E25.12,';')
624  FORMAT ('f(',I3,')=',E25.12,';')
625  FORMAT ('ido(',I3,')=',I3,';')
626  FORMAT ('dd(',I3,')=',E25.12,';')
     JTOT=0

!**************ASSEMBLING GLOBAL STIFFNESS*************************

     NDF_TOT=NDF_CELL+NDF_INC+NDF_CRCK+6
     loop_4: DO IJ=1,NDF_CELL
        I=(IJ-1)/2+1
        J=IJ-(I-1)*2
        IJ1=IPOINT(IJ)
        F1(IJ1)=F1(IJ1)-FRES(IJ)
        FIN1(IJ1)=FIN1(IJ1)-FRES(IJ+NDF_TOT)
        IF (NIT.EQ.2) cycle loop_4
        loop_5: DO KL=1,NDF_CELL
           K=(KL-1)/2+1
           L=KL-(K-1)*2               
           KL1=IPOINT(KL)
           IF (KL1.LT.IJ1) cycle loop_5
           JPT=JDIAG(KL1)-(KL1-IJ1)
           JTOT=JTOT+1
           SK1(JPT)=SK1(JPT)+SKE(IJ,KL)
        enddo loop_5
     enddo loop_4
     loop_51: DO IJ=NDF_CELL+1,NDF_CELL+NDF_INC+NDF_CRCK
        IJ1=IPOINT(IJ)
        F1(IJ1)=F1(IJ1)-FRES(IJ)
        FIN1(IJ1)=FIN1(IJ1)-FRES(IJ+NDF_TOT)
        IF (IJ.EQ.NDF_CELL+NDF_INC+NDF_CRCK) THEN
           loop_53: DO J=1,6
              IJ_RIG=NDF_CELL+NDF_INC+NDF_CRCK+J
              IJ1=NEQ+(NEL-1)*6+J
              F1(IJ1)=F1(IJ1)-FRES(IJ_RIG)
              FIN1(IJ1)=FIN1(IJ1)-FRES(IJ_RIG+NDF_TOT)
           enddo loop_53
        ENDIF
     enddo loop_51
     IF(NIT.NE.2.AND.NUMMPI.GT.1) THEN
        call walltime(ENDSEC,ENDMSEC)
        TOT_time=(ENDSEC-STSEC)+(ENDMSEC-STMSEC)*1.D-06
        TOT_time=TOT_time/60.D0
        TMPI1(NEL)=TOT_time
     ENDIF
     DEALLOCATE(SKE)
  enddo loop_50
  IF(NUMMPI.GT.1) THEN
     IF(NIT.NE.2) THEN
        TMPI=0.D0
        CALL MPI_ALLREDUCE(TMPI1,TMPI,NELX,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,IERR)
     ENDIF
     DOTIN_tmp=0.D0
     CALL MPI_ALLREDUCE(DOTIN1,DOTIN_tmp,1,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,IERR)
     DOTIN1=DOTIN_tmp
  ENDIF
  DOTIN=DOTIN+DOTIN1
  IDISP_DU=0
  IF(NUMMPI.GT.1) THEN
     CALL MPI_ALLREDUCE(KSUBST,KSUBST_tot,1,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,IERR)
     IF(KSUBST_tot.NE.NUMMPI) THEN
        KSUBST=0
     ENDIF
  ENDIF
  IF(NIT.NE.2.AND.NUMMPI.GT.1) THEN  
     loop_10020: DO I=1,NUMMPI
        NELS=NELALLOC(I,1)
        NELE=NELALLOC(I,2)
        IF(I.GT.1) THEN
           loop_10021: DO IN=NELS,NELE
              NP_SKIO(IN,1)=NP_SKIO(IN-1,1)+NP_SKIO(IN-1,2)
           enddo loop_10021
        ENDIF
        CALL MPI_BCAST(NP_SKIO(NELS,1),NELE-NELS+1,MPI_INTEGER,I-1,MPI_COMM_WORLD,IERR)
        CALL MPI_BCAST(NP_SKIO(NELS,2),NELE-NELS+1,MPI_INTEGER,I-1,MPI_COMM_WORLD,IERR)
        CALL MPI_BCAST(NP_SKIO(NELS,3),NELE-NELS+1,MPI_INTEGER,I-1,MPI_COMM_WORLD,IERR)
        CALL MPI_BCAST(NP_SKIO(NELS,4),NELE-NELS+1,MPI_INTEGER,I-1,MPI_COMM_WORLD,IERR)
        IF(I.GT.1.AND.MYMPI.EQ.I-1) THEN
           NUM_ACOUNT=NP_SKIO(NELE,1)+NP_SKIO(NELE,2)-NP_SKIO(NELS,1)
           loop_10022: DO IN=NUM_ACOUNT,1,-1
              SKIO(NP_SKIO(NELS,1)+IN)=SKIO(IN)
           enddo loop_10022
        ENDIF
        call MPI_BARRIER(MPI_COMM_WORLD,IERR)
     enddo loop_10020
     call MPI_BARRIER(MPI_COMM_WORLD,IERR)
     loop_10023: DO I=1,NUMMPI
        NELS=NELALLOC(I,1)
        NELE=NELALLOC(I,2)
        loop_10024: DO IN=NELS,NELE
           CALL MPI_BCAST(SKIO(NP_SKIO(IN,1)+1),NP_SKIO(IN,2),MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
        enddo loop_10024
     enddo loop_10023

  ENDIF

  IF(NUMMPI.GT.1) THEN
     CALL MPI_ALLREDUCE(F1,F,NEQ2,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,IERR)
     CALL MPI_ALLREDUCE(FIN1,FIN,NEQ2,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,IERR)
     IF(NIT.NE.2) THEN
        NUN_ACOUNT=JDIAG(NEQ1)
        IF(NUN_ACOUNT.GT.1.5*5000000) THEN
           NUMT=NUN_ACOUNT/5000000+1
           NUN_ACOUNT=5000000
           DO IT=1,NUMT
              INDEX=(IT-1)*NUN_ACOUNT+1
              IF(IT.EQ.NUMT) THEN
                 NUN_ACOUNT=JDIAG(NEQ1)-INDEX
              ENDIF
              CALL MPI_ALLREDUCE(SK1(INDEX),SK(INDEX),NUN_ACOUNT,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,IERR)
           ENDDO
        ELSE
           CALL MPI_ALLREDUCE(SK1,SK,JDIAG(NEQ1),MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,IERR)
        ENDIF
     ENDIF
  ELSE
     F(1:NEQ2)=F1
     FIN(1:NEQ2)=FIN1
     SK(1:JDIAG(NEQ1))=SK1(1:JDIAG(NEQ1))
  ENDIF
  IF(NUMMPI.GT.1) THEN
     loop_10025: DO I=1,NUMMPI
        NELS=NELALLOC(I,1)
        NELE=NELALLOC(I,2)

        NUM_ACOUNT=(NELE-NELS+1)*2*NBM
        INDEX=(NELS-1)*2*NBM+1
        CALL MPI_BCAST(BETLC(INDEX),NUM_ACOUNT,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
        CALL MPI_BCAST(BETTOT(INDEX),NUM_ACOUNT,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
        CALL MPI_BCAST(BETST(INDEX),NUM_ACOUNT,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
        NUM_ACOUNT=0
        loop_10026: DO J=NELS,NELE
           NUM_ACOUNT=NUM_ACOUNT+NINTM(J)
        enddo loop_10026
        INDEX=NPBG(NELS)+1
        CALL MPI_BCAST(NPLINM(INDEX),NUM_ACOUNT,MPI_INTEGER,I-1,MPI_COMM_WORLD,IERR)
        CALL MPI_BCAST(NPLCM(INDEX),NUM_ACOUNT,MPI_INTEGER,I-1,MPI_COMM_WORLD,IERR)
        CALL MPI_BCAST(DEPLSMAT(INDEX),NUM_ACOUNT,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
        CALL MPI_BCAST(VMMAT(INDEX),NUM_ACOUNT,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
        CALL MPI_BCAST(DFVOID(INDEX),NUM_ACOUNT,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
        NUM_ACOUNT=0
        loop_10027: DO J=NELS,NELE
           NUM_ACOUNT=NUM_ACOUNT+NINTC(J)
        enddo loop_10027
        INDEX=NPBM(NELS)+1
        NUM_ACOUNT=0
        loop_10028: DO J=NELS,NELE
           NUM_ACOUNT=NUM_ACOUNT+NINTC(J)*4
        enddo loop_10028
        INDEX=NPBM(NELS)*4+1
        CALL MPI_BCAST(STCOMST(INDEX),NUM_ACOUNT,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
        CALL MPI_BCAST(STNCOMST(INDEX),NUM_ACOUNT,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
        NUM_ACOUNT=0
        loop_10029: DO J=NELS,NELE
           NUM_ACOUNT=NUM_ACOUNT+NINTM(J)*4
        enddo loop_10029
        INDEX=NPBG(NELS)*4+1
        CALL MPI_BCAST(STMATST(INDEX),NUM_ACOUNT,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
        CALL MPI_BCAST(STNMATST(INDEX),NUM_ACOUNT,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)

        loop_10030: DO J=NELS,NELE
           CALL MPI_BCAST(EZ_MAT(1,J),NBM,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
           CALL MPI_BCAST(EZ_COM(1,J),NBM,MPI_DOUBLE_PRECISION,I-1,MPI_COMM_WORLD,IERR)
        enddo loop_10030

        loop_10031: DO J=NELS,NELE
           CALL MPI_BCAST(NELDISP_IN_NEL(J),NELX+1,MPI_INTEGER,I-1,MPI_COMM_WORLD,IERR)
           NUM_ACOUNT_S=NELDISP_IN_NEL(J)
           CALL MPI_BCAST(NO_NELDISP(1,J),NUM_ACOUNT_S,MPI_INTEGER,I-1,MPI_COMM_WORLD,IERR)
        enddo loop_10031
     enddo loop_10025
  ENDIF

  IMATLC_tmp=0.D0
  VM_LOC_tmp=0.D0
  EPLS_LOC_tmp=0.D0
  FVOID_LOC_tmp=0.D0
  IFAIL_tmp=0.D0
  NPT_S=NPBG(NELSTART)+1
  loop_10032: DO II=NELSTART,NELEND
     loop_10033: DO JJ=1,NINTM(II)
        NPT=NPBG(II)+JJ
        IMATLC_tmp(NPT)=IMATLC(NPT)
        VM_LOC_tmp(NPT)=VM_LOC(NPT)
        EPLS_LOC_tmp(NPT)=EPLS_LOC(NPT)
        FVOID_LOC_tmp(NPT)=FVOID_LOC(NPT)
        IFAIL_tmp(NPT)=IFAIL(NPT)
     enddo loop_10033
  enddo loop_10032
  IF(NUMMPI.GT.1) THEN
     NUM_ACOUNT=NPBG(NELX)+NINTM(NELX)
     CALL MPI_ALLREDUCE(IMATLC_tmp,IMATLC,NUM_ACOUNT,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,IERR)
     CALL MPI_ALLREDUCE(VM_LOC_tmp,VM_LOC,NUM_ACOUNT,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,IERR)
     CALL MPI_ALLREDUCE(EPLS_LOC_tmp,EPLS_LOC,NUM_ACOUNT,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,IERR)
     CALL MPI_ALLREDUCE(FVOID_LOC_tmp,FVOID_LOC,NUM_ACOUNT,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,IERR)
     CALL MPI_ALLREDUCE(IFAIL_tmp,IFAIL,NUM_ACOUNT,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,IERR)
  ENDIF

!**************Apply boundary conditions***************************

  CALL BOUND2(F,NLOAD,VLOAD,2,NBOUD2)          
  IF (NIT.NE.2.AND.NITK.NE.-2) THEN
     CALL SKYINV (NIT,JDIAG,NODE,NINT,IJK,IJK1,IJK2,SK,F)
  ENDIF
1001 FORMAT (I4,2X,E12.6)
  ITVG=0
  loop_10048: DO I=1,NEQ1
     IF (IFORCE_TVG(I,1).NE.0) THEN
        ITVG=ITVG+1
        J=IFORCE_TVG(I,2)
        F(I)=F(I)-FIN(J)*RHOF_TVG(I)
        FIN(I)=FIN(I)-FIN(J)*RHOF_TVG(I)
        IF (NIT.NE.2) THEN
           loop_10049: DO K=1,NEQ1
              IF (K.LT.I) THEN                  
                 IF (JDIAG(I)-(I-K).GT.JDIAG(I-1)) THEN
                    SKIK=SK(JDIAG(I)-(I-K))
                 ELSE
                    SKIK=0.D0
                 ENDIF
              ELSEIF (K.EQ.I) THEN
                 SKIK=SK(JDIAG(K))
              ELSEIF (JDIAG(K)-(K-I).GT.JDIAG(K-1)) THEN
                 SKIK=SK(JDIAG(K)-(K-I))
              ELSE
                 SKIK=0.D0
              ENDIF
              SKIK1=SKIK
              IF (K.LT.J) THEN                  
                 IF (JDIAG(J)-(J-K).GT.JDIAG(J-1)) THEN
                    SKIK=SKIK-RHOF_TVG(I)*SK(JDIAG(J)-(J-K))
                 ENDIF
              ELSEIF (K.EQ.J) THEN
                 SKIK=SKIK-RHOF_TVG(I)*SK(JDIAG(K))
              ELSEIF (JDIAG(K)-(K-J).GT.JDIAG(K-1)) THEN
                 SKIK=SKIK-RHOF_TVG(I)*SK(JDIAG(K)-(K-J))
              ENDIF
              SKTVG(K,ITVG)=SKIK
              SKTVGT(K,ITVG)=SKIK1
              IF (K.EQ.I) SKTVGT(K,ITVG)=0.D0
           enddo loop_10049
           loop_10050: DO K=1,0
              NEL_BEG=(K-1)*(3*NSDMAX+2)
              IROW=0
              JROW=0
              KL=1
              loop_10051: DO WHILE (KL.LE.INT_HP_CELL(NEL_BEG+1))
                 IF (INT_HP_CELL(NEL_BEG+KL*3).EQ.I) THEN
                    IROW=IROW+1
                    NELIROW(IROW)=KL
                 ENDIF
                 IF (INT_HP_CELL(NEL_BEG+KL*3).EQ.J) THEN
                    JROW=JROW+1
                    NELJROW(JROW)=KL
                 ENDIF
                 KL=KL+1
              enddo loop_10051
              loop_10052: DO L=1,INT_HP_INC(NEL_BEG+1)
                 WRITE (*,*) 'FORCE BOUNDARY CONDITION ON &
                      TVG BOUND HAS NOT BEEN CHECKED'
                 STOP
                 NDFI=INT_HP_INC(NEL_BEG+L*3)
                 IF (NDFI.GT.NEQ1) THEN
                    SKTVG(NDFI,ITVG)=0.D0
                    SKTVGT(NDFI,ITVG)=0.D0
                    loop_10053: DO MROW=1,IROW
                       MR=NELIROW(MROW)
                       SKTVG(NDFI,ITVG)=SKTVG(NDFI,ITVG)&
                            +SKIO(NP_SKIO(NEL,1)+(L+6-1)*NP_SKIO(NEL,4)+INT_HP_INC(NEL_BEG+1)+6+MR)
                       SKTVGT(NDFI,ITVG)=SKTVGT(NDFI,ITVG)&
                            +SKIO(NP_SKIO(NEL,1)+(L+6-1)*NP_SKIO(NEL,4)+INT_HP_INC(NEL_BEG+1)+6+MR)
                       SKIO(NP_SKIO(NEL,1)+(L+6-1)*NP_SKIO(NEL,4)+INT_HP_INC(NEL_BEG+1)+6+MR)=0.D0
                    enddo loop_10053
                    loop_10054: DO MROW=1,JROW
                       MR=NELJROW(MROW)
                       SKTVG(NDFI,ITVG)=SKTVG(NDFI,ITVG)-RHOF_TVG(I)*&
                            SKIO(NP_SKIO(NEL,1)+(L+6-1)*NP_SKIO(NEL,4)+INT_HP_INC(NEL_BEG+1)+6+MR)
                    enddo loop_10054
                 ENDIF
              enddo loop_10052
           enddo loop_10050
           FTVG(ITVG)=F(I)
           F(I)=0.D0
        ENDIF
     ENDIF
  enddo loop_10048
  IF (NIT.NE.2) THEN
     ITVG=0
     loop_10055: DO I=1,NEQ1
        IF (IFORCE_TVG(I,1).NE.0) THEN
           ITVG=ITVG+1
           J=IFORCE_TVG(I,2)
           loop_10056: DO K=1,NEQ1
              IF (K.LT.I) THEN                  
                 IF (JDIAG(I)-(I-K).GT.JDIAG(I-1)) THEN
                    SK(JDIAG(I)-(I-K))=0.D0
                 ENDIF
              ELSEIF (K.EQ.I) THEN
                 SK(JDIAG(K))=0.D0
              ELSEIF (JDIAG(K)-(K-I).GT.JDIAG(K-1)) THEN
                 SK(JDIAG(K)-(K-I))=0.D0
              ENDIF
           enddo loop_10056
           SK(JDIAG(I))=1.D0
        ENDIF
     enddo loop_10055
  ENDIF
  CALL NBOUND1(NIT,SK,F,DU,JDIAG,NBC1,VBC1,NODE,&
       NINT,IJK,IJK1,IJK2,NBOUD1) 
  CALL NBOUND_MAC(NIT,SK,F,DU,JDIAG,NBC1,VBC1,NODE,&
       NINT,IJK,IJK1,IJK2,NBOUD1) 
  CALL EXCHN (FIN,XMTRL,NEQ2)      
  loop_10058: DO I=1,NBOUD1
     IF(NBC1(I*3-2).LE.NX_CELL) THEN
        NDD1=(NBC1(I*3-2)-1)*2+1
        NDD2=(NBC1(I*3-2)-1)*2+2
     ELSE
        NDD1=NBC1(I*3-2)*2
        NDD2=NBC1(I*3-2)*2+1
     ENDIF
     IF (NBC1(I*3-1).EQ.1) THEN            
        IF (NIT.EQ.2) THEN
           XMTRL(NDD1)=ALPH*VBC1(I*2-1)-DU(NDD1)
        ENDIF
        IF (NIT.NE.2) THEN
           loop_10059: DO K=1,ITVG
              SKTVGT(NDD1,K)=0.D0
           enddo loop_10059
        ENDIF
     ENDIF
     IF (NBC1(I*3).EQ.1) THEN
        IF (NIT.EQ.2) THEN
           XMTRL(NDD2)=ALPH*VBC1(I*2)-DU(NDD2)
        ENDIF
        IF (NIT.NE.2) THEN
           loop_10060: DO K=1,ITVG
              SKTVGT(NDD2,K)=0.D0
           enddo loop_10060
        ENDIF
     ENDIF
  enddo loop_10058
  DEALLOCATE(S_STMATST_tmp,S_STNMATST_tmp,VM_FAILIPT_tmp,&
       EPL_FAILIPT_tmp,DFVOID_S_tmp,DEPLSMAT_S_tmp,SK1,&
       VM_LOC_tmp,EPLS_LOC_tmp,FVOID_LOC_tmp)
  IF(SUM(F(1:NEQ2)).NE.SUM(F(1:NEQ2))) THEN
     write(*,*) "FRES=",SUM(F)
     IDEBUG=1
     DO WHILE(IDEBUG.EQ.1)
        IDEBUG=1
     ENDDO
     ido=1
     if(ido.Eq.1) then
        goto 9999
     endif
  ENDIF
  FRES_MAX=0.D0
  DO I=1,NEQ2
     IF(DABS(F(I)).GT.FRES_MAX) FRES_MAX=F(I) 
  ENDDO
  RETURN
END SUBROUTINE ASMBLYMPI

!****************************************************************
! Allocate different elements to different processes in MPI
!****************************************************************
SUBROUTINE ALLOCATE_NEL(NUMMPI,NELX)
!****************************************************************
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NLM=180)
  COMMON /MPITIME/ TMPI(NLM),NELALLOC(100,2)
  DIMENSION XNEL(NUMMPI)
  SUMTIME=0.D0
  TIMEMIN=1.E+20
  loop_10061: DO I=1,NELX
     SUMTIME=SUMTIME+TMPI(I)
     IF(TIMEMIN.GT.TMPI(I)) TIMEMIN=TMPI(I)
  enddo loop_10061

  AVGTIME=SUMTIME/NUMMPI
  NELAVG=NELX/NUMMPI


  NELALLOC(1,1)=1
  loop_10062: DO I=1,NUMMPI-1
     IF(I.GT.1) THEN
        NELALLOC(I,1)= NELALLOC(I-1,2)+1
        SUMTIME=0.D0
        TIMEMIN=1.E+20
        loop_10063: DO J=NELALLOC(I,1),NELX
           SUMTIME=SUMTIME+TMPI(J)
           IF(TIMEMIN.GT.TMPI(J)) TIMEMIN=TMPI(J)
        enddo loop_10063
        AVGTIME=SUMTIME/(NUMMPI-I+1)
     ENDIF
     IF(AVGTIME.NE.0) THEN
        NELALLOC(I,2)=NELALLOC(I,1)
        XTIME=TMPI(NELALLOC(I,2))+TMPI(NELALLOC(I,2)+1)
        loop_10064: DO WHILE(XTIME.LT.(AVGTIME+0.5D0*TIMEMIN).AND.NELALLOC(I,2).LT.NELX)
           NELALLOC(I,2)=NELALLOC(I,2)+1
           XTIME=XTIME+TMPI(NELALLOC(I,2)+1)
        enddo loop_10064
     ELSE
        NELALLOC(I,2)=NELALLOC(I,1)+NELAVG-1
     ENDIF
     IF(NELALLOC(I,2).GT.NELX) THEN
        NELALLOC(I,2)=NELX
     ENDIF
  enddo loop_10062
  IF(NUMMPI.GT.1) NELALLOC(NUMMPI,1)=NELALLOC(NUMMPI-1,2)+1
  NELALLOC(NUMMPI,2)=NELX

  RETURN
END SUBROUTINE ALLOCATE_NEL
