!********************************************************
! Generate integration points in the matrix and inclusion
! of each element.
!********************************************************
SUBROUTINE IDENTIPT (NX,NELX,NODE,NBETA,IJK,IJK1,IJK2,NINT,X,Y,DU,&
     NBC1,VBC1)
!********************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  PARAMETER (ALPHA=0.E0)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NLM_SOFT=40000)
  DIMENSION NODE(1),IJK(NLM,1),NINT(NLM,2),X(1),Y(1),&
       IJK1(NLM,1),NBETA(1),IJK2(NLM,1)
  DIMENSION X5(6),Y5(6),SH(6),GDN(6,2),JCMN(100),DU(1),nbc1(1),vbc1(1)
  DIMENSION XDIV5(6),YDIV5(6),XCUT(10,3),YCUT(10,3)
  INTEGER, ALLOCATABLE ::ICLOSE(:),JDIAG(:),IRAD_TEMP(:),ITHET_TEMP(:)
  DOUBLE PRECISION, ALLOCATABLE :: X1(:),Y1(:),RCLOSE(:),SC1(:),F1(:)&
       ,H(:),H1(:),H2(:),XTEMP(:),YTEMP(:),GJACTMP(:)

  COMMON /MACSTN/ NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)
  COMMON /BOUNDCURVE/ ABD_CRV,BBD_CRV,ANBD_CRV,&
       XBD_CRV,YBD_CRV,IBD_CRV
  COMMON /TRACKTIP/ ITR,ITRACK(500)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /GAUQUAD/ W(1275),BP(1275),INTBEG(50)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /SCALPRM/ XCENT(NLM),YCENT(NLM),SCALE(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /SCALPRMC/ XCENTPP(NLM),YCENTPP(NLM),SCALEPP(NLM)
  COMMON /SHPCRCK/ CONFOUR1(NLM),&
       CSFOUR1(20,NLM),SNFOUR1(20,NLM)
  COMMON /SHPVOID/ FSCALE(NLM),CONFOUR(NLM),&
       CSFOUR(50,NLM),SNFOUR(50,NLM)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /PLNST/ KPLS
  COMMON /ELEPROP/ PROMAT(16,10),MPE(NLM),MPG(NLM)
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON /EDGEPRM/ NACTIVE(NLM),ICENT(NLM),NMUL(NLM)
  COMMON /INTREM/ JSUB
  COMMON /SYMETRNODES/ ICMN(NDFELM)
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /BETACONST/ IBET_TOT(NLM),IBET_CON(NBM,NLM)
  COMMON /BETACONSTI/ IBET_TOTI(NLM),IBET_CONI(NBM,NLM)
  COMMON /HMATRIX/ HMAT(NLM*NBM*(NBM+1))
  COMMON /PLC/ PMATLC(2*INTM*3*NBM)
  COMMON /INSTT/ NPLINM(NLM*INTM),NPLINC(NLM*INTC)
  COMMON /HMATRIXTOL/ HFACT
  COMMON /DISCCOORD/ SCOORD(NLM*INTM),TCOORD(NLM*INTM),&
       ITHETA(NLM*INTM),IRADIUS(NLM*INTM)
  COMMON /DISCSETUP/ IJK_SETUP(NLM)
  COMMON /SOFTBOUNDARY/ IDOSOFT(NDFELM)      
  COMMON /IDOASSIGN/ KASSIGN
  COMMON /ZOOMINGJ/  GJACOB_ZOOM,GJ_VCF(NLM),GJ_SOFT(NLM)
  COMMON /SOFTINC/  INC_SOFT_EDGE(NLM,20)
  COMMON /SOFTMAT/  MAT_SOFT_EDGE(NLM,100)
  COMMON /NELADJBOUND/ nel_adj_bound(NLM,100)
  COMMON /INTNUMSC/ NINTL(NLM),NINTA(NLM)
  COMMON/INTEGPTS/IRD1,IRD2,IRDL,IRDA,RSINGP,RSINGG
  COMMON/INTEGPTSINC/NRDL      
  COMMON /WLTBASEC/ DPOSW(NLM*NBM,2),NPBG_WLT(NLM),SSIGXG(NLM*NBM),SSIGYG(NLM*NBM),IWORP(NLM),IBET_WLTC(NBM,NLM)
  COMMON /WLTBASEM/ DPOSWM(NLM*NBM,2),NPBG_WLTM(NLM),SSIGXGM(NLM*NBM),SSIGYGM(NLM*NBM),IBET_WLTM(NBM,NLM)
  COMMON /POLYBOUND/ POLYXY,NUMPOLY(NLM),BOUNDXY,NUMBOUND(NLM),&
       IBOUND(NLM,200),ANGBOUND(NLM,200)
  COMMON /XKPARM/ DNEAR
  COMPLEX POLYXY(NLM,100),BOUNDXY(NLM,200,2)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  ALLOCATE(ICLOSE(NDFOUT+1),JDIAG(NBM),IRAD_TEMP(INTM),ITHET_TEMP(INTM))
  ICLOSE=0
  JDIAG=0
  IRAD_TEMP=0
  ITHET_TEMP=0

  ALLOCATE(X1(NDFELM),Y1(NDFELM),RCLOSE(NDFOUT+1),SC1(MAX(INTM,INTC)*9)&
       ,F1(NBM),H((NBM*(NBM+1))/2),H1((NBM*(NBM+1))/2),H2((NBM*(NBM+1))/2)&
       ,XTEMP(INTM),YTEMP(INTM),GJACTMP(INTM))
  X1=0.D0
  Y1=0.D0
  RCLOSE=0.D0
  SC1=0.D0
  F1=0.D0
  H=0.D0
  H1=0.D0
  H2=0.D0
  XTEMP=0.D0
  YTEMP=0.D0
  GJACTMP=0.D0

  INC_SOFT_EDGE=0
  MAT_SOFT_EDGE=0
  nel_adj_bound=0
  KASSIGN=0
  HFACT=1.D-06
  loop_10003: DO I=1,NBM
     JDIAG(I)=(I*(I+1))/2
  enddo loop_10003
  CSC=1.E0
  INUM=1
  NINPT=2
  IJ=0
  IRDC=5
  NRDL=14
  loop_2001: DO I=1,MAX(NRDL,14)
     INTBEG(I)=IJ
     CALL GAULEG (-1.D0,1.D0,BP(IJ+1),W(IJ+1),I)
     IJ=IJ+I
  enddo loop_2001
  NRD1=4
  NRD2=MAX(NRDL,14)
  XBEG1=0.E0
  XEND1=1.E0
  RONE=1.E0
  IMATPT=0
  ICOMPT=0
  IF(MYMPI.EQ.INT(0)) THEN
     OPEN (612,FILE='ele.grpM')
  ENDIF
  loop_1: DO I=1,NELX
     AREA_MAT=0.D0
     itr=0
     NPBG(I)=IMATPT
     NPBM(I)=ICOMPT
     IF(MYMPI.EQ.INT(0)) THEN
     ENDIF
     NPCK1=0
     NPCK2=0
     NUMNOD=NODE(I)
     NUMNOD1=NINT(I,1)
     NUMNOD2=NINT(I,2)

!***********Calculate the number of Integration points*************

     NB=NBETA(I)-NCYLFLAG(I,1)*NTRMADD(I,1)-NCYLFLAG(I,2)&
          *NTRMADD(I,2)+NB_ADP_MAT(I)
     NBP=NB
     NBC=NBETA(I)-NCYLFLAG(I,1)*NTRMADD(I,1)-NCYLFLAG(I,2)&
          *NTRMADD(I,2)+NB_ADP_COM(I)
     NBPC=NBC
     IF (NB.GT.7) NORDI=0
     IF (NB.GT.12) NORDI=0
     IF (NB.GT.18) NORDI=1
     IF (NB.GT.25) NORDI=2
     IF (NB.GT.33) NORDI=3
     IF (NB.GT.42) NORDI=4
     IF (NB.GT.52) NORDI=5
     IF (NB.GT.63) NORDI=6
     IF (NB.GT.75) NORDI=7
     IF (NBC.GT.7) NORDI_C=0
     IF (NBC.GT.12) NORDI_C=0
     IF (NBC.GT.18) NORDI_C=1
     IF (NBC.GT.25) NORDI_C=2
     IF (NBC.GT.33) NORDI_C=3
     IF (NBC.GT.42) NORDI_C=4
     IF (NBC.GT.52) NORDI_C=5
     NORD(I)=MAX(NRDL,14)
     loop_5: DO J=1,NUMNOD
        ND=IJK(I,J)
        ND1=NDGLB(ND*2-1)
        ND2=NDGLB(ND*2)
        X1(J)=X(ND)+DU(ND1)*ALPHA
        Y1(J)=Y(ND)+DU(ND2)*ALPHA
     enddo loop_5

     IF (NUMNOD1.GT.0) THEN
        loop_2: DO J=1,NUMNOD1
           ND=IJK1(I,J)
           ND1=NDGLB(ND*2-1)
           ND2=NDGLB(ND*2)
           X1(NUMNOD+J)=X(ND)+DU(ND1)*ALPHA
           Y1(NUMNOD+J)=Y(ND)+DU(ND2)*ALPHA
        enddo loop_2
     ENDIF
     IF (NUMNOD2.GT.0) THEN
        loop_23: DO J=1,NUMNOD2
           ND=IJK2(I,J)
           ND1=NDGLB(ND*2-1)
           ND2=NDGLB(ND*2)
           X1(NUMNOD+NUMNOD1+J)=X(ND)+DU(ND1)*ALPHA
           Y1(NUMNOD+NUMNOD1+J)=Y(ND)+DU(ND2)*ALPHA
        enddo loop_23
     ENDIF

!**********Store effective nodes and their co-ordinates***********

     XC=0.D0
     YC=0.D0
     XC=XCENTP(I)
     YC=YCENTP(I)
     XCC=XCENTPP(I)
     YCC=YCENTPP(I)

!*********Get Center and scale for inclusion**********************

     XC1=0.E0
     YC1=0.E0
     XC1=XCENTP(I)
     YC1=YCENTP(I)
     IK=NCYLFLAG(I,1)*(KORD(I,1)+IRECTRM(I,1)+1)
     IF (NUMNOD1.EQ.INT(0).AND.IK.EQ.INT(0)) THEN
        XC=XC1
        YC=YC1
     ENDIF
     IF (NUMNOD2.EQ.INT(0)) XCC=XC
     IF (NUMNOD2.EQ.INT(0)) YCC=YC
     YMAX=-1.D1
     XMAX=-1.D1
     loop_501: DO I1=1,NUMNOD
        IF (ABS(X1(I1)-XC1).GT.XMAX) XMAX=ABS(X1(I1)-XC1)
        IF (ABS(Y1(I1)-YC1).GT.YMAX) YMAX=ABS(Y1(I1)-YC1)
     enddo loop_501
     SCALE(I)=DMAX1(XMAX,YMAX)
     XCENT(I)=XC1
     YCENT(I)=YC1
     YMAX=-1.D1
     XMAX=-1.D1
     RADMIN=1.D20
     THETMIN=1.D20
     loop_502: DO I1=1,NUMNOD1
        I2=I1+1-(I1/NUMNOD1)*NUMNOD1
        XD=X1(I2+NUMNOD)-X1(I1+NUMNOD)
        YD=Y1(I2+NUMNOD)-Y1(I1+NUMNOD)
        THET1=DSQRT(XD*XD+YD*YD)
        IF (THETMIN.GT.THET1) THETMIN=THET1               
        IF (ABS(X1(I1+NUMNOD)-XC).GT.XMAX) XMAX=ABS(X1(I1+NUMNOD)-&
             XC)
        IF (ABS(Y1(I1+NUMNOD)-YC).GT.YMAX) YMAX=ABS(Y1(I1+NUMNOD)&
             -YC)
     enddo loop_502
     IF (MCRACK(I).EQ.1) THEN
        THETMIN=DATAN(1.D0)*4.D0*(XSCALEM(I)+YSCALEM(I))/8.D0
     ENDIF
     IF (NUMNOD1.EQ.INT(0)) THEN
        loop_10004: DO J=1,NUMNOD
           J1=J+1-(J/NUMNOD)*NUMNOD
           XD=X1(J1)-X1(J)
           YD=Y1(J1)-Y1(J)
           THET=DSQRT(XD*XD+YD*YD)
           IF (THETMIN.GT.THET.AND.THET.GT.1.D-10) THEN
              THETMIN=THET
           ENDIF
        enddo loop_10004
     ENDIF
     SCALEP(I)=SQRT(XMAX*YMAX)
     XCENTP(I)=XC
     YCENTP(I)=YC
     YMAX=-1.D1
     XMAX=-1.D1
     loop_503: DO I1=1,NUMNOD2
        IF (ABS(X1(I1+NUMNOD+NUMNOD1)-XCC).GT.XMAX) XMAX=ABS&
             (X1(I1+NUMNOD+NUMNOD1)-XCC)
        IF (ABS(Y1(I1+NUMNOD+NUMNOD1)-YCC).GT.YMAX) YMAX=ABS&
             (Y1(I1+NUMNOD+NUMNOD1)-YCC)
     enddo loop_503
     SCALEPP(I)=DSQRT(XMAX*YMAX)
     XCENTPP(I)=XCC
     YCENTPP(I)=YCC
     one=1.e0

!*************Check if the node on the inclusion boundary
!             is the same as effective node on matrix boundary**********

     loop_10005: DO IJ=1,NUMNOD1
        IJND=IJK1(I,IJ)
        ICMN(IJ)=0
        JCMN(IJ)=0
        loop_10006: DO IK=1,NUMNOD
           IKND=IJK(I,IK)
           IF (IJND.EQ.IKND) THEN
              ICMN(IJ)=1
           ENDIF
        enddo loop_10006
     enddo loop_10005
     loop_10007: DO IJ=1,NUMNOD2
        IJND=IJK2(I,IJ)
        JCMN(IJ+NUMNOD1)=0
        loop_10008: DO IK=1,NUMNOD1
           IKND=IJK1(I,IK)
           IF (IJND.EQ.IKND) THEN
              JCMN(IK)=IJ
              JCMN(IJ+NUMNOD1)=IK
           ENDIF
        enddo loop_10008
     enddo loop_10007
     CALL FOURIER (I,NUMNOD1,XC,YC,X1(NUMNOD+1),Y1(NUMNOD+1),&
          CONFOUR(I),CSFOUR(1,I),SNFOUR(1,I),XSCALEM(I),YSCALEM(I))
     IF(MYMPI.EQ.INT(0)) THEN
        OPEN (12,FILE='ele.grp')
        OPEN (412,FILE='ele.grpp1')
     ENDIF
     YM2=PROMAT(1,MPG(I))
     IND=NINT(I,1)
     loop_43: DO I1=1,NUMNOD
        IF (NUMNOD1.NE.0) THEN
           RCLOSE(I1)=1.D6
           loop_44: DO J=1,NUMNOD1
              XD=X1(J+NUMNOD)-X1(I1)
              YD=Y1(J+NUMNOD)-Y1(I1) 
              RR=SQRT(XD*XD+YD*YD)
              IF (RR.LT.RCLOSE(I1)) THEN
                 RCLOSE(I1)=RR
                 ICLOSE(I1)=J
              ENDIF
           enddo loop_44
        ELSE
           ICLOSE(I1)=I1
           IF (IND.EQ.INT(0)) ICLOSE(I1)=0
        ENDIF
     enddo loop_43
     IF(NUMNOD.GE.NUMNOD1) THEN
        loop_10009: DO I1=1,NUMNOD
           I1_bef=I1-1
           IF(I1_bef.EQ.INT(0)) I1_bef=NUMNOD
           IF(ICLOSE(I1_bef).EQ.NUMNOD1.AND.ICLOSE(I1).NE.NUMNOD1) THEN
              IF(ICLOSE(I1)-0.GT.1) THEN
                 ICLOSE(I1)=1
              ENDIF
           ELSE
              IF(ICLOSE(I1)-ICLOSE(I1_bef).GT.1) THEN
                 ICLOSE(I1)=ICLOSE(I1_bef)+1
              ENDIF
           ENDIF
           IF(ICLOSE(I1).EQ.1) THEN
              I2=I1-1
              IF(I2.EQ.INT(0)) I2=NUMNOD
              IF(ICLOSE(I2).NE.1) ICLOSE(I2)=NUMNOD1
              I2_bef=I2-1
              IF(I2_bef.EQ.INT(0)) I2_bef=NUMNOD
              loop_10010: DO WHILE(ICLOSE(I2)-ICLOSE(I2_bef).GT.1) 
                 ICLOSE(I2_bef)=ICLOSE(I2)-1
                 I2=I2_bef
                 I2_bef=I2-1
                 IF(I2_bef.EQ.INT(0)) I2_bef=NUMNOD
              enddo loop_10010
           ENDIF
        enddo loop_10009
        loop_10011: DO I1=1,NUMNOD
           I1_bef=I1-1
           IF(I1_bef.EQ.INT(0)) I1_bef=NUMNOD
           IF(ICLOSE(I1_bef).EQ.NUMNOD1.AND.ICLOSE(I1).NE.NUMNOD1) THEN
              IF(ICLOSE(I1)-0.GT.1) THEN
                 ICLOSE(I1)=1
              ENDIF
           ELSE
              IF(ICLOSE(I1)-ICLOSE(I1_bef).GT.1) THEN
                 ICLOSE(I1)=ICLOSE(I1_bef)+1
              ENDIF
           ENDIF
           IF(ICLOSE(I1).EQ.1) THEN
              I2=I1-1
              IF(I2.EQ.INT(0)) I2=NUMNOD
              IF(ICLOSE(I2).NE.1) ICLOSE(I2)=NUMNOD1
              I2_bef=I2-1
              IF(I2_bef.EQ.INT(0)) I2_bef=NUMNOD
              loop_10012: DO WHILE(ICLOSE(I2)-ICLOSE(I2_bef).GT.1) 
                 ICLOSE(I2_bef)=ICLOSE(I2)-1
                 I2=I2_bef
                 I2_bef=I2-1
                 IF(I2_bef.EQ.INT(0)) I2_bef=NUMNOD
              enddo loop_10012
           ENDIF
        enddo loop_10011
     ENDIF
     JJ=0
     XSC=XSCALEM(I)
     YSC=YSCALEM(I)
     CSC=ANM(I)
     CSC1=CSC*DATAN(1.D0)/4.5D1
     CS6=DCOS(CSC1)
     SN6=DSIN(CSC1)
     K1=0

!*********Calculate the distance between the center of element and
!         the inclusion*******************************************

     XDIF=XC1-XC
     YDIF=YC1-YC
     SC=SCALE(I)
     IK=NCYLFLAG(I,1)*(KORD(I,1)+IRECTRM(I,1)+1)
     IF (IK.LT.NCYLFLAG(I,2)*(KORD(I,2)+IRECTRM(I,2)+1)) IK=&
          NCYLFLAG(I,2)*(KORD(I,2)+IRECTRM(I,2)+1)
     IK=8
     KTYP=0
     IF (MCRACK(I).NE.0) THEN
        KTYP=1
        XSCM=XSCALEM(I)
        YSCM=YSCALEM(I)
        CSCM=ANM(I)
        XCM=XCENTP(I)
        YCM=YCENTP(I)
     ENDIF
     KTYP=2
     A0=CONFOUR(I)
     XCM=XCENTPP(I)
     YCM=YCENTPP(I)
     SC=SCALE(I)
     SCP=SCALEP(I)
     LINPT=100
     JTHETA=0

901  FORMAT (2(E12.6,2X))

     CALL DISCRET_ELLIP(NELX,I,IRD2,X,Y,NODE,IJK,NINT&
          ,IJK1,IJK2,NBETA,K1,XTEMP,YTEMP,GJACTMP,IRAD_TEMP,ITHET_TEMP)
     loop_10017: DO JJ=1,K1
        XIPT(NPBG(I)+JJ)=(XTEMP(JJ)-XC1)/SCALE(I)
        YIPT(NPBG(I)+JJ)=(YTEMP(JJ)-YC1)/SCALE(I)
        GJACOB(NPBG(I)+JJ)=GJACTMP(JJ)
        GJ_VCF(I)=GJ_VCF(I)+GJACOB(NPBG(I)+JJ)
        IRADIUS(NPBG(I)+JJ)=IRAD_TEMP(JJ)
        ITHETA(NPBG(I)+JJ)=ITHET_TEMP(JJ)
     enddo loop_10017

     IJK_SETUP(I)=NUMBOUND(I)
     NINTM(I)=K1
     IMATPT=IMATPT+K1

     IF (NINTM(I).GT.INTM.OR.NINTM(I)+NPBG(I).GT.NLM*INTM) THEN
        WRITE (*,*) 'TOO MANY INT. POINTS FOR ELEMENT',I
        WRITE (*,*) ' NINPT=', NINTM(I)
        STOP
     ENDIF
     NPBM(I)=ICOMPT
     IF(MYMPI.EQ.INT(0)) THEN
        OPEN (512,FILE='ele.grpC')
        OPEN (12,FILE='ele.grpp')
        WRITE (12,*) '"NEL=',I,'"'
     ENDIF
     K1=0
     IK=NCYLFLAG(I,2)*2*(KORD(I,2)+IRECTRM(I,2)+1)
     IND=NINT(I,2)
     loop_643: DO I1=1,NUMNOD1
        IF (NUMNOD2.NE.0) THEN
           RCLOSE(I1)=1.D6
           loop_644: DO J=1,NUMNOD2
              XD=X1(J+NUMNOD+NUMNOD1)-X1(I1+NUMNOD)
              YD=Y1(J+NUMNOD+NUMNOD1)-Y1(I1+NUMNOD)
              RR=SQRT(XD*XD+YD*YD)
              IF (RR.LT.RCLOSE(I1)) THEN
                 RCLOSE(I1)=RR
                 ICLOSE(I1)=J
              ENDIF
           enddo loop_644
        ELSE
           ICLOSE(I1)=I1
           IF (IND.EQ.INT(0)) ICLOSE(I1)=0
        ENDIF
     enddo loop_643
     JJ=0
     JPUSH=NUMNOD+NUMNOD1
     XSC1=XSCALEI(I)
     YSC1=YSCALEI(I)
     CSC2=ANI(I)
     CSC3=CSC2*DATAN(1.D0)/4.5E1
     CS8=DCOS(CSC3)
     SN8=DSIN(CSC3)
     XCP=XCC
     YCP=YCC

     loop_663: DO J=1,NUMNOD1
        J1=J+1
        IF (J.EQ.NUMNOD1) J1=1
        I1=ICLOSE(J)
        I2=ICLOSE(J1)
        KFL=I2-I1
        IF (KFL.LT.0) KFL=NUMNOD2+KFL
        MFL=0
        IF (KFL.EQ.INT(0)) MFL=1
        IF (MFL.EQ.1) KFL=1
        DX=X1(JPUSH+I2)-X1(J1+NUMNOD)
        DY=Y1(JPUSH+I2)-Y1(J1+NUMNOD)            
        DL=SQRT(DX*DX+DY*DY)
        NODE1_INCENT=0
        NODE2_INCENT=0
        IF (DL.GT.1.E-10) THEN
           CS2=DX/DL
           SN2=DY/DL
           DX=XC-X1(JPUSH+I2)
           DY=YC-Y1(JPUSH+I2)
           DL=DSQRT(DX*DX+DY*DY)
           CS22=DX/DL
           SN22=DY/DL
           DETT=CS2*SN22-SN2*CS22
           IF (DETT.LT.0.E0) THEN
              CS2=CS22
              SN2=SN22
           ENDIF
        ELSE
           DX=XC-X1(JPUSH+I2)
           DY=YC-Y1(JPUSH+I2)
           DL=DSQRT(DX*DX+DY*DY)
           IF (DL.LT.1.D-12) THEN
              NODE2_INCENT=1
           ELSE
              CS2=DX/DL
              SN2=DY/DL
           ENDIF
        ENDIF
        DX=X1(JPUSH+I1)-X1(J+NUMNOD)
        DY=Y1(JPUSH+I1)-Y1(J+NUMNOD)
        DL=SQRT(DX*DX+DY*DY)
        IF (DL.GT.1.E-10) THEN
           CS1=DX/DL
           SN1=DY/DL
           DL6=DL
           DX=XC-X1(JPUSH+I1)
           DY=YC-Y1(JPUSH+I1)
           DL=DSQRT(DX*DX+DY*DY)
           CS11=DX/DL
           SN11=DY/DL
           DETT=CS1*SN11-SN1*CS11
           IF (DETT.GT.0.E0) THEN
              CS1=CS11
              SN1=SN11
           ENDIF
        ELSE
           DX=XC-X1(JPUSH+I1)
           DY=YC-Y1(JPUSH+I1)
           DL=DSQRT(DX*DX+DY*DY)
           IF (DL.LT.1.D-12) THEN
              NODE1_INCENT=1
              IF (NODE2_INCENT.EQ.1) THEN
                 WRITE (*,*) 'TWO NODES AT PARTICLE CENTER?'
                 STOP
              ELSE
                 CS1=CS2
                 SN1=SN2
              ENDIF
           ELSE
              CS1=DX/DL
              SN1=DY/DL
           ENDIF
        ENDIF
        IF (NODE2_INCENT.EQ.1) THEN
           CS2=CS1
           SN2=SN1
        ENDIF
        DET3=(SN1*CS2-SN2*CS1)
        JPLL=0
        IF (DABS(DET3).GT.1.E-10) THEN
           DL1=((X1(JPUSH+I1)-X1(JPUSH+I2))*SN2-(Y1(JPUSH+I1)-&
                Y1(JPUSH+I2))*CS2)/DET3
        ELSE
           JPLL=1
           CS_PLL=CS1
           SN_PLL=SN1
           DL1=0.d0
        ENDIF
        XINTCPT=DL1*CS1+X1(JPUSH+I1)
        YINTCPT=DL1*SN1+Y1(JPUSH+I1)
        DX=X1(J1+NUMNOD)-X1(J+NUMNOD)
        DY=Y1(J1+NUMNOD)-Y1(J+NUMNOD)
        DL=DSQRT(DX*DX+DY*DY)
        CS=DX/DL
        SN=DY/DL

!********** Begin Discretizing ************************************

        loop_7442: DO IKFL=1,KFL

!********* Divide the area according to the number of nodes ********

           JJ=JJ+1
           IF (IKFL.EQ.1) THEN
              X5(1)=X1(J+NUMNOD)
              Y5(1)=Y1(J+NUMNOD)
              IF (NUMNOD2.EQ.INT(0)) THEN
                 X5(4)=XC
                 Y5(4)=YC
              ELSE
                 X5(4)=X1(JPUSH+I1)
                 Y5(4)=Y1(JPUSH+I1)
                 XBEG=X1(JPUSH+I1)
                 YBEG=Y1(JPUSH+I1)
                 XEND=X1(JPUSH+I2)
                 YEND=Y1(JPUSH+I2)
              ENDIF
           ELSE
              X5(4)=X5(3)
              Y5(4)=Y5(3)
              X5(1)=X5(2)
              Y5(1)=Y5(2)
           ENDIF
           IF (MFL.EQ.1) THEN
              X5(3)=X5(4)
              Y5(3)=Y5(4)
              X5(2)=X1(J1+NUMNOD)
              Y5(2)=Y1(J1+NUMNOD)
           ELSE
              IKFL1=I1+IKFL
              IF (IKFL1.GT.NUMNOD2) IKFL1=IKFL1-NUMNOD2
              IF (IKFL1.EQ.I2) THEN
                 X5(2)=X1(J1+NUMNOD)
                 Y5(2)=Y1(J1+NUMNOD)
                 X5(3)=X1(JPUSH+I2)
                 Y5(3)=Y1(JPUSH+I2)
              ELSE
                 IF (JPLL.EQ.INT(0)) THEN
                    XDIF=X1(JPUSH+IKFL1)-XINTCPT
                    YDIF=Y1(JPUSH+IKFL1)-YINTCPT
                    DLLL=DSQRT(XDIF*XDIF+YDIF*YDIF)
                    CS11=XDIF/DLLL
                    SN11=YDIF/DLLL
                 ELSE
                    CS11=-CS_PLL
                    SN11=-SN_PLL
                 ENDIF
                 IF (MCRACK(I).EQ.INT(0)) THEN
                    DET=SN11*CS-CS11*SN
                    DS=((X1(JPUSH+IKFL1)-X1(J+NUMNOD))*SN11-(Y1(&
                         JPUSH+IKFL1)-Y1(J+NUMNOD))*CS11)/DET
                    IF (DS.GT.DL.OR.DS.LT.0) THEN
                       WRITE (21,*) 'INT. LINE  OUTSIDE'
                       WRITE (21,*) 'VORONOI BOUNDARY, FOR &
                            ELEMENT',I
                       WRITE (21,*) 'PROGRAM TERMINATED'
                       STOP
                    ENDIF
                    X5(2)=X1(J+NUMNOD)+DS*CS
                    Y5(2)=Y1(J+NUMNOD)+SN*DS
                 ELSE
                    XDIF1=X1(JPUSH+IKFL1)-XCENTP(I)
                    YDIF1=Y1(JPUSH+IKFL1)-YCENTP(I)
                    XDIF=XDIF1*CS6+YDIF1*SN6
                    YDIF=-XDIF1*SN6+YDIF1*CS6
                    CS22=CS11*CS6+SN11*SN6
                    SN22=SN11*CS6-CS11*SN6
                    FACT1=(XDIF/XSCALEM(I))**2+(YDIF/YSCALEM(I))**2&
                         -1.D0
                    FACT2=(XDIF*CS22)/XSCALEM(I)**2+(YDIF*SN22)/&
                         YSCALEM(I)**2
                    FACT3=(CS22/XSCALEM(I))**2+(SN22/YSCALEM(I))**2
                    DET=DSQRT((FACT2/FACT3)**2-FACT1/FACT3)
                    B2A=-FACT2/FACT3
                    IF (DET+B2A.LT.0.D0) THEN
                       DL=DET+B2A
                    ELSEIF (B2A-DET.LT.0.D0) THEN
                       DL=B2A-DET
                    ELSE
                       WRITE (*,*) 'UNKNOWN DL'
                       STOP
                    ENDIF
                    X5(2)=X1(JPUSH+IKFL1)+DL*CS11
                    Y5(2)=Y1(JPUSH+IKFL1)+DL*SN11
                 ENDIF
                 X5(3)=X1(JPUSH+IKFL1)
                 Y5(3)=Y1(JPUSH+IKFL1)
              ENDIF
           ENDIF
           XXX2=X5(2)
           YYY2=Y5(2)
           XXX3=X5(3)
           YYY3=Y5(3)
           IQUADNUM=1
           IF (NUMNOD2.NE.0) THEN
              X55=(X5(4)+X5(3))*0.5E0
              Y55=(Y5(4)+Y5(3))*0.5E0
              X54=(X5(4)-XCP)*CS8+(Y5(4)-YCP)*SN8
              Y54=(Y5(4)-YCP)*CS8-(X5(4)-XCP)*SN8
              RINS1=((X54)/XSC1)**2+((Y54)/YSC1)**2
              RINS1=DSQRT(RINS1)
              X53=(X5(3)-XCP)*CS8+(Y5(3)-YCP)*SN8
              Y53=(Y5(3)-YCP)*CS8-(X5(3)-XCP)*SN8
              RINS2=((X53)/XSC1)**2+((Y53)/YSC1)**2
              RINS2=DSQRT(RINS2)
              IF (RINS1+RINS2.LT.1.95D0) THEN
                 X5(5)=X55
                 Y5(5)=Y55
              ELSE
                 ANG=DATAN2(Y55-YCP,X55-XCP)
                 CS7=DCOS(ANG)
                 SN7=DSIN(ANG)
                 CSS=CS7*CS8+SN7*SN8
                 SNN=SN7*CS8-SN8*CS7
                 RF=(CSS/XSC1)**2+(SNN/YSC1)**2
                 RF=(RINS1+RINS2)*0.5D0/DSQRT(RF)
                 X55=RF*CSS
                 Y55=RF*SNN
                 X5(5)=X55*CS8-Y55*SN8+XCP
                 Y5(5)=X55*SN8+Y55*CS8+YCP
              ENDIF
           ELSE
              X5(5)=XC
              Y5(5)=YC
           ENDIF
           IF (MCRACK(I).EQ.1) THEN
              X66=(X5(1)+X5(2))*0.5E0
              Y66=(Y5(1)+Y5(2))*0.5E0
              RINS1=((X5(1)-XC)/XSC)**2+((Y5(1)-YC)/YSC)**2
              RINS1=DSQRT(RINS1)
              RINS2=((X5(1)-XC)/XSC)**2+((Y5(1)-YC)/YSC)**2
              RINS2=DSQRT(RINS2)
              IF (RINS1+RINS2.LT.1.95D0) THEN
                 X5(6)=X66
                 Y5(6)=Y66
              ELSE
                 ANG=DATAN2(Y66-YC,X66-XC)
                 CS7=DCOS(ANG)
                 SN7=DSIN(ANG)
                 CSS=CS7*CS6+SN7*SN6
                 SNN=SN7*CS6-SN6*CS7
                 RF=(CSS/XSC)**2+(SNN/YSC)**2
                 RF=DSQRT(1.D0/RF)
                 X66=RF*CSS
                 Y66=RF*SNN
                 X5(6)=X66*CS6-Y66*SN6+XC
                 Y5(6)=X66*SN6+Y66*CS6+YC
              ENDIF
           ELSE
              X5(6)=(X5(1)+X5(2))*0.5E0
              Y5(6)=(Y5(1)+Y5(2))*0.5E0
           ENDIF
           IF (IK.NE.0) THEN
              JDIV1=3
              JDIV2=3
           ELSE
              JDIV1=3
              JDIV2=3
           ENDIF
           XDIV5(4)=X5(4)
           XDIV5(3)=X5(3)
           XDIV5(5)=X5(5)
           YDIV5(4)=Y5(4)
           YDIV5(3)=Y5(3)
           YDIV5(5)=Y5(5)

!****************** Calculate the area of the Quadrilateral ***************

           AREA=0.D0
           loop_10024: DO IIPT=1,4
              YL=BP(INTBEG(4)+IIPT)
              loop_10025: DO JIPT=1,4
                 XL=BP(INTBEG(4)+JIPT)
                 CALL GGRAD6(ICON,I,XL,YL,SH,DET,GDN,&
                      X5,Y5,LW)       
                 AREA=AREA+DET*W(INTBEG(4)+IIPT)*&
                      W(INTBEG(JIPT)+JIPT)
              enddo loop_10025
           enddo loop_10024
           IF (AREA.LT.1.D-13) GOTO 741
           FRACDIV=1.D0/DFLOAT(JDIV1*(JDIV1+1))
           loop_74: DO I3=1,MAX(JDIV1,JDIV2)
              FRACD=DFLOAT(I3*(I3+1))*FRACDIV
              IF (I3.LE.JDIV1) THEN
                 XDIV5(1)=X5(4)+(X5(1)-X5(4))*FRACD
                 YDIV5(1)=Y5(4)+(Y5(1)-Y5(4))*FRACD
              ENDIF
              IF (I3.LE.JDIV2) THEN
                 XDIV5(2)=X5(3)+(X5(2)-X5(3))*FRACD
                 YDIV5(2)=Y5(3)+(Y5(2)-Y5(3))*FRACD
              ENDIF
              XDIV5(6)=X5(5)+(X5(6)-X5(5))*FRACD
              YDIV5(6)=Y5(5)+(Y5(6)-Y5(5))*FRACD
              IF(MYMPI.EQ.INT(0)) THEN
                 WRITE (512,*)
                 WRITE (512,901) XDIV5(1),YDIV5(1)
                 WRITE (512,901) XDIV5(6),YDIV5(6)
                 WRITE (512,901) XDIV5(2),YDIV5(2)
                 WRITE (512,901) XDIV5(3),YDIV5(3)
                 WRITE (512,901) XDIV5(5),YDIV5(5)
                 WRITE (512,901) XDIV5(4),YDIV5(4)
                 WRITE (512,901) XDIV5(1),YDIV5(1)
              ENDIF
              IF (IK.NE.0) THEN
                 IRD1=5+NORDI_C
                 IF (I3.GT.1) IRD1=3+NORDI_C
                 IRD2=4
              ELSE
                 IRD1=3+NORDI_C
                 IRD2=4
              ENDIF
              NFAC1=INTBEG(IRD1)
              NFAC2=INTBEG(IRD2)
              loop_10026: DO I33=1,IRD1
                 YL=BP(NFAC1+I33)
                 loop_764: DO J3=1,IRD2
                    K1=K1+1
                    XL=BP(J3+NFAC2)

!********** Calculate the shape functions and Jacobi for given 
!           integration points ************************************

                    CALL GGRAD6(ICON,I,XL,YL,SH,DET,GDN,&
                         XDIV5,YDIV5,LW)  
                    XI=0.E0
                    YI=0.E0
                    loop_747: DO II1=1,6
                       XI=XI+XDIV5(II1)*SH(II1)
                       YI=YI+YDIV5(II1)*SH(II1)
                    enddo loop_747
                    XIPTCOM(NPBM(I)+K1)=(XI-XC)/SCALEP(I)
                    YIPTCOM(NPBM(I)+K1)=(YI-YC)/SCALEP(I)
                    GJACOM(NPBM(I)+K1)=W(I33+NFAC1)*W(J3+&
                         NFAC2)*DET
                 enddo loop_764
              enddo loop_10026
              XDIV5(4)=XDIV5(1)
              YDIV5(4)=YDIV5(1)
              XDIV5(3)=XDIV5(2)
              YDIV5(3)=YDIV5(2)
              XDIV5(5)=XDIV5(6)
              YDIV5(5)=YDIV5(6)
           enddo loop_74
741        CONTINUE
740        CONTINUE
           X5(3)=XXX3
           X5(2)=XXX2
           Y5(3)=YYY3
           Y5(2)=YYY2
        enddo loop_7442
     enddo loop_663
     NINTC(I)=K1
     ICOMPT=ICOMPT+K1

     IF (NINTC(I).GT.INTC) THEN
        WRITE (*,*) 'TOO MANY INTG. POINTS FOR ELEMENT',I
        WRITE (*,*) ' NINPT=', NINTC(I)
        STOP
     ENDIF
823  CONTINUE
     IF(MYMPI.EQ.INT(0)) THEN
        REWIND (12)
        CLOSE  (12)
        REWIND (512)
        CLOSE  (512)
     ENDIF
     NB1=NCYLFLAG(I,1)*NTRMADD(I,1)+NB+NCYLFLAG(I,2)*NTRMADD(I,2)
     loop_10027: DO J=1,NB1
        IBET_CON(J,I)=0
     enddo loop_10027

     NBS=NB-(NPBG_WLTM(I+1)-NPBG_WLTM(I))
     IBET_TOT(I)=0

     loop_10028: DO J=NBS+1,NBS+NPBG_WLTM(I+1)-NPBG_WLTM(I)
        IF(IBET_WLTM(J-NBS,I).EQ.1) THEN
           IBET_CON(J,I)=IBET_WLTM(J-NBS,I)
           IBET_TOT(I)=IBET_TOT(I)+1
        ENDIF
     enddo loop_10028

     NBS=NBC-(NPBG_WLT(I+1)-NPBG_WLT(I))
     IBET_TOTI(I)=0
     loop_100281: DO J=NBS+1,NBS+NPBG_WLT(I+1)-NPBG_WLT(I)
        IF(IBET_WLTC(J-NBS,I).EQ.1) THEN
           IBET_CONI(J,I)=IBET_WLTC(J-NBS,I)
           IBET_TOTI(I)=IBET_TOTI(I)+1
        ENDIF
     ENDDO loop_100281

     IT1=0
     IT2=0
     CALL PGLB(I,IT1,IT2,NBETA)
     IT1=1
     IT2=1
     CALL PGLB(I,IT1,IT2,NBETA)
     YM=PROMAT(1,MPE(I))
     PR=PROMAT(2,MPE(I))
     G2=-PR*(1.D0+PR*KPLS)/YM
     G1=(1.D0-PR*PR*KPLS)/YM
     G=2.D0*(1.D0+PR)/YM
     loop_10029: DO J=1,NINTM(I)
        SC1(J*9-8)=G1
        SC1(J*9-7)=G2
        SC1(J*9-6)=0.D0
        SC1(J*9-5)=G2
        SC1(J*9-4)=G1
        SC1(J*9-3)=0.D0
        SC1(J*9-2)=0.D0
        SC1(J*9-1)=0.D0
        SC1(J*9)=G
     enddo loop_10029
     NIT=-1
     NITT=-1
     NBEG=(I-1)*NBM*(NBM+1)
     loop_10031: DO J=1,JDIAG(NB1)
        HMAT(NBEG+J)=0.D0
     enddo loop_10031

     loop_10034: DO J=1,NINTM(I)
        NPLINM(NPBG(I)+J)=1
     enddo loop_10034
     CALL HMATIN(I,NINTM(I),NIT,NITT,NB1,SC1,H,F1)
     loop_10035: DO J=1,NINTM(I)
        NPLINM(NPBG(I)+J)=0
     enddo loop_10035

     IB=0
     loop_10036: DO K=1,NB1
        loop_10037: DO L=IB+1,JDIAG(K)
           KL=K-(JDIAG(K)-L)
           H1(L)=H(L)
           H2(L)=H1(L)
        enddo loop_10037
        IB=JDIAG(K)
     enddo loop_10036
     NBEG=(I-1)*NBM*(NBM+1)
     loop_10038: DO J=1,NB1
        loop_10039: DO K=1,J
           JK=JDIAG(J)-(J-K)
           HMAT(NBEG+JK)=H(JK)
        enddo loop_10039
     enddo loop_10038
     loop_10040: DO J=1,NB
        IF (IBET_CON(J,I).EQ.1) THEN
           loop_10041: DO K=1,J-1
              JK=JDIAG(J)-(J-K)
              HMAT(NBEG+JK)=0.D0
           enddo loop_10041
           HMAT(NBEG+JDIAG(J))=1.D0
           loop_10042: DO K=J+1,NB
              JK=JDIAG(K)-(K-J)
              HMAT(NBEG+JK)=0.D0
           enddo loop_10042
        ENDIF
     enddo loop_10040
     DO J=1,NB1
        IBET_CON(J,I)=0            
     ENDDO
     INEW=1
     IBET_TOT(I)=0
     loop_10043: DO WHILE (INEW.EQ.1) 
        CALL SKYLIN (H1,F1,JDIAG,NB1,1)
        HMAX=0.D0
        loop_10044: DO J=1,NB1
           IF (HMAX.LT.DABS(H1(JDIAG(J))).AND.IBET_CON(J,I).NE.1) &
                THEN
              HMAX=DABS(H1(JDIAG(J)))
           ENDIF
        enddo loop_10044
        HTOL=HMAX*HFACT
        INEW=0
        J=0
        loop_10045: DO WHILE (INEW.EQ.0.AND.J.LT.NB1)
           J=J+1
           IF (H1(JDIAG(J)).LT.HTOL.AND.IBET_CON(J,I).EQ.INT(0)) THEN
              INEW=1
              IBET_CON(J,I)=1
              loop_10046: DO K=1,J
                 JK=JDIAG(J)-(J-K)
                 IF (K.NE.J) THEN
                    HMAT(NBEG+JK)=0.D0
                    H2(JK)=0.D0
                 ELSE
                    HMAT(NBEG+JK)=1.D0
                    H2(JK)=1.D0
                 ENDIF
              enddo loop_10046
              loop_10047: DO K=J+1,NB1
                 JK=JDIAG(K)-(K-J)
                 HMAT(NBEG+JK)=0.D0
                 H2(JK)=0.D0
              enddo loop_10047
              IBET_TOT(I)=IBET_TOT(I)+1
           ENDIF
        enddo loop_10045
        loop_10048: DO J=1,JDIAG(NB1)
           H1(J)=H2(J)
        enddo loop_10048
     enddo loop_10043

     loop_10049: DO j=1,NB1
        ibet_coni(j,i)=ibet_con(j,i)
     enddo loop_10049
     ibet_toti(i)=ibet_tot(i)
     CALL IZERO (IDOSOFT,NDFELM)
     CALL TMATLOC_MAT(I,YM2,SCALE(I),XC1,YC1,SCALEP(I),XC,YC,&
          SCALEPP(I),XCC,YCC,NUMNOD,NUMNOD1,NUMNOD2,NB1,X1,Y1)  
     NB1=NCYLFLAG(I,1)*NTRMADD(I,1)+NB+NCYLFLAG(I,2)*NTRMADD(I,2)
     CALL IZERO (IDOSOFT,NDFELM)
     CALL TMATLOC_INC(I,YM2,SCALE(I),XC1,YC1,SCALEP(I),XC,YC,&
          SCALEPP(I),XCC,YCC,NUMNOD,NUMNOD1,NUMNOD2,NB1,X1,Y1)  
  enddo loop_1
  REWIND (941)
  CLOSE (941)
  IF(MYMPI.EQ.INT(0)) THEN
     rewind(612)
     close(612)
  ENDIF

  ! calculate nearest neighbour
  DNEAR=1.D+20
  DNEAR_MIN=1.D+20
  DNEAR_AVG=0.D0
  DNEAR_MAX=-1.D+20
  DO I=1,NELX
     X11=XCENTP(I)
     Y11=YCENTP(I)
     DO J=1,NELX
        IF(I.NE.J) THEN
           X22=XCENTP(J)
           Y22=YCENTP(J)
           CALL INTERSECTION_POINT(XCENTP(I),YCENTP(I),X11,Y11,X22,Y22,&
                XSCALEM(I),YSCALEM(I),ANM(I),X31,Y31)
           CALL INTERSECTION_POINT(XCENTP(J),YCENTP(J),X11,Y11,X22,Y22,&
                XSCALEM(J),YSCALEM(J),ANM(J),X32,Y32)
           DIS=DSQRT((X31-X32)**2+(Y31-Y32)**2)
           IF(DIS.LT.DNEAR) DNEAR=DIS
        ENDIF
     ENDDO
     DNEAR_AVG=DNEAR_AVG+DNEAR
     IF(DNEAR.LT.DNEAR_MIN) DNEAR_MIN=DNEAR
     IF(DNEAR.GT.DNEAR_MAX) DNEAR_MAX=DNEAR
  ENDDO
  DNEAR_AVG=DNEAR_AVG/NELX
  IF(NELX.EQ.1) THEN
     DNEAR=SCALE(1)
  ELSE
     IF(MYMPI.EQ.0) THEN
        WRITE(*,*) "Nearest Neighbor Distance (Max, Min, Avg.):",DNEAR_MAX,DNEAR_MIN,DNEAR_AVG
     ENDIF
     DNEAR=DNEAR_MIN
  ENDIF

  DEALLOCATE(ICLOSE,JDIAG,IRAD_TEMP,ITHET_TEMP)
  DEALLOCATE(X1,Y1,RCLOSE,SC1,F1,H,H1,H2,XTEMP,YTEMP,GJACTMP)
  RETURN
END SUBROUTINE IDENTIPT

!******************************************************
! This function is used to calculate the shape functions, their derivatives,
! and the determinant of 6-noded triangle elements
SUBROUTINE GGRAD6(ICON,NEL,XL,YL,SH,DET,GDN,X1,Y1,LW)                   
!******************************************************
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /VELTY/ VEGDLC
  DIMENSION SH(6),GDN(6,2) , DN(6,2),DJ(2,2),XE(6,2),VEGDLC(2,1),&
       X1(6),Y1(6),SHH(6)
  !       (SET SHAPE FUNCTIONS) 
  ICON=1
  loop_10386: DO I=1,6
     XE(I,1)=X1(I)
     XE(I,2)=Y1(I)
  enddo loop_10386
  SH(1) = 0.25*XL*(XL-1.)*(1.-YL)                            
  SH(2) = 0.25*XL*(1.+XL)*(1.-YL)                            
  SH(3) = 0.25*XL*(1.+XL)*(1.+YL)
  SH(4) = 0.25*XL*(XL-1.E0)*(1.+YL)                          
  SH(5) = 0.50*(1.-XL**2)*(1.+YL)
  SH(6) = 0.50*(1.-XL**2)*(1.-YL)

  DN(1,1) =  0.25*(1.-YL)*(2.*XL-1.)                         
  DN(2,1) =  0.25*(1.-YL)*(2.*XL+1.)                         
  DN(3,1) =  0.25*(1+2*XL)*(1.+YL)
  DN(4,1) =  0.25*(2*XL-1)*(1.+YL)                                          
  DN(1,2) = -0.25*(XL-1.)*XL                                 
  DN(2,2) = -0.25*(1.+XL)*XL                                 
  DN(3,2) =  0.25*XL*(1.+XL)                                 
  DN(4,2) =  0.25*XL*(XL-1.E0) 
  DN(5,1) =  -XL*(1.+YL)
  DN(5,2) =  0.50*(1-XL**2)
  DN(6,1) = -XL*(1.-YL)
  DN(6,2) = 0.5E0*(XL**2-1.)

  !      ( COMPUTE JACOBIAN)                                       
  loop_200: DO I=1,2
     loop_10387: DO J=1,2
        DJIJ = 0.                                                  
        loop_202: DO IA=1,6
           DJIJ =     DJIJ +XE(IA,J) *DN(IA,I)                        
        enddo loop_202
        DJ(I,J) = DJIJ                                             
     enddo loop_10387
  enddo loop_200
  DET = DJ(1,1)*DJ(2,2) - DJ(1,2)*DJ(2,1)
  IF (DET.GE.-1.E-10) RETURN
  WRITE(21,*) NEL,DET,XL,YL,' GGRAD6'                 
  WRITE (21,*) ((XE(I,J),J=1,2),I=1,6)
  OPEN (217,FILE='ele.plot')
  loop_10388: DO I=1,11
     WRITE (217,*)
     XL=-1.D0+2.D-01*(I-1)
     loop_10389: DO J=1,11
        YL=-1.D0+2.D-01*(J-1)
        SHH(1) = 0.25*XL*(XL-1.)*(1.-YL)                            
        SHH(2) = 0.25*XL*(1.+XL)*(1.-YL)                            
        SHH(3) = 0.25*XL*(1.+XL)*(1.+YL)
        SHH(4) = 0.25*XL*(XL-1.E0)*(1.+YL)                          
        SHH(5) = 0.50*(1.-XL**2)*(1.+YL)
        SHH(6) = 0.50*(1.-XL**2)*(1.-YL)
        XX=0.D0
        YY=0.D0
        loop_10390: DO K=1,6
           XX=XX+SHH(K)*XE(K,1)
           YY=YY+SHH(K)*XE(K,2)
        enddo loop_10390
        WRITE (217,217) XX,YY
217     FORMAT (2(E12.6,2X))
     enddo loop_10389
  enddo loop_10388
  WRITE (217,*)
  WRITE (217,217) XE(1,1),XE(1,2)
  WRITE (217,217) XE(6,1),XE(6,2)
  WRITE (217,217) XE(2,1),XE(2,2)
  WRITE (217,217) XE(3,1),XE(3,2)
  WRITE (217,217) XE(5,1),XE(5,2)
  WRITE (217,217) XE(4,1),XE(4,2)
  WRITE (217,217) XE(1,1),XE(1,2)
  REWIND (217)
  CLOSE (217)
  RETURN
END SUBROUTINE GGRAD6

!******************************************************
SUBROUTINE GAULEG (X1,X2,X,W,N)
  !******************************************************
  !     SUBROUTINE GAULEG GENERATES N INTERGRATION FROM (X1,X2)
  !     WITH WEIGHTS W(I)>0,I=1..N AND BASE POINTS X(I)\IN(X1,X2), I=1..N
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (EPS=3.D-14)
  DIMENSION X(1),W(1)
  M=(N+1)/2
  XM=(X1+X2)/2
  XL=(X2-X1)/2
  PI=DATAN(1.D0)*4.D0
  loop_12: DO I=1,M
     Z=DCOS(PI*(I-0.25D0)/(N+0.5D0))
1    CONTINUE
     P1=1.D0
     P2=0.D0
     loop_11: DO J=1,N
        P3=P2
        P2=P1
        P1=((2.D0*J-1.D0)*Z*P2-(J-1.D0)*P3)/J
     enddo loop_11
     PP=N*(Z*P1-P2)/(Z*Z-1.D0)
     Z1=Z
     Z=Z1-P1/PP
     IF (DABS(Z-Z1).GT.EPS) GOTO 1	
     X(I)=XM-XL*Z
     X(N+1-I)=XM+XL*Z
     W(I)=2.D0*XL/((1.D0-Z*Z)*PP*PP)
     W(N+1-I)=W(I)
  enddo loop_12
  RETURN
END SUBROUTINE GAULEG

!******************************************************
! This subroutine calculates the co-effecients of the Fourier Series
!******************************************************
SUBROUTINE FOURIER (NEL,NIX,XC,YC,X2,Y2,A0,CSINT,SNNT,XSC,YSC)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  DIMENSION X2(NDELM/2),Y2(NDELM/2)
  DIMENSION CSINT(1),SNNT(1)
  DOUBLE PRECISION, ALLOCATABLE :: X1(:),Y1(:),PD(:),ALPHA(:),GAMMA(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /EDGEPRM/ NACTIVE(NLM),ICENT(NLM),NMUL(NLM)
  COMMON /SYMETRNODES/ ICMN(NDFELM)
  ALLOCATE(X1(NDELM/2),Y1(NDELM/2),PD(NDELM/2),ALPHA(NDELM/2),GAMMA(NDELM/2))
  X1=0.D0
  Y1=0.D0
  PD=0.D0
  ALPHA=0.D0
  GAMMA=0.D0

  loop_2: DO I=1,NIX
     IBEF=I-1
     IF (I.EQ.1) IBEF=NIX
     IAFT=I+1
     IF (I.EQ.NIX) IAFT=1
     IF (ICMN(I).EQ.0.OR.ICMN(IBEF).EQ.0.OR.ICMN(IAFT).EQ.0) THEN
        X1(I)=(X2(I)-XC)
        Y1(I)=(Y2(I)-YC)
        GAMMA(I)=TANINV1(X1(I),Y1(I))
     ENDIF
  enddo loop_2
  loop_3: DO I=1,NIX
     IAFT=I+1
     IF (I.EQ.NIX) IAFT=1
     IF (ICMN(I).EQ.0.OR.ICMN(IAFT).EQ.0) THEN
        XL1=DSQRT (X1(I)*X1(I)+Y1(I)*Y1(I))
        I1=IAFT
        DX1=X1(I1)-X1(I)
        DY1=Y1(I1)-Y1(I)
        XL2=DSQRT (DX1*DX1+DY1*DY1)
        AL=(-Y1(I)*DY1-X1(I)*DX1)/XL2
        X7=X1(I)+AL*DX1/XL2
        Y7=Y1(I)+AL*DY1/XL2
        PD(I)=DSQRT(X7*X7+Y7*Y7)
        ALPHA(I)=DATAN2(Y7,X7)
     ENDIF
  enddo loop_3
  CONV=DATAN(1.D0)/4.5D1
  PI=DATAN(1.D0)*4.E0
  A0=0.D0
  NML=1
  loop_5: DO I=1,NTERM
     CSINT(I)=0.D0
     SNNT(I)=0.D0
     loop_67: DO JK=1,NML
        loop_6: DO J=1,NIX
           JAFT=J+1
           IF (J.EQ.NIX) JAFT=1
           IF (ICMN(J).EQ.0.OR.ICMN(JAFT).EQ.0) THEN
              J1=JAFT
              TH1=PI2MOD(GAMMA(J)-ALPHA(J))
              TH2=PI2MOD(GAMMA(J1)-ALPHA(J))
              AL=ALPHA(J)+PI*(JK-1)*2.E0/NML
              IF (I.EQ.1) THEN
                 I1=0
                 A0=A0+PD(J)*COSNTH(I1,TH1,TH2)/PI/2.D0
              ENDIF
              CSINT(I)=CSINT(I)+PD(J)*(DCOS(I*AL)*COSNTH&
                   (I,TH1,TH2)-DSIN(I*AL)*SINNTH&
                   (I,TH1,TH2))/PI
              SNNT(I)=SNNT(I)+PD(J)*(DSIN(I*AL)*COSNTH&
                   (I,TH1,TH2)+DCOS(I*AL)*SINNTH&
                   (I,TH1,TH2))/PI
           ENDIF
        enddo loop_6
     enddo loop_67
  enddo loop_5
  loop_10396: DO I=1,360
     ANG=CONV*I
     RAD=A0
     loop_10397: DO J=1,NTERM
        RAD=RAD+CSINT(J)*DCOS(J*ANG)+SNNT(J)*DSIN(J*ANG)
     enddo loop_10397
71   FORMAT (2(E12.6,2X))
  enddo loop_10396

  DEALLOCATE(X1,Y1,PD,ALPHA,GAMMA)

  RETURN
END SUBROUTINE FOURIER

!******************************************************
FUNCTION COSNTH (N,TH1,TH2)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  N1=N-(N/2)*2
  COSNTH=0.D0
  IF (N1.EQ.1) THEN
     IF (N.NE.1) THEN
        COSNTH=(DSIN((N-1)*TH2)-DSIN((N-1)*TH1))/(N-1)
        ICS=N-2
        IMUL=1
        loop_1: DO I=ICS,1,-2
           COSNTH=COSNTH-IMUL*SNINT (I,TH1,TH2)
           IMUL=IMUL*(-1)
        enddo loop_1
     ELSE
        COSNTH=TH2-TH1            
     ENDIF
  ELSE
     IF (N.NE.0) THEN
        ICS=N-2
        IMUL=1
        COSNTH=(DSIN((N-1)*TH2)-DSIN((N-1)*TH1))/(N-1)
        loop_2: DO I=ICS,2,-2
           COSNTH=COSNTH-IMUL*SNINT (I,TH1,TH2)
           IMUL=IMUL*(-1)
        enddo loop_2
        COSNTH=COSNTH-IMUL*(DSIN(TH1)-DSIN(TH2))
     ELSE
        IMUL=-1
     ENDIF
     A1=DABS(1.D0/DCOS(TH1)+DTAN(TH1))
     A2=DABS(1.D0/DCOS(TH2)+DTAN(TH2))            
     COSNTH=COSNTH-IMUL*DLOG(A2/A1)
  ENDIF
  RETURN
END FUNCTION COSNTH

!******************************************************
FUNCTION SNINT(N,TH1,TH2)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  IF (N.EQ.1) THEN
     SNINT=(TH2-TH1)-(DSIN(2*TH2)-DSIN(2*TH1))/2.D0
  ELSE
     SNINT=(SIN(N*TH2-TH2)+SIN(N*TH2-TH2)*N+SIN(N*TH2+TH2)-SIN(N*TH2+&
          TH2&
          )*N)/(-1+N)/(1+N)-(SIN(N*TH1-TH1)+SIN(N*TH1-TH1)*N+SIN(N*TH1+TH1)-&
          SIN(N*TH1+TH1)*N)/(-1+N)/(1+N)
  ENDIF
  RETURN
END FUNCTION SNINT

!******************************************************
FUNCTION SINNTH (N,TH1,TH2)
!******************************************************
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  SINNTH=0.D0
  N1=N-(N/2)*2      
  IF (N1.EQ.1) THEN
     IMUL=1
     loop_1: DO I=N-1,2,-2
        SINNTH=SINNTH-IMUL*2.D0*(DCOS(I*TH2)-DCOS(I*TH1))/DFLOAT(I)
        IMUL=IMUL*(-1)
     enddo loop_1
     SINNTH=SINNTH+IMUL*DLOG(DABS(DCOS(TH1)/DCOS(TH2)))
  ELSE
     IMUL=1
     loop_2: DO I=N-1,1,-2
        SINNTH=SINNTH-IMUL*2.D0*(DCOS(I*TH2)-DCOS(I*TH1))/DFLOAT(I)
        IMUL=IMUL*(-1)
     enddo loop_2
  ENDIF
  RETURN
END FUNCTION SINNTH

!******************************************************
FUNCTION TANINV1 (X,Y)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  TANINV1=DATAN2(Y,X)
  IF (TANINV1.LT.0.D0) TANINV1=DATAN(1.D0)*8+TANINV1
  RETURN
END FUNCTION TANINV1

!******************************************************
FUNCTION PI2MOD (X)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PI=DATAN(1.D0)*4.D0
  PI2MOD=X
  IF (X.GT.PI/2.D0) THEN
     PI2MOD=PI2MOD-2.D0*PI
  ELSEIF (X.LT.-PI/2.D0) THEN
     PI2MOD=2.D0*PI+PI2MOD
  ENDIF
  RETURN
END FUNCTION PI2MOD

!******************************************************        
SUBROUTINE FIND_CUT(LINPT1,KTYP,LCUT,ICUT,IK,X1,Y1,X2,Y2,XC,YC,SC,SCP,&
     A0,XSC,YSC,CSC,CSINT,SNNT,XCUT,YCUT,NUM_CUT)
!******************************************************  

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (FRAC_IN=0.4D0)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  DIMENSION CSINT(1),SNNT(1),XCUT(30),YCUT(30)
  DIMENSION X(501),Y(501),F(501),DFDX(501),DFDY(501),DFDXY(501),&
       DFDXX(501),DFDYY(501),FRAC_AC(50)
  IF (IK.EQ.0) THEN
     ICUT=2
     XCUT(1)=X1
     YCUT(1)=Y1
     XCUT(2)=X2
     YCUT(2)=Y2
     NUM_CUT=2
     RETURN
  ENDIF
  LINPT=500
  IF (LINPT.GT.500) THEN
     WRITE (*,*) 'ASKING FOR TOO MANY INTERPOLATION POINTS ON THE RA&
          DIAL LINE. NUMBER OF POINTS RESET TO 100'
     LINPT=100
  ENDIF
  ICUT=LCUT+1
  IF (ICUT.GT.10) THEN
     WRITE (*,*) 'ASKING FOR TOO MANY CUTS ON THE RADIAL LINE. NUMBE&
          R OF CUTS RESET TO 10'
     ICUT=10
  ENDIF
  FRAC=1.D0/DFLOAT(LINPT-1)
  loop_10398: DO I=1,LINPT
     X(I)=X1+(X2-X1)*(I-1)*FRAC-XC
     Y(I)=Y1+(Y2-Y1)*(I-1)*FRAC-YC
  enddo loop_10398
  EXP=1.D0/DMAX1(DFLOAT(IK),1.D0)
  IF(SCP/SC.LT.0.2D0) THEN
     EXP=0.5D0-0.375D0*(2.D0*SCP/SC)**(1.5)
  ENDIF
  loop_10399: DO I=1,ICUT
     FRAC_AC(I)=FRAC_IN/(2.D0**(I-1))
     FRAC_AC(I)=FRAC_AC(I)**EXP
  enddo loop_10399
  CALL CONMAP16(LINPT,SC,A0,CSINT,SNNT,X,Y,F,DFDX,&
       DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC,CSC)
  XCUT(1)=X1
  YCUT(1)=Y1
  KCUT=2
  FBEG=F(1)
  JADD=LINPT/LCUT
  JMIN=1
  loop_10400: DO JCUT=2,ICUT-1
     FBEG=FBEG/FRAC_AC(JCUT-1)
     F(LINPT+1)=FBEG*0.5D0
     JMIN=LINPT-1
     loop_10401: DO WHILE (KCUT.LE.JMIN.AND.F(KCUT).LE.FBEG) 
        KCUT=KCUT+1
     enddo loop_10401
     IF (KCUT.EQ.LINPT) THEN 
        NUM_CUT=JCUT
        loop_10402: DO MCUT=2,ICUT
           XCUT(MCUT)=XCUT(1)+(X2-XCUT(1))*DFLOAT(MCUT-1)/DFLOAT(ICUT-1)
           YCUT(MCUT)=YCUT(1)+(Y2-YCUT(1))*DFLOAT(MCUT-1)/DFLOAT(ICUT-1)
        enddo loop_10402
        GOTO 322
     ELSE
        XCUT(JCUT)=X1+(X2-X1)*(KCUT-1)*FRAC
        YCUT(JCUT)=Y1+(Y2-Y1)*(KCUT-1)*FRAC
     ENDIF
     FBEG=F(KCUT)
  enddo loop_10400
  XCUT(ICUT)=X2
  YCUT(ICUT)=Y2
  XD=XCUT(ICUT)-XCUT(ICUT-1)
  YD=YCUT(ICUT)-YCUT(ICUT-1)
  DL1=DSQRT(XD*XD+YD*YD)
  XD=XCUT(ICUT-2)-XCUT(ICUT-1)
  YD=YCUT(ICUT-2)-YCUT(ICUT-1)
  DL2=DSQRT(XD*XD+YD*YD)
  IF (DL2.GT.DL1) THEN
     XCUT(ICUT-1)=(XCUT(ICUT)+XCUT(ICUT-2))*0.5D0
     YCUT(ICUT-1)=(YCUT(ICUT)+YCUT(ICUT-2))*0.5D0
  ENDIF
  GOTO 321
322 JCUT=ICUT
321 NUM_CUT=JCUT      
  CONTINUE
  RETURN
END SUBROUTINE FIND_CUT

!******************************************************
! Conformal Mapping for the integration points.
SUBROUTINE CONMAPAS (NINPT,SC,A0,CSINT,SNNT,X1,Y1,F,DFDX,&
     DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)

  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)

  DIMENSION CSINT(1),SNNT(1)
  DIMENSION X1(1),Y1(1),F(1),DFDX(1),DFDY(1),DFDXY(1),DFDXX(1),&
       DFDYY(1)

  DOUBLE PRECISION, ALLOCATABLE ::TH(:),R22(:),R2(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  ALLOCATE(TH(INTM),R22(INTM),R2(INTM))
  TH=0.D0
  R22=0.D0
  R2=0.D0
  SC1=A0/SC
  SC2=SC1/SC
  loop_2: DO I=1,NTERM
     loop_1: DO J=1,NINPT
        X=X1(J)
        Y=Y1(J)
        IF (I.EQ.1) THEN
           F(J)=SQRT(X**2+Y**2)
           TH(J)=DATAN2(Y,X)
           R2(J)=F(J)**2
           R22(J)=R2(J)**2
           DFDX(J)=DCOS(TH(J))
           DFDY(J)=DSIN(TH(J))
           DFDXX(J)=DSIN(TH(J))**2/F(J)
           DFDYY(J)=DCOS(TH(J))**2/F(J)
           DFDXY(J)=-DSIN(TH(J))*DCOS(TH(J))/F(J)
        ENDIF
        DTX = -Y/R2(J)
        DTY = X/R2(J)
        DTXX = 2/R22(J)*Y*X
        DTYY = -2/R22(J)*Y*X
        DTXY = (Y**2-X**2)/R22(J)
        DTX2=DTX**2
        DTY2=DTY**2
        DXY2=DTX*DTY
        F(J)=F(J)-CSINT(I)*DCOS(I*TH(J))-SNNT(I)*DSIN(I*TH(J))
        DFDX(J)=DFDX(J)+(CSINT(I)*DSIN(I*TH(J))-SNNT(I)*&
             DCOS(I*TH(J)))*DTX*I
        DFDXX(J)=DFDXX(J)+(CSINT(I)*(DCOS(I*TH(J))*DTX2*I+&
             DSIN(I*TH(J))*DTXX)-SNNT(I)*(-DSIN(I*TH(J))*&
             I*DTX2+DCOS(I*TH(J))*DTXX))*I
        DFDY(J)=DFDY(J)+(CSINT(I)*DSIN(I*TH(J))-SNNT(I)*&
             DCOS(I*TH(J)))*DTY*I
        DFDYY(J)=DFDYY(J)+(CSINT(I)*(DCOS(I*TH(J))*DTY2*I+&
             DSIN(I*TH(J))*DTYY)-SNNT(I)*(-DSIN(I*TH(J))*I*&
             DTY2+DCOS(I*TH(J))*DTYY))*I
        DFDXY(J)=DFDXY(J)+(CSINT(I)*(DCOS(I*TH(J))*DXY2*I+&
             DSIN(I*TH(J))*DTXY)-SNNT(I)*(-DSIN(I*TH(J))*I*&
             DXY2+DCOS(I*TH(J))*DTXY))*I
        IF (I.EQ.NTERM) THEN      
           F(J)=F(J)/A0
           DFDX(J)=DFDX(J)/SC1
           DFDY(J)=DFDY(J)/SC1
           DFDXY(J)=DFDXY(J)/SC2
           DFDXX(J)=DFDXX(J)/SC2
           DFDYY(J)=DFDYY(J)/SC2
        ENDIF
     enddo loop_1
  enddo loop_2

  DEALLOCATE(TH,R22,R2)
  RETURN
END SUBROUTINE CONMAPAS

!******************************************************
! Subroutine gives the intersection point (X33,Y33) between ellipse
! described by XCENT,YCENT,A,B and Line connecting points (X11,Y11)
! and (X22,Y22)
SUBROUTINE INTERSECTION_POINT(XCENT,YCENT,X11,Y11,X22,Y22,A,B,THETA,X33,Y33)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  !     The information of the elipse
  PI=DATAN(1.D0)*4.D0
  THETA1=THETA*DATAN(1.D0)/4.5D1
  SN=DSIN(THETA1)
  CS=DCOS(THETA1)
  !     Define any two point w.r.t current configuration

  !     transform the coordinate of the two points 
  !     w.r.t a local and unit circle
  xx1=x11-XCENT
  yy1=y11-YCENT
  xx2=x22-XCENT
  yy2=y22-YCENT
  x11p=CS*xx1+SN*yy1
  y11p=-SN*xx1+CS*yy1
  x22p=CS*xx2+SN*yy2
  y22p=-SN*xx2+CS*yy2
  x11p=x11p/A
  y11p=y11p/B
  x22p=x22p/A
  y22p=y22p/B

  !     DL: the distance of the two points in local configuration
  XDIF=x11p-x22p
  YDIF=y11p-y22p
  DL=DSQRT(XDIF**2+YDIF**2)

  !     H: the distance between the center of the unit circle to 
  !     the line connected by the two point in local configuration
  H=(x22p*y11p-x11p*y22p)/DL
  !     SN1 & CS1: the sin and cos of the line connected by the two
  !     points w.r.t the local
  SN1=(y22p-y11p)/DL
  CS1=(x22p-x11p)/DL

  !     The coordinate of #3 point in rotated local configuration.
  IF(x11p**2+y11p**2.LE.1) THEN
     x33p1=DSQRT(1-H**2)
  ELSE
     x33p1=-DSQRT(1-H**2)
  ENDIF
  y33p1=H

  !     Get the coordinate of the #3 point w.r.t the unrotated local
  x33p=CS1*x33p1-SN1*y33p1
  y33p=SN1*x33p1+cs1*y33p1

  !     Transform w.r.t the corresponding ellipse
  x33p=x33p*A
  y33p=y33p*B
  !     Rotate w.r.t the current configuration
  x33=CS*x33p-SN*y33p
  y33=SN*X33p+CS*y33p

  !     Translate w.r.t the current configration
  x33=x33+XCENT
  y33=y33+YCENT
  RETURN
END SUBROUTINE INTERSECTION_POINT

!******************************************************
SUBROUTINE PRE_DISCRET(NELX,XP,YP,NODE,IJK,NINT,IJK1,IJK2)
!******************************************************

  implicit double precision(a-h, o-z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)

  COMMON /POLYBOUND/ POLYXY,NUMPOLY(NLM),BOUNDXY,NUMBOUND(NLM),&
       IBOUND(NLM,200),ANGBOUND(NLM,200)
  COMPLEX POLYXY(NLM,100),BOUNDXY(NLM,200,2)

  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /SCALPRM/ XCENT(NLM),YCENT(NLM),SCALE(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /SCALPRMC/ XCENTPP(NLM),YCENTPP(NLM),SCALEPP(NLM)
  COMMON /SIGRSING/ RSING
  COMMON /DISCCOORD/ SCOORD(NLM*INTM),TCOORD(NLM*INTM),&
       ITHETA(NLM*INTM),IRADIUS(NLM*INTM)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /SHPVOID/ FSCALE(NLM),CONFOUR(NLM),&
       CSFOUR(50,NLM),SNFOUR(50,NLM)
  COMMON /DISCSETUP/ IJK_SETUP(NLM)
  COMMON /DISCRETFLAG/  ISECUPDAT(NLM,200),NPBGSEC(NLM,200),NINTSEC(NLM,200)
  COMMON/ELEMNT/ NX,NELX1,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  DIMENSION NODE(NLM),IJK(NLM,NDELM/2),IJK1(NLM,NDELM/2),IJK2(NLM,NDELM/2),NINT(NLM,2)
  DIMENSION BETA(100),XP(1),YP(1),ANG2(1000)
  COMPLEX WTEMP,ZTEMP,WA1,WA2
  COMPLEX Z(100),W(100),C,POLY(100)
  DOUBLE PRECISION, ALLOCATABLE :: ISAME(:)

  ALLOCATE(ISAME(NX_CELL))
  !     ***************************
  !     IBOUND=1: projected from matrix boundary
  !     IBOUND=2: projected from interface boundary
  !     **********************
  PI=DATAN(1.D0)*4.D0
  ISECUPDAT=0
  loop_10756: DO I=1,NX_CELL
     ISAME(I)=0
     loop_10757: DO NEL=1,NELX
        loop_10758: DO J=1,NODE(NEL)
           IF(IJK(NEL,J).EQ.I) ISAME(I)=ISAME(I)+1 
        enddo loop_10758
     enddo loop_10757
  enddo loop_10756
  loop_10759: DO NEL=1,NELX
     ANG2=0
     XC=XCENTP(NEL)
     YC=YCENTP(NEL)
     XSC=XSCALEM(NEL)
     YSC=YSCALEM(NEL)
     CSC=ANM(NEL)
     CSC1=CSC*DATAN(1.D0)/4.5D1
     CS6=DCOS(CSC1)
     SN6=DSIN(CSC1)

     NUMPOLY(NEL)=0
     NUMBOUND(NEL)=0


     loop_10760: DO I=1,NODE(NEL)
        IFLAG=0
        IF(I.EQ.1) THEN
           IPREV=IJK(NEL,NODE(NEL))
        ELSE
           IPREV=IJK(NEL,I-1)
        ENDIF
        IF(I.EQ.NODE(NEL)) THEN
           INEXT=IJK(NEL,1)
        ELSE
           INEXT=IJK(NEL,I+1)
        ENDIF
        WA1=DCMPLX(XP(INEXT),YP(INEXT))-DCMPLX(XP(IJK(NEL,I)),YP(IJK(NEL,I)))
        WA2=DCMPLX(XP(IPREV),YP(IPREV))-DCMPLX(XP(IJK(NEL,I)),YP(IJK(NEL,I)))
        cosA1A2=DABS(DABS(DBLE(WA1)*DBLE(WA2)+AIMAG(WA1)*AIMAG(WA2))&
             /CDABS(WA1)/CDABS(WA2))
        IF(DABS(cosA1A2-1).LT.1.D-3) IFLAG=1
        IF(ISAME(IJK(NEL,I)).GT.2) IFLAG=0
        IF(NELX.EQ.1) IFLAG=0
        IF(IFLAG.EQ.0) THEN
           X1=XP(IJK(NEL,I))-XC
           Y1=YP(IJK(NEL,I))-YC
           X11=(X1*CS6+Y1*SN6)/XSC
           Y11=(-X1*SN6+Y1*CS6)/YSC
           ANGTMP=DATAN2(Y11,X11)
           IF(ANGTMP.LT.0) THEN
              ANGTMP=2*PI+ANGTMP
           ENDIF
           NUMPOLY(NEL)=NUMPOLY(NEL)+1
           POLYXY(NEL,NUMPOLY(NEL))=DCMPLX(XP(IJK(NEL,I)),YP(IJK(NEL,I)))
           NUMBOUND(NEL)=NUMBOUND(NEL)+1
           ISECUPDAT(NEL,NUMBOUND(NEL))=1
           ANG2(NUMBOUND(NEL))=ANGTMP
           BOUNDXY(NEL,NUMBOUND(NEL),1)=DCMPLX(XP(IJK(NEL,I)),YP(IJK(NEL,I)))
           X11=1*DCOS(ANGTMP)*XSC
           Y11=1*DSIN(ANGTMP)*YSC
           X1=X11*CS6-Y11*SN6
           Y1=X11*SN6+Y11*CS6
           loop_10761: DO J=1,NINT(NEL,1)
              IF(CDABS(DCMPLX(XP(IJK1(NEL,J)),YP(IJK1(NEL,J)))&
                   -DCMPLX(X1+XC,Y1+YC)).LE.1.E-6) THEN
                 X1=XP(IJK1(NEL,J))-XC
                 Y1=YP(IJK1(NEL,J))-YC
              ENDIF
           enddo loop_10761
           BOUNDXY(NEL,NUMBOUND(NEL),2)=DCMPLX(X1+XC,Y1+YC)
           IBOUND(NEL,NUMBOUND(NEL))=1
           X11=(X1*CS6+Y1*SN6)/XSC
           Y11=(-X1*SN6+Y1*CS6)/YSC
           ANGTMP=DATAN2(Y11,X11)
           IF(ANGTMP.LT.0) THEN
              ANGTMP=2*PI+ANGTMP
           ENDIF
           ANGBOUND(NEL,NUMBOUND(NEL))=ANGTMP
        ENDIF
     enddo loop_10760
     NEND2=NUMBOUND(NEL)
     loop_10762: DO I=1,NINT(NEL,1)
        X1=XP(IJK1(NEL,I))-XC
        Y1=YP(IJK1(NEL,I))-YC
        X11=(X1*CS6+Y1*SN6)/XSC
        Y11=(-X1*SN6+Y1*CS6)/YSC
        IF(I.EQ.1) THEN
           ANGTMP=0.D0
        ELSE
           ANGTMP=DATAN2(Y11,X11)
        ENDIF
        IF(ANGTMP.LT.0) THEN
           ANGTMP=2*PI+ANGTMP
        ENDIF
        IFIND=0
        loop_10763: DO I1=1,NEND2
           IF(DABS(ANGTMP-ANGBOUND(NEL,I1)).LT.PI/180.D0.OR.&
                DABS(DABS(ANGTMP-ANGBOUND(NEL,I1))-2*PI).LT.PI/180.D0) THEN
              IFIND=1
              BOUNDXY(NEL,I1,2)=DCMPLX(XP(IJK1(NEL,I)),YP(IJK1(NEL,I)))
              ANGBOUND(NEL,I1)=ANGTMP
              IBOUND(NEL,I1)=1
              EXIT
           ENDIF
        enddo loop_10763
        IF(IFIND.EQ.0) THEN
           NUMBOUND(NEL)=NUMBOUND(NEL)+1
           ISECUPDAT(NEL,NUMBOUND(NEL))=1        
           ANG2(NUMBOUND(NEL))=ANGTMP
           IBOUND(NEL,NUMBOUND(NEL))=2
           ANGBOUND(NEL,NUMBOUND(NEL))=ANGTMP
           BOUNDXY(NEL,NUMBOUND(NEL),2)=DCMPLX(XP(IJK1(NEL,I)),YP(IJK1(NEL,I)))

           xm1=XC
           ym1=YC
           xm2=XP(IJK1(NEL,I))
           ym2=YP(IJK1(NEL,I))
           IFIND=0
           ANGTMP1=DATAN2(ym1-ym2,xm1-xm2)
           loop_10764: DO J=1,NODE(NEL)

              IF(J.EQ.NODE(NEL)) THEN
                 INEXT=IJK(NEL,1)
              ELSE
                 INEXT=IJK(NEL,J+1)
              ENDIF
              xs1=XP(IJK(NEL,J))
              ys1=YP(IJK(NEL,J))
              xs2=XP(INEXT)
              ys2=YP(INEXT)
              ANGTMP2=DATAN2(ys1-ys2,xs1-xs2)
              IF(DABS(ANGTMP1-ANGTMP2).LT.1.E-3.OR.&
                   DABS(PI-DABS(ANGTMP1-ANGTMP2)).LT.1.E-3) THEN
                 CONTINUE
              ELSE
                 XINT=((xs2*ys1-xs1*ys2)*(xm2-xm1)-&
                      (xm2*ym1-xm1*ym2)*(xs2-xs1))/&
                      ((ys1-ys2)*(xm2-xm1)-(ym1-ym2)*(xs2-xs1))
                 YINT=((xs2*ys1-xs1*ys2)*(ym1-ym2)-&
                      (xm2*ym1-xm1*ym2)*(ys1-ys2))/&
                      ((xs2-xs1)*(ym1-ym2)-(xm2-xm1)*(ys1-ys2))
                 loop_10765: DO IJ=1,NODE(NEL)
                    XX1=XP(IJK(NEL,IJ))
                    YY1=YP(IJK(NEL,IJ))
                    IF(CDABS(DCMPLX(XINT,YINT)-DCMPLX(XX1,YY1)).LT.1.E-5) THEN
                       XINT=XX1
                       YINT=YY1
                    ENDIF
                 enddo loop_10765
                 dl=dsqrt((xs1-xs2)**2+(ys1-ys2)**2)
                 dl1=dsqrt((xint-xs2)**2+(yint-ys2)**2)
                 dl2=dsqrt((xs1-xint)**2+(ys1-yint)**2)
                 X1=XINT-XC
                 Y1=YINT-YC
                 X11=(X1*CS6+Y1*SN6)/XSC
                 Y11=(-X1*SN6+Y1*CS6)/YSC
                 ANGTMP=DATAN2(Y11,X11)
                 IF(ANGTMP.LT.0) THEN
                    ANGTMP=2*PI+ANGTMP
                 ENDIF
                 if(dl1.LE.dl.AND.dl2.LE.dl.AND.&
                      (DABS(ANGTMP-ANG2(NUMBOUND(NEL))).LT.PI/4.D0&
                      .OR.DABS(2*PI-DABS(ANGTMP-ANG2(NUMBOUND(NEL)))).LT.PI/4.D0)) THEN
                    BOUNDXY(NEL,NUMBOUND(NEL),1)=DCMPLX(XINT,YINT)
                    KFIND=0
                    loop_10766: DO J1=1,NEND2
                       IF(CDABS(DCMPLX(xs1,ys1)-BOUNDXY(NEL,J1,1)).LT.1.E-8) THEN
                          KFIND=1
                       ENDIF
                    enddo loop_10766
                    IF(KFIND.EQ.0) THEN
                       X1=xs1-XC
                       Y1=ys1-YC
                       X11=(X1*CS6+Y1*SN6)/XSC
                       Y11=(-X1*SN6+Y1*CS6)/YSC
                       ANGT1=DATAN2(Y11,X11)
                       IF(ANGT1.LT.0) THEN
                          ANGT1=2*PI+ANGT1
                       ENDIF
                       IF(DABS(ANGT1-ANGTMP).LT.PI/180.D0.OR.&
                            2*PI-DABS(ANGT1-ANGTMP).LT.PI/180.D0) THEN
                          BOUNDXY(NEL,NUMBOUND(NEL),1)=DCMPLX(xs1,ys1)
                       ENDIF
                    ENDIF
                    KFIND=0
                    loop_10767: DO J1=1,NEND2
                       IF(CDABS(DCMPLX(xs2,ys2)-BOUNDXY(NEL,J1,1)).LT.1.E-8) THEN
                          KFIND=1
                       ENDIF
                    enddo loop_10767
                    IF(KFIND.EQ.0) THEN
                       X1=xs2-XC
                       Y1=ys2-YC
                       X11=(X1*CS6+Y1*SN6)/XSC
                       Y11=(-X1*SN6+Y1*CS6)/YSC
                       ANGT1=DATAN2(Y11,X11)
                       IF(ANGT1.LT.0) THEN
                          ANGT1=2*PI+ANGT1
                       ENDIF
                       IF(DABS(ANGT1-ANGTMP).LT.PI/180.D0.OR.&
                            2*PI-DABS(ANGT1-ANGTMP).LT.PI/180.D0) THEN
                          BOUNDXY(NEL,NUMBOUND(NEL),1)=DCMPLX(xs2,ys2)
                       ENDIF
                    ENDIF

                    IFIND=1
                    EXIT
                 ENDIF
              ENDIF
           enddo loop_10764
           IF(IFIND.NE.1) THEN
              write(*,*) "Cannot find a intersection point!!!"
              stop
           ENDIF
        ENDIF
     enddo loop_10762
     !     SORTING ARRAY IN INCREASING ORDER
     loop_10768: DO I=1,NUMBOUND(NEL)-1
        loop_10769: DO J=I+1,NUMBOUND(NEL)
           IF (ANGBOUND(NEL,J) .LT. ANGBOUND(NEL,I)) THEN
              TEMP=ANG2(I)
              ANG2(I)=ANG2(J)
              ANG2(J)=TEMP
              TEMP=ANGBOUND(NEL,I)
              ANGBOUND(NEL,I)=ANGBOUND(NEL,J)
              ANGBOUND(NEL,J)=TEMP
              ITEMP=IBOUND(NEL,I)
              IBOUND(NEL,I)=IBOUND(NEL,J)
              IBOUND(NEL,J)=ITEMP
              ZTEMP=BOUNDXY(NEL,I,1)
              BOUNDXY(NEL,I,1)=BOUNDXY(NEL,J,1)
              BOUNDXY(NEL,J,1)=ZTEMP
              ITEMP=ISECUPDAT(NEL,I)
              ISECUPDAT(NEL,I)=ISECUPDAT(NEL,J)
              ISECUPDAT(NEL,J)=ITEMP
              ZTEMP=BOUNDXY(NEL,I,2)
              BOUNDXY(NEL,I,2)=BOUNDXY(NEL,J,2)
              BOUNDXY(NEL,J,2)=ZTEMP
           ENDIF
        enddo loop_10769
     enddo loop_10768
     loop_20830: DO I1=1,NUMBOUND(NEL)
        X1=DBLE(BOUNDXY(NEL,I1,1))-XC
        Y1=AIMAG(BOUNDXY(NEL,I1,1))-YC
        X11=(X1*CS6+Y1*SN6)/XSC
        Y11=(-X1*SN6+Y1*CS6)/YSC
        ANGTMP=DATAN2(Y11,X11)
        IF(ANGTMP.LT.0) THEN
           ANGTMP=2*PI+ANGTMP
        ENDIF
        J1=I1-1
        IF(I1.EQ.1) J1=NUMBOUND(NEL)
        X1=DBLE(BOUNDXY(NEL,J1,1))-XC
        Y1=AIMAG(BOUNDXY(NEL,J1,1))-YC
        X11=(X1*CS6+Y1*SN6)/XSC
        Y11=(-X1*SN6+Y1*CS6)/YSC
        ANGTMP1=DATAN2(Y11,X11)
        IF(ANGTMP1.LT.0) THEN
           ANGTMP1=2*PI+ANGTMP1
        ENDIF
        IF(DABS(ANGTMP-ANGTMP1).GT.PI) THEN
           IF(ANGTMP.LT.PI/2.D0) THEN
              ANGTMP=2*PI+ANGTMP
           ELSEIF(ANGTMP.GT.PI+PI/2.D0) THEN
              ANGTMP1=2*PI+ANGTMP1
           ENDIF
        ENDIF
        if(ANGTMP1.GT.ANGTMP) THEN
           ZTEMP=BOUNDXY(NEL,J1,1)
           BOUNDXY(NEL,J1,1)=BOUNDXY(NEL,I1,1)
           BOUNDXY(NEL,I1,1)=ZTEMP
           ITEMP=IBOUND(NEL,J1)
           IBOUND(NEL,J1)=IBOUND(NEL,I1)
           IBOUND(NEL,I1)=ITEMP
        ENDIF
     enddo loop_20830
  enddo loop_10759

  !     Check all the possible points on the matrix boundary and adjust too close point
  loop_10790: DO NEL=1,NELX
     XC=XCENTP(NEL)
     YC=YCENTP(NEL)
     XSC=XSCALEM(NEL)
     YSC=YSCALEM(NEL)
     CSC=ANM(NEL)
     CSC1=CSC*DATAN(1.D0)/4.5D1
     CS6=DCOS(CSC1)
     SN6=DSIN(CSC1)

     loop_10791: DO I=1,NUMPOLY(NEL)
        I1=I
        IF(I.EQ.NUMPOLY(NEL)) THEN
           I2=1
        ELSE
           I2=I+1
        ENDIF
        XX1=DBLE(POLYXY(NEL,I1))
        YY1=AIMAG(POLYXY(NEL,I1))
        XX2=DBLE(POLYXY(NEL,I2))
        YY2=AIMAG(POLYXY(NEL,I2))
        loop_10792: DO J=1,NUMBOUND(NEL)
           IF(CDABS(BOUNDXY(NEL,J,1)-DCMPLX(XX1,YY1)).LT.1.E-8) THEN
              ANGT1=ANGBOUND(NEL,J)
           ENDIF
           IF(CDABS(BOUNDXY(NEL,J,1)-DCMPLX(XX2,YY2)).LT.1.E-8) THEN
              ANGT2=ANGBOUND(NEL,J)
           ENDIF
        enddo loop_10792
        IFIND=0
        loop_10793: DO INEL=1,NELX
           IF(INEL.NE.NEL) THEN
              loop_10794: DO J=1,NUMPOLY(INEL)
                 J1=J
                 IF(J.EQ.NUMPOLY(INEL)) THEN
                    J2=1
                 ELSE
                    J2=J+1
                 ENDIF
                 XX3=DBLE(POLYXY(INEL,J1))
                 YY3=AIMAG(POLYXY(INEL,J1))
                 XX4=DBLE(POLYXY(INEL,J2))
                 YY4=AIMAG(POLYXY(INEL,J2))
                 IF((DABS(XX1-XX4)+DABS(XX2-XX3)+&
                      DABS(YY1-YY4)+DABS(YY2-YY3)).LT.1.E-3) THEN
                    IFIND=1
                    EXIT
                 ENDIF
              enddo loop_10794
              IF(IFIND.EQ.1) THEN
                 EXIT
              ENDIF
           ENDIF
        enddo loop_10793
        IF(IFIND.EQ.1) THEN
           loop_10795: DO J=NUMBOUND(INEL),1,-1
              XX4=DBLE(BOUNDXY(INEL,J,1))
              YY4=AIMAG(BOUNDXY(INEL,J,1))
              IF(DABS(XX1-XX4)+DABS(YY1-YY4).LT.1.E-3) THEN
                 EXIT
              ENDIF
           enddo loop_10795
           J=J-1
           IF(J.EQ.0) J=NUMBOUND(INEL)
           XX3=DBLE(BOUNDXY(INEL,J,1))
           YY3=AIMAG(BOUNDXY(INEL,J,1))
           loop_10796: DO WHILE(DABS(XX2-XX3)+DABS(YY2-YY3).GT.1.E-3)
              X1=XX3-XC
              Y1=YY3-YC
              X11=(X1*CS6+Y1*SN6)/XSC
              Y11=(-X1*SN6+Y1*CS6)/YSC
              ANGTMP=DATAN2(Y11,X11)
              IF(ANGTMP.LT.0) THEN
                 ANGTMP=2*PI+ANGTMP
              ENDIF
              IFIND=0
              loop_10797: DO J1=1,NUMBOUND(NEL)
                 KFIND1=0
                 IF(ANGT1.GT.ANGT2) THEN
                    IF(ANGBOUND(NEL,J1).GT.ANGT1.AND.ANGBOUND(NEL,J1).LT.2*PI) THEN
                       KFIND1=1
                    ENDIF
                    IF(ANGBOUND(NEL,J1).GT.0.D0.AND.ANGBOUND(NEL,J1).LT.ANGT2) THEN
                       KFIND1=1
                    ENDIF
                 ELSE
                    IF(ANGBOUND(NEL,J1).GT.ANGT1.AND.ANGBOUND(NEL,J1).LT.ANGT2) THEN
                       KFIND1=1
                    ENDIF
                 ENDIF
                 IF(KFIND1.EQ.1) THEN
                    IF(DABS(ANGBOUND(NEL,J1)-ANGTMP).LT.PI/180.D0.AND.&
                         BOUNDXY(NEL,J1,1).NE.BOUNDXY(INEL,J,1)) THEN
                       IF(IBOUND(NEL,J1).NE.1) THEN
                          IFIND1=0
                          loop_10798: DO J2=1,NUMBOUND(NEL)
                             IF(J2.NE.J1.AND.CDABS(BOUNDXY(NEL,J2,1)-&
                                  BOUNDXY(INEL,J,1)).LT.1.E-6) THEN
                                IFIND1=1
                                EXIT
                             ENDIF
                          enddo loop_10798
                          if(IFIND1.EQ.0) THEN
                             BOUNDXY(NEL,J1,1)=BOUNDXY(INEL,J,1)
                          ENDIF
                       ELSE
                          !     Check if the # INEL element already have this point.
                          IFIND1=0
                          loop_10799: DO J2=1,NUMBOUND(INEL)
                             IF(CDABS(BOUNDXY(INEL,J2,1)-&
                                  BOUNDXY(NEL,J1,1)).LT.1.E-6) THEN
                                IFIND1=1
                                EXIT
                             ENDIF
                          enddo loop_10799

                          IF(IFIND1.EQ.0) THEN
                             BOUNDXY(INEL,J,1)=BOUNDXY(NEL,J1,1)
                          ELSE

                          ENDIF
                       ENDIF
                       EXIT
                    ENDIF
                 ENDIF
              enddo loop_10797
              J=J-1
              IF(J.EQ.0) J=NUMBOUND(INEL)
              XX3=DBLE(BOUNDXY(INEL,J,1))
              YY3=AIMAG(BOUNDXY(INEL,J,1))
           enddo loop_10796

        ENDIF
     enddo loop_10791
  enddo loop_10790


  !     generate the complete BOUNDXY for discretization
  loop_10810: DO NEL=1,NELX
     XC=XCENTP(NEL)
     YC=YCENTP(NEL)
     XSC=XSCALEM(NEL)
     YSC=YSCALEM(NEL)
     CSC=ANM(NEL)
     CSC1=CSC*DATAN(1.D0)/4.5D1
     CS6=DCOS(CSC1)
     SN6=DSIN(CSC1)
     loop_10811: DO I=1,NUMPOLY(NEL)
        I1=I
        IF(I.EQ.NUMPOLY(NEL)) THEN
           I2=1
        ELSE
           I2=I+1
        ENDIF
        XX1=DBLE(POLYXY(NEL,I1))
        YY1=AIMAG(POLYXY(NEL,I1))
        XX2=DBLE(POLYXY(NEL,I2))
        YY2=AIMAG(POLYXY(NEL,I2))
        IFIND=0
        loop_10812: DO INEL=1,NELX
           loop_10813: DO J=1,NUMPOLY(INEL)
              J1=J
              IF(J.EQ.NUMPOLY(INEL)) THEN
                 J2=1
              ELSE
                 J2=J+1
              ENDIF
              XX3=DBLE(POLYXY(INEL,J1))
              YY3=AIMAG(POLYXY(INEL,J1))
              XX4=DBLE(POLYXY(INEL,J2))
              YY4=AIMAG(POLYXY(INEL,J2))
              IF((DABS(XX1-XX4)+DABS(XX2-XX3)+&
                   DABS(YY1-YY4)+DABS(YY2-YY3)).LT.1.E-3) THEN
                 IFIND=1
                 EXIT
              ENDIF
           enddo loop_10813
           IF(IFIND.EQ.1) THEN
              EXIT
           ENDIF
        enddo loop_10812
        IF(IFIND.EQ.1) THEN
           loop_10814: DO J=NUMBOUND(INEL),1,-1
              XX4=DBLE(BOUNDXY(INEL,J,1))
              YY4=AIMAG(BOUNDXY(INEL,J,1))
              IF(DABS(XX1-XX4)+DABS(YY1-YY4).LT.1.E-3) THEN
                 EXIT
              ENDIF
           enddo loop_10814
           J=J-1
           IF(J.EQ.0) J=NUMBOUND(INEL)
           XX3=DBLE(BOUNDXY(INEL,J,1))
           YY3=AIMAG(BOUNDXY(INEL,J,1))
           loop_10815: DO WHILE(DABS(XX2-XX3)+DABS(YY2-YY3).GT.1.E-3)
              IFIND=0
              loop_10816: DO J1=1,NUMBOUND(NEL)
                 X1=DBLE(BOUNDXY(NEL,J1,1))-XC
                 Y1=AIMAG(BOUNDXY(NEL,J1,1))-YC
                 X11=(X1*CS6+Y1*SN6)/XSC
                 Y11=(-X1*SN6+Y1*CS6)/YSC
                 ANGTMP1=DATAN2(Y11,X11)
                 IF(ANGTMP1.LT.0) THEN
                    ANGTMP1=2*PI+ANGTMP1
                 ENDIF
                 X1=DBLE(BOUNDXY(INEL,J,1))-XC
                 Y1=AIMAG(BOUNDXY(INEL,J,1))-YC
                 X11=(X1*CS6+Y1*SN6)/XSC
                 Y11=(-X1*SN6+Y1*CS6)/YSC
                 ANGTMP2=DATAN2(Y11,X11)
                 IF(ANGTMP2.LT.0) THEN
                    ANGTMP2=2*PI+ANGTMP2
                 ENDIF
                 IF(DABS(ANGTMP1-ANGTMP2).GT.PI) THEN
                    IF(ANGTMP1.GT.PI) ANGTMP2=ANGTMP2+2*PI
                    IF(ANGTMP2.GT.PI) ANGTMP1=ANGTMP1+2*PI
                 ENDIF
                 IF(CDABS(BOUNDXY(NEL,J1,1)-BOUNDXY(INEL,J,1)).LT.1.E-8) THEN
                    IFIND=1
                    EXIT
                 ENDIF
                 IF(DABS(ANGTMP1-ANGTMP2).LT.PI/180.D0.AND.IFIND.EQ.0) THEN
                    IFIND=1
                    loop_10817: DO J2=1,NUMBOUND(INEL)
                       IF(CDABS(BOUNDXY(NEL,J1,1)-BOUNDXY(INEL,J2,1)).LT.1.E-8) THEN
                          IFIND=0
                          EXIT
                       ENDIF
                    enddo loop_10817
                    IF(IFIND.EQ.1) THEN
                       BOUNDXY(INEL,J,1)=BOUNDXY(NEL,J1,1)
                    ENDIF
                    EXIT
                 ENDIF
              enddo loop_10816
              IF(IFIND.EQ.0) THEN
                 NUMBOUND(NEL)=NUMBOUND(NEL)+1
                 ISECUPDAT(NEL,NUMBOUND(NEL))=1
                 BOUNDXY(NEL,NUMBOUND(NEL),1)=BOUNDXY(INEL,J,1)
                 X1=XX3-XC
                 Y1=YY3-YC
                 X11=(X1*CS6+Y1*SN6)/XSC
                 Y11=(-X1*SN6+Y1*CS6)/YSC
                 ANGTMP=DATAN2(Y11,X11)
                 IF(ANGTMP.LT.0) THEN
                    ANGTMP=2*PI+ANGTMP
                 ENDIF
                 X11=1*DCOS(ANGTMP)*XSC
                 Y11=1*DSIN(ANGTMP)*YSC
                 X1=X11*CS6-Y11*SN6
                 Y1=X11*SN6+Y11*CS6
                 BOUNDXY(NEL,NUMBOUND(NEL),2)=DCMPLX(X1+XC,Y1+YC)
                 IBOUND(NEL,NUMBOUND(NEL))=1
                 X11=(X1*CS6+Y1*SN6)/XSC
                 Y11=(-X1*SN6+Y1*CS6)/YSC
                 ANGTMP=DATAN2(Y11,X11)
                 IF(ANGTMP.LT.0) THEN
                    ANGTMP=2*PI+ANGTMP
                 ENDIF
                 ANGBOUND(NEL,NUMBOUND(NEL))=ANGTMP
              ENDIF
              J=J-1
              IF(J.EQ.0) J=NUMBOUND(INEL)
              XX3=DBLE(BOUNDXY(INEL,J,1))
              YY3=AIMAG(BOUNDXY(INEL,J,1))
           enddo loop_10815

        ENDIF

     enddo loop_10811

     !     SORTING ARRAY IN INCREASING ORDER
     loop_10826: DO I1=1,NUMBOUND(NEL)-1
        loop_10827: DO J1=I1+1,NUMBOUND(NEL)
           IF (ANGBOUND(NEL,J1) .LT. ANGBOUND(NEL,I1)) THEN
              TEMP=ANGBOUND(NEL,I1)
              ANGBOUND(NEL,I1)=ANGBOUND(NEL,J1)
              ANGBOUND(NEL,J1)=TEMP
              ITEMP=IBOUND(NEL,I1)
              IBOUND(NEL,I1)=IBOUND(NEL,J1)
              IBOUND(NEL,J1)=ITEMP
              ZTEMP=BOUNDXY(NEL,I1,1)
              BOUNDXY(NEL,I1,1)=BOUNDXY(NEL,J1,1)
              BOUNDXY(NEL,J1,1)=ZTEMP
              ZTEMP=BOUNDXY(NEL,I1,2)
              BOUNDXY(NEL,I1,2)=BOUNDXY(NEL,J1,2)
              BOUNDXY(NEL,J1,2)=ZTEMP
              ITEMP=ISECUPDAT(NEL,I1)
              ISECUPDAT(NEL,I1)=ISECUPDAT(NEL,J1)
              ISECUPDAT(NEL,J1)=ITEMP
           ENDIF
        enddo loop_10827
     enddo loop_10826

     !     Check to sure there is no cross in BOUNDXY
     loop_10830: DO I1=1,NUMBOUND(NEL)
        X1=DBLE(BOUNDXY(NEL,I1,1))-XC
        Y1=AIMAG(BOUNDXY(NEL,I1,1))-YC
        X11=(X1*CS6+Y1*SN6)/XSC
        Y11=(-X1*SN6+Y1*CS6)/YSC
        ANGTMP=DATAN2(Y11,X11)
        IF(ANGTMP.LT.0) THEN
           ANGTMP=2*PI+ANGTMP
        ENDIF
        J1=I1-1
        IF(I1.EQ.1) J1=NUMBOUND(NEL)
        X1=DBLE(BOUNDXY(NEL,J1,1))-XC
        Y1=AIMAG(BOUNDXY(NEL,J1,1))-YC
        X11=(X1*CS6+Y1*SN6)/XSC
        Y11=(-X1*SN6+Y1*CS6)/YSC
        ANGTMP1=DATAN2(Y11,X11)
        IF(ANGTMP1.LT.0) THEN
           ANGTMP1=2*PI+ANGTMP1
        ENDIF
        IF(DABS(ANGTMP-ANGTMP1).GT.PI) THEN
           IF(ANGTMP.LT.PI/2.D0) THEN
              ANGTMP=2*PI+ANGTMP
           ELSEIF(ANGTMP.GT.PI+PI/2.D0) THEN
              ANGTMP1=2*PI+ANGTMP1
           ENDIF
        ENDIF
        if(ANGTMP1.GT.ANGTMP) THEN
           ZTEMP=BOUNDXY(NEL,J1,1)
           BOUNDXY(NEL,J1,1)=BOUNDXY(NEL,I1,1)
           BOUNDXY(NEL,I1,1)=ZTEMP
           ITEMP=IBOUND(NEL,J1)
           IBOUND(NEL,J1)=IBOUND(NEL,I1)
           IBOUND(NEL,I1)=ITEMP
        ENDIF
     enddo loop_10830
  enddo loop_10810


  RETURN
END SUBROUTINE PRE_DISCRET

!******************************************************
! Subrouting for discretising elliptical inclusion geometry
SUBROUTINE DISCRET_ELLIP (NELX,NEL,IRD2,XP,YP,NODE,IJK,NINT&
     ,IJK1,IJK2,NBETA,K1,XTEMP,YTEMP,GJACTMP,IRAD_TEMP,ITHET_TEMP)
!******************************************************

  implicit double precision(a-h, o-z)

  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  DIMENSION XDIV5(6),YDIV5(6),SH(6),GDN(6,2)
  DIMENSION X5(6),Y5(6),XCUT(10,3),YCUT(10,3)

  COMMON /POLYBOUND/ POLYXY,NUMPOLY(NLM),BOUNDXY,NUMBOUND(NLM),&
       IBOUND(NLM,200),ANGBOUND(NLM,200)
  COMPLEX POLYXY(NLM,100),BOUNDXY(NLM,200,2)

  COMMON /GAUQUAD/ W(1275),BP(1275),INTBEG(50)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /SCALPRM/ XCENT(NLM),YCENT(NLM),SCALE(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /SCALPRMC/ XCENTPP(NLM),YCENTPP(NLM),SCALEPP(NLM)
  COMMON /SIGRSING/ RSING
  COMMON /DISCCOORD/ SCOORD(NLM*INTM),TCOORD(NLM*INTM),&
       ITHETA(NLM*INTM),IRADIUS(NLM*INTM)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /SHPVOID/ FSCALE(NLM),CONFOUR(NLM),&
       CSFOUR(50,NLM),SNFOUR(50,NLM)
  COMMON /DISCSETUP/ IJK_SETUP(NLM)
  COMMON /DISCRETFLAG/  ISECUPDAT(NLM,200),NPBGSEC(NLM,200),NINTSEC(NLM,200)
  COMMON /DAMELEM/ XDAMG(NLM),YDAMG(NLM),ORDAMG(NLM),IDAMG(NLM)
  COMMON /REDOGM/ IREDO_GM(NLM)
  DIMENSION NODE(NLM),IJK(NLM,NDELM/2),IJK1(NLM,NDELM/2),IJK2(NLM,NDELM/2),NINT(NLM,2),NBETA(NLM)
  DIMENSION XP(1),YP(1)
  DIMENSION RADIN(1000),ANG2(1000)
  DIMENSION  XTEMP(INTM),YTEMP(INTM),GJACTMP(INTM)
  DIMENSION  IANG(1000),IUPD(1000)
  COMPLEX ANGXY(1000),ANGXY1(1000),ZTEMP,WA1,WA2
  DIMENSION NPBGSEC_TMP(200)
  DIMENSION IRAD_TEMP(INTM),ITHET_TEMP(INTM)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  !     ***************************
  !     IANG=1: projected from matrix boundary
  !     IANG=2: projected from interface boundary
  !     ANG2:  the theta on the projected plane
  !     ANGXY is for matrix boundary
  !     ANGXY1 is for interface boundary
  !     **********************

  PI=DATAN(1.D0)*4.D0
  IF (MCRACK(NEL).NE.0) THEN
     KTYP=1
     XSCM=XSCALEM(NEL)
     YSCM=YSCALEM(NEL)
     CSCM=ANM(NEL)
     XCM=XCENTP(NEL)
     YCM=YCENTP(NEL)
  ELSEIF (MCRACK(NEL).EQ.0) THEN
     KTYP=2
     A0=CONFOUR(NEL)
     XCM=XCENTPP(NEL)
     YCM=YCENTPP(NEL)
  ENDIF
  SC=SCALE(NEL)
  SCP=SCALEP(NEL)
  ICUT=4
  XC=XCENTP(NEL)
  YC=YCENTP(NEL)
  XSC=XSCALEM(NEL)
  YSC=YSCALEM(NEL)
  CSC=ANM(NEL)
  CSC1=CSC*DATAN(1.D0)/4.5D1
  CS6=DCOS(CSC1)
  SN6=DSIN(CSC1)
  NEND2=0
  ANG2=0
  IANG=0
  ANGXY=0
  ANGXY1=0
  radin=0
  IUPD=0
  XLEN_INC=0.D0

  AREA_MAT=0.D0

  loop_10832: DO I=1,NUMBOUND(NEL)
     ANG2(I)=ANGBOUND(NEL,I)
     IANG(I)=IBOUND(NEL,I)
     IUPD(I)=ISECUPDAT(NEL,I)
     ANGXY(I)=BOUNDXY(NEL,I,1)
     ANGXY1(I)=BOUNDXY(NEL,I,2)
     XINT=DBLE(ANGXY(I))
     YINT=AIMAG(ANGXY(I))
     X1=XINT-XC
     Y1=YINT-YC
     X11=(X1*CS6+Y1*SN6)/XSC
     Y11=(-X1*SN6+Y1*CS6)/YSC
     radin(I)=dsqrt((X11)**2+(Y11)**2)
     IF(I.NE.NUMBOUND(NEL)) THEN
        XLEN_INC=XLEN_INC+CDABS(BOUNDXY(NEL,I,2)-BOUNDXY(NEL,I+1,2))
     ELSE
        XLEN_INC=XLEN_INC+CDABS(BOUNDXY(NEL,I,2)-BOUNDXY(NEL,1,2))
     ENDIF
  enddo loop_10832
  NEND2=NUMBOUND(NEL)

  !     SORTING ARRAY IN INCREASING ORDER      
  NRADLINES2=NEND2
  loop_10833: DO I=1,NRADLINES2-1
     loop_10834: DO J=I+1,NRADLINES2
        IF (ANG2(J) .LT. ANG2(I)) THEN
           TEMP=ANG2(I)
           ANG2(I)=ANG2(J)
           ANG2(J)=TEMP
           ZTEMP=ANGXY(I)
           ANGXY(I)=ANGXY(J)
           ANGXY(J)=ZTEMP
           ZTEMP=ANGXY1(I)
           ANGXY1(I)=ANGXY1(J)
           ANGXY1(J)=ZTEMP
           ITEMP=IANG(I)
           IANG(I)=IANG(J)
           IANG(J)=ITEMP
           ITEMP=IUPD(I)
           IUPD(I)=IUPD(J)
           IUPD(J)=ITEMP
           rd=radin(I)
           radin(I)=radin(J)
           radin(J)=rd
        ENDIF
     enddo loop_10834
  enddo loop_10833

  !     ***************Add a mid angle between neighbor pair*********
  loop_10835: DO I=1,NRADLINES2
     ANGTMP=0.D0
     IFLAG=0
     IF(I.EQ.NRADLINES2) THEN
        WA1=ANGXY(I)
        WA2=ANGXY(1)
        ANGT1=(ANG2(I)+2*PI)/2
        ANGT2=(ANG2(I)+2*PI)/2

        ANGXY(NEND2+1)=(WA1+WA2)/2.D0
        X1=DBLE(ANGXY(NEND2+1))-XC
        Y1=AIMAG(ANGXY(NEND2+1))-YC
        X11=(X1*CS6+Y1*SN6)/XSC
        Y11=(-X1*SN6+Y1*CS6)/YSC
        radin(NEND2+1)=dsqrt((X11)**2+(Y11)**2)
        ANGTMP=DATAN2(Y11,X11)
        ANGTMP=(ANG2(I)+2*PI)/2
        IF(ANGTMP.LT.0) THEN
           ANGTMP=2*PI+ANGTMP
        ENDIF
        ANG2(NEND2+1)=ANGTMP
        NEND2=NEND2+1
     ELSE
        WA1=ANGXY(I)
        WA2=ANGXY(I+1)
        ANGT1=(ANG2(I)+ANG2(I+1))/2
        ANGT2=(ANG2(I)+ANG2(I+1))/2
        ANGXY(NEND2+1)=(ANGXY(I)+ANGXY(I+1))/2.D0
        X1=DBLE(ANGXY(NEND2+1))-XC
        Y1=AIMAG(ANGXY(NEND2+1))-YC
        X11=(X1*CS6+Y1*SN6)/XSC
        Y11=(-X1*SN6+Y1*CS6)/YSC
        radin(NEND2+1)=dsqrt((X11)**2+(Y11)**2)
        ANGTMP=DATAN2(Y11,X11)
        ANGTMP=(ANG2(I)+ANG2(I+1))/2
        IF(ANGTMP.LT.0) THEN
           ANGTMP=2*PI+ANGTMP
        ENDIF
        ANG2(NEND2+1)=ANGTMP
        NEND2=NEND2+1
     ENDIF
  enddo loop_10835

  !%%%%%%     SORTING ARRAY IN DECREASING ORDER
  NRADLINES2=NEND2
  loop_10836: DO I=1,NRADLINES2-1
     loop_10837: DO J=I+1,NRADLINES2
        IF (ANG2(J) .LT. ANG2(I)) THEN
           TEMP=ANG2(I)
           ANG2(I)=ANG2(J)
           ANG2(J)=TEMP
           ZTEMP=ANGXY(I)
           ANGXY(I)=ANGXY(J)
           ANGXY(J)=ZTEMP
           ZTEMP=ANGXY1(I)
           ANGXY1(I)=ANGXY1(J)
           ANGXY1(J)=ZTEMP
           ITEMP=IANG(I)
           IANG(I)=IANG(J)
           IANG(J)=ITEMP
           ITEMP=IUPD(I)
           IUPD(I)=IUPD(J)
           IUPD(J)=ITEMP
           rd=radin(I)
           radin(I)=radin(J)
           radin(J)=rd
        ENDIF
     enddo loop_10837
  enddo loop_10836
  ANG2(NEND2+1)=2*PI-ANG2(1)
  ANGXY(NEND2+1)=ANGXY(1)
  ANGXY1(NEND2+1)=ANGXY1(1)
  IANG(NEND2+1)=IANG(1)
  IUPD(NEND2+1)=IUPD(1)
  radin(NEND2+1)=radin(1)
  NEND2=NEND2+1
  NRADLINES2=NEND2
  OPEN(678,file="tmp.dat")
  NB=NBETA(NEL)-NCYLFLAG(NEL,1)*NTRMADD(NEL,1)-NCYLFLAG(NEL,2)&
       *NTRMADD(NEL,2)+NB_ADP_MAT(NEL)
  IF (NB.GT.7) NORDI=0
  IF (NB.GT.12) NORDI=0
  IF (NB.GT.18) NORDI=1
  IF (NB.GT.25) NORDI=2
  IF (NB.GT.33) NORDI=3
  IF (NB.GT.42) NORDI=4
  IF (NB.GT.52) NORDI=5
  IF (NB.GT.63) NORDI=6
  IF (NB.GT.75) NORDI=6
  IK=NCYLFLAG(NEL,1)*(KORD(NEL,1)+IRECTRM(NEL,1)+1)
  IF (IK.LT.NCYLFLAG(NEL,2)*(KORD(NEL,2)+IRECTRM(NEL,2)+1)) IK=&
       NCYLFLAG(NEL,2)*(KORD(NEL,2)+IRECTRM(NEL,2)+1)
  IK=8
  JK=8
  K1=0
  K2=0

  JTHETA=0
  loop_10838: DO j=1,NRADLINES2-2,2
     JTHETA=JTHETA+1
     IFLAG=0
     ISECUPDAT(NEL,1+J/2)=0
     IF(IUPD(J).EQ.1.OR.IUPD(J+2).EQ.1.&
          &AND.IBOUND(NEL,1+J/2).NE.6) THEN
        IFLAG=1
        ISECUPDAT(NEL,1+J/2)=1
     ENDIF
     NPBGSEC_TMP(1+J/2)=K1
     X5(1)=DBLE(ANGXY(j))
     Y5(1)=AIMAG(ANGXY(j))
     X5(4)=DBLE(ANGXY1(j))
     Y5(4)=AIMAG(ANGXY1(j))

     CALL FIND_CUT(100,1,4,ICUT,IK,X5(4),Y5(4),X5(1),&
          Y5(1),XCM,YCM,SC,SCP,A0,XSCM,YSCM,CSCM,CSFOUR(1,NEL),&
          SNFOUR(1,NEL),XCUT(1,1),YCUT(1,1),ICUT1)


     X5(6)=DBLE(ANGXY(j)+ANGXY(j+2))/2.D0
     Y5(6)=AIMAG(ANGXY(j)+ANGXY(j+2))/2.D0
     X1=DBLE(ANGXY1(j)+ANGXY1(j+2))/2.D0-XC
     Y1=AIMAG(ANGXY1(j)+ANGXY1(j+2))/2.D0-YC
     X11=(X1*CS6+Y1*SN6)/XSC
     Y11=(-X1*SN6+Y1*CS6)/YSC
     ANGTMP=DATAN2(Y11,X11)
     X11=1*DCOS(ANGTMP)*XSC
     Y11=1*DSIN(ANGTMP)*YSC
     X1=X11*CS6-Y11*SN6
     Y1=X11*SN6+Y11*CS6
     X5(5)=X1+XC
     Y5(5)=Y1+YC

     CALL FIND_CUT(100,1,4,ICUT,IK,X5(5),Y5(5),X5(6),&
          Y5(6),XCM,YCM,SC,SCP,A0,XSCM,YSCM,CSCM,CSFOUR(1,NEL),&
          SNFOUR(1,NEL),XCUT(1,2),YCUT(1,2),ICUT2)
     X5(2)=DBLE(ANGXY(j+2))
     Y5(2)=AIMAG(ANGXY(j+2))
     X5(3)=DBLE(ANGXY1(j+2))
     Y5(3)=AIMAG(ANGXY1(j+2))
     CALL FIND_CUT(100,1,4,ICUT,IK,X5(3),Y5(3),X5(2),&
          Y5(2),XCM,YCM,SC,SCP,A0,XSCM,YSCM,CSCM,CSFOUR(1,NEL),&
          SNFOUR(1,NEL),XCUT(1,3),YCUT(1,3),ICUT3)

     ICUTF=5
     JRADIUS=0
     loop_4: DO I3=2,ICUTF
        JRADIUS=JRADIUS+1
        XDIV5(4)=XCUT(I3-1,1)
        YDIV5(4)=YCUT(I3-1,1)
        IF (I3.EQ.2) THEN
           XDIV5(5)=XCUT(I3-1,2)
           YDIV5(5)=YCUT(I3-1,2)
        ELSE
           XDIV5(5)=XDIV5(6)
           YDIV5(5)=YDIV5(6)
        ENDIF
        XDIV5(3)=XCUT(I3-1,3)
        YDIV5(3)=YCUT(I3-1,3)
        XDIV5(1)=XCUT(I3,1)
        YDIV5(1)=YCUT(I3,1)
        XDIV5(6)=XCUT(I3,2)
        YDIV5(6)=YCUT(I3,2)
        XDIV5(2)=XCUT(I3,3)
        YDIV5(2)=YCUT(I3,3)
        XDS=X5(1)-X5(4)
        YDS=Y5(1)-Y5(4)
        YLS=DSQRT(XDS*XDS+YDS*YDS)
        XDS=XDIV5(1)-X5(1)
        YDS=YDIV5(1)-Y5(1)
        YLS1=DSQRT(XDS*XDS+YDS*YDS)
        YL1=-1.D0+2.D0*YLS1/YLS
        XL1=-1.D0
        XDS=X5(2)-X5(3)
        YDS=Y5(2)-Y5(3)
        YLS=DSQRT(XDS*XDS+YDS*YDS)
        XDS=XDIV5(2)-X5(2)
        YDS=YDIV5(2)-Y5(2)
        YLS1=DSQRT(XDS*XDS+YDS*YDS)
        YL2=-1.D0+2.D0*YLS1/YLS
        XL2=1.D0
        xl=(xl1+xl2)*0.5d0
        yl=(yl1+yl2)*0.5d0
        CALL GGRAD6(ICON,NEL,XL,YL,SH,DET,GDN,&
             X5,Y5,LW)    
        XDIV5(6)=0.D0
        YDIV5(6)=0.D0
        loop_10839: DO KLM=1,6
           XDIV5(6)=XDIV5(6)+SH(KLM)*X5(KLM)
           YDIV5(6)=YDIV5(6)+SH(KLM)*Y5(KLM)
        enddo loop_10839
        IF(MYMPI.EQ.0) THEN
           WRITE (612,*)
           WRITE (612,901) XDIV5(1),YDIV5(1)
           WRITE (612,901) XDIV5(6),YDIV5(6)
           WRITE (612,901) XDIV5(2),YDIV5(2)
           WRITE (612,901) XDIV5(3),YDIV5(3)
           WRITE (612,901) XDIV5(5),YDIV5(5)
           WRITE (612,901) XDIV5(4),YDIV5(4)
           WRITE (612,901) XDIV5(1),YDIV5(1)
        ENDIF

        IF (JK.NE.0) THEN
           IRD1=5
           IF (I3.GT.2) IRD1=3
           IF (I3.GT.3) IRD1=3+NORDI
           IF (I3.GT.3) THEN
              IRD2=4+NORDI
           ELSE
              IRD2=4+NORDI/2
           ENDIF
        ELSE
           IRD1=5+NORDI
           IRD2=5+NORDI
        ENDIF

        IRD2=100*DABS(ANG2(J+2)-ANG2(J))/PI
        DLX=0.5D0*(DSQRT((XDIV5(3)-XDIV5(4))**2+(YDIV5(3)-YDIV5(4))**2)&
             +DSQRT((XDIV5(1)-XDIV5(2))**2+(YDIV5(1)-YDIV5(2))**2))
        DLY=0.5D0*(DSQRT((XDIV5(1)-XDIV5(4))**2+(YDIV5(1)-YDIV5(4))**2)&
             +DSQRT((XDIV5(3)-XDIV5(2))**2+(YDIV5(3)-YDIV5(2))**2))

        IRD2=DLX/DLY*IRD1
        IF(IRD2.LT.3) IRD2=3
        IF(IRD2.GT.7) IRD2=7
        NFAC1=INTBEG(IRD1)
        NFAC2=INTBEG(IRD2)
        IF(IFLAG.EQ.1) THEN
           loop_10840: DO I33=1,IRD1
              YL=BP(NFAC1+I33)
              loop_64: DO J3=1,IRD2
                 K1=K1+1
                 K2=K2+1
                 XL=BP(J3+NFAC2)
                 WW=W(I33+NFAC1)*W(J3+NFAC2)
                 CALL GGRAD6(ICON,NEL,XL,YL,SH,DET,GDN,&
                      XDIV5,YDIV5,LW)                
                 IF (ICON.EQ.0) THEN
901                 FORMAT (2(E12.6,2X))
                    WRITE (*,*) NUMNOD,NUMNOD1
                    STOP
                 ENDIF
                 XI=0.E0
                 YI=0.E0
                 loop_47: DO II1=1,6
                    XI=XI+XDIV5(II1)*SH(II1)
                    YI=YI+YDIV5(II1)*SH(II1)
                 enddo loop_47
                 IRAD_TEMP(K1)=JRADIUS
                 ITHET_TEMP(K1)=JTHETA
                 XTEMP(K2)=XI
                 YTEMP(K2)=YI
                 write(678,*) XI,YI
                 GJACTMP(K2)=WW*DET
                 IF (GJACTMP(K2).LT.0.D0) THEN
                    WRITE (*,*) 'IMPOSSIBLE GJAOB FOR INTPT.'&
                         ,K1,'IN ELE.',NEL
                 ENDIF
                 AREA_MAT=AREA_MAT+DET*WW
              enddo loop_64
           enddo loop_10840
        ELSE
           loop_10841: DO I33=1,IRD1
              loop_10842: DO J3=1,IRD2
                 K1=K1+1
                 IRAD_TEMP(K1)=JRADIUS
                 ITHET_TEMP(K1)=JTHETA
              enddo loop_10842
           enddo loop_10841
        ENDIF
        XDIV5(4)=XDIV5(1)
        YDIV5(4)=YDIV5(1)
        XDIV5(3)=XDIV5(2)
        YDIV5(3)=YDIV5(2)
        XDIV5(5)=XDIV5(6)
        YDIV5(5)=YDIV5(6)
     enddo loop_4
  enddo loop_10838

  loop_10843: DO I=1,NUMBOUND(NEL)
     NPBGSEC(NEL,I)=NPBGSEC_TMP(I)
     IF(I.EQ.NUMBOUND(NEL)) THEN
        NINTSEC(NEL,I)=K1-NPBGSEC_TMP(I)
     ELSE
        NINTSEC(NEL,I)=NPBGSEC_TMP(I+1)-NPBGSEC_TMP(I)
     ENDIF
  enddo loop_10843
  close(678)
END SUBROUTINE DISCRET_ELLIP
