!************************************************************************
! Calculates the T_{e} (Traction) on the surface of the element NEL.
SUBROUTINE TMATLOC_INC(NEL,YM2,A,XC,YC,A1,XCP,YCP,A2,XCCP,YCCP,NX,&
     NIX,NIX1,NB,XN,YN)
!************************************************************************

  !  VARIABLE DEFINITION
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  INCLUDE 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (NLM_SOFT=40000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NTMMAX=NDFELM*15)
  PARAMETER (MAX_INT_ORDER=20)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NMAX_POLY=25,NM_PL=NMAX_POLY-1)
  PARAMETER (NUMHG=NLM*10000)
  PARAMETER (NUMTMOUT=NLM*18000,NUMTMIN=NLM*18000,NUMTMIN1=NLM*18000&
       ,NUMTMIN2=NLM*5000)
  DIMENSION XN(1),YN(1),XL(3,2),SH(2,4)

  INTEGER, ALLOCATABLE ::ICOMN(:), LC_ND(:),LC_BND(:),INTERP(:)&
       ,INTERP_LC(:,:),ICMMN(:),ICOMN_INC(:),ICOMN_CRK(:),NDPOLY(:,:)&
       ,IHP(:),intcr(:),icomn1(:),ICMNL(:),ICMNL1(:),NDMAP(:)


  DOUBLE PRECISION, ALLOCATABLE :: XOUT(:),YOUT(:),XIN(:),YIN(:)&
       ,DETIN(:),DCS_NORM(:),DSN_NORM(:),XLOC1(:),YLOC1(:),ANGLOC1(:)&
       ,CSLOC1(:),SNLOC1(:),XLENGTH(:),XLENGTH_I(:),SH_X(:,:),SH_Y(:,:)&
       ,XN1(:),YN1(:),T(:,:),U(:,:),V(:,:),EIG(:),WORK(:),TSOFT(:,:)&
       ,XNRML(:),YNRML(:),XIN1(:),YIN1(:),XMDLOC(:),YMDLOC(:),DUR1(:)&
       ,DUR2(:),DUR3(:),XMAP(:),YMAP(:),F(:),DFDX(:),DFDY(:),DFDXY(:)&
       ,DFDXX(:),DFDYY(:),SXLC(:),SYLC(:),PM(:),PREC(:,:),PMATLCB(:,:,:)&
       ,DETOUT(:),DETOUT1(:)
  COMMON /CRACKSOFTBOUND/ NDCRK_ADD(NLM),NDFCRK_ADD(NLM,NDELM)
  COMMON /HOURGLASS/ IHGLASS(NLM,NDELM),PHI_HGLASS(NUMHG),&
       NP_HGLASS(NLM,4),IHGNEL(NLM)
  COMMON /MACSTN/ NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)
  COMMON /BOUNDCURVE/ ABD_CRV,BBD_CRV,ANBD_CRV,&
       XBD_CRV,YBD_CRV,IBD_CRV
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /GAUQUAD/ W(1275),BP(1275),INTBEG(50)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /GMATR/ TMOUT(NUMTMOUT), NP_TMOUT(NLM,4),&
       TMIN(NUMTMIN), NP_TMIN(NLM,4),&
       TMIN1(NUMTMIN1), NP_TMIN1(NLM,4),&
       TMIN2(NUMTMIN2), NP_TMIN2(NLM,4)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /SHPVOID/ FSCALE(NLM),CONFOUR(NLM),&
       CSFOUR(50,NLM),SNFOUR(50,NLM)
  COMMON /SHPCRCK/ CONFOUR1(NLM),&
       CSFOUR1(20,NLM),SNFOUR1(20,NLM)
  COMMON /EDGEPRM/ NACTIVE(NLM),ICENT(NLM),NMUL(NLM)
  COMMON /COMNOD/ NODCOM(NLM,NDELM,4)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /ADAPTATIONS/ ANGLE_ADAPT_X(NLM,200,2),ANGLE_ADAPT_Y&
       (NLM,200,2),NX_ADAPT_NX(NODM),NX_NX_ADAPT(NODM),NUM_ADAPT_X&
       (NLM,200),NUM_ADAPT_Y(NLM,200),IJK_ADAPT_X(NLM,200,2),&
       IJK_ADAPT_Y(NLM,200,2),nx_adapt
  COMMON /ADAPTOPTML/ IDIR_OPTIMIZE(NLM,200),ANGLE_OPTIMIZE(NLM,200),&
       TRAC_NORM(NLM,200,2),TRAC_FRAC_CELL_ADPX(NLM,200,2),&
       TRAC_FRAC_CELL_ADPY(NLM,200,2)
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /HPADAPTINC/ COORD_HP_INC(NLM*NSDMAX*3),INT_HP_INC&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_INC(NSMAX)
  COMMON /LAGRPOLY/ PRD((NMAX_POLY*(NMAX_POLY+1))/2),&
       IPRD(NM_PL)
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /BETACONST/ IBET_TOT(NLM),IBET_CON(NBM,NLM)
  COMMON /BETACONSTI/ IBET_TOTI(NLM),IBET_CONI(NBM,NLM)
  COMMON /RIGFLAG/ IFINE
  COMMON /SOFTBOUNDARY/ IDOSOFT(NDFELM)
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),&
       INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /IDOASSIGN/ KASSIGN
  COMMON/INTEGPTS/IRD1,IRD2,IRDL,IRDA,RSINGP,RSINGG
  COMMON/INTEGPTSINC/NRDL      
  COMPLEX WCG
  COMMON /WLTBASEC/ DPOSW(NLM*NBM,2),NPBG_WLT(NLM),SSIGXG(NLM*NBM),SSIGYG(NLM*NBM),IWORP(NLM),IBET_WLTC(NBM,NLM)
  COMMON /WLTBASEM/ DPOSWM(NLM*NBM,2),NPBG_WLTM(NLM),SSIGXGM(NLM*NBM),SSIGYGM(NLM*NBM),IBET_WLTM(NBM,NLM)
  COMMON /INCBETA/  NBETA_INC(NLM),NBETA_DIF(NLM)
  COMMON/ELEMNT/NX1,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)

  NEL_BEG=(NEL-1)*(NSDMAX*3+2)
  NUMD=5*INT_HP_INC(NEL_BEG+1)

  ALLOCATE(ICOMN(NUMD+NX+NIX+NIX1), LC_ND(NUMD),LC_BND(NUMD),INTERP(NUMD)&
       ,INTERP_LC(NUMD,NUMD),ICMMN(NUMD),ICOMN_INC(NUMD+NX+NIX+NIX1)&
       ,ICOMN_CRK(NX+NIX+NIX1),NDPOLY(NUMD,2),IHP(NUMD*2),intcr(NUMD*3)&
       ,icomn1(NUMD),ICMNL(NUMD),ICMNL1(NUMD),NDMAP(NUMD*NRDL))
  ICOMN=0
  LC_ND=0
  LC_BND=0
  INTERP=0
  INTERP_LC=0
  ICMMN=0
  ICOMN_INC=0
  ICOMN_CRK=0
  NDPOLY=0
  IHP=0
  intcr=0
  icomn1=0
  ICMNL=0
  ICMNL1=0
  NDMAP=0

  ALLOCATE(XOUT(NUMD*NRDL),YOUT(NUMD*NRDL),XIN(NUMD*NRDL),YIN(NUMD*NRDL),DETIN(NUMD*NRDL)&
       ,DCS_NORM(NUMD*NRDL),DSN_NORM(NUMD*NRDL),XLOC1(NUMD),YLOC1(NUMD)&
       ,ANGLOC1(NUMD),CSLOC1(NUMD),SNLOC1(NUMD),XLENGTH(NUMD)&
       ,XLENGTH_I(NUMD),SH_X(NMAX_POLY,50),SH_Y(NMAX_POLY,50),XN1(NUMD)&
       ,YN1(NUMD),TSOFT(NB,NUMD),XNRML(NUMD*NRDL),YNRML(NUMD*NRDL),XIN1(NUMD*NRDL)&
       ,YIN1(NUMD*NRDL),XMDLOC(NUMD),YMDLOC(NUMD),DUR1(NUMD*2),DUR2(NUMD*2)&
       ,DUR3(NUMD*2),XMAP(200),YMAP(200),F(200),DFDX(200),DFDY(200)&
       ,DFDXY(200),DFDXX(200),DFDYY(200),SXLC(NUMD*NRDL),SYLC(NUMD*NRDL)&
       ,PM(1000),PREC(3,NB*NUMD*NRDL),DETOUT(NUMD*NRDL),DETOUT1(NUMD*NRDL))
  XOUT=0.D0
  YOUT=0.D0
  XIN=0.D0
  YIN=0.D0
  DETIN=0.D0
  DCS_NORM=0.D0
  DSN_NORM=0.D0
  XLOC1=0.D0
  YLOC1=0.D0
  ANGLOC1=0.D0
  CSLOC1=0.D0
  SNLOC1=0.D0
  XLENGTH=0.D0
  XLENGTH_I=0.D0
  SH_X=0.D0
  SH_Y=0.D0
  XN1=0.D0
  YN1=0.D0
  TSOFT=0.D0
  XNRML=0.D0
  YNRML=0.D0
  XIN1=0.D0
  YIN1=0.D0
  XMDLOC=0.D0
  YMDLOC=0.D0
  DUR1=0.D0
  DUR2=0.D0
  DUR3=0.D0
  XMAP=0.D0
  YMAP=0.D0
  F=0.D0
  DFDX=0.D0
  DFDY=0.D0
  DFDXY=0.D0
  DFDXX=0.D0
  DFDYY=0.D0
  SXLC=0.D0
  SYLC=0.D0
  PM=0.D0
  PREC=0.D0
  DETOUT=0.D0
  DETOUT1=0.D0
  NINPTS=0
  NEL_BEG=(NEL-1)*(NSDMAX*3+2)
  KEL_BEG=(NEL-1)*NSDMAX*3
  ND_TOT=INT_HP_INC(NEL_BEG+2)
  loop_10002: do i=1,ND_TOT
     icomn_inc(i)=0
  enddo loop_10002

  JDO=0
  A0=CONFOUR(NEL)
  XCC=XC
  YCC=YC
  SC=A
  SC1=A1
  XDIF=XCC-XCP
  YDIF=YCC-YCP
  XDIF1=XCP-XCCP
  YDIF1=YCP-YCCP
  XDIF2=XCC-XCCP
  YDIF2=YCC-YCCP
  NUMIN=0
  NUMNOD=NX
  CONV_DEG_RAD=DATAN(1.D0)/4.5D1
  NEL_BEG=(NEL-1)*(NSDMAX*3+2)
  KEL_BEG=(NEL-1)*NSDMAX*3
  NDF_INC=INT_HP_INC(NEL_BEG+1)
  ND_TOT=INT_HP_INC(NEL_BEG+2)
  loop_10011: DO I=1,ND_TOT
     ANGLOC1(I)=COORD_HP_INC(KEL_BEG+(I-1)*3+1)
     XLOC1(I)=COORD_HP_INC(KEL_BEG+(I-1)*3+2)
     YLOC1(I)=COORD_HP_INC(KEL_BEG+(I-1)*3+3)         
     LC_BND(I)=INT_HP_INC(NEL_BEG+I*3+1)
     LC_ND(I)=INT_HP_INC(NEL_BEG+I*3+2)
  enddo loop_10011
  loop_10012: DO I=1,ND_TOT
     INTERP(I)=1
     INTERP_LC(I,1)=I
  enddo loop_10012
  XSC=XSCALEM(NEL)
  XSC_2=XSC*XSC
  YSC=YSCALEM(NEL)
  YSC_2=YSC*YSC
  CSC=ANM(NEL)
  CSC1=ANM(NEL)*DATAN(1.D0)/4.5D1
  CS6=DCOS(CSC1)
  SN6=DSIN(CSC1)
  XSC1=XSCALEI(NEL)
  YSC1=YSCALEI(NEL)
  CSC2=ANI(NEL)
  CSC3=ANI(NEL)*DATAN(1.D0)/4.5D1
  CS8=DCOS(CSC3)
  SN8=DSIN(CSC3)
  loop_77: DO I=1,ND_TOT+NIX
     ICOMN(I)=0
  enddo loop_77
  loop_10013: DO I=1,NIX1
     ICMNL1(I)=0
  enddo loop_10013
  loop_10014: DO I=1,ND_TOT
     ICMNL(I)=0
  enddo loop_10014

  loop_10027: DO I=ND_TOT+1,NDF_INC
     I1=INT_HP_INC(NEL_BEG+I*3+1)
     INTERP(I1)=INTERP(I1)+1
     INTERP_LC(I1,INTERP(I1))=I
     IF (LC_ND(I1).EQ.1.OR.LC_ND(I1).EQ.4) THEN
        LC_ND(I)=6
     ELSE
        LC_ND(I)=7
     ENDIF
  enddo loop_10027
  NINPT=(ND_TOT)*NORD(NEL)
  loop_10028: DO I=1,ND_TOT
     INTERP(I)=INTERP(I)+1
     INEXT=I+1
     IF (INEXT.GT.ND_TOT) INEXT=1
     IFLAG=0
     loop_10029: DO WHILE (IFLAG.EQ.0) 
        IF (((LC_ND(INEXT)-LC_ND(I))/3)*3+LC_ND(I).EQ.LC_ND(INEXT)) &
             THEN
           IFLAG=1
        ELSE
           INEXT=INEXT+1
           IF (INEXT.GT.ND_TOT) THEN
              INEXT=1
           ENDIF
        ENDIF
     enddo loop_10029
     INTERP_LC(I,INTERP(I))=INEXT
     IFLAG=0
     IC=1
     loop_10030: DO WHILE (IFLAG.EQ.0)
        IF (IC.GT.INTERP(I)) THEN
           IFLAG=1
           IC=IC-1
        ELSE
           IF (LC_ND(I).LT.3) THEN
              IC=IC+1
           ELSE
              IFLAG=1
           ENDIF
        ENDIF
     enddo loop_10030
     ANGLE=ANGLOC1(INTERP_LC(I,IC))*CONV_DEG_RAD
     CSLOC1(I)=DCOS(ANGLE)
     SNLOC1(I)=DSIN(ANGLE)
  enddo loop_10028
  ICUT=0
  JCUT=0
  loop_10031: DO I=1,ND_TOT
     I1=I+1
     IF (I1.GT.ND_TOT) I1=1
     IND1=INT_HP_INC(NEL_BEG+I*3)
     IND2=INT_HP_INC(NEL_BEG+I1*3)
     ICMMN(I)=0
     J=1
     loop_10032: DO WHILE (J.LE.INT_HP_CELL(NEL_BEG+2).AND.ICMMN(I).EQ.0)
        J1=J-1
        IF (J1.EQ.0) J1=INT_HP_CELL(NEL_BEG+2)
        JND1=INT_HP_CELL(NEL_BEG+J1*3)
        JND2=INT_HP_CELL(NEL_BEG+J*3)
        IF (JND1.EQ.IND1) THEN
           JCUT=JCUT+1
        ENDIF
        IF (JND1.EQ.IND1.AND.JND2.EQ.IND2) THEN
           ICMMN(I)=1
           ICUT=1
        ELSE
           J=J+1
        ENDIF
     enddo loop_10032
  enddo loop_10031
  !     END ADDITION FOR CUT PARTICLE
  N1=0
  IF(NEL.EQ.1) THEN
     open(980,file="inc_bound.dat")
  else
     open(980,file="inc_bound.dat",position="APPEND")
  ENDIF
  loop_20: DO N=1,ND_TOT
     NAFT=N+1-(N/ND_TOT)*ND_TOT
     X0=XLOC1(N)
     Y0=YLOC1(N)
     X1=XLOC1(NAFT)
     Y1=YLOC1(NAFT)
     XMID=(X0+X1)*0.5D0
     YMID=(Y0+Y1)*0.5D0

     IF(X0.NE.X1.OR.Y0.NE.Y1) THEN
        IF (MCRACK(NEL).EQ.1.AND.ICMMN(N).NE.1.AND.&
             (ICOMN_INC(N).EQ.0.OR.ICOMN_INC(NAFT).EQ.0)) THEN
           !     END ADDITION FOR CUT PARTICLE
           XMID=XMID-XCP
           YMID=YMID-YCP
           XMID1=XMID*CS6+YMID*SN6
           YMID1=YMID*CS6-XMID*SN6
           ANGM=DATAN2(YMID1,XMID1)
           CSL=DCOS(ANGM)
           SNL=DSIN(ANGM)
           RF=CSL*CSL/XSC_2+SNL*SNL/YSC_2
           RF=1.D0/DSQRT(RF)
           XMID1=RF*CSL
           YMID1=RF*SNL
           XMID=XMID1*CS6-YMID1*SN6+XCP
           YMID=YMID1*CS6+XMID1*SN6+YCP
        ENDIF
     ENDIF
     XMDLOC(N)=XMID
     YMDLOC(N)=YMID
     IF (NCYLFLAG(NEL,2).NE.0) THEN
        loop_10033: DO J=1,101
           S=-1.D0+DFLOAT(J-1)*2.D-2
           XMAP(J)=X0*(S-1)*S/2.E0+X1*S*(1+S)/2.E0+XMID*(1-S**2)-XCCP
           YMAP(J)=Y0*(S-1)*S/2.E0+Y1*S*(1+S)/2.E0+YMID*(1-S**2)-YCCP
        enddo loop_10033
        N101=101
        CALL CONMAP13(N101,SC,A0,CSINT,SNNT,XMAP,YMAP,F,DFDX,&
             DFDY,DFDXY,DFDXX,DFDYY,XSC1/1.08D0,YSC1/1.01D0,CSC2)
     ELSE
        loop_10034: DO J=1,101
           F(J)=1.D0
        enddo loop_10034
     ENDIF
     J=1
     loop_10035: DO WHILE (J.LT.101)
        FS=F(J)
        JK=J+1
        IFIND=0
        JK=101
        S1=-1.D0+(J-1)*2.D-2
        S2=-1.D0+(JK-1)*2.D-2
        SMD=(S1+S2)*0.5D0
        XS1=X0*(S1-1)*S1/2.E0+X1*S1*(1+S1)/2.E0+XMID*(1-S1**2)
        YS1=Y0*(S1-1)*S1/2.E0+Y1*S1*(1+S1)/2.E0+YMID*(1-S1**2)
        XS2=X0*(S2-1)*S2/2.E0+X1*S2*(1+S2)/2.E0+XMID*(1-S2**2)
        YS2=Y0*(S2-1)*S2/2.E0+Y1*S2*(1+S2)/2.E0+YMID*(1-S2**2)
        XSMD=X0*(SMD-1)*SMD/2.E0+X1*SMD*(1+SMD)/2.E0+XMID*(1-SMD**2)
        YSMD=Y0*(SMD-1)*SMD/2.E0+Y1*SMD*(1+SMD)/2.E0+YMID*(1-SMD**2)

        loop_10037: DO KK=1,NRDL
           SLC=BP(INTBEG(NORD(NEL))+KK)
           S=S1*(1.D0-SLC)*0.5D0+S2*(1.D0+SLC)*0.5D0               
           WLC=W(INTBEG(NORD(NEL))+KK)               
           XAC=X0*(S-1)*S/2.E0+X1*S*(1+S)/2.E0+XMID*(1-S**2)
           YAC=Y0*(S-1)*S/2.E0+Y1*S*(1+S)/2.E0+YMID*(1-S**2)
           IF (KK.EQ.1) THEN
           ENDIF
648        FORMAT ('"(',I3,',',I3,')"')
647        FORMAT (2(E12.6,2X))
           N1=N1+1
           SXLC(N1)=S
           SYLC(N1)=S
           XOUT(N1)=(XAC-XCC)/SC
           YOUT(N1)=(YAC-YCC)/SC
           XIN(N1)=(XAC-XCP)/A1
           YIN(N1)=(YAC-YCP)/A1
           DCS=XS1*(SLC-0.5D0)+XS2*(SLC+0.5D0)-2.D0*XSMD*SLC
           DSN=YS1*(SLC-0.5D0)+YS2*(SLC+0.5D0)-2.D0*YSMD*SLC
           GJAC=DSQRT(DCS*DCS+DSN*DSN)
           DETOUT(N1)=GJAC*WLC
           !     ADDED FOR CUT PARTICLE
           IF (ICMMN(N).EQ.1.OR.IDOSOFT(N).EQ.1) THEN
              DETOUT1(N1)=0.D0
           ELSE
              DETOUT1(N1)=DETOUT(N1)
           ENDIF
           !     END ADDITION FOR CUT PARTICLE
           XD=X0-X1
           YD=Y0-Y1
           XBETW=DSQRT(XD*XD+YD*YD)
           IF (GJAC.LT.1.D-10.OR.XBETW.LT.1.D-10) THEN
              DCS_NORM(N1)=1.D0
              DSN_NORM(N1)=0.D0
              DETOUT(N1)=0.D0
           ELSE
              write(980,*) XOUT(N1)*SC+XCC,YOUT(N1)*SC+YCC
              DCS=DCS/GJAC
              DSN=DSN/GJAC
              DSN_NORM(N1)=-DCS
              DCS_NORM(N1)=DSN
           ENDIF

           XLENGTH(N)=XLENGTH(N)+DETOUT(N1)
           NDMAP(N1)=N
        enddo loop_10037
        J=JK
        FS=F(J)
     enddo loop_10035
  enddo loop_20
  rewind(980)
  close(980)
  NINPT=N1

  ALLOCATE(PMATLCB(NINPT,3,NB))
  PMATLCB=0.D0
  loop_10038: DO I=1,ND_TOT
     I1=INTERP_LC(I,INTERP(I))
     I2=I
     XLENGTH_I(I)=0.D0
     loop_10039: DO WHILE (I2.NE.I1) 
        XLENGTH_I(I)=XLENGTH_I(I)+XLENGTH(I2)
        I2=I2+1
        IF (I2.GT.ND_TOT) I2=1
     enddo loop_10039
  enddo loop_10038
  NBDIF=NB_ADP_COM(NEL)-NB_ADP_MAT(NEL)
  NB=NB-NCYLFLAG(NEL,1)*NTRMADD(NEL,1)-NCYLFLAG(NEL,2)&
       *NTRMADD(NEL,2)
  IF(IWORP(NEL).EQ.3) THEN
     NB=NB-(NPBG_WLTM(NEL+1)-NPBG_WLTM(NEL))
  ENDIF
  loop_201: DO I=1,NINPT
     XX=XOUT(I)
     YY=YOUT(I)
     CALL GEN_VCF_P(NB,XX,YY,PM)
     loop_10040: DO INB=1,NB
        PMATLCB(I,1,INB)=PM((INB-1)*3+1)
        PMATLCB(I,2,INB)=PM((INB-1)*3+2)
        PMATLCB(I,3,INB)=PM((INB-1)*3+3)
     enddo loop_10040
     IF(IWORP(NEL).NE.3) THEN
        XOUT(I)=(XX*SC+XDIF)
        YOUT(I)=(YY*SC+YDIF)
     ENDIF
  enddo loop_201
  ION=0
  IF (NCYLFLAG(NEL,1).EQ.1) THEN
     CALL PMATLOCAS1(NEL,NINPT,SC,XDIF,YDIF,XOUT,YOUT,NB,&
          CONFOUR(NEL),CSFOUR(1,NEL),SNFOUR(1,NEL),ION,PMATLCB)
     NB=NB+NTRMADD(NEL,1)       
     IF (NCYLFLAG(NEL,2).NE.1) THEN  
        loop_10044: DO I=1,NINPT
           XOUT(I)=XOUT(I)+XCP
           YOUT(I)=YOUT(I)+YCP
        enddo loop_10044
     ENDIF
  ENDIF
  ION=1
  IF (NCYLFLAG(NEL,2).EQ.1) THEN
     loop_10045: DO I=1,NINPT
        XOUT(I)=XOUT(I)+XDIF1
        YOUT(I)=YOUT(I)+YDIF1
     enddo loop_10045
     CALL PMATLOCAS1(NEL,NINPT,SC,XDIF2,YDIF2,XOUT,YOUT,NB,&
          CONFOUR(NEL),CSFOUR(1,NEL),SNFOUR(1,NEL),ION,PMATLCB)         
     NB=NB+NTRMADD(NEL,2)
     loop_10046: DO I=1,NINPT
        XOUT(I)=XOUT(I)+XCCP
        YOUT(I)=YOUT(I)+YCCP
     enddo loop_10046
  ENDIF
  loop_2001: DO I=1,3
     loop_2002: DO J=1,2
        XL(I,J)=0.D0
     enddo loop_2002
  enddo loop_2001
  IF(IHGNEL(NEL).EQ.1) THEN
     IF(NEL.EQ.1) THEN
        NUM_DIFF=NDF_INC*NDF_INC-NP_HGLASS(NEL,2)
        NP_HGLASS(NEL,1)=0
        NP_HGLASS(NEL,3)=NDF_INC
        NP_HGLASS(NEL,4)=NDF_INC
        NP_HGLASS(NEL,2)=NP_HGLASS(NEL,3)*NP_HGLASS(NEL,4)
     ELSE
        NUM_DIFF=NDF_INC*NDF_INC-NP_HGLASS(NEL,2)
        NP_HGLASS(NEL,1)=NP_HGLASS(NEL-1,1)+NP_HGLASS(NEL-1,2)
        NP_HGLASS(NEL,3)=NDF_INC
        NP_HGLASS(NEL,4)=NDF_INC
        NP_HGLASS(NEL,2)=NP_HGLASS(NEL,3)*NP_HGLASS(NEL,4)
     ENDIF
  ELSE
     IF(NEL.EQ.1) THEN
        NUM_DIFF=-NP_HGLASS(NEL,2)
        NP_HGLASS(NEL,1)=0
        NP_HGLASS(NEL,3)=0
        NP_HGLASS(NEL,4)=0
        NP_HGLASS(NEL,2)=0
     ELSE
        NUM_DIFF=-NP_HGLASS(NEL,2)
        NP_HGLASS(NEL,1)=NP_HGLASS(NEL-1,1)+NP_HGLASS(NEL-1,2)
        NP_HGLASS(NEL,3)=0
        NP_HGLASS(NEL,4)=0
        NP_HGLASS(NEL,2)=0
     ENDIF
  ENDIF
  IF((NP_HGLASS(NEL,1)+NP_HGLASS(NEL,2)).GT.NUMHG) THEN
     WRITE(*,*) "THE dimension of PHI_HGLASS is not enough"
     WRITE(*,*) "Increase it to", (NP_HGLASS(NEL,1)+NP_HGLASS(NEL,2)), NEL
  ENDIF
  IF(NUM_DIFF.GT.0) THEN
     loop_10047: DO I=NELX,NEL+1,-1
        loop_10048: DO J=NP_HGLASS(I,2),1,-1
           PHI_HGLASS(NP_HGLASS(I,1)+NUM_DIFF+J)=PHI_HGLASS(NP_HGLASS(I,1)+J)
        enddo loop_10048
        NP_HGLASS(I,1)=NP_HGLASS(I,1)+NUM_DIFF
     enddo loop_10047
  ELSE
     loop_10049: DO I=NEL+1,NELX
        loop_10050: DO J=1,NP_HGLASS(I,2)
           PHI_HGLASS(NP_HGLASS(I,1)+NUM_DIFF+J)=PHI_HGLASS(NP_HGLASS(I,1)+J)
        enddo loop_10050
        NP_HGLASS(I,1)=NP_HGLASS(I,1)+NUM_DIFF
     enddo loop_10049
  ENDIF
  IF(IHGNEL(NEL).EQ.1) THEN
     loop_10051: DO I=1,NDF_INC
        loop_10052: DO J=1,NDF_INC
           PHI_HGLASS(NP_HGLASS(NEL,1)+(I-1)*NP_HGLASS(NEL,4)+J)=0.D0
        enddo loop_10052
        PHI_HGLASS(NP_HGLASS(NEL,1)+(I-1)*NP_HGLASS(NEL,4)+I)=1.D0
     enddo loop_10051
  ENDIF
  ITR=0
2025 ITR=ITR+1
  IF(NEL.EQ.1) THEN
     NUM_DIFF=NB*NDF_INC-NP_TMIN(NEL,2)
     NP_TMIN(NEL,1)=0
     NP_TMIN(NEL,3)=NB
     NP_TMIN(NEL,4)=NDF_INC
     NP_TMIN(NEL,2)=NP_TMIN(NEL,3)*NP_TMIN(NEL,4)
  ELSE
     NUM_DIFF=NB*NDF_INC-NP_TMIN(NEL,2)
     NP_TMIN(NEL,1)=NP_TMIN(NEL-1,1)+NP_TMIN(NEL-1,2)
     NP_TMIN(NEL,3)=NB
     NP_TMIN(NEL,4)=NDF_INC
     NP_TMIN(NEL,2)=NP_TMIN(NEL,3)*NP_TMIN(NEL,4)
  ENDIF
  IF((NP_TMIN(NEL,1)+NP_TMIN(NEL,2)).GT.NUMTMIN) THEN
     WRITE(*,*) "THE dimension of TMIN is not enough"
     WRITE(*,*) "Increase it to", (NP_TMIN(NEL,1)+NP_TMIN(NEL,2)), NEL
  ENDIF
  IF(NUM_DIFF.LT.0) THEN
     WRITE(*,*) "Impossible NB*NDF_INC",NB,NDF_INC
     stop
  ENDIF
  IF(NUM_DIFF.GT.0) THEN
     loop_10053: DO I=NELX,NEL+1,-1
        loop_10054: DO J=NP_TMIN(I,2),1,-1
           TMIN(NP_TMIN(I,1)+NUM_DIFF+J)=TMIN(NP_TMIN(I,1)+J)
        enddo loop_10054
        NP_TMIN(I,1)=NP_TMIN(I,1)+NUM_DIFF
     enddo loop_10053
  ENDIF
  !************************************************
  loop_205: DO I=1,NB*NDF_INC
     I1=(I-1)/(NDF_INC)+1
     I2=I-(I1-1)*NDF_INC
     TMIN(NP_TMIN(NEL,1)+(I1-1)*NP_TMIN(NEL,4)+I2)=0.D0
     TSOFT(i1,i2)=0.d0
  enddo loop_205
  IF(MYMPI.EQ.0) THEN
     if(NEL.EQ.1) THEN
        open(981,file="tmin_bound.dat")
     else
        open(981,file="tmin_bound.dat",position="APPEND")
        write(981,*) 
     ENDIF
  ENDIF
  INP=0
  loop_202: DO I=1,NINPT
     IF (I.EQ.1) THEN
        IC_X=1
        IC_Y=2
     ENDIF
     I1=NDMAP(I)
     I2=I1+1
     IF (I2.GT.ND_TOT) I2=1
     I7=I-(I/NORD(NEL))*NORD(NEL)
     IF (I7.EQ.0) I7=NORD(NEL)
     IF (I7.EQ.1) THEN
        IF (LC_ND(I1).EQ.1.OR.LC_ND(I1).EQ.4) THEN
           IC_X=I1
        ELSE
           IC_Y=I1
        ENDIF
        XADD=0.D0
        YADD=0.D0
        IC_X1=IC_X
        loop_10055: DO WHILE (IC_X1.NE.I1) 
           XADD=XADD+XLENGTH(IC_X1)
           IC_X1=IC_X1+1
           IF (IC_X1.GT.ND_TOT) IC_X1=1
        enddo loop_10055
        IC_Y1=IC_Y
        loop_10056: DO WHILE (IC_Y1.NE.I1) 
           YADD=YADD+XLENGTH(IC_Y1)
           IC_Y1=IC_Y1+1
           IF (IC_Y1.GT.ND_TOT) IC_Y1=1
        enddo loop_10056
        CS=CSLOC1(IC_X)
        SN=SNLOC1(IC_X)
        loop_10057: DO IJ=I1,I1+NORD(NEL)-1
           IK=IJ-I1+1
           sx=sxlc(i)
           sy=sylc(i)
           FACT=2.D0/DFLOAT(INTERP(IC_X)-1)
           loop_10058: DO KJ=1,INTERP(IC_X)
              IPT=IPRD(INTERP(IC_X)-1)+KJ-1
              SH_X(KJ,IK)=PRD(IPT)
              loop_10059: DO L=1,INTERP(IC_X)
                 IF (L.NE.KJ) THEN
                    SH_X(KJ,IK)=SH_X(KJ,IK)*&
                         (SX+1.D0-FACT*DFLOAT(L-1))
                 ENDIF
              enddo loop_10059
           enddo loop_10058
           FACT=2.D0/DFLOAT(INTERP(IC_Y)-1)
           loop_10060: DO KJ=1,INTERP(IC_Y)
              IPT=IPRD(INTERP(IC_Y)-1)+KJ-1
              SH_Y(KJ,IK)=PRD(IPT)
              loop_10061: DO L=1,INTERP(IC_Y)
                 IF (L.NE.KJ) THEN
                    SH_Y(KJ,IK)=SH_Y(KJ,IK)*&
                         (SY+1.D0-FACT*DFLOAT(L-1))
                 ENDIF
              enddo loop_10061
           enddo loop_10060
        enddo loop_10057
     ENDIF
     IF (DETOUT(I).GT.1.D-11) THEN
        IF (ICOMN(I1).EQ.0.OR.ICOMN(I2).EQ.0) THEN
           S=BP(INTBEG(NORD(NEL))+I7)
           IF (IDOSOFT(I1).EQ.0) THEN
              IF(MYMPI.EQ.0) write(981,*) XOUT(I),YOUT(I)
           ENDIF
           XL(1,1)=DCS_NORM(I)
           XL(3,1)=DSN_NORM(I)
           XL(2,2)=XL(3,1)
           XL(3,2)=XL(1,1)
           loop_204: DO J=1,NB
              TTX=(PMATLCB(I,1,J)*XL(1,1)+PMATLCB(I,3,J)*XL(3,1))&
                   *DETOUT(I)
              TTY=(PMATLCB(I,2,J)*XL(2,2)+PMATLCB(I,3,J)*XL(3,2))&
                   *DETOUT(I)
              TTX_C=TTX*CS
              TTX_S=TTX*SN
              TTY_C=TTY*CS
              TTY_S=TTY*SN
              IBEG=IPRD(INTERP(IC_X)-1)
              XLENX=0.D0
              XLENY=0.D0
              ND=1
              FACT=2.D0/DFLOAT(INTERP(IC_X)-1)
              loop_10062: DO WHILE (ND.LE.INTERP(IC_X)) 
                 S=-1.D0+((1.D0+S)*XLENGTH(I1)+XADD*2.D0)/&
                      XLENGTH_I(IC_X)
                 IPT=IPRD(INTERP(IC_X)-1)+ND-1
                 SH1=PRD(IPT)
                 loop_10063: DO L=1,INTERP(IC_X)
                    IF (L.NE.ND) THEN
                       SH1=SH1*(S+1.D0-FACT*DFLOAT(L-1))
                    ENDIF
                 enddo loop_10063
                 sx=sxlc(i)
                 if (nd.eq.1) then
                    sh1=(1.d0-sx)*0.5d0
                 else
                    sh1=(1.d0+sx)*0.5d0
                 endif
                 ID=INTERP_LC(IC_X,ND)
                 IF (IDOSOFT(I1).EQ.0) THEN
                    IF (LC_ND(ID).EQ.1) THEN                        
                       TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)=&
                            TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)&
                            +(TTX_C*CS+TTY_S*CS)*SH1
                       TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID+1)=&
                            TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID+1)&
                            +(TTX_C*SN+TTY_S*SN)*SH1
                    ELSEIF (LC_ND(ID).EQ.2) THEN
                       TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID-1)=&
                            TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID-1)&
                            +(TTX_C*CS+TTY_S*CS)*SH1
                       TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)=&
                            TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)&
                            +(TTX_C*SN+TTY_S*SN)*SH1
                    ELSE
                       TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)=&
                            TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)&
                            +(TTX_C+TTY_S)*SH1
                    ENDIF
                 ENDIF
                 IF (IBET_CON(J,NEL).NE.-501) THEN                  
                    IF (LC_ND(ID).EQ.1) THEN                        
                       TSOFT(J,ID)=TSOFT(J,ID)+(TTX_C*CS+&
                            TTY_S*CS)*SH1
                       TSOFT(J,ID+1)=TSOFT(J,ID+1)+(TTX_C*SN&
                            +TTY_S*SN)*SH1
                    ELSEIF (LC_ND(ID).EQ.2) THEN
                       TSOFT(J,ID-1)=TSOFT(J,ID-1)+(TTX_C*CS+&
                            TTY_S*CS)*SH1
                       TSOFT(J,ID)=TSOFT(J,ID)+(TTX_C*SN&
                            +TTY_S*SN)*SH1
                    ELSE
                       TSOFT(J,ID)=TSOFT(J,ID)+(TTX_C+TTY_S)&
                            *SH1
                    ENDIF
                 ENDIF
                 ND=ND+1
              enddo loop_10062
              IBEG=IPRD(INTERP(IC_Y)-1)
              ND=1
              FACT=2.D0/DFLOAT(INTERP(IC_Y)-1)
              loop_10064: DO WHILE (ND.LE.INTERP(IC_Y))
                 S=-1.D0+((1.D0+S)*XLENGTH(I1)+YADD*2.D0)/&
                      XLENGTH_I(IC_Y)
                 IPT=IPRD(INTERP(IC_Y)-1)+ND-1
                 SH1=PRD(IPT)
                 loop_10065: DO L=1,INTERP(IC_Y)
                    IF (L.NE.ND) THEN
                       SH1=SH1*(S+1.D0-FACT*DFLOAT(L-1))
                    ENDIF
                 enddo loop_10065
                 sy=sylc(i)
                 if (nd.eq.1) then
                    sh1=(1.d0-sy)*0.5d0
                 else
                    sh1=(1.d0+sY)*0.5d0
                 endif
                 ID=INTERP_LC(IC_Y,ND)
                 IF (IDOSOFT(I1).EQ.0) THEN
                    IF (LC_ND(ID).EQ.2) THEN                        
                       TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID-1)=&
                            TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID-1)&
                            +(TTX_S*SN-TTY_S*CS)*SH1
                       TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)=&
                            TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)&
                            +(-TTX_S*CS+TTY_C*CS)*SH1
                    ELSEIF (LC_ND(ID).EQ.1) THEN
                       TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)=&
                            TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)&
                            +(TTX_S*SN-TTY_S*CS)*SH1
                       TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID+1)=&
                            TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID+1)&
                            +(-TTX_S*CS+TTY_C*CS)*SH1
                    ELSE
                       TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)=&
                            TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+ID)&
                            +(TTY_C-TTX_S)*SH1
                    ENDIF
                 ENDIF
                 IF (IBET_CON(J,NEL).NE.-501) THEN                  
                    IF (LC_ND(ID).EQ.2) THEN                        
                       TSOFT(J,ID-1)=TSOFT(J,ID-1)+(TTX_S*SN-&
                            TTY_S*CS)*SH1
                       TSOFT(J,ID)=TSOFT(J,ID)+(-TTX_S*CS&
                            +TTY_C*CS)*SH1
                    ELSEIF (LC_ND(ID).EQ.1) THEN
                       TSOFT(J,ID)=TSOFT(J,ID)+(TTX_S*SN-&
                            TTY_S*CS)*SH1
                       TSOFT(J,ID+1)=TSOFT(J,ID+1)+(-TTX_S*CS&
                            +TTY_C*CS)*SH1
                    ELSE
                       TSOFT(J,ID)=TSOFT(J,ID)+(TTY_C-TTX_S)&
                            *SH1
                    ENDIF
                 ENDIF
                 ND=ND+1
              enddo loop_10064
           enddo loop_204
        ENDIF
     ENDIF
  enddo loop_202
  IF(MYMPI.EQ.0) THEN
     rewind(981)
     close(981)
  ENDIF
28 FORMAT ('u1(',I4,')=',E25.12,';')
29 FORMAT ('u2(',I4,')=',E25.12,';')
30 FORMAT ('u3(',I4,')=',E25.12,';')

  XCC=XCP
  YCC=YCP
  SC=A1
  loop_10086: DO I=1,NINPT
     XOUT(I)=(XOUT(I)-XCC)/SC
     YOUT(I)=(YOUT(I)-YCC)/SC
  enddo loop_10086
  !%%%% FOR WAVELET IN INCLUSION %%%%%%   
  NBSTART=0
  IF (IWORP(NEL) .EQ. 0.OR.IWORP(NEL) .EQ. 2.OR.IWORP(NEL) .EQ. 3) THEN
     NB=NB-NCYLFLAG(NEL,1)*NTRMADD(NEL,1)-NCYLFLAG(NEL,2)&
          *NTRMADD(NEL,2)+NBDIF-NBETA_DIF(NEL)
     IF(IWORP(NEL).EQ.3) THEN
        NB=NB-(NPBG_WLTM(NEL+1)-NPBG_WLTM(NEL))
     ENDIF
     NBSTART=NB
     loop_301: DO I=1,NINPT
        XX=XIN(I)
        YY=YIN(I)
        CALL GEN_VCF_P(NB,XX,YY,PM)
        loop_10087: DO INB=1,NB
           PMATLCB(I,1,INB)=PM((INB-1)*3+1)
           PMATLCB(I,2,INB)=PM((INB-1)*3+2)
           PMATLCB(I,3,INB)=PM((INB-1)*3+3)
        enddo loop_10087
        IF(IWORP(NEL).EQ.0) THEN
           IF(NCYLFLAG(NEL,2).EQ.1) THEN
              XIN(I)=(XX*A1+XDIF1)
              YIN(I)=(YY*A1+YDIF1)
           ELSE
              XIN(I)=(XX*A1+XCP)
              YIN(I)=(YY*A1+YCP)
           ENDIF
        ENDIF
        !     END ADDITION FOR CUT PARTICLE
     enddo loop_301
  ENDIF

  ION=1
  IF(NEL.EQ.1) THEN
     NUM_DIFF=NB*NDF_INC-NP_TMIN1(NEL,2)
     NP_TMIN1(NEL,1)=0
     NP_TMIN1(NEL,3)=NB
     NP_TMIN1(NEL,4)=NDF_INC
     NP_TMIN1(NEL,2)=NP_TMIN1(NEL,3)*NP_TMIN1(NEL,4)
  ELSE
     NUM_DIFF=NB*NDF_INC-NP_TMIN1(NEL,2)
     NP_TMIN1(NEL,1)=NP_TMIN1(NEL-1,1)+NP_TMIN1(NEL-1,2)
     NP_TMIN1(NEL,3)=NB
     NP_TMIN1(NEL,4)=NDF_INC
     NP_TMIN1(NEL,2)=NP_TMIN1(NEL,3)*NP_TMIN1(NEL,4)
  ENDIF
  IF((NP_TMIN1(NEL,1)+NP_TMIN1(NEL,2)).GT.NUMTMIN1) THEN
     WRITE(*,*) "THE dimension of TMIN1 is not enough"
     WRITE(*,*) "Increase it to", (NP_TMIN1(NEL,1)+NP_TMIN1(NEL,2)), NEL
  ENDIF
  IF(NUM_DIFF.LT.0) THEN
     WRITE(*,*) "Impossible NB*NDF_INC",NB,NDF_INC
     stop
  ENDIF
  IF(NUM_DIFF.GT.0) THEN
     loop_10091: DO I=NELX,NEL+1,-1
        loop_10092: DO J=NP_TMIN1(I,2),1,-1
           TMIN1(NP_TMIN1(I,1)+NUM_DIFF+J)=TMIN1(NP_TMIN1(I,1)+J)
        enddo loop_10092
        NP_TMIN1(I,1)=NP_TMIN1(I,1)+NUM_DIFF
     enddo loop_10091
  ENDIF
  !************************************************
  loop_305: DO I=1,NB*NDF_INC
     I1=(I-1)/(NDF_INC)+1
     I2=I-(I1-1)*NDF_INC
     TSOFT(I1,I2)=0.D0
     TMIN1(NP_TMIN1(NEL,1)+(I1-1)*NP_TMIN1(NEL,4)+I2)=0.D0
  enddo loop_305
  tj118=0.d0
  IF(MYMPI.EQ.0) THEN
     if(NEL.EQ.1) THEN
        open(982,file="tmin1_bound.dat")
     else
        open(982,file="tmin1_bound.dat",position="APPEND")
        write(982,*) 
     ENDIF
  ENDIF
  INP=0
  loop_302: DO I=1,NINPT
     IF (I.EQ.1) THEN
        IC_X=1
        IC_Y=2
     ENDIF
     I1=NDMAP(I)
     I2=I1+1
     IF (I2.GT.ND_TOT) I2=1
     I7=I-(I/NORD(NEL))*NORD(NEL)
     IF (I7.EQ.0) I7=NORD(NEL)
     IF (I7.EQ.1) THEN
        IF (LC_ND(I1).EQ.1.OR.LC_ND(I1).EQ.4) THEN
           IC_X=I1
        ELSE
           IC_Y=I1
        ENDIF
        XADD=0.D0
        YADD=0.D0
        IC_X1=IC_X
        loop_10093: DO WHILE (IC_X1.NE.I1) 
           XADD=XADD+XLENGTH(IC_X1)
           IC_X1=IC_X1+1
           IF (IC_X1.GT.ND_TOT) IC_X1=1
        enddo loop_10093
        IC_Y1=IC_Y
        loop_10094: DO WHILE (IC_Y1.NE.I1) 
           YADD=YADD+XLENGTH(IC_Y1)
           IC_Y1=IC_Y1+1
           IF (IC_Y1.GT.ND_TOT) IC_Y1=1
        enddo loop_10094
        CS=CSLOC1(IC_X)
        SN=SNLOC1(IC_X)
        loop_10095: DO IJ=I1,I1+NORD(NEL)-1
           IK=IJ-I1+1
           sx=sxlc(i)
           sy=sylc(i)
           FACT=2.D0/DFLOAT(INTERP(IC_X)-1)
           loop_10096: DO KJ=1,INTERP(IC_X)
              IPT=IPRD(INTERP(IC_X)-1)+KJ-1
              SH_X(KJ,IK)=PRD(IPT)
              loop_10097: DO L=1,INTERP(IC_X)
                 IF (L.NE.KJ) THEN
                    SH_X(KJ,IK)=SH_X(KJ,IK)*&
                         (SX+1.D0-FACT*DFLOAT(L-1))
                 ENDIF
              enddo loop_10097
           enddo loop_10096
           FACT=2.D0/DFLOAT(INTERP(IC_Y)-1)
           loop_10098: DO KJ=1,INTERP(IC_Y)
              IPT=IPRD(INTERP(IC_Y)-1)+KJ-1
              SH_Y(KJ,IK)=PRD(IPT)
              loop_10099: DO L=1,INTERP(IC_Y)
                 IF (L.NE.KJ) THEN
                    SH_Y(KJ,IK)=SH_Y(KJ,IK)*&
                         (SY+1.D0-FACT*DFLOAT(L-1))
                 ENDIF
              enddo loop_10099
           enddo loop_10098
        enddo loop_10095
     ENDIF
     IF (DETOUT(I).GT.1.D-11) THEN
        IF ((ICOMN(I1).EQ.0.OR.ICOMN(I2).EQ.0)) THEN
           IF (ICMNL(I1).EQ.0.OR.ICMNL(I2).EQ.0) THEN  
              IF(MYMPI.EQ.0) write(982,*) XIN(I),YIN(I)
           ENDIF
           XL(1,1)=DCS_NORM(I)
           XL(3,1)=DSN_NORM(I)
           XL(2,2)=XL(3,1)
           XL(3,2)=XL(1,1)
           loop_304: DO J=1,NB
              TTX=(PMATLCB(I,1,J)*XL(1,1)+PMATLCB(I,3,J)*XL(3,1))&
                   *DETOUT(I)
              TTY=(PMATLCB(I,2,J)*XL(2,2)+PMATLCB(I,3,J)*XL(3,2))&
                   *DETOUT(I)
              TTX_C=TTX*CS
              TTX_S=TTX*SN
              TTY_C=TTY*CS
              TTY_S=TTY*SN
              IBEG=IPRD(INTERP(IC_X)-1)
              XLENX=0.D0
              XLENY=0.D0
              ND=1
              FACT=2.D0/DFLOAT(INTERP(IC_X)-1)
              loop_10100: DO WHILE (ND.LE.INTERP(IC_X)) 
                 S=-1.D0+((1.D0+S)*XLENGTH(I1)+XADD*2.D0)/&
                      XLENGTH_I(IC_X)
                 IPT=IPRD(INTERP(IC_X)-1)+ND-1
                 SH1=PRD(IPT)
                 loop_10101: DO L=1,INTERP(IC_X)
                    IF (L.NE.ND) THEN
                       SH1=SH1*(S+1.D0-FACT*DFLOAT(L-1))
                    ENDIF
                 enddo loop_10101
                 sx=sxlc(i)
                 if (interp(ic_x).eq.2) then
                    if (nd.eq.1) then
                       sh1=(1.d0-sx)*0.5d0
                    else
                       sh1=(1.d0+sx)*0.5d0
                    endif
                 else
                    if (nd.eq.1) then
                       sh1=sx*(sx-1.d0)*0.5d0
                    else if (nd.eq.2) then
                       sh1=1.d0-sx*sx
                    else
                       sh1=sx*(1.d0+sx)*0.5d0
                    endif
                 endif
                 ID=INTERP_LC(IC_X,ND)
                 IF (LC_ND(ID).EQ.1) THEN                 
                    IF (ICMNL(I1).EQ.0.OR.ICMNL(I2).EQ.0) THEN       
                       TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)=&
                            TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)&
                            +(TTX_C*CS+TTY_S*CS)*SH1
                       TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID+1)=&
                            TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID+1)&
                            +(TTX_C*SN+TTY_S*SN)*SH1
                    ENDIF
                    TSOFT(J,ID)=TSOFT(J,ID)+(TTX_C*CS+&
                         TTY_S*CS)*SH1
                    TSOFT(J,ID+1)=TSOFT(J,ID+1)+(TTX_C*SN&
                         +TTY_S*SN)*SH1
                 ELSEIF (LC_ND(ID).EQ.2) THEN
                    IF (ICMNL(I1).EQ.0.OR.ICMNL(I2).EQ.0) THEN       
                       TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID-1)=&
                            TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID-1)&
                            +(TTX_C*CS+TTY_S*CS)*SH1
                       TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)=&
                            TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)&
                            +(TTX_C*SN+TTY_S*SN)*SH1
                    ENDIF
                    TSOFT(J,ID-1)=TSOFT(J,ID-1)+(TTX_C*CS+&
                         TTY_S*CS)*SH1
                    TSOFT(J,ID)=TSOFT(J,ID)+(TTX_C*SN&
                         +TTY_S*SN)*SH1
                 ELSE
                    IF (ICMNL(I1).EQ.0.OR.ICMNL(I2).EQ.0) THEN       
                       TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)=&
                            TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)&
                            +(TTX_C+TTY_S)*SH1
                    ENDIF
                    TSOFT(J,ID)=TSOFT(J,ID)+(TTX_C+TTY_S)&
                         *SH1
                 ENDIF
                 ND=ND+1
              enddo loop_10100
              IBEG=IPRD(INTERP(IC_Y)-1)
              ND=1
              FACT=2.D0/DFLOAT(INTERP(IC_Y)-1)
              loop_10102: DO WHILE (ND.LE.INTERP(IC_Y))
                 S=-1.D0+((1.D0+S)*XLENGTH(I1)+YADD*2.D0)/&
                      XLENGTH_I(IC_Y)
                 IPT=IPRD(INTERP(IC_Y)-1)+ND-1
                 SH1=PRD(IPT)
                 loop_10103: DO L=1,INTERP(IC_Y)
                    IF (L.NE.ND) THEN
                       SH1=SH1*(S+1.D0-FACT*DFLOAT(L-1))
                    ENDIF
                 enddo loop_10103
                 sy=sylc(i)
                 if (interp(ic_x).eq.2) then
                    if (nd.eq.1) then
                       sh1=(1.d0-sy)*0.5d0
                    else
                       sh1=(1.d0+sy)*0.5d0
                    endif
                 else
                    if (nd.eq.1) then
                       sh1=sy*(sy-1.d0)*0.5d0
                    else if (nd.eq.2) then
                       sh1=1.d0-sy*sy
                    else
                       sh1=sy*(1.d0+sy)*0.5d0
                    endif
                 endif
                 ID=INTERP_LC(IC_Y,ND)
                 IF (LC_ND(ID).EQ.2) THEN                        
                    IF (ICMNL(I1).EQ.0.OR.ICMNL(I2).EQ.0) THEN       
                       TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID-1)=&
                            TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID-1)&
                            +(TTX_S*SN-TTY_S*CS)*SH1
                       TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)=&
                            TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)&
                            +(-TTX_S*CS+TTY_C*CS)*SH1
                    ENDIF
                    TSOFT(J,ID-1)=TSOFT(J,ID-1)+(TTX_S*SN-&
                         TTY_S*CS)*SH1
                    TSOFT(J,ID)=TSOFT(J,ID)+(-TTX_S*CS&
                         +TTY_C*CS)*SH1
                 ELSEIF (LC_ND(ID).EQ.1) THEN
                    IF (ICMNL(I1).EQ.0.OR.ICMNL(I2).EQ.0) THEN       
                       TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)=&
                            TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)&
                            +(TTX_S*SN-TTY_S*CS)*SH1
                       TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID+1)=&
                            TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID+1)&
                            +(-TTX_S*CS+TTY_C*CS)*SH1
                    endif
                    TSOFT(J,ID)=TSOFT(J,ID)+(TTX_S*SN-&
                         TTY_S*CS)*SH1
                    TSOFT(J,ID+1)=TSOFT(J,ID+1)+(-TTX_S*CS&
                         +TTY_C*CS)*SH1
                 ELSE
                    IF (ICMNL(I1).EQ.0.OR.ICMNL(I2).EQ.0) THEN       
                       TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)=&
                            TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+ID)&
                            +(TTY_C-TTX_S)*SH1
                    endif
                    TSOFT(J,ID)=TSOFT(J,ID)+(TTY_C-TTX_S)&
                         *SH1                           
                 ENDIF
                 ND=ND+1
              enddo loop_10102
           enddo loop_304
        ENDIF
     ENDIF
  enddo loop_302
  IF(MYMPI.EQ.0) THEN
     rewind(982)
     close(982)
  ENDIF
  LWORK=2*MAX(3*MIN(NBM,NDELM)+MAX(NBM,NDELM),5*MIN(NBM,NDELM))
  ALLOCATE(T(NBM,NDFELM),U(NBM,NBM),V(NDFELM,NDFELM),EIG(NDFELM)&
       ,WORK(LWORK))
  T=0.D0
  U=0.D0
  V=0.D0
  EIG=0.D0
  WORK=0.D0
  NBD=0
  loop_10104: DO I=1,NB
     NBD=NBD+1
     loop_10105: DO J=1,NDF_INC
        T(NBD,J)=TSOFT(I,J)
     enddo loop_10105
  enddo loop_10104
  IPATH=01
  TOL=-1.D-10
  IF (JCUT.EQ.0) THEN
     loop_10106: DO I=1,ND_TOT
        IF (IDOSOFT(I).EQ.1) JCUT=JCUT-IDOSOFT(I)
     enddo loop_10106
  ENDIF
  jcut=0
  if (kassign.ne.0) jcut=3
  IF (ICUT.EQ.1.OR.JCUT.GT.2) THEN
     ISTOP=0
     loop_10107: DO I=1,0
        IF (EIG(I).LT.1.D-03) THEN
           WRITE (*,*) 'CODE NOT READY FOR HOURGLASS MODES IN'
           WRITE (*,*) 'CUT PARTICLE. D.O.F=',I,' S.VAL=',&
                EIG(I)
           ISTOP=1
        ENDIF
     enddo loop_10107
     IF (ISTOP.EQ.1) STOP
     IHGLASS(NEL,NDF_INC+1)=1
     loop_10108: DO I=1,NDF_INC
        EIG(I)=1.D0
        IHGLASS(NEL,I)=0
     enddo loop_10108
     IHGNEL(NEL)=0
  ELSEIF (JCUT.GT.0) THEN
     PRINT *,'NOT READY TO HANDLE PARTIAL RIGID BODY CONSTRAINTS'
     STOP
  ELSE IF (JCUT.LT.0) THEN
     loop_10109: DO I=1,ND_TOT
        IF (INTERP(I).GT.3) THEN
           WRITE (*,*) 'PROGRAM NOT READY FOR SEPERATING OUT '
           WRITE (*,*) 'ONLY RIGID BODY MODES ALONG&
                INCLUSION/SOFTENING'
           WRITE (*,*) 'BOUNDARY FOR CUBIC(OR) GRATER INTERP'
           STOP
        ENDIF
     enddo loop_10109
     DTRAN_NORM=1.D0/DSQRT(DFLOAT(NDF_INC/2))
     loop_10110: DO I=1,ND_TOT-1,2
        DUR1(I)=1.D0*DTRAN_NORM
        DUR1(I+1)=0.D0
        DUR2(I)=0.D0
        DUR2(I+1)=1.D0*DTRAN_NORM
        DUR3(I)=YLOC1(I)
        DUR3(I+1)=-XLOC1(I)
     enddo loop_10110
     loop_10111: DO I=ND_TOT+1,NDF_INC
        DUR1(I)=0.D0
        DUR2(I)=0.D0
        DUR3(I)=0.D0
     enddo loop_10111
     loop_10112: DO I=1,ND_TOT
        IF (INTERP(I).EQ.3) THEN
           NDL=INTERP_LC(I,2)
           IF (LC_ND(I).EQ.1.OR.LC_ND(I).EQ.4) THEN
              DUR1(NDL)=1.D0*DTRAN_NORM
              DUR2(NDL)=0.D0
              DUR3(NDL)=YMDLOC(I+1)
           ELSE
              DUR1(NDL)=0.D0
              DUR2(NDL)=1.D0*DTRAN_NORM
              DUR3(NDL)=-XMDLOC(I)
           ENDIF
        ENDIF
     enddo loop_10112
     DT1=0.D0
     DT2=0.D0
     loop_10113: DO I=1,NDF_INC
        DT1=DT1+DUR3(I)*DUR1(I)
        DT2=DT2+DUR3(I)*DUR2(I)
     enddo loop_10113
     DNRM3=0.D0
     DTPRD1=0.D0
     DTPRD2=0.D0
     DTPRD3=0.D0
     loop_10114: DO I=1,NDF_INC
        DUR3(I)=DUR3(I)-DT1*DUR1(I)-DT2*DUR2(I)
        DNRM3=DNRM3+DUR3(I)*DUR3(I)
        DTPRD1=DTPRD1+DUR1(I)*DUR2(I)
        DTPRD2=DTPRD2+DUR2(I)*DUR3(I)
        DTPRD3=DTPRD3+DUR3(I)*DUR1(I)
     enddo loop_10114
     IF (DABS(DNRM3-1.D0).GT.1.D-03) THEN
        DNRM3=1.D0/DSQRT(DNRM3)
        loop_10115: DO I=1,NDF_INC
           DUR3(I)=DUR3(I)*DNRM3
        enddo loop_10115
     ENDIF
     loop_10116: DO I=1,NDF_INC
        V(NDF_INC,I)=DUR1(I)
        V(NDF_INC-1,I)=DUR2(I)
        V(NDF_INC-2,I)=DUR3(I)
        EIG(I)=0.D0
        EIG(I)=0.D0
        EIG(I)=0.D0
     enddo loop_10116
     IJNOW=NDF_INC
     IDO=NDF_INC-3
     loop_10117: DO WHILE (IJNOW.NE.0.AND.IDO.NE.0) 
        loop_10118: DO I=1,NDF_INC
           DUR1(I)=0.D0
        enddo loop_10118
        DUR1(IJNOW)=1.D0
        loop_10119: DO K=IDO+1,NDF_INC
           DTPR=0.D0
           loop_10120: DO L=1,NDF_INC
              DTPR=DTPR+DUR1(L)*V(K,L)
           enddo loop_10120
           loop_10121: DO L=1,NDF_INC
              DUR1(L)=DUR1(L)-DTPR*V(K,L)
           enddo loop_10121
        enddo loop_10119
        DNRM1=0.D0
        loop_10122: DO L=1,NDF_INC
           DNRM1=DNRM1+DUR1(L)*DUR1(L)
        enddo loop_10122
        IF (DABS(DNRM1).LT.1.D-07) THEN
           IJNOW=IJNOW-1
        ELSE
           IF (DABS(DNRM1-1.D0).GT.1.D-03) THEN
              DNRM1=1.D0/DSQRT(DNRM1)
           ELSE
              DNRM1=1.D0
           ENDIF
           loop_10123: DO L=1,NDF_INC
              V(IDO,L)=DUR1(L)*DNRM1
           enddo loop_10123
           EIG(IDO)=1.D0
           IJNOW=IJNOW-1
           IDO=IDO-1
        ENDIF
     enddo loop_10117
     IF (IDO.NE.0) THEN
        WRITE (*,*) 'GRAHM-SCHMIDTH FAILED'
        STOP
     ENDIF
     loop_10124: DO I=1,NDF_INC
        loop_10125: DO J=I,NDF_INC
           VIJ=0.D0
           loop_10126: DO K=1,NDF_INC
              VIJ=VIJ+V(K,I)*V(K,J)
           enddo loop_10126
           IF (I.NE.J) THEN
              DERR=DABS(VIJ)
           ELSE
              DERR=DABS(VIJ-1.D0)
           ENDIF
           IF (DERR.GT.1.D-03) THEN
              WRITE (*,*) 'VT*V=',VIJ,'??'
           ENDIF
        enddo loop_10125
     enddo loop_10124
     IHGNEL(NEL)=1
     IHGLASS(NEL,NDF_INC+1)=1
     loop_10127: DO I=1,NDF_INC
        IHGLASS(NEL,I)=0      
        IHGLASS(NEL,NDF_INC+1)=0
        IF (EIG(I).LT.1.D-03) THEN
           IHGLASS(NEL,NDF_INC+1)=1
           IHGLASS(NEL,I)=1
        ENDIF
        FACT=1.D0
        FACT=1.D0/FACT
        loop_10128: DO J=1,NDF_INC
           V(I,J)=V(I,J)*FACT
        enddo loop_10128
     enddo loop_10127
  ELSE
     CALL DGESVD ('A','A',NBM,NDFELM,T,NBM,EIG,U,NBM,V,NDFELM,WORK,&
          LWORK,INFO)
     EIGR_MAX=0.D0
     loop_10129: DO I=NDF_INC-2,NDF_INC
        IF (EIGR_MAX.LT.EIG(I)) THEN
           EIGR_MAX=EIG(I)
        ENDIF
     enddo loop_10129

     ICUT=0
     !     ****************
     IF (ICUT.EQ.0) THEN
        IHGLASS(NEL,NDF_INC+1)=1
        loop_10130: DO I=1,NDF_INC
           IHGLASS(NEL,I)=0      
           IHGLASS(NEL,NDF_INC+1)=0
           IF (EIG(I).LT.1.D-03) THEN
              IHGLASS(NEL,NDF_INC+1)=1
              IHGLASS(NEL,I)=1
           ENDIF
           FACT=1.D0
           FACT=1.D0/FACT
           loop_10131: DO J=1,NDF_INC
              V(I,J)=V(I,J)*FACT
           enddo loop_10131
        enddo loop_10130
        IHGNEL(NEL)=1
     ELSE
        IHGLASS(NEL,NDF_INC+1)=1
        loop_10132: DO I=1,NDF_INC
           EIG(I)=1.D0
           IHGLASS(NEL,I)=0
        enddo loop_10132
        IHGNEL(NEL)=0
     ENDIF
     ! Lines modified temporarily for yongs comparision
  ENDIF
  IF(NDF_INC.GT.NDELM) THEN
     WRITE(*,*) "NDELM(=",NDELM,") is not enough,&
          increase it to ", NDF_INC
  ENDIF
  IF(IHGNEL(NEL).EQ.1) THEN
     IF(NEL.EQ.1) THEN
        NUM_DIFF=NDF_INC*NDF_INC-NP_HGLASS(NEL,2)
        NP_HGLASS(NEL,1)=0
        NP_HGLASS(NEL,3)=NDF_INC
        NP_HGLASS(NEL,4)=NDF_INC
        NP_HGLASS(NEL,2)=NP_HGLASS(NEL,3)*NP_HGLASS(NEL,4)
     ELSE
        NUM_DIFF=NDF_INC*NDF_INC-NP_HGLASS(NEL,2)
        NP_HGLASS(NEL,1)=NP_HGLASS(NEL-1,1)+NP_HGLASS(NEL-1,2)
        NP_HGLASS(NEL,3)=NDF_INC
        NP_HGLASS(NEL,4)=NDF_INC
        NP_HGLASS(NEL,2)=NP_HGLASS(NEL,3)*NP_HGLASS(NEL,4)
     ENDIF
  ELSE
     IF(NEL.EQ.1) THEN
        NUM_DIFF=-NP_HGLASS(NEL,2)
        NP_HGLASS(NEL,1)=0
        NP_HGLASS(NEL,3)=0
        NP_HGLASS(NEL,4)=0
        NP_HGLASS(NEL,2)=0
     ELSE
        NUM_DIFF=-NP_HGLASS(NEL,2)
        NP_HGLASS(NEL,1)=NP_HGLASS(NEL-1,1)+NP_HGLASS(NEL-1,2)
        NP_HGLASS(NEL,3)=0
        NP_HGLASS(NEL,4)=0
        NP_HGLASS(NEL,2)=0
     ENDIF
  ENDIF
  IF((NP_HGLASS(NEL,1)+NP_HGLASS(NEL,2)).GT.NUMHG) THEN
     WRITE(*,*) "THE dimension of PHI_HGLASS is not enough"
     WRITE(*,*) "Increase it to", (NP_HGLASS(NEL,1)+NP_HGLASS(NEL,2)), NEL
  ENDIF
  IF(NUM_DIFF.GT.0) THEN
     loop_10133: DO I=NELX,NEL+1,-1
        loop_10134: DO J=NP_HGLASS(I,2),1,-1
           PHI_HGLASS(NP_HGLASS(I,1)+NUM_DIFF+J)=PHI_HGLASS(NP_HGLASS(I,1)+J)
        enddo loop_10134
        NP_HGLASS(I,1)=NP_HGLASS(I,1)+NUM_DIFF
     enddo loop_10133
  ELSE
     loop_10135: DO I=NEL+1,NELX
        loop_10136: DO J=1,NP_HGLASS(I,2)
           PHI_HGLASS(NP_HGLASS(I,1)+NUM_DIFF+J)=PHI_HGLASS(NP_HGLASS(I,1)+J)
        enddo loop_10136
        NP_HGLASS(I,1)=NP_HGLASS(I,1)+NUM_DIFF
     enddo loop_10135
  ENDIF
  IF(IHGNEL(NEL).EQ.1) THEN
     loop_10137: DO I=1,NDF_INC
        loop_10138: DO J=1,NDF_INC
           PHI_HGLASS(NP_HGLASS(NEL,1)+(I-1)*NP_HGLASS(NEL,4)+J)=V(J,I)
        enddo loop_10138
     enddo loop_10137
  ENDIF
  loop_10139: DO i=1,nb
     if (ibet_con(i,nel).eq.-501) then
        loop_10140: do j=1,ndf_inc
           TMIN(NP_TMIN(NEL,1)+(I-1)*NP_TMIN(NEL,4)+J)=0.D0
        enddo loop_10140
     endif
  enddo loop_10139
  NUMIN=NX+NIX
  NUMNOD=NIX1
  NINPT=NIX1*NORD(NEL)
  !     FORM T MATRIX
  NADD=NX+2*NIX
  if (nix1.ne.0) then
     numin=nx+nix
     loop_10141: DO N1=NUMIN+1,numin+NIX1
        icomn(n1+nix)=0            
        N2=nx+1
        loop_10142: do while (icomn(n1+nix).eq.0.and.n2.le.nx+nix)
           xd=xn(n1)-xn(n2)
           yd=yn(n1)-yn(n2)
           if (dsqrt(xd*xd+yd*yd).lt.1.d-12) then
              icomn(n1+nix)=nix+n2
           else
              n2=n2+1
           endif
        enddo loop_10142
     enddo loop_10141
  endif
  loop_10143: do j=1,nix1
     xn1(j)=xn(numin+j)
     yn1(j)=yn(numin+j)
     icomn1(j)=icomn(j+numin+nix)
     ihp(j*2-1)=j*2-1
     ihp(j*2)=j*2
  enddo loop_10143
  ipolycr=0
  nixt=nix1
  jnow=0
  ndcrk_add(nel)=0
  loop_10144: do j=1,0
     jnow=jnow+1
     j1=j+1
     if (j1.gt.nix1) j1=1
     if (icomn(numin+nix+j).ne.0.and.icomn(numin+nix+j1).ne.0) then
        k=1
        kfind=0
        loop_10145: do while (k.le.nd_tot.and.kfind.eq.0) 
           if (int_hp_inc(nel_beg+k*3+2).eq.1) then
              xd=xn(j+numin)-coord_hp_inc(kel_beg+k*3-1)
              yd=yn(j+numin)-coord_hp_inc(kel_beg+k*3)
              if (dabs(xd*xd+yd*yd).lt.1.d-10) then
                 kfind=k
              else
                 k=k+1
              endif
           else
              k=k+1
           endif
        enddo loop_10145
        if (kfind.eq.0) then
           write (*,*) 'common node in crack-incl boundary doesnt'
           write (*,*) 'have equivalent in coord_hp_inc'
           stop
        endif
        if (interp(kfind).eq.3) then
           ndcrk_add(nel)=ndcrk_add(nel)+1
           ndfcrk_add(nel,ndcrk_add(nel))=int_hp_inc(nel_beg+interp_lc(kfind,2)*3)
           ipolycr=ipolycr+1
           ndpoly(ipolycr,1)=ndcrk_add(nel)+nix1*2
           ndpoly(ipolycr,2)=jnow*2-1
        else if (interp(kfind).gt.3) then
           write (*,*) 'code not ready for cubic (or grater) interp'
           write (*,*) 'on crack boundary'
           stop
        endif
        if (interp(kfind+1).eq.3) then
           ndcrk_add(nel)=ndcrk_add(nel)+1
           ndfcrk_add(nel,ndcrk_add(nel))=int_hp_inc(nel_beg+interp_lc(kfind+1,2)*3)
           ipolycr=ipolycr+1
           ndpoly(ipolycr,1)=ndcrk_add(nel)+nix1*2
           ndpoly(ipolycr,2)=jnow*2
        else if (interp(kfind+1).gt.3) then
           write (*,*) 'code not ready for cubic (or grater) interp'
           write (*,*) 'on crack boundary'
           stop
        endif
        kfind1=kfind+2
        if (kfind1.gt.nd_tot) kfind1=1
        jadd=0
        loop_10146: do while (int_hp_inc(nel_beg+kfind1*3+2).ne.1) 
           if (int_hp_inc(nel_beg+kfind1*3+2).eq.4) then
              jadd=jadd+1
              ndcrk_add(nel)=ndcrk_add(nel)+1
              ndfcrk_add(nel,ndcrk_add(nel))=int_hp_inc(nel_beg+kfind1*3)
              ndh1=ndcrk_add(nel)+nix1*2
              if (interp(kfind1).eq.3) then
                 ndcrk_add(nel)=ndcrk_add(nel)+1
                 ndfcrk_add(nel,ndcrk_add(nel))=int_hp_inc(nel_beg+interp_lc(kfind1,2)*3)
                 ipolycr=ipolycr+1
                 ndpoly(ipolycr,1)=ndcrk_add(nel)+nix1*2
                 ndpoly(ipolycr,2)=(jnow+jadd)*2-1
              else if (interp(kfind1).gt.3) then
                 write (*,*) 'code not ready for cubic (or grater) interp'
                 write (*,*) 'on crack boundary'
                 stop
              endif
              ndcrk_add(nel)=ndcrk_add(nel)+1
              ndfcrk_add(nel,ndcrk_add(nel))=int_hp_inc(nel_beg+kfind1*3+3)
              ndh2=ndcrk_add(nel)+nix1*2
              if (interp(kfind1+1).eq.3) then
                 ndcrk_add(nel)=ndcrk_add(nel)+1
                 ndfcrk_add(nel,ndcrk_add(nel))=int_hp_inc(nel_beg+interp_lc(kfind1+1,2)*3)
                 ipolycr=ipolycr+1
                 ndpoly(ipolycr,1)=ndcrk_add(nel)+nix1*2
                 ndpoly(ipolycr,2)=(jnow+jadd)*2
              else if (interp(kfind1+1).gt.3) then
                 write (*,*) 'code not ready for cubic (or grater) interp'
                 write (*,*) 'on crack boundary'
                 stop
              endif
              loop_10147: do l=nixt,jnow+jadd,-1
                 xn1(l+1)=xn1(l)
                 yn1(l+1)=yn1(l)
                 ihp((l+1)*2-1)=ihp(l*2-1)
                 ihp((l+1)*2)=ihp(l*2)
                 icomn1(l+1)=icomn1(l)
              enddo loop_10147
              nixt=nixt+1
              icomn1(jnow+jadd)=1
              xn1(jnow+jadd)=coord_hp_inc(kel_beg+kfind1*3-1)
              yn1(jnow+jadd)=coord_hp_inc(kel_beg+kfind1*3)
              ihp((jnow+jadd)*2-1)=ndh1
              ihp((jnow+jadd)*2)=ndh2
           endif
           kfind1=kfind1+1
           if (kfind1.gt.nd_tot) kfind1=1
        enddo loop_10146
        jnow=jnow+jadd
     endif
  enddo loop_10144
  NUMNOD=NIXt
  NINPT=NIXt*NORD(NEL)
  N1=0
  loop_10148: DO N=1,NIXT
     X0=XN1(N)
     Y0=YN1(N)
     M=N+1
     IF (M.GT.NUMNOD) M=1
     X1=XN1(M)
     Y1=YN1(M)
     X12=X1-XCCP
     Y12=Y1-YCCP
     X11=X12*CS8+Y12*SN8
     Y11=-X12*SN8+Y12*CS8
     RINS1=((X11)/XSC1)**2+((Y11)/YSC1)**2
     RINS1=DSQRT(RINS1)
     X12=X0-XCCP
     Y12=Y0-YCCP
     X11=X12*CS8+Y12*SN8
     Y11=-X12*SN8+Y12*CS8
     RINS2=((X11)/XSC1)**2+((Y11)/YSC1)**2
     RINS2=DSQRT(RINS2)
     XMID=(X0+X1)*0.5E0
     YMID=(Y0+Y1)*0.5E0
     ANG=DATAN2(YMID-YCCP,XMID-XCCP)
     CS7=DCOS(ANG)
     SN7=DSIN(ANG)
     CSS=CS8*CS7+SN7*SN8
     SNN=SN7*CS8-SN8*CS7
     RF=(CSS/XSC1)**2+(SNN/YSC1)**2
     IF (ICOMN1(M).EQ.0.OR.ICOMN1(N).EQ.0) THEN
        RF=(RINS1+RINS2)*0.5D0/DSQRT(RF)
        XMID1=RF*CSS
        YMID1=RF*SNN
        XMID=XMID1*CS8-YMID1*SN8+XCCP
        YMID=XMID1*SN8+YMID1*CS8+YCCP
     ELSE
        XMID=(X0+X1)*0.5D0
        YMID=(Y0+Y1)*0.5D0
     ENDIF
     loop_10149: DO J=1,101
        S=-1.D0+DFLOAT(J-1)*2.D-2
        XMAP(J)=X0*(S-1)*S/2.E0+X1*S*(1+S)/2.E0+XMID*(1-S**2)-XCCP
        YMAP(J)=Y0*(S-1)*S/2.E0+Y1*S*(1+S)/2.E0+YMID*(1-S**2)-YCCP
     enddo loop_10149
     N101=101
     CALL CONMAP13(N101,SC,A0,CSINT,SNNT,XMAP,YMAP,F,DFDX,&
          DFDY,DFDXY,DFDXX,DFDYY,XSC1/1.08D0,YSC1/1.01D0,CSC2)
     J=1
     loop_10150: DO WHILE (J.LT.101)
        FS=F(J)
        JK=J+1
        IFIND=0
        loop_10151: DO WHILE (JK.LE.101.AND.IFIND.EQ.0) 
           IF (FS.LT.1.1) THEN
              IF (F(JK).GT.1.1) THEN
                 IFIND=1
              ENDIF
           ELSE IF (FS.LT.1.2) THEN
              IF (F(JK).LT.1.1.OR.F(JK).GT.1.2) THEN
                 IFIND=1
              ENDIF
           ELSE IF (FS.LT.1.4) THEN
              IF (F(JK).LT.1.2.OR.F(JK).GT.1.4) THEN
                 IFIND=1
              ENDIF
           ELSE
              IF (F(JK).LT.1.4) THEN
                 IFIND=1
              ENDIF
           ENDIF
           IF (IFIND.EQ.0) JK=JK+1
        enddo loop_10151
        IF (JK.EQ.102) JK=101
        S1=-1.D0+(J-1)*2.D-2
        S2=-1.D0+(JK-1)*2.D-2
        SMD=(S1+S2)*0.5D0
        XS1=X0*(S1-1)*S1/2.E0+X1*S1*(1+S1)/2.E0+XMID*(1-S1**2)
        YS1=Y0*(S1-1)*S1/2.E0+Y1*S1*(1+S1)/2.E0+YMID*(1-S1**2)
        XS2=X0*(S2-1)*S2/2.E0+X1*S2*(1+S2)/2.E0+XMID*(1-S2**2)
        YS2=Y0*(S2-1)*S2/2.E0+Y1*S2*(1+S2)/2.E0+YMID*(1-S2**2)
        XSMD=X0*(SMD-1)*SMD/2.E0+X1*SMD*(1+SMD)/2.E0+XMID*(1-SMD**2)
        YSMD=Y0*(SMD-1)*SMD/2.E0+Y1*SMD*(1+SMD)/2.E0+YMID*(1-SMD**2)
        loop_10152: DO KK=1,NRDL
           SLC=BP(INTBEG(NORD(NEL))+KK)
           S=S1*(1.D0-SLC)*0.5D0+S2*(1.D0+SLC)*0.5D0               
           WLC=W(INTBEG(NORD(NEL))+KK)               
           XAC=X0*(S-1)*S/2.E0+X1*S*(1+S)/2.E0+XMID*(1-S**2)
           YAC=Y0*(S-1)*S/2.E0+Y1*S*(1+S)/2.E0+YMID*(1-S**2)
           N1=N1+1
           SXLC(N1)=S
           SYLC(N1)=S
           XIN1(N1)=(XAC-XCP)/SC
           YIN1(N1)=(YAC-YCP)/SC
           DCS=XS1*(SLC-0.5D0)+XS2*(SLC+0.5D0)-2.D0*XSMD*SLC
           DSN=YS1*(SLC-0.5D0)+YS2*(SLC+0.5D0)-2.D0*YSMD*SLC
           GJAC=DSQRT(DCS*DCS+DSN*DSN)
           IF (ICOMN1(N).EQ.1.AND.ICOMN1(M).EQ.1) THEN
              DETIN(N1)=0.D0
           ELSE
              DETIN(N1)=GJAC*WLC
           ENDIF
           !     END ADDITION FOR CUT PARTICLE
           XD=X0-X1
           YD=Y0-Y1
           XBETW=DSQRT(XD*XD+YD*YD)
           IF (GJAC.LT.1.D-10.OR.XBETW.LT.1.D-10) THEN
              XNRML(N1)=1.D0
              YNRML(N1)=0.D0
              DETIN(N1)=0.D0
           ELSE
              DCS=DCS/GJAC
              DSN=DSN/GJAC
              YNRML(N1)=-DCS
              XNRML(N1)=DSN
           ENDIF
           NDMAP(N1)=N
        enddo loop_10152
        J=JK
        FS=F(J)
     enddo loop_10150
  enddo loop_10148
  NINPT=N1
  DEALLOCATE(PMATLCB)
  ALLOCATE(PMATLCB(NINPT,3,NB))
  PMATLCB=0.D0
  SC=A1
  NB=NB-NCYLFLAG(NEL,2)*NTRMADD(NEL,2)
  IF(IWORP(NEL).NE.0) THEN
     NB=NB-(NPBG_WLT(NEL+1)-NPBG_WLT(NEL))
  ENDIF
  loop_521: DO I=1,NINPT
     XX=XIN1(I)
     YY=YIN1(I)
     CALL GEN_VCF_P(NB,XX,YY,PM)
     loop_10153: DO INB=1,NB
        PMATLCB(I,1,INB)=PM((INB-1)*3+1)
        PMATLCB(I,2,INB)=PM((INB-1)*3+2)
        PMATLCB(I,3,INB)=PM((INB-1)*3+3)
     enddo loop_10153
     IF(IWORP(NEL).EQ.0) THEN
        IF(NCYLFLAG(NEL,2).EQ.1) THEN
           XIN1(I)=(XX*SC+XDIF1)
           YIN1(I)=(YY*SC+YDIF1)
        ELSE
           XIN1(I)=(XX*SC+XCP)
           YIN1(I)=(YY*SC+YCP)
        ENDIF
     ENDIF
  enddo loop_521

  IF (NCYLFLAG(NEL,2).EQ.1) THEN
     CALL PMATLOCASS1(NEL,NINPT,SC,XDIF1,YDIF1,XIN1,YIN1,NB,&
          CONFOUR1(NEL),CSFOUR1(1,NEL),SNFOUR1(1,NEL),PMATLCB)
     NB=NB+NTRMADD(NEL,2)*NCYLFLAG(NEL,2)
     loop_10156: DO I=1,NINPT
        XIN1(I)=(XIN1(I)+XCCP)
        YIN1(I)=(YIN1(I)+YCCP)
     enddo loop_10156
  ENDIF
  IF(NEL.EQ.1) THEN
     NUM_DIFF=NB*(NUMNOD*2+ipolycr)-NP_TMIN2(NEL,2)
     NP_TMIN2(NEL,1)=0
     NP_TMIN2(NEL,3)=NB
     NP_TMIN2(NEL,4)=(NUMNOD*2+ipolycr)
     NP_TMIN2(NEL,2)=NP_TMIN2(NEL,3)*NP_TMIN2(NEL,4)
  ELSE
     NUM_DIFF=NB*(NUMNOD*2+ipolycr)-NP_TMIN2(NEL,2)
     NP_TMIN2(NEL,1)=NP_TMIN2(NEL-1,1)+NP_TMIN2(NEL-1,2)
     NP_TMIN2(NEL,3)=NB
     NP_TMIN2(NEL,4)=(NUMNOD*2+ipolycr)
     NP_TMIN2(NEL,2)=NP_TMIN2(NEL,3)*NP_TMIN2(NEL,4)
  ENDIF
  IF((NP_TMIN2(NEL,1)+NP_TMIN2(NEL,2)).GT.NUMTMIN2) THEN
     WRITE(*,*) "THE dimension of TMIN2 is not enough"
     WRITE(*,*) "Increase it to", (NP_TMIN2(NEL,1)+NP_TMIN2(NEL,2)), NEL
  ENDIF
  IF(NUM_DIFF.LT.0) THEN
     WRITE(*,*) "Impossible NB*(NUMNOD*2+ipolycr)",NB,(NUMNOD*2+ipolycr)
     stop
  ENDIF
  IF(NUM_DIFF.GT.0) THEN
     loop_10157: DO I=NELX,NEL+1,-1
        loop_10158: DO J=NP_TMIN2(I,2),1,-1
           TMIN2(NP_TMIN2(I,1)+NUM_DIFF+J)=TMIN2(NP_TMIN2(I,1)+J)
        enddo loop_10158
        NP_TMIN2(I,1)=NP_TMIN2(I,1)+NUM_DIFF
     enddo loop_10157
  ENDIF
  !************************************************
  loop_525: DO I=1,NB*(NUMNOD*2+ipolycr)
     I1=(I-1)/(NUMNOD*2)+1
     I2=I-(I1-1)*NUMNOD*2
     TMIN2(NP_TMIN2(NEL,1)+(I1-1)*NP_TMIN2(NEL,4)+I2)=0.D0
  enddo loop_525
  loop_10159: do j=1,nix
     intcr(j*3-2)=0
     intcr(j*3-1)=0
     intcr(j*3-0)=0
  enddo loop_10159
  loop_10160: do j=1,ipolycr
     jj=ndpoly(j,2)
     jk=(jj-1)/2+1
     intcr(jk*3-2)=1
     if (jj-(jj/2)*2.eq.0) then
        intcr(jk*3)=ndpoly(j,1)
     else
        intcr(jk*3-1)=ndpoly(j,1)
     endif
  enddo loop_10160
  loop_10161: do j=1,ipolycr
     if (intcr(j*3-2).eq.1) then
        if (intcr(j*3-1).eq.0.or.intcr(j*3).eq.0) then
           write (*,*) 'program doesnt work for different&
                poly order'
           write (*,*) 'interpolation in x&y of crack boundary'
           stop
        endif
     endif
  enddo loop_10161
  IF(MYMPI.EQ.0) THEN
     if(NEL.EQ.1) THEN
        open(983,file="tmin2_bound.dat")
     else
        open(983,file="tmin2_bound.dat",position="APPEND")
        write(983,*) 
     ENDIF
  ENDIF
  INP=1
  loop_524: DO J=1,NB
     loop_622: DO I=1,NINPT
        I1=ndmap(i)
        I2=I1+1
        IF (I2.GT.NUMNOD) I2=1
        I7=I-(I/NORD(NEL))*nord(nel)
        IF (I7.EQ.0) I7=NORD(NEL)
        S=sxlc(i)
        if (intcr(i1*3-2).eq.0) then
           SH(1,1)=(1.D0-S)/2.D0
           SH(1,3)=(1.D0+S)/2.D0
           SH(2,2)=SH(1,1)
           SH(2,4)=SH(1,3)
        else
           sh(1,1)=(s*(s-1.d0))*0.5d0
           sh(1,3)=(s*(s+1.d0))*0.5d0
           sh(2,2)=sh(1,1)
           sh(2,4)=sh(1,3)
           shm1=1.d0-s*s
           shm2=shm1
           imd1=intcr(i1*3-1)
           imd2=intcr(i1*3)
        endif
        XL(1,1)=XNRML(I)
        XL(3,1)=YNRML(I)
        XL(2,2)=XL(3,1)
        XL(3,2)=XL(1,1)
        IF (ICOMN1(I1).EQ.0.OR.ICOMN1(I2).EQ.0) THEN
           IF(J.EQ.1) THEN
              IF(I-INP.EQ.1) THEN
                 INP=I
              ELSE
                 INP=I
              ENDIF
           ENDIF
           IF(MYMPI.EQ.0.AND.J.EQ.1) write(983,*) XIN1(I),YIN1(I)
           TT1=(PMATLCB(I,1,J)*XL(1,1)+PMATLCB(I,3,J)*XL(3,1))&
                *DETIN(I)
           TT2=(PMATLCB(I,2,J)*XL(2,2)+PMATLCB(I,3,J)*XL(3,2)&
                )*DETIN(I)
           I11=ihp(i1*2-1)
           i12=ihp(i1*2)
           i21=ihp(i2*2-1)
           i22=ihp(i2*2)
           TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+I11)=&
                TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+I11)&
                +TT1*SH(1,1)
           TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+I12)=&
                TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+I12)&
                +TT2*SH(2,2)
           TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+I21)=&
                TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+I21)&
                +TT1*SH(1,3)
           TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+I22)=&
                TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+I22)&
                +TT2*SH(2,4)
           if (intcr(i1*3-2).eq.1) then
              TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+Imd1)=&
                   TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+Imd1)&
                   +TT1*SHm1
              TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+Imd2)=&
                   TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+Imd2)&
                   +TT2*SHm2
           endif
        ENDIF
     enddo loop_622
  enddo loop_524
  IF(MYMPI.EQ.0) THEN
     rewind(983)
     close(983)
  ENDIF
  DEALLOCATE(ICOMN, LC_ND,LC_BND,INTERP,INTERP_LC,ICMMN,ICOMN_INC&
       ,ICOMN_CRK,NDPOLY,IHP,intcr,icomn1,ICMNL,ICMNL1,NDMAP)

  DEALLOCATE(XOUT,YOUT,XIN,YIN,DETIN,DCS_NORM,DSN_NORM,XLOC1,YLOC1&
       ,ANGLOC1,CSLOC1,SNLOC1,XLENGTH,XLENGTH_I,SH_X,SH_Y,XN1&
       ,YN1,T,U,V,EIG,WORK,TSOFT,XNRML,YNRML,XIN1&
       ,YIN1,XMDLOC,YMDLOC,DUR1,DUR2,DUR3,XMAP,YMAP,F,DFDX,DFDY&
       ,DFDXY,DFDXX,DFDYY,SXLC,SYLC,PM,PREC,DETOUT,DETOUT1)
  DEALLOCATE(PMATLCB)
  RETURN
END SUBROUTINE TMATLOC_INC
