!===============================================================
!********************************************************************
SUBROUTINE TRANSPOSE(M,N,A,AT,IDIMA,IDIMAT)
!********************************************************************
!     THIS SUBROUTINE RETURNS 'MATRIX AT' AS TRANSPOSE OF 'MATRIX AMAT'
!     M=NO. OF ROWS OF AMAT
!     N=NO. OF COLUMNS OF AMAT
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  DIMENSION A(IDIMA,1),AT(IDIMAT,1)       
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  loop_10: DO I=1,N
     loop_10000: DO J=1,M
        AT(I,J)=0.0
        AT(I,J)=A(J,I)
     enddo loop_10000
  enddo loop_10
  RETURN     
  END
!===================================================================

!********************************************************************
SUBROUTINE MATMUL(N,M,L,AA,BB,CC,IDIMA,IDIMB,IDIMC)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
!     THIS SUBROUTINE RETURNS MARTIX [CC] = MATRIX [AA] * MATRIX [BB]
!     N=NO. OF ROWS OF [AA]      =NO. OF ROWS OF [CC]
!     M=NO. OF COLUMNS OF [AA]   =NO. OF ROWS OF [BB]
!     L=NO. OF COLUMNS OF [BB]   =NO. OF COLUMNS OF [CC]
  DIMENSION AA(IDIMA,1),BB(IDIMB,1),CC(IDIMC,1)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  loop_10: DO I=1,N
     loop_10001: DO J=1,L
        CC(I,J)=0.0
        loop_10002: DO K=1,M
           CC(I,J)=CC(I,J)+AA(I,K)*BB(K,J)
        enddo loop_10002
     enddo loop_10001
  enddo loop_10
  RETURN 
END SUBROUTINE MATMUL
!     ============================================================== 

FUNCTION DOTPRD1(V1,V2,N)
!     
!----------------------------------------------------------------------
!     
!     THIS FUNCTION COMPUTES THE DOTPRODUCT OF TWO VECTORS
!     TAKING CARE OF THE FIRST BOUNDARY CONDITION.
!-----------------------------------------------------------------------
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
 
  DIMENSION V1(N),V2(N)
  DOTPRD1=0.E0
  loop_1: DO I=1,N
     DOTPRD1=DOTPRD1+V1(I)*V2(I)
  enddo loop_1
  RETURN
  END
!     
!---------------------------------------------------------------------
!     
SUBROUTINE AZERO1(A,N)
!Assigns zeros to all elements in the matrix.
!---------------------------------------------------------------------
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  DIMENSION A(1)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  loop_10: DO I=1,N
     A(I)=0.
  enddo loop_10
  RETURN
END SUBROUTINE AZERO1
!----------------------------------------------------------------------
!     
FUNCTION DOTPRD(V1,V2,NBC1)
!     
!----------------------------------------------------------------------
!     
!     THIS FUNCTION COMPUTES THE DOTPRODUCT OF TWO VECTORS
!     TAKING CARE OF THE FIRST BOUNDARY CONDITION.
!-----------------------------------------------------------------------
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
!     
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON/BOUNDA/NBOUD1,NBOUD2,NBOUD3,NUPNCH
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /MACSTN/ NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)
  COMMON /BOUNDCURVE/ ABD_CRV,BBD_CRV,ANBD_CRV,&
       XBD_CRV,YBD_CRV,IBD_CRV
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /RIGIDDOF/ IRIGID(NDFM)
 
  DIMENSION V1(NEQ),V2(NEQ),NBC1(NBOUD1*3)
 
  DOTPRD=0.E0
  loop_10023: DO I=1,NEQ1
     IDO=1
     loop_10024: DO K=1,NBOUD1
        ND=NBC1(K*3-2)
        IF(ND.GT.nx_cell) THEN
           IF (NBC1(K*3-1).EQ.1) THEN
              ND1=ND*2
           ELSE
              ND1=0
           ENDIF
           IF (NBC1(K*3).EQ.1) THEN
              ND2=ND*2+1
           ELSE
              ND2=0
           ENDIF
           IF (ND1.EQ.I.OR.ND2.EQ.I) IDO=0
        ELSE
           IF (NBC1(K*3-1).EQ.1) THEN
              ND1=ND*2-1
           ELSE
              ND1=0
           ENDIF
           IF (NBC1(K*3).EQ.1) THEN
              ND2=ND*2
           ELSE
              ND2=0
           ENDIF
           IF (ND1.EQ.I.OR.ND2.EQ.I) IDO=0
        ENDIF
     enddo loop_10024
     IF (IDO.NE.0) THEN
        DOTPRD=DOTPRD+V1(I)*V2(I)
     ENDIF
  enddo loop_10023
 
  RETURN
  END

!     
!---------------------------------------------------------------------
!     
SUBROUTINE AZERO(A)
!     
!---------------------------------------------------------------------
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  DIMENSION A(1)
  COMMON/INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON/ELEMNT/ NX,NELX,N,NEQ1,NEQ2,NPLANE,NX_CELL
  loop_10: DO I=1,NEQ2
     A(I)=0.
  enddo loop_10
     RETURN
END SUBROUTINE AZERO

!     
!---------------------------------------------------------------------
!     
SUBROUTINE EXCHN(A,B,N)   
!     
!---------------------------------------------------------------------
!     
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
     
  DIMENSION A(1),B(1)
     
  loop_10: DO I=1,N
     B(I)=A(I)
  enddo loop_10
  RETURN
END SUBROUTINE EXCHN

!********************************************************************
SUBROUTINE SKYLIN(A,B,JDIAG,NEQ,KKK)
! IF KKK=1 ONLY LU-DECOMPOSITION FOR MATRIX A
! IF KKK=2 ONLU SOLVE THE SOLUTION U IN A*U=B
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
 
  DIMENSION A(1),B(1),JDIAG(1)                                      
  JR = 0                                                            
  loop_600: DO J=1,NEQ
     JD = JDIAG(J)                                                     
     JH  = JD-JR                                                       
     IS = J-JH +2                                                     
     IF (JH-2) 600,300,100
100  IF (KKK.EQ.2) GOTO 500                                            
     IE = J-1                                                          
     K = JR+2                                                          
     ID = JDIAG(IS-1)                                                  
     loop_200: DO I=is,ie
        IR =ID                                                            
        ID = JDIAG(I)                                                     
        IH = MIN0(ID-IR-1, I-IS+1)                                        
        IF (IH.GT.0) A(K) = A(K) -DOT (A(K-IH),A(ID-IH),IH)               
        K = K+1                                                          
     enddo loop_200
300  IF (KKK.EQ.2) GOTO 500                                            
     IR = JR+1                                                         
     IE = JD-1                                                         
     K = J-JD                                                          
     loop_400: DO I=ir,ie
        ID = JDIAG(K+I)                                                   
        IF (A(ID).EQ.0.) cycle loop_400
        D = A(I)                                                          
        A(I) = A(I) /A(ID)                                                
        A(JD) = A(JD)-D*A(I)                                              
     enddo loop_400
500  IF (KKK.NE.1) B(J) = B(J) -DOT(A(JR+1),B(IS-1) ,JH-1)             
600  JR = JD                                                           
  enddo loop_600
  IF (KKK.EQ.1) RETURN                                              
  loop_700: DO I=1,NEQ
     ID = JDIAG(I)                                                     
     IF (A(ID).NE.0.) B(I) = B(I)/A(ID)                                
  enddo loop_700
1100 J = NEQ                                                          
  JD = JDIAG(J)                                                    
800 D = B(J)                                                         
  J = J-1                                                          
  IF (J.LE.0) RETURN                                               
  JR = JDIAG(J)                                                    
  IF (JD-JR.LE.1) GOTO 1000                                        
  IS = J-JD+JR+2                                                   
  K = JR -IS+1                                                     
  loop_900: DO I=is,j
     B(I) = B(I) -A(I+K)*D                                            
  enddo loop_900
1000 JD = JR                                                          
  GOTO 800                                                         
END SUBROUTINE SKYLIN
                                  

!********************************************************************
FUNCTION DOT(A,B,N)                                              
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  DIMENSION A(N) ,B(N)                                             
  DOT = 0.                                                         
  loop_100: DO I=1,n
     DOT = DOT + A(I) *B(I)                                           
  enddo loop_100
  RETURN                                                           
END FUNCTION DOT

!********************************************************************
SUBROUTINE IZERO(K,N)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  DIMENSION K(1)
  loop_10051: DO I=1,N
     K(I)=0
  enddo loop_10051
  RETURN
  END
