!******************************************************
! This subroutine updates the simulation variables.
SUBROUTINE UPDATVAR (IUP1,DU,X,Y,VLOAD,VLST,NBETA,NODE,NINT,IJK,IJK1,&
     IJK2)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  !     *****************************
  !     IUP=1: updat xk; IUP=0: don't updat xk & set xk=1; IUP=2: don't updat xk
  !     ************************
  INCLUDE 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (NLM_SOFT=40000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (ALPHA=0.E0)
  PARAMETER (MAX_INT_ORDER=20)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NMAX_POLY=25,NM_PL=NMAX_POLY-1)
  PARAMETER (INTERP=200)
  DIMENSION DU(NDFM),X(1),Y(1),NBETA(1),NODE(1),NINT(NLM,2) 
  DIMENSION VLOAD(2,1),VLST(2,1),STRP(4),IDONE(NODM),IJK(NLM,1),&
       IJK1(NLM,1),IJK2(NLM,1)
  DIMENSION XN_HIST(20),XN_HIST1(20)

  INTEGER, ALLOCATABLE :: IFIND(:),LDONE(:),inv(:),INPTUP(:)
  DOUBLE PRECISION, ALLOCATABLE :: XK_NLOC1(:),XK_NLOC_S1(:),WTOTLS(:)&
       ,SC(:),WTOTL(:),TMPI1_UP(:),dlv(:)
  COMMON /DAMELEM/ XDAMG(NLM),YDAMG(NLM),ORDAMG(NLM),IDAMG(NLM)
  COMMON /GAUQUAD/ W(1275),BP(1275),INTBEG(50)
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),&
       INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /SOFTSTR/ S_STMAT(NLM_SOFT*9*4),S_STMATST(NLM_SOFT*9*4)
  COMMON /SOFTSTN/ S_STNMAT(NLM_SOFT*9*4),S_STNMATST(NLM_SOFT*9*4)
  COMMON /PLPMATS/ VMMAT_S(NLM_SOFT*9),EPLSMAT_S(NLM_SOFT*9)&
       ,DEPLSMAT_S(NLM_SOFT*9),NPLMAT_S(NLM_SOFT*9)
  COMMON /VOIDDATAS/ FVOID_S(NLM_SOFT*9),DFVOID_S(NLM_SOFT*9)
  COMMON /PROP/ YM,PR
  COMMON /ELEPROP/ PROMAT(16,10),MPE(NLM),MPG(NLM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /PLLC/ NPLCM(NLM*INTM),NPLCC(NLM*INTC)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON/BOUNDA/NBOUD1,NBOUD2,NBOUD3,NUPNCH
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /EPSCOM/ STNCOM(NLM*INTC*4),STNCOMST(NLM*INTC*4)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /PLPCOM/ VMCOM(NLM*INTC),EPLSCOM(NLM*INTC)&
       ,DEPLSCOM(NLM*INTC),NPLCOM(NLM*INTC)
  COMMON /MATLOC/ VM_LOC(NLM*INTM),EPLS_LOC(NLM*INTM),&
       FVOID_LOC(NLM*INTM),IMATLC(NLM*INTM),IFAIL(NLM*INTM)
  COMMON /LOCALTILL/ STRST(INTM*4),STNST(INTM*4),DEPLS(INTM*4)&
       ,DFV(INTM*4),VM_L(INTM),EHYD(NLM*INTM),&
       DEHY(NLM*INTM),STMAT_LC(NLM*INTM),STNMAT_LC(NLM*INTM),&
       EPLSMAT_LC(NLM*INTM),FVOID_LC(NLM*INTM),ILCTYP(NLM*INTM)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /BETAGL/ BETTOT(MAXH*NLM),BETST(MAXH*NLM),&
       BETLC(MAXH*NLM)
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /UNROTATEDDISP/ DUTEMP(NDFM)
  COMMON /TOTDIS/ DISTOT(NDFM)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /INSTT/ NPLINM(NLM*INTM),NPLINC(NLM*INTC)
  common /plastflags/ nplinm_s(nlm_soft*9)
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /VOIDDATA/ FVOID(INTM*NLM),DFVOID(INTM*NLM)
  COMMON /CONSTMT1/ NPTS(10),STSN(10,100,2)
  COMMON /LOCALIZE/ ILOCAL_LC(INTM),ILOCAL(INTM)
  COMMON /ADAPTATIONS/ ANGLE_ADAPT_X(NLM,200,2),ANGLE_ADAPT_Y&
       (NLM,200,2),NX_ADAPT_NX(NODM),NX_NX_ADAPT(NODM),NUM_ADAPT_X&
       (NLM,200),NUM_ADAPT_Y(NLM,200),IJK_ADAPT_X(NLM,200,2),&
       IJK_ADAPT_Y(NLM,200,2),nx_adapt
  COMMON /ADAPTOPTML/ IDIR_OPTIMIZE(NLM,200),ANGLE_OPTIMIZE(NLM,200),&
       TRAC_NORM(NLM,200,2),TRAC_FRAC_CELL_ADPX(NLM,200,2),&
       TRAC_FRAC_CELL_ADPY(NLM,200,2)
  COMMON /ADAPTCONNECT/ NUM_TEMP(NLM),NODE_TEMP(NLM,NDELM),&
       ANG_TEMP(NLM,NDELM)
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /LAGRPOLY/ PRD((NMAX_POLY*(NMAX_POLY+1))/2),&
       IPRD(NM_PL)
  COMMON /HPADAPTINC/ COORD_HP_INC(NLM*NSDMAX*3),INT_HP_INC&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_INC(NSMAX)
  COMMON /ELASFLAG/ IELASTIC
  COMMON /NLOCPRM/ XLCHAR,XP,XQ,XK_NLOC(NLM*INTM)
  COMMON /SCALPRM/ XCENT(NLM),YCENT(NLM),SCALE(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /SCALPRMC/ XCENTPP(NLM),YCENTPP(NLM),SCALEPP(NLM)
  COMMON /VOIDPARAM/ Q1,Q2,Q3,FCOL,FMAX,FMAX_MODEL 
  COMMON /VOIDFAILURE/  VFRT
  COMMON /NONLOCALEVAL/ NUMEL_NLOC(NLM),NUMELC_NLOC(80,NLM)
  COMMON /STEPNUM/ IST
  COMMON /SOFTTANG/ STRST1(INTM*4),STRST2(INTM*4),STNST1(INTM*4),&
       STNST2(INTM*4),STNST3(INTM*4)
  COMMON /INIVOID/ FVOID_IN(NLM*INTM)
  COMMON /INIVOIDSOFT/ FVOID_INS(NLM_SOFT*9)
  COMMON /INTBEGNSOFT/ NPBG_SOFT(NLM_SOFT),NINTM_SOFT(NLM_SOFT)
  COMMON /IPTTYS/ XIPT_SOFT(NLM_SOFT*9),YIPT_SOFT(NLM_SOFT*9)&
       ,GJAC_SOFT(NLM_SOFT*9)
  COMMON /NLOCPRMS/ XK_NLOC_S(NLM_SOFT*9)
  COMMON /NELSID/ NELS_IN_NEL(NLM_SOFT)
  COMMON /DISPNEL/ NELDISP_IN_NEL(NLM), NO_NELDISP(NLM_SOFT,NLM)
  COMMON /BOUNDMAXMIN/ PX1,PX2,PY1,PY2
  COMMON /BETACONST/ IBET_TOT(NLM),IBET_CON(NBM,NLM)
  COMMON /SOFTPOINTER/ INEW_SOFT,ISOFT_TOT,IEL_SOFT(NLM)
  COMMON /POSTDATE/ DFVOID_SP(NLM_SOFT*9),DFVOID_P(INTM*NLM)
  common /IPTFAILDAT/ IPT_FAIL(NLM_SOFT*9),VM_FAILIPT(NLM_SOFT*9),EPL_FAILIPT(NLM_SOFT*9)
  COMMON /VVFGRAD/ VVFG(NLM*INTM),VVFG_S(NLM_SOFT*9)
  COMMON /ADPTMESH/ NELS_ADP,IADPT_MESH_NEL(NLM_SOFT), NELS_SUB(NLM_SOFT,4)
  COMMON /DISPSHIFT/ ISOFTEL(NLM)
  COMMON /MPITIME1/ TMPI_UP(NLM),NELALLOC_UP(100,2)
  COMMON /STEPCONTROL/ DF_MAX,DF_CRT,ALPH_NOW,DFMAX_STEP(3)
  COMMON /SOFTFAIL/ NUM_FAILS(NLM)
  COMMON /XKPARM/ DNEAR,DPTPDIST
  COMMON /XKPARMUP/ IUPXK,IDAMGXK(NLM),ISOFTXK(NLM),NEL_SOFT_OLD
  COMMON /NEIGHNEL/ NUM_NEIGH(NLM),NEL_NEIGH(NLM,20)
  COMMON /IRELOAD/ IREADALL

  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NUMMPI,IERR)

  DF_MIN=0.D0

  ALLOCATE(IFIND(INTM),LDONE(NODM*2),INPTUP(INTERP))
  IFIND=0
  LDONE=0
  INPTUP=0
  NLM_SOFT1=(NEL_SOFT+NELS_ADP)
  ALLOCATE(XK_NLOC1(NELX*INTM),XK_NLOC_S1(NLM_SOFT1*9),WTOTLS(NLM_SOFT1*9)&
       ,SC(MAX(INTM,INTC)*9),WTOTL(NELX*INTM),TMPI1_UP(NLM))
  XK_NLOC1=0.D0
  XK_NLOC_S1=0.D0
  WTOTLS=0.D0
  SC=0.D0
  WTOTL=0.D0
  TMPI1_UP=0.D0
  NUMTP=0
  NUMMIN=10000
  NUMMAX=0

  FV_Crit=(VFRT*FMAX_MODEL-FCOL)*(FMAX-FCOL)&
       /(FMAX_MODEL-FCOL)+FCOL
  IF(MYMPI.EQ.0) THEN
     write(*,*) "UPDATTING VARIABLES ......"
     call walltime(STSECT,STMSECT)
  ENDIF
  FACT_COL=(FMAX_MODEL-FCOL)/(FMAX-FCOL)
  IF (IELASTIC.NE.0) GOTO 111
  IF (IVPL.EQ.4) THEN
     loop_10005: DO NEL=1,NELX
        loop_10006: DO I=1,NINTM(NEL)
           IPT=NPBG(NEL)+I
           IF (IMATLC(IPT).EQ.2.AND.GJACOB(IPT).GT.1.D-10) THEN
              IMATLC(IPT)=0
              WRITE (*,*) 'SOFTENED INT. POINT IN VCFEM'
           ELSEIF (IMATLC(IPT).EQ.2) THEN
              IFIND(I)=0
              IMATLC(IPT)=0
           ELSE
              IFIND(I)=0
           ENDIF
        enddo loop_10006
     enddo loop_10005
  ENDIF
  IUP=IUP1
  IF(IVPL.NE.int(4)) IUP=0
  IF(PROMAT(7,1).LT.1.E-5) IUP=0
  if(IUP.EQ.0) THEN
     loop_10008: DO NEL=1,NELX
        loop_10009: DO I=1,NINTM(NEL)
           IPT=NPBG(NEL)+I
           XK_NLOC(IPT)=1.D0
        enddo loop_10009
     enddo loop_10008
  ENDIF
  NUM_FAILS=0
  loop_10054: DO I=1,NX
     IDONE(I)=0
  enddo loop_10054
  CONV_DEG_RAD=DATAN(1.D0)/4.5D1            
  loop_10055: DO I=1,NEQ2
     LDONE(I)=0
  enddo loop_10055
  loop_10056: DO NEL=1,NELX
     NEL_BEG=(NEL-1)*(3*NSDMAX+2)
     loop_10057: DO J=1,INT_HP_INC(NEL_BEG+1)
        DU(INT_HP_INC(NEL_BEG+J*3))=DUTEMP(INT_HP_INC(NEL_BEG+J*3))
     enddo loop_10057
     loop_10058: DO J=1,NINT(NEL,2)
        ND=IJK2(NEL,J)
        ND1=NDGLB(ND*2-1)
        ND2=NDGLB(ND*2)
        DU(ND1)=DUTEMP(ND1)
        DU(ND2)=DUTEMP(ND2)
     enddo loop_10058
  enddo loop_10056

  loop_10059: DO ND=1,NX
     ND1=(ND-1)*2+1
     ND2=ND*2
     NDF1=NDGLB(ND1)
     NDF2=NDGLB(ND2)
     IF (LDONE(ND1).EQ.0) THEN
        LDONE(ND1)=1
        DISTOT(ND1)=DISTOT(ND1)+DU(NDF1)
     endif
     IF (LDONE(ND2).EQ.0) THEN
        LDONE(ND2)=1
        DISTOT(ND2)=DISTOT(ND2)+DU(NDF2)
     ENDIF
  enddo loop_10059
111 CONTINUE
  loop_1: DO I=1,NELX
     MP=MPE(I)
     IND=NDIV(I)
     loop_2: DO J=1,NINTM(I)
        loop_3: DO K=1,3
           STMAT((NPBG(I)+J-1)*4+K)=STMAT((NPBG(I)+J-1)*4+K)+STMATST&
                ((NPBG(I)+J-1)*4+K)
           STNMAT((NPBG(I)+J-1)*4+K)=STNMAT((NPBG(I)+J-1)*4+K)+&
                STNMATST((NPBG(I)+J-1)*4+K)
           STMATST((NPBG(I)+J-1)*4+K)=0.E0
           STNMATST((NPBG(I)+J-1)*4+K)=0.E0
        enddo loop_3
        IF(GJACOB(NPBG(I)+J).EQ.0) THEN
           STMATST((NPBG(I)+J)*4)=0.D0
           STNMATST((NPBG(I)+J)*4)=0.E0
        ENDIF
        EPLSMAT(NPBG(I)+J)=EPLSMAT(NPBG(I)+J)+DEPLSMAT(NPBG(I)+J)
        STMAT((NPBG(I)+J)*4)=STMAT((NPBG(I)+J)*4)+STMATST((NPBG(I)+J)*4)
        STNMAT((NPBG(I)+J)*4)=STNMAT((NPBG(I)+J)*4)+STNMATST&
             ((NPBG(I)+J)*4)

        STMATST((NPBG(I)+J)*4)=0.E0
        STNMATST((NPBG(I)+J)*4)=0.E0
        HYP=STMAT((NPBG(I)+J)*4)/3.E0
        loop_7: DO K=1,2
           HYP=HYP+STMAT((NPBG(I)+J-1)*4+K)/3.E0
        enddo loop_7
        loop_8: DO K=1,3
           STRP(K)=STMAT((NPBG(I)+J-1)*4+K)-HYP*DFLOAT(1-(K-1)/2)
        enddo loop_8
        STRP(4)=STMAT((NPBG(I)+J)*4)-HYP
        VM=1.5E0*(STRP(1)*STRP(1)+STRP(2)*STRP(2)+2.*&
             STRP(3)*STRP(3)+STRP(4)*STRP(4)) 
        VM=DSQRT(VM)
        IF (I.EQ.1.AND.J.EQ.3) THEN
           EP=EPLSMAT(NPBG(I)+J)
           loop_10060: DO K=1,NPTS(MP)-1
              IF (EP.GT.STSN(MP,K,2).AND.EP.LE.STSN(MP,K+1,2)) THEN
                 SLP=(STSN(MP,K+1,1)-STSN(MP,K,1))/&
                      (STSN(MP,K+1,2)-STSN(MP,K,2))
                 VMM=STSN(MP,K,1)+(EP-STSN(MP,K,2))*SLP
              ELSEIF (K.EQ.NPTS(MP)-1.AND.EP.GT.STSN(MP,K+1,2)) THEN
                 SLP=(STSN(MP,K+1,1)-STSN(MP,K,1))/&
                      (STSN(MP,K+1,2)-STSN(MP,K,2))
                 VMM=STSN(MP,K,1)+(EP-STSN(MP,K,2))*SLP
              ENDIF
           enddo loop_10060
        ENDIF
        IF (NPLCM(NPBG(I)+J).EQ.1) THEN
           IF (IVPL.NE.1) THEN
              VMMAT(NPBG(I)+J)=VM
           ENDIF
           NPLMAT(NPBG(I)+J)=1
           EP=EPLSMAT(NPBG(I)+J)
           loop_10061: DO K=1,NPTS(MP)-1
              IF (EP.GT.STSN(MP,K,2).AND.EP.LE.STSN(MP,K+1,2)) THEN
                 SLP=(STSN(MP,K+1,1)-STSN(MP,K,1))/&
                      (STSN(MP,K+1,2)-STSN(MP,K,2))
                 VMM=STSN(MP,K,1)+(EP-STSN(MP,K,2))*SLP
              ELSEIF (K.EQ.NPTS(MP)-1.AND.EP.GT.STSN(MP,K+1,2)) THEN
                 SLP=(STSN(MP,K+1,1)-STSN(MP,K,1))/&
                      (STSN(MP,K+1,2)-STSN(MP,K,2))
                 VMM=STSN(MP,K,1)+(EP-STSN(MP,K,2))*SLP
              ENDIF
           enddo loop_10061
        ELSE
           NPLMAT(NPBG(I)+J)=0
        ENDIF
        IPT=NPBG(I)+J
        JPT=(IPT-1)*4
        MPT=(J-1)*4
        ILOCAL(J)=0
        IF (IVPL.EQ.4) THEN
           IF (IMATLC(IPT).LT.2) THEN
              hu_f1=FVOID(NPBG(I)+J)
              DFVOID_P(NPBG(I)+J)=DFVOID(NPBG(I)+J)
              DFVOID(NPBG(I)+J)=0.D0
           ELSE
              STMATST(JPT+1)=0.D0
              STMATST(JPT+2)=0.D0
              STMATST(JPT+3)=0.D0
              STMATST(JPT+4)=0.D0             
              STNMAT_LC(JPT+1)=0.D0
              STNMAT_LC(JPT+2)=0.D0
              STNMAT_LC(JPT+3)=0.D0
              STNMAT_LC(JPT+4)=0.D0
              DFV(J)=0.D0
              DEPLS(J)=0.D0
              hu_f1=FVOID(IPT)
              DFVOID_P(IPT)=DFVOID(IPT)
              DFVOID(IPT)=0.D0
              IF (DEPLSMAT(IPT).GT.0.D0) THEN
              ELSE
                 WRITE (*,*) 'IMPOSSIBLE DEPLS'
              ENDIF
           ENDIF
           EP=EPLSMAT(IPT)
           KPT=2
           KPT_FIND=0
           loop_10062: DO WHILE (KPT.LE.NPTS(MP).AND.KPT_FIND.NE.1) 
              IF (STSN(MP,KPT,2).GT.EP) THEN
                 KPT_FIND=1
                 SLPP=(STSN(MP,KPT,1)-STSN(MP,KPT-1,1))/&
                      (STSN(MP,KPT,2)-STSN(MP,KPT-1,2))
                 VM0=STSN(MP,KPT-1,1)+(EP-STSN(MP,KPT-1,2))*&
                      SLPP
              ELSEIF (KPT.EQ.NPTS(MP)) THEN
                 KPT_FIND=1
                 SLPP=(STSN(MP,KPT,1)-STSN(MP,KPT-1,1))/&
                      (STSN(MP,KPT,2)-STSN(MP,KPT-1,2))
                 VM0=STSN(MP,KPT-1,1)+(EP-STSN(MP,KPT-1,2))*&
                      SLPP                           
              ENDIF
              KPT=KPT+1
           enddo loop_10062
           VMMAT(IPT)=VM0
           IF (IVPL.EQ.4.AND.NPLMAT(IPT).EQ.1.AND.IMATLC(IPT).EQ.0) THEN
              HYD=STMAT(JPT+1)+STMAT(JPT+2)+STMAT(JPT+4)
              SXX=STMAT(JPT+1)-HYD/3.D0
              SYY=STMAT(JPT+2)-HYD/3.D0
              SZZ=STMAT(JPT+4)-HYD/3.D0
              SXY=STMAT(JPT+3)
              VMM=DSQRT(1.5D0*(SXX*SXX+SYY*SYY+SZZ*SZZ+2.D0*SXY*SXY))
              F=FVOID(IPT)
              if(F.GT.FMAX) THEN
                 F=FMAX
              ENDIF
              IF (IMATLC(IPT).EQ.1) THEN
                 IF (F.GT.0.D0) THEN
                    FACT=(FMAX_MODEL-FVOID_LOC(IPT))/(FMAX-&
                         FVOID_LOC(IPT))
                    F=FVOID_LOC(IPT)+(F-FVOID_LOC(IPT))*FACT
                 ENDIF
              ELSEIF (F.GT.FCOL) THEN
                 F=FCOL+(F-FCOL)*FACT_COL
              ENDIF
              IF(F.GT.VFRT*FMAX_MODEL) THEN
                 F=VFRT*FMAX_MODEL
              ENDIF
              P=HYD*Q2/VM0
              IF (DABS(P).LT.5.5D0) THEN
                 DSNHP=DSINH(P)
                 DCSHP=DCOSH(P) 
                 DCSHP1=DCOSH(P) 
              ELSE
                 DSNHP=DSINH(5.5D0)*DABS(P)/P+&
                      DCOSH(5.5D0)*(DABS(P)-5.5D0)*&
                      DABS(P)/P
                 DCSHP=DCOSH(5.5D0)+DSINH(5.5D0)*&
                      (DABS(P)-5.5D0)*DABS(P)/P+&
                      DCOSH(5.5D0)*(DABS(P)-5.5D0)**2/2.D0
                 DCSHP1=DCOSH(5.5D0)
              ENDIF
              HYD_YLD=Q1*F*DCSHP*VM0*VM0
              EPL_YLD=VM0*VM0*(1.D0+F*F*Q3)
              DEV_YLD=VMM*VMM
              RES=DEV_YLD+HYD_YLD-EPL_YLD
              IF (MYMPI.EQ.10000.AND.RES.GT.1.D-02*EPL_YLD) THEN
                 WRITE (*,*) 'IMPOSSIBLE YIELD SURF'
                 WRITE (*,*) 'NEL= ', I
                 WRITE (*,*) 'RES= ',RES
                 WRITE (*,*) 'EPL_YLD= ',EPL_YLD
                 WRITE (*,*) 'F= ', FVOID(IPT) ,' EP= ', EP
              ENDIF
           ENDIF
        ENDIF
        DEPLSMAT(NPBG(I)+J)=0.E0
     enddo loop_2
     IF (IVPL.EQ.4) THEN         
        NITT=2
        NIT=2
        MP=MPE(I)
        NINPT=NINTM(I)
        loop_10063: DO J=1,NINPT
           IPT=NPBG(I)+J
           IF (IMATLC(IPT).EQ.2) THEN
              STNMAT_LC(IPT*4-3)=-STNMATST(IPT*4-3)
              STNMATST(IPT*4-3)=0.D0
              STNMAT_LC(IPT*4-2)=-STNMATST(IPT*4-2)
              STNMATST(IPT*4-2)=0.D0
              STNMAT_LC(IPT*4-1)=-STNMATST(IPT*4-1)
              STNMATST(IPT*4-1)=0.D0
           ENDIF
        enddo loop_10063
     ENDIF
     loop_4: DO J=1,NINTC(I)
        vrate=STCOMST((NPBM(I)+J)*4)/(STCOMST((NPBM(I)+J-1)*4+1)+STCOMST((NPBM(I)+J-1)*4+2))
        loop_5: DO K=1,3
           STCOM((NPBM(I)+J-1)*4+K)=STCOM((NPBM(I)+J-1)*4+K)+&
                STCOMST((NPBM(I)+J-1)*4+K)
           STNCOM((NPBM(I)+J-1)*4+K)=STNCOM((NPBM(I)+J-1)*4+K)+&
                STNCOMST((NPBM(I)+J-1)*4+K)
           STCOMST((NPBM(I)+J-1)*4+K)=0.E0
           STNCOMST((NPBM(I)+J-1)*4+K)=0.E0             
        enddo loop_5
        STCOM((NPBM(I)+J)*4)=STCOM((NPBM(I)+J)*4)+STCOMST&
             ((NPBM(I)+J)*4)
        STNCOM((NPBM(I)+J)*4)=STNCOM((NPBM(I)+J)*4)+STNCOMST&
             ((NPBM(I)+J)*4)
        EPLSCOM(NPBM(I)+J)=EPLSCOM(NPBM(I)+J)+DEPLSCOM(NPBM(I)+J)
        vrate=STCOM((NPBM(I)+J)*4)/(STCOM((NPBM(I)+J-1)*4+1)+STCOM((NPBM(I)+J-1)*4+2))
        STCOMST((NPBM(I)+J)*4)=0.E0
        STNCOMST((NPBM(I)+J)*4)=0.E0
        IF (NPLCOM(NPBM(I)+J).EQ.1) THEN
           HYP=STCOM((NPBM(I)+J)*4)/3.E0
           loop_9: DO K=1,2
              HYP=HYP+STCOM((NPBM(I)+J-1)*4+K)/3.E0
           enddo loop_9
           loop_10: DO K=1,3
              STRP(K)=STCOM((NPBM(I)+J-1)*4+K)-HYP*DFLOAT(1-(K-1)/2)
           enddo loop_10
           STRP(4)=STCOM((NPBM(I)+J)*4)-HYP
           VM=1.5E0*(STRP(1)*STRP(1)+STRP(2)*STRP(2)+2.*&
                STRP(3)*STRP(3)+STRP(4)*STRP(4)) 
           VMCOM(NPBM(I)+J)=SQRT(VM)
           NPLCOM(NPBM(I)+J)=1
        ENDIF
        DEPLSCOM(NPBM(I)+J)=0.E0
     enddo loop_4
     loop_10064: DO J=1,NBM
        IF(IBET_CON(J,I).EQ.1) THEN
           BETST(J+(I-1)*2*NBM)=0.D0
        ENDIF
     enddo loop_10064
     loop_6: DO J=1,NBM*2
        BETTOT(J+(I-1)*2*NBM)=BETTOT(J+(I-1)*2*NBM)+&
             BETST(J+(I-1)*2*NBM)
        BETST(J+(I-1)*2*NBM)=0.E0
     enddo loop_6
  enddo loop_1
  loop_13: DO I=1,NBOUD2
     loop_10065: DO J=1,2
        VLOAD(J,I)=VLOAD(J,I)+VLST(J,I)
     enddo loop_10065
  enddo loop_13
  IF(MYMPI.EQ.0) THEN
     call walltime(ENDSECT,ENDMSECT)
     TOT_time=(ENDSECT-STSECT)+(ENDMSECT-STMSECT)*1.D-06
     TOT_time=TOT_time/60.D0
     write(*,*) "FINISHED UPDATTING",NUMMIN,NUMMAX
     write(*,*) "Time taken: ",TOT_time," mins."
  ENDIF
  DU=0.D0
  DUTEMP=0.D0

  DEALLOCATE(IFIND,LDONE,INPTUP)
  DEALLOCATE(XK_NLOC1,XK_NLOC_S1,WTOTLS,SC,WTOTL)
  RETURN
END SUBROUTINE UPDATVAR

!******************************************************
! MACSTR calculates the macroscopic simulation varibles
! for each element
SUBROUTINE MACSTR(NBETA)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  INCLUDE 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (NLM_SOFT=40000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  DIMENSION NBETA(1),GATOT_INC(NLM)
  COMMON /STEPNUM/ IST
  COMMON /IDAMSTEP/ STRMAC_EL(10,NLM),STRCOM_EL(10,NLM),IDAM_NOW
  COMMON /DAMELEM/ XDAMG(NLM),YDAMG(NLM),ORDAMG(NLM),IDAMG(NLM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /MACRSCP/ STMAC(2,6)
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /EPSCOM/ STNCOM(NLM*INTC*4),STNCOMST(NLM*INTC*4)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /PLPCOM/ VMCOM(NLM*INTC),EPLSCOM(NLM*INTC)&
       ,DEPLSCOM(NLM*INTC),NPLCOM(NLM*INTC)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /STRAIN/ STRN(4)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /PLLC/ NPLCM(NLM*INTM),NPLCC(NLM*INTC) 
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /SCALPRM/ XCENT(NLM),YCENT(NLM),SCALE(NLM)
  COMMON /VOIDDATA/ FVOID(INTM*NLM),DFVOID(INTM*NLM)
  COMMON /SOFTSTR/ S_STMAT(NLM_SOFT*9*4),S_STMATST(NLM_SOFT*9*4)
  COMMON /SOFTSTN/ S_STNMAT(NLM_SOFT*9*4),S_STNMATST(NLM_SOFT*9*4)
  COMMON /IPTTYS/ XIPT_SOFT(NLM_SOFT*9),YIPT_SOFT(NLM_SOFT*9)&
       ,GJAC_SOFT(NLM_SOFT*9)
  COMMON /INTBEGNSOFT/ NPBG_SOFT(NLM_SOFT),NINTM_SOFT(NLM_SOFT)
  COMMON /PLPMATS/ VMMAT_S(NLM_SOFT*9),EPLSMAT_S(NLM_SOFT*9)&
       ,DEPLSMAT_S(NLM_SOFT*9),NPLMAT_S(NLM_SOFT*9)
  COMMON /VOIDDATAS/ FVOID_S(NLM_SOFT*9),DFVOID_S(NLM_SOFT*9)
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),&
       INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /ZOOMINGJ/  GJACOB_ZOOM,GJ_VCF(NLM),GJ_SOFT(NLM)
  COMMON /ADPTMESH/ NELS_ADP,IADPT_MESH_NEL(NLM_SOFT), NELS_SUB(NLM_SOFT,4)

  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NUMMPI,IERR)
  IF(MYMPI.EQ.0) THEN
     IF(IST.EQ.1) THEN
        OPEN (571,FILE='vcf.rspn')
     ELSE
        OPEN (571,FILE='vcf.rspn',POSITION='APPEND')
     ENDIF
  ENDIF
  loop_1: DO I=1,2
     loop_2: DO J=1,4
        STMAC(I,J)=0.E0
     enddo loop_2
  enddo loop_1
  GATOT_INC=0.D0
  AREA=0.E0
  AREA_M=0.D0
  AREA_SOFT=0.D0
  SEPL=0.E0
  FV=0.E0
  FTOT=0.D0
  EPHYD=0.D0
  FV_MAX=0.D0
  IF (IDAM_NOW.EQ.1) THEN
     OPEN (573,FILE='damage_in.prog')         
     WRITE (573,*) 'BEFORE REDISCRETIZING IN STEP:',IST
     loop_10076: DO I=1,NELX
        WRITE (573,74) 'FOR NEL:',I,' MAC. INT. VARIABLES ARE:',&
             (STRMAC_EL(J,I),J=1,4)
74      FORMAT (A8,I2,A25,4(E12.6,1X))
     enddo loop_10076
     loop_10077: DO I=1,NELX
        WRITE (573,74) 'FOR NEL:',I,' MAC. INT. VARIABLES ARE:',&
             (STRCOM_EL(J,I),J=1,4)
     enddo loop_10077
  ENDIF
  loop_3: DO I=1,NELX
     STRMAC_EL(1,I)=0.D0
     STRMAC_EL(2,I)=0.D0
     STRMAC_EL(3,I)=0.D0
     STRMAC_EL(4,I)=0.D0
     STRCOM_EL(1,I)=0.D0
     STRCOM_EL(2,I)=0.D0
     STRCOM_EL(3,I)=0.D0
     STRCOM_EL(4,I)=0.D0
     loop_4: DO K=1,3
        loop_5: DO J=1,NINTM(I)
           STMAC(1,K)=STMAC(1,K)+STMAT((NPBG(I)+J-1)*4+K)*GJACOB&
                (NPBG(I)+J)
           STMAC(2,K)=STMAC(2,K)+STNMAT((NPBG(I)+J-1)*4+K)*GJACOB&
                (NPBG(I)+J)
           STRMAC_EL(K+1,I)=STRMAC_EL(K+1,I)+STMAT((NPBG(I)+J-1)&
                *4+K)*GJACOB(NPBG(I)+J)
           IF (K.EQ.1) THEN
              AREA=AREA+GJACOB(NPBG(I)+J)
              AREA_M=AREA_M+GJACOB(NPBG(I)+J)
              STMAC(1,4)=STMAC(1,4)+STMAT((NPBG(I)+J)*4)*&
                   GJACOB(NPBG(I)+J) 
              STMAC(2,4)=STMAC(2,4)+STNMAT((NPBG(I)+J)*4)*&
                   GJACOB(NPBG(I)+J)
              SEPL=SEPL+EPLSMAT(NPBG(I)+J)*GJACOB(NPBG(I)+J)
              FV=FV+FVOID(NPBG(I)+J)*GJACOB(NPBG(I)+J)
              IF(FVOID(NPBG(I)+J).GT.FV_MAX) FV_MAX=FVOID(NPBG(I)+J)
              STRMAC_EL(1,I)=STRMAC_EL(1,I)+EPLSMAT(NPBG(I)+J)*&
                   GJACOB(NPBG(I)+J)
           ENDIF
        enddo loop_5
        loop_6: DO J=1,NINTC(I)
           IF (K.EQ.1) STMAC(1,4)=STMAC(1,4)+STCOM((NPBM(I)+J)*4)*&
                GJACOM(NPBM(I)+J)
           IF (K.EQ.1) AREA=AREA+GJACOM(NPBM(I)+J)
           IF (K.EQ.1) GATOT_INC(I)=GATOT_INC(I)+GJACOM(NPBM(I)+J)
           IF (K.EQ.1) STMAC(2,4)=STMAC(2,4)+STNCOM((NPBM(I)+J)*4)*&
                GJACOM(NPBM(I)+J)
           IF (K.EQ.1) SEPL=SEPL+EPLSCOM(NPBM(I)+J)*GJACOM(NPBM(I)+J)
           IF (K.EQ.1) THEN
              STRCOM_EL(1,I)=STRCOM_EL(1,I)+EPLSCOM(NPBM(I)+J)*&
                   GJACOM(NPBM(I)+J)
           ENDIF
           STMAC(1,K)=STMAC(1,K)+STCOM((NPBM(I)+J-1)*4+K)*GJACOM&
                (NPBM(I)+J)
           STMAC(2,K)=STMAC(2,K)+STNCOM((NPBM(I)+J-1)*4+K)*GJACOM&
                (NPBM(I)+J)
           STRCOM_EL(K+1,I)=STRCOM_EL(K+1,I)+STCOM((NPBM(I)+J-1)&
                *4+K)*GJACOM(NPBM(I)+J)
        enddo loop_6
     enddo loop_4
     DO K=1,4
        STRCOM_EL(K,I)=STRCOM_EL(K,I)/GATOT_INC(I)
     ENDDO
  enddo loop_3
  IF (IDAM_NOW.EQ.1) THEN
     WRITE (573,*) 'AFTER REDISCRETIZING IN STEP:',IST
     loop_10078: DO I=1,NELX
        WRITE (573,74) 'FOR NEL:',I,' MAC. INT. VARIABLES ARE:',&
             (STRMAC_EL(J,I),J=1,4)
     enddo loop_10078
     loop_10079: DO I=1,NELX
        WRITE (573,74) 'FOR NEL:',I,' MAC. INT. VARIABLES ARE:',&
             (STRCOM_EL(J,I),J=1,4)
     enddo loop_10079
     REWIND (573)
     CLOSE (573)
  ENDIF
  loop_7: DO J=1,2
     loop_8: DO I=1,4
        STMAC(J,I)=STMAC(J,I)/AREA
     enddo loop_8
  enddo loop_7
  IF(STMAC(1,1).NE.STMAC(1,1)) THEN
     IDEBUG=0
     write(*,*) "Pause in macstr"
     loop_10083: DO WHILE(IDEBUG.EQ.1) 
        IDEBUG=1
     enddo loop_10083
  ENDIF
  SEPL=SEPL/AREA_M
  FV=FV/AREA_M
  FTOT=FTOT/AREA
  EPHYD=EPHYD/AREA
  STMAC(1,5)=STMAC(1,1)+STMAC(1,2)
  HYD=STMAC(1,5)+STMAC(1,4)
  STMAC(1,6)=STMAC(1,1)*STMAC(1,1)+STMAC(1,2)*STMAC(1,2)+2.E0*&
       STMAC(1,3)*STMAC(1,3)+STMAC(1,4)*STMAC(1,4)-HYD*HYD/3.E0
  STMAC(1,6)=DSQRT(STMAC(1,6)*1.5D0)
  IF(MYMPI.EQ.0) THEN
     WRITE (*,10) SEPL,(STMAC(1,J),J=1,4),FV,FV_MAX
     WRITE (57,101) IST,SEPL,(STMAC(1,J),J=1,4),FV,FV_MAX
101  FORMAT (I4,7(2X,E12.6))
     WRITE (571,10) SEPL,(STMAC(1,J),J=1,4),FV,FV_MAX
     WRITE (571,*) "GJACOB_ZOOM = ",GJACOB_ZOOM,"  AREA_SOFT = ", AREA_SOFT
     REWIND (571)
     CLOSE (571)
10   FORMAT (7(2X,E12.6))
11   FORMAT (3(E12.6,2X))
  ENDIF
  RETURN
END SUBROUTINE MACSTR

!******************************************************
! This subroutine outputs the equivalent stress-strain curve
SUBROUTINE OUT_EQV(STMAC,ILOAD_ST,VBC_TOT)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  INCLUDE 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  DIMENSION STMAC(2,6)
  COMMON /BOUNDMAXMIN/ PX1,PX2,PY1,PY2
  COMMON /POSTVBC/  IBCXY
  COMMON /IDAMSTEP/ STRMAC_EL(10,NLM),STRCOM_EL(10,NLM),IDAM_NOW
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /MACDROP/ EQV_S,EQV_E,EQVMAC,NUMDROP,IMACDROP
  COMMON /DAMELEM/ XDAMG(NLM),YDAMG(NLM),ORDAMG(NLM),IDAMG(NLM)
  COMMON /IRELOAD/ IREADALL
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)

  EQVMAC=EQV_S

  SMEAN=(STMAC(1,1)+STMAC(1,2)+STMAC(1,4))/3.D0
  DS11=STMAC(1,1)-SMEAN
  DS22=STMAC(1,2)-SMEAN
  DS33=STMAC(1,4)-SMEAN
  DS12=STMAC(1,3)
  EMEAN=(STMAC(2,1)+STMAC(2,2)+STMAC(2,4))/3.D0
  DE11=STMAC(2,1)-EMEAN
  DE22=STMAC(2,2)-EMEAN
  DE33=STMAC(2,4)-EMEAN
  DE12=STMAC(2,3)
  EQV_S=DSQRT(1.5D0*(DS11*DS11+DS22*DS22+DS33*DS33+2.D0*DS12*DS12))
  EQV_E=DSQRT(2.D0/3.D0*(DE11*DE11+DE22*DE22+DE33*DE33+2.D0*DE12*DE12))

  IF(EQV_S.NE.EQV_S.OR.EQV_E.NE.EQV_E) THEN
     STOP
  ENDIF


  IF(EQV_S.LT.EQVMAC) THEN
     IFLAG=0
     DO I=1,NELX
        IF(IDAMG(I).EQ.1) THEN
           IFLAG=1
           EXIT
        ENDIF
     END DO
     IF(IFLAG.EQ.0) THEN
        NUMDROP=NUMDROP+1
        IF(NUMDROP.GT.3) THEN
           IMACDROP=1
        ENDIF
     ENDIF
  ENDIF

  IF(MYMPI.EQ.0) THEN
     open(175,file='MAC_STRSTN.dat')
     write(175,201) STMAC(1,1),STMAC(1,2),STMAC(1,3),STMAC(1,4),STMAC(2,1),STMAC(2,2),STMAC(2,3),STMAC(2,4)
     rewind(175)
     close(175)

201  FORMAT (8e12.3)

     open(175,file='EQV_CURVE.dat')
     IF(IBCXY.EQ.1) XYMAX=DABS(PX2-PX1)
     IF(IBCXY.EQ.2) XYMAX=DABS(PY2-PY1)
     write(175,*) 0,0,0
     write(175,*) EQV_E,EQV_S,VBC_TOT/XYMAX
     rewind(175)
     close(175)

     open(175,file='INC_MACSTR.dat')
     write(175,*) 0.D0,((STRCOM_EL(J,I),J=1,4),I=1,NELX)
     rewind(175)
     close(175)
  ENDIF
END SUBROUTINE OUT_EQV

!******************************************************
! This subroutine creates the output file required to
! generate contour plots using the Postprocessing tools.
SUBROUTINE OUTVAR_UN(IST,NODE,NINT,IJK,&
     IJK1,IJK2,X,Y)
!******************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  INCLUDE 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NLM_SOFT=40000)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  DIMENSION NODE(NLM),NINT(NLM,2),IJK(NLM,NDELM/2),IJK1(NLM,NDELM/2),&
       IJK2(NLM,NDELM/2),X(NODM),Y(NODM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /ELEPROP/ PROMAT(16,10),MPE(NLM),MPG(NLM)
  COMMON /PLNST/ KPLS
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /SCALPRM/ XCENT(NLM),YCENT(NLM),SCALE(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /SCALPRMC/ XCENTPP(NLM),YCENTPP(NLM),SCALEPP(NLM)
  COMMON /EDGEPRM/ NACTIVE(NLM),ICENT(NLM),NMUL(NLM)
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /EPSCOM/ STNCOM(NLM*INTC*4),STNCOMST(NLM*INTC*4)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /PLPCOM/ VMCOM(NLM*INTC),EPLSCOM(NLM*INTC)&
       ,DEPLSCOM(NLM*INTC),NPLCOM(NLM*INTC)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /VOIDDATA/ FVOID(INTM*NLM),DFVOID(INTM*NLM)
  COMMON /NLOCPRM/ XLCHAR,XP,XQ,XK_NLOC(NLM*INTM)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),&
       INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /SOFTSTR/ S_STMAT(NLM_SOFT*9*4),S_STMATST(NLM_SOFT*9*4)
  COMMON /SOFTSTN/ S_STNMAT(NLM_SOFT*9*4),S_STNMATST(NLM_SOFT*9*4)
  COMMON /PLPMATS/ VMMAT_S(NLM_SOFT*9),EPLSMAT_S(NLM_SOFT*9)&
       ,DEPLSMAT_S(NLM_SOFT*9),NPLMAT_S(NLM_SOFT*9)
  COMMON /VOIDDATAS/ FVOID_S(NLM_SOFT*9),DFVOID_S(NLM_SOFT*9)
  COMMON /INTBEGNSOFT/ NPBG_SOFT(NLM_SOFT),NINTM_SOFT(NLM_SOFT)
  COMMON /IPTTYS/ XIPT_SOFT(NLM_SOFT*9),YIPT_SOFT(NLM_SOFT*9)&
       ,GJAC_SOFT(NLM_SOFT*9)
  COMMON /NLOCPRMS/ XK_NLOC_S(NLM_SOFT*9)
  COMMON /ELEMENTSADDED/ NINTS_now,NELADD,NEWNELS(NLM_SOFT)
  COMMON /POSTDATE/ DFVOID_SP(NLM_SOFT*9),DFVOID_P(INTM*NLM)
  COMMON /VVFGRAD/ VVFG(NLM*INTM),VVFG_S(NLM_SOFT*9)
  COMMON /ADPTMESH/ NELS_ADP,IADPT_MESH_NEL(NLM_SOFT), NELS_SUB(NLM_SOFT,4)
  COMMON /TIMESTEP/ Time_step,NTot_step
  COMMON /COORDSKIP/ FLAG_WR,NSTART,NSTART1
  COMMON /IRELOAD/ IREADALL
  COMPLEX Z10(100,NLM),W10(100,NLM),C10(NLM)
  DIMENSION BETA10(NLM,100),NUM_VERT10(NLM)
  COMPLEX Z(100),W(100),C
  DIMENSION BETA(100)
  DIMENSION  RADWLT(200)
  DIMENSION STR(3)

  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)

  IF(MYMPI.EQ.0) THEN
     IF(IST.EQ.1) THEN
        OPEN(999,file="results_un.dat",FORM="UNFORMATTED")
     ELSE
        OPEN(999,file="results_un.dat",FORM="UNFORMATTED",POSITION="APPEND")
     ENDIF
     IDO=1
     IF(IDO.EQ.1) THEN
        WRITE (999) "Total time step finished:  ", Time_step
        WRITE (999) NX,NELX
2       FORMAT (15(I4,2X))
        WRITE (999) KPLS,IVPL
        WRITE (999) (X(I),Y(I),I=1,NX)
        NSTART1=NSTART1+2+((2*NX-1)/5+1)+((NELX-1)/15+1)*3+2*NELX+&
             ((NELX-1)/15+1)+(1)+((NELX*3-1)/15+1)
3       FORMAT (5(E12.6,2X))
        WRITE (999) (NODE(I),I=1,NELX)
        WRITE (999) (NINT(I,1),I=1,NELX)
        WRITE (999) (NINT(I,2),I=1,NELX)
        loop_21: DO I=1,NELX
           WRITE (999) MCRACK(I),XSCALEM(I),YSCALEM(I),ANM(I),XCENTP(I),&
                YCENTP(I),NMUL(I)
        enddo loop_21
        loop_22: DO I=1,NELX
           WRITE (999) ICRACK(I),XSCALEI(I),YSCALEI(I),ANI(I),XCENTPP(I),&
                YCENTPP(I)
        enddo loop_22
6       FORMAT (I4,5(2X,E12.6),I4)
        WRITE (999) ((IJK(I,J),J=1,NODE(I)),I=1,NELX)
        WRITE (999) ((IJK1(I,J),J=1,NINT(I,1)),I=1,NELX)
        WRITE (999) ((IJK2(I,J),J=1,NINT(I,2)),I=1,NELX)
     ENDIF

     write(*,*) "IST= ",IST
     write(999) "IST= ",IST
     write(999) NELX
     loop_10118: DO NEL=1,NELX
        SC=SCALE(NEL)
        XCCC=XCENT(NEL)
        YCCC=YCENT(NEL)
        IF(MYMPI.EQ.0) THEN
           WRITE (999) NINTM(NEL)
           WRITE (999) (Xipt(NPBG(NEL)+J)*SC+XCCC,&
                Yipt(NPBG(NEL)+J)*SC+YCCC,J=1,NINTM(NEL))
        ENDIF
     enddo loop_10118

     loop_10119: DO NEL=1,NELX
        SC=SCALEP(NEL)
        XCCC=XCENTP(NEL)
        YCCC=YCENTP(NEL)
        IF(MYMPI.EQ.0) THEN
           WRITE (999) NINTC(NEL)
           WRITE (999) (XiptCOM(NPBM(NEL)+J)*SC+XCCC,&
                YiptCOM(NPBM(NEL)+J)*SC+YCCC,J=1,NINTC(NEL))
        ENDIF
     enddo loop_10119



     loop_10120: DO NEL=1,NELX
        loop_10121: DO IPT=1,NINTM(NEL)
           if(GJACOB(NPBG(NEL)+IPT).GT.1.E-15) THEN
              press=(STMAT((NPBG(NEL)+IPT-1)*4+1)+STMAT((NPBG(NEL)+IPT-1)*4+2)&
                   +STMAT((NPBG(NEL)+IPT-1)*4+4))/3.D0
              WRITE(999) STMAT((NPBG(NEL)+IPT-1)*4+1),&
                   STMAT((NPBG(NEL)+IPT-1)*4+2),&
                   STMAT((NPBG(NEL)+IPT-1)*4+3),&
                   STMAT((NPBG(NEL)+IPT-1)*4+4),&
                   STNMAT((NPBG(NEL)+IPT-1)*4+1),&
                   FVOID(NPBG(NEL)+IPT),&
                   EPLSMAT(NPBG(NEL)+IPT),&
                   XK_NLOC(NPBG(NEL)+IPT)
           ELSE
              WRITE(999) 0.D0,0.D0,0.D0,0.D0,0.D0,0.D0,0.D0,0.D0
           ENDIF

        enddo loop_10121
     enddo loop_10120

     loop_10122: DO NEL=1,NELX
        loop_10123: DO IPT=1,NINTC(NEL)
           NPT1=(NPBM(NEL)+IPT-1)*4
           STR(1)=STCOM(NPT1+1)+STCOMST(NPT1+1)
           STR(2)=STCOM(NPT1+2)+STCOMST(NPT1+2)
           STR(3)=STCOM(NPT1+3)+STCOMST(NPT1+3)
           SADD=STR(1)+STR(2)
           SSUB=STR(1)-STR(2)
           SSQR=SSUB*SSUB+4.E0*STR(3)*STR(3)
           SSQR=DSQRT(SSQR)
           SPR1=(SADD+SSQR)*0.5E0
           SPR2=(SADD-SSQR)*0.5E0
           press=(STCOM((NPBM(NEL)+IPT-1)*4+1)+STCOM((NPBM(NEL)+IPT-1)*4+2)&
                +STCOM((NPBM(NEL)+IPT-1)*4+4))/3.D0
           WRITE(999) STCOM((NPBM(NEL)+IPT-1)*4+1),&
                STCOM((NPBM(NEL)+IPT-1)*4+2),&
                STCOM((NPBM(NEL)+IPT-1)*4+3),&
                STCOM((NPBM(NEL)+IPT-1)*4+4),&
                STNCOM((NPBM(NEL)+IPT-1)*4+1)
        enddo loop_10123
     enddo loop_10122

     NEL_SOFTx=NEL_SOFT+NELS_ADP

     write(999) NEL_SOFTX-NELS_ADP/4
     loop_10124: DO NELS=1,NEL_SOFTX
        IF(IADPT_MESH_NEL(NELS).EQ.0.OR.IADPT_MESH_NEL(NELS).EQ.3) THEN
           loop_10125: DO I=1,9
              write(999) XIPT_SOFT((NELS-1)*9+I),YIPT_SOFT((NELS-1)*9+I)
           enddo loop_10125
        ENDIF
     enddo loop_10124
     loop_10126: DO NELS=1,NEL_SOFTX
        IF(IADPT_MESH_NEL(NELS).EQ.0.OR.IADPT_MESH_NEL(NELS).EQ.3) THEN
           press=(s_stmat((i-1)*4+1)+s_stmat((i-1)*4+2)&
                +s_stmat((i-1)*4+4))/3.D0
           loop_10127: DO I=npbg_soft(nels)+1,npbg_soft(nels)+nintm_soft(nels)
              write(999) s_stmat((i-1)*4+1),&
                   s_stmat((i-1)*4+2),&
                   s_stmat((i-1)*4+3),&
                   s_stmat((i-1)*4+4),&
                   s_stnmat((i-1)*4+1),&
                   fvoid_s(i),&
                   eplsmat_s(i),&
                   XK_NLOC_S(i)
           enddo loop_10127
        ENDIF
     enddo loop_10126

     write(999) 
     write(999)

     rewind(999)
     close(999)
  ENDIF
  !     ***************************
  !     Used for calculate the energy near the corners
  IDO=0
  IF(IDO.EQ.1) THEN
     SEN=0.D0
     WTTOT=0.D0
     loop_10128: DO NEL=1,NELX
        NUM_VERT=NUM_VERT10(NEL)
        loop_10129: DO I=1,NUM_VERT
           W(I)=W10(I,NEL)
        enddo loop_10129
        loop_10130: DO J=1,NUM_VERT
           RAD=1.E20
           DL=1.E+20
           loop_10131: DO J1=1,NUM_VERT
              IF(J.NE.J1) THEN
                 DL=min(DL,CDABS(W(J)-W(J1)))
              ENDIF
           enddo loop_10131
           RAD=min(0.3*DL,RAD)
           RADWLT(J)=RAD
        enddo loop_10130
        loop_10132: DO IPT=1,NINTM(NEL)
           X1=Xipt(NPBG(NEL)+IPT)*SCALE(NEL)+XCENT(NEL)
           Y1=Yipt(NPBG(NEL)+IPT)*SCALE(NEL)+YCENT(NEL)
           IFLAG=0
           loop_10133: DO J=1,NUM_VERT
              IF (CDABS(DCMPLX(X1,Y1)-W(J)) .LE. &
                   0.55*RADWLT(J)) THEN
                 IFLAG=1
                 EXIT
              ENDIF
           enddo loop_10133
           IF(IFLAG.EQ.1) THEN
              SEN=SEN+0.5*(STMAT((NPBG(NEL)+IPT-1)*4+1)&
                   *STNMAT((NPBG(NEL)+IPT-1)*4+1)+&
                   STMAT((NPBG(NEL)+IPT-1)*4+2)&
                   *STNMAT((NPBG(NEL)+IPT-1)*4+2)+&
                   2*STMAT((NPBG(NEL)+IPT-1)*4+3)&
                   *STNMAT((NPBG(NEL)+IPT-1)*4+3))*GJACOB(NPBG(NEL)+IPT)
              WTTOT=WTTOT+GJACOB(NPBG(NEL)+IPT)
           ENDIF
        enddo loop_10132
        loop_10134: DO IPT=1,NINTC(NEL)
           X1=XiptCOM(NPBM(NEL)+IPT)*SCALEP(NEL)+XCENTP(NEL)
           Y1=YiptCOM(NPBM(NEL)+IPT)*SCALEP(NEL)+YCENTP(NEL)
           IFLAG=0
           loop_10135: DO J=1,NUM_VERT
              IF (CDABS(DCMPLX(X1,Y1)-W(J)) .LE. &
                   0.55*RADWLT(J)) THEN
                 IFLAG=1
                 EXIT
              ENDIF
           enddo loop_10135
           IF(IFLAG.EQ.1) THEN
              SEN=SEN+0.5*(STCOM((NPBM(NEL)+IPT-1)*4+1)&
                   *STNCOM((NPBM(NEL)+IPT-1)*4+1)+&
                   STCOM((NPBM(NEL)+IPT-1)*4+2)&
                   *STNCOM((NPBM(NEL)+IPT-1)*4+2)+&
                   2*STCOM((NPBM(NEL)+IPT-1)*4+3)&
                   *STNCOM((NPBM(NEL)+IPT-1)*4+3))*GJACOM(NPBM(NEL)+IPT)
              WTTOT=WTTOT+GJACOM(NPBM(NEL)+IPT)
           ENDIF
        enddo loop_10134
     enddo loop_10128
     SEN=SEN/WTTOT
     write(*,*) "Energy around conners is:", SEN
  ENDIF
  !     *****************************************

  RETURN
END SUBROUTINE OUTVAR_UN
