Program CMRL

  ! Declaration of implicit types

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)

  ! Declaration of libraries included
  INCLUDE 'mpif.h'
  ! Definition of the parameters used

  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NLM_SOFT=40000)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NUMHG=NLM*10000)
  PARAMETER (NUMTMOUT=NLM*18000,NUMTMIN=NLM*18000,NUMTMIN1=NLM*18000&
       ,NUMTMIN2=NLM*5000)
  ! Declaration of dimensions

  DIMENSION NODE(NLM),IJK(NLM,NDELM/2),IJK2(NLM,NDELM/2),&
       Y(NODM),F(NDFM),DU(NDFM),DU1(NDFM),IJK1(NLM,NDELM/2),&
       NINT(NLM,2),JDIAG(NDFM),X(NODM),&
       NLOAD(100),VLOAD(2,50),YLD_TEMP(10),&
       NBC1(3000),VBC1(2000),VLST(2,100),VBC_TEMP(2000),&
       NBETA(NLM),NSLIDE(50),VSLIDE(2,50),INT_ARRAY(10)

  DOUBLE PRECISION, ALLOCATABLE :: SK(:)

  ! Declaration of variables

  COMMON /BOUNDVBC/ VBC1_STEP(2000)
  COMMON /VOIDDATA/ FVOID(INTM*NLM),DFVOID(INTM*NLM)
  COMMON /NLOCPRM/ XLCHAR,XP,XQ,XK_NLOC(NLM*INTM)
  COMMON /NLOCPRMS/ XK_NLOC_S(NLM_SOFT*9)
  COMMON /ADAPTPARAM/ TRAC_FRAC,IADAPT_CELL,IADAPT_INC
  COMMON /IDAMSTEP/ STRMAC_EL(10,NLM),STRCOM_EL(10,NLM),IDAM_NOW
  COMMON /DAMELEM/ XDAMG(NLM),YDAMG(NLM),ORDAMG(NLM),IDAMG(NLM)
  COMMON /MAPPARAM/NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /CONVG1/ ICON1
  COMMON /REGENVAR/ IREGEN
  COMMON /PLNST/ KPLS
  COMMON /TOTDIS/ DISTOT(NDFM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON/BOUNDA/NBOUD1,LFOR,NBOUD3,NUPNCH
  COMMON /MACSTN/ NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)
  COMMON /OUTPLANE/ EZZ_APP1
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /EPSCOM/ STNCOM(NLM*INTC*4),STNCOMST(NLM*INTC*4)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /PLPCOM/ VMCOM(NLM*INTC),EPLSCOM(NLM*INTC)&
       ,DEPLSCOM(NLM*INTC),NPLCOM(NLM*INTC)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /BETAGL/ BETTOT(MAXH*NLM),BETST(MAXH*NLM),&
       BETLC(MAXH*NLM)
  COMMON /ELEPROP/ PROMAT(16,10),MPE(NLM),MPG(NLM)
  COMMON /YIELD/ HRD(16,3),YLDIN(16)
  common/hoonmt/stsn1(100,2),npts1
  COMMON /CONSTMT1/ NPTS(10),STSN(10,100,2)
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /STEPNUM/ IST
  COMMON /MACRSCP/ STMAC(2,6)
  COMMON /CRCKTIME/ NCRACK,IELCRACK(NLM)
  COMMON /ITRFILES/ ITRFIL1,ITRFIL2,FLAG11,FLAG12,FLAG21,FLAG22
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /SCALPRM/ XCENT(NLM),YCENT(NLM),SCALE(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /SCALPRMC/ XCENTPP(NLM),YCENTPP(NLM),SCALEPP(NLM)
  COMMON /LOADINGPARAM/ NLOAD_ST,ILOAD_ST,NST_LOAD(100)
  COMMON /OUTFILES/ WRITE_FILE1,WRITE_FILE2
  COMMON /TRACKTIP/ ITR,ITRACK(500)
  COMMON /SOFTPOINTER/ INEW_SOFT,ISOFT_TOT,IEL_SOFT(NLM)
  COMMON /RESOLVE/ I_READAPT
  COMMON /ELASFLAG/ IELASTIC
  COMMON /IWRITE/ IWRT
  COMMON /ITERBET/ IBET_FLAG
  COMMON /COORDSKIP/ FLAG_WR,NSTART,NSTART1
  COMMON /RESTARTPARAM/ JRESTART,KRESTART
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /SOFTNEQ/  NEQ_SOFT
  COMMON /IPTTYS/ XIPT_SOFT(NLM_SOFT*9),YIPT_SOFT(NLM_SOFT*9),GJAC_SOFT(NLM_SOFT*9)
  COMMON /SOFTSTR/ S_STMAT(NLM_SOFT*9*4),S_STMATST(NLM_SOFT*9*4)
  COMMON /SOFTSTN/ S_STNMAT(NLM_SOFT*9*4),S_STNMATST(NLM_SOFT*9*4)
  COMMON /PLPMATS/ VMMAT_S(NLM_SOFT*9),EPLSMAT_S(NLM_SOFT*9)&
       ,DEPLSMAT_S(NLM_SOFT*9),NPLMAT_S(NLM_SOFT*9)
  COMMON /VOIDDATAS/ FVOID_S(NLM_SOFT*9),DFVOID_S(NLM_SOFT*9)
  COMMON /INTBEGNSOFT/ NPBG_SOFT(NLM_SOFT),NINTM_SOFT(NLM_SOFT)
  COMMON /INSTT/ NPLINM(NLM*INTM),NPLINC(NLM*INTC)
  COMMON /PLLC/ NPLCM(NLM*INTM),NPLCC(NLM*INTC)
  common /plastflags/ nplinm_s(nlm_soft*9)
  COMMON /IDOASSIGN/ KASSIGN
  COMMON /CHARSIZE/ DLE
  COMMON /ARCLPARAM/ ALPH,DALPH,DUTEMPARC(NDFM),DUARC(NDFM),DUIN(NDFM),DUIN1(NDFM),DLTOT,IARCL
  COMMON /UNROTATEDDISP/ DUTEMP(NDFM)
  COMMON /ARCLINIT/ DUIN0(NDFM)
  COMMON /DEADLOAD/ IDEAD,GCBEF,SQBEF
  COMMON /UPDATCRACKSOFT/  IFLAG
  COMMON /TIMESTEP/ Time_step,NTot_step
  COMMON /ZOOMINGJ/  GJACOB_ZOOM,GJ_VCF(NLM),GJ_SOFT(NLM)
  COMMON /VOIDFAILURE/  VFRT
  COMMON /IQSINT1/  STRTMAX,STMAX,ISTRTMAX
  COMMON /DAMGPART/ IDAMFLAG
  common /IPTFAILDAT/ IPT_FAIL(NLM_SOFT*9),VM_FAILIPT(NLM_SOFT*9),EPL_FAILIPT(NLM_SOFT*9)
  COMMON /DISPSHIFT/ ISOFTEL(NLM)
  COMMON /HOURGLASS/ IHGLASS(NLM,NDELM),PHI_HGLASS(NUMHG),&
       NP_HGLASS(NLM,4),IHGNEL(NLM)
  COMMON /GMATR/ TMOUT(NUMTMOUT), NP_TMOUT(NLM,4),&
       TMIN(NUMTMIN), NP_TMIN(NLM,4),&
       TMIN1(NUMTMIN1), NP_TMIN1(NLM,4),&
       TMIN2(NUMTMIN2), NP_TMIN2(NLM,4)
  COMMON /STEPCONTROL/ DF_MAX,DF_CRT,ALPH_NOW,DFMAX_STEP(3)
  COMMON /ADPTMESH/ NELS_ADP,IADPT_MESH_NEL(NLM_SOFT), NELS_SUB(NLM_SOFT,4)
  COMMON /TITLENAME/ title,title1
  COMMON /SOFTFAIL/ NUM_FAILS(NLM)
  COMMON /VOIDPARAM/ Q1,Q2,Q3,FCOL,FMAX,FMAX_MODEL 
  COMMON /XKPARMUP/ IUPXK,IDAMGXK(NLM),ISOFTXK(NLM),NEL_SOFT_OLD
  COMMON /MACDROP/ EQV_S,EQV_E,EQVMAC,NUMDROP,IMACDROP
  COMMON /DECOMP/ IPARALLEL
  COMMON /IRELOAD/ IREADALL

  COMMON /TIME/ DT_TOTAL,DT_STEP,DTIME,DTIME1
  COMMON /VISCOUS/ GAMMA,EXPP,IVISCOUS

  CHARACTER*60 title,title1
  CHARACTER*60 outfile_name
  CHARACTER*80 FLAG,WRITE_FILE1,WRITE_FILE2
  CHARACTER*20 FLAG11,FLAG12,FLAG21,FLAG22,FLAG_WR
  CHARACTER *4 NUMBER

  EXTERNAL TITLE_TRANSFER
  DATA LR,LW,NDF,INTXY/1,2,2,4/ 

  ! Initialization of parallel zone

  CALL MPI_INIT(IERR)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NUMMPI,IERR)

  IPARALLEL=0
  DF_MAX=0.D0
  DF_CRT=0.05D0
  ALPH_NOW=1.D0
  ALPH=1.D0
  EZZ_STEP=0.D0

  title="                                                     ";
  title1="                                                     ";


1 FORMAT (A)
  IF(MYMPI.EQ.0) THEN
     OPEN (2047,FILE='open_up.dat')
  ENDIF
  IF(MYMPI.EQ.0) THEN
     OPEN (746,FILE='error_raw.dat')
     OPEN (77,FILE='ifl4.dat')
     READ (77,1) FLAG
  ENDIF
  call mpi_bcast(FLAG,80,MPI_CHARACTER,0,mpi_comm_world,ierror)

  IJK(1,1)=NLM    
  I=TITLE_TRANSFER(FLAG,IJK,title,title1)

  FLAG21='junk1.qsint'
  FLAG22='junk2.qsint'

  IF(MYMPI.EQ.0) THEN
     READ (77,1)FLAG
     OPEN(LR,FILE =FLAG)
     READ (77,1) FLAG11
     OPEN(20,FILE =FLAG11)
     READ (77,1) FLAG12
     OPEN(21,FILE =FLAG12)
     READ (77,1) FLAG
     OPEN (58,FILE=FLAG)
     READ (77,1) FLAG_WR
     OPEN (51,FILE=FLAG_WR)
     OPEN (61,FILE="VTK_BOUND.coord")
     WRITE_FILE1=FLAG_WR
     READ (77,1) FLAG
     OPEN (52,FILE=FLAG)
     WRITE_FILE2=FLAG
     READ (77,1) FLAG
     OPEN (57,FILE=FLAG)
     READ (77,1) FLAG
     OPEN (284,FILE=FLAG)
     READ (77,1) FLAG
     OPEN (285,FILE=FLAG)
     READ (58,*) NLOAD_ST,KPLS
     READ (58,*) IFREQ 
     OPEN (42,FILE='crack.section')
     OPEN (1326,FILE='imat.dat')
  ENDIF
  call mpi_bcast(WRITE_FILE1,80,MPI_CHARACTER,0,mpi_comm_world,ierror)
  call mpi_bcast(WRITE_FILE2,80,MPI_CHARACTER,0,mpi_comm_world,ierror)
  call mpi_bcast(NLOAD_ST,1,MPI_INTEGER,0,mpi_comm_world,ierror)
  call mpi_bcast(KPLS,1,MPI_INTEGER,0,mpi_comm_world,ierror)
  call mpi_bcast(IFREQ,1,MPI_INTEGER,0,mpi_comm_world,ierror)
  call MPI_BARRIER(MPI_COMM_WORLD,IERR)  

  ! READ THE VC - FINITE ELEMENT MESH
  CALL HRMESH(NODE,X,Y,IJK,MPE,MPG,LR,LW)
  call MPI_BARRIER(MPI_COMM_WORLD,IERR)  
  CALL HRMESH1(NELX,NX,NINT,IJK1,IJK2,MPG,LR)
  call MPI_BARRIER(MPI_COMM_WORLD,IERR)  
  NEQ=NX*2+3
  NEQ2=NEQ+NELX*6
  IF(NEQ2.GT.NDFM) THEN
     write(*,*) "NDFM (",NDFM,") is not enough,", &
          " increasing it to ",NEQ2
  ENDIF

  CALL PRE_DISCRET(NELX,X,Y,NODE,IJK,NINT,IJK1,IJK2)

  ! READ MATERIAL CONSTANTS
  CALL MATERL(PROMAT,LMAT,KK1,KK2,LR,LW)
  call MPI_BARRIER(MPI_COMM_WORLD,IERR)  
  ! READ INPUT DATA FOR BOUNDARY CONDITIONS
  CALL BETASET(NELX,NODE,NINT,NBETA,LR)
  call MPI_BARRIER(MPI_COMM_WORLD,IERR)  
  ISOLVE=-1
  CALL BOUNDCON(NODE,NINT,NBC1,IJK,IJK1,IJK2,X,Y,&
       VBC1,LR,ISOLVE)
  call MPI_BARRIER(MPI_COMM_WORLD,IERR)  
  ITYP=0

  call MPI_BARRIER(MPI_COMM_WORLD,IERR)
  !  IDENTIFY INTEGRATION POINTS
  CALL IDENTIPT (NX,NELX,NODE,NBETA,IJK,IJK1,IJK2,NINT,&
       X,Y,DU1,NBC1,VBC1)

  CALL INITIAL (NBETA,NODE,NINT)

  CALL CALPTPDIST()

  DF_CRT=0.6D0*(FMAX-PROMAT(3,1))
  IF(MYMPI.EQ.0) THEN
     call walltime(STSEC,STMSEC)
  ENDIF

  IF(MYMPI.EQ.0) THEN
     READ (58,*) NST_LOAD(1)
     READ (58,*) DELT,IVPL,NPLINT
     READ (58,*) DLE

     !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     !     Finding the smallest perimeter of elements
     DL_MIN=1E+20
     DLTOT1=0.D0
     loop_10006: DO I=1,NELX
        DL=0.D0                  
        loop_10007: DO J=1,NODE(I)-1
           DL=DL+DSQRT((X(IJK(I,J))-X(IJK(I,J+1)))**2+&
                (Y(IJK(I,J))-Y(IJK(I,J+1)))**2)
        enddo loop_10007
        DL=DL+DSQRT((X(IJK(I,NODE(I)))-X(IJK(I,1)))**2+&
             (Y(IJK(I,NODE(I)))-Y(IJK(I,1)))**2)
        IF(DL.LT.DL_MIN) DL_MIN=DL
        DLTOT1=DLTOT1+DL
     enddo loop_10006
     DLAVG=DLTOT1/NELX
     DLE=DLAVG/100.D0
     !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%               

  ENDIF

  call mpi_bcast(NST_LOAD(1),1,mpi_integer,0,mpi_comm_world,ierror)

  call mpi_bcast(DELT,1,mpi_double_precision,0,mpi_comm_world,ierror)

  call mpi_bcast(IVPL,1,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(NPLINT,1,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(DLE,1,mpi_double_precision,0,mpi_comm_world,ierror)
  NST_LOAD_TEMP=NST_LOAD(1)
  NST=NST_LOAD_TEMP

  loop_10008: DO MP=1,LMAT
     YLD_TEMP(MP)=YLDIN(MP)
     YLDIN(MP)=PROMAT(1,MP)*1.D+16
     STSN(MP,1,1)=YLDIN(MP)
  enddo loop_10008

  ! READ THE BOUNDARY CONDITIONS FROM THE INPUT FILE
  CALL RBOUN1(NST,NBC1,VBC1,NBOUD1,NDF,LR,LW)
  CALL RBOUN2(NST,NLOAD,VLOAD,VLST,NDF,LFOR,LR,LW)
  CALL RBOUN4(NSLIDE,VSLIDE,SPRIN3,LSLID,LR,LW)
  CALL RBOUN_MAC(NST,LR,LW)     
  CALL PRESKY (NINT,IJK,IJK1,NODE,JDIAG,ISKM)
  CALL NODFIX(NBOUD1,NBC1,VBC1,NODE,IJK)

  DO I=1,NBOUD1*2
     VBC1(I) = VBC1(I)*NST
  END DO

  IARCL=1
  CALL INITIAL_YLD(NELX)
  ALLOCATE(SK(JDIAG(NEQ1)))
  SK=0.D0
  IST=1

  IF(NDFM.LT.NEQ2) THEN
     WRITE(*,*) "NDFM(=",NDFM,") is not enough, &
          increase it to ",NEQ2
  ENDIF

  IF(MYMPI.EQ.0) THEN
     REWIND (20)
     CLOSE (20)
  ENDIF
  IF(MYMPI.EQ.0) THEN
     OPEN (20,FILE=FLAG21)
  ENDIF

  IF (JDIAG(NEQ1).GT.ISKM) THEN
     WRITE (*,*) 'STIFFNESS IS TOO SMALL'
     WRITE (*,*) 'JDIAG=',JDIAG(NEQ1)
  ENDIF
  CALL AZERO (DU1)
  CALL AZERO (DUTEMP)
  DALPH=0.D0
  ! ASSEMBLE THE STIFFNESS MATRIX
  CALL ASMBLYMPI(-1,SK,F,DU1,NBETA,NODE,NBC1,NLOAD,&
       IJK,IJK1,IJK2,NINT,VBC1,VLOAD,X,Y,NDF,JDIAG)
  CALL SKYLIN(SK,F,JDIAG,NEQ1,0)
  CALL FORCE_TVGBOUND(SK,F,JDIAG,-1)
  CALL INTEXT (NODE,NINT,IJK,IJK1,IJK2,F,F)               
  CALL EXCHN(F,DU1,NEQ2)
  CALL EXCHN (DU1,DUIN,NEQ2)               
  DLTOT=ALPH**2
  if (iarcl.eq.1) then
     loop_10019: do i=1,neq2
        DUIN0(I)=DUIN(I)
     enddo loop_10019
  endif

  ! DETERMINE THE STRESSES AT THE INTEGRATION POINTS
  CALL QSINT(DU,DU1,DELTME,IJK,IJK1,IJK2,NINT,NODE,NBETA,&
       JDIAG,NBC1,NLOAD,VBC1,VLOAD,X,Y,SK,F,ITEREF,0)
  IF(MYMPI.EQ.0) THEN
     write(*,*) "end qsint", IVPL," ITEREF= ", ITEREF,&
          " DLTOT= ",DLTOT," ALPH= ",ALPH," ICON1= ",ICON1,&
          "ALPH_NOW=", ALPH_NOW
  ENDIF

  call MPI_BARRIER(MPI_COMM_WORLD,IERR)
  ! UPDATE SIMULATION VARIABLES
  CALL UPDATVAR (1,DU1,X,Y,VLOAD,VLST,NBETA,NODE,NINT,IJK,IJK1&
       ,IJK2)

  IF(MYMPI.EQ.0) THEN
     call outvar_UN(IST,NODE,NINT,IJK,IJK1,IJK2,X,Y)
  ENDIF

  VBC_MAX=0.D0
  loop_10038: DO IV=1,1000
     IF(VBC_MAX.LT.ALPH*VBC1(IV)) VBC_MAX=ALPH*VBC1(IV)
  enddo loop_10038

  ! OUTPUT THE STRESS-STRAIN EQUIVALENT CURVE
  CALL MACSTR(NBETA)
  call OUT_EQV(STMAC,ILOAD_ST,VBC_MAX)

  IF(MYMPI.EQ.0) THEN
     OPEN (41,FILE='step.finish')
     WRITE (41,*) 'STEP=',IST,' AFTER LOADING',' STMAC=',&
          (STMAC(1,K),K=1,4)
     REWIND (41)
     CLOSE (41)
  ENDIF
  call MPI_BARRIER(MPI_COMM_WORLD,IERR)
  IF(MYMPI.EQ.1) THEN
     OPEN (41,FILE='step.finish',POSITION='APPEND')
     WRITE (41,*) 'STEP=',IST,' AFTER LOADING',' STMAC=',&
          (STMAC(1,K),K=1,4)
     REWIND (41)
     CLOSE (41)
  ENDIF

  call MPI_BARRIER(MPI_COMM_WORLD,IERR)

  !     End timing
  IF(MYMPI.EQ.0) THEN
     call walltime(ENDSEC,ENDMSEC)
     TOT_time=(ENDSEC-STSEC)+(ENDMSEC-STMSEC)*1.E-06
     TOT_time=TOT_time/60
     OPEN(666,file="time.dat")
     write(666,*) 'Time taked for solution = ', TOT_time,' mins.&
          for NUMMPI= ', NUMMPI
     close(666)
     close(2047)
  ENDIF
  close(61)
  DEALLOCATE(SK)
  CALL MPI_FINALIZE(IERR)
  STOP
END Program CMRL

!************************************************************  
! Initialize all the arrays
SUBROUTINE INITIAL (NBETA,NODE,NINT)
!************************************************************  

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (NODPER=NDELM)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)

  DIMENSION NBETA(NLM),NODE(NLM),NINT(NLM,2)     
  COMMON /DISPSHIFT/ ISOFTEL(NLM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /TOTDIS/ DISTOT(NDFM)
  COMMON /ELEPROP/ PROMAT(16,10),MPE(NLM),MPG(NLM)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /EPSCOM/ STNCOM(NLM*INTC*4),STNCOMST(NLM*INTC*4)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /PLPCOM/ VMCOM(NLM*INTC),EPLSCOM(NLM*INTC)&
       ,DEPLSCOM(NLM*INTC),NPLCOM(NLM*INTC)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /BETAGL/ BETTOT(MAXH*NLM),BETST(MAXH*NLM),&
       BETLC(MAXH*NLM)
  COMMON /YIELD/ HRD(16,3),YLDIN(16)
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /VOIDDATA/ FVOID(INTM*NLM),DFVOID(INTM*NLM)
  COMMON /VOIDPARAM/ Q1,Q2,Q3,FCOL,FMAX,FMAX_MODEL 
  COMMON /SCALPRM/ XCENT(NLM),YCENT(NLM),SCALE(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /SCALPRMC/ XCENTPP(NLM),YCENTPP(NLM),SCALEPP(NLM)
  COMMON /NLOCPRM/ XLCHAR,XP,XQ,XK_NLOC(NLM*INTM)
  COMMON /INIVOID/ FVOID_IN(NLM*INTM)
  common/coalesc/fsubc,fsubf,fsubu,facvoid
  COMMON /MACDROP/ EQV_S,EQV_E,EQVMAC,NUMDROP,IMACDROP
  COMMON /ANISOTROPIC/ XF_AN,XG_AN,XH_AN,XC_AN,IANIS

  IANIS=0
  XF_AN=0.5D0
  XG_AN=0.5D0
  XH_AN=0.5D0
  XC_AN=3.D0


  EQV_S=0.D0
  IMACDROP=0

  Q1=3.D0
  Q2=0.5D0
  Q3=2.25D0
  FCOL=PROMAT(3,2)
  FMAX=PROMAT(4,2)
  FMAX_MODEL=2.D0/Q1
  FSUBC=FCOL
  FSUBU=FMAX_MODEL
  FSUBF=FMAX
  FACVOID=(FMAX_MODEL-FCOL)/(FMAX-FCOL)
  loop_1: DO I=1,NELX
     ISOFTEL(I)=0
     IND=NDIV(I)
     loop_2: DO J=1,NINTM(I)
        STMAT((NPBG(I)+J)*4)=0.E0
        STMATST((NPBG(I)+J)*4)=0.E0
        IF (IVPL.NE.1) THEN
           VMMAT(NPBG(I)+J)=YLDIN(MPE(I))
           XX=XIPT(NPBG(I)+J)*SCALE(I)+XCENT(I)
           YY=YIPT(NPBG(I)+J)*SCALE(I)+YCENT(I)
           RR=(XX*XX+YY*YY)
           RR=RR*RR/(8.D-02**4)               
           FVOID(NPBG(I)+J)=PROMAT(3,MPE(I))
           IF(FVOID(NPBG(I)+J).LT.1.D-10) FVOID(NPBG(I)+J)=1.D-10
           FVOID_IN(NPBG(I)+J)=FVOID(NPBG(I)+J)
           XK_NLOC(J+NPBG(I))=1.D0
        ELSE
           VMMAT(NPBG(I)+J)=YLDIN(MPE(I))*1.D-08
        ENDIF
        EPLSMAT(NPBG(I)+J)=0.E0
        DEPLSMAT(NPBG(I)+J)=0.E0
        NPLMAT(NPBG(I)+J)=0
        loop_3: DO K=1,3
           STMAT((NPBG(I)+J-1)*4+K)=0.E0
           STMATST((NPBG(I)+J-1)*4+K)=0.E0
           STNMAT((NPBG(I)+J-1)*4+K)=0.E0
           STNMATST((NPBG(I)+J-1)*4+K)=0.E0
        enddo loop_3
     enddo loop_2
     loop_4: DO J=1,NINTC(I)
        STCOM((NPBM(I)+J)*4)=0.E0
        STCOMST((NPBM(I)+J)*4)=0.E0
        VMCOM(NPBM(I)+J)=YLDIN(MPG(I))
        EPLSCOM(NPBM(I)+J)=0.E0
        DEPLSCOM(NPBM(I)+J)=0.E0
        NPLCOM(NPBM(I)+J)=0
        loop_5: DO K=1,3
           STCOM((NPBM(I)+J-1)*4+K)=0.E0
           STCOMST((NPBM(I)+J-1)*4+K)=0.E0
           STNCOM((NPBM(I)+J-1)*4+K)=0.E0
           STNCOMST((NPBM(I)+J-1)*4+K)=0.E0
        enddo loop_5
     enddo loop_4
     loop_6: DO J=1,NBETA(I)*2
        BETTOT(J+(I-1)*2*NBM)=0.E0
        BETST(J+(I-1)*2*NBM)=0.E0
     enddo loop_6
  enddo loop_1
  loop_12: DO I=1,NEQ2
     DISTOT(I)=0.E0
  enddo loop_12
  RETURN
END SUBROUTINE INITIAL

!************************************************************  
SUBROUTINE INITIAL_YLD(NELX) 
!************************************************************  

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  DIMENSION IDONE(INTM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /ELEPROP/ PROMAT(16,10),MPE(NLM),MPG(NLM)
  COMMON /YIELD/ HRD(16,3),YLDIN(16)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /VOIDDATA/ FVOID(INTM*NLM),DFVOID(INTM*NLM)
  COMMON /INIVOID/ FVOID_IN(NLM*INTM)
  COMMON /CONSTMT1/ NPTS(10),STSN(10,100,2)
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  loop_10059: DO NEL=1,NELX
     NPT=NPBG(NEL)
     MP=MPE(NEL)
     IF (IVPL.NE.1) THEN
        loop_10060: DO J=1,NPTS(MP)-1
           E1=STSN(MP,J,2)
           E2=STSN(MP,J+1,2)
           S1=STSN(MP,J,1)
           S2=STSN(MP,J+1,1) 
           SLP=(S2-S1)/(E2-E1)
           loop_10061: DO I=1,NINTM(NEL)
              EP=EPLSMAT(NPT+I)
              IF (J.EQ.1) IDONE(I)=0
              IF (IDONE(I).EQ.0) THEN
                 IF (E1.LE.EP.AND.E2.GE.EP) THEN
                    IDONE(I)=1
                    VMMAT(NPT+I)=S1+SLP*(EP-E1)
                 ELSEIF (EP.LT.E1.AND.J.EQ.1) THEN
                    IDONE(I)=1
                    VMMAT(NPT+I)=S1+SLP*(EP-E1)
                 ELSEIF (EP.GT.E2.AND.J.EQ.NPTS(MP)-1) THEN
                    IDONE(I)=1
                    VMMAT(NPT+I)=S1+SLP*(EP-E1)
                 ENDIF
              ENDIF
           enddo loop_10061
        enddo loop_10060
     ELSE
        loop_10062: DO I=1,NINTM(NEL)
           VMMAT(NPT+I)=DMIN1(1.D-10,1.D-08*YLDIN(MP))
           IF(IVPL.EQ.0) THEN
              FVOID(NPT+I)=0.D0
              FVOID_IN(NPT+I)=0.D0
           ENDIF
        enddo loop_10062
     ENDIF
  enddo loop_10059
  RETURN
END SUBROUTINE INITIAL_YLD

!****************************************************************************
! Read the VC-FEM mesh , geometry of the elements.
SUBROUTINE HRMESH(NODE,X,Y,IJK,&
     MPE,MPG,LR,LW)
!****************************************************************************        
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (NLM_SOFT=40000)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  DIMENSION X(NODM),Y(NODM),IJK(NLM,NDELM/2),MPE(NLM),MPG(NLM),&
       NODE(NLM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),&
       INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /BOUNDMAXMIN/ PX1,PX2,PY1,PY2
  COMMON /NEIGHNEL/ NUM_NEIGH(NLM),NEL_NEIGH(NLM,20)
  CHARACTER*20 FLAG,LINE
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  NEL_SOFT=0
  CALL LAGRANGE()
  IF(MYMPI.EQ.0) THEN
     READ(LR,598) FLAG 
598  FORMAT(A)                                                                             
     READ(LR,598)LINE                              
     READ (LR, * ) NX,NELX

     READ(LR,598)LINE                              
     loop_106: DO I=1,NX
        READ(LR, * ) N,X(N),Y(N)                                        
     enddo loop_106
     NEQ1=0                  
     READ(LR,598)LINE                              
     loop_100: DO I=1,NELX
        READ(LR, * ) NEL,MPE(NEL),NODE(NEL),(IJK(NEL,J),J=1,NODE(NEL))
        MPG(I)=1 
        loop_101: DO J=1,NODE(I)
           IF (NEQ1.LT.IJK(I,J))NEQ1=IJK(I,J)
        enddo loop_101
     enddo loop_100
  ENDIF
  call mpi_bcast(NX,1,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(NELX,1,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(X,NX,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(Y,NX,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(neq1,1,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(mpe(1),NELX,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(node(1),NELX,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(ijk,(NLM*NDELM/2),mpi_integer,0,mpi_comm_world,ierror)

  NX_CELL=NEQ1
  NEQ1=NEQ1*2+3 
  !     Deciding the max&min value of the boundary
  PX1=X(1)
  PY1=Y(1)
  PX2=X(1)
  PY2=Y(1)

  loop_10063: DO I=2,NX
     IF(PX1.GT.X(I)) PX1=X(I)
     IF(PY1.GT.Y(I)) PY1=Y(I)
     IF(PX2.LT.X(I)) PX2=X(I)
     IF(PY2.LT.Y(I)) PY2=Y(I)
  enddo loop_10063

  ! Finding all the neighbour elements
  DO I=1,NELX
     NUM_NEIGH(I)=1
     NEL_NEIGH(I,NUM_NEIGH(I))=I
     DO J=1,NELX
        IF(I.NE.J) THEN
           JFIND1=0
           DO I1=1,NODE(I)
              DO J1=1,NODE(J)
                 IF(IJK(I,I1).EQ.IJK(J,J1)) THEN
                    JFIND1=1
                    EXIT
                 ENDIF
              ENDDO
              IF(JFIND1.EQ.1) THEN
                 NUM_NEIGH(I)=NUM_NEIGH(I)+1
                 NEL_NEIGH(I,NUM_NEIGH(I))=J
                 EXIT
              ENDIF
           ENDDO
        ENDIF
     ENDDO
  ENDDO

  RETURN     
END SUBROUTINE HRMESH

!****************************************************************************
! Read VC - FEM mesh, inclusion geometry.
SUBROUTINE HRMESH1(NELX,NX,NINT,IJK1,IJK2,MPG,LR)  
!****************************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)

  DIMENSION NINT(NLM,2),MPG(NLM),&
       IJK1(NLM,NDELM/2),IJK2(NLM,NDELM/2)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /EDGEPRM/ NACTIVE(NLM),ICENT(NLM),NMUL(NLM)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /SCALPRMC/ XCENTPP(NLM),YCENTPP(NLM),SCALEPP(NLM)
  COMMON /DAMELEM/ XDAMG(NLM),YDAMG(NLM),ORDAMG(NLM),IDAMG(NLM)
  COMMON /CRKNODE/ MCTIP(NODM)
  CHARACTER*20 LINE

  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)

  NBEG=NX
  IF(MYMPI.EQ.0) THEN
     READ(LR,598) LINE 
  ENDIF
598 FORMAT(A)                             
  I1=NELX
  IF(MYMPI.EQ.0) THEN
     loop_6: DO I=1,NELX
        READ(LR,*) N,MPG(N),NINT(I,1),(IJK1(I,J),J=1,NINT(I,1))
     enddo loop_6
     READ (LR,*)
     loop_8: DO I=1,NELX
        READ(LR,*) N,NINT(I,2),(IJK2(I,J),J=1,NINT(I,2))
        WRITE (88,*) N,NINT(I,2),(IJK2(I,J),J=1,NINT(I,2))
        IF (NINT(I,2).EQ.0) THEN
           IDAMG(I)=0
        ELSE
           IDAMG(I)=1
        ENDIF
     enddo loop_8
     READ (LR,*)
     loop_7: DO I=1,NELX
        READ (LR,*) MCRACK(I),XSCALEM(I),YSCALEM(I),ANM(I),XCENTP(I),&
             YCENTP(I),NMUL(I)
     enddo loop_7
     READ (LR,*)
     loop_71: DO I=1,NELX
        READ (LR,*) ICRACK(I),XSCALEI(I),YSCALEI(I),ANI(I),XCENTPP(I),&
             YCENTPP(I)
     enddo loop_71
  ENDIF

  call mpi_bcast(mpg(1),nelx,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(NINT,NLM*2,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(ijk1,(NLM*NDELM/2),mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(NUM_VERT10,NELX,mpi_integer,0,mpi_comm_world,ierror)

  call mpi_bcast(IDAMG,NELX,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(ijk2,(NLM*NDELM/2),mpi_integer,0,mpi_comm_world,ierror)

  call mpi_bcast(mcrack(1),NELX,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(xscalem(1),NELX,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(yscalem(1),NELX,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(anm(1),NELX,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(xcentp(1),NELX,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(ycentp(1),NELX,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(nmul(1),NELX,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(icrack(1),NELX,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(xscalei(1),NELX,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(yscalei(1),NELX,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(ani(1),NELX,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(xcentpp(1),NELX,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(ycentpp(1),NELX,mpi_double_precision,0,mpi_comm_world,ierror)

  loop_10064: DO I=1,NX
     MCTIP(I)=0
  enddo loop_10064
  loop_10065: DO NEL=1,NELX
     IF (NINT(NEL,2).NE.0) THEN
        ITIP=IJK2(NEL,1)
        MCTIP(ITIP)=1
        ITIP=IJK2(NEL,2)
        MCTIP(ITIP)=1
        ITIP=IJK2(NEL,5)
        MCTIP(ITIP)=1
        ITIP=IJK2(NEL,5)
        MCTIP(ITIP)=1
        ITIP=IJK2(NEL,7)
        MCTIP(ITIP)=1
        ITIP=IJK2(NEL,12)
        MCTIP(ITIP)=1
     ENDIF
  enddo loop_10065
  RETURN
END SUBROUTINE HRMESH1

!****************************************************************************
! Read Material properties from the input file.
SUBROUTINE MATERL(PROMAT,LMAT,KK1,KK2,LR,LW)               
!****************************************************************************                                             

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  DIMENSION PROMAT(16,10)    
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /YIELD/ HRD(16,3),YLDIN(16)
  COMMON /CONSTMT1/ NPTS(10),STSN(10,100,2)
  COMMON /NLOCPRM/ XLCHAR,XP,XQ,XK_NLOC(NLM*INTM)
  COMMON /CONSTMTS/ NPTSS(10),STSNS(10,100,2)      
  common/hoonmt/stsn1(100,2),npts1
  COMMON/NUCLEA/VONUFN,VONUS,VONUEN,VONUTN,SPECA,SPECB,INUCL
  CHARACTER  FLAG*80                                         
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)

  IF(MYMPI.EQ.0) THEN
     READ(LR,598) FLAG                                          
598  FORMAT(A)                                                  
     READ(LR, * ) LMAT
     loop_10066: DO I=1,LMAT
        READ(LR, * ) (PROMAT(J,I),J=1,2)
     enddo loop_10066
  ENDIF
  call mpi_bcast(LMAT,1,MPI_integer,0,MPI_COMM_WORLD,ierror)
  call mpi_bcast(promat,(16*10),mpi_double_precision,0,mpi_comm_world,ierror)
  RETURN                                                     
END SUBROUTINE MATERL
!*********************************************************************
! Read the First boundary nodes and D.O.F which are constrained
SUBROUTINE RBOUN1(NST,NBC1,VBC1,NBOUD1,NDF,LR,LW)     
!*********************************************************************                                                                     
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  DIMENSION NBC1(1),VBC1(1)                                       
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /REPTPARAM/ IREPT_FLAG,KSTR1,KSTR2,IREPT(4),&
       JREPT(4),KD1_BD(NODM),KD2_BD(NODM),NEL_KD1(NODM,2),&
       NEL_KD2(NODM,2),EMAC(3)
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON /POSTVBC/  IBCXY
  CHARACTER  FLAG*80

  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)

  IF(MYMPI.EQ.0) THEN
     READ(LR,598) FLAG                                               
598  FORMAT(A)                                                       
     READ(LR, * )NBD1                                       
  ENDIF
  call mpi_bcast(FLAG,80,mpi_character,0,mpi_comm_world,ierror)
  call mpi_bcast(NBD1,1,mpi_integer,0,mpi_comm_world,ierror)
  I2=0
  loop_100: DO I1=1,NBD1
     IF(MYMPI.EQ.0) THEN
        READ(LR, * )NODNUM,K1,K2,D1,D2
     ENDIF

     call mpi_bcast(NODNUM,1,mpi_integer,0,mpi_comm_world,ierror)
     call mpi_bcast(K1,1,mpi_integer,0,mpi_comm_world,ierror)
     call mpi_bcast(K2,1,mpi_integer,0,mpi_comm_world,ierror)
     call mpi_bcast(D1,1,mpi_double_precision,0,mpi_comm_world,ierror)
     call mpi_bcast(D2,1,mpi_double_precision,0,mpi_comm_world,ierror)
     IF (IREPT_FLAG.EQ.0) THEN
        IF (K1.EQ.1) THEN
           IF(D1.NE.0) IBCXY=1
           I2=I2+1
           I=NBOUD1+I2
           NDG=NDGLB((NODNUM-1)*2+1)
           IF (NDG-(NDG/2)*2.EQ.1) THEN
              NBC1(3*(I-1)+1)=NODNUM
              NBC1(3*(I-1)+2)=1
              NBC1(3*(I-1)+3)=0
              VBC1(2*(I-1)+1)=D1/NST
              VBC1(2*(I-1)+2)=0.D0
           ELSE
              NBC1(3*(I-1)+1)=NODNUM
              NBC1(3*(I-1)+2)=0
              NBC1(3*(I-1)+3)=1
              VBC1(2*(I-1)+1)=0.D0
              VBC1(2*(I-1)+2)=D2/NST
           ENDIF
        ENDIF
        IF (K2.EQ.1) THEN
           IF(D2.NE.0) IBCXY=2
           I2=I2+1
           I=NBOUD1+I2
           NDG=NDGLB((NODNUM-1)*2+2)
           IF (NDG-(NDG/2)*2.EQ.1) THEN
              NBC1(3*(I-1)+1)=NODNUM
              NBC1(3*(I-1)+2)=1
              NBC1(3*(I-1)+3)=0
              VBC1(2*(I-1)+1)=D1/NST
              VBC1(2*(I-1)+2)=0.D0
           ELSE
              NBC1(3*(I-1)+1)=NODNUM
              NBC1(3*(I-1)+2)=0
              NBC1(3*(I-1)+3)=1
              VBC1(2*(I-1)+1)=0.D0
              VBC1(2*(I-1)+2)=D2/NST
           ENDIF
        ENDIF
     ENDIF
  enddo loop_100
  IF (IREPT_FLAG.EQ.0) THEN
     NBOUD1=NBOUD1+I2
  ENDIF
  RETURN                                                          
END SUBROUTINE RBOUN1

!************************************************************
! Read applied macroscopic plane strains
SUBROUTINE RBOUN_MAC(NST,LR,LW)     
!************************************************************  

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)

  include 'mpif.h'

  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  COMMON /MACSTN/ NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)
  COMMON /OUTPLANE/ EZZ_APP1
  COMMON /BOUNDCURVE/ ABD_CRV,BBD_CRV,ANBD_CRV,&
       XBD_CRV,YBD_CRV,IBD_CRV
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /REPTPARAM/ IREPT_FLAG,KSTR1,KSTR2,IREPT(4),&
       JREPT(4),KD1_BD(NODM),KD2_BD(NODM),NEL_KD1(NODM,2),&
       NEL_KD2(NODM,2),EMAC(3)

  CHARACTER  FLAG*80
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  IF(MYMPI.EQ.0) THEN
     READ (LR,598) FLAG
598  FORMAT (A)
     READ(LR, * ) NBOUD_MAC,EZZ_APP1
     EZZ_APP1=EZZ_APP1/NST
  ENDIF

  call mpi_bcast(NBOUD_MAC,1,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(EZZ_APP1,1,mpi_double_precision,0,mpi_comm_world,ierror)
  IF (IREPT_FLAG.EQ.1) NBOUD_MAC=3
  IF(MYMPI.EQ.0) THEN
     IF (NBOUD_SLD.GE.0.AND.IREPT_FLAG.EQ.0) THEN
        loop_100: DO I=1,NBOUD_MAC
           READ(LR, * ) MACNUM,D1
           NBC_MAC(I)=MACNUM
           VBC_MAC(I)=D1/NST
        enddo loop_100
     ELSE
        NBOUD_MAC=3
        loop_10067: DO I=1,3
           NBC_MAC(I)=I
           VBC_MAC(I)=0.D0
        enddo loop_10067
        IF (IREPT_FLAG.EQ.1) THEN
           loop_10068: DO J=1,3
              READ (LR,*) I,EMAC(I)
           enddo loop_10068
        ENDIF
     ENDIF
  ENDIF
  call mpi_bcast(NBOUD_MAC,1,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(NBC_MAC,4,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(VBC_MAC,4,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(EMAC,3,mpi_double_precision,0,mpi_comm_world,ierror)

  RETURN                                                          
END SUBROUTINE RBOUN_MAC

!************************************************************  
! Read the second boundary nodes and corresponding applied
! forces on these nodes
SUBROUTINE RBOUN2(NST,NLOAD,VLOAD,VLST,NDF,LFOR,LR,LW)     
!************************************************************  

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  DIMENSION NLOAD(100),VLOAD(2,50),VLST(2,100)                    
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /REPTPARAM/ IREPT_FLAG,KSTR1,KSTR2,IREPT(4),&
       JREPT(4),KD1_BD(NODM),KD2_BD(NODM),NEL_KD1(NODM,2),&
       NEL_KD2(NODM,2),EMAC(3)
  CHARACTER  FLAG*80                            
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)

  IF(MYMPI.EQ.0) THEN
     READ(LR,598) FLAG                                          
598  FORMAT(A)                                                  
     READ(LR, * ) LFOR                                          
  ENDIF
  call mpi_bcast(LFOR,1,mpi_integer,0,mpi_comm_world,ierror)

  loop_100: DO I=1,LFOR
     IF(MYMPI.EQ.0) THEN
        READ(LR, * ) NLOAD(I),(VLOAD(J,I),J=1,NDF)            
     ENDIF
     call mpi_bcast(NLOAD,LFOR,mpi_integer,0,&
          mpi_comm_world,ierror)
     call mpi_bcast(vload,(2*50),mpi_double_precision,0,&
          mpi_comm_world,ierror)
     IF (IREPT_FLAG.EQ.0) THEN
        loop_101: DO J=1,2
           VLST(J,I)=VLOAD(J,I)/NST
           VLOAD(J,I)=VLST(J,I)
        enddo loop_101
     ENDIF
  enddo loop_100
  IF (IREPT_FLAG.EQ.1) LFOR=0
  RETURN                                                     
END SUBROUTINE RBOUN2

!************************************************************  
! Read the fourth boundary nodes.
SUBROUTINE RBOUN4(NSLIDE,VSLIDE,SPRING,LSLID,LR,LW)        
!************************************************************  

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  DIMENSION NSLIDE(50),VSLIDE(2,50)                            
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  CHARACTER  FLAG*80      
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  IF(MYMPI.EQ.0) THEN
     READ(LR,598) FLAG                                          
598  FORMAT(A)                                                  
     READ(LR, * ) LSLID,SPRING                                  
     READ(LR, * ) (NSLIDE(I),(VSLIDE(J,I),J=1,2),I=1,LSLID)     
     LSLID=0
  ENDIF
  call mpi_bcast(LSLID,1,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(SPRING,1,mpi_double_precision,0,mpi_comm_world,ierror)
  call mpi_bcast(NSLIDE,LSLID,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(VSLIDE,(2*50),mpi_double_precision,0,mpi_comm_world,ierror)
  RETURN                                                     
END SUBROUTINE RBOUN4

!************************************************************  
SUBROUTINE PRESKY (NINT,IJK,IJK1,NODE,JDIAG,NMAX)
!************************************************************  

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  INCLUDE 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  DIMENSION  NINT(NLM,2),IJK(NLM,NDELM/2),NODE(NLM),JDIAG(NDFM),IJK1(NLM,NDELM/2)

  INTEGER, ALLOCATABLE :: JMAX(:),KCON(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  ALLOCATE(JMAX(NODM*2),KCON(NODM*2))

  JMAX=0
  KCON=0
  loop_100: DO I=1,NEQ1
     JMAX(I)=0
     KCON(I)=0
  enddo loop_100
  loop_1: DO I=1,NEQ1
     loop_2: DO J=1,NELX
        NEL_BEG=(J-1)*(3*NSDMAX+2)
        loop_21: DO K=1,INT_HP_CELL(NEL_BEG+1)
           IF (INT_HP_CELL(NEL_BEG+K*3).NE.I) cycle loop_21
           KCON(I)=1
           loop_3: DO L=1,INT_HP_CELL(NEL_BEG+1)
              LM=INT_HP_CELL(NEL_BEG+L*3)
              JDIF=I-LM
              IF (JDIF.GT.JMAX(I)) JMAX(I)=JDIF
           enddo loop_3
        enddo loop_21
     enddo loop_2
  enddo loop_1
  JDIAG(1)=1
  loop_5: DO I=2,NEQ1
     JDIAG(I)=JDIAG(I-1)+JMAX(I)+1
  enddo loop_5
  IF (JDIAG(NEQ1).GT.NMAX) THEN
     IF(MYMPI.EQ.0) THEN
        WRITE (21,*) 'DIMENSION OF STIFFNESS MATRIX TOO SMALL'
     ENDIF
     STOP
  ENDIF

  DEALLOCATE(JMAX,KCON)

  RETURN
END SUBROUTINE PRESKY

!************************************************************  
! Read the initial beta parameters(Polynomial+Reciprocal) in 
! the matrix and inclusion phase of the element.
SUBROUTINE BETASET(NELX,NODE,NINT,NBETA,LR)
!************************************************************  

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  DIMENSION NODE(NLM),NINT(NLM,2),NBETA(NLM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /INCBETA/  NBETA_INC(NLM),NBETA_DIF(NLM)
  DIMENSION BETA10(NLM,100),NUM_VERT10(NLM)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  IF(MYMPI.EQ.0) THEN
     READ (LR,*) NTERM
     loop_141: DO I=1,NELX
        READ (LR,*) NCYLFLAG(I,1),IRECTRM(I,1),KORD(I,1)
        READ (LR,*) NCYLFLAG(I,2),IRECTRM(I,2),KORD(I,2)
        READ (LR,*) NCYLFLAG(I,3),IRECTRM(I,3),KORD(I,3)
        NFAC=0
        NTRMADD(I,1)=(((KORD(I,1)+1)*(KORD(I,1)+2)-NFAC)*IRECTRM(I,1))&
             /2
        NTRMADD(I,2)=(((KORD(I,2)+1)*(KORD(I,2)+2)-NFAC)*IRECTRM(I,2))&
             /2
        NTRMADD(I,3)=(((KORD(I,3)+1)*(KORD(I,3)+2)-NFAC)*IRECTRM(I,2)*&
             IRECTRM(I,3))/2
     enddo loop_141
     READ (LR,*) IBETA
  ENDIF

  call mpi_bcast(NTERM,1,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(NCYLFLAG,(NLM*3),mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(IRECTRM,(NLM*3),mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(KORD,(NLM*3),mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(NTRMADD,(NLM*3),mpi_integer,0,mpi_comm_world,ierror)
  IF(MYMPI.EQ.0) THEN
     loop_1: DO I=1,NELX
        NB_ADP_MAT(I)=0
        NB_ADP_COM(I)=0
        IF (IBETA.EQ.0) THEN
           NMAX=NINT(I,1)
           IF (NODE(I).GT.NMAX) NMAX=NODE(I)
           IF (NMAX.LE.5) THEN
              NBETA(I)=7
           ELSEIF (NMAX.LE.7) THEN
              NBETA(I)=12
           ELSEIF (NMAX.LE.10) THEN
              NBETA(I)=18
           ELSEIF (NMAX.LE.14) THEN
              NBETA(I)=25
           ELSE
              IF(MYMPI.EQ.0) THEN
                 WRITE (21,*) 'STRESS POLY. IS QUINTIC &
                      OR HIGHER FOR ELE.',I
              ENDIF
              STOP
           ENDIF
        ELSE
           READ (LR,*) NBETA(I)

           NBETA_INC(I)=NINT(I,1)*2-3-num_vert10(I)*3
           IF(NBETA_INC(I).LE.25) THEN
              NBETA_INC(I)=25
           ELSEIF(NBETA_INC(I).LE.33) THEN
              NBETA_INC(I)=33
           ELSEIF(NBETA_INC(I).LE.42) THEN
              NBETA_INC(I)=42
           ELSEIF(NBETA_INC(I).LE.52) THEN
              NBETA_INC(I)=52
           ELSEIF(NBETA_INC(I).LE.63) THEN
              NBETA_INC(I)=63
           ELSEIF(NBETA_INC(I).LE.75) THEN
              NBETA_INC(I)=75
           ELSEIF(NBETA_INC(I).LE.88) THEN
              NBETA_INC(I)=88
           ELSE
              NBETA_INC(I)=88
           ENDIF
           NBETA_INC(I)=NBETA(I)
           NBETA_DIF(I)=NBETA(I)-NBETA_INC(I)
           NBETA(I)=NBETA(I)+NCYLFLAG(I,1)*NTRMADD(I,1)+NCYLFLAG(I,2)*&
                NTRMADD(I,2)

        ENDIF
     enddo loop_1
  ENDIF
  call mpi_bcast(NB_ADP_MAT,NELX,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(NB_ADP_COM,NELX,mpi_integer,0,mpi_comm_world,ierror)
  call mpi_bcast(NBETA,NELX,mpi_integer,0,mpi_comm_world,ierror)
  RETURN
END SUBROUTINE BETASET

!************************************************************  
! Initialize data structures for elements.
SUBROUTINE BOUNDCON(NODE,NINT,NBC1,IJK,IJK1,IJK2,&
     X,Y,VBC1,LR,ISOLVE)
!************************************************************  

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NDFM=NODM*2)
  DIMENSION IJK(NLM,NDELM/2),IJK1(NLM,NDELM/2),NINT(NLM,2),NODE(NLM),NBC1(1)
  DIMENSION X(NODM),Y(NODM),VBC1(1),IJK2(NLM,NDELM/2)

  INTEGER, ALLOCATABLE :: NDELNUM(:),NDELMP(:,:,:),NBDREPT(:,:),INC_CRCK(:)&
       ,NEL_ND(:),NEL_NUMND(:,:,:),ND1_BD(:),ND2_BD(:)

  COMMON /REPTPARAM/ IREPT_FLAG,KSTR1,KSTR2,IREPT(4),&
       JREPT(4),KD1_BD(NODM),KD2_BD(NODM),NEL_KD1(NODM,2),&
       NEL_KD2(NODM,2),EMAC(3)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON/BOUNDA/NBOUD1,LFOR,NBOUD3,NUPNCH
  COMMON/COMNOD/NODCOM(NLM,NDELM,4)
  COMMON/TVERGBOUND/ DCSL(20),DSNL(20),DCONT(20),ICONT(20),NREPT
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /MACSTN/ NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)
  COMMON /BOUNDCURVE/ ABD_CRV,BBD_CRV,ANBD_CRV,&
       XBD_CRV,YBD_CRV,IBD_CRV
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /HTOPCELL/ NUMH_SIDE_CELL,NUMELH_SIDE_CELL(NSMAX),&
       NELH_SIDE_CELL(NSMAX*2),NODEH_SIDE_CELL(NSMAX*2),&
       NCONH_SIDE_CELL(NSMAX*2)
  COMMON /HTRACCELL/ TRAC_TRCH_CELL(NSMAX*25),&
       INT_TRCH_CELL(NSMAX*3)
  COMMON /HPADAPTINC/ COORD_HP_INC(NLM*NSDMAX*3),INT_HP_INC&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_INC(NSMAX)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /ELEPROP/ PROMAT(16,10),MPE(NLM),MPG(NLM)
  COMMON/TVGPARAM/ RHOF_TVG(NDFM),IDOF_TVG(20),IFORCE_TVG(NDFM,2)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)

  ALLOCATE(NDELNUM(NODM),NDELMP(NODM,NDELM,2),NBDREPT(NODM,2),INC_CRCK(NDELM)&
       ,NEL_ND(NODM*2),NEL_NUMND(NODM*2,100,2),ND1_BD(NODM),ND2_BD(NODM))
  NDELNUM=0
  NDELMP=0
  NBDREPT=0
  INC_CRCK=0
  NEL_ND=0
  NEL_NUMND=0
  ND1_BD=0
  ND2_BD=0

  IF (ISOLVE.GT.-2) NBOUD1=0
  CONV_DEG_RAD=DATAN(1.D0)/4.5D1
  IF (ISOLVE.LT.0) THEN
     loop_101: DO I=1,NX_CELL
        NDGLB(I*2-1)=I*2-1
        NDGLB(I*2)=I*2
        NDELNUM(I)=0
     enddo loop_101
     loop_10069: DO I=1,3
        NDGLB(NX*2+NELX*6+I)=0
        ND_MAC(I)=NX_CELL*2+I
     enddo loop_10069
     loop_10070: DO I=NX_CELL+1,NX
        NDGLB(I*2-1)=I*2+2
        NDGLB(I*2)=I*2+3
        IDGLB(NDGLB(I*2-1))=I
        IDGLB(NDGLB(I*2))=I
        NDELNUM(I)=0
     enddo loop_10070
  ELSE
     loop_10071: DO I=1,NX
        NDELNUM(I)=0
     enddo loop_10071
  ENDIF
  loop_102: DO J=1,NELX
     loop_103: DO K=1,NODE(J)
        ND=IJK(J,K)
        NDELNUM(ND)=NDELNUM(ND)+1
        NDELMP(ND,NDELNUM(ND),1)=J
        NDELMP(ND,NDELNUM(ND),2)=K
     enddo loop_103
     NODCOM (J,NINT(J,1)+1,1)=0
     loop_104: DO K=1,NINT(J,1)
        ND=IJK1(J,K)
        NODCOM(J,K,1)=0
        loop_105: DO L=1,NODE(J)
           IF (ND.NE.IJK(J,L)) cycle loop_105
           NODCOM(J,NINT(J,1)+1,1)=NODCOM(J,NINT(J,1)+1,1)+1
           NODCOM(J,K,1)=1
           NODCOM(J,K,2)=L
           exit loop_105
        enddo loop_105
     enddo loop_104
     NODCOM (J,NINT(J,2)+1,3)=0
     loop_1004: DO K=1,NINT(J,2)
        ND=IJK2(J,K)
        NODCOM(J,K,3)=0
        loop_1005: DO L=1,NINT(J,1)
           IF (ND.NE.IJK1(J,L)) cycle loop_1005
           NODCOM(J,NINT(J,2)+1,3)=NODCOM(J,NINT(J,2)+1,3)+1
           NODCOM(J,K,3)=1
           NODCOM(J,K,4)=L
           exit loop_1005
        enddo loop_1005
     enddo loop_1004
  enddo loop_102
  KSTOP=0
  loop_10072: DO I=1,(NEQ1-3)/2
     IF (NDELNUM(I).EQ.0) THEN
        WRITE (*,*) 'UNCONNECTED NODE ',I
        KSTOP=1
     ENDIF
  enddo loop_10072
  IF (KSTOP.EQ.100) STOP
  I=1
  NDREPT=0
4 continue
  loop_2: DO J=1,NDELNUM(I)
     NEL=NDELMP(I,J,1)
     NPOS=NDELMP(I,J,2)
     K1=NPOS+1
     IF (NPOS.EQ.NODE(NEL)) K1=1
     KI1=IJK(NEL,K1)
     loop_3: DO L=1,NDELNUM(I)
        IF (J.NE.L) THEN
           NELL=NDELMP(I,L,1)
           LPOS=NDELMP(I,L,2)
           K2=LPOS-1
           IF (LPOS.EQ.1) K2=NODE(NELL)
           KI2=IJK(NELL,K2)
           IF (KI2.EQ.KI1) cycle loop_2
        ENDIF
     enddo loop_3
     NDREPT=NDREPT+1
     NBDREPT(NDREPT,1)=I
     NBDREPT(NDREPT,2)=KI1
     IF(MYMPI.EQ.0) THEN
        WRITE (21,*) NBDREPT(NDREPT,1),NBDREPT(NDREPT,2)
     ENDIF
     IF (NDREPT.EQ.1) NBEG=I
     I=KI1
     IF (I.EQ.NBEG) GOTO 5
     IF (NDREPT.GE.NX) THEN
        IF(MYMPI.EQ.0) THEN
           WRITE (21,*) 'TOO MANY NODES ON BOUNDARY'
        ENDIF
        STOP
     ENDIF
     GOTO 4
  enddo loop_2
  IF (NDREPT.NE.0) THEN
     IF(MYMPI.EQ.0) THEN
        WRITE (21,*) 'UNABLE TO FIND SECOND BND SEG FOR NODE:',I
     ENDIF
     STOP
  ENDIF
  I=I+1
  GOTO 4
5 IF (ISOLVE.LT.-1) GOTO 211
  IF (ISOLVE.NE.-1) THEN
     DEALLOCATE(NDELNUM,NDELMP,NBDREPT,INC_CRCK,NEL_ND,NEL_NUMND,ND1_BD,ND2_BD)
     RETURN
  ENDIF
  loop_10073: DO I=1,NDFM
     IFORCE_TVG(I,1)=0
  enddo loop_10073
  loop_10074: DO NEL=1,NELX
     IBD(NEL)=0
     loop_10075: DO J=1,NODE(NEL)
        IBD_ND(J,NEL)=0
     enddo loop_10075
  enddo loop_10074

  NBOUD_SLD=-1
  IBD_CRV=-1
  ABD_CRV=1.0
  BBD_CRV=1.0
  ANBD_CRV=0.0
  XBD_CRV=0.0
  YBD_CRV=0.0

  JMIN_BND=0
  loop_10079: DO I=1,NDREPT
     ND1=NBDREPT(I,1)
     JDIF=NX_CELL*2+1-MIN(NDGLB(ND1*2-1),NDGLB(ND1*2))
     IF (JDIF.GT.JMIN_BND) THEN
        JMIN_BND=JDIF
     ENDIF
     IF (NBOUD_SLD.GE.0) THEN
        NBOUD1=NBOUD1+1
        NBC1(NBOUD1*3-2)=ND1
        NBC1(NBOUD1*3-1)=1
        NBC1(NBOUD1*3)=1
        VBC1(NBOUD1*2-1)=0
        VBC1(NBOUD1*2)=0
     ENDIF
     ND2=NBDREPT(I,2)
     loop_10080: DO J=1,NDELNUM(ND1)
        NEL=NDELMP(ND1,J,1)
        NPOS=NDELMP(ND1,J,2)
        IBD(NEL)=1
        IBD_ND(NPOS,NEL)=1            
     enddo loop_10080
  enddo loop_10079
211 CONTINUE
  loop_10081: DO NEL=1,NELX
     IBEG=(NEL-1)*(NSDMAX*3+2)
     JBEG=(NEL-1)*NSDMAX*3
     IF (ISOLVE.EQ.-2) GOTO 212
     NTOT=NODE(NEL)*2+IBD(NEL)*3
     INT_HP_CELL(IBEG+1)=NTOT
     INT_HP_CELL(IBEG+2)=NODE(NEL)*2
     loop_10082: DO J=1,NODE(NEL) 
        ND=IJK(NEL,J)
        INT_HP_CELL(IBEG+J*6-3)=NDGLB(ND*2-1)
        IDGLB(NDGLB(ND*2-1))=ND
        INT_HP_CELL(IBEG+J*6-2)=IBD_ND(J,NEL)
        INT_HP_CELL(IBEG+J*6-1)=1
        COORD_HP_CELL(JBEG+J*6-5)=0.D0            
        COORD_HP_CELL(JBEG+J*6-4)=X(ND)
        COORD_HP_CELL(JBEG+J*6-3)=Y(ND)           
        INT_HP_CELL(IBEG+J*6)=NDGLB(ND*2)
        IDGLB(NDGLB(ND*2))=ND
        INT_HP_CELL(IBEG+J*6+1)=IBD_ND(J,NEL)
        INT_HP_CELL(IBEG+J*6+2)=2
        COORD_HP_CELL(JBEG+J*6-2)=90.D0            
        COORD_HP_CELL(JBEG+J*6-1)=X(ND)
        COORD_HP_CELL(JBEG+J*6)=Y(ND)           
     enddo loop_10082
     loop_10083: DO J=1,3*IBD(NEL)
        INT_HP_CELL(IBEG+NODE(NEL)*6+J*3)=NX_CELL*2+J
        IDGLB(NX_CELL*2+J)=0
        INT_HP_CELL(IBEG+NODE(NEL)*6+J*3+1)=2
        INT_HP_CELL(IBEG+NODE(NEL)*6+J*3+2)=3
     enddo loop_10083
212  CONTINUE
     IBEG=(NEL-1)*(NSDMAX*3+2)
     JBEG=(NEL-1)*NSDMAX*3
     NTOT=NINT(NEL,1)*2
     INT_HP_INC(IBEG+1)=NTOT
     INT_HP_INC(IBEG+2)=NTOT
     loop_10084: DO J=1,NINT(NEL,1) 
        ND=IJK1(NEL,J)
        INT_HP_INC(IBEG+J*6-3)=NDGLB(ND*2-1)
        IDGLB(NDGLB(ND*2-1))=ND
        IF (NODCOM(NEL,J,1).EQ.1) THEN               
           INT_HP_INC(IBEG+J*6-2)=IBD_ND(NODCOM(NEL,J,2),NEL)
        ELSE
           INT_HP_INC(IBEG+J*6-2)=0
        ENDIF
        INT_HP_INC(IBEG+J*6-1)=1
        COORD_HP_INC(JBEG+J*6-5)=0.D0            
        COORD_HP_INC(JBEG+J*6-4)=X(ND)
        COORD_HP_INC(JBEG+J*6-3)=Y(ND)     
        INT_HP_INC(IBEG+J*6)=NDGLB(ND*2)      
        IF (NODCOM(NEL,J,1).EQ.1) THEN               
           INT_HP_INC(IBEG+J*6+1)=IBD_ND(NODCOM(NEL,J,2),NEL)
        ELSE
           INT_HP_INC(IBEG+J*6+1)=0
        ENDIF
        IDGLB(NDGLB(ND*2))=ND
        INT_HP_INC(IBEG+J*6+2)=2
        COORD_HP_INC(JBEG+J*6-2)=90.D0            
        COORD_HP_INC(JBEG+J*6-1)=X(ND)
        COORD_HP_INC(JBEG+J*6)=Y(ND)           
     enddo loop_10084
     ANGLE=ANM(NEL)*CONV_DEG_RAD
     CS6=DCOS(ANGLE)
     SN6=DSIN(ANGLE)
     XSC_2=XSCALEM(NEL)*XSCALEM(NEL)
     YSC_2=YSCALEM(NEL)*YSCALEM(NEL)
     loop_10085: DO J=1,NINT(NEL,2)
        INC_CRCK(J)=0
     enddo loop_10085
     loop_10086: DO J=1,NINT(NEL,2)
        IF (NODCOM(NEL,J,3).EQ.1) THEN
           INC_CRCK(NODCOM(NEL,J,4))=1
        ENDIF
     enddo loop_10086
     loop_10087: DO J=1,NINT(NEL,1)
        J1=J+1-(J/NINT(NEL,1))*NINT(NEL,1)
        IF (NODCOM(NEL,J,1).EQ.0.OR.NODCOM(NEL,J1,1).EQ.0) THEN
           ND1=IJK1(NEL,J)
           ND2=IJK1(NEL,J1)
           XMD=(X(ND1)+X(ND2))*0.5D0
           YMD=(Y(ND1)+Y(ND2))*0.5D0
           IF (MCRACK(NEL).EQ.1) THEN
              XMD=XMD-XCENTP(NEL)
              YMD=YMD-YCENTP(NEL)
              XMD1=XMD*CS6+YMD*SN6
              YMD1=YMD*CS6-XMD*SN6
              ANG=DATAN2(YMD1,XMD1)
              CSL=DCOS(ANG)
              SNL=DSIN(ANG)
              RF=CSL*CSL/XSC_2+SNL*SNL/YSC_2
              RF=1.D0/DSQRT(RF)
              XMD1=RF*CSL
              YMD1=RF*SNL
              XMD=XMD1*CS6-YMD1*SN6+XCENTP(NEL)
              YMD=YMD1*CS6+XMD1*SN6+YCENTP(NEL)
           ENDIF
        ENDIF
     enddo loop_10087
  enddo loop_10081
  loop_10148: DO ND=1,NX*2
     NEL_ND(ND)=0
  enddo loop_10148
  loop_10149: DO NEL=1,NELX
     NEL_BEG=(NEL-1)*(3*NSDMAX+2)
     loop_10150: DO J=1,INT_HP_CELL(NEL_BEG+2)
        ND=INT_HP_CELL(NEL_BEG+J*3)
        NEL_ND(ND)=NEL_ND(ND)+1
        NEL_NUMND(ND,NEL_ND(ND),1)=NEL
        NEL_NUMND(ND,NEL_ND(ND),2)=J
     enddo loop_10150
  enddo loop_10149
  DEALLOCATE(NDELNUM,NDELMP,NBDREPT,INC_CRCK,NEL_ND,NEL_NUMND,ND1_BD,ND2_BD)
  RETURN
END SUBROUTINE BOUNDCON

!************************************************************  
SUBROUTINE NODFIX(NBOUD1,NBC1,VBC1,NODE,IJK)
!************************************************************  

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)

  DIMENSION NBC1(1),NODE(NLM),IJK(NLM,NDELM/2),VBC1(1)
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /FSTBND/ IFST(NLM,NODPER+1,2),VFST(NLM,NODPER+1,2)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL   
  loop_1: DO I=1,NELX
     NEL_BEG=(I-1)*(3*NSDMAX+2)
     NDF_EL=INT_HP_CELL(NEL_BEG+1)
     IFST(I,NDF_EL+1,1)=0
     loop_10165: DO J=1,INT_HP_CELL(NEL_BEG+1)
        IFST(I,J,1)=0
        IFST(I,J,2)=0
        ND=INT_HP_CELL(NEL_BEG+J*3)
        loop_2: DO K=1,NBOUD1
           IF (NBC1(K*3-1).EQ.1) THEN
              IF(NBC1(K*3-2).LE.NX_CELL) THEN
                 NDD=(NBC1(K*3-2)*2-1)
              ELSE
                 NDD=NBC1(K*3-2)*2
              ENDIF
              IF (NDD.EQ.ND) THEN
                 IFST(I,NDF_EL+1,1)=1
                 IFST(I,J,1)=1
                 VFST(I,J,1)=VBC1(K*2-1)
              ENDIF
           ENDIF
           IF (NBC1(K*3).EQ.1) THEN
              IF(NBC1(K*3-2).LE.NX_CELL) THEN
                 NDD=(NBC1(K*3-2)*2)
              ELSE
                 NDD=NBC1(K*3-2)*2+1
              ENDIF
              IF (NDD.EQ.ND) THEN
                 IFST(I,NDF_EL+1,1)=1
                 IFST(I,J,1)=1
                 VFST(I,J,1)=VBC1(K*2)
              ENDIF
           ENDIF
        enddo loop_2
     enddo loop_10165
  enddo loop_1
  RETURN
END SUBROUTINE NODFIX

!****************************************************************************
SUBROUTINE LAGRANGE()
!****************************************************************************
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NMAX_POLY=25,NM_PL=NMAX_POLY-1) 
  COMMON /LAGRPOLY/ PRD((NMAX_POLY*(NMAX_POLY+1))/2),&
       IPRD(NM_PL)
  ISTART=1
  loop_10246: DO I=1,NM_PL
     IPRD(I)=ISTART
     FACT=2.D0/DFLOAT(I)
     loop_10247: DO J=1,I+1
        S=-1.D0+FACT*(J-1)
        PRD(ISTART+J-1)=1.D0
        loop_10248: DO K=1,I+1
           IF (J.NE.K) THEN
              PRD(ISTART+J-1)=PRD(ISTART+J-1)*(S+1.D0-FACT*(K-1))
           ENDIF
        enddo loop_10248
        PRD(ISTART+J-1)=1.D0/PRD(ISTART+J-1)
     enddo loop_10247
     ISTART=ISTART+I+1
  enddo loop_10246
  RETURN
END SUBROUTINE LAGRANGE


SUBROUTINE QSINT(DU,DU1,DELTME,IJK,IJK1,IJK2,NINT,NODE,NBETA,&
     JDIAG,NBC1,NLOAD,VBC1,VLOAD,X,Y,SK,F,ITEREF,IZEROUPDAT)
  !     234567891123456789212345678931234567894123456789512345678961234567897
  !------------------------------------------------------------------------------
  !     
  !     PURPOSE:
  !     
  !     THIS SUBROUTINE INTRODUCES THE QUASI-NEWTON METHODS
  !     FOR SOLUTION OF THE EQUILIBRIUM EQUATIONS.
  !     
  !--------------------------------------------------------------------------------
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)

  INCLUDE 'mpif.h'

  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NLM_SOFT=40000)
  !     PURPOSE:
  !     
  !     TT    = EQUILIBRIUM ITERATION NUMBER
  !     NSTP1 = CYCLE NUMBER
  !     ITE   = EQUILIBRIUM ITERATION NUMBER
  !     NUMUPD= NUMBER OF STIFFNESS UPDATES (K(I))
  !     NUMRHS= NUMBER OF RIGHT HAND SIDE EVALUATIONS
  !     ITEREF= STIFFNESS MATRIX REFORMATIONS
  !     STEP  =   STEP SIZE FROM LINE SEARCH
  !     GC    = INITIAL ENERGY NORM
  !     GO    = CURRENT ENERGY NORM
  !     UNM   = DISPLACEMENT NORM
  !     TOL   = REQUIRED TOLERANCE ON DISPLACEMENT
  !     ITR   = TOTAL NUMBER OF ITERATIONS TO CONVERGE
  !     IEQUIT=NUMBER OF TIME STEPS BETWEEN EQUILIBRIUM ITRNS.
  !     ILIMIT=MAX. NO EQ. ITERNS. BET. STIFFNESS REFORMATIONS.
  !     MAXREF=MAX NO STIFFNESS REFORMATIONS BETWEEN TIME STEPS
  !     UVTOL  = CONVERGENCE TOLERANCE ON DISPLACEMENT
  !     ECTL  =CONVERGENCE TOLERANCE ON ENERGY.
  !     NIT   =0 CONSTRUCT STIFFNESS FOR FIRST ITERATION
  !     =1 REFORMATION OF THE STIFFNESS MATRIX
  !     =2 LOAD VECTOR CONSTRUCTION FOR SUBSEQUENT ITRNS.
  !--------------------------------------------------------------------------
  !     
  !     23456789112345678921234567893123456789412345678951234567896123456789712      
  DIMENSION DU1(1),DU(NDFM),IJK(NLM,1),NINT(NLM,2),NODE(1),&
       NBETA(1),IJK1(NLM,1),IJK2(NLM,1)
  DIMENSION JDIAG(1),SK(1),F(NDFM),X(1),Y(1)
  DIMENSION NBC1(1),NLOAD(1),VBC1(1),VLOAD(2,1) 
  DIMENSION FOLD(NDFM)
  DIMENSION SKCLM(1),FF(1),H(1),T(1),T1(1),T2(1),T3(1),COORD(1),&
       DUTOT(1),BETA(1),DD(10),IDOSOFT(1)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /GEOM/ XMTRL(NDFM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON/BOUNDA/NBOUD1,NBOUD2,NBOUD3,NUPNCH
  COMMON/MIDSTP/ALPHA
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /BETAGL/ BETTOT(MAXH*NLM),BETST(MAXH*NLM),&
       BETLC(MAXH*NLM)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /LIMITITER/ ILIMIT
  COMMON /QSITER/ NIT
  COMMON /PLLC/ NPLCM(NLM*INTM),NPLCC(NLM*INTC)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /PLPCOM/ VMCOM(NLM*INTC),EPLSCOM(NLM*INTC)&
       ,DEPLSCOM(NLM*INTC),NPLCOM(NLM*INTC)
  COMMON /FRHSN/ FIN(NDFM)
  COMMON /INSTT/ NPLINM(NLM*INTM),NPLINC(NLM*INTC)
  COMMON /CONVG1/ ICON1
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /IDAMSTEP/ STRMAC_EL(10,NLM),STRCOM_EL(10,NLM),IDAM_NOW
  COMMON /ITRFILES/ ITRFIL1,ITRFIL2,FLAG11,FLAG12,FLAG21,FLAG22
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /ELASFLAG/ IELASTIC
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /GCREF/ GCINIT
  COMMON /DFREF/ DFDIN
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),&
       INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /NELSID/ NELS_IN_NEL(NLM_SOFT)
  COMMON /DISPSHIFT/ ISOFTEL(NLM)
  common /plsintsubst/ ksubst
  DATA IEQUIT,ILIMIT,MAXREF/1,8,10/ 
  CHARACTER*20 FLAG11,FLAG12,FLAG21,FLAG22
  COMMON /ARCLPARAM/ ALPH,DALPH,DUTEMPARC(NDFM),DUARC(NDFM),DUIN(NDFM),DUIN1(NDFM),DLTOT,IARCL
  COMMON /DEADLOAD/ IDEAD,GCBEF,SQBEF
  COMMON /WLTBASEC/ DPOSW(NLM*NBM,2),NPBG_WLT(NLM),SSIGXG(NLM*NBM),SSIGYG(NLM*NBM),IWORP(NLM),IBET_WLTC(NBM,NLM)
  COMMON /WLTBASEM/ DPOSWM(NLM*NBM,2),NPBG_WLTM(NLM),SSIGXGM(NLM*NBM),SSIGYGM(NLM*NBM),IBET_WLTM(NBM,NLM)
  COMMON /DISPNEL/ NELDISP_IN_NEL(NLM), NO_NELDISP(NLM_SOFT,NLM)
  COMMON /DECOMP/ IPARALLEL
  COMMON /INCBETA/  NBETA_INC(NLM),NBETA_DIF(NLM)
  COMMON /SOFTNEQ/  NEQ_SOFT
  COMMON /TITLENAME/ title,title1
  COMMON /MACDROP/ EQV_S,EQV_E,EQVMAC,NUMDROP,IMACDROP
  COMMON /STEPCONTROL/ DF_MAX,DF_CRT,ALPH_NOW,DFMAX_STEP(3)
  COMMON /FRESMAX/ FRES_MAX
  CHARACTER*60 title,title1
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  G=0.D0
  SQTOL=0.D0
  SQQ=0.D0
  DINORM=0.D0
  UNM=0.D0
  DFAVG=0.D0
  DFMAX=0.D0
  G_OLD=1.D0
  IDO=0
  ILIMIT=0
  UVTOL=1.E-2
  IDIV=0
  LW=20
  IF(MYMPI.EQ.0) WRITE (LW,920)
920 FORMAT(' ENTERING ITERATION ')
  IF(MYMPI.EQ.0) WRITE(LW,600) 
600 FORMAT(/////,80('-'),/) 
  ECTL=1.E-2
  IF(IMACDROP.EQ.1.OR.IDEAD.EQ.1) THEN
     ECTL=5.E-2
     UVTOL=0.05D0
  ENDIF
  ITE=0
  ITR=0
  ITEREF=0
  NUMUPD=0
  NUMRHS=0 
  Q1=0.E0
  Q2=0.E0
  Q=0.E0
  UVTOL=UVTOL*UVTOL
  NIT=0
  !     ******(SOLVE THE INCREMENTAL EQUATION AT MIDSTEP)******
  !     
  STEP=1.E0
  CALL ASMRHS(0,DU,DU1,DELTME,IJK,IJK1,IJK2,NINT,NODE,NBETA,&
       X,Y,SK,F,JDIAG,NBC1,NLOAD,VBC1,VLOAD,STEP,G0)
  IF(DABS(G0).GT.1.D+2) goto 900
  loop_52: DO I=1,NELX
     IND=NDIV(I)
     loop_53: DO J=1,NINTM(I)
        NPLCM(NPBG(I)+J)=NPLINM(NPBG(I)+J)
     enddo loop_53
     loop_54: DO J=1,NINTC(I)
        NPLCOM(NPBM(I)+J)=NPLCC(NPBM(I)+J)
     enddo loop_54
     NBAD=NB_ADP_COM(I)+NB_ADP_MAT(I)
     NBTOT=2*NBETA(I)+NBAD-NCYLFLAG(I,1)*NTRMADD(I,1)
     loop_58: DO J=1,NBTOT
        BETST(J+(I-1)*2*NBM)=BETLC(J+(I-1)*2*NBM)
        BETLC(J+(I-1)*2*NBM)=0.E0
     enddo loop_58
  enddo loop_52
  !     
  !     **(FIRST ENERGY NORM & LOAD NORM)****
  !     
  RHSN=DD(1)+DOTPRD(F,F,NBC1) 
  GC=G0
  IF (ksubst.eq.0) then
     g0=gc*1.d2
     GOTO 900
  endif
  GC=DMAX1(GCINIT,DABS(G0))
  gc=DD(1)+dotprd1(xmtrl,du1,neq2)
  NOEQ=NEQ
  CALL EXCHN(XMTRL,FOLD,NEQ2)
  DMDL=DD(1)+DOTPRD(DU,DU,NBC1)
  DUMAX=DD(2)
  DO I=1,NEQ1
     IF(DUMAX.LT.DABS(DU(I))) DUMAX=DABS(DU(I))
  ENDDO
  DMOD1=DD(1)+DOTPRD(DU1,DU1,NBC1)
  DO I=1,NEQ1
     DD(1)=DD(1)+DU1(I)*DU1(I)
  ENDDO
  DU1AVG=dsqrt(DD(1)/(DD(2)+NEQ1))
  DFDL1=DOTPRD(FIN,FIN,NBC1)
  DFDIN=DFDL1
  DFDL=DOTPRD(F,F,NBC1)
  TOL=UVTOL*DMAX1(DMDL,DMOD1)
  IF(MYMPI.EQ.0) THEN
     WRITE(20,870)DMDL,DMOD1,TOL
  ENDIF
870 FORMAT(/'MODULUS OF DU,DU1&TOL',3(D20.6))

  IF(MYMPI.EQ.0) THEN
     WRITE (20,*) 'G=',G,'G0=',G0,'GC=',GC,'STEP=',STEP
     WRITE (20,*) 'SQQ=',SQQ,'DINORM=',DINORM,'SQTOL=',SQTOL
     WRITE (20,*) 'ITEREF = ',ITEREF,' G0/GC= ',G0/GC,' ECTL= ',ECTL
     WRITE (*,*) 'ITEREF = ',ITEREF,' G0/GC= ',G0/GC,' ECTL= ',ECTL
     WRITE (*,*) 'G=',G,'G0=',G0,'GC=',GC,'STEP=',STEP
     WRITE (*,*) 'DINORM=',DINORM,'SQTOL=',SQTOL
     WRITE (*,*) 'DUMAX=',DUMAX,'DU1AVG=',DU1AVG
     WRITE (*,*) 'DFMAX=',DFMAX,'DFAVG=',DFAVG
     WRITE (*,*) 'FRES_MAX=',FRES_MAX
  ENDIF
  ICON1=1
  GCBEF=GC
  SQBEF=SQTOL
  IF(MYMPI.EQ.0) THEN
     WRITE(20,130) ITR,ITEREF,GC
     WRITE(20,131) G0,UNM,TOL
  ENDIF
900 IF(MYMPI.EQ.0) THEN
     REWIND (20)
     CLOSE (20)
  ENDIF
  IF (ITRFIL1.EQ.0) THEN 
     ITRFIL1=1
     IF(MYMPI.EQ.0) THEN
        OPEN (20,FILE=FLAG21)
     ENDIF
  ELSE
     ITRFIL1=0
     IF(MYMPI.EQ.0) THEN
        OPEN (20,FILE=FLAG11)
     ENDIF
  ENDIF
  RETURN
130 FORMAT(///'NUMBER OF ITRNS',I5,2X,'NUMBER OF',&
       'STIFFNESS REFMS',I5,2X,'INITIAL ENERGY NORM',&
       2X,D20.6)
131 FORMAT(///'CURRENT ENERGY NORM',2X,D20.6,&
       'DISPLACEMENT NORM',D20.6,2X,'DISPLACEMENT&
       TOLERANCE',D20.6)
140 FORMAT(///'ITERATION LIMIT REACHED')
150 FORMAT(//'STIFFNESS MATRIX WILL NOW BE REFORMED')
160 FORMAT(///'RESIDUAL LOAD VECTOR LARGER THAN INCREMENTAL&
       LOADS AFTER ITERATION NO',I5)
END SUBROUTINE QSINT

!     
!------------------------------------------------------------------------------
!     
!     
SUBROUTINE ASMRHS(NIT,DU,DU1,DELTME,IJK,IJK1,IJK2,NINT,NODE,NBETA,&
     X,Y,SK,F,JDIAG,NBC1,NLOAD,VBC1,VLOAD,STEP,G)
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  include 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NLM_SOFT=40000)
  !     
  !     
  !-------------------------------------------------------------------------------
  !     
  !     PURPOSE:
  !     THIS SUBROUTINE ASSEMBLES THE RIGHT HAND SIDE(LOAD VECTOR)
  !     DURING THE ITERATION PROCESS.
  !     
  !-------------------------------------------------------------------------------
  !     ARGUMENT:
  !     GXMID=GRID COORDINATES AT MID STEP
  !     XMTRL=MATERIAL COORDINATES
  !     DU   =INCREMENTAL MATERIAL POINT DISPLACEMENT
  !     DELXG=INCREMENTAL GRID DISPLACEMENT
  !     NIT  =0 .WHEN FIRST EVALUATION IN ITERATION
  !     =1 STIFFNESS REFORMATION
  !     =2  WHEN NEXT ITERATIONS
  !     LAG(NODE)=1 IF NODE IS LAGRANGIAN
  !     =0 IF NODE IS ALE
  !     =7 ELLIPTIC MESH GENERATION PTS
  !     XUND=THE COORDINATE IN THE UNDEFORMED COORDINATE
  !     OF THE NODE AT THE PREVIOUS CONFIGURATION
  !     XUND1=COORDINATE IN THE UNDEFORMED CONFIGURATION
  !     OF THE MATRL PT AT GRID COORD. GXMID 
  !     DELTME=CURRENT TIME INCREMENT
  !     G     = ENERGY NORM AT CURRENT ITERATION
  !     RO    = DENSITY
  !     SKU   = UPPER STIFFNESS MATRIX
  !     SKL   = LOWER STIFFNESS MATRIX
  !     F     = LOAD VECTOR
  !     DELST  = ELASTICITY MATRIX FOR MAT GROUPS.
  !     BFV   = BODY FORCE.
  !     G0XYZ = UNDEFORMED COORDINATES  T=T(0)
  !     NPLANE=1 IF UNDEFORMED SHEET IS PLANE .
  !     
  !---------------------------------------------------------------------------
  DIMENSION DU(1),DU1(1),X(1),Y(1),SK(1)&
       ,F(1),IJK1(NLM,1),IJK2(NLM,1)
  DIMENSION DD(1),SKCLM(1),FF(1),H(1),T(1),T1(1),T2(1),T3(1),&
       COORD(1),DUTOT(1),BETA(1),IDOSOFT(1)
  DIMENSION NBC1(1),NLOAD(1),VBC1(1),VLOAD(2,1)
  DIMENSION IJK(NLM,1),NINT(NLM,2),JDIAG(1),NODE(1),NBETA(1)

  CHARACTER :: matdescra(3)
  DIMENSION XINT(NEQ1),YOUT(NEQ1)


  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /GEOM/ XMTRL(NDFM)
  COMMON/BOUNDA/NBOUD1,NBOUD2,NBOUD3,NUPNCH
  COMMON/MIDSTP/ALPHA
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),&
       INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /NELSID/ NELS_IN_NEL(NLM_SOFT)
  COMMON /DISPSHIFT/ ISOFTEL(NLM)
  COMMON /ARCLPARAM/ ALPH,DALPH,DUTEMPARC(NDFM),DUARC(NDFM),DUIN(NDFM),DUIN1(NDFM),DLTOT,IARCL
  COMMON /FINDOT/ DOTIN,DOTIN1

  COMMON /DISPNEL/ NELDISP_IN_NEL(NLM), NO_NELDISP(NLM_SOFT,NLM)
  COMMON /DECOMP/ IPARALLEL

  COMMON /TITLENAME/ title,title1
  CHARACTER*60 title,title1

  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)

701 FORMAT(' ENTERING ASMRHS ')
  ALPH0=1.D0
  LW=6
  NOEQ=NEQ
  DOTIN=ALPH*ALPH-DLTOT
  IF (IARCL.EQ.1) THEN
     loop_10004: DO I=1,NEQ2
        DOTIN=DOTIN+DU1(I)*DU1(I)
        DUIN1(I)=DU1(I)
     enddo loop_10004
  ENDIF
  NOEQ=NEQ
  CALL ASMBLYMPI(NIT,SK,F,DU1,NBETA,NODE,NBC1,NLOAD,&
       IJK,IJK1,IJK2,NINT,VBC1,VLOAD,X,Y,NDF,JDIAG)
  XINT(1:NEQ1)=F(1:NEQ1)
  CALL SKYLIN(SK,F,JDIAG,NEQ1,0)
  CALL FORCE_TVGBOUND(SK,F,JDIAG,NIT)
  CALL INTEXT (NODE,NINT,IJK,IJK1,IJK2,F,F)
  IF (IARCL.EQ.1) THEN
     CALL SKYLIN(SK,DUARC,JDIAG,NEQ1,2)
     CALL FORCE_TVGBOUND(SK,DUARC,JDIAG,2)
     CALL INTEXT (NODE,NINT,IJK,IJK1,IJK2,DUARC,DUARC)
  ENDIF
  CALL EXCHN(F,DU,NEQ2)
  CALL EXCHN(XMTRL,F,NEQ2)
  RETURN
END SUBROUTINE ASMRHS

SUBROUTINE QSINT1(NEL,NITT,DU6,DU1,IJK,NUMNOD,NUMNOD1,NUMNOD2,&
     NB,MP1,MP2,X,Y,H)
  !     
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)

  INCLUDE 'mpif.h'

  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  DIMENSION DU1(1),DU6(1),DU(MAXH),IJK(NLM,1),JDIAG(NBM),&
       BETOPT(NBM)
  DIMENSION H(1),F(MAXH),X(1),Y(1)
  DIMENSION FOLD(1000)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /GEOM1/ XMTRL(NDFM)
  COMMON /CONVCHK/ ICON
  COMMON /ITERWRITE/ NLIN_WRITE,CHAR_WRITE(1000)
  COMMON /IWRITE/ IWRT
  COMMON /SOFTPOINTER/ INEW_SOFT,ISOFT_TOT,IEL_SOFT(NLM)
  COMMON /ARCLENGTH/ ARC_IN(NBM),F1(NBM),ALPHA,JSOFT
  COMMON /HCONDITION/ IHCON
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /STEPNUM/ IST
  COMMON /IQSINT1/  STRTMAX,STMAX,ISTRTMAX
  CHARACTER*70 CHAR_WRITE
  CHARACTER*9 CHAR_FORM
  DATA IEQUIT,ILIMIT,MAXREF/1,8,10/ 
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  ILIMIT=0
  IVPL_OLD=IVPL
  IDEB=0
  I_CON=0
  DU_LIMIT=2000
  LW=21
920 FORMAT(' ENTERING ITERATION ')
600 FORMAT(/////,80('-'),/) 
  CALL EXCHN(DU1,ARC_IN,NB)
  DU1(NB+1)=1.D0
  DU6(NB+1)=0.D0
  UVTOL=1.E-2
  ECTL=1.E-3
  ITE=0
  ITR=0
  ITEREF=0
  NUMUPD=0
  NUMRHS=0 
  UNM=0.D0
  Q1=0.E0
  Q2=0.E0
  Q=0.E0
  UVTOL=UVTOL*UVTOL
  KFL=0
  IF (NUMNOD1.NE.0) KFL=1
  NEQ=NB+KFL*NB
  loop_821: DO I=1,NEQ
     JDIAG(I)=(I*(I+1))/2
  enddo loop_821
  !     
  !     ******(SOLVE THE INCREMENTAL EQUATION AT MIDSTEP)******
  !     
  STEP=1.E0
  IF (JSOFT.EQ.1) THEN
     JSOFT=0
     KSOFT=1
  ENDIF
  !     
  !     **(FIRST ENERGY NORM & LOAD NORM)****
  !     
  IF(STRTMAX.GT.100.0.AND.IDEB.EQ.0) THEN
     goto 900
     IDEB=1
     IVPL=0
     IF(MYMPI.EQ.0) write(*,*) "STRTMAX= ",STRTMAX 
     STRTMAX=0.D0
  ENDIF
  CALL ASMRHS1(NEL,NITT,0,DU,DU6,DU1,IJK,JDIAG,NUMNOD,&
       NUMNOD1,NUMNOD2,NB,MP1,MP2,X,Y,H,F,STEP,G0)
  RHSN=DOTPRD1(DU6,DU6,NEQ+1) 
  RHSNI=RHSN
  GC=G0
  Q1=1.D0
  NOEQ=NEQ
  CALL EXCHN(F,FOLD,NOEQ+1)
  DMDL=DOTPRD1(DU,DU,NEQ+JSOFT)
  DMOD1=DOTPRD1(DU1,DU1,NEQ+JSOFT)
  TOL=UVTOL*DMAX1(DMDL,DMOD1)
  IF(MYMPI.EQ.0) THEN
     WRITE(21,870)DMDL,DMOD1,TOL
  ENDIF
870 FORMAT(/'MODULUS OF DU,DU1&TOL',3(D20.6))
  !     ****(START ITERATION)****
  !     
30 ITE=ITE+1
  ITR=ITR+1
  STEP=1.E0

  CALL ASMRHS1(NEL,NITT,2,DU,DU6,DU1,IJK,JDIAG,NUMNOD,&
       NUMNOD1,NUMNOD2,NB,MP1,MP2,X,Y,H,F,STEP,G)
  IF (ABS(G).LT.1.E-14.AND.ABS(G0).LT.1.E-14) GO TO 110
  IF(ABS(G).LE.(0.90*ABS(G0))) GO TO 40

  IF(STRTMAX.GT.100.0.AND.IDEB.EQ.0) THEN
     goto 900
     IDEB=1
     IF(MYMPI.EQ.0) write(*,*) "STRTMAX= ",STRTMAX 
     STRTMAX=0.D0
  ENDIF
  CALL LINSCH1(NEL,NITT,2,DU,DU6,DU1,IJK,JDIAG,&
       NUMNOD,NUMNOD1,NUMNOD2,NB,MP1,MP2,X,Y,H,F,G,G0,STEP)
  IF(STRTMAX.LT.100.0) THEN
     IDEB=0
     IVPL=IVPL_OLD
  ENDIF
  IF(MYMPI.EQ.0) THEN
     WRITE(21,789)STEP,ITR,TOL
  ENDIF
  IF(STEP.LT.0.001E0.AND.ITE.GT.1) ITE=ILIMIT+1
40 continue
  loop_50: DO I=1,NEQ+JSOFT
     DU1(I)=DU1(I)+STEP*DU(I)
  enddo loop_50
  ALPHA=DU1(NB+1)
  IF (IEL_SOFT(NEL).EQ.0) THEN
     UNM=DOTPRD1(DU,DU,NEQ+JSOFT)
     UNM=UNM*STEP*STEP     
  ELSE
     UNM=DOTPRD1(F,F,NEQ+JSOFT)
  ENDIF
  Q2=Q1
  Q1=0.E0
  IF(ITR.NE.1.AND.OLUNM.NE.0.)Q1=UNM/OLUNM 
  Q=AMAX1(Q1,Q2) 
  OLUNM=UNM
  RHSVN=DOTPRD1(F,F,NEQ+1)
  DINORM=SQRT(UNM)
  IF(RHSVN.LE.RHSN) GO TO 70
69 IF(MYMPI.EQ.0) THEN
     WRITE(21,160) ITE
  ENDIF
  RHSN=RHSVN
60 ITEREF=ITEREF+1
  IF(ITEREF.GT.MAXREF*2/3) THEN
     ECTL=1.E-2
     UVTOL=1.E-1
  ENDIF
  IF(ITEREF.GT.MAXREF)GO TO 900
  IF(MYMPI.EQ.0) THEN
     WRITE(21,150)
  ENDIF
31 ITE=0
  NUMUPD=0
  CALL ASMRHS1(NEL,NITT,0,DU,DU6,DU1,IJK,JDIAG,NUMNOD,&
       NUMNOD1,NUMNOD2,NB,MP1,MP2,X,Y,H,F,STEP,G0)
  IF(STRTMAX.GT.100.0) THEN
     IDEB=0
     IVPL=IVPL_OLD
  ENDIF

  NOEQ=NEQ
  CALL EXCHN(F,FOLD,NOEQ+1)
  DMDL=DOTPRD1(DU,DU,NEQ+JSOFT)
  DMOD1=DOTPRD1(DU1,DU1,NEQ+JSOFT)
  TOL=UVTOL*DMAX1(DMDL,DMOD1)
  GO TO 30
  !     
70 CONTINUE
  IF (DABS(G0).GT.1.D+05) GOTO 900
  SQQ=SQRT(Q)
  IF(ILIMIT.EQ.0) THEN
     SQQ=DMIN1(0.5D0,SQQ)
  ENDIF
  SQTOL=SQRT(TOL)
  IF (RHSVN.LT.1.D-05*RHSNI) GOTO 110
  IF (RHSVN.LT.1.D-02*RHSNI.AND.DABS(G0).LT.1.D-03*DABS(DOTPRD1(DU6,DU1,NEQ+1))) GOTO 110
  if(DABS(DINORM).LT.1.D-20) GOTO 110
  IF((SQQ*DINORM).GT.((1.E0-SQQ)*SQTOL)) GO TO 80
  IF(ABS(G0).GT.ECTL*ABS(GC)) GO TO 80
  GO TO 110
80 IF(ITE.LE.ILIMIT) GO TO 90
  IF(MYMPI.EQ.0) THEN
     WRITE(20,140)
  ENDIF
  GO TO 60

90 if(STEP.EQ.0) THEN
     STEP=1.E-16
     IF(MYMPI.EQ.0) write(*,*) "Reset Step for BROY1  nel=",nel
  ENDIF

  IF(DU(1).NE.DU(1)) THEN
     write(*,*) "NAN, Pause in qsint1"
     idebug=0
     loop_10032: DO while(idebug.eq.1) 
        idebug=1
     enddo loop_10032
  ENDIF
  IF(IEL_SOFT(NEL).EQ.0) THEN
     G0=DOTPRD1(DU,F,NEQ)
  ELSE
     G0=DOTPRD1(DU,F,NEQ)-DU(NEQ+1)*F(NEQ+1)
  ENDIF
  IF(MYMPI.EQ.0) THEN
     WRITE(21,789)STEP,ITR,TOL
  ENDIF
789 FORMAT(/'STEP S',D15.5,5X,'ITERATION NO',I5,5X,&
       'DISPLACEMENT TOLERANCE',D20.6)
  GO TO 30
110 CONTINUE
  ICON=1
  IF(MYMPI.EQ.0) THEN
     WRITE(21,130) ITR,ITEREF,GC
  ENDIF
  IF(MYMPI.EQ.0) THEN
     WRITE(21,131) G0,UNM,TOL
  ENDIF
  ITEREF=0
  IF(IVPL.NE.IVPL_OLD) THEN
     IVPL=IVPL_OLD
     IDEB=0
     IF(MYMPI.EQ.0) write(*,*) "IVPL<>IVPL_OLD"
     goto 31
  ENDIF
  RETURN
900 CONTINUE
  IF(MYMPI.EQ.0) THEN
     WRITE(21,901)
  ENDIF
901 FORMAT(///'THE BROY. ITERATION DID NOT CONVERGE&
       EVEN WITH MAX. REFORMATIONS.')
  ICON=0
  IF(DU(1).GT.DU_LIMIT) THEN
     I_CON=1
     IF(MYMPI.EQ.0) write(*,*) "DU(1) >10 stop, DU(1)= ",DU(1)
     DU_LIMIT=DU(1)
     IF(DU(1).GT.100) THEN
        IVPL=0
        goto 31
     ENDIF
     IVPL=IVPL_OLD
     IDEB=0
     goto 30
  ENDIF
  IF(IVPL.NE.IVPL_OLD) THEN
     IVPL=IVPL_OLD
     IDEB=0
     IF(MYMPI.EQ.0) write(*,*) "IVPL<>IVPL_OLD"
     goto 31
  ENDIF
  RETURN
130 FORMAT(///'NUMBER OF ITRNS',I5,2X,'NUMBER OF',&
       'STIFFNESS REFMS',I5,2X,'INITIAL ENERGY NORM',&
       2X,D20.6)
131 FORMAT(///'CURRENT ENERGY NORM',2X,D20.6,&
       'DISPLACEMENT NORM',D20.6,2X,'DISPLACEMENT&
       TOLERANCE',D20.6)
140 FORMAT(///'ITERATION LIMIT REACHED')
150 FORMAT(//'STIFFNESS MATRIX WILL NOW BE REFORMED')
160 FORMAT(///'RESIDUAL LOAD VECTOR LARGER THAN INCREMENTAL&
       LOADS AFTER ITERATION NO',I5)
END SUBROUTINE QSINT1

SUBROUTINE ASMRHS1(NEL,NITT,NIT,DU,DU6,DU1,IJK,JDIAG,NUMNOD,&
     NUMNOD1,NUMNOD2,NB,MP1,MP2,X,Y,H,F,STEP,G)
  !     
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  DIMENSION DU(1),DU6(1),DU1(1),X(1),Y(1),H(1)&
       ,F(1),H1(NBM,NBM),JDIAG(1),H2(NBM*(NBM+1)),IPIV(NBM),&
       WORK(4*NBM),IWORK(NBM)
  DIMENSION IJK(NLM,1),F2(NBM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /GEOM1/ XMTRL(NDFM)
  COMMON /BETACONLC1/ IBET_CONLC(NBM)
  COMMON /PLC/ PMATLC(2*INTM*3*NBM)
  COMMON /PLM/ PCOMLC(INTC*3*NBM)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /BETACONST/ IBET_TOT(NLM),IBET_CON(NBM,NLM)
  COMMON /HMATRIXTOL/ HFACT
  COMMON /ARCLENGTH/ ARC_IN(NBM),F1(NBM),ALPHA,JSOFT
  COMMON /SOFTPOINTER/ INEW_SOFT,ISOFT_TOT,IEL_SOFT(NLM)
  COMMON /HCONDITION/ IHCON
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /IQSINT1/  STRTMAX,STMAX,ISTRTMAX

701 FORMAT(' ENTERING ASMRHS1 ')
  LW=6
  KFL=0
  IF (NUMNOD1.NE.0) KFL=1
  NEQ=NB+KFL*NB
  NOEQ=NEQ
  CALL EXCHN (ARC_IN,F2,NEQ)
  loop_10033: DO I=1,NB
     F2(I)=F2(I)-DU1(I)
  enddo loop_10033
  IF (NIT.EQ.2) GO TO 100
  NOEQ=NEQ
  CALL STGUES (NEL,NUMNOD,NUMNOD1,NB,DU1)
  IF(STRTMAX.GT.100.0) THEN
     IVPL=0
     STRTMAX=0.D0
  ENDIF
  loop_10034: DO I=1,NB
     IBET_CONLC(I)=0
  enddo loop_10034
  CALL HMAT(NITT,NIT,H,DU6,F,DU1,NEL,NB,NUMNOD,NUMNOD1,&
       NUMNOD2,MP1,MP2)
  IF (JSOFT.EQ.1) THEN
     F(NB+1)=-DOTPRD1(ARC_IN,F2,NB)
  ELSE
     F(NB+1)=0.D0
  ENDIF
  RTOL=DSQRT(DOTPRD1(F,F,NEQ)/DOTPRD1(DU6,DU6,NEQ))/DU1(NB+1)
  CALL EXCHN (H,H2,JDIAG(NB))
  loop_10035: DO I=1,NEQ
     IBET_CONLC(I)=0
  enddo loop_10035
  INEW=1 
  IHCON=0
  loop_10036: DO WHILE (INEW.EQ.1.AND.IHCON.EQ.0)           
     CALL EXCHN (F,XMTRL,NEQ)
     CALL EXCHN (F,DU,NEQ)
     IF (IEL_SOFT(NEL).NE.10000) THEN
        CALL SKYLIN (H,DU,JDIAG,NEQ,0)
        INEW=0
        I=1
        loop_10037: DO WHILE (I.LE.NEQ.AND.INEW.NE.1.AND.IHCON.EQ.0)
           IF (H(JDIAG(I)).LT.0.D0) THEN
              IHCON=1
              IF (IHCON.EQ.0) THEN
                 loop_10038: DO J=1,I-1
                    H2(JDIAG(I)-(I-J))=0.D0
                 enddo loop_10038
                 H2(JDIAG(I))=1.D0
                 loop_10039: DO J=I+1,NEQ
                    H2(JDIAG(J)-(J-I))=0.D0
                 enddo loop_10039
                 F(I)=0.D0
                 IBET_CONLC(I)=1
                 CALL EXCHN(H2,H,JDIAG(NEQ))
                 INEW=1
              ENDIF
           ELSE
              I=I+1
           ENDIF
        enddo loop_10037
     ELSE
        loop_10040: DO I=1,NB
           loop_10041: DO J=1,I
              IJ=JDIAG(I)-(I-J)
              H1(J,I)=H(IJ)
              H1(I,J)=H1(J,I)
           enddo loop_10041
        enddo loop_10040
        IF (INFO.NE.0) THEN
           WRITE (*,*) 'CAME HERE'
           READ (*,*)
        ELSE
           CALL EXCHN (F,DU,NB+1)
           IF (INFO.NE.0) THEN
              WRITE (*,*) 'CAME HERE TOO'
              READ (*,*)
           ENDIF
        ENDIF
     ENDIF
  enddo loop_10036
  INEW=0
  IF (JSOFT.NE.1) THEN
     DU(NEQ+1)=0.D0            
  ELSE
     CALL EXCHN (DU6,F1,NEQ)
     CALL SKYLIN (H,F1,JDIAG,NEQ,2)
     AFACT=DOTPRD1(F1,ARC_IN,NEQ)
     IF (DABS(AFACT).GT.1.D-10) THEN
        IF (RTOL.GT.1.D-04) THEN
           DU(NEQ+1)=(F(NB+1)-DOTPRD1(DU,ARC_IN,NEQ))/AFACT
        ELSE
           DU(NEQ+1)=0.D0
        ENDIF
     ELSE
        WRITE (*,*) 'HIT ZERO SLOPE??'
        DU(NEQ+1)=0.D0
     ENDIF
     loop_10042: DO I=1,NEQ
        DU(I)=DU(I)+DU(NEQ+1)*F1(I)
     enddo loop_10042
  ENDIF
  G=STEP*DOTPRD1(F,DU,NEQ)-DU(NEQ+1)*F(NEQ+1)
  RETURN
  !     
  !     *****(NEXT ITERATION STEP)****
  !     
100 CONTINUE   
  loop_41: DO I=1,NEQ+1
     DU1(I)=DU1(I)+STEP*DU(I) 
  enddo loop_41
  IF(dabs(DU1(1))>100000.and.ivpl.EQ.4) THEN
     idebug=0
     loop_10043: do while(idebug.EQ.1) 
        idebug=1
     enddo loop_10043
  ENDIF
  CALL STGUES (NEL,NUMNOD,NUMNOD1,NB,DU1)
  IF(STRTMAX.GT.100.0) THEN
     IVPL=0
     STRTMAX=0.D0
  ENDIF
  CALL HMAT(NITT,2,H2,DU6,F,DU1,NEL,NB,NUMNOD,NUMNOD1,&
       NUMNOD2,MP1,MP2)
  loop_10044: DO I=1,NEQ
     IF (IBET_CONLC(I).EQ.1) THEN
        F(I)=0.D0
     ENDIF
  enddo loop_10044
  IF (JSOFT.EQ.1) THEN
     F(NB+1)=-DOTPRD1(ARC_IN,F2,NB)
  ELSE
     F(NB+1)=0.D0
  ENDIF
  G=DOTPRD1(DU,F,NEQ)-DU(NEQ+1)*F(NEQ+1)
  loop_51: DO I=1,NEQ+1
     DU1(I)=DU1(I)-STEP*DU(I)
  enddo loop_51
  RETURN
END SUBROUTINE ASMRHS1
!     
!----------------------------------------------------------------------------
!     
SUBROUTINE LINSCH1(NEL,NITT,NIT,DU,DU6,DU1,IJK,JDIAG,&
     NUMNOD,NUMNOD1,NUMNOD2,NB,MP1,MP2,X,Y,H,F,G,G0,STEP)
  !     
  !-----------------------------------------------------------------------------
  !     
  !     PURPOSE:
  !     THIS SUBROUTINE PERFORMS A LINE SEARCH TO
  !     OBTAIN THE PARAMETER S(STEP) FOR THE SOLUTION.
  !     
  !------------------------------------------------------------------------------
  !     
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  DIMENSION IJK(NLM,1),JDIAG(1),H(1)
  DIMENSION DU(1),DU6(1),DU1(1),X(1),Y(1),F(1)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  DATA LINMAX,STOL/10,0.50/
701 FORMAT('ENTERING LINESRCH')
  IF(G*G0.GT.0.E0) RETURN
  J=0
  GA=G
  GB=G0
  SB=0.E0
  SA=1.E0
  SA1=SA
  SB1=SB
10 J=J+1
  IF(DABS(SA1-SB1)/DABS(STEP-SA1).GT.20.D0&
       .OR.DABS(SA1-SB1)/DABS(STEP-SB1).GT.20.D0) THEN
     STEP=0.5D0*(SA+SB)
  ELSE
     STEP=SA-GA*(SA-SB)/(GA-GB)
  ENDIF
  SA1=SA
  SB1=SB
  CALL ASMRHS1(NEL,NITT,2,DU,DU6,DU1,IJK,JDIAG,NUMNOD,&
       NUMNOD1,NUMNOD2,NB,MP1,MP2,X,Y,H,F,STEP,G)
  IF(G*GA.GT.0.E0)GO TO 20
  SB=SA
  GB=GA
20 if(DABS(SA-STEP).LT.1.E-5*DABS(SA-SB)) RETURN
  SA=STEP
  GA=G
  IF(J.EQ.LINMAX) RETURN
  IF(ABS(G).GT.STOL*ABS(G0)) GO TO 10
  RETURN
END SUBROUTINE LINSCH1

!************************************************************************
! Calculate the maximum distance between any two gauss points
SUBROUTINE CALPTPDIST(X,Y,NODE,NINT,IJK,IJK1,IJK2)
!************************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  INCLUDE 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (NLM_SOFT=40000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (ALPHA=0.E0)
  PARAMETER (MAX_INT_ORDER=20)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NMAX_POLY=25,NM_PL=NMAX_POLY-1)
  PARAMETER (INTERP=2)
  DIMENSION X(1),Y(1),NODE(1),NINT(NLM,2) 
  DIMENSION IJK(NLM,1),IJK1(NLM,1),IJK2(NLM,1)

  INTEGER, ALLOCATABLE :: inv(:)
  DOUBLE PRECISION, ALLOCATABLE ::dlv(:)

  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /SCALPRM/ XCENT(NLM),YCENT(NLM),SCALE(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /SCALPRMC/ XCENTPP(NLM),YCENTPP(NLM),SCALEPP(NLM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /NEIGHNEL/ NUM_NEIGH(NLM),NEL_NEIGH(NLM,20)
  COMMON /XKPARM/ DNEAR,DPTPDIST

  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NUMMPI,IERR)

  ALLOCATE(inv(INTERP+2))
  ALLOCATE(dlv(INTERP+2))
  inv=0
  dlv=0.D0


  DLMAX=0.D0
  DLMIN=1.D+20
  NELSTART=DFLOAT(NELX)/DFLOAT(NUMMPI)*MYMPI+1
  NELEND=DFLOAT(NELX)/DFLOAT(NUMMPI)*(MYMPI+1)
  if(NELEND.GT.NELX) NELEND=NELX
  if((MYMPI+1).EQ.NUMMPI) NELEND=NELX
  DO I=NELSTART,NELEND
     DO J=NPBG(I)+1,NINTM(I)+NPBG(I)
        xxint=xipt(j)*scale(i)+xcentp(i)
        yyint=yipt(j)*scale(i)+ycentp(i)
        DLMIN=1.E+10
        NEL=I
        DO IPT=1,NINTM(NEL)
           IF(NPBG(NEL)+IPT.NE.J) THEN
              XX=(XIPT(NPBG(NEL)+IPT)*SCALE(NEL)+XCENTP(NEL))
              YY=(YIPT(NPBG(NEL)+IPT)*SCALE(NEL)+YCENTP(NEL))
              XD=XX-XXINT
              YD=YY-YYINT
              DL=DSQRT(XD*XD+YD*YD)
              IF(DL.LT.DLMIN) DLMIN=DL
           ENDIF
        enddo
        IF(DLMIN.GT.DLMAX) DLMAX=DLMIN
     ENDDO
  ENDDO
  IF(NUMMPI.GT.1) THEN
     CALL MPI_ALLREDUCE(DLMAX,DPTPDIST,1,MPI_DOUBLE_PRECISION,MPI_MAX,MPI_COMM_WORLD,IERR)
  ELSE
     DPTPDIST=DLMAX
  ENDIF


  IF(MYMPI.EQ.0) THEN
     WRITE(*,*) "The maximum distance bewteen 2 Gauss Points is: ",DPTPDIST
  ENDIF
  DEALLOCATE(inv)
  DEALLOCATE(dlv)

  RETURN
END SUBROUTINE CALPTPDIST
