
!********************************************************************
! Calculate the local stiffness matrix (SKE) for element NEL for the given
! local displacement DUTOT.
SUBROUTINE ESTIFO(NIT,NEL,NB,NX,NIX,NIX1,IJK,X,Y,SKE,FRES,DUTOT,&
     MP1,MP2,NDIM) 
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  INCLUDE 'mpif.h'
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (NLM_SOFT=40000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (MXSKE=(NDFELM*(NDFELM+1))/2)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2,MAXHSK=NBM*(NBM+1))
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NUMSKIO=NLM*200000)
  PARAMETER (NUMHG=NLM*10000)
  PARAMETER (NUMTMOUT=NLM*18000,NUMTMIN=NLM*18000,NUMTMIN1=NLM*18000&
       ,NUMTMIN2=NLM*5000)
  DIMENSION SKE(NDIM,NDIM),DUTOT(NDIM),X(NDIM),Y(NDIM),FRES(NDIM*2),IJK(NLM,1)

  DIMENSION JDIAG(NBM),IBETLC(NBM),INC_CON(NBM)
  DIMENSION BETA(MAXH),F(MAXH),FR(MAXH)&
       ,FP(MAXH),COORD_CELLinc(1)

  INTEGER, ALLOCATABLE :: JPT(:)
  DOUBLE PRECISION, ALLOCATABLE :: BETA1(:),T(:,:),T1(:,:),T2(:,:),T3(:,:),H(:),H1(:),&
       FTEMP(:),FRES9(:),SKMUL(:,:),PHITRAN(:,:),SKLC(:,:),HT(:),SKCLM(:)

  COMMON /DISPSHIFT/ ISOFTEL(NLM)
  COMMON /NELSID/ NELS_IN_NEL(NLM_SOFT)
  COMMON /BETACONLC/ IBET_CONLC(NBM)
  COMMON /ITERWRITE/ NLIN_WRITE,CHAR_WRITE(1000)
  COMMON /CONMPDATAM/ FGM(NLM*INTM),DFDXGM(NLM*INTM),DFDYGM&
       (NLM*INTM),DFDXXGM(NLM*INTM),DFDXYGM(NLM*INTM),DFDYYGM&
       (NLM*INTM)
  common /plsintsubst/ ksubst
  COMMON /CONMPDATAMC/ FGMC(NLM*INTM),DFDXGMC(NLM*INTM),DFDYGMC&
       (NLM*INTM),DFDXXGMC(NLM*INTM),DFDXYGMC(NLM*INTM),DFDYYGMC&
       (NLM*INTM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /MATPR/ YM1,YM2,PR1,PR2
  COMMON /PLNST/ KPLS
  COMMON /PROP/ YM,PR
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /EPSCOM/ STNCOM(NLM*INTC*4),STNCOMST(NLM*INTC*4)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /PLPCOM/ VMCOM(NLM*INTC),EPLSCOM(NLM*INTC)&
       ,DEPLSCOM(NLM*INTC),NPLCOM(NLM*INTC)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /BETAGL/ BETTOT(MAXH*NLM),BETST(MAXH*NLM),&
       BETLC(MAXH*NLM)
  COMMON /PLLC/ NPLCM(NLM*INTM),NPLCC(NLM*INTC)
  COMMON /CONVCHK/ ICON
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /INOUT/ SKIO(NUMSKIO),NP_SKIO(NLM,4)
  COMMON /POLLSTF/ NIT_POL
  COMMON /QSSTEP/ IQST
  COMMON /INTLOPBG/ HYP1(INTM),HYP2(INTM),VMLC(INTM),STRP(INTM,4),&
       SN1(INTM*4)
  COMMON /INTLOPBG1/ HYP11(INTC),HYP21(INTC),VMLC1(INTC),&
       STRP1(INTC,4),SN11(INTC*4)
  COMMON /SCALPRM/ XCENT(NLM),YCENT(NLM),SCALE(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /SCALPRMC/ XCENTPP(NLM),YCENTPP(NLM),SCALEPP(NLM)
  COMMON /INSTT/ NPLINM(NLM*INTM),NPLINC(NLM*INTC)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /GMATR/ TMOUT(NUMTMOUT), NP_TMOUT(NLM,4),&
       TMIN(NUMTMIN), NP_TMIN(NLM,4),&
       TMIN1(NUMTMIN1), NP_TMIN1(NLM,4),&
       TMIN2(NUMTMIN2), NP_TMIN2(NLM,4)
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /ITRTYP/ IPR,IDONE,ISPECIAL(INTM)
  COMMON /ITRFILES/ ITRFIL1,ITRFIL2,FLAG11,FLAG12,FLAG21,FLAG22
  COMMON /SOFTPOINTER/ INEW_SOFT,ISOFT_TOT,IEL_SOFT(NLM)
  COMMON /MATLOC/ VM_LOC(NLM*INTM),EPLS_LOC(NLM*INTM),&
       FVOID_LOC(NLM*INTM),IMATLC(NLM*INTM),IFAIL(NLM*INTM)
  COMMON /LOCALDOF/ IPOINT(NDFELM),NDF_CELL,NDF_INC,&
       NDF_CRCK,NADAPT_CELL,NADAPT_INC,NADAPT_CRCK
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /PROPTRANS/ EZ_MAT(NBM,NLM),EZ_COM(NBM,NLM)
  COMMON /MACSTN/ NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /IWRITE/ IWRT
  COMMON /BETACONST/ IBET_TOT(NLM),IBET_CON(NBM,NLM)
  COMMON /REPTPARAM/ EMAC(3),IREPT_FLAG,KSTR1,KSTR2,IREPT(4),&
       JREPT(4),KD1_BD(NODM),KD2_BD(NODM),NEL_KD1(NODM,2),&
       NEL_KD2(NODM,2)
  COMMON /GURSFACT/ VM_TEMP(INTM),SLP_TEMP(INTM)
  COMMON /HMATRIXTOL/ HFACT
  COMMON /CONSTMT1/ NPTS(10),STSN(10,100,2)
  COMMON /ARCLENGTH/ ARC_IN(NBM),DU7(NBM),ALPHA,JSOFT
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),&
       INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /BOUNDARYDISP/ IDOSOFT(NDFELM),DD(NDFELM)
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /HPADAPTINC/ COORD_HP_INC(NLM*NSDMAX*3),INT_HP_INC&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_INC(NSMAX)
  COMMON /HOURGLASS/ IHGLASS(NLM,NDELM),PHI_HGLASS(NUMHG),&
       NP_HGLASS(NLM,4),IHGNEL(NLM)
  COMMON /FINDOT/ DOTIN,DOTIN1
  COMMON /DISPDUFLAG/ IDISP_DU
  COMMON /DISPNEL/ NELDISP_IN_NEL(NLM), NO_NELDISP(NLM_SOFT,NLM)
  COMMON /DECOMP/ IPARALLEL
  COMMON /YIELD/ HRD(16,3),YLDIN(16)
  COMMON /WLTBASEC/ DPOSW(NLM*NBM,2),NPBG_WLT(NLM),SSIGXG(NLM*NBM),SSIGYG(NLM*NBM),IWORP(NLM),IBET_WLTC(NBM,NLM)
  COMMON /WLTBASEM/ DPOSWM(NLM*NBM,2),NPBG_WLTM(NLM),SSIGXGM(NLM*NBM),SSIGYGM(NLM*NBM),IBET_WLTM(NBM,NLM)
  COMMON /INCBETA/  NBETA_INC(NLM),NBETA_DIF(NLM)
  COMMON /TITLENAME/ title,title1
  CHARACTER*60 title,title1
  CHARACTER*20 FLAG11,FLAG12,FLAG21,FLAG22
  CHARACTER*70 CHAR_WRITE
  CHARACTER*9 CHAR_FORM

  NDF_TOT=NDF_CELL+NDF_INC+NDF_CRCK
  NQ=((NDF_TOT)*(NDF_TOT+1))/2
  ALLOCATE(JPT(NQ))
  JPT=0
  JDIAG=0
  IBETLC=0
  INC_CON=0

  ALLOCATE(FTEMP(2*NDIM),FRES9(2*NDIM),SKMUL(NDIM,NDIM),&
       PHITRAN(NDIM,NDIM),SKLC(NDIM,NDIM),SKCLM(NQ))

  BETA=0.D0
  F=0.D0
  FR=0.D0
  FP=0.D0
  FTEMP=0.D0
  FRES9=0.D0
  SKMUL=0.D0
  COORD_CELLinc=0.D0
  PHITRAN=0.D0
  SKLC=0.D0

  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYMPI,IERR)

  JSOFT=IEL_SOFT(NEL)
  IF(MYMPI.EQ.0) THEN
     REWIND (21)
     CLOSE (21)
  ENDIF
  ISOLVE=1
  KFLU=0
  IF (KFLU.EQ.1) THEN
     loop_10000: DO I=1,NDF_CELL+NDF_INC
        DUTOT(I)=0.D0
     enddo loop_10000
  ENDIF
  IF (ITRFIL2.EQ.0) THEN
     ITRFIL2=1         
     IF(MYMPI.EQ.0) THEN
        OPEN (21,FILE=FLAG22)
     ENDIF
  ELSE
     ITRFIL2=0
     IF(MYMPI.EQ.0) THEN
        OPEN (21,FILE=FLAG12)
     ENDIF
  ENDIF
  NLIN_WRITE=0
  NLIN_WRITE=NLIN_WRITE+1
  CHAR_WRITE(NLIN_WRITE)='ENETERING QSINT1'
  NDF_TOT=NDF_CELL+NDF_INC+NDF_CRCK
  IPR=1
  IF (NIT.LE.0.AND.INEW_SOFT.EQ.0) IPR=0
  IF (NIT.EQ.0.AND.IVPL.EQ.4) IPR=1
  A=SCALE(NEL)
  X0=XCENT(NEL)
  Y0=YCENT(NEL)
  A1=SCALEP(NEL)
  X0P=XCENTP(NEL)
  Y0P=YCENTP(NEL)
  loop_61: DO I=1,NINTM(NEL)
     HYP1(I)=(STMAT((NPBG(NEL)+I-1)*4+1)+STMAT((NPBG(NEL)+I-1)*4+2)&
          +STMAT((NPBG(NEL)+I)*4))
     STRP(I,1)=STMAT((NPBG(NEL)+I-1)*4+1)-HYP1(I)/3.E0
     STRP(I,2)=STMAT((NPBG(NEL)+I-1)*4+2)-HYP1(I)/3.E0
     STRP(I,3)=STMAT((NPBG(NEL)+I-1)*4+3)
     STRP(I,4)=STMAT((NPBG(NEL)+I)*4)-HYP1(I)/3.E0
     IF (NIT.LT.0) NPLINM(NPBG(NEL)+I)=NPLMAT(NPBG(NEL)+I)
     VMLC(I)=VMMAT(NPBG(NEL)+I)
     IF (IPR.EQ.1) THEN
        NPLINM(NPBG(NEL)+I)=NPLCM(NPBG(NEL)+I)
     ELSE
        NPLINM(NPBG(NEL)+I)=NPLMAT(NPBG(NEL)+I)
     ENDIF
     IF (IMATLC(NPBG(NEL)+I).GT.1) THEN
        NPLINM(NPBG(NEL)+I)=25
     ENDIF
  enddo loop_61
  loop_62: DO I=1,NINTC(NEL)
     HYP11(I)=(STCOM((NPBM(NEL)+I-1)*4+1)+STCOM((NPBM(NEL)+I-1)*4+2)&
          +STCOM((NPBM(NEL)+I)*4))
     STRP1(I,1)=STCOM((NPBM(NEL)+I-1)*4+1)-HYP1(I)/3.E0
     STRP1(I,2)=STCOM((NPBM(NEL)+I-1)*4+2)-HYP1(I)/3.E0
     STRP1(I,3)=STCOM((NPBM(NEL)+I-1)*4+3)
     STRP1(I,4)=STCOM((NPBM(NEL)+I)*4)-HYP1(I)/3.E0
     VMLC1(I)=SQRT(1.5E0*(STRP1(I,1)*STRP1(I,1)+STRP1(I,2)*&
          STRP1(I,2)+2.E0* STRP1(I,3)*STRP1(I,3)+STRP1(I,4)*STRP1(I,4)))
     IF (VMLC1(I).LT.0.99E0*VMCOM(NPBM(NEL)+I)) VMLC1(I)=VMCOM&
          (NPBM(NEL)+I)
  enddo loop_62
  NPL1=0
  ION=1
  NBDIF=NB_ADP_COM(NEL)-NB_ADP_MAT(NEL)
  NB1=NB-NCYLFLAG(NEL,1)*NTRMADD(NEL,1)+NBDIF
  ALLOCATE(BETA1(2*NBM),T(NBM,NDF_CELL),T1(NBM,NDF_INC),T2(NBM,NDF_INC),T3(NBM,NDF_CRCK))
  CALL AZERO1(F,2*NB)
  CALL AZERO1(BETA1,2*NB)
  loop_501: DO I=1,NB
     IBET_CONLC(I)=0
     loop_502: DO J=1,NDF_CELL
        T(I,J)=TMOUT(NP_TMOUT(NEL,1)+(I-1)*NP_TMOUT(NEL,4)+J)
     enddo loop_502
     loop_503: DO J=1,NDF_INC
        T1(I,J)=TMIN(NP_TMIN(NEL,1)+(I-1)*NP_TMIN(NEL,4)+J)
     enddo loop_503
  enddo loop_501
  loop_504: DO I=1,NB1
     loop_505: DO J=1,NDF_INC
        T2(I,J)=TMIN1(NP_TMIN1(NEL,1)+(I-1)*NP_TMIN1(NEL,4)+J)
     enddo loop_505
     loop_506: DO J=1,NDF_CRCK
        T3(I,J)=TMIN2(NP_TMIN2(NEL,1)+(I-1)*NP_TMIN2(NEL,4)+J)
     enddo loop_506
  enddo loop_504
973 FORMAT ('g(',I4,',',I4,')=',e25.12,';')
974 FORMAT ('g1(',I4,',',I4,')=',e25.12,';')
977 FORMAT ('g2(',I4,',',I4,')=',e25.12,';')
975 FORMAT ('duo(',I4,')=',e25.12,';')
976 FORMAT ('dui(',I4,')=',E25.12,';')
  CALL MATMUL (NB,NDF_CELL,ION,T,DUTOT,F,NBM,NDFELM,MAXH)
  CALL MATMUL (NB,NDF_INC,ION,T1,DUTOT(NDF_CELL+1),F(NB+1),NBM,NDFELM,&
       MAXH)
  CALL MATMUL (NB1,NDF_INC,ION,T2,DUTOT(NDF_CELL+1),FP,NBM,NDFELM,MAXH)
  CALL MATMUL (NB1,NDF_CRCK,ION,T3,DUTOT(NDF_CELL+NDF_INC+1),&
       FP(NB1+1),NBM,NDFELM,MAXH)
  !     CALCULATE H MATRIX
  loop_316: DO I=1,NB
     F(I)=F(I)-F(I+NB)
     IF (IBET_CON(I,NEL).EQ.1) F(I)=0.D0
  enddo loop_316
  loop_317: DO I=1,NB1
     IF (NIX1.NE.0) THEN
        FP(I)=FP(I)-FP(I+NB1)
     ENDIF
  enddo loop_317
  !%%%% MODIFICATION FOR WAVELET( I .GT. NB) %%%%%%%%
  loop_314: DO I=1,MAX(NB,NB1)
     IF (I .LE. NB) THEN
        BETA1(I+NB)=0.E0
        IF (IPR.EQ.1.OR.(NIT.EQ.-1.OR.NIT.EQ.1).OR.IVPL.EQ.4) THEN
           BETA1(I)=BETST(I+(NEL-1)*2*NBM)
        ELSE
           BETA1(I)=0.E0
        ENDIF
        BETA1(I+NB)=BETST(I+NB+(NEL-1)*2*NBM)
     ELSEIF(I .GT. NB) THEN
        BETA1(I+NB)=BETST(I+NB+(NEL-1)*2*NBM)
     ENDIF
  enddo loop_314
  !%%%% END MODIFICATION FOR WAVELET %%%%%%%%
  loop_821: DO I=1,MAX(NB,NB1)
     JDIAG(I)=(I*(I+1))/2
  enddo loop_821

  ALLOCATE(H(2*JDIAG(MAX(NB,NB1))),H1(2*JDIAG(MAX(NB,NB1))),HT(2*JDIAG(MAX(NB,NB1))))
  CALL STGUES (NEL,NX,NIX,NB,BETA1)   
  JVPL=IVPL
  MP=MP1
  IF ((NIT.NE.-1.AND.NIT.NE.1)) THEN
     BETA1(NB+1)=1.D0
     IAGAIN=1
     IF ((NIT.LE.0.OR.IPR.EQ.0)) THEN
        IF (IPR.EQ.0.OR.IVPL.NE.4) THEN
           CALL HMAT(-1,-1,H,F,FR,BETA1,NEL,NB,NX,0,0,MP1,MP2)
           CALL EXCHN (F,BETA1,NB)
           CALL SKYLIN (H,BETA1,JDIAG,NB,0)
        ENDIF
     ENDIF
     NIT7=2
     kflu=0
     IF (KFLU.EQ.1) THEN
        OPEN (347,FILE='frs_qsint.dat')
        loop_10004: DO I=1,NB
           WRITE (347,*) f(i)
        enddo loop_10004
     else if (kflu.eq.-1) then
        OPEN (347,FILE='frs_qsint.dat')
        loop_10005: DO I=1,NB
           read (347,*) f(i)
        enddo loop_10005
     endif
     REWIND (347)
     close (347)
     CALL QSINT1(NEL,NIT7,F,BETA1,IJK,NX,0,0,NB,MP1,MP2,&
          X,Y,H)      
     jadj=0
     if (jadj.eq.1) then
        loop_10006: do i=1,nb
           beta1(i)=0.d0
        enddo loop_10006
        beta1(3)=1.1538d0
     endif
     IF (ICON.EQ.10) THEN   
        IF (IPR.NE.0) THEN
           IPR=IPR-1
           ICH=0
           loop_413: DO I=1,NINTM(NEL)
              NPLINM(NPBG(NEL)+I)=NPLMAT(NPBG(NEL)+I)
           enddo loop_413
           DEALLOCATE(JPT)
           DEALLOCATE(BETA1,T2,H,T,T1,SKCLM,T3,H1,FTEMP,FRES9&
                ,SKMUL,PHITRAN,SKLC,HT)
           return
        ELSE
           IF(MYMPI.EQ.0) THEN
              WRITE (21,21) (CHAR_WRITE(I),I=1,NLIN_WRITE)
21            FORMAT(A)
              NINPT=NINTM(NEL)
              WRITE (21,*) 'MAKING A GUESS FOR BETAS, NEL=',NEL
              WRITE (21,*) NB,NX,NIX,NIX1
              WRITE (21,*)
702           FORMAT (2(E12.6,2X))
              WRITE (21,702) (X(I),Y(I),I=1,NX)
              WRITE (21,702) X(1),Y(1)
              WRITE (21,*)
              WRITE (21,702) (X(I)+DUTOT(I*2-1),Y(I)+DUTOT(I*2),&
                   I=1,NX)
              WRITE (21,*)
              WRITE (21,702) (X(I),Y(I),I=NX+1,NX+NIX)
              WRITE (21,702) X(1+NX),Y(1+NX)
              WRITE (21,*)
              WRITE (21,702) (X(I)+DUTOT(I*2-1),Y(I)+DUTOT(I*2),&
                   I=NX+1,NX+NIX)
              WRITE (21,702) X(NX+1)+DUTOT(NX*2+1),Y(NX+1)+&
                   DUTOT(NX*2+2)
              WRITE (21,*)
              WRITE (21,702) (X(I),Y(I),I=NX+NIX+1,NX+NIX+NIX1)
              WRITE (21,702) X(1+NX+NIX),Y(1+NX+NIX)
              WRITE (21,*)
              WRITE (21,702) (X(I)+DUTOT(I*2-1),Y(I)+DUTOT(I*2),&
                   I=NX+NIX+1,NX+NIX+NIX1)
              WRITE (21,702) X(NX+NIX+1)+DUTOT((NX+NIX)*2+1),&
                   Y(NX+NIX+1)+DUTOT((NX+NIX)*2+2)
              WRITE (21,*) NB,(NCYLFLAG(NEL,I),IRECTRM(NEL,I),&
                   KORD(NEL,I),NTRMADD(NEL,I),I=1,3),NINTM(NEL)
              WRITE (21,701) XCENT(NEL),YCENT(NEL),SCALE(NEL),XCENTP&
                   (NEL),YCENTP(NEL),SCALEP(NEL),XCENTPP(NEL),&
                   YCENTPP(NEL)
              WRITE (21,701) (BETTOT(I+(NEL-1)*2*NBM),I=1,NBM)
              WRITE (21,701) (BETST(I+(NEL-1)*2*NBM),I=1,NBM)
              WRITE (21,701) (F(I),I=1,NB)
              WRITE (21,701) (XIPT(NPBG(NEL)+I),YIPT(NPBG(NEL)+I),&
                   GJACOB(NPBG(NEL)+I),I=1,NINTM(NEL))
              WRITE (21,701) (FGM(NPBG(NEL)+I),DFDXGM(NPBG(NEL)+I),&
                   DFDYGM(NPBG(NEL)+I),DFDXXGM(NPBG(NEL)+I),DFDXYGM&
                   (NPBG(NEL)+I),DFDYYGM(NPBG(NEL)+I),I=1,NINTM(NEL))
              WRITE (21,701) (FGMC(NPBG(NEL)+I),DFDXGMC(NPBG(NEL)+I),&
                   DFDYGMC(NPBG(NEL)+I),DFDXXGMC(NPBG(NEL)+I),DFDXYGMC&
                   (NPBG(NEL)+I),DFDYYGMC(NPBG(NEL)+I),I=1,NINTM(NEL))
701           FORMAT (5(E12.6,2X))
           ENDIF
           KSUBST=0
        ENDIF
     ELSE
        IF(MYMPI.EQ.0) THEN
           WRITE (21,*) 'DONE QSINT1 FOR NEL=',NEL,' NIT=',NIT
        ENDIF
     ENDIF
     IF (YM2.GT.1.D-03) THEN            
        BETA1(1+NB)=BETST(1+NB+(NEL-1)*2*NBM)
        CALL HMAT(1,1,H,FP,FR,BETA1(NB+1),NEL,NB,0,NIX,NIX1,MP1,MP2)
        CALL EXCHN (FR,BETA(NB+1),NB1)            
        loop_10007: DO I=1,NB1
           INC_CON(I)=0
        enddo loop_10007
        loop_10008: DO I=1,JDIAG(NB1)
           HT(I)=H(I)
        enddo loop_10008
        INEW=1
        loop_10009: DO WHILE (INEW.EQ.1) 
           CALL SKYLIN (H,BETA(NB+1),JDIAG,NB1,1)
           HMAX=-1.D0
           loop_10010: DO I=1,NB1
              IF (H(JDIAG(I)).GT.HMAX.AND.INC_CON(I).EQ.0) HMAX=H(JDIAG(I))
           enddo loop_10010
           I=NB1-NCYLFLAG(NEL,2)*NTRMADD(NEL,2)
           INEW=0
           loop_10011: DO WHILE (INEW.EQ.0.AND.I.LT.NB1.AND.NDF_CRCK.NE.0) 
              I=I+1
              IF (H(JDIAG(I)).LT.1.D-04*HMAX.AND.INC_CON(I).EQ.0) THEN
                 INEW=1
                 INC_CON(I)=1
                 BETA(NB+I)=0.D0
                 loop_10012: DO J=1,I-1
                    HT(JDIAG(I)-(I-J))=0.D0
                 enddo loop_10012
                 HT(JDIAG(I))=1.D0
                 loop_10013: DO J=I+1,NB1
                    HT(JDIAG(J)-(J-I))=0.D0
                 enddo loop_10013
                 loop_10014: DO I=1,JDIAG(NB1)
                    H(I)=HT(I)
                 enddo loop_10014
              ENDIF
           enddo loop_10011
        enddo loop_10009
        CALL SKYLIN (H,BETA(NB+1),JDIAG,NB1,2)            
        IDO=0
        IF (IDO.EQ.1) THEN
           loop_10015: DO I=1,NB1
              WRITE (*,*) I,H(JDIAG(I))
           enddo loop_10015
        ENDIF
     ELSE
        CALL AZERO1(BETA1(NB+1),NB1)
        CALL AZERO1(BETA(NB+1),NB1)
     ENDIF
     loop_10016: DO I=1,NB1
        BETA1(I+NB)=BETA1(I+NB)+BETA(I+NB)
     enddo loop_10016
     CALL STGUES (NEL,NX,NIX,NB,BETA1)       
  ENDIF
  IF (NIT.NE.2) THEN
     NITT=1
     CALL HMAT(NIT,NITT,H,F,FR,BETA1,NEL,NB,NX,NIX,NIX1,MP1,MP2)
     loop_10017: DO I=1,NB1
        INC_CON(I)=0
        FP(I)=0.D0
     enddo loop_10017
     NBEG=(NB*(NB+1))/2
     loop_10018: DO I=1,JDIAG(NB1)
        HT(I)=H(NBEG+I)
     enddo loop_10018
     INEW=1
     loop_10019: DO WHILE (INEW.EQ.1) 
        CALL SKYLIN (H(NBEG+1),FP,JDIAG,NB1,1)
        HMAX=-1.D0
        loop_10020: DO I=1,NB1
           IF (H(NBEG+JDIAG(I)).GT.HMAX.AND.INC_CON(I).EQ.0) HMAX=H(NBEG+JDIAG(I))
        enddo loop_10020
        I=NB1-NCYLFLAG(NEL,2)*NTRMADD(NEL,2)
        INEW=0
        loop_10021: DO WHILE (INEW.EQ.0.AND.I.LT.NB1.AND.NDF_CRCK.NE.0) 
           I=I+1
           IF (H(NBEG+JDIAG(I)).LT.1.D-04*HMAX.AND.INC_CON(I).EQ.0) THEN
              INEW=1
              INC_CON(I)=1                     
              loop_10022: DO J=1,I-1
                 HT(JDIAG(I)-(I-J))=0.D0
              enddo loop_10022
              HT(JDIAG(I))=1.D0
              loop_10023: DO J=I+1,NB1
                 HT(JDIAG(J)-(J-I))=0.D0
              enddo loop_10023
              loop_10024: DO I=1,JDIAG(NB1)
                 H(NBEG+I)=HT(I)
              enddo loop_10024
           ENDIF
        enddo loop_10021
     enddo loop_10019
873  FORMAT ('hmatrix(',I4,',',I4,')=',E25.12,';')
     JJBEG=(NB*(NB+1))/2
874  FORMAT ('hinc(',I4,',',I4,')=',E12.6,';')
  ELSE
     NITT=NIT
     CALL HMAT(NIT,NITT,H,F,FR,BETA1,NEL,NB,NX,NIX,NIX1,MP1,MP2)
     loop_10025: DO I=1,NB1
        INC_CON(I)=0
        FP(I)=0.D0
     enddo loop_10025
     NBEG=(NB*(NB+1))/2
     loop_10026: DO I=1,JDIAG(NB1)
        HT(I)=H(NBEG+I)
     enddo loop_10026
     INEW=1
     loop_10027: DO WHILE (INEW.EQ.1) 
        CALL SKYLIN (H(NBEG+1),FP,JDIAG,NB1,1)
        HMAX=-1.D0
        loop_10028: DO I=1,NB1
           IF (H(NBEG+JDIAG(I)).GT.HMAX.AND.INC_CON(I).EQ.0) HMAX=H(NBEG+JDIAG(I))
        enddo loop_10028
        I=NB1-NCYLFLAG(NEL,2)*NTRMADD(NEL,2)
        INEW=0
        loop_10029: DO WHILE (INEW.EQ.0.AND.I.LT.NB1.AND.NDF_CRCK.NE.0) 
           I=I+1
           IF (H(NBEG+JDIAG(I)).LT.1.D-04*HMAX.AND.INC_CON(I).EQ.0) THEN
              INEW=1
              INC_CON(I)=1                     
              loop_10030: DO J=1,I-1
                 HT(JDIAG(I)-(I-J))=0.D0
              enddo loop_10030
              HT(JDIAG(I))=1.D0
              loop_10031: DO J=I+1,NB1
                 HT(JDIAG(J)-(J-I))=0.D0
              enddo loop_10031
              loop_10032: DO I=1,JDIAG(NB1)
                 H(NBEG+I)=HT(I)
              enddo loop_10032
           ENDIF
        enddo loop_10029
     enddo loop_10027
  ENDIF
  CALL AZERO1(FRES,(NDF_TOT+6)*2)
  CALL AZERO1(FRES9,(NDF_TOT+6)*2)
  loop_1: DO I=1,NBM*2
     IPR=0
     IF (IPR.EQ.1) THEN
        BETA(I)=BETTOT(I+(NEL-1)*2*NBM)
     ELSE
        BETA(I)=BETTOT(I+(NEL-1)*2*NBM)+BETA1(I)
     ENDIF
  enddo loop_1
  IF (NIT.NE.2) THEN
     NQ=((NDF_TOT)*(NDF_TOT+1))/2
     CALL AZERO1(SKCLM,NQ)
     II=0
     NQ1=NDF_TOT
     loop_203: DO I=NQ1,1,-1
        loop_204: DO J=1,I
           JPT(II+J)=NQ1-I+1
        enddo loop_204
        II=II+I
     enddo loop_203
     loop_10034: DO I=1,NB
        IBET_CONLC(I)=0
     enddo loop_10034
     INEW=1
     CALL EXCHN (H,H1,JDIAG(NB))
     loop_10035: DO WHILE (INEW.EQ.1) 
        CALL EXCHN (H1,H,JDIAG(NB))
        CALL SKYLIN(H,F,JDIAG,NB,0)
        HMAX=-1.D0
        loop_10036: DO I=1,NB
           IFACT=IBET_CONLC(I)+IBET_CON(I,NEL)
           IF (DABS(H(JDIAG(I))).GT.HMAX.AND.IFACT.EQ.0) &
                THEN
              HMAX=DABS(H(JDIAG(I)))
           ENDIF
        enddo loop_10036
        HTOL=HFACT*HMAX
        INEW=0
        I=nb+1
        loop_10037: DO WHILE (INEW.EQ.0.AND.I.LT.NB)
           I=I+1
           IFACT=IBET_CONLC(I)+IBET_CON(I,NEL)
           IF (H(JDIAG(I)).LT.HTOL.AND.IFACT.EQ.-100) THEN
              IBET_CONLC(I)=1
              loop_10038: DO K=1,I
                 IK=JDIAG(I)-(I-K)
                 H1(IK)=0.D0
              enddo loop_10038
              H1(JDIAG(I))=1.D0
              loop_10039: DO K=I+1,NB
                 IK=JDIAG(K)-(K-I)
                 H1(IK)=0.D0
              enddo loop_10039
              F(I)=0.D0
              INEW=1
           ENDIF
        enddo loop_10037
     enddo loop_10035
     KBEG1=2
     KBEG2=0
     IF (NIT.EQ.-1.AND.(IVPL.EQ.1.OR.IREPT_FLAG.EQ.1)) THEN
        CALL SKYLIN(H,FR,JDIAG,NB,2)
        IF (NIX.NE.0.AND.YM2.GT.1.D-03) THEN
           CALL SKYLIN(H(JDIAG(NB)+1),FR(NB+1),JDIAG,NB1,2)
           KBEG2=2
        ENDIF
        CALL EXCHN(FR,BETA1,NB+NB1)
        IPR=0
        loop_10040: DO I=1,NBM*2
           IF (IPR.EQ.1) THEN
              BETA(I)=BETTOT(I+(NEL-1)*2*NBM)
           ELSE
              BETA(I)=BETTOT(I+(NEL-1)*2*NBM)+BETA1(I)
           ENDIF
        enddo loop_10040
     ELSEIF (NIT.EQ.-1) THEN
        loop_10041: DO I=1,NBM*2
           BETA(I)=BETTOT(I+(NEL-1)*2*NBM)
        enddo loop_10041
     ENDIF
     loop_10042: DO I=1,NB
        IF (IBET_CON(I,NEL).EQ.1) THEN
           loop_10043: DO J=1,NDF_CELL
              T(I,J)=0.D0
           enddo loop_10043
           loop_10044: DO J=1,NDF_INC
              T1(I,J)=0.D0
           enddo loop_10044
        ENDIF
     enddo loop_10042
     loop_10045: DO I=1,NB1
        IF (INC_CON(I).EQ.1) THEN
           loop_10046: DO J=1,NDF_INC
              T2(I,J)=0.D0
           enddo loop_10046
           loop_10047: DO J=1,NDF_CRCK
              T3(I,J)=0.D0
           enddo loop_10047
        ENDIF
     enddo loop_10045
     loop_822: DO I=1,MAX(NDF_CRCK,MAX(NDF_CELL,NDF_INC))
        IF (I.LE.NDF_CELL) THEN
           CALL SKYLIN (H,T(1,I),JDIAG,NB,KBEG1)
           KBEG1=2
        ENDIF
        IF (I.LE.NDF_INC) THEN
           CALL SKYLIN (H,T1(1,I),JDIAG,NB,KBEG1)
           IF (YM2.GT.1.E-06) THEN
              KBEG2=2
              CALL SKYLIN (H(JDIAG(NB)+1),T2(1,I),JDIAG,NB1,KBEG2)
              KBEG2=2
           ENDIF
        ENDIF
        IF (I.LE.NDF_CRCK) THEN
           CALL SKYLIN (H(JDIAG(NB)+1),T3(1,I),JDIAG,NB1,KBEG2)
        ENDIF
     enddo loop_822
     IF (NIT.EQ.-1) CALL SKYLIN(H,EZ_MAT(1,NEL),JDIAG,NB,KBEG1)
     IF (NIT.EQ.-1) CALL SKYLIN(H(JDIAG(NB)+1),EZ_COM(1,NEL),&
          JDIAG,NB1,KBEG2)    
     !     T   -1
     !***  CALCULATING [SKE]=[G] [H]  [G]******
     SKE(1:NDF_TOT,1:NDF_TOT)=0.D0
     loop_202: DO J=1,MAX(NB,NB1)
        loop_201: DO I=1,NQ
           I1=JPT(I)
           I2=I-(NQ-((NQ1-I1+1)*(NQ1-I1+2))/2)+I1-1
           IF (I1.LE.NDF_CELL) THEN
              IF (I2.LE.NDF_CELL.AND.J.LE.NB.AND.IBET_CON(J,NEL).EQ.0) THEN
                 SKCLM(I)=SKCLM(I)+TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+I1)*T(J,I2)
              ELSEIF (I2.LE.NDF_CELL+NDF_INC.AND.J.LE.NB.AND.IBET_CON(J,NEL).EQ.0) THEN
                 SKCLM(I)=SKCLM(I)-TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+I1)*T1(J,I2-NDF_CELL)
              ENDIF
           ELSEIF (I1.LE.NDF_CELL+NDF_INC) THEN
              IF (I2.LE.NDF_CELL+NDF_INC)THEN
                 IF (J.LE.NB.AND.IBET_CON(J,NEL).EQ.0) THEN
                    SKCLM(I)=SKCLM(I)+TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+I1-NDF_CELL)&
                         *T1(J,I2-NDF_CELL)
                 ENDIF
                 IF (J.LE.NB1.AND.YM2.GT.1.E-06) THEN
                    IF (INC_CON(J).EQ.0) THEN
                       SKCLM(I)=SKCLM(I)+TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+I1-NDF_CELL)&
                            *T2(J,I2-NDF_CELL)
                    ENDIF
                 ENDIF
              ELSEIF (J.LE.NB1.AND.YM2.GT.1.E-06) THEN
                 IF (INC_CON(J).EQ.0) THEN
                    SKCLM(I)=SKCLM(I)-TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+I1-NDF_CELL)&
                         *T3(J,I2-NDF_CELL-NDF_INC)
                 ENDIF
              ENDIF
           ELSEIF (J.LE.NB1.AND.YM2.GT.1.E-06) THEN
              IF (INC_CON(J).EQ.0) THEN
                 SKCLM(I)=SKCLM(I)+TMIN2(NP_TMIN2(NEL,1)+(J-1)*NP_TMIN2(NEL,4)+I1-NDF_CELL-NDF_INC)&
                      *T3(J,I2-NDF_CELL-NDF_INC)
              ENDIF
           ENDIF
        enddo loop_201
     enddo loop_202
231  FORMAT ('ske2(',I4,',',I4,')=',E25.12,';')
232  FORMAT ('phi(',I4,',',I4,')=',E25.12,';')
     loop_10049: DO I=1,NQ
        I1=JPT(I)
        I2=I-(NQ-((NQ1-I1+1)*(NQ1-I1+2))/2)+I1-1
        SKE(I1,I2)=SKCLM(I)
        SKE(I2,I1)=SKCLM(I)
     enddo loop_10049
  ENDIF
  if (nit.ne.-1000) then
     loop_206: DO I=1,NDF_TOT
        loop_207: DO J=1,MAX(NB,NB1)
           IF (I.LE.NDF_CELL.AND.J.LE.NB) THEN
              FRES(I)=FRES(I)+TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+I)*BETA(J)
              FRES9(I)=FRES9(I)+TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+I)*BETA(J)
              IF (NIT.EQ.-1) FRES(I)=FRES(I)+TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+I)&
                   *EZ_MAT(J,NEL)*EZZ_APP
              IF (NIT.EQ.-1) FRES9(I)=FRES9(I)+TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+I)&
                   *EZ_MAT(J,NEL)*EZZ_APP
           ELSEIF (I.LE.NDF_CELL+NDF_INC) THEN
              IF (YM2.GT.1.E-06.AND.J.LE.NB1) THEN
                 FRES(I)=FRES(I)+TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+I-NDF_CELL)*BETA(J+NB)
                 FRES9(I)=FRES9(I)+TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+I-NDF_CELL)*BETA(J+NB)
                 IF (NIT.EQ.-1) FRES(I)=FRES(I)+TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+I-NDF_CELL)&
                      *EZ_COM(J,NEL)*EZZ_APP
                 IF (NIT.EQ.-1) FRES9(I)=FRES9(I)+TMIN1(NP_TMIN1(NEL,1)+(J-1)*NP_TMIN1(NEL,4)+I-NDF_CELL)&
                      *EZ_COM(J,NEL)*EZZ_APP
              ENDIF
              IF (J.LE.NB) THEN
                 FRES(I)=FRES(I)-TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+I-NDF_CELL)*BETA(J)
                 FRES9(I)=FRES9(I)-TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+I-NDF_CELL)*BETA(J)
                 IF (NIT.EQ.-1) FRES(I)=FRES(I)-TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+I-NDF_CELL)&
                      *EZ_MAT(J,NEL)*EZZ_APP
                 IF (NIT.EQ.-1) FRES9(I)=FRES9(I)-TMIN(NP_TMIN(NEL,1)+(J-1)*NP_TMIN(NEL,4)+I-NDF_CELL)&
                      *EZ_MAT(J,NEL)*EZZ_APP
              ENDIF
           ELSEIF (J.LE.NB1) THEN
              FRES(I)=FRES(I)-TMIN2(NP_TMIN2(NEL,1)&
                   +(J-1)*NP_TMIN2(NEL,4)+I-NDF_CELL-NDF_INC)*BETA(J+NB)
              FRES9(I)=FRES9(I)-TMIN2(NP_TMIN2(NEL,1)&
                   +(J-1)*NP_TMIN2(NEL,4)+I-NDF_CELL-NDF_INC)*BETA(J+NB)
              IF (NIT.EQ.-1) FRES(I)=FRES(I)-TMIN2(NP_TMIN2(NEL,1)&
                   +(J-1)*NP_TMIN2(NEL,4)+I-NDF_CELL-NDF_INC)*EZ_COM(J,NEL)*EZZ_APP
              IF (NIT.EQ.-1) FRES9(I)=FRES9(I)-TMIN2(NP_TMIN2(NEL,1)&
                   +(J-1)*NP_TMIN2(NEL,4)+I-NDF_CELL-NDF_INC)*EZ_COM(J,NEL)*EZZ_APP
           ENDIF
        enddo loop_207
     enddo loop_206
  endif
  loop_991: DO I=NDF_TOT+1,NDF_TOT+6
     loop_992: DO J=1,NDF_TOT+6
        SKE(I,J)=0.E0
        SKE(J,I)=0.E0
     enddo loop_992
     SKE(I,I)=1.E0
  enddo loop_991
  CALL REASSM (NEL,NIT,NX,NIX,NIX1,FRES,SKE,IBD(NEL),IBD_ND(1,NEL),NDIM)
  IF (NIT.NE.2) THEN
     IF(NDF_CELL+NDF_INC+NDF_CRCK.GT.NSDMAX) THEN
        WRITE(*,*) "NSDMAX(=",NSDMAX,") is not enough,&
             increase it to",NDF_CELL+NDF_INC+NDF_CRCK
     ENDIF

     loop_10050: DO J=1,NDF_INC
        IF(IHGNEL(NEL).EQ.1) THEN
           loop_10051: DO I=1,NDF_INC
              PHITRAN(I,J)=PHI_HGLASS(NP_HGLASS(NEL,1)+(I-1)*NP_HGLASS(NEL,4)+J)
           enddo loop_10051
        ELSE
           loop_10052: DO I=1,NDF_INC
              PHITRAN(I,J)=0.D0
           enddo loop_10052
           PHITRAN(J,J)=1.D0
        ENDIF
     enddo loop_10050
     loop_10053: DO J=1,NDF_INC
        loop_10054: DO I=1,NDF_CELL+NDF_INC+NDF_CRCK
           SKLC(J,I)=SKE(I,J+NDF_CELL)
        enddo loop_10054
     enddo loop_10053
     loop_10055: DO J=NDF_CELL+1,NDF_CELL+NDF_INC
        loop_10056: DO I=1,NDF_CELL+NDF_INC+NDF_CRCK
           J1=J-NDF_CELL
           SKMUL(I,J1)=0.D0
           loop_10057: DO K=1,NDF_INC
              SKMUL(I,J1)=SKMUL(I,J1)+SKLC(K,I)*PHITRAN(K,J1)
           enddo loop_10057
        enddo loop_10056
     enddo loop_10055
     loop_10058: DO I=NDF_CELL+1,NDF_CELL+NDF_INC
        loop_10059: DO J=1,NDF_CELL
           SKE(J,I)=SKMUL(J,I-NDF_CELL)
        enddo loop_10059
     enddo loop_10058
     loop_10060: DO I=NDF_CELL+1,NDF_CELL+NDF_INC
        loop_10061: DO J=NDF_CELL+NDF_INC+1,NDF_CELL+NDF_INC+NDF_CRCK
           SKE(J,I)=SKMUL(J,I-NDF_CELL)
        enddo loop_10061
     enddo loop_10060
     loop_10062: DO I=NDF_CELL+1,NDF_CELL+NDF_INC
        loop_10063: DO J=1,NDF_CELL
           SKE(I,J)=SKE(J,I)
        enddo loop_10063
     enddo loop_10062
     loop_10064: DO I=NDF_CELL+1,NDF_CELL+NDF_INC
        loop_10065: DO J=NDF_CELL+NDF_INC+1,NDF_CELL+NDF_INC+NDF_CRCK
           SKE(I,J)=SKE(J,I)
        enddo loop_10065
     enddo loop_10064
     loop_10066: DO J=NDF_CELL+1,NDF_CELL+NDF_INC
        loop_10067: DO I=NDF_CELL+1,NDF_CELL+NDF_INC
           I1=I-NDF_CELL
           SKE(I,J)=0.D0
           loop_10068: DO K=1,NDF_INC
              SKE(I,J)=SKE(I,J)+PHITRAN(K,I1)*SKMUL(K+NDF_CELL,J-NDF_CELL)
           enddo loop_10068
        enddo loop_10067
     enddo loop_10066
  ENDIF
  NEL_BEG=(NEL-1)*(3*NSDMAX+2)
  loop_10069: DO I=NDF_CELL+1,NDF_CELL+NDF_INC
     FTEMP(I-NDF_CELL)=0
     FTEMP(I-NDF_CELL+NDF_INC)=0.D0
     IF(IHGNEL(NEL).EQ.1) THEN
        loop_10070: DO J=1,NDF_INC
           FTEMP(I-NDF_CELL)=FTEMP(I-NDF_CELL)+PHI_HGLASS(NP_HGLASS(NEL,1)&
                +(J-1)*NP_HGLASS(NEL,4)+I-NDF_CELL)*FRES(J+NDF_CELL)
           IF (ISOFTEL(NEL).NE.0.AND.NIT.NE.2) THEN
              FTEMP(I-NDF_CELL+NDF_INC)=FTEMP(I-NDF_CELL+NDF_INC)&
                   +PHI_HGLASS(NP_HGLASS(NEL,1)+(J-1)*NP_HGLASS(NEL,4)+I-NDF_CELL)&
                   *FRES(J+NDF_TOT+6+NDF_CELL)
           ENDIF
        enddo loop_10070
     ELSE
        FTEMP(I-NDF_CELL)=FTEMP(I-NDF_CELL)+FRES(I-NDF_CELL+NDF_CELL)
        IF (ISOFTEL(NEL).NE.0.AND.NIT.NE.2) THEN
           FTEMP(I-NDF_CELL+NDF_INC)=FTEMP(I-NDF_CELL+NDF_INC)+FRES(I-NDF_CELL+NDF_TOT+6+NDF_CELL)
        ENDIF
     ENDIF
  enddo loop_10069
  CALL EXCHN(FTEMP,FRES(NDF_CELL+1),NDF_INC)
  loop_10074: DO I=1,NDF_TOT+6
     TEMP=FRES(I+NDF_TOT+6)
     FRES(I+NDF_TOT+6)=FRES(I)
     FRES(I)=FRES(I)+TEMP
  enddo loop_10074
  IF(NDF_INC+NDF_CRCK.GT.NDFIN) THEN
     WRITE(*,*) "NDFIN (=",NDFIN,") is not enough,&
          increase it to", NDF_INC+NDF_CRCK
  ENDIF
  IF(NDF_CELL+NDF_INC+NDF_CRCK+6.GT.2*NDFIN) THEN
     WRITE(*,*) "NDFIN (=",NDFIN,") is not enough,&
          increase it to", (NDF_CELL+NDF_INC+NDF_CRCK+6)/2
  ENDIF
  DEALLOCATE(JPT)
  DEALLOCATE(BETA1,T2,H,T,T1,SKCLM,T3,H1,FTEMP,FRES9&
       ,SKMUL,PHITRAN,SKLC,HT)

  RETURN
END SUBROUTINE ESTIFO

!********************************************************************
! Statically condenses the global stiffness w.r.t. D.O.F on the
! inclusion, but not on the element boundaries.
SUBROUTINE SKYINV (NIT,JDIAG,NODE,NINT,IJK,IJK1,IJK2,SK,F)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NUMSKIO=NLM*200000)
  DIMENSION JDIAG(1),NODE(1),NINT(NLM,2),IJK(NLM,1),&
       IJK1(NLM,1),IJK2(NLM,1)
  DIMENSION SK(1),F(1)


  INTEGER, ALLOCATABLE :: JDIAG1(:)
  DOUBLE PRECISION, ALLOCATABLE :: SK1(:,:),FRES(:),FF(:),SKL(:)&
       ,SK1T(:,:),SKK(:,:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /INOUT/ SKIO(NUMSKIO),NP_SKIO(NLM,4)
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON /LOCALDOF/ IPOINT(NDFELM),NDF_CELL,NDF_INC,&
       NDF_CRCK,NADAPT_CELL,NADAPT_INC,NADAPT_CRCK
  COMMON /ADAPTATIONS/ ANGLE_ADAPT_X(NLM,200,2),ANGLE_ADAPT_Y&
       (NLM,200,2),NX_ADAPT_NX(NODM),NX_NX_ADAPT(NODM),NUM_ADAPT_X&
       (NLM,200),NUM_ADAPT_Y(NLM,200),IJK_ADAPT_X(NLM,200,2),&
       IJK_ADAPT_Y(NLM,200,2),nx_adapt
  COMMON /ADAPTOPTML/ IDIR_OPTIMIZE(NLM,200),ANGLE_OPTIMIZE(NLM,200),&
       TRAC_NORM(NLM,200,2),TRAC_FRAC_CELL_ADPX(NLM,200,2),&
       TRAC_FRAC_CELL_ADPY(NLM,200,2)
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /HPADAPTINC/ COORD_HP_INC(NLM*NSDMAX*3),INT_HP_INC&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_INC(NSMAX)
  COMMON /CRACKSOFTBOUND/ NDCRK_ADD(NLM),NDFCRK_ADD(NLM,NDELM)

  ALLOCATE(JDIAG1(NDFIN))

  ALLOCATE(FRES(NDFIN),FF(NDFIN))

  FRES=0.D0
  FF=0.D0
  JDIAG1=0.D0
  loop_100: DO NEL=1,NELX
     NUMNOD=NODE(NEL)
     NUMNOD1=NINT(NEL,1)
     NUMNOD2=NINT(NEL,2)
     NEL_BEG=(NEL-1)*(NSDMAX*3+2)
     KEL_BEG=(NEL-1)*NSDMAX*3
     NDF_CELL=INT_HP_CELL(NEL_BEG+1)
     NADAPT_CELL=NDF_CELL-NUMNOD*2
     loop_10075: DO I=1,NDF_CELL
        IPOINT(I)=INT_HP_CELL(NEL_BEG+2+I*3-2)
     enddo loop_10075
     NDF_INC=INT_HP_INC(NEL_BEG+1)
     loop_10076: DO J=1,NDF_INC
        IPOINT(NDF_CELL+J)=INT_HP_INC(NEL_BEG+J*3)
     enddo loop_10076
     NDF_CELLINC=NDF_CELL+NDF_INC
     loop_10077: DO J=1,NUMNOD2
        ND=IJK2(NEL,J)
        IPOINT(NDF_CELLINC+J*2-1)=NDGLB(ND*2-1)
        IPOINT(NDF_CELLINC+J*2)=NDGLB(ND*2)
     enddo loop_10077
     loop_10078: DO J=1,NDCRK_ADD(NEL)
        IPOINT(NDF_CELLINC+NUMNOD2*2+J)=NDFCRK_ADD(NEL,J)
     enddo loop_10078
     NDF_CRCK=2*NUMNOD2+NDCRK_ADD(NEL)
     NDF_TOT=NDF_CELL+NDF_INC+NDF_CRCK         
     IF (NUMNOD1.NE.0) THEN
        NQ1=NDF_CELL
        NQ2=NDF_INC+NDF_CRCK+6
        ALLOCATE(SK1(NQ1,NQ2))
        ALLOCATE(SK1T(NQ2,NQ1))
        ALLOCATE(SKK(NQ1,NQ1))
        ALLOCATE(SKL((NQ2*(NQ2+1))/2))
        SK1=0.D0
        SK1T=0.D0
        SKK=0.D0
        loop_1: DO I=1,NQ2
           JDIAG1(I)=(I*(I+1))/2
        enddo loop_1
        SKL(1)=SKIO(NP_SKIO(NEL,1)+(1-1)*NP_SKIO(NEL,4)+1)
        NPT=(NEL-1)*6+1+NEQ
        FRES(1)=F(NPT)      
        loop_2: DO J=2,NQ2
           IF (J.LE.6) THEN
              NPT=(NEL-1)*6+J+NEQ
           ELSE
              NPT=IPOINT(J+NDF_CELL-6)
           ENDIF
           FRES(J)=F(NPT)
           loop_212: DO K=1,J
              JPT=JDIAG1(J)-(J-K)
              SKL(JPT)=SKIO(NP_SKIO(NEL,1)+(K-1)*NP_SKIO(NEL,4)+J)
           enddo loop_212
        enddo loop_2
        loop_21: DO I=1,NQ1
           loop_211: DO J=1,NQ2
              SK1(I,J)=SKIO(NP_SKIO(NEL,1)+(J-1)*NP_SKIO(NEL,4)+I+NQ2)
           enddo loop_211
        enddo loop_21
        IDEBUG=0
        IF(IDEBUG.EQ.1) THEN
           open(432,file="fres.dat")
           loop_10079: DO J=1,NQ2
              read(432,*) FRES(J)
           enddo loop_10079
           close(432)
        ENDIF
        IF (NIT.NE.2) THEN
           CALL TRANSPOSE (NQ1,NQ2,SK1,SK1T,NQ1,NQ2)
           CALL SKYLIN (SKL,SK1T,JDIAG1,NQ2,0)
           loop_3: DO I=2,NQ1
              CALL SKYLIN (SKL,SK1T(1,I),JDIAG1,NQ2,2)
           enddo loop_3
           CALL MATMUL (NQ1,NQ2,NQ1,SK1,SK1T,SKK,NQ1,NQ2,&
                NQ1)
           CALL SKYLIN (SKL,FRES,JDIAG1,NQ2,2)
           CALL MATMUL (NQ1,NQ2,1,SK1,FRES,FF,NQ1,NDFIN,&
                NDFIN)
        ELSE
           CALL MATMUL (NQ1,NQ2,1,SK1,FRES,FF,NQ1,NDFIN,&
                NDFIN)
        ENDIF
        loop_4: DO IJ=1,NDF_CELL
           IJ1=IPOINT(IJ)
           F(IJ1)=F(IJ1)-FF(IJ)
           IF (NIT.NE.2) THEN
              loop_5: DO KL=1,NDF_CELL
                 KL1=IPOINT(KL)
                 IF (KL1.LE.IJ1) THEN
                    JPT=JDIAG(IJ1)-(IJ1-KL1)
                    SK(JPT)=SK(JPT)-SKK(KL,IJ)
                 ENDIF
              enddo loop_5
           ENDIF
        enddo loop_4
        IF (NIT.NE.2) THEN
           loop_8: DO I=1,NQ1
              loop_6: DO J=1,NQ2
                 IF (I.EQ.NQ1) THEN
                    loop_7: DO K=1,J-1
                       SKIO(NP_SKIO(NEL,1)+(K-1)*NP_SKIO(NEL,4)+J)=SKL(JDIAG1(J)-(J-K))
                    enddo loop_7
                    SKIO(NP_SKIO(NEL,1)+(J-1)*NP_SKIO(NEL,4)+J)=SKL(JDIAG1(J))
                 ENDIF
                 SKIO(NP_SKIO(NEL,1)+(J-1)*NP_SKIO(NEL,4)+I+NQ2)=SK1T(J,I)
              enddo loop_6
           enddo loop_8
        ENDIF
        DEALLOCATE(SK1,SK1T,SKK,SKL)
     ENDIF
  enddo loop_100

  DEALLOCATE(JDIAG1)

  DEALLOCATE(FRES,FF)
  RETURN
END SUBROUTINE SKYINV

!********************************************************************
! Complete the inversion of the stiffness*DU1 = F system w.r.t 
! internal(DU1) D.O.F  given the displacement variable.
SUBROUTINE INTEXT (NODE,NINT,IJK,IJK1,IJK2,DU,F)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NUMSKIO=NLM*200000)
  DIMENSION NODE(1),NINT(NLM,2),IJK(NLM,1),IJK1(NLM,1),&
       IJK2(NLM,1),DU(1),F(1)


  INTEGER, ALLOCATABLE :: JDIAG(:)
  DOUBLE PRECISION, ALLOCATABLE :: SK(:),SK1(:,:),FF(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /INOUT/ SKIO(NUMSKIO),NP_SKIO(NLM,4)
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON /COMNOD/ NODCOM(NLM,NDELM,4)
  COMMON /LOCALDOF/ IPOINT(NDFELM),NDF_CELL,NDF_INC,&
       NDF_CRCK,NADAPT_CELL,NADAPT_INC,NADAPT_CRCK
  COMMON /ADAPTATIONS/ ANGLE_ADAPT_X(NLM,200,2),ANGLE_ADAPT_Y&
       (NLM,200,2),NX_ADAPT_NX(NODM),NX_NX_ADAPT(NODM),NUM_ADAPT_X&
       (NLM,200),NUM_ADAPT_Y(NLM,200),IJK_ADAPT_X(NLM,200,2),&
       IJK_ADAPT_Y(NLM,200,2),nx_adapt
  COMMON /ADAPTOPTML/ IDIR_OPTIMIZE(NLM,200),ANGLE_OPTIMIZE(NLM,200),&
       TRAC_NORM(NLM,200,2),TRAC_FRAC_CELL_ADPX(NLM,200,2),&
       TRAC_FRAC_CELL_ADPY(NLM,200,2)
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /HPADAPTINC/ COORD_HP_INC(NLM*NSDMAX*3),INT_HP_INC&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_INC(NSMAX)
  COMMON /CRACKSOFTBOUND/ NDCRK_ADD(NLM),NDFCRK_ADD(NLM,NDELM)
  ALLOCATE(JDIAG(NDFIN))
  JDIAG=0

  loop_1: DO I=1,NELX
     IF (NINT(I,1).NE.0) THEN
        NUMNOD=NODE(I)
        NUMNOD1=NINT(I,1)
        NUMNOD2=NINT(I,2)
        NEL_BEG=(I-1)*(NSDMAX*3+2)
        KEL_BEG=(I-1)*NSDMAX*3
        NDF_CELL=INT_HP_CELL(NEL_BEG+1)
        NADAPT_CELL=NDF_CELL-NUMNOD*2
        loop_10080: DO J=1,NDF_CELL
           IPOINT(J)=INT_HP_CELL(NEL_BEG+2+J*3-2)
        enddo loop_10080
        NDF_INC=INT_HP_INC(NEL_BEG+1)
        loop_10081: DO J=1,NDF_INC
           IPOINT(NDF_CELL+J)=INT_HP_INC(NEL_BEG+J*3)
        enddo loop_10081
        NDF_CELLINC=NDF_CELL+NDF_INC
        loop_10082: DO J=1,NUMNOD2
           ND=IJK2(I,J)
           IPOINT(NDF_CELLINC+J*2-1)=NDGLB(ND*2-1)
           IPOINT(NDF_CELLINC+J*2)=NDGLB(ND*2)
        enddo loop_10082
        loop_10083: DO J=1,NDCRK_ADD(I)
           IPOINT(NDF_CELLINC+NUMNOD2*2+J)=NDFCRK_ADD(I,J)
        enddo loop_10083
        NDF_CRCK=2*NUMNOD2+NDCRK_ADD(I)
        NDF_TOT=NDF_CELL+NDF_INC+NDF_CRCK         
        loop_2: DO J=1,NDF_INC+NDF_CRCK+6
           JDIAG(J)=(J*(J+1))/2
        enddo loop_2
        ALLOCATE(SK(JDIAG(NDF_INC+NDF_CRCK+6)))
        ALLOCATE(SK1(NDF_INC+NDF_CRCK+6,NDF_CELL))
        ALLOCATE(FF(NDF_INC+NDF_CRCK+6))
        loop_3: DO J=1,NDF_INC+NDF_CRCK
           JJ=IPOINT(J+NDF_CELL)
           loop_4: DO K=1,NDF_CELL
              SK1(J+6,K)=-SKIO(NP_SKIO(I,1)+(J+6-1)*NP_SKIO(I,4)+NDF_INC+NDF_CRCK+6+K)
           enddo loop_4
           loop_5: DO K=1,J+5
              SK(JDIAG(J+6)-(J+6-K))=SKIO(NP_SKIO(I,1)+(K-1)*NP_SKIO(I,4)+J+6)
           enddo loop_5
           SK(JDIAG(J+6))=SKIO(NP_SKIO(I,1)+(J+6-1)*NP_SKIO(I,4)+J+6)
           FF(J+6)=F(JJ)
31         CONTINUE
        enddo loop_3
        loop_33: DO J=1,6
           FF(J)=F(NEQ+(I-1)*6+J)
           loop_34: DO K=1,NDF_CELL
              SK1(J,K)=-SKIO(NP_SKIO(I,1)+(J-1)*NP_SKIO(I,4)+K+NDF_INC+NDF_CRCK+6)
           enddo loop_34
           loop_36: DO K=1,J-1
              SK(JDIAG(J)-(J-K))=SKIO(NP_SKIO(I,1)+(K-1)*NP_SKIO(I,4)+J)
           enddo loop_36
           SK(JDIAG(J))=SKIO(NP_SKIO(I,1)+(J-1)*NP_SKIO(I,4)+J)
        enddo loop_33
        CALL SKYLIN(SK,FF,JDIAG,NDF_INC+NDF_CRCK+6,2)
        loop_6: DO J=1,NDF_INC+NDF_CRCK
           loop_61: DO KL=1,NDF_CELL
              KL1=IPOINT(KL)
              FF(J+6)=FF(J+6)+SK1(J+6,KL)*DU(KL1)
           enddo loop_61
        enddo loop_6
        loop_67: DO J=1,6
           ND=NEQ+(I-1)*6+J
           DU(ND)=FF(J)
           loop_68: DO KL=1,NDF_CELL
              KL1=IPOINT(KL)
              DU(ND)=DU(ND)+SK1(J,KL)*DU(KL1)
           enddo loop_68
        enddo loop_67
        loop_7: DO K=1,NDF_INC+NDF_CRCK
           IPT=IPOINT(K+NDF_CELL)
           IF (K.LE.NDF_INC) THEN
              IF (IPT.LE.NX_CELL*2) THEN
                 IPT=0
              ENDIF
           ELSEIF (K.GT.NDF_INC.AND.K.LE.NDF_INC+NUMNOD2*2) THEN
              KD=(K-NDF_INC-1)/2+1
              KK1=1
              loop_10084: DO WHILE (KK1.LE.NDF_INC.AND.IPT.NE.0) 
                 IF (IPOINT(KK1+NDF_CELL).EQ.IPT) THEN
                    IPT=0
                 ELSE
                    KK1=KK1+1
                 ENDIF
              enddo loop_10084
           ELSE
              IPT=0
           ENDIF
           IF (IPT.NE.0) THEN                  
              DU(IPT)=FF(K+6)
           ENDIF
        enddo loop_7
        DEALLOCATE(SK,SK1,FF)
     ELSE
        loop_8: DO J=1,6
           DU(NEQ+(I-1)*6+J)=0.E0
        enddo loop_8
     ENDIF
  enddo loop_1
  DEALLOCATE(JDIAG)
  RETURN
END SUBROUTINE INTEXT

!********************************************************************
SUBROUTINE HMAT(NIT,NITT,H,F,FR,BETA,NEL,NB,NX,NIX,NIX1,MP1,MP2)
  !********************************************************************

  !     CALCULATE A MATRIX WHICH IS =MT*ES*H*ES*M INTEGRATED
  !     OVER THE PARTICULATE VOLUME FOR ALL THE ELEMENTS
  !          
  !       GPX,GPX    S & T COORDINATES OF 3X3 INTEGRATION PTS  WITHIN
  !                  A PARTICULATE
  !       
  !       GWX,GWY    CORRESPONDING WEIGHT FACTORS
  !       DETJ       DETERMINANT OF JACOBIAN AT CORRESPONDING S & T

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  DIMENSION H(1),F1(NBM),F2(NBM),BETA(1),&
       FR(1),F(1)     
  DIMENSION SC1(MAX(INTM,INTC)*3*3)

  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /BETACONLC1/ IBET_CONLC(NBM)
  COMMON /PLNST/ KPLS
  COMMON /MATPR/ YM1,YM2,PR1,PR2
  COMMON /PROP/ YM,PR
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /EPSCOM/ STNCOM(NLM*INTC*4),STNCOMST(NLM*INTC*4)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /PLPCOM/ VMCOM(NLM*INTC),EPLSCOM(NLM*INTC)&
       ,DEPLSCOM(NLM*INTC),NPLCOM(NLM*INTC)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /STRAIN/ STRN(4)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /PLLC/ NPLCM(NLM*INTM),NPLCC(NLM*INTC)
  COMMON /INTLOPBG/ HYP1(INTM),HYP2(INTM),VMLC(INTM),STRP(INTM,4),SN1(INTM*4)
  COMMON /ELEPROP/ PROMAT(16,10),MPE(NLM),MPG(NLM)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /WLTBASEC/ DPOSW(NLM*NBM,2),NPBG_WLT(NLM),SSIGXG(NLM*NBM),SSIGYG(NLM*NBM),IWORP(NLM),IBET_WLTC(NBM,NLM)
  COMMON /WLTBASEM/ DPOSWM(NLM*NBM,2),NPBG_WLTM(NLM),SSIGXGM(NLM*NBM),SSIGYGM(NLM*NBM),IBET_WLTM(NBM,NLM)
  COMMON /INCBETA/  NBETA_INC(NLM),NBETA_DIF(NLM)
  ! ASSEMBLING HMATRIX
  SC1=0.D0
  IND=NDIV(NEL)
  IF (NX.NE.0) THEN
     MP=MP1
     YM=YM1
     PR=PR1
     NINPT=NINTM(NEL)
     CALL UPDAT2(NEL,NINPT,NITT,NIT,MP,SC1)
     CALL HMATIN(NEL,NINPT,NIT,NITT,NB,SC1,H,F1)
  ELSE
     CALL AZERO1(F1,NB)
  ENDIF
  MP=MP2
  YM=YM2
  PR=PR2
  IF(MP.EQ.3) THEN
     !This can be used to set the properties for second kind of particle.     
     YM=PROMAT(1,3)
     PR=PROMAT(2,3)
  ENDIF
  NBDIF=NB_ADP_COM(NEL)-NB_ADP_MAT(NEL)
  NB1=NB-NCYLFLAG(NEL,1)*NTRMADD(NEL,1)+NBDIF
  NBEG=(NB*(NB+1))/2+1
  IF (NX.EQ.0) NBEG=1
  IF (NIX.NE.0.AND.YM.GT.1.E-6) THEN
     NINPT=NINTC(NEL)
     CALL UPDAT21(NEL,NINPT,NITT,NIT,MP,SC1)
     CALL HMATIN1(NEL,NINPT,NIT,NITT,NB1,SC1,H(NBEG),F2)       
  ELSE
     CALL AZERO1(F2,NB1)
  ENDIF
  KBEG=0
  IF (NX.NE.0) THEN
     KBEG=NB
     loop_43: DO I=1,NB
        FR(I)=BETA(NB+1)*F(I)+F1(I)
        IF (IBET_CONLC(I).EQ.1) THEN
           FR(I)=0.D0
        ENDIF
     enddo loop_43
  ENDIF
  IF (NIX.NE.0.AND.YM.GT.1.E-06) THEN
     loop_44: DO I=1,NB1
        FR(I+KBEG)=F(I+KBEG)+F2(I)
     enddo loop_44
  ELSEIF (YM.LE.1.E-06) THEN
     CALL AZERO1(H(NBEG),(NB1*(NB1+1))/2)
  ENDIF
  RETURN
END SUBROUTINE HMAT

!********************************************************************
! This subroutine modifies the load vector depending on VBC1
SUBROUTINE NBOUND1(NIT,SK,F,DU,JDIAG,NBC1,VBC1,NODE,&
     NINT,IJK,IJK1,IJK2,NBOUD1) 
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (NODPER=NDELM)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NUMSKIO=NLM*200000)
  ! PURPOSE:
  !     MODIFY COEFFICIENT MATRIX BY PUTTING ZEROS IN THE
  !     ROWS AND COLUMNS OF SK, CORRESPONDING TO THE CONSTRAINED 
  !     D.O.F.THE DIAGONAL OF SUCH ROWS AND COLUMNS ARE SET TO '1'. 
  !     MODIFY THE LOAD VECTOR DEPENDING UPON VBC1
  DIMENSION SK(1),JDIAG(1),NBC1(1),VBC1(1),F(1),IJK2(NLM,1),&
       DU(1),NINT(NLM,2),IJK(NLM,1),IJK1(NLM,1),NODE(1)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL   
  COMMON /INOUT/ SKIO(NUMSKIO),NP_SKIO(NLM,4)
  COMMON /FSTBND/ IFST(NLM,NODPER+1,2),VFST(NLM,NODPER+1,2)
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON /LOCALDOF/ IPOINT(NDFELM),NDF_CELL,NDF_INC,&
       NDF_CRCK,NADAPT_CELL,NADAPT_INC,NADAPT_CRCK
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /ADAPTATIONS/ ANGLE_ADAPT_X(NLM,200,2),ANGLE_ADAPT_Y&
       (NLM,200,2),NX_ADAPT_NX(NODM),NX_NX_ADAPT(NODM),NUM_ADAPT_X&
       (NLM,200),NUM_ADAPT_Y(NLM,200),IJK_ADAPT_X(NLM,200,2),&
       IJK_ADAPT_Y(NLM,200,2),nx_adapt
  COMMON /ADAPTOPTML/ IDIR_OPTIMIZE(NLM,200),ANGLE_OPTIMIZE(NLM,200),&
       TRAC_NORM(NLM,200,2),TRAC_FRAC_CELL_ADPX(NLM,200,2),&
       TRAC_FRAC_CELL_ADPY(NLM,200,2)
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /HPADAPTINC/ COORD_HP_INC(NLM*NSDMAX*3),INT_HP_INC&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_INC(NSMAX)
  COMMON/TVGPARAM/ RHOF_TVG(NDFM),IDOF_TVG(20),IFORCE_TVG(NDFM,2)
  COMMON /ARCLPARAM/ ALPH,DALPH,DUTEMPARC(NDFM),DUARC(NDFM),DUIN(NDFM),DUIN1(NDFM),DLTOT,IARCL
  loop_1: DO I=1,NBOUD1
     ND=NBC1(I*3-2)
     loop_2: DO J=1,2
        NFX=NBC1(I*3-2+J)
        IF (NFX.EQ.0) cycle loop_2
        IF(ND.GT.NX_CELL) THEN
           NDG=ND*2+J-1
        ELSE
           NDG=(ND-1)*2+J
        ENDIF
        JDG=JDIAG(NDG)
        IF (NDG.EQ.1) GO TO 3
        loop_4: DO K=JDIAG(NDG-1)+1,JDIAG(NDG)
           KG=NDG-(JDG-K)
           IDO=1
           IF (IDO.EQ.1.AND.NIT.NE.2) THEN
              F(KG)=F(KG)-SK(K)*(ALPH*VBC1((I-1)*2+J)-DU(NDG))
              DUARC(KG)=DUARC(KG)-SK(K)*VBC1((I-1)*2+J)
              SK(K)=0.E0
           ENDIF
        enddo loop_4
3       IF (NIT.NE.2) SK(JDG)=1.
        loop_5: DO KG=NDG+1,NEQ1
           IDO=1
           IF (IDO.EQ.1) THEN
              JDF=JDIAG(KG)-(KG-NDG)
              IF (JDF.LE.JDIAG(KG-1).OR.NIT.EQ.2) cycle loop_5
              F(KG)=F(KG)-SK(JDF)*(ALPH*VBC1((I-1)*2+J)-DU(NDG))
              DUARC(KG)=DUARC(KG)-SK(JDF)*VBC1((I-1)*2+J)
              SK(JDF)=0.E0
           ENDIF
        enddo loop_5
     enddo loop_2
  enddo loop_1
  loop_6: DO I=1,NBOUD1
     loop_611: DO J=1,2
        IF (NBC1(I*3-2+J).EQ.0) cycle loop_611
        IF(NBC1(I*3-2).GT.NX_CELL) THEN
           NDG=NBC1(I*3-2)*2+J-1
        ELSE
           NDG=(NBC1(I*3-2)-1)*2+J
        ENDIF
        F(NDG)=ALPH*VBC1((I-1)*2+J)-DU(NDG)
        DUARC(NDG)=vbc1((i-1)*2+j)
     enddo loop_611
  enddo loop_6
  IF (NIT.NE.2) THEN
     loop_7: DO NEL=1,0
        NEL_BEG=(NEL-1)*(3*NSDMAX+2)
        NDF_EL=INT_HP_CELL(NEL_BEG+1)
        IF (NINT(NEL,1).NE.0) THEN
           IF (IFST(NEL,NDF_EL+1,1).EQ.1) THEN                  
              NUMNOD=NODE(NEL)
              NEL_BEG=(NEL-1)*(NSDMAX*3+2)
              KEL_BEG=(NEL-1)*NSDMAX*3
              NDF_CELL=INT_HP_CELL(NEL_BEG+1)
              NADAPT_CELL=NDF_CELL-NUMNOD*2
              loop_10085: DO I=1,NDF_CELL
                 IPOINT(I)=INT_HP_CELL(NEL_BEG+2+I*3-2)
              enddo loop_10085
              NDF_INC=INT_HP_INC(NEL_BEG+1)
              NDF_CRCK=2*NINT(NEL,2)
              NDF_TOT=NDF_CELL+NDF_INC+NDF_CRCK
              NDF_CELLINC=NDF_CELL+NDF_INC
              loop_10086: DO I=1,NDF_INC
                 IPOINT(NDF_CELL+I)=INT_HP_INC(NEL_BEG+I*3)
              enddo loop_10086
              loop_10087: DO I=1,NINT(NEL,2)
                 ND=IJK2(NEL,I)
                 ND1=NDGLB(ND*2-1)
                 ND2=NDGLB(ND*2)
                 IPOINT(NDF_CELLINC+I*2-1)=ND1
                 IPOINT(NDF_CELLINC+I*2)=ND2
              enddo loop_10087
              loop_8: DO I=1,NDF_CELL
                 IF (IFST(NEL,I,1).EQ.1) THEN
                    NQ2=NDF_INC+NINT(NEL,2)*2+6
                    VF=VFST(NEL,I,1)
                    IJ1=INT_HP_CELL(NEL_BEG+I*3)
                    IJ=I
                    loop_9: DO J=NDF_CELL+1,NDF_CELLINC
                       JK=(J-NDF_CELL)+6
                       JK1=IPOINT(J)
                       F(JK1)=F(JK1)-SKIO(NP_SKIO(NEL,1)+(JK-1)*NP_SKIO(NEL,4)+IJ+NQ2)*&
                            (VF-DU(IJ1))
                       SKIO(NP_SKIO(NEL,1)+(JK-1)*NP_SKIO(NEL,4)+IJ+NQ2)=0.E0
                    enddo loop_9
                    loop_88: DO J=NDF_CELLINC+1,NDF_TOT
                       JK=(J-NDF_CELLINC)
                       JK1=IPOINT(J)
                       F(JK1)=F(JK1)-SKIO(NP_SKIO(NEL,1)+(JK-1)*NP_SKIO(NEL,4)+IJ+NQ2)*&
                            (VF-DU(IJ1))
                       SKIO(NP_SKIO(NEL,1)+(JK-1)*NP_SKIO(NEL,4)+IJ+NQ2)=0.E0
                    enddo loop_88
                    loop_10: DO JK=1,6
                       JK1=NEQ+(NEL-1)*6+JK
                       F(JK1)=F(JK1)-SKIO(NP_SKIO(NEL,1)+(JK-1)*NP_SKIO(NEL,4)+IJ+NQ2)*&
                            (VF-DU(IJ1))
                       SKIO(NP_SKIO(NEL,1)+(JK-1)*NP_SKIO(NEL,4)+IJ+NQ2)=0.E0
                    enddo loop_10
                 ENDIF
              enddo loop_8
           ENDIF
        ENDIF
     enddo loop_7
  ENDIF
  RETURN
END SUBROUTINE NBOUND1

!********************************************************************
! Modify the co-effecient matrix by putting zeros in the rows and columns
! of SK corresponding to the constrained D.O.F. The diagonal of such
! rows and columns are set to 1.
SUBROUTINE NBOUND_MAC(NIT,SK,F,DU,JDIAG,NBC1,VBC1,NODE,&
     NINT,IJK,IJK1,IJK2,NBOUD1) 
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NUMSKIO=NLM*200000)

  ! PURPOSE:
  !     MODIFY COEFFICIENT MATRIX BY PUTTING ZEROS IN THE
  !     ROWS AND COLUMNS OF SK, CORRESPONDING TO THE CONSTRAINED 
  !     D.O.F.THE DIAGONAL OF SUCH ROWS AND COLUMNS ARE SET TO '1'. 
  !     MODIFY THE LOAD VECTOR DEPENDING UPON VBC1
  DIMENSION SK(1),JDIAG(1),NBC1(1),VBC1(1),F(1),IJK2(NLM,1),&
       DU(1),NINT(NLM,2),IJK(NLM,1),IJK1(NLM,1),NODE(1)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL   
  COMMON /INOUT/ SKIO(NUMSKIO),NP_SKIO(NLM,4)
  COMMON /FSTBND/ IFST(NLM,NODPER+1,2),VFST(NLM,NODPER+1,2)
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)
  COMMON /LOCALDOF/ IPOINT(NDFELM),NDF_CELL,NDF_INC,&
       NDF_CRCK,NADAPT_CELL,NADAPT_INC,NADAPT_CRCK
  COMMON /MACSTN/ NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /ADAPTATIONS/ ANGLE_ADAPT_X(NLM,200,2),ANGLE_ADAPT_Y&
       (NLM,200,2),NX_ADAPT_NX(NODM),NX_NX_ADAPT(NODM),NUM_ADAPT_X&
       (NLM,200),NUM_ADAPT_Y(NLM,200),IJK_ADAPT_X(NLM,200,2),&
       IJK_ADAPT_Y(NLM,200,2),nx_adapt
  COMMON /ADAPTOPTML/ IDIR_OPTIMIZE(NLM,200),ANGLE_OPTIMIZE(NLM,200),&
       TRAC_NORM(NLM,200,2),TRAC_FRAC_CELL_ADPX(NLM,200,2),&
       TRAC_FRAC_CELL_ADPY(NLM,200,2)
  COMMON /BOUNDCURVE/ ABD_CRV,BBD_CRV,ANBD_CRV,&
       XBD_CRV,YBD_CRV,IBD_CRV
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /HPADAPTINC/ COORD_HP_INC(NLM*NSDMAX*3),INT_HP_INC&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_INC(NSMAX)
  loop_1: DO I=1,NBOUD_MAC
     NDG=ND_MAC(NBC_MAC(I))
     JDG=JDIAG(NDG)
     IF (NDG.EQ.1) GO TO 3
     loop_4: DO K=JDIAG(NDG-1)+1,JDIAG(NDG)
        KG=NDG-(JDG-K)
        IDO=1
        IF (KG.LE.NX_CELL*2.AND.NDGLB(KG).NE.KG) IDO=0
        IF (IDO.EQ.1.AND.NIT.NE.2) THEN
           F(KG)=F(KG)-SK(K)*(VBC_MAC(I)-DU(NDG))
           SK(K)=0.E0
        ENDIF
     enddo loop_4
3    IF (NIT.NE.2) SK(JDG)=1.
     loop_5: DO KG=NDG+1,NEQ1
        IDO=1
        IF (KG.LE.NX_CELL*2.AND.NDGLB(KG).NE.KG) IDO=0
        IF (IDO.EQ.1) THEN
           JDF=JDIAG(KG)-(KG-NDG)
           IF (JDF.LE.JDIAG(KG-1).OR.NIT.EQ.2) cycle loop_5
           F(KG)=F(KG)-SK(JDF)*(VBC_MAC(I)-DU(NDG))
           SK(JDF)=0.E0
        ENDIF
     enddo loop_5
2    CONTINUE
  enddo loop_1
  loop_6: DO I=1,NBOUD_MAC
     NDG=ND_MAC(NBC_MAC(I))
     F(NDG)=VBC_MAC(I)-DU(NDG)
  enddo loop_6
  IF (NIT.NE.2) THEN
     loop_7: DO NEL=1,0
        IF (IBD(NEL).EQ.1) THEN
           NUMNOD=NODE(NEL)
           NEL_BEG=(NEL-1)*(NSDMAX*3+2)
           KEL_BEG=(NEL-1)*NSDMAX*3
           NDF_CELL=INT_HP_CELL(NEL_BEG+1)
           NADAPT_CELL=NDF_CELL-NUMNOD*2
           loop_10088: DO I=1,NDF_CELL
              IPOINT(I)=INT_HP_CELL(NEL_BEG+2+I*3-2)
           enddo loop_10088
           NDF_INC=INT_HP_INC(NEL_BEG+1)
           NDF_CRCK=2*NINT(NEL,2)
           NDF_TOT=NDF_CELL+NDF_INC+NDF_CRCK
           NDF_CELLINC=NDF_CELL+NDF_INC
           loop_10089: DO I=1,NDF_INC
              IPOINT(NDF_CELL+I)=INT_HP_INC(NEL_BEG+I*3)
           enddo loop_10089
           loop_10090: DO I=1,NINT(NEL,2)
              ND=IJK2(NEL,I)
              ND1=NDGLB(ND*2-1)
              ND2=NDGLB(ND*2)
              IPOINT(NDF_CELLINC+I*2-1)=ND1
              IPOINT(NDF_CELLINC+I*2)=ND2
           enddo loop_10090
           loop_8: DO I=1,NBOUD_MAC
              IJ1=ND_MAC(NBC_MAC(I))
              IJ=INT_HP_CELL(NEL_BEG+2)+NBC_MAC(I)
              VF=VBC_MAC(I)-DU(IJ1)                        
              NQ2=NDF_INC+2*NINT(NEL,2)+6
              loop_9: DO J=NDF_CELL+1,NDF_TOT
                 JK=(J-NDF_CELL)+6
                 JK1=IPOINT(J)
                 F(JK1)=F(JK1)-SKIO(NP_SKIO(NEL,1)+(JK-1)*NP_SKIO(NEL,4)+IJ+NQ2)*&
                      (VF)
                 SKIO(NP_SKIO(NEL,1)+(JK-1)*NP_SKIO(NEL,4)+IJ+NQ2)=0.E0
              enddo loop_9
              loop_10: DO JK=1,6
                 JK1=NEQ+(NEL-1)*6+JK
                 F(JK1)=F(JK1)-SKIO(NP_SKIO(NEL,1)+(JK-1)*NP_SKIO(NEL,4)+IJ+NQ2)*VF
                 SKIO(NP_SKIO(NEL,1)+(JK-1)*NP_SKIO(NEL,4)+IJ+NQ2)=0.E0
              enddo loop_10
           enddo loop_8
        ENDIF
     enddo loop_7
  ENDIF
  RETURN
END SUBROUTINE NBOUND_MAC

!********************************************************************
! Subroutine applies the secondary boundary conditions.
SUBROUTINE BOUND2(F,NLOAD,VLOAD,NDF,LFDR)                 
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /BOUNPRM/ NDGLB(NODM*2),IDGLB(NODM*2)

  DIMENSION F(1),NLOAD(1),VLOAD(NDF,1)                      
  loop_100: DO I=1,LFDR
     NODE = NLOAD(I)                                           
     loop_10091: DO J=1,ndf
        NCJ1 = NDF*(NODE -1) +J                                   
        NCJ=NDGLB (NCJ1)
        F(NCJ) = F(NCJ) +VLOAD(J,I)                               
     enddo loop_10091
  enddo loop_100
  RETURN                                                    
END SUBROUTINE BOUND2

!********************************************************************        
! Generate H_{m} and F1 for matrix element.
SUBROUTINE HMATIN (NEL,NINPT,NIT,NITT,NB,SC1,H,F1)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)      
  DIMENSION SC1(1),F1(1)
  DIMENSION H(1),JDIAG(NBM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /PLC/ PMATLC(2*INTM*3*NBM)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /INTLOPBG/ HYP1(INTM),HYP2(INTM),VMLC(INTM),STRP(INTM,4),&
       SN1(INTM*4)
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /PROPTRANS/ EZ_MAT(NBM,NLM),EZ_COM(NBM,NLM)
  COMMON /PROPTRANSLCMAT/ PRMAT_X(INTM),PRMAT_Y(INTM),PRMAT_XY&
       (INTM)
  COMMON /PROPTRANSLCCOM/ PRCOM_X(INTC),PRCOM_Y(INTC),PRCOM_XY&
       (INTC)
  COMMON /BETACONST/ IBET_TOT(NLM),IBET_CON(NBM,NLM)
  COMMON /HMATRIX/ HMAT(NLM*NBM*(NBM+1))
  COMMON /ELASFLAG/ IELASTIC
  COMMON /BETACONLC/ IBET_CONLC(NBM)
  COMMON /INSTT/ NPLINM(NLM*INTM),NPLINC(NLM*INTC)
  COMMON /REPTPARAM/ EMAC(3),IREPT_FLAG,KSTR1,KSTR2,IREPT(4),&
       JREPT(4),KD1_BD(NODM),KD2_BD(NODM),NEL_KD1(NODM,2),&
       NEL_KD2(NODM,2)
  MUL=3*NBM
  NPT=0
  loop_28: DO J=1,NB
     EZ_MAT(J,NEL)=0.D0
     F1(J)=0.E0
  enddo loop_28
  IF (NIT.EQ.-1.AND.IVPL.NE.1.AND.IREPT_FLAG.EQ.0) GOTO 1
  I1PT=0
  loop_5: DO I1=1,NINPT
     NPT=(I1-1)*3*NBM
     I1PT=(I1-1)*4
     J1PT=(NPBG(NEL)+I1-1)*4
     GJ=GJACOB(NPBG(NEL)+I1)
     SNX=SN1(I1PT+1)
     SNY=SN1(I1PT+2)
     SNXY=SN1(I1PT+3)
     loop_2: DO J=1,NB
        IF (NIT.NE.-1.OR.IVPL.EQ.1) THEN
           PMX=PMATLC(NPT+J*3-2)*SNX
           PMY=PMATLC(NPT+J*3-1)*SNY
           PMXY=PMATLC(NPT+J*3)*SNXY
           F1(J)=F1(J)-(PMX+PMY+PMXY)*GJ
        ENDIF
        IF (IREPT_FLAG.EQ.1) THEN
           PMX=PMATLC(NPT+J*3-2)*EMAC(1)
           PMY=PMATLC(NPT+J*3-1)*EMAC(2)
           PMXY=PMATLC(NPT+J*3)*EMAC(3)*2.D0               
           F1(J)=F1(J)+(PMX+PMY+PMXY)*GJ
        ENDIF
     enddo loop_2
  enddo loop_5
1 IF (NITT.EQ.2) RETURN
  NPT=0
  NBEG=(NEL-1)*NBM*(NBM+1)
  loop_6: DO J=1,(NB*(NB+1))/2
     IF (J.LE.NB) THEN
        JDIAG(J)=(J*(J+1))/2
     ENDIF
     H(J)=HMAT(NBEG+J)
  enddo loop_6
  I13=0
  loop_44: DO I3=1,NINPT
     GJ=GJACOB(NPBG(NEL)+I3)
     NPT=(I3-1)*MUL
     I13=(I3-1)*9
     I23=0
     IF (GJ.GT.1.E-10) THEN
        J=1
        loop_10092: DO J1=1,NB
           PMX1=PMATLC(NPT+J1*3-2)*GJ
           PMY1=PMATLC(NPT+J1*3-1)*GJ
           PMXY1=PMATLC(NPT+J1*3)*GJ
           loop_10093: DO J2=1,J1
              IF (IBET_CON(J1,NEL).NE.1.AND.IBET_CON(J2,NEL).NE.1) THEN
                 IF (NPLINM(NPBG(NEL)+I3).EQ.1) THEN 
                    PMX2=PMATLC(NPT+J2*3-2)
                    PMY2=PMATLC(NPT+J2*3-1)
                    PMXY2=PMATLC(NPT+J2*3)
                    H_tmp=PMX1*(SC1(I13+1)*PMX2+SC1(I13+2)*PMY2+SC1(I13+3)*PMXY2)
                    H_tmp=h_tmp+PMY1*(SC1(I13+4)*PMX2+SC1(I13+5)*PMY2+SC1(I13+6)*PMXY2)
                    H_tmp=H_tmp+PMXY1*(SC1(I13+7)*PMX2+SC1(I13+8)*PMY2+SC1(I13+9)*PMXY2)
                    H(J)=H(J)+H_tmp
                 ENDIF
              ENDIF
              J=J+1
           enddo loop_10093
           EZ_MAT(J1,NEL)=EZ_MAT(J1,NEL)+(PMX1*PRMAT_X(I3)+&
                PMY1*PRMAT_Y(I3)+PMXY1*PRMAT_XY(I3))
        enddo loop_10092
     ENDIF

  enddo loop_44
  loop_10094: DO I=1,NB
     IF (IBET_CON(I,NEL).EQ.1) THEN
        H(JDIAG(I))=1.D0
     ENDIF
  enddo loop_10094
  RETURN
END SUBROUTINE HMATIN

!********************************************************************
SUBROUTINE HMATIN1 (NEL,NINPT,NIT,NITT,NB,SC1,H,F1)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)      
  DIMENSION SC1(1),F1(1)
  DIMENSION H(1),JDIAG(NBM)
  COMMON /EPSMAT/ STNMAT(NLM*INTM*4),STNMATST(NLM*INTM*4)
  COMMON /EPSCOM/ STNCOM(NLM*INTC*4),STNCOMST(NLM*INTC*4)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /PLM/ PCOMLC(INTC*3*NBM)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /INTLOPBG1/ HYP11(INTC),HYP21(INTC),VMLC1(INTC),&
       STRP1(INTC,4),SN11(INTC*4)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /PROPTRANS/ EZ_MAT(NBM,NLM),EZ_COM(NBM,NLM)
  COMMON /PROPTRANSLCMAT/ PRMAT_X(INTM),PRMAT_Y(INTM),PRMAT_XY&
       (INTM)
  COMMON /PROPTRANSLCCOM/ PRCOM_X(INTC),PRCOM_Y(INTC),PRCOM_XY&
       (INTC)
  COMMON /REPTPARAM/ EMAC(3),IREPT_FLAG,KSTR1,KSTR2,IREPT(4),&
       JREPT(4),KD1_BD(NODM),KD2_BD(NODM),NEL_KD1(NODM,2),&
       NEL_KD2(NODM,2)
  MUL=3*NBM
  NPT=0
  loop_28: DO J=1,NB
     F1(J)=0.E0
     EZ_COM(J,NEL)=0.D0
  enddo loop_28
  IF (NIT.EQ.-1.AND.IREPT_FLAG.EQ.0) GOTO 1
  I1PT=0
  loop_5: DO I1=1,NINPT
     NPT=(I1-1)*MUL
     I1PT=(I1-1)*4         
     J1PT=(NPBM(NEL)+I1-1)*4
     GJ=GJACOM(NPBM(NEL)+I1)
     SNX=SN11(I1PT+1)
     SNY=SN11(I1PT+2)
     SNXY=SN11(I1PT+3)
     loop_2: DO J=1,NB
        IF (NIT.NE.-1) THEN
           PMX=PCOMLC(NPT+J*3-2)*SNX
           PMY=PCOMLC(NPT+J*3-1)*SNY
           PMXY=PCOMLC(NPT+J*3)*SNXY
           F1(J)=F1(J)-(PMX+PMY+PMXY)*GJ
        ENDIF
        IF (IREPT_FLAG.EQ.1) THEN
           PMX=PCOMLC(NPT+J*3-2)*EMAC(1)
           PMY=PCOMLC(NPT+J*3-1)*EMAC(2)
           PMXY=PCOMLC(NPT+J*3)*EMAC(3)*2.D0
           F1(J)=F1(J)+(PMX+PMY+PMXY)*GJ
        ENDIF
     enddo loop_2
  enddo loop_5
1 IF (NITT.EQ.2) RETURN
  NPT=0
  loop_6: DO J=1,(NB*(NB+1))/2
     IF (J.LE.NB) THEN
        JDIAG(J)=(J*(J+1))/2
     ENDIF
     H(J)=0.E0
  enddo loop_6
  I13=0
  loop_44: DO I3=1,NINPT
     NPT=(I3-1)*MUL
     I13=(I3-1)*9
     GJ=GJACOM(NPBM(NEL)+I3)
     J=1
     loop_10103: DO J1=1,NB
        PMX1=PCOMLC(NPT+J1*3-2)*GJ
        PMY1=PCOMLC(NPT+J1*3-1)*GJ
        PMXY1=PCOMLC(NPT+J1*3)*GJ
        loop_10104: DO J2=1,J1
           PMX2=PCOMLC(NPT+J2*3-2)
           PMY2=PCOMLC(NPT+J2*3-1)
           PMXY2=PCOMLC(NPT+J2*3)
           H_tmp=PMX1*(SC1(I13+1)*PMX2+SC1(I13+2)*PMY2+SC1(I13+3)*PMXY2)
           H_tmp=H_tmp+PMY1*(SC1(I13+4)*PMX2+SC1(I13+5)*PMY2+SC1(I13+6)*PMXY2)
           H_tmp=H_tmp+PMXY1*(SC1(I13+7)*PMX2+SC1(I13+8)*PMY2+SC1(I13+9)*PMXY2)
           H(J)=H(J)+H_tmp
           J=J+1
        enddo loop_10104
        EZ_COM(J1,NEL)=EZ_COM(J1,NEL)+(PMX1*PRCOM_X(I3)+&
             PMY1*PRCOM_Y(I3)+PMXY1*PRCOM_XY(I3))
     enddo loop_10103
  enddo loop_44
  RETURN
END SUBROUTINE HMATIN1

!********************************************************************
! Calclate the stress increment for the given beta increment.
SUBROUTINE STGUES (NEL,NUMNOD,NUMNOD1,NB,BETA)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NLM_SOFT=40000)

  DIMENSION BETA(1),BET1(NBM),BET2(NBM)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /INTBEGNSOFT/ NPBG_SOFT(NLM_SOFT),NINTM_SOFT(NLM_SOFT)
  COMMON /NLOCPRMS/ XK_NLOC_S(NLM_SOFT*9)
  COMMON /NLOCPRM/ XLCHAR,XP,XQ,XK_NLOC(NLM*INTM)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /STRCOM/ STCOM(NLM*INTC*4),STCOMST(NLM*INTC*4)
  COMMON /STRMAT/ STMAT(NLM*INTM*4),STMATST(NLM*INTM*4)
  COMMON /BETAGL/ BETTOT(MAXH*NLM),BETST(MAXH*NLM),&
       BETLC(MAXH*NLM)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC) 
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /PLC/ PMATLC(2*INTM*3*NBM)
  COMMON /PLM/ PCOMLC(INTC*3*NBM)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /DAMELEM/ XDAMG(NLM),YDAMG(NLM),ORDAMG(NLM),IDAMG(NLM)
  COMMON /IQSINT1/  STRTMAX,STMAX,ISTRTMAX
  COMMON /PLPMAT/ VMMAT(NLM*INTM),EPLSMAT(NLM*INTM)&
       ,DEPLSMAT(NLM*INTM),NPLMAT(NLM*INTM)
  COMMON /VOIDDATA/ FVOID(INTM*NLM),DFVOID(INTM*NLM)
  COMMON /VOIDPARAM/ Q1,Q2,Q3,FCOL,FMAX,FMAX_MODEL
  COMMON /VOIDFAILURE/  VFRT
  COMMON /PLINTST/ DELT,IVPL,NPLINT
  COMMON /STEPNUM/ IST
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),&
       INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /ADPTMESH/ NELS_ADP,IADPT_MESH_NEL(NLM_SOFT), NELS_SUB(NLM_SOFT,4)
  COMMON /WLTBASEC/ DPOSW(NLM*NBM,2),NPBG_WLT(NLM),SSIGXG(NLM*NBM),SSIGYG(NLM*NBM),IWORP(NLM),IBET_WLTC(NBM,NLM)
  COMMON /WLTBASEM/ DPOSWM(NLM*NBM,2),NPBG_WLTM(NLM),SSIGXGM(NLM*NBM),SSIGYGM(NLM*NBM),IBET_WLTM(NBM,NLM)
  COMMON /INCBETA/  NBETA_INC(NLM),NBETA_DIF(NLM)

  FACT_COL=(FMAX_MODEL-FCOL)/(FMAX-FCOL)
  CT=1.
  ST=0.     
  loop_1: DO I=1,NBM
     IF (I.LE.NB) THEN
        BET1(I)=BETA(I)
        BET2(I)=BETA(I+NB)
        BETLC(I+(NEL-1)*2*NBM)=BETA(I)
        BETLC(I+NB+(NEL-1)*2*NBM)=BETA(I+NB)
     ELSE
        BET2(I)=BETA(I+NB)
        BETLC(I+NB+(NEL-1)*2*NBM)=BETA(I+NB)
     ENDIF
  enddo loop_1
  NBDIF=NB_ADP_COM(NEL)-NB_ADP_MAT(NEL)
  NB1=NB-NCYLFLAG(NEL,1)*NTRMADD(NEL,1)+NBDIF
  IF (NUMNOD.EQ.0) GOTO 1003
  MUL=3*NBM
  NPT=0
  NPT1=0
  STRTMAX=0.D0
  STRTMIN=1.D0
  STMAX=0.D0
  loop_10105: DO K=1,NINTM(NEL)
     NPT=(K-1)*MUL
     NPT1=(NPBG(NEL)+K-1)*4
     STMATST(NPT1+1)=0.E0
     STMATST(NPT1+2)=0.E0
     STMATST(NPT1+3)=0.E0
     IF (GJACOB(NPBG(NEL)+K).GT.1.D-10) THEN
        loop_10106: DO I=1,NB
           PRD1=PMATLC(NPT+I*3-2)*BET1(I)
           PRD2=PMATLC(NPT+I*3-1)*BET1(I)
           PRD3=PMATLC(NPT+I*3)*BET1(I)
           STMATST(NPT1+1)=STMATST(NPT1+1)+PRD1
           STMATST(NPT1+2)=STMATST(NPT1+2)+PRD2
           STMATST(NPT1+3)=STMATST(NPT1+3)+PRD3
        enddo loop_10106
     ENDIF
  enddo loop_10105
1003 IF (NUMNOD1.EQ.0) RETURN
  NPT=0
  NPT1=0
  NB2=NB1
  MUL=3*NBM
  loop_10111: DO K=1,NINTC(NEL)
     NPT=(K-1)*MUL
     NPT1=(NPBM(NEL)+K-1)*4
     STCOMST(NPT1+1)=0.E0
     STCOMST(NPT1+2)=0.E0
     STCOMST(NPT1+3)=0.E0
     loop_10112: DO I=1,NB2
        PRD1=PCOMLC(NPT+I*3-2)*BET2(I)
        PRD2=PCOMLC(NPT+I*3-1)*BET2(I)
        PRD3=PCOMLC(NPT+I*3)*BET2(I)
        STCOMST(NPT1+1)=STCOMST(NPT1+1)+PRD1
        STCOMST(NPT1+2)=STCOMST(NPT1+2)+PRD2
        STCOMST(NPT1+3)=STCOMST(NPT1+3)+PRD3
     enddo loop_10112
  enddo loop_10111
  RETURN
END SUBROUTINE STGUES

!********************************************************************
! Generate new stiffness matrix by voiding the common D.O.F.s between 
! inclusion and element boundary, use D.O.F on the element to replace
! the corresponding D.O.F on the inclusion.
SUBROUTINE REASSM (NEL,NIT,NX,NIX,NIX1,FRES,SKE,IBND,IPT_BND,NDIM)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (MXSKE=(NDFELM*(NDFELM+1))/2)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)

  DIMENSION SKE(NDIM,1),FRES(1),IPT_BND(1)


  DOUBLE PRECISION, ALLOCATABLE :: SKE1(:,:),FRES1(:),TRMUL(:,:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /COMNOD/ NODCOM(NLM,NDELM,4)
  COMMON /SYMNODE/ ICMN(NDFELM)
  COMMON /LOCALDOF/ IPOINT(NDFELM),NDF_CELL,NDF_INC,&
       NDF_CRCK,NADAPT_CELL,NADAPT_INC,NADAPT_CRCK

  NDF_TOT=NDF_CELL+NDF_INC+NDF_CRCK

  ALLOCATE(SKE1(NDF_TOT+6,NDF_TOT+6),FRES1(NDF_TOT+6),TRMUL(NDF_TOT+6,NDF_TOT+6))
  SKE1=0.D0
  FRES1=0.D0
  TRMUL=0.D0
  IPARTMAT=0
  ICRKPART=0

  loop_10113: DO I=NDF_CELL+NDF_INC+1,NDF_CELL+NDF_INC+NDF_CRCK
     IF (ICMN(I).NE.I) ICRKPART=ICRKPART+1
  enddo loop_10113
  loop_10114: DO I=NDF_CELL+1,NDF_CELL+NDF_INC
     IF (ICMN(I).NE.I) IPARTMAT=IPARTMAT+1
  enddo loop_10114
  loop_10115: DO I=1,NDF_TOT+6
     FRES1(I)=0.D0
     loop_10116: DO J=1,NDF_TOT+6
        TRMUL(I,J)=0.D0
        SKE1(I,J)=0.D0
     enddo loop_10116
  enddo loop_10115
  loop_10117: DO I=1,NDF_TOT+6
     TRMUL(I,ICMN(I))=1.D0
  enddo loop_10117
  loop_10118: DO I=1,NDF_TOT+6
     loop_10119: DO J=1,NDF_TOT+6      
        loop_10120: DO K=1,NDF_TOT+6
           IF (ICMN(K).EQ.I) THEN
              IF (J.EQ.1) FRES1(I)=FRES1(I)+FRES(K)
              IF (NIT.NE.2) SKE1(I,J)=SKE1(I,J)+SKE(K,J)
           ENDIF
        enddo loop_10120
     enddo loop_10119
  enddo loop_10118
  loop_10121: DO I=1,NDF_TOT+6
     loop_10122: DO J=1,NDF_TOT+6      
        IF (NIT.NE.2) SKE(I,J)=0.D0
        IF (J.EQ.1) FRES(I)=FRES1(I)
        IF (NIT.NE.2) THEN
           loop_10123: DO K=1,NDF_TOT+6
              IF (ICMN(K).EQ.J) THEN
                 SKE(I,J)=SKE(I,J)+SKE1(I,K)
              ENDIF
           enddo loop_10123
        ENDIF
     enddo loop_10122
  enddo loop_10121
  loop_10124: DO I=1,NDF_TOT
     IF (ICMN(I).NE.I) SKE(I,I)=1.D0
  enddo loop_10124
  DEALLOCATE(SKE1,FRES1,TRMUL)

  RETURN
END SUBROUTINE REASSM

!********************************************************************
SUBROUTINE FORCE_TVGBOUND(SK,DU,JDIAG,NIT)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  DIMENSION SK(1),DU(1),JDIAG(1)
  DIMENSION NDF_TVG(20),SKK(20,20),FK(20)
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL 
  COMMON /TVGSTIFF/ SKTVG(NDFM,20),SKTVGT(NDFM,20),FTVG(NDFM),ITVG
  COMMON/TVGPARAM/ RHOF_TVG(NDFM),IDOF_TVG(20),IFORCE_TVG(NDFM,2)
  ITVG=0
  loop_10137: DO I=1,NEQ1
     IF (IFORCE_TVG(I,1).NE.0) THEN
        ITVG=ITVG+1
        NDF_TVG(ITVG)=I      
        IF (NIT.NE.2) THEN
           CALL SKYLIN(SK,SKTVGT(1,ITVG),JDIAG,NEQ1,2)
        ENDIF
     ENDIF
  enddo loop_10137
  IF (ITVG.GT.1) THEN
     WRITE (*,*) 'PROGRAM NOT WRITTEN FOR MORE THAN ONE FORCE CONSTRAINT IN TVG BOUND.'
     STOP
  ENDIF
  loop_10138: DO I1=1,ITVG
     I=NDF_TVG(I1)
     SKK(I1,I1)=SKTVG(I,I1)-DOTPRD1(SKTVG(1,I1),SKTVGT(1,I1),NEQ1)
     FK(I1)=FTVG(I1)-DOTPRD1(SKTVG(1,I1),DU,NEQ1)
     IF (DABS(SKK(I1,I1)).LT.1.D-10) THEN
        WRITE (*,*) 'UNABLE TO SOLVE FOR TVG. BOUND D.O.F ',I
        STOP
     ENDIF
     FK(I1)=FK(I1)/SKK(I1,I1)
  enddo loop_10138
  loop_10139: DO I=1,NEQ1
     loop_10140: DO J1=1,ITVG
        J=NDF_TVG(J1)
        IF (I.NE.J) THEN
           DU(I)=DU(I)-SKTVGT(I,J1)*FK(J1)
        ELSE
           DU(I)=FK(J1)
        ENDIF
     enddo loop_10140
  enddo loop_10139
  RETURN
END SUBROUTINE FORCE_TVGBOUND
