
!********************************************************************
! Assemble total stress shape function.
SUBROUTINE PGLB(NEL,IT1,IT2,NBETA)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)      
  DIMENSION NBETA(1)
  DOUBLE PRECISION, ALLOCATABLE :: X1(:),Y1(:),PM(:),RQUAD(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /PLC/ PMATLC(2*INTM*3*NBM)
  COMMON /PLM/ PCOMLC(INTC*3*NBM)
  COMMON /IPTTY/ IDPT(NLM*INTM),XIPT(NLM*INTM),YIPT(NLM*INTM)&
       ,GJACOB(NLM*INTM)
  COMMON /IPTCKOM/ XIPTCOM(NLM*INTC),YIPTCOM(NLM*INTC)&
       ,GJACOM(NLM*INTC)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /SHPVOID/ FSCALE(NLM),CONFOUR(NLM),&
       CSFOUR(50,NLM),SNFOUR(50,NLM)
  COMMON /INTNUM/ NINTM(NLM),NINTC(NLM)
  COMMON /SCALPRM/ XCENT(NLM),YCENT(NLM),SCALE(NLM)
  COMMON /SCALPRMP/ XCENTP(NLM),YCENTP(NLM),SCALEP(NLM)
  COMMON /SCALPRMC/ XCENTPP(NLM),YCENTPP(NLM),SCALEPP(NLM)
  COMMON /SHPCRCK/ CONFOUR1(NLM),&
       CSFOUR1(20,NLM),SNFOUR1(20,NLM)
  COMMON /EDGEPRM/ NACTIVE(NLM),ICENT(NLM),NMUL(NLM)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /STPTYPM/ IST
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /BETACONST/ IBET_TOT(NLM),IBET_CON(NBM,NLM)
  NINPT=MAX(NINTM(NEL),NINTC(NEL))
  ALLOCATE(X1(NINPT),Y1(NINPT),PM(1000),RQUAD(NINPT))
  X1=0.D0
  Y1=0.D0
  PM=0.D0
  RQUAD=0.D0
  MUL=3*NBM
  IADD=MUL*INTM
  IADD1=MUL*INTC
  NPT=-IADD
  NPT1=-IADD1
  IST=IT1
  XSC=XSCALEM(NEL)
  YSC=YSCALEM(NEL)
  SC=SCALE(NEL)
  SC1=SCALEP(NEL)
  XDIF=XCENT(NEL)-XCENTP(NEL)
  YDIF=YCENT(NEL)-YCENTP(NEL)
  XDIF1=XCENTP(NEL)-XCENTPP(NEL)
  YDIF1=YCENTP(NEL)-YCENTPP(NEL)
  XDIF2=XCENT(NEL)-XCENTPP(NEL)
  YDIF2=YCENT(NEL)-YCENTPP(NEL)
  NINPT=NINTM(NEL)
  NB=NBETA(NEL)-NCYLFLAG(NEL,1)*NTRMADD(NEL,1)-NCYLFLAG(NEL,2)*&
       NTRMADD(NEL,2)+NB_ADP_MAT(NEL)
  NPT=0
  IF (IT1.GT.1) GOTO 23
  loop_1: DO I=1,NINPT
     IPT1=NPT+(I-1)*MUL
     IPT2=IPT1+NBM
     IPT3=IPT2+NBM
     XX=XIPT(NPBG(NEL)+I)
     YY=YIPT(NPBG(NEL)+I)
     IF (IT1.NE.0) THEN
        CALL GEN_VCF_P(NB,XX,YY,PM)
        loop_10000: DO INB=1,NB*3
           PMATLC(IPT1+INB)=PM(INB)
        enddo loop_10000
     ENDIF
     X1(I)=(XX*SC+XDIF)
     Y1(I)=(YY*SC+YDIF)
  enddo loop_1
  ION=0      
  IF (NCYLFLAG(NEL,1).EQ.1) THEN
     CALL PMATLOCAS (NEL,NINPT,SC,XDIF,YDIF,X1,Y1,RQUAD,NB,&
          CONFOUR(NEL),CSFOUR(1,NEL),SNFOUR(1,NEL),ION)
     NB=NB+NTRMADD(NEL,1)
  ENDIF
  ION=1
  IF (NCYLFLAG(NEL,2).EQ.1) THEN
     loop_10001: DO I=1,NINPT
        X1(I)=X1(I)+XDIF1
        Y1(I)=Y1(I)+YDIF1
     enddo loop_10001
     CALL PMATLOCAS (NEL,NINPT,SC,XDIF2,YDIF2,X1,Y1,RQUAD,NB,&
          CONFOUR(NEL),CSFOUR(1,NEL),SNFOUR(1,NEL),ION)
     NB=NB+NTRMADD(NEL,2)
  ENDIF
  IF (IT1.NE.0) THEN
     loop_10002: DO I=1,NB
        IF (IBET_CON(I,NEL).EQ.1) THEN
           loop_10003: DO J=1,NINPT
              IPT1=NPT+(J-1)*MUL+(I-1)*3
              PMATLC(IPT1+1)=0.D0
              PMATLC(IPT1+2)=0.D0
              PMATLC(IPT1+3)=0.D0
           enddo loop_10003
        ENDIF
     enddo loop_10002
  ENDIF
  NBDIF=NB_ADP_COM(NEL)-NB_ADP_MAT(NEL)
  NB=NB-NCYLFLAG(NEL,1)*NTRMADD(NEL,1)-NCYLFLAG(NEL,2)&
       *NTRMADD(NEL,2)+NBDIF
23 NPT1=0
  NINPT=NINTC(NEL)
  XSC=XSCALEI(NEL)
  YSC=YSCALEI(NEL)
  IST=IT2
  loop_3: DO I=1,NINPT
     IPT1=NPT1+(I-1)*MUL
     IPT2=IPT1+NBM
     IPT3=IPT2+NBM
     XX=XIPTCOM(NPBM(NEL)+I)
     YY=YIPTCOM(NPBM(NEL)+I)
     IF (IT2.NE.0) THEN
        CALL GEN_VCF_P(NB,XX,YY,PM)
        loop_10004: DO INB=1,NB*3
           PCOMLC(IPT1+INB)=PM(INB)
        enddo loop_10004
     ENDIF

     X1(I)=(XX*SC1+XDIF1)
     Y1(I)=(YY*SC1+YDIF1)
  enddo loop_3
  IF (NCYLFLAG(NEL,2).EQ.1) THEN
     CALL PMATLOCASS (NEL,NINPT,SC1,XDIF1,YDIF1,X1,Y1,RQUAD,NB,&
          CONFOUR1(NEL),CSFOUR1(1,NEL),SNFOUR1(1,NEL))
  ENDIF
  DEALLOCATE(X1,Y1,PM,RQUAD)
  RETURN
END SUBROUTINE PGLB

!********************************************************************
! Assemble reciprocal stress shape function.
SUBROUTINE PMATLOCAS (NEL,NINPT,SC,XDIF,YDIF,X1,Y1,RQUAD,JBEG,&
     A0,CSINT,SNNT,ION)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  DIMENSION CSINT(1),SNNT(1),X1(1),Y1(1),RQUAD(1)
  DOUBLE PRECISION, ALLOCATABLE :: F(:),DFDXX(:),DFDYY(:),DFDXY(:)&
       ,DFDY(:),DFDX(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /PLC/ PMATLC(2*INTM*3*NBM)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /CONMPDATAM/ FGM(NLM*INTM),DFDXGM(NLM*INTM),DFDYGM&
       (NLM*INTM),DFDXXGM(NLM*INTM),DFDXYGM(NLM*INTM),DFDYYGM&
       (NLM*INTM)
  COMMON /CONMPDATAMC/ FGMC(NLM*INTM),DFDXGMC(NLM*INTM),DFDYGMC&
       (NLM*INTM),DFDXXGMC(NLM*INTM),DFDXYGMC(NLM*INTM),DFDYYGMC&
       (NLM*INTM)
  COMMON /CONMPDATAC/ FGC(NLM*INTM),DFDXGC(NLM*INTM),DFDYGC&
       (NLM*INTM),DFDXXGC(NLM*INTM),DFDXYGC(NLM*INTM),DFDYYGC&
       (NLM*INTM)
  COMMON /STPTYPM/ IST
  COMMON/ELEMNT/NX,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  ALLOCATE(F(NINPT),DFDXX(NINPT),DFDYY(NINPT),DFDXY(NINPT),DFDY(NINPT),&
       DFDX(NINPT))

  F=0.D0
  DFDXX=0.D0
  DFDYY=0.D0
  DFDXY=0.D0
  DFDY=0.D0
  DFDX=0.D0
  IF (IST.EQ.0) THEN
     IF (ION.EQ.0) THEN
        XSC=XSCALEM(NEL)/1.01D0
        YSC=YSCALEM(NEL)/1.01D0
        IF (XSC.LT.YSC/00.99E0) THEN
           YSC=00.99E0*XSC
        ENDIF
        CSC=ANM(NEL)
        IF (MCRACK(NEL).EQ.1) THEN
           ITYP=1
        ELSEIF (MCRACK(NEL).EQ.2) THEN
           ITYP=2
        ELSE
           ITYP=0
        ENDIF
     ELSE
        XSC=XSCALEI(NEL)/1.05D0
        YSC=YSCALEI(NEL)/1.05D0
        CSC=ANI(NEL)
        ITYP=1
     ENDIF
     ONE=1.E0
     IF (ITYP.EQ.1) THEN
        IF (ION.EQ.0) THEN
           CALL CONMAP1(NINPT,SC,A0,CSINT,SNNT,X1,Y1,F,DFDX,&
                DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC,CSC)
        ELSE
           CALL CONMAP11(NINPT,SC,A0,CSINT,SNNT,X1,Y1,F,DFDX,&
                DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC,CSC)
        ENDIF
     ELSEIF (ITYP.EQ.2) THEN
        IF (ION.NE.0) THEN
           CALL CONMAP11(NINPT,SC,A0,CSINT,SNNT,X1,Y1,F,DFDX,&
                DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC,CSC)
        ENDIF
     ELSE
        CALL CONMAPAS (NINPT,SC,A0,CSINT,SNNT,X1,Y1,F,DFDX,&
             DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC)
     ENDIF
     NPT=NPBG(NEL)
     loop_10019: DO I=1,NINPT
        IF (ION.EQ.0) THEN
           FGM(NPT+I)=F(I)
           DFDXGM(NPT+I)=DFDX(I)
           DFDYGM(NPT+I)=DFDY(I)
           DFDXXGM(NPT+I)=DFDXX(I)
           DFDYYGM(NPT+I)=DFDYY(I)
           DFDXYGM(NPT+I)=DFDXY(I)
        ELSE
           FGMC(NPT+I)=F(I)
           DFDXGMC(NPT+I)=DFDX(I)
           DFDYGMC(NPT+I)=DFDY(I)
           DFDXXGMC(NPT+I)=DFDXX(I)
           DFDYYGMC(NPT+I)=DFDYY(I)
           DFDXYGMC(NPT+I)=DFDXY(I)
        ENDIF
     enddo loop_10019
  ELSE
     NPT6=NPBG(NEL)
     KADD=JBEG
     MUL=3*NBM
     NPT=0
     IF (ION.EQ.0) THEN
        KRD=KORD(NEL,1)
        IREC=IRECTRM(NEL,1)
     ELSE
        KRD=KORD(NEL,2)
        IREC=IRECTRM(NEL,2)
     ENDIF
     loop_31: DO NORD=0,KRD
        M=NORD
        N=0
        loop_32: DO KXYDP=1,NORD+1
           loop_42: DO IMF=NORD+1,IREC+NORD
              KADD=KADD+1
              loop_1: DO I=1,NINPT
                 NPT1=NPT+(I-1)*MUL
                 NPT2=NPT1+NBM
                 NPT3=NPT2+NBM
                 XMF=IMF-1
                 XX=(X1(I)-XDIF)/SC
                 YY=(Y1(I)-YDIF)/SC
                 IF (N.NE.0) THEN
                    YYN=YY**N
                    IF (N-1.NE.0) THEN
                       YYN1=YY**(N-1)
                       IF (N-2.NE.0) THEN
                          YYN2=YY**(N-2)
                       ELSE
                          YYN2=1.D0
                       ENDIF
                    ELSE
                       YYN1=1.D0
                       YYN2=0.D0
                    ENDIF
                 ELSE
                    YYN=1.D0
                    YYN1=0.D0
                    YYN2=0.D0
                 ENDIF
                 IF (M.NE.0) THEN
                    XXM=XX**M
                    IF (M-1.NE.0) THEN
                       XXM1=XX**(M-1)
                       IF (M-2.NE.0) THEN
                          XXM2=XX**(M-2)
                       ELSE
                          XXM2=1.D0
                       ENDIF
                    ELSE
                       XXM1=1.D0
                       XXM2=0.D0
                    ENDIF
                 ELSE
                    XXM=1.D0
                    XXM1=0.D0
                    XXM2=0.D0
                 ENDIF
                 U=XXM*YYN
                 DUX=M*XXM1*YYN
                 DUY=N*YYN1*XXM
                 DUXX=DFLOAT((M-1)*M)*XXM2*YYN
                 DUYY=DFLOAT((N-1)*N)*YYN2*XXM
                 DUXY=DFLOAT(M*N)*XXM1*YYN1
                 PWR1=XMF
                 PWR2=PWR1-1
                 PWR3=PWR2-1
                 PWR4=PWR3+1
                 IF (F(I).LE.0.E0) F(I)=1.E0
                 IF (XMF.LT.0.99D0) THEN         
                    IF (ION.EQ.0) THEN
                       FF=DLOG(FGM(NPT6+I))
                       FF1=1.D0/FGM(NPT6+I)
                       FX=FF1*DFDXGM(NPT6+I)
                       FY=FF1*DFDYGM(NPT6+I)
                       FXX=FF1*DFDXXGM(NPT6+I)-FX*FX
                       FYY=FF1*DFDYYGM(NPT6+I)-FY*FY
                       FXY=FF1*DFDXYGM(NPT6+I)-FX*FY
                    ELSE
                       FF=DLOG(FGMC(NPT6+I))
                       FF1=1.D0/FGMC(NPT6+I)
                       FX=FF1*DFDXGMC(NPT6+I)
                       FY=FF1*DFDYGMC(NPT6+I)
                       FXX=FF1*DFDXXGMC(NPT6+I)-FX*FX
                       FYY=FF1*DFDYYGMC(NPT6+I)-FY*FY
                       FXY=FF1*DFDXYGMC(NPT6+I)-FX*FY
                    ENDIF
                 ELSE
                    F00=1.D0
                    R1=1.D0
                    IF (ION.EQ.0) THEN
                       FF1=1.D0/FGM(NPT6+I)
                       FF=FF1**XMF
                       FX=-XMF*FF*FF1*DFDXGM(NPT6+I)
                       FY=-XMF*FF*FF1*DFDYGM(NPT6+I)
                       FXX=-(XMF+1)*FX*FF1*DFDXGM(NPT6+I)-&
                            XMF*FF*FF1*DFDXXGM(NPT6+I)
                       FXY=-(XMF+1)*FX*FF1*DFDYGM(NPT6+I)-&
                            XMF*FF*FF1*DFDXYGM(NPT6+I)
                       FYY=-(XMF+1)*FY*FF1*DFDYGM(NPT6+I)-&
                            XMF*FF*FF1*DFDYYGM(NPT6+I)
                    ELSE
                       FF1=1.D0/FGMC(NPT6+I)
                       FF=FF1**XMF
                       FX=-XMF*FF*FF1*DFDXGMC(NPT6+I)
                       FY=-XMF*FF*FF1*DFDYGMC(NPT6+I)
                       FXX=-(XMF+1)*FX*FF1*DFDXGMC(NPT6+I)-&
                            XMF*FF*FF1*DFDXXGMC(NPT6+I)
                       FXY=-(XMF+1)*FX*FF1*DFDYGMC(NPT6+I)-&
                            XMF*FF*FF1*DFDXYGMC(NPT6+I)
                       FYY=-(XMF+1)*FY*FF1*DFDYGMC(NPT6+I)-&
                            XMF*FF*FF1*DFDYYGMC(NPT6+I)
                    ENDIF
                 ENDIF
                 DXX=DUXX*FF+DUX*FX+DUX*FX+U*FXX
                 DXY=DUXY*FF+DUX*FY+DUY*FX+U*FXY
                 DYY=DUYY*FF+DUY*FY+DUY*FY+U*FYY
                 PMATLC(NPT1+KADD*3-2)=DYY
                 PMATLC(NPT1+KADD*3-1)=DXX
                 PMATLC(NPT1+KADD*3)=-DXY
              enddo loop_1
           enddo loop_42
           M=M-1
           N=N+1
        enddo loop_32
     enddo loop_31
  ENDIF
  IF (NEL.EQ.NELX) THEN
     REWIND (757)
     CLOSE (757)
  ENDIF
  DEALLOCATE(F,DFDXX,DFDYY,DFDXY,DFDY,DFDX)
  RETURN
END SUBROUTINE PMATLOCAS

!********************************************************************
SUBROUTINE PMATLOCAS1 (NEL,NINPT,SC,XDIF,YDIF,X1,Y1,JBEG,&
     A0,CSINT,SNNT,NIX,PMATLCB)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NTMMAX=NDFELM*15)
  DIMENSION CSINT(1),SNNT(1),X1(1),Y1(1),PMATLCB(NINPT,3,1)
  DOUBLE PRECISION, ALLOCATABLE :: F(:),DFDXX(:),DFDYY(:),DFDXY(:)&
       ,DFDY(:),DFDX(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /PLC/ PMATLC(2*INTM*3*NBM)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  ALLOCATE(F(NINPT),DFDXX(NINPT),DFDYY(NINPT),DFDXY(NINPT),DFDY(NINPT),&
       DFDX(NINPT))
  F=0.D0
  DFDXX=0.D0
  DFDYY=0.D0
  DFDXY=0.D0
  DFDY=0.D0
  DFDX=0.D0

  IF (NIX.EQ.0) THEN
     XSC=XSCALEM(NEL)/1.01D0
     YSC=YSCALEM(NEL)/1.01D0   
     IF (XSC.LT.YSC/00.99E0) THEN
        YSC=00.99E0*XSC
     ENDIF
     CSC=ANM(NEL)
     KRD=KORD(NEL,1)
     IREC=IRECTRM(NEL,1)
     ITYP=MCRACK(NEL)
  ELSE
     XSC=XSCALEI(NEL)/1.05D0
     YSC=YSCALEI(NEL)/1.05D0
     CSC=ANI(NEL)
     KRD=KORD(NEL,2)
     IREC=IRECTRM(NEL,2)
     ITYP=1
  ENDIF
  A1=(XSC-YSC)/2
  A2=(XSC+YSC)/2
  ONE=1.E0
  IF (ITYP.EQ.1) THEN
     IF (NIX.EQ.0) THEN
        CALL CONMAP14(NINPT,SC,A0,CSINT,SNNT,X1,Y1,F,DFDX,&
             DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC,CSC)
     ELSE
        CALL CONMAP15(NINPT,SC,A0,CSINT,SNNT,X1,Y1,F,DFDX,&
             DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC,CSC)
     ENDIF
  ELSEIF (ITYP.EQ.2) THEN
     IF (NIX.NE.0) THEN
        CALL CONMAP15(NINPT,SC,A0,CSINT,SNNT,X1,Y1,F,DFDX,&
             DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC,CSC)
     ENDIF
  ELSE
     CALL CONMAPAS (NINPT,SC,A0,CSINT,SNNT,X1,Y1,F,DFDX,&
          DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC)
  ENDIF
  KADD=JBEG
  MUL=3*NBM
  NPT=0
  loop_31: DO NORD=0,KRD
     M=NORD
     N=0
     loop_32: DO KXYDP=1,NORD+1
        loop_42: DO IMF=NORD+1,IREC+NORD
           KADD=KADD+1
           loop_1: DO I=1,NINPT
              NPT1=NPT+(I-1)*MUL
              NPT2=NPT1+NBM
              NPT3=NPT2+NBM
              XMF=IMF-1
              XX=(X1(I)-XDIF)/SC
              YY=(Y1(I)-YDIF)/SC
              IF (N.NE.0) THEN
                 YYN=YY**N
                 IF (N-1.NE.0) THEN
                    YYN1=YY**(N-1)
                    IF (N-2.NE.0) THEN
                       YYN2=YY**(N-2)
                    ELSE
                       YYN2=1.D0
                    ENDIF
                 ELSE
                    YYN1=1.D0
                    YYN2=0.D0
                 ENDIF
              ELSE
                 YYN=1.D0
                 YYN1=0.D0
                 YYN2=0.D0
              ENDIF
              IF (M.NE.0) THEN
                 XXM=XX**M
                 IF (M-1.NE.0) THEN
                    XXM1=XX**(M-1)
                    IF (M-2.NE.0) THEN
                       XXM2=XX**(M-2)
                    ELSE
                       XXM2=1.D0
                    ENDIF
                 ELSE
                    XXM1=1.D0
                    XXM2=0.D0
                 ENDIF
              ELSE
                 XXM=1.D0
                 XXM1=0.D0
                 XXM2=0.D0
              ENDIF
              U=XXM*YYN
              DUX=M*XXM1*YYN
              DUY=N*YYN1*XXM
              DUXX=DFLOAT((M-1)*M)*XXM2*YYN
              DUYY=DFLOAT((N-1)*N)*YYN2*XXM
              DUXY=DFLOAT(M*N)*XXM1*YYN1
              PWR1=XMF
              PWR2=PWR1+1
              PWR3=PWR2+1
              PWR4=PWR3+1
              IF (F(I).LE.0.E0) F(I)=1.E0
              IF (XMF.LT.0.99D0) THEN         
                 F1=DLOG(F(I))
                 F2=1/F(I)
                 F3=-1/F(I)**2
              ELSE
                 F00=1.D0
                 F1=(1/F(I)**PWR1)*F00
                 F2=(-PWR1/F(I)**PWR2)*F00
                 F3=(PWR2*PWR1/F(I)**PWR3)*F00
              ENDIF
              PMATLCB(I,1,KADD)=(DUYY*F1+2.D0*DUY*F2*DFDY(I)+U*F3*&
                   DFDY(I)**2+U*F2*DFDYY(I))
              PMATLCB(I,2,KADD)=(DUXX*F1+2.D0*DUX*F2*DFDX(I)+U*F3*&
                   DFDX(I)**2+U*F2*DFDXX(I))
              PMATLCB(I,3,KADD)=-(DUXY*F1+DUX*F2*DFDY(I)+DUY*F2*&
                   DFDX(I)+U*F3*DFDX(I)*DFDY(I)+U*F2*DFDXY(I))
           enddo loop_1
        enddo loop_42
        M=M-1
        N=N+1
     enddo loop_32
  enddo loop_31
  DEALLOCATE(F,DFDXX,DFDYY,DFDXY,DFDY,DFDX)
  RETURN
END SUBROUTINE PMATLOCAS1

!********************************************************************
SUBROUTINE PMATLOCASS (NEL,NINPT,SC,XDIF,YDIF,X1,Y1,RQUAD,JBEG,&
     A0,CSINT,SNNT)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NTMMAX=NDFELM*15)
  DIMENSION CSINT(1),SNNT(1),X1(1),Y1(1)
  DOUBLE PRECISION, ALLOCATABLE :: F(:),DFDXX(:),DFDYY(:),DFDXY(:)&
       ,DFDY(:),DFDX(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /PLC/ PMATLC(2*INTM*3*NBM)
  COMMON /PLM/ PCOMLC(INTC*3*NBM)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /CONMPDATAC/ FGC(NLM*INTM),DFDXGC(NLM*INTM),DFDYGC&
       (NLM*INTM),DFDXXGC(NLM*INTM),DFDXYGC(NLM*INTM),DFDYYGC&
       (NLM*INTM)
  COMMON /STPTYPM/ IST
  ALLOCATE(F(NINPT),DFDXX(NINPT),DFDYY(NINPT),DFDXY(NINPT),DFDY(NINPT),&
       DFDX(NINPT))
  F=0.D0
  DFDXX=0.D0
  DFDYY=0.D0
  DFDXY=0.D0
  DFDY=0.D0
  DFDX=0.D0
  IF (IST.EQ.0) THEN
     XSC=XSCALEI(NEL)/1.05D0
     YSC=YSCALEI(NEL)/1.05D0
     A1=(XSC-YSC)/2
     A2=(XSC+YSC)/2
     ONE=1.E0
     CSC=ANI(NEL)
     CALL CONMAP12(NINPT,SC,A0,CSINT,SNNT,X1,Y1,F,DFDX,&
          DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC,CSC)
     NPT=NPBM(NEL)
     loop_10021: DO I=1,NINPT
        FGC(NPT+I)=F(I)
        DFDXGC(NPT+I)=DFDX(I)
        DFDYGC(NPT+I)=DFDY(I)
        DFDXXGC(NPT+I)=DFDXX(I)
        DFDYYGC(NPT+I)=DFDYY(I)
        DFDXYGC(NPT+I)=DFDXY(I)
     enddo loop_10021
  ELSE
     NPT6=NPBM(NEL)
     KADD=JBEG
     MUL=3*NBM
     NPT=0
     loop_31: DO NORD=0,KORD(NEL,2)
        M=NORD
        N=0
        loop_32: DO KXYDP=1,NORD+1
           loop_42: DO IMF=NORD+1,IRECTRM(NEL,2)+NORD
              KADD=KADD+1
              loop_1: DO I=1,NINPT
                 NPT1=NPT+(I-1)*MUL
                 NPT2=NPT1+NBM
                 NPT3=NPT2+NBM
                 XMF=IMF-1
                 XX=(X1(I)-XDIF)/SC
                 YY=(Y1(I)-YDIF)/SC
                 IF (N.NE.0) THEN
                    YYN=YY**N
                    IF (N-1.NE.0) THEN
                       YYN1=YY**(N-1)
                       IF (N-2.NE.0) THEN
                          YYN2=YY**(N-2)
                       ELSE
                          YYN2=1.D0
                       ENDIF
                    ELSE
                       YYN1=1.D0
                       YYN2=0.D0
                    ENDIF
                 ELSE
                    YYN=1.D0
                    YYN1=0.D0
                    YYN2=0.D0
                 ENDIF
                 IF (M.NE.0) THEN
                    XXM=XX**M
                    IF (M-1.NE.0) THEN
                       XXM1=XX**(M-1)
                       IF (M-2.NE.0) THEN
                          XXM2=XX**(M-2)
                       ELSE
                          XXM2=1.D0
                       ENDIF
                    ELSE
                       XXM1=1.D0
                       XXM2=0.D0
                    ENDIF
                 ELSE
                    XXM=1.D0
                    XXM1=0.D0
                    XXM2=0.D0
                 ENDIF
                 U=XXM*YYN
                 DUX=M*XXM1*YYN
                 DUY=N*YYN1*XXM
                 DUXX=DFLOAT((M-1)*M)*XXM2*YYN
                 DUYY=DFLOAT((N-1)*N)*YYN2*XXM
                 DUXY=DFLOAT(M*N)*XXM1*YYN1
                 PWR1=XMF
                 PWR2=PWR1-1
                 PWR3=PWR2-1
                 IF (XMF.LT.0.99D0) THEN         
                    FF=DLOG(FGC(NPT6+I))
                    FF1=1.D0/FGC(NPT6+I)
                    FX=FF1*DFDXGC(NPT6+I)
                    FY=FF1*DFDYGC(NPT6+I)
                    FXX=FF1*DFDXXGC(NPT6+I)-FX*FX
                    FYY=FF1*DFDYYGC(NPT6+I)-FY*FY
                    FXY=FF1*DFDXYGC(NPT6+I)-FX*FY
                 ELSE
                    F00=1.D0
                    R1=1.D0
                    FF1=1.D0/FGC(NPT6+I)
                    FF=FF1**XMF
                    FX=-XMF*FF*FF1*DFDXGC(NPT6+I)
                    FY=-XMF*FF*FF1*DFDYGC(NPT6+I)
                    FXX=-(XMF+1)*FX*FF1*DFDXGC(NPT6+I)-&
                         XMF*FF*FF1*DFDXXGC(NPT6+I)
                    FXY=-(XMF+1)*FX*FF1*DFDYGC(NPT6+I)-&
                         XMF*FF*FF1*DFDXYGC(NPT6+I)
                    FYY=-(XMF+1)*FY*FF1*DFDYGC(NPT6+I)-&
                         XMF*FF*FF1*DFDYYGC(NPT6+I)
                 ENDIF
                 DXX=DUXX*FF+DUX*FX+DUX*FX+U*FXX
                 DXY=DUXY*FF+DUX*FY+DUY*FX+U*FXY
                 DYY=DUYY*FF+DUY*FY+DUY*FY+U*FYY
                 PCOMLC(NPT1+KADD*3-2)=DYY
                 PCOMLC(NPT1+KADD*3-1)=DXX
                 PCOMLC(NPT1+KADD*3)=-DXY
              enddo loop_1
           enddo loop_42
           M=M-1
           N=N+1
        enddo loop_32
     enddo loop_31
  ENDIF
  DEALLOCATE(F,DFDXX,DFDYY,DFDXY,DFDY,DFDX)
  RETURN
END SUBROUTINE PMATLOCASS

!********************************************************************
SUBROUTINE PMATLOCASS1 (NEL,NINPT,SC,XDIF,YDIF,X1,Y1,JBEG,&
     A0,CSINT,SNNT,PMATLCB)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NTMMAX=NDFELM*15)
  DIMENSION CSINT(1),SNNT(1),X1(1),Y1(1),PMATLCB(NINPT,3,1)
  DOUBLE PRECISION, ALLOCATABLE :: F(:),DFDXX(:),DFDYY(:),DFDXY(:)&
       ,DFDY(:),DFDX(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /PLC/ PMATLC(2*INTM*3*NBM)
  COMMON /PLM/ PCOMLC(INTC*3*NBM)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  ALLOCATE(F(NINPT),DFDXX(NINPT),DFDYY(NINPT),DFDXY(NINPT),DFDY(NINPT),&
       DFDX(NINPT))
  F=0.D0
  DFDXX=0.D0
  DFDYY=0.D0
  DFDXY=0.D0
  DFDY=0.D0
  DFDX=0.D0

  XSC=XSCALEI(NEL)/1.05D0
  YSC=YSCALEI(NEL)/1.05D0
  A1=(XSC-YSC)/2
  A2=(XSC+YSC)/2
  ONE=1.E0
  CSC=ANI(NEL)
  CALL CONMAP13(NINPT,SC,A0,CSINT,SNNT,X1,Y1,F,DFDX,&
       DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC,CSC)
  KADD=JBEG
  MUL=3*NBM
  NPT=0
  loop_31: DO NORD=0,KORD(NEL,2)
     M=NORD
     N=0
     loop_32: DO KXYDP=1,NORD+1
        loop_42: DO IMF=NORD+1,IRECTRM(NEL,2)+NORD
           KADD=KADD+1
           loop_1: DO I=1,NINPT
              NPT1=NPT+(I-1)*MUL
              NPT2=NPT1+NBM
              NPT3=NPT2+NBM
              XMF=IMF-1
              XX=(X1(I)-XDIF)/SC
              YY=(Y1(I)-YDIF)/SC
              IF (N.NE.0) THEN
                 YYN=YY**N
                 IF (N-1.NE.0) THEN
                    YYN1=YY**(N-1)
                    IF (N-2.NE.0) THEN
                       YYN2=YY**(N-2)
                    ELSE
                       YYN2=1.D0
                    ENDIF
                 ELSE
                    YYN1=1.D0
                    YYN2=0.D0
                 ENDIF
              ELSE
                 YYN=1.D0
                 YYN1=0.D0
                 YYN2=0.D0
              ENDIF
              IF (M.NE.0) THEN
                 XXM=XX**M
                 IF (M-1.NE.0) THEN
                    XXM1=XX**(M-1)
                    IF (M-2.NE.0) THEN
                       XXM2=XX**(M-2)
                    ELSE
                       XXM2=1.D0
                    ENDIF
                 ELSE
                    XXM1=1.D0
                    XXM2=0.D0
                 ENDIF
              ELSE
                 XXM=1.D0
                 XXM1=0.D0
                 XXM2=0.D0
              ENDIF
              U=XXM*YYN
              DUX=M*XXM1*YYN
              DUY=N*YYN1*XXM
              DUXX=DFLOAT((M-1)*M)*XXM2*YYN
              DUYY=DFLOAT((N-1)*N)*YYN2*XXM
              DUXY=DFLOAT(M*N)*XXM1*YYN1
              PWR1=XMF
              PWR2=PWR1+1
              PWR3=PWR2+1
              PWR4=PWR3+1
              IF (F(I).LE.0.E0) F(I)=1.E0
              IF (XMF.LT.0.99D0) THEN         
                 F1=DLOG(F(I))
                 F2=1/F(I)
                 F3=-1/F(I)**2
              ELSE
                 F00=1.D0
                 F1=(1/F(I)**PWR1)*F00
                 F2=(-PWR1/F(I)**PWR2)*F00
                 F3=(PWR2*PWR1/F(I)**PWR3)*F00
              ENDIF
              PMATLCB(I,1,KADD)=DUYY*F1+2.D0*DUY*F2*DFDY(I)+U*F3*&
                   DFDY(I)**2+U*F2*DFDYY(I)
              PMATLCB(I,2,KADD)=DUXX*F1+2.D0*DUX*F2*DFDX(I)+U*F3*&
                   DFDX(I)**2+U*F2*DFDXX(I)
              PMATLCB(I,3,KADD)=-(DUXY*F1+DUX*F2*DFDY(I)+DUY*F2*&
                   DFDX(I)+U*F3*DFDX(I)*DFDY(I)+U*F2*DFDXY(I))
           enddo loop_1
        enddo loop_42
        M=M-1
        N=N+1
     enddo loop_32
  enddo loop_31
  DEALLOCATE(F,DFDXX,DFDYY,DFDXY,DFDY,DFDX)
  RETURN
END SUBROUTINE PMATLOCASS1

!********************************************************************
! Calculates matrices G_{e} in element NEL.
SUBROUTINE TMATLOC_MAT(NEL,YM2,A,XC,YC,A1,XCP,YCP,A2,XCCP,YCCP,&
     NX,NIX,NIX1,NB,XN,YN)  
!********************************************************************

  !  VARIABLE DEFINITION
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (NLM_SOFT=40000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (NTMMAX=NDFELM*15)
  PARAMETER (MAX_INT_ORDER=20)
  PARAMETER (NSDMAX=2*NDELM,NSMAX=2500)
  PARAMETER (NMAX_POLY=25,NM_PL=NMAX_POLY-1)
  PARAMETER (NUMTMOUT=NLM*18000,NUMTMIN=NLM*18000,NUMTMIN1=NLM*18000&
       ,NUMTMIN2=NLM*5000)
  DIMENSION XN(1),YN(1),XL(3,2)
  DIMENSION XDISC(200),YDISC(200),F_INC(200),F_CRK(200),DFDX(200),&
       DFDY(200),DFDXX(200),DFDYY(200),DFDXY(200)
  DIMENSION XSOFT_ON_BOUND(40),YSOFT_ON_BOUND(40),SSOFT_ON_SEG(40)
  DIMENSION XLC(2),YLC(2),SSTART(20),SEND(20),ISOFT_DONE(20)
  INTEGER, ALLOCATABLE :: ICOMN(:),LC_ND(:),LC_BND(:),INTERP(:),&
       INTERP_LC(:,:),ICX_IPT(:),ICY_IPT(:),IDISC(:)
  DOUBLE PRECISION, ALLOCATABLE :: XOUT(:),YOUT(:),DETOUT(:),DCS_NORM(:)&
       ,DSN_NORM(:),XLOC1(:),YLOC1(:),ANGLOC1(:),CSLOC1(:),SNLOC1(:)&
       ,XADD_ND(:),YADD_ND(:),XADD_IPT(:),YADD_IPT(:),SDISC(:,:)&
       ,SDISC_E(:,:),XLENGTH(:),XLENGTH_I(:),PM(:),PREC(:,:),PMATLCB(:,:,:)
  COMMON /MACSTN/ NBOUD_SLD,NBOUD_MAC,EZZ_APP,NBC_MAC(4),VBC_MAC(4)
  COMMON /BOUNDCURVE/ ABD_CRV,BBD_CRV,ANBD_CRV,&
       XBD_CRV,YBD_CRV,IBD_CRV
  COMMON/BOUNDARY/ JMIN_BND,ND_MAC(3),IBD(NLM),IBD_ND(NDELM,NLM)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  COMMON /GAUQUAD/ W(1275),BP(1275),INTBEG(50)
  COMMON /INTORD/ NORD(NLM),NDIV(NLM)
  COMMON /CYLFLAG/ NCYLFLAG(NLM,3)
  COMMON /GMATR/ TMOUT(NUMTMOUT), NP_TMOUT(NLM,4),&
       TMIN(NUMTMIN), NP_TMIN(NLM,4),&
       TMIN1(NUMTMIN1), NP_TMIN1(NLM,4),&
       TMIN2(NUMTMIN2), NP_TMIN2(NLM,4)
  COMMON /MAPPARAM/ NTERM,NTRMADD(NLM,3),IRECTRM(NLM,3),KORD(NLM,3)
  COMMON /SHPVOID/ FSCALE(NLM),CONFOUR(NLM),&
       CSFOUR(50,NLM),SNFOUR(50,NLM)
  COMMON /SHPCRCK/ CONFOUR1(NLM),&
       CSFOUR1(20,NLM),SNFOUR1(20,NLM)
  COMMON /EDGEPRM/ NACTIVE(NLM),ICENT(NLM),NMUL(NLM)
  COMMON /COMNOD/ NODCOM(NLM,NDELM,4)
  COMMON /INCSCALE/ XSCALEM(NLM),YSCALEM(NLM),ANM(NLM),MCRACK(NLM)
  COMMON /CRKSCALE/ XSCALEI(NLM),YSCALEI(NLM),ANI(NLM),ICRACK(NLM)
  COMMON /ADAPTATIONS/ ANGLE_ADAPT_X(NLM,200,2),ANGLE_ADAPT_Y&
       (NLM,200,2),NX_ADAPT_NX(NODM),NX_NX_ADAPT(NODM),NUM_ADAPT_X&
       (NLM,200),NUM_ADAPT_Y(NLM,200),IJK_ADAPT_X(NLM,200,2),&
       IJK_ADAPT_Y(NLM,200,2),nx_adapt
  COMMON /ADAPTOPTML/ IDIR_OPTIMIZE(NLM,200),ANGLE_OPTIMIZE(NLM,200),&
       TRAC_NORM(NLM,200,2),TRAC_FRAC_CELL_ADPX(NLM,200,2),&
       TRAC_FRAC_CELL_ADPY(NLM,200,2)
  COMMON /HPADAPTCELL/ COORD_HP_CELL(NLM*NSDMAX*3),INT_HP_CELL&
       (NLM*(NSDMAX*3+2)),IHP_ADAPT_CELL(NSMAX)
  COMMON /LAGRPOLY/ PRD((NMAX_POLY*(NMAX_POLY+1))/2),&
       IPRD(NM_PL)
  COMMON /BETAADAPT/ NB_ADP_MAT(NLM),NB_ADP_COM(NLM)
  COMMON /BETACONST/ IBET_TOT(NLM),IBET_CON(NBM,NLM)
  COMMON /DISCSETUP/ IJK_SETUP(NLM)
  COMMON /SOFTEL/ COORD_HP_SOFT(NLM_SOFT*18),&
       INT_HP_SOFT(NLM_SOFT*(18)),NEL_SOFT
  COMMON /SOFTBOUNDARY/ IDOSOFT(NDFELM)
  COMMON /WLTBASEC/ DPOSW(NLM*NBM,2),NPBG_WLT(NLM),SSIGXG(NLM*NBM),SSIGYG(NLM*NBM),IWORP(NLM),IBET_WLTC(NBM,NLM)
  COMMON /WLTBASEM/ DPOSWM(NLM*NBM,2),NPBG_WLTM(NLM),SSIGXGM(NLM*NBM),SSIGYGM(NLM*NBM),IBET_WLTM(NBM,NLM)
  COMMON/ELEMNT/NX1,NELX,NEQ,NEQ1,NEQ2,NPLANE,NX_CELL
  ALLOCATE(ICOMN(NDELM*2),LC_ND(NDFELM),LC_BND(NDFELM),INTERP(NDFELM)&
       ,INTERP_LC(NDFELM,NMAX_POLY),ICX_IPT(NTMMAX),ICY_IPT(NTMMAX)&
       ,IDISC(NDFELM))
  ICOMN=0
  LC_ND=0
  LC_BND=0
  INTERP=0
  INTERP_LC=0
  ICX_IPT=0
  ICY_IPT=0
  IDISC=0
  ALLOCATE(XOUT(NTMMAX),YOUT(NTMMAX),DETOUT(NTMMAX),DCS_NORM(NDFELM*50)&
       ,DSN_NORM(NDFELM*50),XLOC1(NDFELM),YLOC1(NDFELM),ANGLOC1(NDFELM)&
       ,CSLOC1(NDFELM),SNLOC1(NDFELM),XADD_ND(NDFELM),YADD_ND(NDFELM)&
       ,XADD_IPT(NTMMAX),YADD_IPT(NTMMAX),SDISC(NDFELM,200)&
       ,SDISC_E(NDFELM,200),XLENGTH(NDFELM),XLENGTH_I(NDFELM),PM(1000)&
       ,PREC(3,NBM*INTM))
  XOUT=0.D0
  YOUT=0.D0
  DETOUT=0.D0
  DCS_NORM=0.D0
  DSN_NORM=0.D0
  XLOC1=0.D0
  YLOC1=0.D0
  ANGLOC1=0.D0
  CSLOC1=0.D0
  SNLOC1=0.D0
  XADD_ND=0.D0
  YADD_ND=0.D0
  XADD_IPT=0.D0
  YADD_IPT=0.D0
  SDISC=0.D0
  SDISC_E=0.D0
  XLENGTH=0.D0
  XLENGTH_I=0.D0
  PM=0.D0
  PREC=0.D0
  JTHETA=IJK_SETUP(NEL)
  IK=NCYLFLAG(NEL,1)*(KORD(NEL,1)+IRECTRM(NEL,1)+1)
  IF (IK.LT.NCYLFLAG(NEL,2)*(KORD(NEL,2)+IRECTRM(NEL,2)+1)) IK=&
       NCYLFLAG(NEL,2)*(KORD(NEL,2)+IRECTRM(NEL,2)+1)
  IF (IK.NE.0) THEN
     JDIV=4
  ELSE
     JDIV=0
  ENDIF
  ISOFT_ON_BOUND=0

  A0=CONFOUR(NEL)
  XCC=XC
  YCC=YC
  SC=A
  SC1=A1
  XDIF=XCC-XCP
  YDIF=YCC-YCP
  XDIF1=XCP-XCCP
  YDIF1=YCP-YCCP
  XDIF2=XCC-XCCP
  YDIF2=YCC-YCCP
  NUMIN=0
  NUMNOD=NX
  CONV_DEG_RAD=DATAN(1.D0)/4.5D1
  NEL_BEG=(NEL-1)*(NSDMAX*3+2)
  KEL_BEG=(NEL-1)*NSDMAX*3
  NDF_CELL=INT_HP_CELL(NEL_BEG+1)
  ND_TOT=INT_HP_CELL(NEL_BEG+2)
  LC_ND=0
  LC_BND=0
  loop_10023: DO I=1,ND_TOT
     ANGLOC1(I)=COORD_HP_CELL(KEL_BEG+(I-1)*3+1)
     XLOC1(I)=COORD_HP_CELL(KEL_BEG+(I-1)*3+2)
     YLOC1(I)=COORD_HP_CELL(KEL_BEG+(I-1)*3+3)         
     LC_BND(I)=INT_HP_CELL(NEL_BEG+I*3+1)
     LC_ND(I)=INT_HP_CELL(NEL_BEG+I*3+2)
  enddo loop_10023
  NPT=100
  IONE=1
  loop_10024: DO I=1,ND_TOT
     I1=I+1-(I/ND_TOT)*ND_TOT
     XLC(1)=XLOC1(I)
     XLC(2)=XLOC1(I1)
     YLC(1)=YLOC1(I)
     YLC(2)=YLOC1(I1)
     NOUT_IN=0
     NIN_OUT=0
     XLENGTH(I)=0.D0
     IF (NIN_OUT.GT.1.OR.NOUT_IN.GT.1) THEN
        WRITE (*,*) 'IMPOSSIBLE IN_OUT (or OUT_IN)'
        WRITE (*,*) NOUT_IN,NIN_OUT
        STOP
     ENDIF
     IDISC(I)=0
     NSEGMENT=0
     KFL=0
     SNOW=-1.D0
     SFIN=1.D0
     JNOW=-1
     JEND=-1
     loop_10029: DO WHILE (KFL.EQ.0)
        NSEGMENT=NSEGMENT+1
        SSTART(NSEGMENT)=SNOW
        JTRAN=-1
        SMIN=1.D1
        IF (JTRAN.EQ.-1) THEN
           SEND(NSEGMENT)=SFIN
           SH1=(1.D0-SFIN)*0.5D0
           SH2=(1.D0+SFIN)*0.5D0
           XX1=SH1*XLC(1)+SH2*XLC(2)
           YY1=SH1*YLC(1)+SH2*YLC(2)
           SH1=0.D0
           SH2=1.D0
           XX2=SH1*XLC(1)+SH2*XLC(2)
           YY2=SH1*YLC(1)+SH2*YLC(2)
           loop_10031: DO K=1,14
              SS=BP(INTBEG(14)+K)
              WW=W(INTBEG(14)+K)
              DS1=-0.5D0
              DS2=0.5D0
              DXS=DS1*XX1+DS2*XX2
              DYS=DS1*YY1+DS2*YY2
              DS=DSQRT(DXS*DXS+DYS*DYS)
              XLENGTH(I)=XLENGTH(I)+DS*WW
           enddo loop_10031
           KFL=1
        ELSE
           SEND(NSEGMENT)=SMIN
           SH1=(1.D0-SMIN)*0.5D0
           SH2=(1.D0+SMIN)*0.5D0
           XX1=SH1*XLC(1)+SH2*XLC(2)
           YY1=SH1*YLC(1)+SH2*YLC(2)
           SNOW=SSOFT_ON_SEG(JTRAN*2)
           SH1=(1.D0-SNOW)*0.5D0
           SH2=(1.D0+SNOW)*0.5D0
           XX2=SH1*XLC(1)+SH2*XLC(2)
           YY2=SH1*YLC(1)+SH2*YLC(2)
           loop_10032: DO K=1,14
              SS=BP(INTBEG(14)+K)
              WW=W(INTBEG(14)+K)
              DS1=-0.5D0
              DS2=0.5D0
              DXS=DS1*XX1+DS2*XX2
              DYS=DS1*YY1+DS2*YY2
              DS=DSQRT(DXS*DXS+DYS*DYS)
              XLENGTH(I)=XLENGTH(I)+DS*WW
           enddo loop_10032
           ISOFT_DONE(JTRAN)=0
           JNOW=JTRAN
        ENDIF
     enddo loop_10029
     loop_10033: DO KSEGMENT=1,NSEGMENT
        SH1=(1.D0-SSTART(KSEGMENT))*0.5D0
        SH2=(1.D0+SSTART(KSEGMENT))*0.5D0
        XB_SEG=SH1*XLOC1(I)+SH2*XLOC1(I1)
        YB_SEG=SH1*YLOC1(I)+SH2*YLOC1(I1)
        SH1=(1.D0-SEND(KSEGMENT))*0.5D0
        SH2=(1.D0+SEND(KSEGMENT))*0.5D0
        XE_SEG=SH1*XLOC1(I)+SH2*XLOC1(I1)
        YE_SEG=SH1*YLOC1(I)+SH2*YLOC1(I1)
        XD=XE_SEG-XB_SEG
        YD=YE_SEG-YB_SEG
        loop_10034: DO J=1,100
           XDISC(J)=XB_SEG+(J-1)*XD/9.9D+01-XCP
           YDISC(J)=YB_SEG+(J-1)*YD/9.9D+01-YCP
        enddo loop_10034
        IF (NCYLFLAG(NEL,1).EQ.1) THEN
           A0=CONFOUR(NEL)
           XSC=XSCALEM(NEL)
           YSC=YSCALEM(NEL)
           CSC=ANM(NEL)
           IF (MCRACK(NEL).EQ.1) THEN
              CALL CONMAP1(NPT,SC,A0,CSFOUR(1,NEL),SNFOUR(1,NEL),&
                   XDISC,YDISC,F_INC,DFDX,DFDY,DFDXY,DFDXX,DFDYY,&
                   XSC,YSC,CSC)
           ELSE
              CALL CONMAPAS (NPT,SC,A0,CSFOUR(1,NEL),SNFOUR(1,NEL),&
                   XDISC,YDISC,F_INC,DFDX,DFDY,DFDXY,DFDXX,DFDYY,XSC&
                   ,YSC)
           ENDIF
        ELSE
           loop_10035: DO J=1,100
              F_INC(J)=1.D+05
           enddo loop_10035
        ENDIF
        IF (NCYLFLAG(NEL,2).EQ.1) THEN
           loop_10036: DO J=1,100
              XDISC(J)=XDISC(J)+XDIF1
              YDISC(J)=YDISC(J)+YDIF1
           enddo loop_10036
           A0=CONFOUR(NEL)
           XSC=XSCALEI(NEL)
           YSC=YSCALEI(NEL)
           CSC=ANI(NEL)
           CALL CONMAP1(NPT,SC,A0,CSFOUR(1,NEL),SNFOUR(1,NEL),XDISC,&
                YDISC,F_CRK,DFDX,DFDY,DFDXY,DFDXX,DFDYY,XSC,YSC,CSC)
        ELSE
           loop_10037: DO J=1,100
              F_CRK(J)=1.D+05
           enddo loop_10037
        ENDIF
        IDISC(I)=IDISC(I)+1
        SDISC(I,IDISC(I))=SSTART(KSEGMENT)
        FI_BEG=F_INC(1)
        IF (FI_BEG.GT.2.D0) THEN
           II_BEG=5
        ELSEIF (FI_BEG.GT.1.4D0) THEN
           II_BEG=4
        ELSEIF (FI_BEG.GT.1.2D0) THEN
           II_BEG=3
        ELSEIF (FI_BEG.GT.1.1D0) THEN
           II_BEG=2
        ELSE
           II_BEG=1
        ENDIF
        FC_BEG=F_CRK(1)         
        IF (FC_BEG.GT.2.D0) THEN
           IC_BEG=5
        ELSEIF (FC_BEG.GT.1.4D0) THEN
           IC_BEG=4
        ELSEIF (FC_BEG.GT.1.2D0) THEN
           IC_BEG=3
        ELSEIF (FC_BEG.GT.1.1D0) THEN
           IC_BEG=2
        ELSE
           IC_BEG=1
        ENDIF
        loop_10038: DO J=2,99
           FI_END=F_INC(J)
           FC_END=F_CRK(J)
           IF (FI_END.GT.2.D0) THEN
              II_END=5
           ELSEIF (FI_END.GT.1.4D0) THEN
              II_END=4
           ELSEIF (FI_END.GT.1.2D0) THEN
              II_END=3
           ELSEIF (FI_END.GT.1.1D0) THEN
              II_END=2
           ELSE
              II_END=1
           ENDIF
           IF (FC_END.GT.2.D0) THEN
              IC_END=5
           ELSEIF (FC_END.GT.1.4D0) THEN
              IC_END=4
           ELSEIF (FC_END.GT.1.2D0) THEN
              IC_END=3
           ELSEIF (FC_END.GT.1.1D0) THEN
              IC_END=2
           ELSE
              IC_END=1
           ENDIF
           IF (IC_BEG.NE.IC_END) THEN
              SLC=-1.D0+2.D0*(J-1)/9.9D+01
              SLC=SSTART(KSEGMENT)+(1.D0+SLC)*0.5D0*&
                   (SEND(KSEGMENT)-SSTART(KSEGMENT))
              SDISC_E(I,IDISC(I))=SLC
              IDISC(I)=IDISC(I)+1
              SDISC(I,IDISC(I))=SLC
           ELSEIF (II_BEG.NE.II_END) THEN
              SLC=-1.D0+2.D0*(J-1)/9.9D+01
              SLC=SSTART(KSEGMENT)+(1.D0+SLC)*0.5D0*&
                   (SEND(KSEGMENT)-SSTART(KSEGMENT))
              SDISC_E(I,IDISC(I))=SLC
              IDISC(I)=IDISC(I)+1
              SDISC(I,IDISC(I))=SLC
           ENDIF
           IC_BEG=IC_END
           II_BEG=II_END
        enddo loop_10038
        SDISC_E(I,IDISC(I))=SEND(KSEGMENT)
     enddo loop_10033
  enddo loop_10024
  loop_10039: DO I=1,ND_TOT
     INTERP(I)=1
     INTERP_LC(I,1)=I
  enddo loop_10039
  loop_10040: DO I=ND_TOT+IBD(NEL)*3+1,NDF_CELL
     ISIDE=INT_HP_CELL(NEL_BEG+I*3+1)
     INTERP(ISIDE)=INTERP(ISIDE)+1
     INTERP_LC(ISIDE,INTERP(ISIDE))=I
     IF (LC_ND(ISIDE).EQ.1.OR.LC_ND(ISIDE).EQ.4) THEN
        LC_ND(I)=6
     ELSE
        LC_ND(I)=7
     ENDIF
  enddo loop_10040
  loop_10041: DO I=1,ND_TOT
     INTERP(I)=INTERP(I)+1
     INEXT=I+1
     IF (INEXT.GT.ND_TOT) INEXT=1
     IFLAG=0
     loop_10042: DO WHILE (IFLAG.EQ.0) 
        IF (((LC_ND(INEXT)-LC_ND(I))/3)*3+LC_ND(I).EQ.LC_ND(INEXT)) &
             THEN
           IFLAG=1
        ELSE
           INEXT=INEXT+1
           IF (INEXT.GT.ND_TOT) THEN
              INEXT=1
           ENDIF
        ENDIF
     enddo loop_10042
     INTERP_LC(I,INTERP(I))=INEXT
     IFLAG=0
     IC=1
     loop_10043: DO WHILE (IFLAG.EQ.0)
        IF (IC.GT.INTERP(I)) THEN
           IFLAG=1
           IC=IC-1
        ELSE
           IF (LC_ND(I).LT.3) THEN
              IC=IC+1
           ELSE
              IFLAG=1
           ENDIF
        ENDIF
     enddo loop_10043
     ANGLE=ANGLOC1(INTERP_LC(I,IC))*CONV_DEG_RAD
     CSLOC1(I)=DCOS(ANGLE)
     SNLOC1(I)=DSIN(ANGLE)
  enddo loop_10041
  XSC=XSCALEM(NEL)
  YSC=YSCALEM(NEL)
  CSC=ANM(NEL)
  CSC1=ANM(NEL)*DATAN(1.D0)/4.5D1
  CS6=DCOS(CSC1)
  SN6=DSIN(CSC1)
  XSC1=XSCALEI(NEL)
  YSC1=YSCALEI(NEL)
  CSC2=ANI(NEL)
  CSC3=ANI(NEL)*DATAN(1.D0)/4.5D1
  CS8=DCOS(CSC3)
  SN8=DSIN(CSC3)
  loop_77: DO I=1,ND_TOT+NIX
     ICOMN(I)=0
  enddo loop_77
  NINPT=(ND_TOT)*NORD(NEL)
  OPEN (647,FILE='tmat_out.dat')
  IC_X=1
  IC_Y=2
  N1=0
  loop_20: DO N=1,ND_TOT
     NAFT=N+1-(N/ND_TOT)*ND_TOT
     X0=XLOC1(N)
     Y0=YLOC1(N)
     X1=XLOC1(NAFT)
     Y1=YLOC1(NAFT)
     XMID=(X1+X0)*0.5D0
     YMID=(Y1+Y0)*0.5D0
     IF (IBD_CRV.GE.1) THEN
        ANG=DATAN2(YMID,XMID)
        XMID=DCOS(ANG)
        YMID=DSIN(ANG)
     ENDIF
     IF (LC_ND(N).EQ.1.OR.LC_ND(N).EQ.4) THEN
        IC_X=N
     ELSE
        IC_Y=N
     ENDIF
     loop_10044: DO K=1,IDISC(N)
        K1=K+1
        SDIF=(SDISC_E(N,K)-SDISC(N,K))*0.5D0
        XX1=(1.D0+SDISC(N,K))*0.5D0*X1+(1.D0-SDISC(N,K))*0.5D0*X0
        YY1=(1.D0+SDISC(N,K))*0.5D0*Y1+(1.D0-SDISC(N,K))*0.5D0*Y0
        XX2=(1.D0+SDISC_E(N,K))*0.5D0*X1+(1.D0-SDISC_E(N,K))*0.5D0&
             *X0
        YY2=(1.D0+SDISC_E(N,K))*0.5D0*Y1+(1.D0-SDISC_E(N,K))*0.5D0&
             *Y0
        loop_10045: DO I7=1,NORD(NEL)
           N1=N1+1
           ICX_IPT(N1)=IC_X
           ICY_IPT(N1)=IC_Y
           S=BP(INTBEG(NORD(NEL))+I7)
           WF=W(INTBEG(NORD(NEL))+I7)
           XAC=XX1*(1.D0-S)/2.E0+XX2*(1+S)/2.E0
           YAC=YY1*(1.D0-S)/2.E0+YY2*(1+S)/2.E0
           IF (I7.EQ.1) THEN
           ENDIF
648        FORMAT ('"(',I3,',',I3,')"')
647        FORMAT (2(E12.6,2X))
           XOUT(N1)=(XAC-XCC)/SC
           YOUT(N1)=(YAC-YCC)/SC
           DCS=(XX2-XX1)/2.D0
           DSN=(YY2-YY1)/2.D0
           GJAC=DSQRT(DCS*DCS+DSN*DSN)
           DETOUT(N1)=GJAC*WF
           IF (IDOSOFT(N).EQ.1) THEN
              DETOUT(N1)=0.D0
           ELSE
              WRITE (647,647) XAC,YAC
           ENDIF
           IF (GJAC.LT.1.D-10) THEN
              DCS_NORM(N1)=1.D0
              DSN_NORM(N1)=0.D0
           ELSE
              DCS=DCS/GJAC
              DSN=DSN/GJAC
              DSN_NORM(N1)=-DCS
              DCS_NORM(N1)=DSN
           ENDIF
           XLENGTH(N)=XLENGTH(N)+DETOUT(N1)
        enddo loop_10045
     enddo loop_10044
  enddo loop_20
  NINPT=N1
  ALLOCATE(PMATLCB(NINPT,3,NB))
  PMATLCB=0.D0
  loop_10046: DO I=1,ND_TOT
     I1=INTERP_LC(I,INTERP(I))
     I2=I
     XLENGTH_I(I)=0.D0
     loop_10047: DO WHILE (I2.NE.I1) 
        XLENGTH_I(I)=XLENGTH_I(I)+XLENGTH(I2)
        I2=I2+1
        IF (I2.GT.ND_TOT) I2=1
     enddo loop_10047
  enddo loop_10046
  loop_10048: DO I=1,ND_TOT
     IF (LC_ND(I).EQ.1.OR.LC_ND(I).EQ.4) THEN
        XADD_ND(I)=0.D0
        J=I
        IFLAG=0
        XLN=0.D0
        loop_10049: DO WHILE (IFLAG.EQ.0) 
           IF (LC_ND(J).EQ.2.OR.LC_ND(J).EQ.5) THEN
              IFLAG=1
           ELSE
              J=J-1
              IF (J.EQ.0) J=ND_TOT
              XLN=XLN+XLENGTH(J)
           ENDIF
        enddo loop_10049
        YADD_ND(I)=XLN
     ELSE
        YADD_ND(I)=0.D0
        J=I
        IFLAG=0
        XLN=0.D0
        loop_10050: DO WHILE (IFLAG.EQ.0) 
           IF (LC_ND(J).EQ.1.OR.LC_ND(J).EQ.4) THEN
              IFLAG=1
           ELSE
              J=J-1
              IF (J.EQ.0) J=ND_TOT
              XLN=XLN+XLENGTH(J)
           ENDIF
        enddo loop_10050
        XADD_ND(I)=XLN
     ENDIF
  enddo loop_10048
  I1=0
  loop_10051: DO I=1,ND_TOT
     loop_10052: DO J=1,IDISC(I)
        J1=J+1
        XLDIF=(SDISC(I,J)+1.D0)*0.5D0*XLENGTH(I)
        SLC=(SDISC_E(I,J)-SDISC(I,J))*0.5D0*XLENGTH(I)
        loop_10053: DO K=1,NORD(NEL)
           I1=I1+1
           S=BP(INTBEG(NORD(NEL))+K)
           XLCDIF=XLDIF+(1.D0+S)*0.5D0*SLC
           XADD_IPT(I1)=XADD_ND(I)+XLCDIF
           YADD_IPT(I1)=YADD_ND(I)+XLCDIF
        enddo loop_10053
     enddo loop_10052
  enddo loop_10051
  REWIND (647)
  CLOSE (647)
  NB=NB-NCYLFLAG(NEL,1)*NTRMADD(NEL,1)-NCYLFLAG(NEL,2)&
       *NTRMADD(NEL,2)
  IF(IWORP(NEL).EQ.3) THEN
     NB=NB-(NPBG_WLTM(NEL+1)-NPBG_WLTM(NEL))
  ENDIF


  loop_201: DO I=1,NINPT
     XX=XOUT(I)
     YY=YOUT(I)
     CALL GEN_VCF_P(NB,XX,YY,PM)
     loop_10054: DO INB=1,NB
        PMATLCB(I,1,INB)=PM((INB-1)*3+1)
        PMATLCB(I,2,INB)=PM((INB-1)*3+2)
        PMATLCB(I,3,INB)=PM((INB-1)*3+3)
     enddo loop_10054
     IF(IWORP(NEL).NE.3) THEN
        XOUT(I)=(XX*SC+XDIF)
        YOUT(I)=(YY*SC+YDIF)
     ENDIF
  enddo loop_201
  ION=0
  IF (NCYLFLAG(NEL,1).EQ.1) THEN
     NINPTS=0
     CALL PMATLOCAS1(NEL,NINPT,SC,XDIF,YDIF,XOUT,YOUT,NB,&
          CONFOUR(NEL),CSFOUR(1,NEL),SNFOUR(1,NEL),ION,PMATLCB)
     NB=NB+NTRMADD(NEL,1)       
     IF (NCYLFLAG(NEL,2).NE.1) THEN  
        loop_10058: DO I=1,NINPT
           XOUT(I)=XOUT(I)+XCP
           YOUT(I)=YOUT(I)+YCP
        enddo loop_10058
     ENDIF
  ENDIF
  ION=1
  IF (NCYLFLAG(NEL,2).EQ.1) THEN
     loop_10059: DO I=1,NINPT
        XOUT(I)=XOUT(I)+XDIF1
        YOUT(I)=YOUT(I)+YDIF1
     enddo loop_10059
     CALL PMATLOCAS1(NEL,NINPT,SC,XDIF2,YDIF2,XOUT,YOUT,NB,&
          CONFOUR(NEL),CSFOUR(1,NEL),SNFOUR(1,NEL),ION,PMATLCB)         
     NB=NB+NTRMADD(NEL,2)
     loop_10060: DO I=1,NINPT
        XOUT(I)=XOUT(I)+XCCP
        YOUT(I)=YOUT(I)+YCCP
     enddo loop_10060
  ENDIF
  loop_2001: DO I=1,3
     loop_2002: DO J=1,2
        XL(I,J)=0.D0
     enddo loop_2002
  enddo loop_2001
  IF(NEL.EQ.1) THEN
     NUM_DIFF=NB*NDF_CELL-NP_TMOUT(NEL,2)
     NP_TMOUT(NEL,1)=0
     NP_TMOUT(NEL,3)=NB
     NP_TMOUT(NEL,4)=NDF_CELL
     NP_TMOUT(NEL,2)=NP_TMOUT(NEL,3)*NP_TMOUT(NEL,4)
  ELSE
     NUM_DIFF=NB*NDF_CELL-NP_TMOUT(NEL,2)
     NP_TMOUT(NEL,1)=NP_TMOUT(NEL-1,1)+NP_TMOUT(NEL-1,2)
     NP_TMOUT(NEL,3)=NB
     NP_TMOUT(NEL,4)=NDF_CELL
     NP_TMOUT(NEL,2)=NP_TMOUT(NEL,3)*NP_TMOUT(NEL,4)
  ENDIF
  IF((NP_TMOUT(NEL,1)+NP_TMOUT(NEL,2)).GT.NUMTMOUT) THEN
     WRITE(*,*) "THE dimension of TMOUT is not enough"
     WRITE(*,*) "Increase it to", (NP_TMOUT(NEL,1)+NP_TMOUT(NEL,2)), NEL
  ENDIF
  IF(NUM_DIFF.LT.0) THEN
     WRITE(*,*) "Impossible NDF_INC"
     stop
  ENDIF
  IF(NUM_DIFF.GT.0) THEN
     loop_10061: DO I=NELX,NEL+1,-1
        loop_10062: DO J=NP_TMOUT(I,2),1,-1
           TMOUT(NP_TMOUT(I,1)+NUM_DIFF+J)=TMOUT(NP_TMOUT(I,1)+J)
        enddo loop_10062
        NP_TMOUT(I,1)=NP_TMOUT(I,1)+NUM_DIFF
     enddo loop_10061
  ENDIF
  loop_205: DO I=1,NB*NDF_CELL
     I1=(I-1)/(NDF_CELL)+1
     I2=I-(I1-1)*NDF_CELL
     TMOUT(NP_TMOUT(NEL,1)+(I1-1)*NP_TMOUT(NEL,4)+I2)=0.D0
  enddo loop_205
  loop_202: DO I=1,NINPT
     IF (DETOUT(I).GT.1.D-11) THEN
        XADD=XADD_IPT(I)
        YADD=YADD_IPT(I)
        IC_X=ICX_IPT(I)
        IC_Y=ICY_IPT(I)
        CS=CSLOC1(IC_X)
        SN=SNLOC1(IC_X)
        XL(1,1)=DCS_NORM(I)
        XL(3,1)=DSN_NORM(I)
        XL(2,2)=XL(3,1)
        XL(3,2)=XL(1,1)
        loop_204: DO J=1,NB
           IF (IBET_CON(J,NEL).EQ.-501) cycle loop_204
           TTX=(PMATLCB(I,1,J)*XL(1,1)+PMATLCB(I,3,J)*XL(3,1))&
                *DETOUT(I)
           TTY=(PMATLCB(I,2,J)*XL(2,2)+PMATLCB(I,3,J)*XL(3,2))&
                *DETOUT(I)
           TTX_C=TTX*CS
           TTX_S=TTX*SN
           TTY_C=TTY*CS
           TTY_S=TTY*SN
           IBEG=IPRD(INTERP(IC_X)-1)
           ND=1
           FACT=2.D0/DFLOAT(INTERP(IC_X)-1)
           loop_10063: DO WHILE (ND.LE.INTERP(IC_X)) 
              S=-1.D0+2.D0*XADD/&
                   XLENGTH_I(IC_X)
              IPT=IPRD(INTERP(IC_X)-1)+ND-1
              SH1=PRD(IPT)
              loop_10064: DO L=1,INTERP(IC_X)
                 IF (L.NE.ND) THEN
                    SH1=SH1*(S+1.D0-FACT*DFLOAT(L-1))
                 ENDIF
              enddo loop_10064
              ID=INTERP_LC(IC_X,ND)
              IF (LC_ND(ID).EQ.1.OR.LC_ND(N).EQ.4) THEN                        
                 TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)=&
                      TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)&
                      +(TTX_C*CS+TTY_S*CS)*SH1
                 TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID+1)=&
                      TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID+1)&
                      +(TTX_C*SN+TTY_S*SN)*SH1
              ELSEIF (LC_ND(ID).EQ.2.OR.LC_ND(N).EQ.5) THEN
                 TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID-1)=&
                      TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID-1)&
                      +(TTX_C*CS+TTY_S*CS)*SH1
                 TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)=&
                      TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)&
                      +(TTX_C*SN+TTY_S*SN)*SH1
              ELSE
                 TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)=&
                      TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)&
                      +(TTX_C+TTY_S)*SH1
              ENDIF
              ND=ND+1
           enddo loop_10063
           IBEG=IPRD(INTERP(IC_Y)-1)
           ND=1
           FACT=2.D0/DFLOAT(INTERP(IC_Y)-1)
           loop_10065: DO WHILE (ND.LE.INTERP(IC_Y))
              S=-1.D0+2.D0*YADD/&
                   XLENGTH_I(IC_Y)
              IPT=IPRD(INTERP(IC_Y)-1)+ND-1
              SH1=PRD(IPT)
              loop_10066: DO L=1,INTERP(IC_Y)
                 IF (L.NE.ND) THEN
                    SH1=SH1*(S+1.D0-FACT*DFLOAT(L-1))
                 ENDIF
              enddo loop_10066
              ID=INTERP_LC(IC_Y,ND)
              IF (LC_ND(ID).EQ.2.OR.LC_ND(N).EQ.5) THEN                        
                 TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID-1)=&
                      TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID-1)&
                      +(TTX_S*SN-TTY_S*CS)*SH1
                 TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)=&
                      TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)&
                      +(-TTX_S*CS+TTY_C*CS)*SH1
              ELSEIF (LC_ND(ID).EQ.1.OR.LC_ND(N).EQ.4) THEN
                 TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)=&
                      TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)&
                      +(TTX_S*SN-TTY_S*CS)*SH1
                 TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID+1)=&
                      TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID+1)&
                      +(-TTX_S*CS+TTY_C*CS)*SH1
              ELSE
                 TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)=&
                      TMOUT(NP_TMOUT(NEL,1)+(J-1)*NP_TMOUT(NEL,4)+ID)&
                      +(TTY_C-TTX_S)*SH1
              ENDIF
              ND=ND+1
           enddo loop_10065
        enddo loop_204
     ENDIF
  enddo loop_202

  DEALLOCATE(ICOMN,LC_ND,LC_BND,INTERP,INTERP_LC,ICX_IPT,ICY_IPT,IDISC)
  DEALLOCATE(XOUT,YOUT,DETOUT,DCS_NORM,DSN_NORM,XLOC1,YLOC1,ANGLOC1&
       ,CSLOC1,SNLOC1,XADD_ND,YADD_ND,XADD_IPT,YADD_IPT,SDISC&
       ,SDISC_E,XLENGTH,XLENGTH_I,PM,PREC)
  DEALLOCATE(PMATLCB)
  RETURN
END SUBROUTINE TMATLOC_MAT

!********************************************************************
SUBROUTINE CONMAP1(NINPT,SC,A0,CSINT,SNNT,X2,Y2,F,DFDX,&
     DFDY,DFDXY,DFDXX,DFDYY,XSC1,YSC1,ANOR)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (MXSKE=(NDFELM*(NDFELM+1))/2)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  DIMENSION X2(1),Y2(1),F(1),DFDX(1),DFDY(1),DFDXY(1),DFDXX(1),&
       DFDYY(1),CSINT(1),SNNT(1)

  DOUBLE PRECISION, ALLOCATABLE :: X1(:),Y1(:)

  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  ALLOCATE(X1(NINPT),Y1(NINPT))
  X1=0.D0
  Y1=0.D0
  ANG=ANOR*DATAN(1.D0)/4.5D1
  CS1=DCOS(ANG)
  SN1=DSIN(ANG)
  loop_10067: DO I=1,NINPT
     X1(I)=X2(I)*CS1+Y2(I)*SN1
     Y1(I)=-X2(I)*SN1+Y2(I)*CS1
  enddo loop_10067
  CSC=1.E0
  XSC=XSC1
  YSC=YSC1
  RACT=SC
  RACT1=RACT*RACT
  RR=(XSC+YSC)/2
  XM=(XSC-YSC)/(XSC+YSC)
  RAVG=XSC+YSC
  XK=RAVG*(XSC-YSC)
  loop_1: DO I=1,NINPT
     X=X1(I)
     Y=Y1(I)
     R8=(X/XSC)**2+(Y/YSC)**2
     IF (R8.LT.1.E0) THEN
        ANG=DATAN2(Y,X)
        CSX=DCOS(ANG)
        CSY=DSIN(ANG)
        RF=(CSX/XSC)**2+(CSY/YSC)**2
        RF=1.01D0/DSQRT(RF)
        X=RF*CSX
        Y=RF*CSY
        WRITE (21,*) 'POSSIBLE ERROR IN CONMAP1'
        WRITE (21,*) 'X=',X,'Y=',Y,'R=',R8
     ENDIF
     RX=X**2
     RY=Y**2
     R1=RX+RY
     R7=R1*R1-2*(RX-RY)*XK+XK**2
     R7=R1*R1-2*(RX-RY)*XK+XK**2
     R=DSQRT(DSQRT(R7))
     FACT=0.25E0/(R*R*R)
     DRX=FACT*(4*(R1)*X-4*X*XK)
     DRY=FACT*(4*(R1)*Y+4*Y*XK)
     FACT1=3/R
     D2RXY=-FACT1*DRX*DRY+FACT*8*X*Y
     D2RXX=-FACT1*DRX*DRX+FACT*(8*RX+4*R1-4*XK)
     D2RYY=-FACT1*DRY*DRY+FACT*(8*RY+4*R1+4*XK)
     D2RXY=-FACT1*DRX*DRY+FACT*8*X*Y
     D2RXX=-FACT1*DRX*DRX+FACT*(8*RX+4*R1-4*XK)
     D2RYY=-FACT1*DRY*DRY+FACT*(8*RY+4*R1+4*XK)
     R5=RX-RY-XK      
     R52=R5*R5
     R53=R52*R5
     TH=DATAN2(2*X*Y,R5)/2      
     FACT=1/R7
     DTX=FACT*(Y*R5-2*RX*Y)
     DTY=FACT*(X*R5+2*RY*X)
     D2TXX=-FACT*(DTX*4*(R1*X-X*XK)+2*X*Y)
     D2TYY=-FACT*(DTY*4*(Y*R1+Y*XK)-2*X*Y)
     D2TXY=-FACT*(DTX*4*(Y*R1+Y*XK)+RX+3*RY+XK)
     D2TXX=-FACT*(DTX*4*(R1*X-X*XK)+2*X*Y)
     D2TYY=-FACT*(DTY*4*(Y*R1+Y*XK)-2*X*Y)
     D2TXY=-FACT*(DTX*4*(Y*R1+Y*XK)+RX+3*RY+XK)
     CS=DCOS(TH)
     SN=DSIN(TH)
     XP=R*CS
     YP=R*SN
     DXPX=DRX*CS-YP*DTX
     DXPY=DRY*CS-YP*DTY
     DYPX=DRX*SN+XP*DTX
     DYPY=DRY*SN+XP*DTY
     D2XPXX=D2RXX*CS-DRX*DTX*SN-DYPX*DTX-YP*D2TXX
     D2XPXY=D2RXY*CS-DRX*SN*DTY-DYPY*DTX-YP*D2TXY
     D2XPYY=D2RYY*CS-DRY*SN*DTY-DYPY*DTY-YP*D2TYY
     D2YPXX=D2RXX*SN+DRX*CS*DTX+DXPX*DTX+XP*D2TXX
     D2YPXY=D2RXY*SN+DRX*CS*DTY+DXPY*DTX+XP*D2TXY
     D2YPYY=D2RYY*SN+DRY*CS*DTY+DXPY*DTY+XP*D2TYY
     FX1=X+XP
     FY1=Y+YP      
     FF=FX1*FX1+FY1*FY1
     IFL=1
     IF (FF.LT.RAVG*RAVG*0.99E0) THEN
        FX1=X-XP
        FY1=Y-YP
        FF=FX1*FX1+FY1*FY1
        IFL=-1
        DXPX=-DXPX
        DXPY=-DXPY
        D2XPXX=-D2XPXX
        D2XPYY=-D2XPYY
        D2XPXY=-D2XPXY
        DYPX=-DYPX
        DYPY=-DYPY
        D2YPXX=-D2YPXX
        D2YPYY=-D2YPYY
        D2YPXY=-D2YPXY         
     ENDIF
     F(I)=DSQRT(FF)
     FINV=1/F(I)
     DFX=FINV*(FX1*(1+DXPX)+FY1*DYPX)
     DFY=FINV*(FX1*DXPY+FY1*(1+DYPY))
     D2FXX=FINV*(-DFX*DFX+(1+DXPX)*(1+DXPX)+FX1*D2XPXX+FY1*D2YPXX+&
          DYPX*DYPX)
     D2FXY=FINV*(-DFX*DFY+FX1*D2XPXY+DXPY*(1+DXPX)+(1+DYPY)*DYPX+&
          FY1*D2YPXY)
     D2FYY=FINV*(-DFY*DFY+FX1*D2XPYY+DXPY*DXPY+(1+DYPY)*(1+DYPY)+&
          FY1*D2YPYY)
     FACT=1/RAVG
     F(I)=F(I)*FACT
     DFDX(I)=DFX*FACT
     DFDY(I)=DFY*FACT
     DFDXX(I)=D2FXX*FACT
     DFDYY(I)=D2FYY*FACT
     DFDXY(I)=D2FXY*FACT
     F(I)=F(I)/CSC
     DFDX(I)=DFDX(I)*RACT/CSC
     DFDXX(I)=DFDXX(I)*RACT1/CSC
     DFDY(I)=DFDY(I)*RACT/CSC
     DFDYY(I)=DFDYY(I)*RACT1/CSC
     DFDXY(I)=DFDXY(I)*RACT1/CSC
  enddo loop_1
  CS2=CS1*CS1
  SN2=SN1*SN1
  CSSN2=CS1*SN1*2.E0
  loop_10068: DO I=1,NINPT
     DFX=DFDX(I)
     DFY=DFDY(I)
     DFXX=DFDXX(I)
     DFYY=DFDYY(I)
     DFXY=DFDXY(I)
     DFDX(I)=DFX*CS1-DFY*SN1
     DFDY(I)=DFX*SN1+DFY*CS1
     DFDXX(I)=DFXX*CS2-DFXY*CSSN2+DFYY*SN2
     DFDXY(I)=DFXX*CSSN2/2.E0+DFXY*(CS2-SN2)-DFYY*CSSN2/2.E0
     DFDYY(I)=DFXX*SN2+DFXY*CSSN2+DFYY*CS2
  enddo loop_10068

  DEALLOCATE(X1,Y1)
  RETURN
END SUBROUTINE CONMAP1

!********************************************************************
SUBROUTINE CONMAP11(NINPT,SC,A0,CSINT,SNNT,X2,Y2,F,DFDX,&
     DFDY,DFDXY,DFDXX,DFDYY,XSC1,YSC1,ANOR)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (MXSKE=(NDFELM*(NDFELM+1))/2)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  DIMENSION X2(1),Y2(1),F(1),DFDX(1),DFDY(1),DFDXY(1),DFDXX(1),&
       DFDYY(1),CSINT(1),SNNT(1)
  DOUBLE PRECISION, ALLOCATABLE :: X1(:),Y1(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  ALLOCATE(X1(NINPT),Y1(NINPT))
  X1=0.D0
  Y1=0.D0
  ANG=ANOR*DATAN(1.D0)/4.5D1
  CS1=DCOS(ANG)
  SN1=DSIN(ANG)
  loop_10069: DO I=1,NINPT
     X1(I)=X2(I)*CS1+Y2(I)*SN1
     Y1(I)=-X2(I)*SN1+Y2(I)*CS1
  enddo loop_10069
  CSC=1.E0
  XSC=XSC1
  YSC=YSC1
  RACT=SC
  RACT1=RACT*RACT
  RR=(XSC+YSC)/2
  XM=(XSC-YSC)/(XSC+YSC)
  RAVG=XSC+YSC
  XK=RAVG*(XSC-YSC)
  loop_1: DO I=1,NINPT
     X=X1(I)
     Y=Y1(I)
     R8=(X/XSC)**2+(Y/YSC)**2
     IF (R8.LT.1.E0) THEN
        ANG=DATAN2(Y,X)
        CSX=DCOS(ANG)
        CSY=DSIN(ANG)
        RF=(CSX/XSC)**2+(CSY/YSC)**2
        RF=1.01D0/DSQRT(RF)
        X=RF*CSX
        Y=RF*CSY
        WRITE (21,*) 'POSSIBLE ERROR IN CONMAP11'
        WRITE (21,*) 'X=',X,'Y=',Y,'R=',R8
     ENDIF
     RX=X**2
     RY=Y**2
     R1=RX+RY
     R7=R1*R1-2*(RX-RY)*XK+XK**2
     R=DSQRT(DSQRT(R7))
     FACT=0.25E0/(R*R*R)
     DRX=FACT*(4*(R1)*X-4*X*XK)
     DRY=FACT*(4*(R1)*Y+4*Y*XK)
     FACT1=3/R
     D2RXY=-FACT1*DRX*DRY+FACT*8*X*Y
     D2RXX=-FACT1*DRX*DRX+FACT*(8*RX+4*R1-4*XK)
     D2RYY=-FACT1*DRY*DRY+FACT*(8*RY+4*R1+4*XK)
     R5=RX-RY-XK      
     R52=R5*R5
     R53=R52*R5
     TH=DATAN2(2*X*Y,R5)/2      
     FACT=1/R7
     DTX=FACT*(Y*R5-2*RX*Y)
     DTY=FACT*(X*R5+2*RY*X)
     D2TXX=-FACT*(DTX*4*(R1*X-X*XK)+2*X*Y)
     D2TYY=-FACT*(DTY*4*(Y*R1+Y*XK)-2*X*Y)
     D2TXY=-FACT*(DTX*4*(Y*R1+Y*XK)+RX+3*RY+XK)
     CS=DCOS(TH)
     SN=DSIN(TH)
     XP=R*CS
     YP=R*SN
     DXPX=DRX*CS-YP*DTX
     DXPY=DRY*CS-YP*DTY
     DYPX=DRX*SN+XP*DTX
     DYPY=DRY*SN+XP*DTY
     D2XPXX=D2RXX*CS-DRX*DTX*SN-DYPX*DTX-YP*D2TXX
     D2XPXY=D2RXY*CS-DRX*SN*DTY-DYPY*DTX-YP*D2TXY
     D2XPYY=D2RYY*CS-DRY*SN*DTY-DYPY*DTY-YP*D2TYY
     D2YPXX=D2RXX*SN+DRX*CS*DTX+DXPX*DTX+XP*D2TXX
     D2YPXY=D2RXY*SN+DRX*CS*DTY+DXPY*DTX+XP*D2TXY
     D2YPYY=D2RYY*SN+DRY*CS*DTY+DXPY*DTY+XP*D2TYY
     FX1=X+XP
     FY1=Y+YP      
     FF=FX1*FX1+FY1*FY1
     IFL=1
     IF (FF.LT.RAVG*RAVG*0.99E0) THEN
        FX1=X-XP
        FY1=Y-YP
        FF=FX1*FX1+FY1*FY1
        IFL=-1
        DXPX=-DXPX
        DXPY=-DXPY
        D2XPXX=-D2XPXX
        D2XPYY=-D2XPYY
        D2XPXY=-D2XPXY
        DYPX=-DYPX
        DYPY=-DYPY
        D2YPXX=-D2YPXX
        D2YPYY=-D2YPYY
        D2YPXY=-D2YPXY         
     ENDIF
     F(I)=DSQRT(FF)
     FINV=1/F(I)
     DFX=FINV*(FX1*(1+DXPX)+FY1*DYPX)
     DFY=FINV*(FX1*DXPY+FY1*(1+DYPY))
     D2FXX=FINV*(-DFX*DFX+(1+DXPX)*(1+DXPX)+FX1*D2XPXX+FY1*D2YPXX+&
          DYPX*DYPX)
     D2FXY=FINV*(-DFX*DFY+FX1*D2XPXY+DXPY*(1+DXPX)+(1+DYPY)*DYPX+&
          FY1*D2YPXY)
     D2FYY=FINV*(-DFY*DFY+FX1*D2XPYY+DXPY*DXPY+(1+DYPY)*(1+DYPY)+&
          FY1*D2YPYY)
     FACT=1/RAVG
     F(I)=F(I)*FACT
     DFDX(I)=DFX*FACT
     DFDY(I)=DFY*FACT
     DFDXX(I)=D2FXX*FACT
     DFDYY(I)=D2FYY*FACT
     DFDXY(I)=D2FXY*FACT
     F(I)=F(I)/CSC
     DFDX(I)=DFDX(I)*RACT/CSC
     DFDXX(I)=DFDXX(I)*RACT1/CSC
     DFDY(I)=DFDY(I)*RACT/CSC
     DFDYY(I)=DFDYY(I)*RACT1/CSC
     DFDXY(I)=DFDXY(I)*RACT1/CSC
  enddo loop_1
  CS2=CS1*CS1
  SN2=SN1*SN1
  CSSN2=CS1*SN1*2.E0
  loop_10070: DO I=1,NINPT
     DFX=DFDX(I)
     DFY=DFDY(I)
     DFXX=DFDXX(I)
     DFYY=DFDYY(I)
     DFXY=DFDXY(I)
     DFDX(I)=DFX*CS1-DFY*SN1
     DFDY(I)=DFX*SN1+DFY*CS1
     DFDXX(I)=DFXX*CS2-DFXY*CSSN2+DFYY*SN2
     DFDXY(I)=DFXX*CSSN2/2.E0+DFXY*(CS2-SN2)-DFYY*CSSN2/2.E0
     DFDYY(I)=DFXX*SN2+DFXY*CSSN2+DFYY*CS2
  enddo loop_10070
  DEALLOCATE(X1,Y1)
  RETURN
END SUBROUTINE CONMAP11

!********************************************************************
SUBROUTINE CONMAP12(NINPT,SC,A0,CSINT,SNNT,X2,Y2,F,DFDX,&
     DFDY,DFDXY,DFDXX,DFDYY,XSC1,YSC1,ANOR)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (MXSKE=(NDFELM*(NDFELM+1))/2)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  DIMENSION X2(1),Y2(1),F(1),DFDX(1),DFDY(1),DFDXY(1),DFDXX(1),&
       DFDYY(1),CSINT(1),SNNT(1)
  DOUBLE PRECISION, ALLOCATABLE :: X1(:),Y1(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  ALLOCATE(X1(NINPT),Y1(NINPT))
  X1=0.D0
  Y1=0.D0
  ANG=ANOR*DATAN(1.D0)/4.5D1
  CS1=DCOS(ANG)
  SN1=DSIN(ANG)
  loop_10071: DO I=1,NINPT
     X1(I)=X2(I)*CS1+Y2(I)*SN1
     Y1(I)=-X2(I)*SN1+Y2(I)*CS1
  enddo loop_10071
  CSC=1.E0
  XSC=XSC1
  YSC=YSC1
  RACT=SC
  RACT1=RACT*RACT
  RR=(XSC+YSC)/2
  XM=(XSC-YSC)/(XSC+YSC)
  RAVG=XSC+YSC
  XK=RAVG*(XSC-YSC)
  loop_1: DO I=1,NINPT
     X=X1(I)
     Y=Y1(I)
     R8=(X/XSC)**2+(Y/YSC)**2
     IF (R8.LT.1.E0) THEN
        ANG=DATAN2(Y,X)
        CSX=DCOS(ANG)
        CSY=DSIN(ANG)
        RF=(CSX/XSC)**2+(CSY/YSC)**2
        RF=1.01D0/DSQRT(RF)
        X=RF*CSX
        Y=RF*CSY
        WRITE (21,*) 'POSSIBLE ERROR IN CONMAP12'
        WRITE (21,*) 'X=',X,'Y=',Y,'R=',R8
     ENDIF
     RX=X**2
     RY=Y**2
     R1=RX+RY
     R7=R1*R1-2*(RX-RY)*XK+XK**2
     R=DSQRT(DSQRT(R7))
     FACT=0.25E0/(R*R*R)
     DRX=FACT*(4*(R1)*X-4*X*XK)
     DRY=FACT*(4*(R1)*Y+4*Y*XK)
     FACT1=3/R
     D2RXY=-FACT1*DRX*DRY+FACT*8*X*Y
     D2RXX=-FACT1*DRX*DRX+FACT*(8*RX+4*R1-4*XK)
     D2RYY=-FACT1*DRY*DRY+FACT*(8*RY+4*R1+4*XK)
     R5=RX-RY-XK      
     R52=R5*R5
     R53=R52*R5
     TH=DATAN2(2*X*Y,R5)/2      
     FACT=1/R7
     DTX=FACT*(Y*R5-2*RX*Y)
     DTY=FACT*(X*R5+2*RY*X)
     D2TXX=-FACT*(DTX*4*(R1*X-X*XK)+2*X*Y)
     D2TYY=-FACT*(DTY*4*(Y*R1+Y*XK)-2*X*Y)
     D2TXY=-FACT*(DTX*4*(Y*R1+Y*XK)+RX+3*RY+XK)
     CS=DCOS(TH)
     SN=DSIN(TH)
     XP=R*CS
     YP=R*SN
     DXPX=DRX*CS-YP*DTX
     DXPY=DRY*CS-YP*DTY
     DYPX=DRX*SN+XP*DTX
     DYPY=DRY*SN+XP*DTY
     D2XPXX=D2RXX*CS-DRX*DTX*SN-DYPX*DTX-YP*D2TXX
     D2XPXY=D2RXY*CS-DRX*SN*DTY-DYPY*DTX-YP*D2TXY
     D2XPYY=D2RYY*CS-DRY*SN*DTY-DYPY*DTY-YP*D2TYY
     D2YPXX=D2RXX*SN+DRX*CS*DTX+DXPX*DTX+XP*D2TXX
     D2YPXY=D2RXY*SN+DRX*CS*DTY+DXPY*DTX+XP*D2TXY
     D2YPYY=D2RYY*SN+DRY*CS*DTY+DXPY*DTY+XP*D2TYY
     FX1=X+XP
     FY1=Y+YP      
     FF=FX1*FX1+FY1*FY1
     IFL=1
     IF (FF.LT.RAVG*RAVG*0.99E0) THEN
        FX1=X-XP
        FY1=Y-YP
        FF=FX1*FX1+FY1*FY1
        IFL=-1
        DXPX=-DXPX
        DXPY=-DXPY
        D2XPXX=-D2XPXX
        D2XPYY=-D2XPYY
        D2XPXY=-D2XPXY
        DYPX=-DYPX
        DYPY=-DYPY
        D2YPXX=-D2YPXX
        D2YPYY=-D2YPYY
        D2YPXY=-D2YPXY         
     ENDIF
     F(I)=DSQRT(FF)
     FINV=1/F(I)
     DFX=FINV*(FX1*(1+DXPX)+FY1*DYPX)
     DFY=FINV*(FX1*DXPY+FY1*(1+DYPY))
     D2FXX=FINV*(-DFX*DFX+(1+DXPX)*(1+DXPX)+FX1*D2XPXX+FY1*D2YPXX+&
          DYPX*DYPX)
     D2FXY=FINV*(-DFX*DFY+FX1*D2XPXY+DXPY*(1+DXPX)+(1+DYPY)*DYPX+&
          FY1*D2YPXY)
     D2FYY=FINV*(-DFY*DFY+FX1*D2XPYY+DXPY*DXPY+(1+DYPY)*(1+DYPY)+&
          FY1*D2YPYY)
     FACT=1/RAVG
     F(I)=F(I)*FACT
     DFDX(I)=DFX*FACT
     DFDY(I)=DFY*FACT
     DFDXX(I)=D2FXX*FACT
     DFDYY(I)=D2FYY*FACT
     DFDXY(I)=D2FXY*FACT
     F(I)=F(I)/CSC
     DFDX(I)=DFDX(I)*RACT/CSC
     DFDXX(I)=DFDXX(I)*RACT1/CSC
     DFDY(I)=DFDY(I)*RACT/CSC
     DFDYY(I)=DFDYY(I)*RACT1/CSC
     DFDXY(I)=DFDXY(I)*RACT1/CSC
  enddo loop_1
  CS2=CS1*CS1
  SN2=SN1*SN1
  CSSN2=CS1*SN1*2.E0
  loop_10072: DO I=1,NINPT
     DFX=DFDX(I)
     DFY=DFDY(I)
     DFXX=DFDXX(I)
     DFYY=DFDYY(I)
     DFXY=DFDXY(I)
     DFDX(I)=DFX*CS1-DFY*SN1
     DFDY(I)=DFX*SN1+DFY*CS1
     DFDXX(I)=DFXX*CS2-DFXY*CSSN2+DFYY*SN2
     DFDXY(I)=DFXX*CSSN2/2.E0+DFXY*(CS2-SN2)-DFYY*CSSN2/2.E0
     DFDYY(I)=DFXX*SN2+DFXY*CSSN2+DFYY*CS2
  enddo loop_10072
  DEALLOCATE(X1,Y1)
  RETURN
END SUBROUTINE CONMAP12

!********************************************************************
SUBROUTINE CONMAP13(NINPT,SC,A0,CSINT,SNNT,X2,Y2,F,DFDX,&
     DFDY,DFDXY,DFDXX,DFDYY,XSC1,YSC1,ANOR)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (MXSKE=(NDFELM*(NDFELM+1))/2)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  DIMENSION X2(1),Y2(1),F(1),DFDX(1),DFDY(1),DFDXY(1),DFDXX(1),&
       DFDYY(1),CSINT(1),SNNT(1)
  DOUBLE PRECISION, ALLOCATABLE :: X1(:),Y1(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  ALLOCATE(X1(NINPT),Y1(NINPT))
  X1=0.D0
  Y1=0.D0
  ANG=ANOR*DATAN(1.D0)/4.5D1
  CS1=DCOS(ANG)
  SN1=DSIN(ANG)
  loop_10073: DO I=1,NINPT
     X1(I)=X2(I)*CS1+Y2(I)*SN1
     Y1(I)=-X2(I)*SN1+Y2(I)*CS1
  enddo loop_10073
  CSC=1.E0
  XSC=XSC1
  YSC=YSC1
  RACT=SC
  RACT1=RACT*RACT
  RR=(XSC+YSC)/2
  XM=(XSC-YSC)/(XSC+YSC)
  RAVG=XSC+YSC
  XK=RAVG*(XSC-YSC)
  loop_1: DO I=1,NINPT
     X=X1(I)
     Y=Y1(I)
     R8=(X/XSC)**2+(Y/YSC)**2
     IF (R8.LT.1.E0) THEN
        ANG=DATAN2(Y,X)
        CSX=DCOS(ANG)
        CSY=DSIN(ANG)
        RF=(CSX/XSC)**2+(CSY/YSC)**2
        RF=1.01D0/DSQRT(RF)
        X=RF*CSX
        Y=RF*CSY
        WRITE (21,*) 'POSSIBLE ERROR IN CONMAP13'
        WRITE (21,*) 'X=',X,'Y=',Y,'R=',R8
     ENDIF
     RX=X**2
     RY=Y**2
     R1=RX+RY
     R7=R1*R1-2*(RX-RY)*XK+XK**2
     R=DSQRT(DSQRT(R7))
     FACT=0.25E0/(R*R*R)
     DRX=FACT*(4*(R1)*X-4*X*XK)
     DRY=FACT*(4*(R1)*Y+4*Y*XK)
     FACT1=3/R
     D2RXY=-FACT1*DRX*DRY+FACT*8*X*Y
     D2RXX=-FACT1*DRX*DRX+FACT*(8*RX+4*R1-4*XK)
     D2RYY=-FACT1*DRY*DRY+FACT*(8*RY+4*R1+4*XK)
     R5=RX-RY-XK      
     R52=R5*R5
     R53=R52*R5
     TH=DATAN2(2*X*Y,R5)/2      
     FACT=1/R7
     DTX=FACT*(Y*R5-2*RX*Y)
     DTY=FACT*(X*R5+2*RY*X)
     D2TXX=-FACT*(DTX*4*(R1*X-X*XK)+2*X*Y)
     D2TYY=-FACT*(DTY*4*(Y*R1+Y*XK)-2*X*Y)
     D2TXY=-FACT*(DTX*4*(Y*R1+Y*XK)+RX+3*RY+XK)
     CS=DCOS(TH)
     SN=DSIN(TH)
     XP=R*CS
     YP=R*SN
     DXPX=DRX*CS-YP*DTX
     DXPY=DRY*CS-YP*DTY
     DYPX=DRX*SN+XP*DTX
     DYPY=DRY*SN+XP*DTY
     D2XPXX=D2RXX*CS-DRX*DTX*SN-DYPX*DTX-YP*D2TXX
     D2XPXY=D2RXY*CS-DRX*SN*DTY-DYPY*DTX-YP*D2TXY
     D2XPYY=D2RYY*CS-DRY*SN*DTY-DYPY*DTY-YP*D2TYY
     D2YPXX=D2RXX*SN+DRX*CS*DTX+DXPX*DTX+XP*D2TXX
     D2YPXY=D2RXY*SN+DRX*CS*DTY+DXPY*DTX+XP*D2TXY
     D2YPYY=D2RYY*SN+DRY*CS*DTY+DXPY*DTY+XP*D2TYY
     FX1=X+XP
     FY1=Y+YP      
     FF=FX1*FX1+FY1*FY1
     IFL=1
     IF (FF.LT.RAVG*RAVG*0.99E0) THEN
        FX1=X-XP
        FY1=Y-YP
        FF=FX1*FX1+FY1*FY1
        IFL=-1
        DXPX=-DXPX
        DXPY=-DXPY
        D2XPXX=-D2XPXX
        D2XPYY=-D2XPYY
        D2XPXY=-D2XPXY
        DYPX=-DYPX
        DYPY=-DYPY
        D2YPXX=-D2YPXX
        D2YPYY=-D2YPYY
        D2YPXY=-D2YPXY         
     ENDIF
     F(I)=DSQRT(FF)
     FINV=1/F(I)
     DFX=FINV*(FX1*(1+DXPX)+FY1*DYPX)
     DFY=FINV*(FX1*DXPY+FY1*(1+DYPY))
     D2FXX=FINV*(-DFX*DFX+(1+DXPX)*(1+DXPX)+FX1*D2XPXX+FY1*D2YPXX+&
          DYPX*DYPX)
     D2FXY=FINV*(-DFX*DFY+FX1*D2XPXY+DXPY*(1+DXPX)+(1+DYPY)*DYPX+&
          FY1*D2YPXY)
     D2FYY=FINV*(-DFY*DFY+FX1*D2XPYY+DXPY*DXPY+(1+DYPY)*(1+DYPY)+&
          FY1*D2YPYY)
     FACT=1/RAVG
     F(I)=F(I)*FACT
     DFDX(I)=DFX*FACT
     DFDY(I)=DFY*FACT
     DFDXX(I)=D2FXX*FACT
     DFDYY(I)=D2FYY*FACT
     DFDXY(I)=D2FXY*FACT
     F(I)=F(I)/CSC
     DFDX(I)=DFDX(I)*RACT/CSC
     DFDXX(I)=DFDXX(I)*RACT1/CSC
     DFDY(I)=DFDY(I)*RACT/CSC
     DFDYY(I)=DFDYY(I)*RACT1/CSC
     DFDXY(I)=DFDXY(I)*RACT1/CSC
  enddo loop_1
  CS2=CS1*CS1
  SN2=SN1*SN1
  CSSN2=CS1*SN1*2.E0
  loop_10074: DO I=1,NINPT
     DFX=DFDX(I)
     DFY=DFDY(I)
     DFXX=DFDXX(I)
     DFYY=DFDYY(I)
     DFXY=DFDXY(I)
     DFDX(I)=DFX*CS1-DFY*SN1
     DFDY(I)=DFX*SN1+DFY*CS1
     DFDXX(I)=DFXX*CS2-DFXY*CSSN2+DFYY*SN2
     DFDXY(I)=DFXX*CSSN2/2.E0+DFXY*(CS2-SN2)-DFYY*CSSN2/2.E0
     DFDYY(I)=DFXX*SN2+DFXY*CSSN2+DFYY*CS2
  enddo loop_10074
  DEALLOCATE(X1,Y1)
  RETURN
END SUBROUTINE CONMAP13

!********************************************************************
SUBROUTINE CONMAP14(NINPT,SC,A0,CSINT,SNNT,X2,Y2,F,DFDX,&
     DFDY,DFDXY,DFDXX,DFDYY,XSC1,YSC1,ANOR)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (MXSKE=(NDFELM*(NDFELM+1))/2)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  DIMENSION X2(1),Y2(1),F(1),DFDX(1),DFDY(1),DFDXY(1),DFDXX(1),&
       DFDYY(1),CSINT(1),SNNT(1)
  DOUBLE PRECISION, ALLOCATABLE :: X1(:),Y1(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  ALLOCATE(X1(NINPT),Y1(NINPT))
  X1=0.D0
  Y1=0.D0

  ANG=ANOR*DATAN(1.D0)/4.5D1
  CS1=DCOS(ANG)
  SN1=DSIN(ANG)
  loop_10075: DO I=1,NINPT
     X1(I)=X2(I)*CS1+Y2(I)*SN1
     Y1(I)=-X2(I)*SN1+Y2(I)*CS1
  enddo loop_10075
  CSC=1.E0
  XSC=XSC1
  YSC=YSC1
  RACT=SC
  RACT1=RACT*RACT
  RR=(XSC+YSC)/2
  XM=(XSC-YSC)/(XSC+YSC)
  RAVG=XSC+YSC
  XK=RAVG*(XSC-YSC)
  loop_1: DO I=1,NINPT
     X=X1(I)
     Y=Y1(I)
     R8=(X/XSC)**2+(Y/YSC)**2
     IF (R8.LT.1.E0) THEN
        ANG=DATAN2(Y,X)
        CSX=DCOS(ANG)
        CSY=DSIN(ANG)
        RF=(CSX/XSC)**2+(CSY/YSC)**2
        RF=1.01D0/DSQRT(RF)
        X=RF*CSX
        Y=RF*CSY
        WRITE (21,*) 'POSSIBLE ERROR IN CONMAP14'
        WRITE (21,*) 'X=',X,'Y=',Y,'R=',R8
        WRITE (21,*) XSC,YSC
        loop_10076: DO JJ=1,NINPT
           WRITE (21,21) X2(JJ),Y2(JJ)
        enddo loop_10076
21      FORMAT (2(E12.6,2X))
        WRITE (21,*)
        loop_10077: DO JJ=1,360
           ANGLE=JJ*DATAN(1.D0)/4.5D1
           CS=DCOS(ANGLE)
           SN=DSIN(ANGLE)
           RF=(CS/XSC)*(CS/XSC)+(SN/YSC)*(SN/YSC)
           RF=1.D0/DSQRT(RF)
           XX1=RF*CS
           YY1=RF*SN
           XX=XX1*CS1-YY1*SN1
           YY=YY1*CS1+XX1*SN1
           WRITE (21,21) XX,YY
        enddo loop_10077
     ENDIF
     RX=X**2
     RY=Y**2
     R1=RX+RY
     R7=R1*R1-2*(RX-RY)*XK+XK**2
     R=DSQRT(DSQRT(R7))
     FACT=0.25E0/(R*R*R)
     DRX=FACT*(4*(R1)*X-4*X*XK)
     DRY=FACT*(4*(R1)*Y+4*Y*XK)
     FACT1=3/R
     D2RXY=-FACT1*DRX*DRY+FACT*8*X*Y
     D2RXX=-FACT1*DRX*DRX+FACT*(8*RX+4*R1-4*XK)
     D2RYY=-FACT1*DRY*DRY+FACT*(8*RY+4*R1+4*XK)
     R5=RX-RY-XK      
     R52=R5*R5
     R53=R52*R5
     TH=DATAN2(2*X*Y,R5)/2      
     FACT=1/R7
     DTX=FACT*(Y*R5-2*RX*Y)
     DTY=FACT*(X*R5+2*RY*X)
     D2TXX=-FACT*(DTX*4*(R1*X-X*XK)+2*X*Y)
     D2TYY=-FACT*(DTY*4*(Y*R1+Y*XK)-2*X*Y)
     D2TXY=-FACT*(DTX*4*(Y*R1+Y*XK)+RX+3*RY+XK)
     CS=DCOS(TH)
     SN=DSIN(TH)
     XP=R*CS
     YP=R*SN
     DXPX=DRX*CS-YP*DTX
     DXPY=DRY*CS-YP*DTY
     DYPX=DRX*SN+XP*DTX
     DYPY=DRY*SN+XP*DTY
     D2XPXX=D2RXX*CS-DRX*DTX*SN-DYPX*DTX-YP*D2TXX
     D2XPXY=D2RXY*CS-DRX*SN*DTY-DYPY*DTX-YP*D2TXY
     D2XPYY=D2RYY*CS-DRY*SN*DTY-DYPY*DTY-YP*D2TYY
     D2YPXX=D2RXX*SN+DRX*CS*DTX+DXPX*DTX+XP*D2TXX
     D2YPXY=D2RXY*SN+DRX*CS*DTY+DXPY*DTX+XP*D2TXY
     D2YPYY=D2RYY*SN+DRY*CS*DTY+DXPY*DTY+XP*D2TYY
     FX1=X+XP
     FY1=Y+YP      
     FF=FX1*FX1+FY1*FY1
     IFL=1
     IF (FF.LT.RAVG*RAVG*0.99E0) THEN
        FX1=X-XP
        FY1=Y-YP
        FF=FX1*FX1+FY1*FY1
        IFL=-1
        DXPX=-DXPX
        DXPY=-DXPY
        D2XPXX=-D2XPXX
        D2XPYY=-D2XPYY
        D2XPXY=-D2XPXY
        DYPX=-DYPX
        DYPY=-DYPY
        D2YPXX=-D2YPXX
        D2YPYY=-D2YPYY
        D2YPXY=-D2YPXY         
     ENDIF
     !      write(113,*) FX1,FY1
     F(I)=DSQRT(FF)
     FINV=1/F(I)
     DFX=FINV*(FX1*(1+DXPX)+FY1*DYPX)
     DFY=FINV*(FX1*DXPY+FY1*(1+DYPY))
     D2FXX=FINV*(-DFX*DFX+(1+DXPX)*(1+DXPX)+FX1*D2XPXX+FY1*D2YPXX+&
          DYPX*DYPX)
     D2FXY=FINV*(-DFX*DFY+FX1*D2XPXY+DXPY*(1+DXPX)+(1+DYPY)*DYPX+&
          FY1*D2YPXY)
     D2FYY=FINV*(-DFY*DFY+FX1*D2XPYY+DXPY*DXPY+(1+DYPY)*(1+DYPY)+&
          FY1*D2YPYY)
     FACT=1/RAVG
     F(I)=F(I)*FACT
     DFDX(I)=DFX*FACT
     DFDY(I)=DFY*FACT
     DFDXX(I)=D2FXX*FACT
     DFDYY(I)=D2FYY*FACT
     DFDXY(I)=D2FXY*FACT
     F(I)=F(I)/CSC
     DFDX(I)=DFDX(I)*RACT/CSC
     DFDXX(I)=DFDXX(I)*RACT1/CSC
     DFDY(I)=DFDY(I)*RACT/CSC
     DFDYY(I)=DFDYY(I)*RACT1/CSC
     DFDXY(I)=DFDXY(I)*RACT1/CSC
  enddo loop_1
  CS2=CS1*CS1
  SN2=SN1*SN1
  CSSN2=CS1*SN1*2.E0
  loop_10078: DO I=1,NINPT
     DFX=DFDX(I)
     DFY=DFDY(I)
     DFXX=DFDXX(I)
     DFYY=DFDYY(I)
     DFXY=DFDXY(I)
     DFDX(I)=DFX*CS1-DFY*SN1
     DFDY(I)=DFX*SN1+DFY*CS1
     DFDXX(I)=DFXX*CS2-DFXY*CSSN2+DFYY*SN2
     DFDXY(I)=DFXX*CSSN2/2.E0+DFXY*(CS2-SN2)-DFYY*CSSN2/2.E0
     DFDYY(I)=DFXX*SN2+DFXY*CSSN2+DFYY*CS2
  enddo loop_10078

  DEALLOCATE(X1,Y1)
  RETURN
END SUBROUTINE CONMAP14

!********************************************************************
SUBROUTINE CONMAP15(NINPT,SC,A0,CSINT,SNNT,X2,Y2,F,DFDX,&
     DFDY,DFDXY,DFDXX,DFDYY,XSC1,YSC1,ANOR)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (MXSKE=(NDFELM*(NDFELM+1))/2)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  DIMENSION X2(1),Y2(1),F(1),DFDX(1),DFDY(1),DFDXY(1),DFDXX(1),&
       DFDYY(1),CSINT(1),SNNT(1)
  DOUBLE PRECISION, ALLOCATABLE :: X1(:),Y1(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  ALLOCATE(X1(NINPT),Y1(NINPT))
  X1=0.D0
  Y1=0.D0
  ANG=ANOR*DATAN(1.D0)/4.5D1
  CS1=DCOS(ANG)
  SN1=DSIN(ANG)
  loop_10079: DO I=1,NINPT
     X1(I)=X2(I)*CS1+Y2(I)*SN1
     Y1(I)=-X2(I)*SN1+Y2(I)*CS1
  enddo loop_10079
  CSC=1.E0
  XSC=XSC1
  YSC=YSC1
  RACT=SC
  RACT1=RACT*RACT
  RR=(XSC+YSC)/2
  XM=(XSC-YSC)/(XSC+YSC)
  RAVG=XSC+YSC
  XK=RAVG*(XSC-YSC)
  loop_1: DO I=1,NINPT
     X=X1(I)
     Y=Y1(I)
     R8=(X/XSC)**2+(Y/YSC)**2
     IF (R8.LT.1.E0) THEN
        ANG=DATAN2(Y,X)
        CSX=DCOS(ANG)
        CSY=DSIN(ANG)
        RF=(CSX/XSC)**2+(CSY/YSC)**2
        RF=1.01D0/DSQRT(RF)
        X=RF*CSX
        Y=RF*CSY
        WRITE (21,*) 'POSSIBLE ERROR IN CONMAP15'
        WRITE (21,*) 'X=',X,'Y=',Y,'R=',R8
     ENDIF
     RX=X**2
     RY=Y**2
     R1=RX+RY
     R7=R1*R1-2*(RX-RY)*XK+XK**2
     R=DSQRT(DSQRT(R7))
     FACT=0.25E0/(R*R*R)
     DRX=FACT*(4*(R1)*X-4*X*XK)
     DRY=FACT*(4*(R1)*Y+4*Y*XK)
     FACT1=3/R
     D2RXY=-FACT1*DRX*DRY+FACT*8*X*Y
     D2RXX=-FACT1*DRX*DRX+FACT*(8*RX+4*R1-4*XK)
     D2RYY=-FACT1*DRY*DRY+FACT*(8*RY+4*R1+4*XK)
     R5=RX-RY-XK      
     R52=R5*R5
     R53=R52*R5
     TH=DATAN2(2*X*Y,R5)/2      
     FACT=1/R7
     DTX=FACT*(Y*R5-2*RX*Y)
     DTY=FACT*(X*R5+2*RY*X)
     D2TXX=-FACT*(DTX*4*(R1*X-X*XK)+2*X*Y)
     D2TYY=-FACT*(DTY*4*(Y*R1+Y*XK)-2*X*Y)
     D2TXY=-FACT*(DTX*4*(Y*R1+Y*XK)+RX+3*RY+XK)
     CS=DCOS(TH)
     SN=DSIN(TH)
     XP=R*CS
     YP=R*SN
     DXPX=DRX*CS-YP*DTX
     DXPY=DRY*CS-YP*DTY
     DYPX=DRX*SN+XP*DTX
     DYPY=DRY*SN+XP*DTY
     D2XPXX=D2RXX*CS-DRX*DTX*SN-DYPX*DTX-YP*D2TXX
     D2XPXY=D2RXY*CS-DRX*SN*DTY-DYPY*DTX-YP*D2TXY
     D2XPYY=D2RYY*CS-DRY*SN*DTY-DYPY*DTY-YP*D2TYY
     D2YPXX=D2RXX*SN+DRX*CS*DTX+DXPX*DTX+XP*D2TXX
     D2YPXY=D2RXY*SN+DRX*CS*DTY+DXPY*DTX+XP*D2TXY
     D2YPYY=D2RYY*SN+DRY*CS*DTY+DXPY*DTY+XP*D2TYY
     FX1=X+XP
     FY1=Y+YP      
     FF=FX1*FX1+FY1*FY1
     IFL=1
     IF (FF.LT.RAVG*RAVG*0.99E0) THEN
        FX1=X-XP
        FY1=Y-YP
        FF=FX1*FX1+FY1*FY1
        IFL=-1
        DXPX=-DXPX
        DXPY=-DXPY
        D2XPXX=-D2XPXX
        D2XPYY=-D2XPYY
        D2XPXY=-D2XPXY
        DYPX=-DYPX
        DYPY=-DYPY
        D2YPXX=-D2YPXX
        D2YPYY=-D2YPYY
        D2YPXY=-D2YPXY         
     ENDIF
     F(I)=DSQRT(FF)
     FINV=1/F(I)
     DFX=FINV*(FX1*(1+DXPX)+FY1*DYPX)
     DFY=FINV*(FX1*DXPY+FY1*(1+DYPY))
     D2FXX=FINV*(-DFX*DFX+(1+DXPX)*(1+DXPX)+FX1*D2XPXX+FY1*D2YPXX+&
          DYPX*DYPX)
     D2FXY=FINV*(-DFX*DFY+FX1*D2XPXY+DXPY*(1+DXPX)+(1+DYPY)*DYPX+&
          FY1*D2YPXY)
     D2FYY=FINV*(-DFY*DFY+FX1*D2XPYY+DXPY*DXPY+(1+DYPY)*(1+DYPY)+&
          FY1*D2YPYY)
     FACT=1/RAVG
     F(I)=F(I)*FACT
     DFDX(I)=DFX*FACT
     DFDY(I)=DFY*FACT
     DFDXX(I)=D2FXX*FACT
     DFDYY(I)=D2FYY*FACT
     DFDXY(I)=D2FXY*FACT
     F(I)=F(I)/CSC
     DFDX(I)=DFDX(I)*RACT/CSC
     DFDXX(I)=DFDXX(I)*RACT1/CSC
     DFDY(I)=DFDY(I)*RACT/CSC
     DFDYY(I)=DFDYY(I)*RACT1/CSC
     DFDXY(I)=DFDXY(I)*RACT1/CSC
  enddo loop_1
  CS2=CS1*CS1
  SN2=SN1*SN1
  CSSN2=CS1*SN1*2.E0
  loop_10080: DO I=1,NINPT
     DFX=DFDX(I)
     DFY=DFDY(I)
     DFXX=DFDXX(I)
     DFYY=DFDYY(I)
     DFXY=DFDXY(I)
     DFDX(I)=DFX*CS1-DFY*SN1
     DFDY(I)=DFX*SN1+DFY*CS1
     DFDXX(I)=DFXX*CS2-DFXY*CSSN2+DFYY*SN2
     DFDXY(I)=DFXX*CSSN2/2.E0+DFXY*(CS2-SN2)-DFYY*CSSN2/2.E0
     DFDYY(I)=DFXX*SN2+DFXY*CSSN2+DFYY*CS2
  enddo loop_10080
  DEALLOCATE(X1,Y1)
  RETURN
END SUBROUTINE CONMAP15

!********************************************************************
SUBROUTINE CONMAP16(NINPT,SC,A0,CSINT,SNNT,X2,Y2,F,DFDX,&
     DFDY,DFDXY,DFDXX,DFDYY,XSC1,YSC1,ANOR)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NODM=20000,NLM=180,NRDM=180,ISKM=50000000)
  PARAMETER (INTM=9000,INTC=NRDM*50,NDFM=2*NODM)
  PARAMETER (NBM=200,NDELM=1500)
  PARAMETER (MAXH=2*NBM,NDFELM=2*NDELM+3)
  PARAMETER (MXSKE=(NDFELM*(NDFELM+1))/2)
  PARAMETER (NODPER=NDELM)
  PARAMETER (NDFOUT=2*NODPER,NDFIN=2*NODPER+3)
  PARAMETER (NDIMSK=(NDFIN*(NDFIN+1))/2)
  DIMENSION X2(1),Y2(1),F(1),DFDX(1),DFDY(1),DFDXY(1),DFDXX(1),&
       DFDYY(1),CSINT(1),SNNT(1)
  DOUBLE PRECISION, ALLOCATABLE :: X1(:),Y1(:)
  COMMON /INTBEGN/ NPBG(NLM),NPBM(NLM)
  ALLOCATE(X1(NINPT),Y1(NINPT))
  X1=0.D0
  Y1=0.D0
  ANG=ANOR*DATAN(1.D0)/4.5D1
  CS1=DCOS(ANG)
  SN1=DSIN(ANG)
  loop_10081: DO I=1,NINPT
     X1(I)=X2(I)*CS1+Y2(I)*SN1
     Y1(I)=-X2(I)*SN1+Y2(I)*CS1
  enddo loop_10081
  CSC=1.E0
  XSC=XSC1/1.01D0
  YSC=YSC1/1.01D0
  RACT=SC
  RACT1=RACT*RACT
  RR=(XSC+YSC)/2
  XM=(XSC-YSC)/(XSC+YSC)
  RAVG=XSC+YSC
  XK=RAVG*(XSC-YSC)
  loop_1: DO I=1,NINPT
     X=X1(I)
     Y=Y1(I)
     R8=(X/XSC)**2+(Y/YSC)**2
     IF (R8.LT.1.E0) THEN
        ANG=DATAN2(Y,X)
        CSX=DCOS(ANG)
        CSY=DSIN(ANG)
        RF=(CSX/XSC)**2+(CSY/YSC)**2
        RF=1.01D0/DSQRT(RF)
        X=RF*CSX
        Y=RF*CSY
        WRITE (21,*) 'POSSIBLE ERROR IN CONMAP16'
        WRITE (21,*) 'X=',X,'Y=',Y,'R=',R8
     ENDIF
     RX=X**2
     RY=Y**2
     R1=RX+RY
     R7=R1*R1-2*(RX-RY)*XK+XK**2
     R=DSQRT(DSQRT(R7))
     FACT=0.25E0/(R*R*R)
     DRX=FACT*(4*(R1)*X-4*X*XK)
     DRY=FACT*(4*(R1)*Y+4*Y*XK)
     FACT1=3/R
     D2RXY=-FACT1*DRX*DRY+FACT*8*X*Y
     D2RXX=-FACT1*DRX*DRX+FACT*(8*RX+4*R1-4*XK)
     D2RYY=-FACT1*DRY*DRY+FACT*(8*RY+4*R1+4*XK)
     R5=RX-RY-XK      
     R52=R5*R5
     R53=R52*R5
     TH=DATAN2(2*X*Y,R5)/2      
     FACT=1/R7
     DTX=FACT*(Y*R5-2*RX*Y)
     DTY=FACT*(X*R5+2*RY*X)
     D2TXX=-FACT*(DTX*4*(R1*X-X*XK)+2*X*Y)
     D2TYY=-FACT*(DTY*4*(Y*R1+Y*XK)-2*X*Y)
     D2TXY=-FACT*(DTX*4*(Y*R1+Y*XK)+RX+3*RY+XK)
     CS=DCOS(TH)
     SN=DSIN(TH)
     XP=R*CS
     YP=R*SN
     DXPX=DRX*CS-YP*DTX
     DXPY=DRY*CS-YP*DTY
     DYPX=DRX*SN+XP*DTX
     DYPY=DRY*SN+XP*DTY
     D2XPXX=D2RXX*CS-DRX*DTX*SN-DYPX*DTX-YP*D2TXX
     D2XPXY=D2RXY*CS-DRX*SN*DTY-DYPY*DTX-YP*D2TXY
     D2XPYY=D2RYY*CS-DRY*SN*DTY-DYPY*DTY-YP*D2TYY
     D2YPXX=D2RXX*SN+DRX*CS*DTX+DXPX*DTX+XP*D2TXX
     D2YPXY=D2RXY*SN+DRX*CS*DTY+DXPY*DTX+XP*D2TXY
     D2YPYY=D2RYY*SN+DRY*CS*DTY+DXPY*DTY+XP*D2TYY
     FX1=X+XP
     FY1=Y+YP      
     FF=FX1*FX1+FY1*FY1
     IFL=1
     IF (FF.LT.RAVG*RAVG*0.99E0) THEN
        FX1=X-XP
        FY1=Y-YP
        FF=FX1*FX1+FY1*FY1
        IFL=-1
        DXPX=-DXPX
        DXPY=-DXPY
        D2XPXX=-D2XPXX
        D2XPYY=-D2XPYY
        D2XPXY=-D2XPXY
        DYPX=-DYPX
        DYPY=-DYPY
        D2YPXX=-D2YPXX
        D2YPYY=-D2YPYY
        D2YPXY=-D2YPXY         
     ENDIF
     F(I)=DSQRT(FF)
     FINV=1/F(I)
     DFX=FINV*(FX1*(1+DXPX)+FY1*DYPX)
     DFY=FINV*(FX1*DXPY+FY1*(1+DYPY))
     D2FXX=FINV*(-DFX*DFX+(1+DXPX)*(1+DXPX)+FX1*D2XPXX+FY1*D2YPXX+&
          DYPX*DYPX)
     D2FXY=FINV*(-DFX*DFY+FX1*D2XPXY+DXPY*(1+DXPX)+(1+DYPY)*DYPX+&
          FY1*D2YPXY)
     D2FYY=FINV*(-DFY*DFY+FX1*D2XPYY+DXPY*DXPY+(1+DYPY)*(1+DYPY)+&
          FY1*D2YPYY)
     FACT=1/RAVG
     F(I)=F(I)*FACT
     DFDX(I)=DFX*FACT
     DFDY(I)=DFY*FACT
     DFDXX(I)=D2FXX*FACT
     DFDYY(I)=D2FYY*FACT
     DFDXY(I)=D2FXY*FACT
     F(I)=F(I)/CSC
     DFDX(I)=DFDX(I)*RACT/CSC
     DFDXX(I)=DFDXX(I)*RACT1/CSC
     DFDY(I)=DFDY(I)*RACT/CSC
     DFDYY(I)=DFDYY(I)*RACT1/CSC
     DFDXY(I)=DFDXY(I)*RACT1/CSC
  enddo loop_1
  CS2=CS1*CS1
  SN2=SN1*SN1
  CSSN2=CS1*SN1*2.E0
  loop_10082: DO I=1,NINPT
     DFX=DFDX(I)
     DFY=DFDY(I)
     DFXX=DFDXX(I)
     DFYY=DFDYY(I)
     DFXY=DFDXY(I)
     DFDX(I)=DFX*CS1-DFY*SN1
     DFDY(I)=DFX*SN1+DFY*CS1
     DFDXX(I)=DFXX*CS2-DFXY*CSSN2+DFYY*SN2
     DFDXY(I)=DFXX*CSSN2/2.E0+DFXY*(CS2-SN2)-DFYY*CSSN2/2.E0
     DFDYY(I)=DFXX*SN2+DFXY*CSSN2+DFYY*CS2
  enddo loop_10082
  DEALLOCATE(X1,Y1)
  RETURN
END SUBROUTINE CONMAP16

!********************************************************************
! Generate the P-matrix corresponding to NB beta terms.
SUBROUTINE GEN_VCF_P(NB,XX,YY,PM)
!********************************************************************

  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  PARAMETER (NBM=200,NDELM=1500)
  DIMENSION PM(1000)


  PM(1) = 0
  PM(2) = 2
  PM(3) = 0
  PM(4) = 0
  PM(5) = 0
  PM(6) = -1
  PM(7) = 2
  PM(8) = 0
  PM(9) = 0
  PM(10) = 0
  PM(11) = 6*XX
  PM(12) = 0
  PM(13) = 0
  PM(14) = 2*YY
  PM(15) = -2*XX
  PM(16) = 2*XX
  PM(17) = 0
  PM(18) = -2*YY
  PM(19) = 6*YY
  PM(20) = 0
  PM(21) = 0
  IF (NB.GT.7) THEN
     PM(22) = 0
     PM(23) = 12*XX**2
     PM(24) = 0
     PM(25) = 0
     PM(26) = 6*XX*YY
     PM(27) = -3*XX**2
     PM(28) = 2*XX**2
     PM(29) = 2*YY**2
     PM(30) = -4*XX*YY
     PM(31) = 6*XX*YY
     PM(32) = 0
     PM(33) = -3*YY**2
     PM(34) = 12*YY**2
     PM(35) = 0
     PM(36) = 0
  ENDIF
  IF (NB.GT.12) THEN
     PM(37) = 0
     PM(38) = 20*XX**3
     PM(39) = 0
     PM(40) = 0
     PM(41) = 12*XX**2*YY
     PM(42) = -4*XX**3
     PM(43) = 2*XX**3
     PM(44) = 6*XX*YY**2
     PM(45) = -6*XX**2*YY
     PM(46) = 6*XX**2*YY
     PM(47) = 2*YY**3
     PM(48) = -6*XX*YY**2
     PM(49) = 12*XX*YY**2
     PM(50) = 0
     PM(51) = -4*YY**3
     PM(52) = 20*YY**3
     PM(53) = 0
     PM(54) = 0
  ENDIF
  IF (NB.GT.18) THEN
     PM(55) = 0
     PM(56) = 30*XX**4
     PM(57) = 0
     PM(58) = 0
     PM(59) = 20*XX**3*YY
     PM(60) = -5*XX**4
     PM(61) = 2*XX**4
     PM(62) = 12*XX**2*YY**2
     PM(63) = -8*XX**3*YY
     PM(64) = 6*XX**3*YY
     PM(65) = 6*XX*YY**3
     PM(66) = -9*XX**2*YY**2
     PM(67) = 12*XX**2*YY**2
     PM(68) = 2*YY**4
     PM(69) = -8*XX*YY**3
     PM(70) = 20*XX*YY**3
     PM(71) = 0
     PM(72) = -5*YY**4
     PM(73) = 30*YY**4
     PM(74) = 0
     PM(75) = 0
  ENDIF
  IF (NB.GT.25) THEN
     PM(76) = 0
     PM(77) = 42*XX**5
     PM(78) = 0
     PM(79) = 0
     PM(80) = 30*XX**4*YY
     PM(81) = -6*XX**5
     PM(82) = 2*XX**5
     PM(83) = 20*XX**3*YY**2
     PM(84) = -10*XX**4*YY
     PM(85) = 6*XX**4*YY
     PM(86) = 12*XX**2*YY**3
     PM(87) = -12*XX**3*YY**2
     PM(88) = 12*XX**3*YY**2
     PM(89) = 6*XX*YY**4
     PM(90) = -12*XX**2*YY**3
     PM(91) = 20*XX**2*YY**3
     PM(92) = 2*YY**5
     PM(93) = -10*XX*YY**4
     PM(94) = 30*XX*YY**4
     PM(95) = 0
     PM(96) = -6*YY**5
     PM(97) = 42*YY**5
     PM(98) = 0
     PM(99) = 0
  ENDIF
  IF (NB.GT.33) THEN
     PM(100) = 0
     PM(101) = 56*XX**6
     PM(102) = 0
     PM(103) = 0
     PM(104) = 42*XX**5*YY
     PM(105) = -7*XX**6
     PM(106) = 2*XX**6
     PM(107) = 30*XX**4*YY**2
     PM(108) = -12*XX**5*YY
     PM(109) = 6*XX**5*YY
     PM(110) = 20*XX**3*YY**3
     PM(111) = -15*XX**4*YY**2
     PM(112) = 12*XX**4*YY**2
     PM(113) = 12*XX**2*YY**4
     PM(114) = -16*XX**3*YY**3
     PM(115) = 20*XX**3*YY**3
     PM(116) = 6*XX*YY**5
     PM(117) = -15*XX**2*YY**4
     PM(118) = 30*XX**2*YY**4
     PM(119) = 2*YY**6
     PM(120) = -12*XX*YY**5
     PM(121) = 42*XX*YY**5
     PM(122) = 0
     PM(123) = -7*YY**6
     PM(124) = 56*YY**6
     PM(125) = 0
     PM(126) = 0
  ENDIF
  IF (NB.GT.42) THEN
     PM(127) = 0
     PM(128) = 72*xx**7
     PM(129) = 0
     PM(130) = 0
     PM(131) = 56*xx**6*yy
     PM(132) = -8*xx**7
     PM(133) = 2*xx**7
     PM(134) = 42*xx**5*yy**2
     PM(135) = -14*xx**6*yy
     PM(136) = 6*xx**6*yy
     PM(137) = 30*xx**4*yy**3
     PM(138) = -18*xx**5*yy**2
     PM(139) = 12*xx**5*yy**2
     PM(140) = 20*xx**3*yy**4
     PM(141) = -20*xx**4*yy**3
     PM(142) = 20*xx**4*yy**3
     PM(143) = 12*xx**2*yy**5
     PM(144) = -20*xx**3*yy**4
     PM(145) = 30*xx**3*yy**4
     PM(146) = 6*xx*yy**6
     PM(147) = -18*xx**2*yy**5
     PM(148) = 42*xx**2*yy**5
     PM(149) = 2*yy**7
     PM(150) = -14*xx*yy**6
     PM(151) = 56*xx*yy**6
     PM(152) = 0
     PM(153) = -8*yy**7
     PM(154) = 72*yy**7
     PM(155) = 0
     PM(156) = 0
  ENDIF
  IF (NB.GT.52) THEN
     PM(157) = 0
     PM(158) = 90*xx**8
     PM(159) = 0
     PM(160) = 0
     PM(161) = 72*xx**7*yy
     PM(162) = -9*xx**8
     PM(163) = 2*xx**8
     PM(164) = 56*xx**6*yy**2
     PM(165) = -16*xx**7*yy
     PM(166) = 6*xx**7*yy
     PM(167) = 42*xx**5*yy**3
     PM(168) = -21*xx**6*yy**2
     PM(169) = 12*xx**6*yy**2
     PM(170) = 30*xx**4*yy**4
     PM(171) = -24*xx**5*yy**3
     PM(172) = 20*xx**5*yy**3
     PM(173) = 20*xx**3*yy**5
     PM(174) = -25*xx**4*yy**4
     PM(175) = 30*xx**4*yy**4
     PM(176) = 12*xx**2*yy**6
     PM(177) = -24*xx**3*yy**5
     PM(178) = 42*xx**3*yy**5
     PM(179) = 6*xx*yy**7
     PM(180) = -21*xx**2*yy**6
     PM(181) = 56*xx**2*yy**6
     PM(182) = 2*yy**8
     PM(183) = -16*xx*yy**7
     PM(184) = 72*xx*yy**7
     PM(185) = 0
     PM(186) = -9*yy**8
     PM(187) = 90*yy**8
     PM(188) = 0
     PM(189) = 0
  ENDIF
  IF (NB.GT.63) THEN
     PM(190) = 0
     PM(191) = 110*XX**9
     PM(192) = 0
     PM(193) = 0
     PM(194) = 90*XX**8*YY
     PM(195) = -10*XX**9
     PM(196) = 2*XX**9
     PM(197) = 72*XX**7*YY**2
     PM(198) = -18*XX**8*YY
     PM(199) = 6*XX**8*YY
     PM(200) = 56*XX**6*YY**3
     PM(201) = -24*XX**7*YY**2
     PM(202) = 12*XX**7*YY**2
     PM(203) = 42*XX**5*YY**4
     PM(204) = -28*XX**6*YY**3
     PM(205) = 20*XX**6*YY**3
     PM(206) = 30*XX**4*YY**5
     PM(207) = -30*XX**5*YY**4
     PM(208) = 30*XX**5*YY**4
     PM(209) = 20*XX**3*YY**6
     PM(210) = -30*XX**4*YY**5
     PM(211) = 42*XX**4*YY**5
     PM(212) = 12*XX**2*YY**7
     PM(213) = -28*XX**3*YY**6
     PM(214) = 56*XX**3*YY**6
     PM(215) = 6*XX*YY**8
     PM(216) = -24*XX**2*YY**7
     PM(217) = 72*XX**2*YY**7
     PM(218) = 2*YY**9
     PM(219) = -18*XX*YY**8
     PM(220) = 90*XX*YY**8
     PM(221) = 0
     PM(222) = -10*YY**9
     PM(223) = 110*YY**9
     PM(224) = 0
     PM(225) = 0
  ENDIF
  IF (NB.GT.75) THEN
     PM(226) = 0
     PM(227) = 132*XX**10
     PM(228) = 0
     PM(229) = 0
     PM(230) = 110*XX**9*YY
     PM(231) = -11*XX**10
     PM(232) = 2*XX**10
     PM(233) = 90*XX**8*YY**2
     PM(234) = -20*XX**9*YY
     PM(235) = 6*XX**9*YY
     PM(236) = 72*XX**7*YY**3
     PM(237) = -27*XX**8*YY**2
     PM(238) = 12*XX**8*YY**2
     PM(239) = 56*XX**6*YY**4
     PM(240) = -32*XX**7*YY**3
     PM(241) = 20*XX**7*YY**3
     PM(242) = 42*XX**5*YY**5
     PM(243) = -35*XX**6*YY**4
     PM(244) = 30*XX**6*YY**4
     PM(245) = 30*XX**4*YY**6
     PM(246) = -36*XX**5*YY**5
     PM(247) = 42*XX**5*YY**5
     PM(248) = 20*XX**3*YY**7
     PM(249) = -35*XX**4*YY**6
     PM(250) = 56*XX**4*YY**6
     PM(251) = 12*XX**2*YY**8
     PM(252) = -32*XX**3*YY**7
     PM(253) = 72*XX**3*YY**7
     PM(254) = 6*XX*YY**9
     PM(255) = -27*XX**2*YY**8
     PM(256) = 90*XX**2*YY**8
     PM(257) = 2*YY**10
     PM(258) = -20*XX*YY**9
     PM(259) = 110*XX*YY**9
     PM(260) = 0
     PM(261) = -11*YY**10
     PM(262) = 132*YY**10
     PM(263) = 0
     PM(264) = 0
  ENDIF
  IF (NB.GT.88) THEN
     PM(265) = 0
     PM(266) = 156*XX**11
     PM(267) = 0
     PM(268) = 0
     PM(269) = 132*XX**10*YY
     PM(270) = -12*XX**11
     PM(271) = 2*XX**11
     PM(272) = 110*XX**9*YY**2
     PM(273) = -22*XX**10*YY
     PM(274) = 6*XX**10*YY
     PM(275) = 90*XX**8*YY**3
     PM(276) = -30*XX**9*YY**2
     PM(277) = 12*XX**9*YY**2
     PM(278) = 72*XX**7*YY**4
     PM(279) = -36*XX**8*YY**3
     PM(280) = 20*XX**8*YY**3
     PM(281) = 56*XX**6*YY**5
     PM(282) = -40*XX**7*YY**4
     PM(283) = 30*XX**7*YY**4
     PM(284) = 42*XX**5*YY**6
     PM(285) = -42*XX**6*YY**5
     PM(286) = 42*XX**6*YY**5
     PM(287) = 30*XX**4*YY**7
     PM(288) = -42*XX**5*YY**6
     PM(289) = 56*XX**5*YY**6
     PM(290) = 20*XX**3*YY**8
     PM(291) = -40*XX**4*YY**7
     PM(292) = 72*XX**4*YY**7
     PM(293) = 12*XX**2*YY**9
     PM(294) = -36*XX**3*YY**8
     PM(295) = 90*XX**3*YY**8
     PM(296) = 6*XX*YY**10
     PM(297) = -30*XX**2*YY**9
     PM(298) = 110*XX**2*YY**9
     PM(299) = 2*YY**11
     PM(300) = -22*XX*YY**10
     PM(301) = 132*XX*YY**10
     PM(302) = 0
     PM(303) = -12*YY**11
     PM(304) = 156*YY**11
     PM(305) = 0
     PM(306) = 0
  ENDIF
  IF (NB.GT.102) THEN
     PM(307) = 0
     PM(308) = 182*XX**12
     PM(309) = 0
     PM(310) = 0
     PM(311) = 156*XX**11*YY
     PM(312) = -13*XX**12
     PM(313) = 2*XX**12
     PM(314) = 132*XX**10*YY**2
     PM(315) = -24*XX**11*YY
     PM(316) = 6*XX**11*YY
     PM(317) = 110*XX**9*YY**3
     PM(318) = -33*XX**10*YY**2
     PM(319) = 12*XX**10*YY**2
     PM(320) = 90*XX**8*YY**4
     PM(321) = -40*XX**9*YY**3
     PM(322) = 20*XX**9*YY**3
     PM(323) = 72*XX**7*YY**5
     PM(324) = -45*XX**8*YY**4
     PM(325) = 30*XX**8*YY**4
     PM(326) = 56*XX**6*YY**6
     PM(327) = -48*XX**7*YY**5
     PM(328) = 42*XX**7*YY**5
     PM(329) = 42*XX**5*YY**7
     PM(330) = -49*XX**6*YY**6
     PM(331) = 56*XX**6*YY**6
     PM(332) = 30*XX**4*YY**8
     PM(333) = -48*XX**5*YY**7
     PM(334) = 72*XX**5*YY**7
     PM(335) = 20*XX**3*YY**9
     PM(336) = -45*XX**4*YY**8
     PM(337) = 90*XX**4*YY**8
     PM(338) = 12*XX**2*YY**10
     PM(339) = -40*XX**3*YY**9
     PM(340) = 110*XX**3*YY**9
     PM(341) = 6*XX*YY**11
     PM(342) = -33*XX**2*YY**10
     PM(343) = 132*XX**2*YY**10
     PM(344) = 2*YY**12
     PM(345) = -24*XX*YY**11
     PM(346) = 156*XX*YY**11
     PM(347) = 0
     PM(348) =-13*YY**12
     PM(349) = 182*YY**12
     PM(350) =0
     PM(351) =0
  ENDIF
  IF (NB.GT.117) THEN
     PM(352) = 0
     PM(353) = 210*XX**13
     PM(354) = 0
     PM(355) = 0
     PM(356) = 182*XX**12*YY
     PM(357) = -14*XX**13
     PM(358) = 2*XX**13
     PM(359) = 156*XX**11*YY**2
     PM(360) = -26*XX**12*YY
     PM(361) = 6*XX**12*YY
     PM(362) = 132*XX**10*YY**3
     PM(363) = -36*XX**11*YY**2
     PM(364) = 12*XX**11*YY**2
     PM(365) = 110*XX**9*YY**4
     PM(366) = -44*XX**10*YY**3
     PM(367) = 20*XX**10*YY**3
     PM(368) = 90*XX**8*YY**5
     PM(369) = -50*XX**9*YY**4
     PM(370) = 30*XX**9*YY**4
     PM(371) = 72*XX**7*YY**6
     PM(372) = -54*XX**8*YY**5
     PM(373) = 42*XX**8*YY**5
     PM(374) = 56*XX**6*YY**7
     PM(375) = -56*XX**7*YY**6
     PM(376) = 56*XX**7*YY**6
     PM(377) = 42*XX**5*YY**8
     PM(378) = -56*XX**6*YY**7
     PM(379) = 72*XX**6*YY**7
     PM(380) = 30*XX**4*YY**9
     PM(381) = -54*XX**5*YY**8
     PM(382) = 90*XX**5*YY**8
     PM(383) = 20*XX**3*YY**10
     PM(384) = -50*XX**4*YY**9
     PM(385) = 110*XX**4*YY**9
     PM(386) = 12*XX**2*YY**11
     PM(387) = -44*XX**3*YY**10
     PM(388) = 132*XX**3*YY**10
     PM(389) = 6*XX*YY**12
     PM(390) = -36*XX**2*YY**11
     PM(391) = 156*XX**2*YY**11
     PM(392) = 2*YY**13
     PM(393) = -26*XX*YY**12
     PM(394) = 182*XX*YY**12
     PM(395) = 0
     PM(396) = -14*YY**13
     PM(397) = 210*YY**13
     PM(398) = 0
     PM(399) = 0
  ENDIF
  IF (NB.GT.133) THEN
     PM(400) = 0
     PM(401) = 240*XX**14
     PM(402) = 0
     PM(403) = 0
     PM(404) = 210*XX**13*YY
     PM(405) = -15*XX**14
     PM(406) = 2*XX**14
     PM(407) = 182*XX**12*YY**2
     PM(408) = -28*XX**13*YY
     PM(409) = 6*XX**13*YY
     PM(410) = 156*XX**11*YY**3
     PM(411) = -39*XX**12*YY**2
     PM(412) = 12*XX**12*YY**2
     PM(413) = 132*XX**10*YY**4
     PM(414) = -48*XX**11*YY**3
     PM(415) = 20*XX**11*YY**3
     PM(416) = 110*XX**9*YY**5
     PM(417) = -55*XX**10*YY**4
     PM(418) = 30*XX**10*YY**4
     PM(419) = 90*XX**8*YY**6
     PM(420) = -60*XX**9*YY**5
     PM(421) = 42*XX**9*YY**5
     PM(422) = 72*XX**7*YY**7
     PM(423) = -63*XX**8*YY**6
     PM(424) = 56*XX**8*YY**6
     PM(425) = 56*XX**6*YY**8
     PM(426) = -64*XX**7*YY**7
     PM(427) = 72*XX**7*YY**7
     PM(428) = 42*XX**5*YY**9
     PM(429) = -63*XX**6*YY**8
     PM(430) = 90*XX**6*YY**8
     PM(431) = 30*XX**4*YY**10
     PM(432) = -60*XX**5*YY**9
     PM(433) = 110*XX**5*YY**9
     PM(434) = 20*XX**3*YY**11
     PM(435) = -55*XX**4*YY**10
     PM(436) = 132*XX**4*YY**10
     PM(437) = 12*XX**2*YY**12
     PM(438) = -48*XX**3*YY**11
     PM(439) = 156*XX**3*YY**11
     PM(440) = 6*XX*YY**13
     PM(441) = -39*XX**2*YY**12
     PM(442) = 182*XX**2*YY**12
     PM(443) = 2*YY**14
     PM(444) = -28*XX*YY**13
     PM(445) = 210*XX*YY**13
     PM(446) = 0
     PM(447) = -15*YY**14
     PM(448) = 240*YY**14
     PM(449) = 0
     PM(450) = 0
  ENDIF
  IF(NB.GT.150) THEN
     PM(451) = 0
     PM(452) = 272*XX**15
     PM(453) = 0
     PM(454) = 0
     PM(455) = 240*XX**14*YY
     PM(456) = -16*XX**15
     PM(457) = 2*XX**15
     PM(458) = 210*XX**13*YY**2
     PM(459) = -30*XX**14*YY
     PM(460) = 6*XX**14*YY
     PM(461) = 182*XX**12*YY**3
     PM(462) = -42*XX**13*YY**2
     PM(463) = 12*XX**13*YY**2
     PM(464) = 156*XX**11*YY**4
     PM(465) = -52*XX**12*YY**3
     PM(466) = 20*XX**12*YY**3
     PM(467) = 132*XX**10*YY**5
     PM(468) = -60*XX**11*YY**4
     PM(469) = 30*XX**11*YY**4
     PM(470) = 110*XX**9*YY**6
     PM(471) = -66*XX**10*YY**5
     PM(472) = 42*XX**10*YY**5
     PM(473) = 90*XX**8*YY**7
     PM(474) = -70*XX**9*YY**6
     PM(475) = 56*XX**9*YY**6
     PM(476) = 72*XX**7*YY**8
     PM(477) = -72*XX**8*YY**7
     PM(478) = 72*XX**8*YY**7
     PM(479) = 56*XX**6*YY**9
     PM(480) = -72*XX**7*YY**8
     PM(481) = 90*XX**7*YY**8
     PM(482) = 42*XX**5*YY**10
     PM(483) = -70*XX**6*YY**9
     PM(484) = 110*XX**6*YY**9
     PM(485) = 30*XX**4*YY**11
     PM(486) = -66*XX**5*YY**10
     PM(487) = 132*XX**5*YY**10
     PM(488) = 20*XX**3*YY**12
     PM(489) = -60*XX**4*YY**11
     PM(490) = 156*XX**4*YY**11
     PM(491) = 12*XX**2*YY**13
     PM(492) = -52*XX**3*YY**12
     PM(493) = 182*XX**3*YY**12
     PM(494) = 6*XX*YY**14
     PM(495) = -42*XX**2*YY**13
     PM(496) = 210*XX**2*YY**13
     PM(497) = 2*YY**15
     PM(498) = -30*XX*YY**14
     PM(499) = 240*XX*YY**14
     PM(500) = 0
     PM(501) = -16*YY**15
     PM(502) = 272*YY**15
     PM(503) = 0
     PM(504) = 0
  ENDIF
  IF (NB.GT.168) THEN
     PM(505) = 0
     PM(506) = 306*XX**16
     PM(507) = 0
     PM(508) = 0
     PM(509) = 272*XX**15*YY
     PM(510) = -17*XX**16
     PM(511) = 2*XX**16
     PM(512) = 240*XX**14*YY**2
     PM(513) = -32*XX**15*YY
     PM(514) = 6*XX**15*YY
     PM(515) = 210*XX**13*YY**3
     PM(516) = -45*XX**14*YY**2
     PM(517) = 12*XX**14*YY**2
     PM(518) = 182*XX**12*YY**4
     PM(519) = -56*XX**13*YY**3
     PM(520) = 20*XX**13*YY**3
     PM(521) = 156*XX**11*YY**5
     PM(522) = -65*XX**12*YY**4
     PM(523) = 30*XX**12*YY**4
     PM(524) = 132*XX**10*YY**6
     PM(525) = -72*XX**11*YY**5
     PM(526) = 42*XX**11*YY**5
     PM(527) = 110*XX**9*YY**7
     PM(528) = -77*XX**10*YY**6
     PM(529) = 56*XX**10*YY**6
     PM(530) = 90*XX**8*YY**8
     PM(531) = -80*XX**9*YY**7
     PM(532) = 72*XX**9*YY**7
     PM(533) = 72*XX**7*YY**9
     PM(534) = -81*XX**8*YY**8
     PM(535) = 90*XX**8*YY**8
     PM(536) = 56*XX**6*YY**10
     PM(537) = -80*XX**7*YY**9
     PM(538) = 110*XX**7*YY**9
     PM(539) = 42*XX**5*YY**11
     PM(540) = -77*XX**6*YY**10
     PM(541) = 132*XX**6*YY**10
     PM(542) = 30*XX**4*YY**12
     PM(543) = -72*XX**5*YY**11
     PM(544) = 156*XX**5*YY**11
     PM(545) = 20*XX**3*YY**13
     PM(546) = -65*XX**4*YY**12
     PM(547) = 182*XX**4*YY**12
     PM(548) = 12*XX**2*YY**14
     PM(549) = -56*XX**3*YY**13
     PM(550) = 210*XX**3*YY**13
     PM(551) = 6*XX*YY**15
     PM(552) = -45*XX**2*YY**14
     PM(553) = 240*XX**2*YY**14
     PM(554) = 2*YY**16
     PM(555) = -32*XX*YY**15
     PM(556) = 272*XX*YY**15
     PM(557) = 0
     PM(558) = -17*YY**16
     PM(559) = 306*YY**16
     PM(560) = 0
     PM(561) = 0
  ENDIF
  IF (NB.GT.187) THEN
     PM(562) = 0
     PM(563) = 342*XX**17
     PM(564) = 0
     PM(565) = 0
     PM(566) = 306*XX**16*YY
     PM(567) = -18*XX**17
     PM(568) = 2*XX**17
     PM(569) = 272*XX**15*YY**2
     PM(570) = -34*XX**16*YY
     PM(571) = 6*XX**16*YY
     PM(572) = 240*XX**14*YY**3
     PM(573) = -48*XX**15*YY**2
     PM(574) = 12*XX**15*YY**2
     PM(575) = 210*XX**13*YY**4
     PM(576) = -60*XX**14*YY**3
     PM(577) = 20*XX**14*YY**3
     PM(578) = 182*XX**12*YY**5
     PM(579) = -70*XX**13*YY**4
     PM(580) = 30*XX**13*YY**4
     PM(581) = 156*XX**11*YY**6
     PM(582) = -78*XX**12*YY**5
     PM(583) = 42*XX**12*YY**5
     PM(584) = 132*XX**10*YY**7
     PM(585) = -84*XX**11*YY**6
     PM(586) = 56*XX**11*YY**6
     PM(587) = 110*XX**9*YY**8
     PM(588) = -88*XX**10*YY**7
     PM(589) = 72*XX**10*YY**7
     PM(590) = 90*XX**8*YY**9
     PM(591) = -90*XX**9*YY**8
     PM(592) = 90*XX**9*YY**8
     PM(593) = 72*XX**7*YY**10
     PM(594) = -90*XX**8*YY**9
     PM(595) = 110*XX**8*YY**9
     PM(596) = 56*XX**6*YY**11
     PM(597) = -88*XX**7*YY**10
     PM(598) = 132*XX**7*YY**10
     PM(599) = 42*XX**5*YY**12
     PM(600) = -84*XX**6*YY**11
     PM(601) = 156*XX**6*YY**11
     PM(602) = 30*XX**4*YY**13
     PM(603) = -78*XX**5*YY**12
     PM(604) = 182*XX**5*YY**12
     PM(605) = 20*XX**3*YY**14
     PM(606) = -70*XX**4*YY**13
     PM(607) = 210*XX**4*YY**13
     PM(608) = 12*XX**2*YY**15
     PM(609) = -60*XX**3*YY**14
     PM(610) = 240*XX**3*YY**14
     PM(611) = 6*XX*YY**16
     PM(612) = -48*XX**2*YY**15
     PM(613) = 272*XX**2*YY**15
     PM(614) = 2*YY**17
     PM(615) = -34*XX*YY**16
     PM(616) = 306*XX*YY**16
     PM(617) = 0
     PM(618) = -18*YY**17
     PM(619) = 342*YY**17
     PM(620) = 0
     PM(621) = 0
  ENDIF
  IF (NB.GT.207) THEN
     PM(622) = 0
     PM(623) = 380*XX**18
     PM(624) = 0
     PM(625) = 0
     PM(626) = 342*XX**17*YY
     PM(627) = -19*XX**18
     PM(628) = 2*XX**18
     PM(629) = 306*XX**16*YY**2
     PM(630) = -36*XX**17*YY
     PM(631) = 6*XX**17*YY
     PM(632) = 272*XX**15*YY**3
     PM(633) = -51*XX**16*YY**2
     PM(634) = 12*XX**16*YY**2
     PM(635) = 240*XX**14*YY**4
     PM(636) = -64*XX**15*YY**3
     PM(637) = 20*XX**15*YY**3
     PM(638) = 210*XX**13*YY**5
     PM(639) = -75*XX**14*YY**4
     PM(640) = 30*XX**14*YY**4
     PM(641) = 182*XX**12*YY**6
     PM(642) = -84*XX**13*YY**5
     PM(643) = 42*XX**13*YY**5
     PM(644) = 156*XX**11*YY**7
     PM(645) = -91*XX**12*YY**6
     PM(646) = 56*XX**12*YY**6
     PM(647) = 132*XX**10*YY**8
     PM(648) = -96*XX**11*YY**7
     PM(649) = 72*XX**11*YY**7
     PM(650) = 110*XX**9*YY**9
     PM(651) = -99*XX**10*YY**8
     PM(652) = 90*XX**10*YY**8
     PM(653) = 90*XX**8*YY**10
     PM(654) = -100*XX**9*YY**9
     PM(655) = 110*XX**9*YY**9
     PM(656) = 72*XX**7*YY**11
     PM(657) = -99*XX**8*YY**10
     PM(658) = 132*XX**8*YY**10
     PM(659) = 56*XX**6*YY**12
     PM(660) = -96*XX**7*YY**11
     PM(661) = 156*XX**7*YY**11
     PM(662) = 42*XX**5*YY**13
     PM(663) = -91*XX**6*YY**12
     PM(664) = 182*XX**6*YY**12
     PM(665) = 30*XX**4*YY**14
     PM(666) = -84*XX**5*YY**13
     PM(667) = 210*XX**5*YY**13
     PM(668) = 20*XX**3*YY**15
     PM(669) = -75*XX**4*YY**14
     PM(670) = 240*XX**4*YY**14
     PM(671) = 12*XX**2*YY**16
     PM(672) = -64*XX**3*YY**15
     PM(673) = 272*XX**3*YY**15
     PM(674) = 6*XX*YY**17
     PM(675) = -51*XX**2*YY**16
     PM(676) = 306*XX**2*YY**16
     PM(677) = 2*YY**18
     PM(678) = -36*XX*YY**17
     PM(679) = 342*XX*YY**17
     PM(680) = 0
     PM(681) = -19*YY**18
     PM(682) = 380*YY**18
     PM(683) = 0
     PM(684) = 0
  ENDIF
  IF (NB.GT.228) THEN
     PM(685) = 0
     PM(686) = 420*XX**19
     PM(687) = 0
     PM(688) = 0
     PM(689) = 380*XX**18*YY
     PM(690) = -20*XX**19
     PM(691) = 2*XX**19
     PM(692) = 342*XX**17*YY**2
     PM(693) = -38*XX**18*YY
     PM(694) = 6*XX**18*YY
     PM(695) = 306*XX**16*YY**3
     PM(696) = -54*XX**17*YY**2
     PM(697) = 12*XX**17*YY**2
     PM(698) = 272*XX**15*YY**4
     PM(699) = -68*XX**16*YY**3
     PM(700) = 20*XX**16*YY**3
     PM(701) = 240*XX**14*YY**5
     PM(702) = -80*XX**15*YY**4
     PM(703) = 30*XX**15*YY**4
     PM(704) = 210*XX**13*YY**6
     PM(705) = -90*XX**14*YY**5
     PM(706) = 42*XX**14*YY**5
     PM(707) = 182*XX**12*YY**7
     PM(708) = -98*XX**13*YY**6
     PM(709) = 56*XX**13*YY**6
     PM(710) = 156*XX**11*YY**8
     PM(711) = -104*XX**12*YY**7
     PM(712) = 72*XX**12*YY**7
     PM(713) = 132*XX**10*YY**9
     PM(714) = -108*XX**11*YY**8
     PM(715) = 90*XX**11*YY**8
     PM(716) = 110*XX**9*YY**10
     PM(717) = -110*XX**10*YY**9
     PM(718) = 110*XX**10*YY**9
     PM(719) = 90*XX**8*YY**11
     PM(720) = -110*XX**9*YY**10
     PM(721) = 132*XX**9*YY**10
     PM(722) = 72*XX**7*YY**12
     PM(723) = -108*XX**8*YY**11
     PM(724) = 156*XX**8*YY**11
     PM(725) = 56*XX**6*YY**13
     PM(726) = -104*XX**7*YY**12
     PM(727) = 182*XX**7*YY**12
     PM(728) = 42*XX**5*YY**14
     PM(729) = -98*XX**6*YY**13
     PM(730) = 210*XX**6*YY**13
     PM(731) = 30*XX**4*YY**15
     PM(732) = -90*XX**5*YY**14
     PM(733) = 240*XX**5*YY**14
     PM(734) = 20*XX**3*YY**16
     PM(735) = -80*XX**4*YY**15
     PM(736) = 272*XX**4*YY**15
     PM(737) = 12*XX**2*YY**17
     PM(738) = -68*XX**3*YY**16
     PM(739) = 306*XX**3*YY**16
     PM(740) = 6*XX*YY**18
     PM(741) = -54*XX**2*YY**17
     PM(742) = 342*XX**2*YY**17
     PM(743) = 2*YY**19
     PM(744) = -38*XX*YY**18
     PM(745) = 380*XX*YY**18
     PM(746) = 0
     PM(747) = -20*YY**19
     PM(748) = 420*YY**19
     PM(749) = 0
     PM(750) = 0
  ENDIF
  RETURN 
END SUBROUTINE GEN_VCF_P
